'****************************************************************
'*  Name    : Ea3agv_WinKeyerB.BAS                              *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 16/07/2019                                        *
'*  Version : 1.0                                               *
'*  Compiler Version 3.7.1.9                                    *
'*  Notes   :                                                   *
'*  Hardware: Amicus18 Board & CoolTerm Terminal                *
'*  Xtal    : Recommanded 16, 20 Mhz for FOSC 64 or 80Mhz       *
'*            Electronic Keyer for Iambic A/B & Ultimatic Mode  *
'*  CW encoder/decoder based on the coding of                   *
'*  Wolfgang Buescher (DL4YHF)                                  *
'*  But the structure is completly different.                   *
'*  Code based in a Simple State Machine system                 *
'*  Please read the <MORSE_Code.txt> file                       *
'*  Compilation Version 0.0.1.76                                *
'****************************************************************
'
'  /\\\\\\\\\\\\\\\     /\\\\\\\\\        /\\\\\\\\\\      /\\\\\\\\\        /\\\\\\\\\\\\  /\\\        /\\\        
'  \/\\\///////////    /\\\\\\\\\\\\\    /\\\///////\\\   /\\\\\\\\\\\\\    /\\\//////////  \/\\\       \/\\\       
'   \/\\\              /\\\/////////\\\  \///       /\\\  /\\\/////////\\\  /\\\             \//\\\      /\\\      
'    \/\\\\\\\\\\\     \/\\\       \/\\\         /\\\//   \/\\\       \/\\\ \/\\\    /\\\\\\\  \//\\\    /\\\     
'     \/\\\///////      \/\\\\\\\\\\\\\\\        \////\\\  \/\\\\\\\\\\\\\\\ \/\\\   \/////\\\   \//\\\  /\\\    
'      \/\\\             \/\\\/////////\\\           \//\\\ \/\\\/////////\\\ \/\\\       \/\\\    \//\\\/\\\   
'       \/\\\             \/\\\        \/\\\  /\\\     /\\\  \/\\\       \/\\\ \/\\\       \/\\\     \//\\\\\  
'        \/\\\\\\\\\\\\\\\ \/\\\        \/\\\ \///\\\\\\\\\\  \/\\\       \/\\\ \//\\\\\\\\\\\\/       \//\\\ 
'         \///////////////  \///         \///    \//////////   \///        \///   \////////////          \///
'
'===============================================================================
'/ PLEASE DO NOT COPY THIS CODE FOR COMMERCIAL USE.
'===============================================================================
' This program is free software for personal use only, you can redistribute it 
' and/or modify. The code is offered as-is and the author does not take any 
' responsibility for its use. This program is distributed in the hope that it will
' be useful, but WITHOUT ANY WARRANTY. However, a mention of the author and compiler
' would be appreciated.
'
' Este programa es un software libre para uso privado, puede redistribuirlo y/o
' modificarlo. Se entrega este cdigo tal como esta y el autor NO se hace responsable
' de su utilizacin. Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador sera
' muy apreciado.

' Ce programme est un logiciel libre pour utilisation prive, vous pouvez le
' redistribuer et/ou modifier. Ce logiciel est offert tel qu'il est, et son auteur
' NE prend AUCUNE responsabilit pour son utilization. Ce programme est distribu
' dans l'espoir qu'il sera util, ' mais SANS AUCUNE GARANTIE. Cependant mentionner
' l'auteur et le compileur serait trs aprci.
'-------------------------------------------------------------------------------
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
' PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHOR OR COPYRIGHT
' HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
' OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
' SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'/==============================================================================
(*
    The paddles should be equipped with a three-wire interconnecting cable
    terminated in a 3.5 mm or a  stereo jack. Miniature shielded and balanced
    microphone cable is ideal for this. The common return is connected to the
    longest ring (shaft) of the stereo jack. The Dah paddle connection is made to
    the jack terminal for the smaller insulated ring. The dot paddle is connected to
    the jack tip connection. If your paddles are equipped with a  stereo jack, a
    suitable stereo adapter is available at most electronic or hi-fi shops.
    Reversed paddle wiring can be corrected by an external conmutator.
*)
'/==============================================================================
'    $define _Proteus
'/==============================================================================
'/ DECLARATIONS FOR PIC DEFINITIONS FILE:
    $ifdef _Proteus
    $define _BaudRate_19200
    $else
    $define _BaudRate_115200    
'    $define _BaudRate_19200
    $endif
    '/--------------------------------------------------------------------------
    Declare HRSIn_Pin PORTC.7
    $define _HRSOutTwoStopBitsInc_
    $define _CheckRCONBits_
    Declare HSerial1_Terminator = CRLF
    $define _HSerial1Terminator
    '/--------------------------------------------------------------------------
'    Declare Float_Display_Type = Fast
    '/--------------------------------------------------------------------------
'    $define  __WatchDog_ON      '/ Special Declare Watchdog
    Declare Watchdog = On        '/ PDS Watchdog
    '/--------------------------------------------------------------------------
'    $define DeclareXtal 20_000
'    $define DeclareXtal 25_000
    '/--------------------------------------------------------------------------
    $ifdef _Proteus
    $define PLL_ConfigFuses OFF
    $else
    $define PLL_ConfigFuses On
    $endif
    '/--------------------------------------------------------------------------    
    Include "D:\MyIncFiles\Amicus18_26K20.inc"
'    $define __TestTimer2
'/==============================================================================
'/ DECLARATIONS FOR PIC HARDWARE:
    '/--------------------------------------------------------------------------
    '/ Define the Hardware Pins for Outputs.
    $define CWDataPin   LATC.0   '/ [Output] Keyer data to port RC0.
    $define StatusLED   LATC.1   '/ [Output] (Enable/Disable) Status LED to port RC1.
    $define CWToneOut   LATC.2   '/ [Output] "CWTonePin" to port RC2.
    $define CWPTT       LATC.3   '/ [Output] (enable/disable) PTT output to port RC3.
    $define CWPracticePin LATC.4 '/ Ouput for CW training output Buzzer.
    $define PORTCinput5   PORTC.5 '/ Input. Not used.    
'    $define TestPin     LATC.5 
    '/--------------------------------------------------------------------------
    '/ Define the Hardware Pin for ADC (PORTA.0)
    $define ADCpin  PORTA.0     '/ Input for ADC For analog Input.    
    $define COMPpin PORTA.1     '/ Input for Comparator for analog input.

    '/ Define pins for Hexadecimal encoder.
    $define SWEncoderpin0    PORTA.2 
    $define SWEncoderpin1    PORTA.3 
    $define SWEncoderpin2    PORTA.4 
    $define SWEncoderpin3    PORTA.5         

    '/ Define the Hardware Pins for Buttons.
'    $define PORT_INPUTS    PORTB
    $define ButtonFUNCTION PORTB.0   '/ [Input] Button FUNCTION in PORTB.0.
    $define PORTBinput1    PORTB.1   '/ Input. Not used.
    $define PORTBinput2    PORTB.2   '/ Input. Not used.
    
    '/ Define the Hardware Pins for paddle.
    $define IP_DASH PORTB.3     '/ [Input] Dash-paddle
    $define IP_DOT  PORTB.4     '/ [Input] Dot-paddle

    '/ Define the encoder pins. These pins are used by the programmer then
    '/ the resitors to ground must to be a little bit high (22K) & without capacitors.
    $define SWEncoderAddPin0 PORTB.5    '/ Encoder Address Bit0.
    $define SWEncoderAddPin1 PORTB.6    '/ Encoder Address Bit1. 
    $define SWEncoderAddPin2 PORTB.7    '/ Encoder Address Bit2. 
'/==============================================================================
'/ Language at compilation: (only one)
    $define _English_
'    $define _Spanish_
'    $define _French_
'/==============================================================================
'/ DECLARATIONS FOR LIBRARY OPTIONS:
    $define _VarToSTrgRS_
    '/--------------------------------------------------------------------------
'    $define __TestBeacon
    $define _MyRandom_
    $define _CopyROMtoE2P_
    $define _HRSE2PStrg_
'    $define _HRSLStrg_
    $define _HRSFStrg_
    $define _NOTuseLF_
    $define __MEASURE_CODE_
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V17.Inc"
'/==============================================================================
'    $define _EncoderCtsOpen    ;/ Encoders with open contacts with position = 0.
    Include "D:\MyIncFiles\EA3AGV_KEYER_V10.Inc"
'/==============================================================================
'    Dim MyResultDWord As Dword                 
    Dim MyResultWord As Word
    Dim MyResultByte As Byte
    Dim MyDelayWord As Word            
'/##############################################################################
'/ Interrupt declare.
    On_Hardware_Interrupt GoTo Interrupt_Handler_In  
'/==============================================================================
    GoTo Over_Interrupt_Handler
'/==============================================================================
'/ Interrupt Handler for the UART library command.
    Declare Reminders = OFF
Interrupt_Handler_In:
STARTSIZE(Interrupt_Handler_CODE)
    Context Save
'/------------------------------------------------------------------------------
    '/ UART Byte received / Circular buffer.
    If PIR1Bits_RCIF = 1 Then       '/ Receiving a Byte from keyboard?
        If RCSTABits_FERR = 1 Then  '/ Was either error status bit set?
            GoTo _RCSTA_Error       '/ Exit the Interrupt routine.
        EndIf
        If RCSTABits_OERR = 1 Then  '/ Was either error status bit set?
            GoTo _RCSTA_Error       '/ Exit the Interrupt routine.
        EndIf
        '/----------------------------------------------------------------------
        '/ Code to avoid write a call to eeprom write routine outside of interrupts & more faster.
        '/ Current state of the circular array pointer.
        FSR0 = AddressOf(CW_StringSend)
        FSR0 = FSR0 + UARTBuff_Head     
        '/----------------------------------------------------------------------
        '/For all Keyboards using ASCII Low Case character. 
        '/ Macro to Insert MYCalSign into the circular array.
        If RCREG = 109 Then         '/ If "m" Low Case. Special character.
            EECON1 = 0              '/ Reading Eeprom memory.
            EEADDR = EEPCW_MYCALL   '/ Loading eeprom address of MyCallSign.
            '/ Code more faster than standard.
            Do
                EECON1Bits_RD = 1           '/ Start to read eeprom memory.
                If EEDATA > 0 Then          '/ Is there an ASCII character available?
                    POSTINC0 = EEDATA       '/ Write to the circular Array & increment the FSR0 pointer.
                    Inc UARTBuff_Head       '/ Update the Head String pointer too.                   
                    WREG = __CW_StringLenght - 1
                    UARTBuff_Head = UARTBuff_Head & WREG                    
                    Inc EEADDR              '/ Increment next eeprom byte address of MyCallSign.
                Else                        '/ If EEDATA = 0 then finish to read the eeprom.
                    F_UARTBuffFull = 1      '/ = [0] End of Eeprom. The Buffer is full (one byte at least) then Start to send bytes to the terminal.
                    EECON1Bits_EEPGD = 1    '/ 1 = Access Flash program memory (Copy of Eread from Compiler command)
                    GoTo END_INT            '/ Exit this Do/Loop & Interrupt routine.
                EndIf
            Loop
        '/----------------------------------------------------------------------
        '/ For all Keyboards using ASCII Low Case character. 
        '/ Macro to Insert URCallSign into the circular array.
        ElseIf RCREG = 117 Then         '/ If "u" Low Case. Special character.
            If F_URCALLSIGN = 1 Then    '/ Did the UrCallSign has been loaded?
                FSR1 = AddressOf(CW_UrCallSignString)   '/ Current pointer of the UrCallsign string.
                Do
                    EEDATA = POSTINC1           '/ Read every URCALLSign character. EEDATA => Temporal variable.
                    If EEDATA > 0 Then     
                        POSTINC0 = EEDATA       '/ Write to the circular Array & increment the array pointer.
                        Inc UARTBuff_Head       '/ Update the Head pointer too.                   
                        WREG = __CW_StringLenght - 1
                        UARTBuff_Head = UARTBuff_Head & WREG                    
                        Inc EEADDR              '/ Increment next byte of MyCall Sign.
                    Else                        '/ If EEDATA = 0 then finish to read the eeprom.
                        F_UARTBuffFull = 1      '/ = [0] End of Eeprom. The Buffer is full (one byte at least) then Start to send bytes to the terminal.
                        GoTo END_INT            '/ Exit this Do/Loop & Interrupt routine.
                    EndIf
                Loop            
            EndIf
        '/----------------------------------------------------------------------        
        Else
        '/----------------------------------------------------------------------
            '/ Receive a standard character from the PC keyboard.
            INDF0 = RCREG                           ' Load one byte only within this interrupt.
            F_UARTBuffFull = 1                      ' There one byte in the buffer at least.
            Inc UARTBuff_Head                       ' Array pointer for next data byte  
            WREG = __CW_StringLenght - 1
            UARTBuff_Head = UARTBuff_Head & WREG    '/ New head Pointer for circular buffer.
            '/------------------------------------------------------------------
        EndIf
        GoTo END_INT                '/ Exit this Interrupt routine.
    EndIf
    '/--------------------------------------------------------------------------
    '/ Function Buttons pressed then read the number of function.
    If INTCONBits_INT0IF = 1 Then
        INTCONBits_INT0IF = 0
        INTCONBits_INT0IE = 0       '/ Disable the RB0 interrupt For a while. (some debounce system)
        ANSEL = %11000011           '/ PORTA.0 is analog. PORTA.1 is analog. Set RA<4:2> as digital I/O pins
        TRISA = %00111111           '/ Set RA<5:0> as digital Input pins
        '/ Encoder Function Read Address: 4
        TRISB = %00011111           '/ Bits7,6,5 outputs, Bits 4,3,2,1,0 inputs.
        SWEncoderAddPin0 = 0
        SWEncoderAddPin1 = 0       
        SWEncoderAddPin2 = 1
        DelayUS 10
        '/ HEX encoder: Valor 0 => %00001111 (all switches open)
        $ifdef _Proteus
        WREG = ~PORTA                   '/ Read HEX encoder, inverse because the connection.     
        $else
            $ifdef _EncoderCtsOpen
            WREG = ~PORTA               '/ Read HEX encoder with contacts Open, inverse because the connection.  
            $else
            WREG = PORTA                '/ Read HEX encoder with contacts closed.
            $endif
        $endif
        WREG = WREG >> 2    
        EncoderNumber = WREG & 15       '/ New number of message to send. (0 to 15)
        Select EncoderNumber            '/ Value of Encoder: 0
            Case 0        
                '/ Stop/Clear a function.
                F_ButtonSTOPpressed = 1 '/ STOP Button pressed.
            
            Case 1            
                '/ Check message number.
                '/ Encoder Messages Read Address: 0
                SWEncoderAddPin2 = 0 
                DelayUS 10
                '/ HEX encoder: Valor 0 => %00001111 (all switches open)
                $ifdef _Proteus
                WREG = ~PORTA                   '/ Read HEX encoder, inverse because the connection.     
                $else
                    $ifdef _EncoderCtsOpen
                    WREG = ~PORTA               '/ Read HEX encoder with contacts Open, inverse because the connection.  
                    $else
                    WREG = PORTA                '/ Read HEX encoder with contacts closed.
                    $endif
                $endif
                WREG = WREG >> 2    
                NBMessageToSend = WREG & 15     '/ New number of message to send. (0 to 15)
                F_SendNewMessage = 1            '/ (Ready) Start to Send a new message

            Case 2
                '/ Goto to configuration.
                F_ButtonCFGpressed = 1          '/ CONFIG Button pressed.

            Case 3                              '/ NR QSO Button pressed?
                '/ Change Paddles/Keyboard Mode. Paddles = 1, Keyboard = 0
                Toggle F_PaddlesMode            

            Case 4
                '/ Send RST in paddles Mode.
                F_ButtonRSTpressed = 1
                If F_PaddlesMode = 0 Then       '/ If Keyboard Mode?
                    INTCONBits_INT0IE = 1       '/ Enable RBO interrupt again. Option disabled for this mode.
                    F_ButtonRSTpressed = 0      '/ No in this Mode.
                EndIf 

            Case 5
                '/ Otherwize Send NR QSO in Contest Mode.
                If F_ContestMode = 1 Then
                    F_ButtonNRQSOpressed = 1    
                    If F_PaddlesMode = 0 Then       '/ If Keyboard Mode?
                        INTCONBits_INT0IE = 1       '/ Enable RBO interrupt again. Option disabled for this mode.
                        F_ButtonNRQSOpressed = 0    '/ No in this Mode.
                    EndIf                
                Else
                    INTCONBits_INT0IE = 1           '/ Enable RBO interrupt again. The option is disabled..
                EndIf

            Case 6                              
                '/  Decrement the QSO Contest Counter.
                F_ButtonQCCpressed = 1  

            Case 7
                '/ Set TUNE transmitter with delay ON/OFF
                F_ButtonTUNEOOpressed = 1

            Case 8
                '/ Set TUNE transmitter continuously.
                F_ButtonTUNEpressed = 1

            Case 9    
                '/ Run test CW
                F_RunCWPractice = 1             '/ Enable running CW practice.
                F_EnablePTTCopy = F_EnablePTT
                F_EnableToneCopy = F_EnableTone
                F_EnableMUTE = 1                '/ MUTE ON, CW output OFF.
                F_EnablePTT = 0                 '/ PTT OFF.
                F_EnableTone = 1                '/ Could be disable by Proton user?

            Case Else
                '/ Nothing else.
                INTCONBits_INT0IE = 1
        EndSelect
    EndIf
' Here another user interrupt code....
' .......
'/------------------------------------------------------------------------------
END_INT:
'/------------------------------------------------------------------------------
    Context Restore         ' Exit the interrupt handler and restore variables
    Declare Reminders = On
ENDSIZE(Interrupt_Handler_CODE)
'/------------------------------------------------------------------------------
_RCSTA_Error:
    WREG = RCREG            '/ Erase the buffer of the UART.
    WREG = RCREG            '/ Erase the buffer of the UART. (second byte)
    Clear RCSTABits_CREN    '/ Clear receiver status
    Set RCSTABits_CREN        
    Set RCSTABits_SPEN
    GoTo END_INT            '/ Exit the Interrupt routine.
'/==============================================================================
Over_Interrupt_Handler:
'/##############################################################################
'/ Checking the hardware reset origin.
    HRSOut_RCON()           
    RCONBits_SBOREN = 1 
    PIE2Bits_HLVDIE = 0
''    HLVDCONBits_HLVDEN = 0
    TBLPTRU = 0
    SSPCON1 = 0 '/ Disables serial port and configures these pins as I/O port pins
    SLRCON = 0  '/ All outputs on all PORTS slew at the standard rate.
'/##############################################################################
'* Purpose : Configure the Timer2 for 16, 20, 25, 64, 80, 100 Mhz xtal.
'* Input   : None                                       
'* Output  : None
'/ Note    : Same structure for 18F2xk22 & 18F2xk20 & 18F452 series.
'/ 
    KYConfigTime2()

'/##############################################################################
'* Purpose : Configure the Timer1 for 16, 20, 25, 64, 80, 100 Mhz xtal.
'* Input   : None                                       
'* Output  : None
'/ Note    : Same structure for 18F2xk22 & 18F2xk20 & 18F452 series.
'/ 
    KYConfigTime1()

'/##############################################################################
'* Purpose : Configure the Timer0 for 16, 20, 25, 64, 80, 100 Mhz xtal for Tone Out.
'* Input   : None                                       
'* Output  : None
'/ Note    : Same structure for 18F2xk22 & 18F2xk20 & 18F452 series.
'/
    KYConfigTime0()
       
'/##############################################################################
START_KEYER:
    #ifdef Watchdog_req
    Clrwdt
    #endif
    '/--------------------------------------------------------------------------
    '/ Configure interrupts
    INTCON = 0                  '/ Disables all interrupts including peripherals.
    RCONBits_IPEN = 0           '/ 0 = Disable priority levels on interrupts (Mid-Range Compatibility mode)
    INTCON3Bits_INT1IP = 1      '/ High priority interrupt For RB1. (in Case of...)
    INTCON3Bits_INT2IP = 1      '/ High priority interrupt For RB2. (in Case of...)

    INTCON2Bits_RBPU = 1        '/ Pull-ups disabled.
    T1CONBits_TMR1ON = 0        '/ Stop the Timer1 (in case of...)
    T2CONBits_TMR2ON = 0        '/ Stop the Timer2 (in Case of...)

    INTCON2Bits_INTEDG0 = 0     '/ External Interrupt 0 Edge Select bit: 0 = Interrupt on falling edge for .
    INTCON2Bits_INTEDG1 = 0     '/ External Interrupt 1 Edge Select bit: 0 = Interrupt On falling edge For . 
    INTCON2Bits_INTEDG2 = 0     '/ External Interrupt 2 Edge Select bit: 0 = Interrupt On falling edge For . 
    IOCB = 0 

    '/ Enable some buttons in PORTB for interrupts
    INTCONBits_INT0IF = 0       '/ Clear RB0 interrupt flag before sleep
    INTCON3Bits_INT1IF = 0      '/ Clear RB1 interrupt flag before sleep
    INTCON3Bits_INT2IF = 0      '/ Clear RB2 interrupt flag for MEM Button.

    INTCOnBits_INT0IE = 1       '/ Enable RB0 interrupt for STOP Button.
    INTCON3Bits_INT1IE = 0      '/ Enable RB1 interrupt for CONFIG Button.
    INTCON3Bits_INT2IE = 0      '/ Enable RB2 interrupt For MEM Button.  
    INTCONBits_PEIE = 1         '/ Peripherals Interrupt Enable bit: 1 = Enables all unmasked peripheral interrupts.
    '/--------------------------------------------------------------------------
    '/ PORTA configuration.
    '/ PORTA.0 configured by ADC library.
    '/ Inputs PORTA for HEX & DEC encoders.
    ANSEL = %11000011   '/ PORTA.0 is analog. PORTA.1 is analog. Set RA<4:2> as digital I/O pins
    TRISA = %00111111   '/ Set RA<5:0> as digital Input pins 
    '/--------------------------------------------------------------------------
    '/ PORTB for inputs only.
    ANSELH = 0              '/ Set RB<4:0> as digital I/O pins
    TRISB = %10011111       '/ Set RB<7:0> as digital Input pins
'/==============================================================================
    Low CWToneOut           '/ Output for Tone.
    Low CWPTT               '/ Disable the transmitter. 
    Low StatusLED
    Low CWDataPin
    Low SWEncoderAddPin0    '/ Output For encoders
    Low SWEncoderAddPin1    '/ Output For encoders
    Low SWEncoderAddPin2    '/ Output For encoders
    '/--------------------------------------------------------------------------
    '/ Clear all flags
    KYClearTimer2Flag()
    KYCWFlags = 0
    KYInputFlags = 0
    CWCONFIGFlags = 0
    PaddleStates = 0
    F_PTTCWAlreadySet = 1
''/==============================================================================
'    KYStartTone()
'    Do
'    If INTCONBits_TMR0IF = 1 Then
'        INTCONBits_TMR0IF = 0
'        Toggle CWToneOut            '/ ToneOut pin.
'    EndIf    
'    Loop
'/==============================================================================
'    KCW_WPM = 12
'    ValueInput = 75
'    WPM_FARNSWORTH = (KCW_WPM * ValueInput) / 100
'    HRSOut "ValueInput: ",Dec ValueInput,CR
'    HRSOut "KCW_WPM: ",Dec KCW_WPM,CR    
'    HRSOut "WPM_FARNSWORTH: ",Dec WPM_FARNSWORTH,CR       
'/==============================================================================
START_KEYER2:
    '/ Init the Keyer parameters.
    HRSFStrg(KYSTRG11,1)       '/ HRSOut "Running file: <EA3AGV_WinKeyer_V10.BAS>"

    ASMParameter(Xtal,0,MyResultByte)
    HRSFStrg(KYSTRG13,0)       '/ HRSOut "Xtal: "
    HRSOut Dec MyResultByte,CR

    ASMParameter(_System_Variable_Count,0,MyResultByte)
    HRSFStrg(KYSTRG12,0)       '/ HRSOut "System Variables Count: "
    HRSOut Dec MyResultByte,CR

    ASMParameter(F1_EOF,2,MyResultWord) '/ Last label in the asm file. (Without eeprom count)
    HRSFStrg(KYSTRG14,0)       '/ HRSOut "Program Bytes Used: "
    HRSOut Dec MyResultWord,CR

    HRSFStrg(KYSTRG16,2)       '/ HRSOut "EA3AGV YAMBIC B / ULTIMATIC KEYER"
    '/==========================================================================    
    '/ Initialization of eeprom default parameters.
    CWData = ERead EEPCW_INIT           '/ Check eeprom initialization.
    If CWData <> $5A Then
        #ifdef Watchdog_req
        Clrwdt
        #endif        
        HRSFStrg(KYSTRG23,1)   '/ HRSOut "INITIALIZE EEPROM..."  
        KYContestNumber = 0
        '/ Default CWCONFIG Flags
        CWCONFIGFlags = 0
        F_EnableTone = 1            '/[0]  1 => Enable the Tone option. (default)
        F_EnableBeacon = 0          '/[1]  0 => Disable the Beacon option. (default) 
        F_EnablePTT = 1             '/[2]  1 => Enable the PTT option. (default)
        F_DashDotRatio = 0          '/[3]  0 => Enable Dash/Dot Ratio 1:3 (default)/ 1 => Enable Dash/Dot Ratio 1:4 
        F_EnableMUTE = 0            '/[4]  0 => Disable MUTE option. (default)
        F_EnableToneCopy = 1        '/[5]  Same as F_EnableTone 
        F_EnablePTTCopy = 1         '/[6]  Same as F_EnablePTT
        F_FarnsworthSpacing = 0     '/[7]  0 => Disable Farnsworth Spacing Option. (-1 WPM step) (default)
        F_UltimaticMode = 0         '/[8]  0 => Iambic Mode.(default) 1 => Ultimatic Mode.  
        F_IambicMode = 0            '/[9]  0 => Iambic A Mode.(default), 1 => Iambic B Mode. 
        F_ShortNumbers = 0          '/[10] 0 => Numbers with standard format for contest. (default)
        F_EnableLoadUrCallSign = 0  '/[11] 0 => Disable to load the correspondent CallSign. (default)
        F_WordSpacing = 1           '/[12] 1 => Enable the auto WordSpacing option.(default)
        F_ContestMode = 0           '/[13] 0 => Disable the Contest Mode option.(default)
        '/----------------------------------------------------------------------
        '/ Here more init config
        '/----------------------------------------------------------------------
        EWrite EEPCW_CONFIG,[CWCONFIGFlags] '/ Save to eeprom all default flags 
        '/----------------------------------------------------------------------
        '/ TXOnDelays [25,50,75,100,125,150,175,200,225,250] X 1mS  
        'ValueInput = 150    '/ Default value (150 X 1mS = 150 mS)
        EWrite EEPCW_TXONDELAY,[150] 
        'CopyROMtoE2P(ROMCW_TXONDELAY,EEPCW_TXONDELAY,1)
        '/----------------------------------------------------------------------
        '/ RXOnDelays [25,50,75,100,125,150,175,200,225,250] X 4mS 
        'ValueInput = 100    '/ Default value  (100 X 4mS = 400 mS)
        EWrite EEPCW_RXONDELAY,[75] 
        'CopyROMtoE2P(ROMCW_RXONDELAY,EEPCW_RXONDELAY,1)
        '/----------------------------------------------------------------------      
        '/ Keyer TUNE ON Delays [5,10,15,20,25,30,35,40,45,50] X 100mS
        'ValueInput = 20    '/ Default value
        EWrite EEPCW_TUNEONOFFDELAY,[20] 
        'CopyROMtoE2P(ROMCW_TUNEDELAYON,EEPCW_TUNEONOFFDELAY,1)
        '/----------------------------------------------------------------------      
        '/ Keyer TUNE OFF Delays [5,10,15,20,25,30,35,40,45,50] X 100mS
        'ValueInput = 20    '/ Default value
'        EWrite EEPCW_TUNEOFFDELAY,[20] 
        'CopyROMtoE2P(ROMCW_TUNEDELAYOFF,EEPCW_TUNEOFFDELAY,1)
        '/---------------------------------------------------------------------- 
        '/ Dot/Dash Compensation 0 mS
        EWrite EEPCW_DOTDASH_ADJUSTMENT,[0]
        'CopyROMtoE2P(ROMCW_DOTDASH_ADJUSTMENT,EEPCW_DOTDASH_ADJUSTMENT,1)
        '/----------------------------------------------------------------------
        '/ WordSpace Adjustment [0,5,10,15,20,25,30,35,40,45] % of WDSPACE.
        'ValueInput = 0    
        EWrite EEPCW_WDSPACE_ADJUSTMENT,[0]
        'CopyROMtoE2P(ROMCW_WDSPACE_ADJUSTMENT,EEPCW_WDSPACE_ADJUSTMENT,1)
        '/---------------------------------------------------------------------- 
        '/ LetterSpace Adjustment [0,5,10,15,20,25,30,35,40,45] % of LTSPACE.
        'ValueInput = 0    '/ Default value
        EWrite EEPCW_LTSPACE_ADJUSTMENT,[0]    '/ 
        'CopyROMtoE2P(ROMCW_LTSPACE_ADJUSTMENT,EEPCW_LTSPACE_ADJUSTMENT,1)
        '/---------------------------------------------------------------------- 
        '/ Farnsworth Spacing Adjustment [95,90,85,80,75,70,65,60,55,50] % of WPM
        'ValueInput = 85    '/ Default value 85% WPM
        EWrite EEPCW_FARNSWORTHSP,[85]
        'CopyROMtoE2P(ROMCW_FARNSWORTHSP,EEPCW_FARNSWORTHSP,1)
        '/----------------------------------------------------------------------
        '/ Beacon Delay Adjustment [3,4,5,6,7,8,9,10,11,12] X seconds
        'ValueInput = 5    '/ Default value 5 seconds
        EWrite EEPCW_BEACONDELAY_ADJUSTMENT,[5]
        'CopyROMtoE2P(ROMCW_BEACONDELAY_ADJUSTMENT,EEPCW_BEACONDELAY_ADJUSTMENT,1)
        '/----------------------------------------------------------------------        
        '/ TUNE transmitter time out. (10 To 127 seconds max)
        'ValueInput = 30    '/ Default value 30 seconds
        EWrite EEPCW_TUNETIMEOUT_ADJUSTMENT,[30]
        'CopyROMtoE2P(ROMCW_TUNETIMEOUT_ADJUSTMENT,EEPCW_TUNETIMEOUT_ADJUSTMENT,1)        
        '/----------------------------------------------------------------------        
        '/ TONE Frequency Adjustment.
        'ValueInput = 4    '/ Default value 4 => (600Hz)
        EWrite EEPCW_TONEFREQUENCY_INDEX,[4]
        'CopyROMtoE2P(ROMCW_TONEFREQUENCY_INDEX,EEPCW_TONEFREQUENCY_INDEX,1)  
        '/----------------------------------------------------------------------    
        '/ MyCall, Default 13 Bytes
        CopyROMtoE2P(ROMCW_MYCALL,EEPCW_MYCALL,255)
        '/---------------------------------------------------------------------- 
        '/ MYQTH, Default 16 Bytes
        CopyROMtoE2P(ROMCW_QTH,EEPCW_QTH,255)
        '/---------------------------------------------------------------------- 
        '/ My QTH LOCATOR, Default 7 Bytes
        CopyROMtoE2P(ROMCW_QTHLOC,EEPCW_QTHLOC,255)
        '/---------------------------------------------------------------------- 
        '/ MyNAME, Default 12 Bytes
        CopyROMtoE2P(ROMCW_NAME,EEPCW_NAME,255)
        '/---------------------------------------------------------------------- 
        '/ My RIG, Default 18 Bytes
        CopyROMtoE2P(ROMCW_RIG,EEPCW_RIG,255)
        '/---------------------------------------------------------------------- 
        '/ My RIG/AMPLIFIER POWER, Default 6 Bytes
        CopyROMtoE2P(ROMCW_PWR,EEPCW_PWR,255)
        '/---------------------------------------------------------------------- 
        '/ My ANT, Default 14 Bytes
        CopyROMtoE2P(ROMCW_ANT,EEPCW_ANT,255)
        '/======================================================================
        '/ Message Nb 0, Default 32 Bytes
        CopyROMtoE2P(ROMCW_MSG0,EEPCW_MSG0,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 1, Default 32 Bytes
        CopyROMtoE2P(ROMCW_MSG1,EEPCW_MSG1,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 2, Default 32 Bytes
        CopyROMtoE2P(ROMCW_MSG2,EEPCW_MSG2,255)
        '/----------------------------------------------------------------------
        '/ Message Nb 3, Default 32 Bytes
        CopyROMtoE2P(ROMCW_MSG3,EEPCW_MSG3,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 4, Default 32 Bytes
        CopyROMtoE2P(ROMCW_MSG4,EEPCW_MSG4,255)
        '/----------------------------------------------------------------------
        '/ Message Nb 5, Default, 64 Bytes
        CopyROMtoE2P(ROMCW_MSG5,EEPCW_MSG5,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 6, Default, 64 Bytes
        CopyROMtoE2P(ROMCW_MSG6,EEPCW_MSG6,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 7, Default, 64 Bytes
        CopyROMtoE2P(ROMCW_MSG7,EEPCW_MSG7,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 8, Default, 64 Bytes
'        EWrite EEPCW_MSG9,["\99",0]                                                
        CopyROMtoE2P(ROMCW_MSG8,EEPCW_MSG8,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 9, Default, 64 Bytes
        CopyROMtoE2P(ROMCW_MSG9,EEPCW_MSG9,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 10, Default, 64 Bytes
        CopyROMtoE2P(ROMCW_MSG10,EEPCW_MSG10,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 11, Default, 64 Bytes
'        EWrite EEPCW_MSG12,["\99",0]                                                
        CopyROMtoE2P(ROMCW_MSG11,EEPCW_MSG11,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 12, Default, 64 Bytes
        CopyROMtoE2P(ROMCW_MSG12,EEPCW_MSG12,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 13, Default, 64 Bytes
        CopyROMtoE2P(ROMCW_MSG13,EEPCW_MSG13,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 14, Default, 64 Bytes
        CopyROMtoE2P(ROMCW_MSG14,EEPCW_MSG14,255)
        '/---------------------------------------------------------------------- 
        '/ Message Nb 15, Default, 64 Bytes
        CopyROMtoE2P(ROMCW_MSG15,EEPCW_MSG15,255)
        '/---------------------------------------------------------------------- 
        EWrite EEPCW_INIT,[$5A] '/ Configuration init complete.    
    EndIf

    '/ Read all CONFIG flags
    CWCONFIGFlags = ERead EEPCW_CONFIG
    HRSFStrg(KYSTRG25,0)   '/ HRSOut "CONFIG Flags: "
    HRSOut IBin16 CWCONFIGFlags,CR

    '/ Read the PTT flag.
    GoSub HRS_PTT_Sub 
    '/ Read & load TX ON DELAY value
    If F_EnablePTT = 1 Then
        ValueInput = ERead EEPCW_TXONDELAY  '/ TXONDelay = [25,50,75,100,125,150,175,200,225,250] X 1mS 
        CalcKYTXOnDelay(ValueInput)
        HRSFStrg(KYSTRG08,0)       '/ "TXON DELAY: "
        HRSOut Dec TXONDelay, " mS",CR
    Else
        CalcKYTXOnDelay(1)
        HRSFStrg(KYSTRG08,0)       '/ "TXON DELAY: "
        HRSFStrg(KYSTRG40,1)       '/ " DISABLED"
    EndIf

    '/ Read & load RX ON DELAY value
    If F_EnablePTT = 1 Then
        ValueInput = ERead EEPCW_RXONDELAY  '/ RXONDelay [25,50,75,100,125,150,175,200,225,250] X 4mS
        CalcKYRXOnDelay(ValueInput)
        HRSFStrg(KYSTRG07,0)       '/ "RXON DELAY: "
        HRSOut Dec RXONDelay, " mS",CR
    Else
        CalcKYRXOnDelay(1)
        HRSFStrg(KYSTRG07,0)       '/ "RXON DELAY: "
        HRSFStrg(KYSTRG40,1)       '/ " DISABLED"
    EndIf

    '/ Read the WPM potentiometer & Calculate timings.
    '/ Dinamic Parameters for the Keyer. (Configurable by potentiometer)
    WPM_OLD = 0         '/ Force To update CW speed (WPM).
    CWConfigWPM() 

    '/ Read TUNE ON DELAY value
    HRSFStrg(KYSTRG03,0)           '/ HRSOut "TUNE ON "
    HRSFStrg(KYSTRG21,0)           '/ HRSOut " DELAY: "
    HRSOut Dec TuneONDelay," mS",CR

    '/ Read TUNE OFF DELAY value
    HRSFStrg(KYSTRG04,0)           '/ HRSOut "TUNE OFF "
    HRSFStrg(KYSTRG21,0)           '/ HRSOut " DELAY: "
    HRSOut Dec TuneOFFDelay," mS",CR

    '/ Read Dot/Dash compensation value. (0 to 31mS)
    ValueInput = ERead EEPCW_DOTDASH_ADJUSTMENT
    HRSFStrg(KYSTRG89,0)       '/ "DOT/DASH COMPENSATION"
    HRSOut " +",Dec ValueInput," mS",CR

    '/ Read Letter Space Adjustment value.
    ValueInput = ERead EEPCW_LTSPACE_ADJUSTMENT '/ [0,5,10,15,20,25,30,35,40,45] % of LTSPACE.
    'GoSub CalcLetterSpaceAdjustment_Sub
    HRSFStrg(KYSTRG31,0)       '/ "LETTER"
    HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
    HRSOut Dec ValueInput
    HRSFStrg(KYSTRG92,1)       '/ "% of LTSPACE"

    '/ Read WordSpace Adjustment value.
    ValueInput = ERead EEPCW_WDSPACE_ADJUSTMENT '/ [0,5,10,15,20,25,30,35,40,45] % of WDSPACE.
    HRSFStrg(KYSTRG30,0)       '/ "WORD SPACE"
    HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
    HRSOut Dec ValueInput
    HRSFStrg(KYSTRG93,1)       '/ "% of WDSPACE"

    '/ Read Farnsworth spacing Adjustment value. (-5% step)
    ValueInput = ERead EEPCW_FARNSWORTHSP   '/ [95,90,85,80,75,70,65,60,55,50] % of WPM
    HRSFStrg(KYSTRG34,0)       '/ "FARNSWORTH SPACE"
    HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
    HRSOut Dec ValueInput
    HRSFStrg(KYSTRG94,1)       '/ "% of WPM"

    '/ Read Beacon Delay Adjustment value. 
    BeaconDelay = ERead EEPCW_BEACONDELAY_ADJUSTMENT   '/ [3,5,7,9,11,13,15,17,19,21] X seconds
    HRSFStrg(KYSTRG95,0)       '/ "BEACON DELAY"
    HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
    HRSOut Dec BeaconDelay," Seconds",CR

    '/ TUNE transmitter time out.
    TuneONTimeMax = ERead EEPCW_TUNETIMEOUT_ADJUSTMENT  
    HRSFStrg(KYSTRG105,0)       '/ "TUNE TIME MAX"
    HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
    HRSOut Dec TuneONTimeMax," Seconds",CR

    '/ TONE Frequency.
    ValueInput = ERead EEPCW_TONEFREQUENCY_INDEX    '/ Reading 0 to 9.  
    KYTMR0LValue = KYToneFreqTable(ValueInput)
    KYLoadToneFreq(KYTMR0LValue)
    HRSFStrg(KYSTRG106,0)            '/ "TONE FREQUENCY"
    Save_FSR0 = KYReadToneFreqTable()
    HRSOut " ",Dec Save_FSR0," Hz",CR

   '/ Read the DOT & DASH time.
    HRSFStrg(KYSTRG09,0)       '/ "DOT TIME: "
    HRSOut Dec PTDotTime," mS",CR
    HRSFStrg(KYSTRG10,0)       '/ "DASH TIME: "
    HRSOut Dec PTDashTime," mS",CR

   '/ Read the Letter Space time.
    HRSFStrg(KYSTRG103,0)       '/ "MSG LETTER SPACE TIME: "
    HRSOut Dec Msg_LetterSpaceTrueTime," mS",CR

   '/ Read the Word Space time.
    HRSFStrg(KYSTRG104,0)       '/ "MSG WORD SPACE TIME: "
    HRSOut Dec Msg_WordSpaceTrueTime," mS",CR

    '/ Read & print all flags individually.
    GoSub HRS_TONE_Sub
    GoSub HRS_BEACON_Sub
    GoSub HRS_DDRATIO_Sub    
    GoSub HRS_MUTE_Sub
    GoSub HRS_FARNSWORTH_Sub
    GoSub HRS_KEYERMODE_Sub
    GoSub HRS_URCALLSIGN_Sub
    GoSub HRS_WORDSPACING_Sub
    GoSub HRS_CONSTESTMODE_Sub
    '/--------------------------------------------------------------------------
    '/ Read My default Call.
    HRSFStrg(KYSTRG17,0)        '/ "My CallSign is: "  
    ReadStrg_E2P(EEPCW_MYCALL)  '/ Load MyCall in the string from eepron
'/==============================================================================
'    TMR0L = 152     '/     TMR0L = 151
'    KYStartTone()
'    Do
'    #ifdef Watchdog_req
'    Clrwdt
'    #endif 
'    If INTCONBits_TMR0IF = 1 Then
'        INTCONBits_TMR0IF = 0
'        Toggle CWToneOut            '/ ToneOut pin.
'        KYToneOFF()
'        Nop
'        TMR0L = 152             '/ 602HZ (255 - 104 + 1)
'        KYStartTone()
'    EndIf    
'    Loop    
'/==============================================================================  
READALLMESSAGES:
    #ifdef Watchdog_req
    Clrwdt
    #endif
    '/--------------------------------------------------------------------------
    GoSub PrintEEPMessages_Sub  '/ Print all messages in EEPROM.
    '/--------------------------------------------------------------------------
    GoSub PrintROMMessages_Sub  '/ Print all messages in ROM.
'/############################################################################## 
' THE MAIN PROGRAM STARTS HERE:
'/==============================================================================
STARTSIZE(CW_STATEMACHINE_CODE)
KEYER_MAIN:
    CheckAllButtonsOFF()
    Input PORTBinput1
    Input PORTBinput2
    Output CWPracticePin      
    Input PORTCinput5    
    DelayMS 500
    INTCONBits_INT0IF = 0       '/ Clear RB0 interrupt flag
'    INTCON3Bits_INT1IF = 0      '/ Clear RB1 interrupt flag
'    INTCON3Bits_INT2IF = 0      '/ Clear RB2 interrupt flag for MEM Button.
    HRSFStrg(KYSTRG50,1)        '/ "PADDLES MODE",0
    F_PaddlesMode = 1
    '/ Clear parameters of UrCallsign.
    DESpacePointer = 0                       
    CSWordCounter = 0
    Clear CW_UrCallSignString   '/ Clear the UrCallSign Buffer.
'/------------------------------------------------------------------------------
'/ To test the Audio frequency at CWTone Pin.
'    T2CONBits_TMR2ON = 1 
'Do
'    #ifdef Watchdog_req
'    Clrwdt
'    #endif
'    If PIR1Bits_TMR2IF = 1 Then
'        PIR1Bits_TMR2IF = 0
'        Toggle CWTonePin
'    EndIf
'Loop
'/==============================================================================
'/ Testing the frequency of Timer2. Ouput signal in CWTimer2OutPin.
'    $ifdef __TestTimer2
'    KYTimer2ON()
'    Do
'    If KYTimer2Flag = 1 Then
'        KYClearTimer2Flag()
'        Toggle CWTimer2OutPin
'    EndIf
'    Loop
'    $endif
'/==============================================================================
'* Purpose  : Repeat configuration of pins & clear some parameters.
'* Input    : None                                       
'* Output   : None
'/
Prepare_waitStart:
    WPM_OLD = 0     '/ Force to update CW speed (WPM).
    CWConfigWPM()   '/ Read CW Speed potenciometer. Compute all timings

Prepare_wait:
STARTSIZE(Prepare_wait_CODE)
    '/ Now enable the interrupts.
    INTCONBits_INT0IF = 0       '/ Clear RB0 interrupt flag.
    INTCONBits_INT0IE = 1       '/ (Button) Enable the RB0 interrupt.
    INTCONBits_GIE = 1          '/ 1 => Enable global interrupts
    '/--------------------------------------------------------------------------
    #ifdef Watchdog_req
    Clrwdt
    #endif
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    KYClearTimer2Flag()
    Low CWDataPin               '/ Unkey CWDataPin.
    Low CWToneOut               '/ Clear Output CWToneOut pin.
    Input ButtonFUNCTION
    Input IP_DOT
    Input IP_DASH    
    '/--------------------------------------------------------------------------
    CWRecChar = 1           '/ Prepare to record the CW character.
    F_SendTone = 0          '/ Clear the Tone.
    '/==========================================================================
    ClearKeyFlags()         '/ Clear all Flags of the keyer.
    '/==========================================================================
    CWCONFIGFlags = ERead EEPCW_CONFIG  '/ Read keyer Config FLAGS.
    '/--------------------------------------------------------------------------
    CWConfigWPM()      '/ Reload the timings (in case of change)

ENDSIZE(Prepare_wait_CODE)
'/============================================================================== 
'* Purpose : Waiting For "anything" To happen. PTT On or OFF & Waiting For transmitter On delay.
'* Input   : None                                       
'* Output  : None
'* Note    : 
'/
WaitingKEY:
STARTSIZE(Waiting_CODE)
Do
    #ifdef Watchdog_req
    Clrwdt
    #endif
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ' Check NR QSO Button pressed.
    If F_ContestMode = 1 Then
        If F_ButtonNRQSOpressed = 1 Then
            F_ButtonNRQSOpressed = 0
            F_PTTCWAlreadySet = 0
            If F_EnablePTT = 1 Then
                '/  Normal mode. Beacon is not running.
                If CWPTT = 0 Then
                    High CWPTT          '/ Transmitter on, receiver off
                    DelayMS TXONDelay   '/ Load & Start the TX delay.
                EndIf
            EndIf      
            CWSendRSTNumberQSO()    '/ Send RST + QSO number.
            KYStartTimer2CP(Msg_WordSpaceTime) '/ Start TimeOut for PTT. 
            INTCONBits_INT0IE = 1   '/ Enable the RB0 interrupt. 
        EndIf
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    If F_ButtonRSTpressed = 1 Then
        F_ButtonRSTpressed = 0
        F_PTTCWAlreadySet = 0
        If F_EnablePTT = 1 Then
            If CWPTT = 0 Then
                High CWPTT          '/ Transmitter on, receiver off
                DelayMS TXONDelay   '/ Load & Start the TX delay.
            EndIf
        EndIf      
        CWSendRST()                 '/ Send RST 
        KYStartTimer2CP(Msg_WordSpaceTime) '/ Start TimeOut for PTT. 
        INTCONBits_INT0IE = 1   '/ Enable the RB0 interrupt.
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ Set TUNE the transmitter with ON/OFF delay.
    If F_ButtonTUNEOOpressed = 1 Then
        F_ButtonTUNEOOpressed = 0
        TUNETX_ONOFF()
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ Set TUNE the transmitter continuously.
    If F_ButtonTUNEpressed = 1 Then
        F_ButtonTUNEpressed = 0
        TUNETX_ON()
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    CWRecChar = 1               '/ Reset the CW character.
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
   '/ Check Dot state.
    If IP_DOT = 0 Then
        F_Dot_Mem = 1
        F_Dot_First = 1         '/ For Ultimatic Mode.
        GoSub StartDotDash_Sub
        If F_Dot_Mem = 1 Then
            GoTo Start_dot      '/ Start keyer routines.
        EndIf
        GoTo Prepare_wait
    EndIf

    '/ Check Dash state.
    If IP_DASH = 0 Then
        F_Dash_Mem = 1
        F_Dash_First = 1        '/ For Ultimatic Mode.
        GoSub StartDotDash_Sub
        If F_Dash_Mem = 1 Then
            GoTo Start_dash     '/ Start keyer routines.
        EndIf
        GoTo Prepare_wait
    EndIf 

    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ' Check TXDown delay timeout.
    If F_PTTCWAlreadySet = 0 Then
        KYCountTimer2()
        If F_CWCounter = 0 Then     '/ End of timer? 
            F_PTTCWAlreadySet = 1
            If F_EnablePTT = 1 Then
                If CWPTT = 1 Then               '/ If PTT is ON then Counting the PTT Timeout.
                    If F_ClearPTT = 1 Then      '/ Enabled to clear the PTT.
                        F_ClearPTT = 0
                        Low CWPTT               '/ Transmitter OFF, receiver ON
                    EndIf
                EndIf        
            EndIf            
            '/----------------------------------------------------------
            If F_WordSpacing = 0 Then  '/ Word spacing option disabled.
                HRSOut "| "            '/ Separator for calls/paddles messages.
                Inc NbCharsPrinted
                Inc NbCharsPrinted
                If NbCharsPrinted > 78 Then
                    NbCharsPrinted = 0
                    HRSOut CR
                EndIf
            Else                    '/ Word spacing option enabled.
                HRSOut "||"         '/ Separator for calls/paddles messages.
                NbCharsPrinted = 0
                CSWordCounter = 0   '/ Loading a new UR CALLSIGN at the beginning of keying.
                DESpacePointer = 0                 
                HRSOut CR           '/ Every time PTT OFF return to the init of line.
            EndIf
            GoTo Prepare_wait
        EndIf
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ To Clear the PTT with the STOP Button/Beacon start & erase the UrCallSign.
    If F_ButtonSTOPpressed = 1 Then
        F_ButtonSTOPpressed = 0
        '/----------------------------------------------------------------------
        F_ClearPTT = 0          '/ Erase the Order to clear the PTT.
        Low CWPTT               '/ Transmitter OFF, receiver ON
        '/----------------------------------------------------------------------
        F_KYBeaconStart = 0     '/ Stops the Beacon Watchdog
        F_SendNewMessage = 0    '/ Stops to send a message.
        '/----------------------------------------------------------------------
        If F_URCALLSIGN = 1 Then
            '/ Erase the URCallSIgn string array and parameters.
            F_URCALLSIGN = 0
            HRSOut CR
            HRSFStrg(KYSTRG54,1)   '/ "UR CALLSIGN IS ERASED",0
            GoSub HRS_URCALLSIGN_Sub
        EndIf
        CSWordCounter = 0
        DESpacePointer = 0    
        CW_UrCallSignString#0 = 0   '/ Trick to clear a String.
        '/----------------------------------------------------------------------
        '/ Checking if the Button is depressed. (debounce)
        'High StatusLED
        While ButtonFUNCTION = 0
            #ifdef Watchdog_req
            Clrwdt
            #endif            
            DelayMS 10
        Wend  
        Low StatusLED            '/ Clear Status LED.
        '/----------------------------------------------------------------------
'        INTCONBits_INT0IF = 0   '/ Clear RB0 interrupt flag for Button.
        '/----------------------------------------------------------------------        
        GoTo Prepare_wait            
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ Option Beacon Watchdog: Counting timeout.
    BeaconTimeOut()
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ Checking if a new message has been called by interruption or Beacon Mode.
    '/ The number of message is in the "NBMessageToSend" variable.
    If F_SendNewMessage = 1 Then
        CheckingMessage()
        '/----------------------------------------------------------------------
        '/ Avoid bounces of the MEM switch.
        INTCONBits_INT0IE = 1   '/ Enable the RB0 interrupt.
        '/----------------------------------------------------------------------
        StartBeaconDelay()          '/ Check if Beacon Mode is running to start a delay beetwen messages.
        KYStartTimer2CP(SumDELAYS)  '/ Start TimeOut for PTT. 
        GoTo Prepare_wait
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ While the Code is Waiting For something, read the Configuration Button.
    If F_ButtonCFGpressed = 1 Then
        F_ButtonCFGpressed = 0
        '/ Checking if the Button is depressed. (debounce)
        'High StatusLED
        While ButtonFUNCTION = 0
            #ifdef Watchdog_req
            Clrwdt
            #endif            
            DelayMS 10
        Wend  
        DelayMS 100
        'StatusLED = 0
        INTCONBits_INT0IE = 1   '/ Enable the RB0 interrupt.
        GoTo STARTCONFIG        
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ Decrement the QSO Contest Counter by Button.
    If F_ButtonQCCpressed = 1 Then
        F_ButtonQCCpressed = 0
        '/ Decrement the QSO Counter.
        If KYContestNumber > 0 Then
            Dec KYContestNumber
        EndIf
        HRSFStrg(KYSTRG38,0)   '/ "Decrement QSO counter: "
        HRSOut  Dec KYContestNumber,CR
        '/ Check if Button is still pressed.
        While ButtonFUNCTION = 0
            #ifdef Watchdog_req
            Clrwdt
            #endif            
            DelayMS 10
        Wend  
        INTCONBits_INT0IE = 1   '/ Enable the RB0 interrupt.
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ Running CW TEST. Disable with Paddles or STOP Button.    
    '/ Dot Paddle & STOP Button stop practice and clear the Practice Mode.
    '/ Dash Paddle stop practice and increment the Practice Mode.    
    If F_RunCWPractice = 1 Then
        F_RunCWPractice = 0
        '/ Seed value changes every time it is called.
        RunCWSeed()     
        RunCWPractice()
        INTCONBits_INT0IE = 1   '/ Enable the RB0 interrupt.
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ While the code is Waiting for something, read the WPM Value.
    CWConfigWPM()
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ Blinking the Status LED when URCALLSIGN is loaded.
    '/ Press the STOP button to erase the URCALLSIGN if it is not used.
    If F_URCALLSIGN = 1 Then
        Inc MyDelayWord
        If MyDelayWord = 0 Then
            Toggle StatusLED
        EndIf
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ Change to Keyboard Mode. 
    If F_PaddlesMode = 0 Then
        GoTo StartKeyboard      '/ Using the Keyboard to send CW characters.
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
Loop
ENDSIZE(Waiting_CODE)
'/==============================================================================
'* Purpose : Start the PTT with Delay / Reset the Beacon function.
'* Input   : Dot/Dash paddle.                                       
'* Output  : Start PTT/ Reset BEACON. 
'* Note    : If BEACON is running. The Dot/Dash pressed stops the Beacon. The PTT is not activated.
'/         : If BEACON is NOT running, the PTT and Delay are activated. 
'/
StartDotDash_Sub:
STARTSIZE(StartDotDash_CODE)
    INTCONBits_INT0IE = 0   '/ Disable the RB0 interrupt(STOP Button) For a While.
    If F_KYBeaconStart = 1 Then
        INTCONBits_GIE = 0 
        F_KYBeaconStart = 0     '/ Stops the Beacon Watchdog
        F_SendNewMessage = 0    '/ Stops to send a message.
        '/ The Dot/Dash is not sent, Clearing flags.
        F_Dot_Mem = 0
        F_Dot_First = 0
        F_Dash_Mem = 0
        F_Dash_First = 0
        '/----------------------------------------------------------------------
        '/ Waiting all paddles are off.
        High StatusLED
        Repeat 
            #ifdef Watchdog_req
            Clrwdt
            #endif     
            DelayMS 10
        Until IP_DOT = 1
        Repeat 
            #ifdef Watchdog_req
            Clrwdt
            #endif      
            DelayMS 10
        Until IP_DASH = 1
        StatusLED = 0           '/ Exit running Beacon Mode. The Beacon Mode is still enabled.
        '/----------------------------------------------------------------------
        INTCONBits_GIE = 1  
        '/----------------------------------------------------------------------
    Else
        '/----------------------------------------------------------------------
        Low StatusLED
        F_PTTCWAlreadySet = 0
        If F_EnablePTT = 1 Then
            '/  Normal mode. Beacon is not running.
            If CWPTT = 0 Then
                High CWPTT          '/ Transmitter on, receiver off
                DelayMS TXONDelay   '/ Load & Start the TX delay.
            EndIf
        EndIf        
        '/----------------------------------------------------------------------
    EndIf
    INTCONBits_INT0IE = 1   '/ Enable the RB0 interrupt again.
    Return
ENDSIZE(StartDotDash_CODE)
'/##############################################################################
'/ STATE MACHINE:
'/==============================================================================
'* Purpose : Starting the Dot pulse sequence.
'* Input   : Dot paddle.                                       
'* Output  : None
'* Note    : Start DOT State
'/
Start_dot:
STARTSIZE(Send_dot_CODE)
    If F_EnableMUTE = 0 Then    '/ If MUTE = OFF then send CW data.
        CWDataPin = 1           '/ Key down CWDataPin
    EndIf
'    F_SendTone = 0
'    If F_EnableTone = 1 Then
'        F_SendTone = 1          '/ Send tone for Dot.
'    EndIf
    KYStartTone()
    KYStartTimer2(CW_DotTime)   '/ Load & start Delay value for Dot.
'/==============================================================================   
'* Purpose : Send Dot pulse to out pin.
'* Input   : None                                       
'* Output  : None
'* Note    : Option to record the Dot.
'/
Send_dot:                  
'/ start sending a DOT
Do
    #ifdef Watchdog_req
    Clrwdt
    #endif

    KYToneOut()

    '/ Nothing more to do, waiting for the final of the CW_DotTime. 
    KYCountTimer2()                 '/ Check dot delay
    If F_CWCounter = 0 Then         '/ End time of Dot.
        CWDataPin = 0               '/ Unkey CWDataPin
        '/----------------------------------------------------------------------
        Rol CWRecChar,Clear         '/ Rotate the character. (Record a Dot/Dash)
        CWRecChar.0 = 0             '/ Append DOT.        
        '/----------------------------------------------------------------------
        F_Dot_Mem = 0               '/ Dot memory done.
        If IP_DASH = 1 Then         '/ Dash depressed?
            F_Dash_First = 0        '/ Reset Dash_First flag For Ultimatic Mode.
        EndIf     
        GoTo Dot_space
    EndIf
Loop
ENDSIZE(Send_dot_CODE)
'/==============================================================================
'* Purpose : Waiting 1 Dot delay after Dot.
'* Input   : None                                       
'* Output  : None
'* Note    : +1 Dot time. total Pause: 1 = 1 Dot delay after Dot
'/         : Start DOT_SPACE State
Dot_space:
STARTSIZE(Dot_space_CODE)
    '/ For Ultimatic Mode/Iambic Mode.
    If F_UltimaticMode = 0 Then     '/ Follows the configuration
        F_Dot_First = 0
        F_Dash_First = 0
    EndIf
    KYStartTimer2(CW_DotDashSpaceTime)         '/ Load & start Delay for Dot space.
'/------------------------------------------------------------------------------
Do
    #ifdef Watchdog_req
    Clrwdt
    #endif
    '/--------------------------------------------------------------------------
    '/ Read Dash Paddle first.
    If IP_DASH = 0 Then
        F_Dash_Mem = 1
    Else
        F_Dash_First = 0
    EndIf 
    '/--------------------------------------------------------------------------
    KYCountTimer2()                  '/ Check Dot_space delay
    If F_CWCounter = 0 Then         '/ End time of Dot_space.
        '/----------------------------------------------------------------------
        '/ Read Dot Paddle
        If IP_DOT = 0 Then
            F_Dot_Mem = 1
        Else
            F_Dot_First = 0
        EndIf 
        '/----------------------------------------------------------------------
        '/ The Ultimatic decision is resolved after in the Dot_space time.
        '/ Ultimatic Mode / Iambic Mode.
        If F_Dash_First = 1 Then
            '/ Ultimatic Mode.
            If F_Dot_Mem = 1 Then
                GoTo Start_dot
            EndIf
            If F_Dash_Mem = 1 Then
                 GoTo Start_dash
            EndIf
        Else
            '/ Iambic Mode / Ultimatic Mode.
            If F_Dash_Mem = 1 Then
                If F_UltimaticMode = 0 Then
                    If F_IambicMode = 0 Then    '/ For Iambic Mode A.
                        F_Dot_Mem = 0           '/ Iambic A
                    EndIf 
                EndIf
                GoTo Start_dash
            EndIf
            If F_Dot_Mem = 1 Then
                If F_UltimaticMode = 0 Then
                    If F_IambicMode = 0 Then    '/ For Iambic Mode A.
                        F_Dash_Mem = 0          '/ Iambic A
                    EndIf
                EndIf
                GoTo Start_dot
            EndIf
        EndIf
        '/----------------------------------------------------------------------
        GoTo Start_LetterSpace
    EndIf
    '/--------------------------------------------------------------------------
    '/ While the code is Waiting for something, read the WPM Value.
    '/ To adjust the speed when the Dot paddle is pressed.
    CWConfigWPM()
    '/--------------------------------------------------------------------------
Loop
ENDSIZE(Dot_space_CODE)
'/==============================================================================
'* Purpose : Starting the Dash pulse sequence.
'* Input   : Dash paddle.                                       
'* Output  : None
'* Note    : Start DASH State
'/
Start_dash:
STARTSIZE(Send_dash_CODE)
    If F_EnableMUTE = 0 Then    '/ If MUTE = OFF then send CW data.
        CWDataPin = 1           '/ Key down CWDataPin
    EndIf
'    F_SendTone = 0
'    If F_EnableTone = 1 Then
'        F_SendTone = 1          '/ Send tone for Dash.
'    EndIf
'    If F_EnableTone = 1 Then
        KYStartTone()
'    EndIf
    KYStartTimer2(CW_DashTime)  '/ Load & start Delay value for Dash.
'/==============================================================================   
'* Purpose : Send Dash pulse to out pin.
'* Input   : None                                       
'* Output  : None
'* Note    : Option to record the Dash.
'/         : Start SEND_DASH State

Send_dash:
Do
    #ifdef Watchdog_req
    Clrwdt
    #endif

    KYToneOut()

    '/ Nothing more to do, waiting for the final of the CW_DashTime. 
    KYCountTimer2()                 '/ Check dash delay
    If F_CWCounter = 0 Then         '/ End time of Dash.
        CWDataPin = 0               '/ Unkey CWDataPin.
        '/----------------------------------------------------------------------
        Rol CWRecChar,Clear         '/ Rotate the Bits.  (Record a Dot/Dash)
        CWRecChar.0 = 1             '/ Append DASH.
        '/----------------------------------------------------------------------
        F_Dash_Mem = 0              '/ Dash memory done.
        If IP_DOT = 1 Then          '/ Dot depressed?
            F_Dot_First = 0         '/ Reset Dot_First flag For Ultimatic Mode.
        EndIf  
        '/----------------------------------------------------------------------
        GoTo Dash_space
    EndIf
Loop
ENDSIZE(Send_dash_CODE)
'/============================================================================== 
'* Purpose : Waiting 1 Dot delay after Dash.
'* Input   : None                                       
'* Output  : None
'* Note    : Waiting +1 Dot time. total Pause: 1 = 1 Dot delay after Dash
'/         : Start DASH_SPACE State

Dash_space:                     '/ Start pause after DASH (Pause:1 Dot)
STARTSIZE(Dash_space_CODE)
    '/ For Ultimatic Mode/Iambic Mode.
    If F_UltimaticMode = 0 Then '/ Follows the configuration
        F_Dot_First = 0
        F_Dash_First = 0
    EndIf
    KYStartTimer2(CW_DotDashSpaceTime)     '/ Start Delay Dash_space
'/------------------------------------------------------------------------------
Do
    #ifdef Watchdog_req
    Clrwdt
    #endif
    '/--------------------------------------------------------------------------
    '/ Read Dot Paddle first.
    If IP_DOT = 0 Then
        F_Dot_Mem = 1
    Else
        F_Dot_First = 0
    EndIf 
    '/--------------------------------------------------------------------------
    ' Check Dash_space delay
    KYCountTimer2()
    '/--------------------------------------------------------------------------
    If F_CWCounter = 0 Then     '/ End time of Dash_space.
        '/----------------------------------------------------------------------
        '/ Read Dash Paddle
        If IP_DASH = 0 Then
            F_Dash_Mem = 1
        Else
            F_Dash_First = 0
        EndIf 
        '/----------------------------------------------------------------------
        '/ The Ultimatic decision is resolved after the Dash_space time.
        '/ Ultimatic Mode / Iambic Mode.
        If F_Dot_First = 1 Then
            '/ Ultimatic Mode.
            If F_Dash_Mem = 1 Then
                GoTo Start_dash
            EndIf
            If F_Dot_Mem = 1 Then
                 GoTo Start_dot
            EndIf
        Else
            '/ Iambic Mode & Ultimatic Mode.
            If F_Dot_Mem = 1 Then
                 If F_UltimaticMode = 0 Then
                     If F_IambicMode = 0 Then   '/ For Iambic Mode A.
                        F_Dash_Mem = 0          '/ Iambic A
                     EndIf
                 EndIf
                 GoTo Start_dot
            EndIf
            If F_Dash_Mem = 1 Then
                 If F_UltimaticMode = 0 Then
                     If F_IambicMode = 0 Then   '/ For Iambic Mode A.
                        F_Dot_Mem = 0           '/ Iambic A
                     EndIf
                 EndIf
                 GoTo Start_dash
            EndIf
        EndIf
       '/----------------------------------------------------------------------
        GoTo Start_LetterSpace
    EndIf
    '/--------------------------------------------------------------------------
    '/ While the code is Waiting for something, read the WPM Value.
    '/ To adjust the speed when the Dash paddle is pressed.
    CWConfigWPM()
    '/--------------------------------------------------------------------------
Loop
ENDSIZE(Dash_space_CODE)
'/============================================================================== 
'* Purpose : Delay For Inter letter state - Detecting SPACES between Characters.
'* Input   : None                                       
'* Output  : None
'* Note    : Waiting +2 Dots time. total Pause: 1 + 2 = 3 Dots delay after Dot Or Dash.
'/         : Start Start_LetterSpace State

Start_LetterSpace:
STARTSIZE(Send_LetterSpace_CODE)
'    High TestPin
    KYStartTimer2(CW_LetterSpaceTime)  '/ Start Timer Letter Space.
'    HRSOut "CW_LetterSpaceTime: ", Dec CW_LetterSpaceTime,CR
'/==============================================================================
Send_LetterSpace:
Do                          '/ Waiting 3 dots time. 
    #ifdef Watchdog_req
    Clrwdt
    #endif

    '/ Check paddles pressed.
    '/ Modif
    ReadPaddles()
    '/ Nothing more to do, waiting for the final of the CW_LetterSpaceTime.    

    KYCountTimer2()         ' Check dash pause delay
    '/--------------------------------------------------------------------------
    If F_CWCounter = 0 Then
        '/----------------------------------------------------------------------
        '/ Send CW characters to the terminal.
        If CWRecChar = 0 Then
            CWRecChar = CW_QMARK    '/ (? char) The CW character must have a start bit. (Bit7)
        EndIf
        '/ Convert all CW format characters to ASCII characters.
        CWData = CWCharToAscii(CWRecChar)
        '/ Transform & Print the special characters.
        Inc NbCharsPrinted      '/ Counting the characters printed to the terminal.
        Inc NbCharsPrinted      '/ Because the Prosigns have 2 characters.
        Select CWData
            Case "#"
                HRSOut "AR"     '/ [#] End of message.
            Case "*"
                HRSOut "AS"     '/ [*] Stand by.               
            Case "%"
                HRSOut "KA"     '/ [%] Beginning of message, Starting Signal.
            Case "&"
                HRSOut "KN"     '/ [&] Go only, invite a specific station To transmit.
            Case "<"
                HRSOut "BK"     '/ [<] End of transmission. Go only, invite a specific station To transmit.        
            Case "="
                HRSOut "BT"     '/ [=] Double Dash, Pause Or Break. "official" separator.
            Case ">"
                HRSOut "VE"     '/ [>] Understood.
            Case "]"
                HRSOut "AA"     '/ [[] New Line.
            Case "["
                HRSOut "AL"     '/ []] Paragraph. 
            Case "^"
                HRSOut "SK"     '/ [^] End of contact (sent before Call).                
            Case "|"
                HRSOut "EOM"    '/ [EOM] (.-----) [|] used for "partitions" of message.
            Case 96
                Inc NbCharsPrinted  '/ Because this Prosign has 3 characters.
                HRSOut "WNG"        '/ [WARNING] CW_WARNING 
            Case Else            
                HRSOut CWData       '/ Print Standard character.
                Dec NbCharsPrinted  '/ Only one character sent.
        EndSelect            
        '/----------------------------------------------------------------------          
        Inc NbCharsPrinted
        If NbCharsPrinted > 80 Then
            NbCharsPrinted = 0
            HRSOut CR
        EndIf
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ Looking for URCallSign. Reading & loading charaters.
        If F_WordSpacing = 1 Then       '/ Word spacing option enabled?.
            If F_EnableLoadUrCallSign = 1 Then
                If F_URCALLSIGN = 0 Then
                    '/--------------------------------------------------------------
                    CW_UrCallSignString[DESpacePointer] = CWData
                    Inc DESpacePointer              '/ Increment the pointer of the array.
                    If DESpacePointer > __CW_UrCallSignStringLenght - 1 Then
                        DESpacePointer = 0
                        CW_UrCallSignString#0 = 0   '/ Trick to clear a String.
                        CSWordCounter = 0
                    EndIf 
                    '/--------------------------------------------------------------
                EndIf
            EndIf
        EndIf
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        CWRecChar = 1           '/ Reset the CW character. (Very Important!!!)
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ Check paddles pressed.
        ReadPaddles()
        '/----------------------------------------------------------------------
        '/ Check Dot/Dash memories.
        If F_Dot_Mem = 1 Then                 
            F_Dot_First = 1     '/ For Ultimatic Mode.
            F_Dash_First = 0    '/ Modif
            GoTo Start_dot
        EndIf
        If F_Dash_Mem = 1 Then
            F_Dash_First = 1    '/ For Ultimatic Mode.
            F_Dot_First = 0     '/ Modif
            GoTo Start_dash
        EndIf
        '/----------------------------------------------------------------------
        '/ NO paddle pressed then waiting a WordSpace.
        SumDELAYS = CW_LetterSpaceTime + CW_DotTimeA
'        HRSOut "SumDELAYS: ", Dec SumDELAYS,CR
        If F_WordSpacing = 1 Then       '/ Word spacing option enabled?
            'Low TestPin                 '/ To check the CW_LetterSpaceTime
            GoTo Start_WordSpace        '/ YES then goto Word space option.
        Else                            '/ NO, Without Word spacing option.
            KYStartTimer2CP(SumDELAYS)  '/ New Start TimeOut for RXON Delay.
            F_PTTCWAlreadySet = 0       '/ Then clear the PTT and/OR set RXONDelay.
            GoTo Prepare_wait        
        EndIf
    EndIf
    '/-------------------------------------------------------------------------- 
    '/ While the code is Waiting for something, read the WPM Value.
    CWConfigWPM()
    '/-------------------------------------------------------------------------- 
Loop
ENDSIZE(Send_LetterSpace_CODE)
'/==============================================================================
'* Purpose : Delay For Inter Word state - Detecting SPACES between Words
'* Input   : None                                       
'* Output  : None
'* Note    : Waiting +4 Dots time. total Pause: 1 + 2 + 4 = 7  Dots delay after Dot or Dash.
'/         : Start Start_WordSpace State

Start_WordSpace:
STARTSIZE(Send_WordSpace_CODE)
    KYStartTimer2(CW_WordSpaceTime)
'    HRSOut "CW_WordSpaceTime: ", Dec CW_WordSpaceTime,CR
'/==============================================================================
Send_WordSpace:
Do
    #ifdef Watchdog_req
    Clrwdt
    #endif

    ReadPaddles()
    '/ Nothing more to do, waiting for the final of the CW_WordSpaceTime.

    '/--------------------------------------------------------------------------
    '/ Check WordSpace delay
    KYCountTimer2()
    '/--------------------------------------------------------------------------
    If F_CWCounter = 0 Then
        '/----------------------------------------------------------------------
        HRSOut " "  '/ It is a Word delay then Send a space to the terminal.
        '/----------------------------------------------------------------------
        Inc NbCharsPrinted          '/ Because Space is character too.
        If NbCharsPrinted > 80 Then
            NbCharsPrinted = 0
            HRSOut CR
        EndIf 
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        STARTSIZE(CheckURCallSign_CODE)
        '/ Looking for UR CallSign.
        If F_EnableLoadUrCallSign = 1 Then  '/ If this option enabled.
            If F_URCALLSIGN = 0 Then        '/ UR CallSign not loaded yet?
                CW_UrCallSignString[DESpacePointer] = " "
                Inc DESpacePointer          '/ Update the array pointer.
                Inc CSWordCounter           '/ Increment the counter of words.
                If DESpacePointer > __CW_UrCallSignStringLenght - 1 Then
                    DESpacePointer = 0
                    CW_UrCallSignString#0 = 0   '/ Trick to clear a String.
                    CSWordCounter = 0
                EndIf
                '/--------------------------------------------------------------
                If CSWordCounter = 2 Then       '/ The array must have 2 words only.    
                    CWLoop = Len(CW_UrCallSignString)   '/ Number of characters loaded in string.
                    '/----------------------------------------------------------
                    '/ For test only. (debug)
'                    HRSOut "[" 
'                        HRSOut CW_UrCallSignString   
'                    HRSOut "] "
                    '/----------------------------------------------------------
                    If CWLoop > 7 Then          '/ Short Call (4 characters + 1 SP + DE + 1 SP) = 8
                        #ifdef Watchdog_req
                        Clrwdt
                        #endif
                        FSR1 = VarPtr(CW_UrCallSignString)
                        Repeat
                            ReadPaddles()                   '/ Check paddles pressed.
                            #ifdef Watchdog_req
                            Clrwdt
                            #endif
                            CWData = INDF1
                            '/--------------------------------------------------
                            '/ Looking for the First Space.
                            If CWData = " " Then            '/ Looking for the next space.
                                POSTINC1 = 0                '/ Final String.
                                '/ Checking the "DE" Word.
                                '/----------------------------------------------
                                '/ Checking the "D" letter.
                                If INDF1 = "D" Then         '/ Is "D" written?
                                    POSTINC1 = 0            '/ Clear RAM position, Final String. Next character.
                                    '/------------------------------------------
                                    '/ Checking the "E" letter.
                                    If INDF1 = "E" Then     '/ Is "E" written?
                                        POSTINC1 = 0        '/ Clear RAM position, Final String. Next character.
                                        '/--------------------------------------
                                        '/ Checking the Space after "DE".
                                        If INDF1 = " " Then     '/ Is a Space written after DE?
                                            F_URCALLSIGN = 1    '/ UrCallSign Valid.
                                        EndIf  
                                        Break                   '/ Exit the Repeat/Until routine.
                                        '/--------------------------------------
                                    Else
                                        Break
                                    EndIf
                                    '/------------------------------------------
                                Else
                                    Break
                                EndIf
                                '/--------------------------------------------------
                            EndIf                
                            '/--------------------------------------------------
                            WREG = POSTINC1 '/ Increment FSR1, string index.
                            Dec CWLoop
                        Until CWLoop = 0
                        If F_URCALLSIGN = 1 Then
                            '/ The UR CAllSin is sent to the terminal to check it.
                            '/ If it is erroneous, it is possible to erase this
                            '/ string by the STOP Button in the PTT OFF time.
                            HRSOut "["
                            HRSOut CW_UrCallSignString 
                            HRSOut "] "
                        EndIf
                    EndIf
                    '/ Clear all parameters to begin again.
                    If F_URCALLSIGN = 0 Then
                        'Clear CW_UrCallSignString   '/ Clear all characters loaded.
                        CW_UrCallSignString#0 = 0   '/ Trick to clear a String.
                    EndIf
                    DESpacePointer = 0                       
                    CSWordCounter = 0
                EndIf
            EndIf
        EndIf        
        ENDSIZE(CheckURCallSign_CODE)
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ Check paddles pressed.
        ReadPaddles()
        '/---------------------------------------------------------------------- 
        '/ Check Dot paddle.
        If F_Dot_Mem = 1 Then                 
            F_Dot_First = 1     '/ For Ultimatic Mode.
            F_Dash_First = 0    '/ Modif
            GoTo Start_dot
        EndIf
        '/ Check Dash paddle.
        If F_Dash_Mem = 1 Then
            F_Dash_First = 1    '/ For Ultimatic Mode.
            F_Dot_First = 0     '/ Modif
            GoTo Start_dash
        EndIf
        '/---------------------------------------------------------------------- 
        '/ NO Dot or Dash pressed then go to start.
        SumDELAYS = SumDELAYS + CW_WordSpaceTime
'        SumDELAYS = SumDELAYS - ((5 * 121) / 100)
'        HRSOut "SumDELAYS: ", Dec SumDELAYS,CR
        KYStartTimer2CP(SumDELAYS)    '/ Start TimeOut for RXON Delay.
        F_PTTCWAlreadySet = 0         '/ Then clear the PTT and/OR set RXONDelay.
        'Low TestPin                   '/ To check the CW_WordSpaceTime
        GoTo Prepare_wait
    EndIf
    '/-------------------------------------------------------------------------- 
    '/ While the code is Waiting for something, read the WPM Value.
    CWConfigWPM()
    '/-------------------------------------------------------------------------- 
Loop
ENDSIZE(Send_WordSpace_CODE)
ENDSIZE(CW_STATEMACHINE_CODE)
'/==============================================================================
'* Purpose : Start Keyboard routine.
'* Input   : string array characters                                       
'* Output  : CWDataPin (morse characters)
'* Note    : The string array [CW_StringSend] must have 128,256 characters lenght. 
'/         : The CW_StringSend array is used as a ring buffer. With the 128 array lenght
'/           there is no problem for characters capacity.

StartKeyboard:
STARTSIZE(KeyboardState_CODE)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    HRSOut CR
    HRSFStrg(KYSTRG15,1)   '/ HRSOut "KEYBOARD MODE" 
    HRSFStrg(KYSTRG22,1)   '/ HRSOut "LISTENING..."   
    CW_Exit = 0
    CWDataPin = 0               '/ CWDataPin for transmitter.
    CWToneOut = 0               '/ Output Tone Pin.

    WPM_OLD = 0     '/ Force to update CW speed (WPM).
    CWConfigWPM()   '/ Read CW Speed potenciometer. Compute all timings
   
    '/ Reset parameters.
    F_PTTUartAlreadySet = 0
    NbCharsPrinted = 0
    MyResultWord = 0

    '/ Clear parameters of UrCallsign.
    DESpacePointer = 0                       
    CSWordCounter = 0
'/------------------------------------------------------------------------------
KeyboardState:
    '/ Enable RCIE interrupt included.
    INTCONBits_GIE = 0  '/ Disable Global interrupts.
    PIE1Bits_RCIE = 0   '/ 0 = Disables the EUSART receive interrupt
    PIR1Bits_RCIF = 0   '/ Clear the UART receive flag in case of...
    IPR1Bits_RCIP = 1   '/ EUSART Receive Interrupt Priority bit: 1 = High priority
    RCSTABits_SPEN = 1  '/ 1 = Serial port enabled (configures RX/DT and TX/CK pins as serial port pins)
    CleanUART1()        '/ Clean the UART before to use [mandatory]. (Avoid UART problems)
    Clear CW_StringSend '/ Erase ALL the string array because some extra characters could be written.
    UARTBuff_Head = 0   '/ Clear the array pointers (better).
    UARTBuff_Tail = 0  
    F_UARTBuffFull = 0
    PIE1Bits_RCIE = 1   '/ 1 = Enables again the EUSART receive interrupt.

    '/ Prepare the interrupts.
    INTCONBits_INT0IE = 1   '/ (Button FUNCTION) Enable the RB0 interrupt.
    INTCONBits_PEIE = 1     '/ Peripherals Interrupt Enable bit: 1 = Enables all unmasked peripheral interrupts.
    INTCONBits_GIE = 1      '/ Enable Global interrupts.
    '/==========================================================================
    KYCW_Timings()          '/ Update the CW speed (WPM).
    '/==========================================================================
    '/ Enable again all Buttons in the waiting loop.
'    INTCONBits_INT0IE = 1   '/ (Button) Enable the RB0 interrupt.
    '/--------------------------------------------------------------------------
KeyboardLoop:
Do
    #ifdef Watchdog_req
    Clrwdt
    #endif
    INTCONBits_INT0IE = 1   '/ (Button) Enable the RB0 interrupt.
    CWDataSend = 0          '/ Clear Exit character. Ready.
    F_SpecialChar = 0
    '/;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    '/ Checking if any character in the buffer?
    If F_UARTBuffFull = 1 Then          
        '/----------------------------------------------------------------------
        '/ Read the ASCCII circular buffer array.
        CWData = CW_StringSend[UARTBuff_Tail]   '/ Extact data from the string array.
        Inc UARTBuff_Tail
        '/ UARTBuff_Tail = UARTBuff_Tail & (__CW_StringLenght - 1) '/ Circular buffer.
        '/ Same code but more efficient.
        WREG = __CW_StringLenght - 1
        UARTBuff_Tail = UARTBuff_Tail & WREG    '/ Circular buffer.
        If UARTBuff_Tail = UARTBuff_Head Then
            F_UARTBuffFull = 0          '/ No character available in the buffer.
            UARTBuff_Tail = 0
            UARTBuff_Head = 0
        EndIf
        '/----------------------------------------------------------------------
        Low StatusLED
        '/----------------------------------------------------------------------
        'HRSOut Dec CWData, " "  '/ DEBUG the character to the terminal.
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::      
        If F_EnableLoadUrCallSign = 1 Then  '/ Option enabled?
            If F_URCALLSIGN = 0 Then
                If CWData = " " Then
                    Inc CSWordCounter       '/ Counting "Space".
                EndIf
                CW_UrCallSignString[DESpacePointer] = CWData
                Inc DESpacePointer          '/ Update the array pointer.
                If DESpacePointer > __CW_UrCallSignStringLenght - 1 Then
                    DESpacePointer = 0
                    CW_UrCallSignString#0 = 0   '/ Trick to clear a String.
                    CSWordCounter = 0
                EndIf 
                '/------------------------------------------------------------------
                If CSWordCounter = 2 Then   '/ The array must have 2 words only.    
                    CWLoop = Len(CW_UrCallSignString)   '/ Number of characters loaded in string.
                    '/--------------------------------------------------------------
                    '/ For test only. (debug)
'                    HRSOut "[" 
'                    HRSOut CW_UrCallSignString   
'                    HRSOut "] "
                    '/--------------------------------------------------------------
                    If CWLoop > 7 Then          '/ Short Call (4 characters + 1 SP + DE + 1 SP) = 8
                        #ifdef Watchdog_req
                        Clrwdt
                        #endif
                        FSR2 = VarPtr(CW_UrCallSignString)
                        Repeat
                            #ifdef Watchdog_req
                            Clrwdt
                            #endif
                            CWData = INDF2
                            '/--------------------------------------------------
                            If CWData = " " Then            '/ Looking for the next space.
                                POSTINC2 = 0                '/ Final String.
                                '/ Checking the "DE" Word.
                                '/----------------------------------------------
                                If INDF2 = "D" Then         '/ Is "D" written?
                                    POSTINC2 = 0            '/ Clear RAM position, Final String. Next character.
                                    '/------------------------------------------
                                    If INDF2 = "E" Then     '/ Is "E" written?
                                        POSTINC2 = 0        '/ Clear RAM position, Final String. Next character.
                                        '/--------------------------------------
                                        If INDF2 = " " Then     '/ Is a Space written after DE?
                                            F_URCALLSIGN = 1    '/ UrCallSign Valid.
                                        EndIf  
                                        Break                   '/ Exit the Repeat/Until routine.
                                        '/--------------------------------------
                                    Else
                                        Break
                                    EndIf
                                    '/------------------------------------------
                                Else
                                    Break
                                EndIf
                                '/--------------------------------------------------
                            EndIf                
                            '/--------------------------------------------------               
                            WREG = POSTINC2             '/ Increment the String index.
                            Dec CWLoop
                        Until CWLoop = 0
                        If F_URCALLSIGN = 1 Then
                            '/ The UR CAllSin is sent to the terminal to check it.
                            '/ If it is erroneous, it is possible to erase this
                            '/ string by the STOP Button in the PTT OFF time.
                            HRSOut " ["
                            HRSOut CW_UrCallSignString 
                            HRSOut "]"
                        EndIf
                    EndIf
                    If F_URCALLSIGN = 0 Then
                        'Clear CW_UrCallSignString   '/ Clear all characters loaded.
                        CW_UrCallSignString#0 = 0     '/ Clear first characters.
                    EndIf
                    '/ Clear all parameters to begin again.
                    DESpacePointer = 0                       
                    CSWordCounter = 0
                EndIf
            EndIf
        EndIf
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::   
        '/ Check the SPACE character. 
        If CWData = " " Then            '/ Compute a SPACE.
            If F_KYBeaconStart = 0 Then
                DelayMS Msg_WordSpaceTime   '/ This is a Space between characters for 7 dots
                HRSOut " "              '/ Send to the terminal.
            Else                        '/ This character is not sent To the Transmitter.
                F_KYBeaconStart = 0     '/ Stop the Beacon Watchdog
                F_SendNewMessage = 0    '/ Stop to send a message.
            EndIf
            GoTo KeyboardLoop           '/ Continue to next character. 
        EndIf
        '/======================================================================
        '/ Start the DelayPTTON + PTT ON.
        If F_EnablePTT = 1 Then
            If CWPTT = 0 Then
                High CWPTT          '/ Transmitter on, receiver off
                DelayMS TXONDelay   '/ Load & Start the TX delay.
            EndIf
        EndIf
        If F_PTTUartAlreadySet = 0 Then
            F_PTTUartAlreadySet = 1
            HRSOut CR
            HRSFStrg(KYSTRG51,1)   '/ "TRANSMITING..."
        EndIf
        '/======================================================================
        '/ Writing 70 characters per line.
        Inc NbCharsPrinted
        If NbCharsPrinted > 70 Then
            NbCharsPrinted = 0
            HRSOut CR
        EndIf
        '/======================================================================
        '/ Checking string Data for special functions.

        '/ MACROS FOR KEYBOARD ON THE FLY. (Low Case character)
        '/    "a" '/ Send ANT string (Antenna)  
        '/    "b" '/ Send "_QSL_VIA_BURO": Address = KBTXTBB 
        '/    "c" '/ Contest Mode: Toggle F_ShortNumbers flag on the fly for keyboard Mode.
        '/    "d" '/ Send "_DE_EA3AGV": Address = KBTXTEE 
        '/    "f" '/ (Final) Send "_73_73_HPE_CUAGN_SK_EE": Address = KBTXTCC 
        '/    "l" '/ (L) Low Case. Send QTHLOC string (QTH LOCATOR) 
        '/    "m" '/ Send MYCALL string (MYCALLSIGN) (By interrupts)   
        '/    "n" '/ Send MYNAME string (MY NAME)
        '/    "q" '/ Send QTH string (QTH) 
        '/    "r" '/ Send RIG string (RIG) 
        '/    "s" '/ Read the RST values from the Decimal encoders & send To CW Datapin
        '/    "t" '/ Send "_FB_TNX_FER_NICE_QSO": Address = KBTXTAA
        '/    "u" '/ Send URCALL string if it is loaded already. (URCALLSIGN)  (By interrupts) 
        '/    "x" '/ Send the QSO number. (max 9999) (XXX) Macro.
        '/    "y" '/ Increment & send the QSO number. (max 9999) (YXX) Macro. 
        '/======================================================================
KeyboardLoop22:
        Select CWData                  
            Case CR                 '/ CR => Carriage Return from keyboard.                          
                CWDataSend = CR     '/ Exit final transmission.

            Case "a" '/ Send MYANT string (Antenna) 
                KBReadE2P(EEPCW_ANT)    '/ Send Bits.
                NbCharsPrinted = NbCharsPrinted + 14
                GoTo KeyboardLoop       '/ Continue to next character from the keyboard. 

            Case "b" '/ Send "_QSL_VIA_BURO_=": Address = KBTXTBB 
                KYWAddress = VarPtr(KBTXTBB)    '/ Address Text in ROM
                Do
                    #ifdef Watchdog_req
                    Clrwdt
                    #endif
                    CWData = cPtr8(KYWAddress++)
                    If CWData = 0 Then
                        GoTo KeyboardLoop       '/ Continue to next character from the keyboard.                     
                    EndIf
                    HRSOut CWData
                    SendCWBits()
                    DelayMS Msg_LetterSpaceTime
                Loop
                DelayMS Msg_WordSpaceTime
                HRSOut " "
                NbCharsPrinted = NbCharsPrinted + 12

            Case "c" '/ Contest Mode: Toggle F_ShortNumbers flag on the fly for keyboard Mode
                Toggle F_ShortNumbers
                GoSub HRS_SORTNUMBERS_Sub       '/ "SHORT NBS ENABLED/DISABLED"
                NbCharsPrinted = NbCharsPrinted + 17
                GoTo KeyboardLoop               '/ Continue to next character from the keyboard.  
                
            Case "d" '/ Send "_DE_EA3AGV": Address = KBTXTEE
                KYWAddress = VarPtr(KBTXTEE)    '/ Address Text in ROM
                Do
                    #ifdef Watchdog_req
                    Clrwdt
                    #endif
                    CWData = cPtr8(KYWAddress++)
                    If CWData = 0 Then
                        GoTo KeyboardLoop       '/ Continue to next character from the keyboard. 
                    EndIf
                    If CWData = CR Then
                        CWDataSend = CR         '/ Exit final transmission.
                        Break
                    EndIf
                    HRSOut CWData
                    SendCWBits()
                    DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots. 
                Loop
                DelayMS Msg_WordSpaceTime
                HRSOut " "
                NbCharsPrinted = NbCharsPrinted + 11

            Case "f" '/ Send "_73_73_HPE_CUAGN_#": Address = KBTXTCC
                KYWAddress = VarPtr(KBTXTCC)    '/ Address Text in ROM
                Do
                    #ifdef Watchdog_req
                    Clrwdt
                    #endif
                    CWData = cPtr8(KYWAddress++)
                    If CWData = 0 Then
                        GoTo KeyboardLoop       '/ Continue to next character from the keyboard. 
                    EndIf
                    If CWData = CR Then
                        CWDataSend = CR         '/ Exit final transmission.
                        Break
                    EndIf
                    HRSOut CWData
                    SendCWBits()
                    DelayMS Msg_LetterSpaceTime
                Loop
                DelayMS Msg_WordSpaceTime
                HRSOut " "
                NbCharsPrinted = NbCharsPrinted + 21
            
            Case "l" '/ (L) Low Case. Send QTHLOC string (QTH LOCATOR)           
                KBReadE2P(EEPCW_QTHLOC) '/ Send Bits.
                NbCharsPrinted = NbCharsPrinted + 7
                GoTo KeyboardLoop       '/ Continue to next character from the keyboard.            

            Case "n" '/ Send MYNAME string (MY NAME)
                KBReadE2P(EEPCW_NAME)   '/ Send Bits.
                NbCharsPrinted = NbCharsPrinted + 11
                GoTo KeyboardLoop       '/ Continue to next character from the keyboard. 

            Case "p" '/ Send "_PSE_K" string + PTT OFF  
                KYWAddress = VarPtr(KBTXTDD)    '/ Address Text in ROM
                Do
                    #ifdef Watchdog_req
                    Clrwdt
                    #endif
                    CWData = cPtr8(KYWAddress++)
                    If CWData = 0 Then Break
                    HRSOut CWData
                    SendCWBits()
                    DelayMS Msg_LetterSpaceTime
                Loop
                DelayMS Msg_WordSpaceTime
                NbCharsPrinted = NbCharsPrinted + 7
                CWDataSend = CR         '/ Exit final transmission.

            Case "q" '/ Send QTH string (QTH)
                KBReadE2P(EEPCW_QTH)    '/ Send Bits.
                NbCharsPrinted = NbCharsPrinted + 15
                GoTo KeyboardLoop       '/ Continue to next character from the keyboard.             

            Case "r" '/ Send RIG string (RIG)
                KBReadE2P(EEPCW_RIG)    '/ Send Bits.
                NbCharsPrinted = NbCharsPrinted + 17
                GoTo KeyboardLoop       '/ Continue to next character from the keyboard.
                            
            Case "s" '/ Read the RST values from the Decimal encoders & send To CW Datapin
                GoSub KYReadRSTEncoders_Sub         
                CWData = CW_StringTemp#0    '/ Byte MSB
                HRSOut CWData
                SendCWBits()
                DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.                
                
                CWData = CW_StringTemp#1    '/ Byte DSB
                HRSOut CWData
                SendCWBits()
                DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots. 

                CWData = CW_StringTemp#2    '/ Byte LSB              
                HRSOut CWData
                SendCWBits()
                DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots. 

                HRSOut " "                  '/ Send a space.
                DelayMS Msg_WordSpaceTime   '/ This is a Word Space between characters for 7 dots

                If F_ContestMode = 1 Then
                    F_ShortNumbers = 1 
                EndIf
                F_EnableLongDash = 0
                WREG = CW_StringTemp#1
                WriteShortNumbers()
                CWData = WREG
                HRSOut CWData
                SendCWBits()
                DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots. 

                WREG = CW_StringTemp#1
                WriteShortNumbers()
                CWData = WREG
                HRSOut CWData
                SendCWBits()
                DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots. 
                
                WREG = CW_StringTemp#2      '/ Byte LSB 
                WriteShortNumbers()
                CWData = WREG
                HRSOut CWData
                SendCWBits()                ' Used Msg_DotDashSpaceTime
                DelayMS Msg_LetterSpaceTime 
                DelayMS Msg_WordSpaceTrueTime 
                HRSOut " "                  '/ Insert a space.
                
                NbCharsPrinted = NbCharsPrinted + 7
                F_ShortNumbers = 0
                GoTo KeyboardLoop   '/ Continue to next character from the keyboard.

            Case "t" '/ Send " FB TNX FER NICE QSO": Address = KBTXTAA
                KYWAddress = VarPtr(KBTXTAA)    '/ Address Text in ROM
                Do
                    #ifdef Watchdog_req
                    Clrwdt
                    #endif
                    CWData = cPtr8(KYWAddress++)
                    If CWData = 0 Then Break
                    HRSOut CWData
                    SendCWBits()
                    DelayMS Msg_LetterSpaceTime
                Loop
                DelayMS Msg_WordSpaceTime
                NbCharsPrinted = NbCharsPrinted + 18
                GoTo KeyboardLoop               '/ Continue to next character from the keyboard.  

            Case "x" '/ Send the QSO number. (max 9999) (XXX) Macro.
                If F_ContestMode = 1 Then
                    F_ShortNumbers = 1
                    F_EnableLongDash = 1
                Else
                    F_ShortNumbers = 0
                    F_EnableLongDash = 0                
                EndIf
                KBSendBitsQSONb()       '/ Send Bits.
                F_ShortNumbers = 0
                F_EnableLongDash = 0                
                NbCharsPrinted = NbCharsPrinted + 8
                GoTo KeyboardLoop       '/ Continue to next character from the keyboard.            
            
            Case "y" '/ Increment & send the QSO number. (max 9999) (YXX) Macro.           
                F_ShortNumbers = 0
                F_EnableLongDash = 0                
                Inc KYContestNumber
                If KYContestNumber > 9999 Then
                    KYContestNumber = 0
                EndIf                
                KBSendBitsQSONb()   '/ Send Bits.
                NbCharsPrinted = NbCharsPrinted + 8
                GoTo KeyboardLoop   '/ Continue to next character from the keyboard.  
            
            Case "#"
                HRSOut "AR"         '/ PROSIGN [#] End of message.

            Case "%"
                HRSOut "KA"         '/ PROSIGN [%] Beginning of message, Starting Signal.

            Case "&"
                HRSOut "KN"         '/ PROSIGN [&] Go only, invite a specific station To transmit.
                CWDataSend = CR     '/ Exit final transmission.

            Case "*"
                HRSOut "AS"         '/ PROSIGN [*] Stand by.
                CWDataSend = CR     '/ Exit final transmission.

            Case "<"
                HRSOut "BK"         '/ PROSIGN [<] End of transmission. Go only, invite a specific station To transmit.
                CWDataSend = CR     '/ Exit final transmission.

            Case "="
                HRSOut "BT"         '/ PROSIGN [=] Double Dash, Pause Or Break. "official" separator
                CWDataSend = CR     '/ Exit final transmission.                

            Case ">"
                HRSOut "VE"         '/ PROSIGN [>] Understood.
            
            Case "["                 
                HRSOut "?"          '/ There is no morse code for this character.
                GoTo KeyboardLoop   '/ Continue to next character from the keyboard. 

            Case "]"
                HRSOut "AA"         '/ PROSIGN []] New Line.
                'GoTo KeyboardLoop   '/ Continue to next character from the keyboard. 
            
            Case "^"
                HRSOut "SK"         '/ PROSIGN [^] End of contact (sent before Call).
                CWDataSend = CR     '/ Exit final transmission.
                
            Case "|"                '/ PROSIGN ("|") This character is not included in the table of symbols.
                F_SpecialChar = 1
                CWData = CW_EOM
                HRSOut "EOM"        '/ Special character [EOM] [|] used for "partitions" of message.
                
            Case 97 To 122          '/ a to z Low case not avaiable.
                HRSOut "?"          '/ Error Low case.
                GoTo KeyboardLoop   '/ Continue to next character from the keyboard.

            Case > 125              '/ Characters not available.
                GoTo KeyboardLoop   '/ Continue to next character from the keyboard. 

            Case Else
                If CWData > 32 Then
                    HRSOut CWData       '/ Printing other Standard keyboard characters.
                Else
                    GoTo KeyboardLoop   '/ Continue to next character from the keyboard. 
                EndIf
        EndSelect
        '/======================================================================
        SendCWBits()    '/ Transform one ASCII byte to dot/dash bits.
        '/======================================================================
KeyboardLoopExit:
        '/ If a Carriage Return has been sent then STOPS the transmission.
        If CWDataSend = CR Then
            If F_EnablePTT = 1 Then
                '/ Compute for minimum PTT OFF delay.
                SumDELAYS = Msg_WordSpaceTrueTime
                If RXONDelay > SumDELAYS Then   '/ Else => NO extra delay.
                    SumDELAYS = RXONDelay - SumDELAYS
                    DelayMS SumDELAYS
                EndIf
                Low CWPTT               '/ PTT OFF, Listening.
            EndIf
            HRSOut "||",CR
            CSWordCounter = 0           '/ Loading a new UR CALLSIGN at the beginning of keying.
            DESpacePointer = 0                 
            NbCharsPrinted = 0          '/ Characters counter for screen terminal.
            F_PTTUartAlreadySet = 0
            F_ShortNumbers = 0          '/ Disable short numbers option when the PTT is OFF.
            HRSFStrg(KYSTRG22,1)   '/ HRSOut "LISTENING...",CR'/ All characters are sent.
            GoTo KeyboardState      '/ Waiting new characters from the keyboard [Clear ring buffer].
        EndIf
        '/----------------------------------------------------------------------
        '/ Now that all the dots and dahs are sent...
        DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.
    '/;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Else    '/ NO character into the UART buffer.
    '/;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        '/ Option Beacon Watchdog: Counting timeout.
        BeaconTimeOut()
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ The UART Buffer is empty then...
        '/ Send the message that has been set while the keyboard was used. (Or before to use)
        '/ The UARTBuffer is empty then try To check a new message?
        If F_SendNewMessage = 1 Then
            If F_PTTUartAlreadySet = 0 Then
                HRSOut CR
                HRSFStrg(KYSTRG51,1)   '/ "TRANSMITING..."
            EndIf
            CheckingMessage()           '/ To Send the pending message.
            '/ Avoid bounces of the button.
            INTCONBits_INT0IE = 1   '/ Enable the RB0 interrupt.
            '/----------------------------------------------------------------------
            '/ Check if Beacon Mode is running to start a delay beetwen messages.
            StartBeaconDelay()
            '/==================================================================
            GoTo KeyboardLoopExit       '/ Exit memory message & Continue to next character from the keyboard.
        EndIf
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ While the Code is Waiting For something, read the Configuration Button.
        If F_ButtonCFGpressed = 1 Then
            F_ButtonCFGpressed = 0
            '/ Checking if the CFG Button is depressed. (debounce)
            'High StatusLED
            While ButtonFUNCTION = 0
                #ifdef Watchdog_req
                Clrwdt
                #endif            
                DelayMS 10
            Wend  
            DelayMS 250
            'StatusLED = 0
            INTCONBits_INT0IE = 1   '/ Enable the RB0 interrupt.
            GoTo STARTCONFIG        
        EndIf
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ To Clear the PTT with the STOP Button/Beacon start & erase the UrCallSign.
        If F_ButtonSTOPpressed = 1 Then
            F_ButtonSTOPpressed = 0
            '/------------------------------------------------------------------
            F_ClearPTT = 0          '/ Erase the Order to clear the PTT.
            Low CWPTT               '/ Transmitter OFF, receiver ON
            '/------------------------------------------------------------------
            F_KYBeaconStart = 0     '/ Stops the Beacon Watchdog
            F_SendNewMessage = 0    '/ Stops to send a message.
            '/------------------------------------------------------------------
            '/ Erase the URCallSIgn string array and parameters.
            If F_URCALLSIGN = 1 Then
                F_URCALLSIGN = 0
                HRSOut CR
                HRSFStrg(KYSTRG54,1)   '/ "UR CALLSIGN IS ERASED"
                GoSub HRS_URCALLSIGN_Sub
            EndIf
            CSWordCounter = 0
            DESpacePointer = 0    
            CW_UrCallSignString#0 = 0   '/ Trick to clear a String.
            '/------------------------------------------------------------------ 
            '/ Checking if the Button is depressed. (debounce)
            'High StatusLED
            While ButtonFUNCTION = 0
                #ifdef Watchdog_req
                Clrwdt
                #endif            
                DelayMS 10
            Wend  
            Low StatusLED               '/ Clear Status LED.
            '/------------------------------------------------------------------
            INTCONBits_INT0IE = 1   '/ (STOP Button) Enable the RB0 interrupt.
            '/------------------------------------------------------------------
        EndIf
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ Decrement the QSO Contest Counter by Button.
        If F_ButtonQCCpressed = 1 Then
            F_ButtonQCCpressed = 0
            '/ Decrement the QSO counter.
            If KYContestNumber > 0 Then
                Dec KYContestNumber
            EndIf
            HRSFStrg(KYSTRG38,0)   '/ "Decrement QSO Counter: "
            HRSOut  Dec KYContestNumber,CR
            '/ Check if Button Stop is still prtessed.
            While ButtonFUNCTION = 0
                #ifdef Watchdog_req
                Clrwdt
                #endif            
                DelayMS 10
            Wend  
            INTCONBits_INT0IE = 1   '/ Enable the RB0 interrupt.
        EndIf
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ Set TUNE the transmitter with ON/OFF delay.
        If F_ButtonTUNEOOpressed = 1 Then
            F_ButtonTUNEOOpressed = 0
            TUNETX_ONOFF()
        EndIf
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ Set TUNE the transmitter continuously.
        If F_ButtonTUNEpressed = 1 Then
            F_ButtonTUNEpressed = 0
            TUNETX_ON()
        EndIf
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ Running CW TEST. Disable with Paddles.    
        If F_RunCWPractice = 1 Then
            F_RunCWPractice = 0
            RunCWSeed()
            RunCWPractice()
            INTCONBits_INT0IE = 1   '/ Enable the RB0 interrupt.
        EndIf
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ While the code is Waiting for something, read the WPM Value.
        CWConfigWPM()          '/ Read the WPM potentiometer => KCW_WPM. 
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ Exits the KEYBOARD MODE. [Switch MODEs by Function encoder]
        If F_PaddlesMode = 1 Then  '/ Exit the Keyboard Mode ?
            PIE1Bits_RCIE = 0      '/ 0 = Disables the EUSART receive interrupt.
            HRSOut CR
            HRSFStrg(KYSTRG50,1)   '/ "PADDLES MODE"      
            Low CWPTT              '/ In case of....            
            GoTo Prepare_waitStart '/ Goto Paddles Mode.
        EndIf
        '/----------------------------------------------------------------------
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/ Blinking the Status LED when URCALLSIGN is loaded.
        '/ Press the STOP to erase the URCALLSIGN if it is not used.
        If F_URCALLSIGN = 1 Then
            Inc MyDelayWord
            If MyDelayWord = 0 Then
                Toggle StatusLED
            EndIf
        EndIf
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    EndIf    
    '/;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    '/ Waiting the next character in the ring buffer.
Loop
ENDSIZE(KeyboardState_CODE)
'/##############################################################################   
'/==============================================================================
'* Purpose : Configuration of keyer parameters.
'* Input   : keyboard                                      
'* Output  : eeprom
'* Note    : 
'/   
STARTCONFIG:
    #ifdef Watchdog_req
    Clrwdt
    #endif
    INTCONBits_GIE = 0      '/ Disable All interrupts.
    PIE1Bits_RCIE = 0       '/ Disable to receive UART interrupts.
    ANSELHBits_ANS11 = 0
    Input ButtonFUNCTION
    Input IP_DOT            '/ Input for paddle Dot.
    Input IP_DASH           '/ Input for paddle Dash.
    Output CWPTT
    Output CWDataPin
    StatusLED = 1           '/ Start configuration

    HRSOut CR
    ReturnStateVar = 255
    HRSFStrg(KYSTRG01,1)   '/ "CONFIGURATION MODE:"
    WPM_OLD = 0                     '/ Force to update CW speed (WPM).
    CWConfigWPM() 
    
STARTCONFIG2:
    #ifdef Watchdog_req
    Clrwdt
    #endif
    HRSFStrg(KYSTRG24,1)   '/ "CODE ?"    
    ValueInput = HRSIn,{10000,ENDCONFIG}
    HRSOut ValueInput,CR

    Select ValueInput
        '/----------------------------------------------------------------------
        Case "A"    
            '/ Dot/Dash compensation. (0 to 31mS)
            '/ Inter-letter spacing Adjustment [0,5,10,15,20,25,30,35,40,45] % of LTSPACE.
            '/ Wordspace spacing Adjustment    [0,5,10,15,20,25,30,35,40,45] % of WDSPACE.
            HRSFStrg(KYSTRG88,1)           '/ "DOT/DASH COMPENSATION, INTER-LETTER SPACING ADJ, WORD SPACE ADJ" 
            HRSOut "D: "
            HRSFStrg(KYSTRG89,1)           '/ "DOT/DASH COMPENSATION"
            HRSOut "L: "
            HRSFStrg(KYSTRG90,1)           '/ "INTER-LETTER SPACING ADJUSTMENT"            
            HRSOut "W: "
            HRSFStrg(KYSTRG91,1)           '/ "WORD SPACING ADJUSTMENT"   
            ValueInput = HRSIn,{5000,STARTCONFIG2}      '/ ValueInput ascii
            '/ Change Low Case character to High Case.
            If ValueInput > 96 Then
                If ValueInput < 123 Then
                    ValueInput = ValueInput - 32
                EndIf
            EndIf   
            If ValueInput = "D" Then
                '/ Dot/Dash compensation. (31mS max)
                Clear CW_String2Temp            '/ Clear Temporal String.
                FSR1 = VarPtr(CW_String2Temp)   '/ Pointing to the beginning of string.
                HRSFStrg(KYSTRG89,0)            '/ "DOT/DASH COMPENSATION"
                HRSOut " 31mS max",CR
                '/--------------------------------------------------------------
                HRSFStrg(KYSTRG64,1)            '/ "PRESS ENTER TO FINISH"
                HRSFStrg(KYSTRG05,0)            '/ "NEW VALUE? "
                EEDATA = 0
                Repeat
                    ValueInput = HRSIn,{5000,STARTCONFIG2}  '/ Input ascii Unit value from keyboard.
                    If ValueInput = CR Then Break           '/ End entry numbers.
                    If ValueInput < 48 Then    '/ Checking correct ASCII byte.
                        HRSFStrg(KYSTRG83,1)   '/ "ERROR! ENTRY VALUE NO VALID"
                        GoTo STARTCONFIG2)     '/ Try again.
                    EndIf
                    If ValueInput > 57 Then    '/ Checking correct ASCII byte.
                        HRSFStrg(KYSTRG83,1)   '/ "ERROR! ENTRY VALUE NO VALID"
                        GoTo STARTCONFIG2)     '/ Try again.
                    EndIf            
                    POSTINC1 = ValueInput      '/ Save value.
                    HRSOut ValueInput
                    Inc EEDATA
                Until EEDATA = 2               '/ 2 DIGITS MAX.
                HRSOut CR
                '/--------------------------------------------------------------
                CWResultByte = Val(CW_String2Temp,Dec)
                CWResultByte = CWResultByte & 31    '/ Limit max 31mS.
                EWrite EEPCW_DOTDASH_ADJUSTMENT,[CWResultByte]
                HRSFStrg(KYSTRG89,0)                '/ "DOT/DASH COMPENSATION"
                HRSOut " +",Dec CWResultByte," mS",CR

            ElseIf ValueInput = "L" Then
                '/ Inter-letter spacing Adjustment [0,5,10,15,20,25,30,35,40,45] % of LTSPACE.
                HRSFStrg(KYSTRG90,1)           '/ "INTER-LETTER SPACING ADJUSTMENT"   
                HRSFStrg(KYSTRG05,0)           '/ "NEW VALUE? "
                ValueInput = HRSIn,{5000,STARTCONFIG2}
                CWResultByte = LetterSpaceAdjTable(ValueInput)
                EWrite EEPCW_LTSPACE_ADJUSTMENT,[CWResultByte]
                HRSOut Dec CWResultByte
                HRSFStrg(KYSTRG92,1)            '/ "% of LTSPACE"

            ElseIf ValueInput = "W" Then
                '/ Wordspace spacing Adjustment [0,5,10,15,20,25,30,35,40,45] % of WDSPACE.
                HRSFStrg(KYSTRG91,1)           '/ "WORD SPACING ADJUSTMENT"   
                HRSFStrg(KYSTRG05,0)           '/ "NEW VALUE? "
                ValueInput = HRSIn,{5000,STARTCONFIG2}
                CWResultByte = WordSpaceAdjTable(ValueInput)
                EWrite EEPCW_WDSPACE_ADJUSTMENT,[CWResultByte]
                HRSOut Dec CWResultByte
                HRSFStrg(KYSTRG93,1)           '/ "% of WDSPACE"

            Else
                HRSFStrg(KYSTRG83,1)   '/ "ERROR! ENTRY VALUE NO VALID"
                GoTo STARTCONFIG2)     '/ Try again.
            EndIf
            KYCW_Timings()  '/ Calculate new timing. 
        '/----------------------------------------------------------------------
        Case "B"    '/ Toggle Beacon On/off
            Toggle F_EnableBeacon                   '/ Enabled/Disabled the Beacon config On/OFF.           
            EWrite EEPCW_CONFIG,[CWCONFIGFlags]     '/ Write all configs again. 
            GoSub HRS_BEACON_Sub
        '/----------------------------------------------------------------------
        Case "C" '/ Enable/Disable to Load the correspondent's UrCallSign.
            Toggle F_EnableLoadUrCallSign
            GoSub HRS_URCALLSIGN_Sub                '/ Print the new value.
            EWrite EEPCW_CONFIG,[CWCONFIGFlags]     '/ Write all configs again.
        '/----------------------------------------------------------------------
        Case "D"    '/ Select 3:1 Or 4:1 Dash/Dot ratio
            Toggle F_DashDotRatio                   '/ Enabled/Disabled the Dash/Dot Ratio config On/OFF.           
            EWrite EEPCW_CONFIG,[CWCONFIGFlags]     '/ Write all configs again. 
            GoSub HRS_DDRATIO_Sub
            KYCW_Timings()                          '/ Calculate new CW timing.   
        '/----------------------------------------------------------------------
        Case "E"    '/"EXIT" Exits from "Command"-mode and returns to normal keyer operation.
            ReturnState(ST_ENDCONFIG)               '/GoTo EndConfig
        '/----------------------------------------------------------------------
        Case "F" '/  Enable/Disable Farnsworth Spacing Option (Toggle ON/OFF)      
            Toggle F_FarnsworthSpacing              '/ Enabled/Disabled the Farnsworth Spacing ON/OFF.           
            EWrite EEPCW_CONFIG,[CWCONFIGFlags]     '/ Write all configs again. 
            GoSub HRS_FARNSWORTH_Sub                '/ Print the new value.
            KYCW_Timings()                          '/ Calculate new CW timing.
        '/----------------------------------------------------------------------
        Case "G" '/ Load Farnsworth Spacing value [95,90,85,80,75,70,65,60,55,50] % of WPM] (-5% WPM step)
            HRSFStrg(KYSTRG101,1)      '/ "LOAD FARNSWORTH SPACING VALUE"
            HRSFStrg(KYSTRG05,1)       '/ "NEW VALUE?"
            ValueInput = HRSIn,{5000,STARTCONFIG2}  '/ ValueInput = 0 TO 9
            CWResultByte = FarnsworthSpacingTable(ValueInput)
            EWrite EEPCW_FARNSWORTHSP,[CWResultByte] '/ Save the new value to the eeprom.
            HRSFStrg(KYSTRG34,0)       '/ "FARNSWORTH SPACE"
            HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
            HRSOut Dec CWResultByte
            HRSFStrg(KYSTRG94,1)       '/ "% of WPM"
            KYCW_Timings()             '/ Calculate new CW timing.
        '/----------------------------------------------------------------------
'        Case "H" '/ Not used.       

        '/----------------------------------------------------------------------
        Case "I" '/ Enable/Disable Ultimatic /Iambic B / Iambic A options.
            HRSFStrg(KYSTRG66,1)           '/ "KEYER MODE?"
            HRSFStrg(KYSTRG67,1)           '/ "ULIMATIC MODE: U"           
            HRSFStrg(KYSTRG69,1)           '/ "IAMBIC B MODE: B"
            HRSFStrg(KYSTRG68,1)           '/ "IAMBIC A MODE: A" 
            HRSFStrg(KYSTRG32,1)           '/ "CHOOSE OPTION? "
            F_KeyerMemoryError = 0
            ValueInput = HRSIn,{5000,STARTCONFIG2}  '/ Input ascii value from keyboard.
            '/ Change Low Case character to High Case.
            If ValueInput > 96 Then
                If ValueInput < 123 Then
                    ValueInput = ValueInput - 32
                EndIf
            EndIf   
            If ValueInput = "U" Then        '/ Input "U" ULTIMATIC
                F_UltimaticMode = 1
                F_IambicMode = 0
            ElseIf ValueInput = "B" Then    '/ Input "B" IAMBIC B        
                F_UltimaticMode = 0
                F_IambicMode = 1
            ElseIf ValueInput = "A" Then    '/ Input "A" IAMBIC A         
                F_UltimaticMode = 0
                F_IambicMode = 0                
            Else                            '/ Else NO change. 
                HRSFStrg(KYSTRG83,1)        '/ "ERROR! ENTRY VALUE NO VALID"
                F_KeyerMemoryError = 1
            EndIf
            If F_KeyerMemoryError = 0 Then
                EWrite EEPCW_CONFIG,[CWCONFIGFlags] '/ Write the new option.
            EndIf
            F_KeyerMemoryError = 0
            GoSub HRS_KEYERMODE_Sub
        '/----------------------------------------------------------------------            
        Case "J" '/ Enable/Disable Word Spacing. (Toggle On/OFF)
            '/ If Word Spacing is disabled then the F_EnableLoadUrCallSign is disabled too.
            Toggle F_WordSpacing
            GoSub HRS_WORDSPACING_Sub               '/ Print the new value.  
            EWrite EEPCW_CONFIG,[CWCONFIGFlags]     '/ Write all configs again.
        '/----------------------------------------------------------------------
        Case "K" '/ Enable/Disable Contest Mode. (Toggle On/OFF)
            Toggle F_ContestMode
            EWrite EEPCW_CONFIG,[CWCONFIGFlags]     '/ Write all configs again.
            GoSub HRS_CONSTESTMODE_Sub              '/ Print the new mode.  
        '/----------------------------------------------------------------------
        Case "L" '/ Load Beacon Delay value [3,5,7,9,11,13,15,17,19,21] X seconds
            HRSFStrg(KYSTRG95,0)       '/ "BEACON DELAY"
            HRSFStrg(KYSTRG20,1)       '/ " ADJUSTMENT "
            HRSFStrg(KYSTRG05,1)       '/ "NEW VALUE?"
            ValueInput = HRSIn,{5000,STARTCONFIG2}  '/ ValueInput = 0 TO 9
            BeaconDelay = BeaconDelayAdjTable(ValueInput)
            EWrite EEPCW_BEACONDELAY_ADJUSTMENT,[BeaconDelay] '/ Save the new value to the eeprom.
            HRSFStrg(KYSTRG95,0)       '/ "BEACON DELAY"
            HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
            HRSOut Dec BeaconDelay," Seconds",CR
        '/----------------------------------------------------------------------
        Case "M" '/ Enable/Disable MUTE (CW Data & PTT disabled) Tone Enable.
            HRSFStrg(KYSTRG102,1)      '/ "MUTE OPTION"
            '/ Save the options status
            F_EnablePTTCopy = F_EnablePTT
            F_EnableToneCopy = F_EnableTone
            Toggle F_EnableMUTE        '/ Enabled/Disabled the MUTE option.           
            If F_EnableMUTE = 1 Then
                F_EnablePTT = 0
                F_EnableTone = 1
            Else
                '/ Restore options.
                F_EnablePTT = F_EnablePTTCopy
                F_EnableTone = F_EnableToneCopy
            EndIf
            EWrite EEPCW_CONFIG,[CWCONFIGFlags]     '/ Write all configs again. 
            GoSub HRS_MUTE_Sub                      '/ Print the new value.
            GoSub HRS_PTT_Sub                       '/ See others options.
            GoSub HRS_TONE_Sub
        '/----------------------------------------------------------------------
        Case "N" '/ Read all messages written in eeprom/ROM & print to the termimal.
            HRSFStrg(KYSTRG85,1)   '/ "READ ALL EEPROM MSG: E"
            HRSFStrg(KYSTRG86,1)   '/ "READ ALL ROM MSG: R"           
            HRSFStrg(KYSTRG32,1)   '/ "CHOOSE OPTION? "
            ValueInput = HRSIn,{5000,STARTCONFIG2}  '/ Input ascii value from keyboard.
            '/ Change Low Case character to High Case.
            If ValueInput > 96 Then
                If ValueInput < 123 Then
                    ValueInput = ValueInput - 32
                EndIf
            EndIf               
            If ValueInput = "E" Then
                GoSub PrintEEPMessages_Sub  '/ Print all messages in EEPROM.
            ElseIf ValueInput = "R" Then
                GoSub PrintROMMessages_Sub
            Else
                HRSFStrg(KYSTRG83,1)        '/ "ERROR! ENTRY VALUE NO VALID"
            EndIf
        '/----------------------------------------------------------------------
        Case "O" '/ Load standard messages (Copy ROM Block to EEP Block).
            HRSFStrg(KYSTRG100,1)           '/ "COPY ROM BLOCK TO EEPROM BLOCK"
            '/ Entry number of ROM Block.
            Clear CW_String2Temp            '/ Clear Temporal String.
            FSR1 = VarPtr(CW_String2Temp)   '/ Pointing to the beginning of string.
            HRSFStrg(KYSTRG56,0)            '/ "INPUT FROM ROM MESSAGES BLOCK: "
            EEDATA = 0
            Repeat
                ValueInput = HRSIn,{5000,STARTCONFIG2}  '/ Input ascii Unit value from keyboard.
                If ValueInput = CR Then Break           '/ End entry numbers.
                If ValueInput < 48 Then    '/ Checking correct ASCII byte.
                    HRSFStrg(KYSTRG83,1)   '/ "ERROR! ENTRY VALUE NO VALID"
                    GoTo STARTCONFIG2)     '/ Try again.
                EndIf
                If ValueInput > 57 Then    '/ Checking correct ASCII byte.
                    HRSFStrg(KYSTRG83,1)   '/ "ERROR! ENTRY VALUE NO VALID"
                    GoTo STARTCONFIG2)     '/ Try again.
                EndIf            
                POSTINC1 = ValueInput      '/ Save value & increment FSR1.
                HRSOut ValueInput
                Inc EEDATA
            Until EEDATA = 2               '/ 2 DIGITS MAX.
            HRSOut CR
            CWResultByte = Val(CW_String2Temp,Dec)

            '/ Entry number of EEPROM Block.
            HRSFStrg(KYSTRG57,0)                    '/ "OUTPUT TO EEPROM MESSAGES BLOCK: "
            ValueInput = HRSIn,{5000,STARTCONFIG2}  '/ Input ascii value from keyboard.
            ValueInput = CheckNumber(ValueInput)    '/ Checking correct ASCII byte.
            If ValueInput = 255 Then
                HRSFStrg(KYSTRG83,1)        '/ "ERROR! ENTRY VALUE NO VALID"
                GoTo STARTCONFIG2)          '/ Try again.
            EndIf
            HRSOut Dec ValueInput,CR            
            HRSFStrg(KYSTRG58,0)            '/ "COPY ROM BLOCK NB: "
            HRSOut Dec CWResultByte
            HRSFStrg(KYSTRG59,0)            '/ " TO EEP BLOCK NB: "
            HRSOut Dec ValueInput,CR
            LoadROMBLOCKStoE2P(CWResultByte,ValueInput) '/ Copy BlockX ROM to block eeprom
            If F_KeyerMemoryError = 1 Then
                F_KeyerMemoryError = 0
                HRSFStrg(KYSTRG83,1)        '/ "ERROR! ENTRY VALUE NO VALID"
                GoTo STARTCONFIG2)          '/ Try again.
            EndIf
            GoSub PrintEEPMessages_Sub      '/ Print all messages in EEPROM.
            ReturnState(ST_ENDCONFIG)       '/ Exit config.
        '/----------------------------------------------------------------------
        Case "P" '/ Read & print all timings parameters.
            HRSFStrg(KYSTRG84,1)       '/ "READ CW TIMINGS"
            GoSub HRS_TONE_Sub
            GoSub HRS_BEACON_Sub
            GoSub HRS_DDRATIO_Sub    
            GoSub HRS_MUTE_Sub
            GoSub HRS_FARNSWORTH_Sub
            GoSub HRS_KEYERMODE_Sub
            GoSub HRS_URCALLSIGN_Sub
            WPM_OLD = 0     '/ Force to update CW speed (WPM).
            CWConfigWPM()   '/ Read CW Speed potenciometer. Calculate CW timings.

            '/ Read Dot/Dash Compensation value. (0 To 31mS)
            HRSFStrg(KYSTRG89,0)       '/ "DOT/DASH COMPENSATION"
            ValueInput = ERead EEPCW_DOTDASH_ADJUSTMENT
            HRSOut " +", Dec ValueInput," mS",CR

            '/ Read Letter Space Adjustment value.
            ValueInput = ERead EEPCW_LTSPACE_ADJUSTMENT '/ [0,5,10,15,20,25,30,35,40,45] % of LTSPACE.
            HRSFStrg(KYSTRG31,0)       '/ "LETTER"
            HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
            HRSOut Dec ValueInput
            HRSFStrg(KYSTRG92,1)       '/ "% of LTSPACE"
            
            '/ Read WordSpace Adjustment value.
            ValueInput = ERead EEPCW_WDSPACE_ADJUSTMENT '/ [0,5,10,15,20,25,30,35,40,45] % of WDSPACE.
            HRSFStrg(KYSTRG30,0)       '/ "WORD SPACE"
            HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
            HRSOut Dec ValueInput
            HRSFStrg(KYSTRG93,1)       '/ "% of WDSPACE"
            
            '/ Read Farnsworth spacing Adjustment value. (-5% step)
            ValueInput = ERead EEPCW_FARNSWORTHSP '/ [95,90,85,80,75,70,65,60,55,50] % of WPM
            HRSFStrg(KYSTRG34,0)       '/ "FARNSWORTH SPACE"
            HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
            HRSOut Dec ValueInput
            HRSFStrg(KYSTRG94,1)       '/ "% of WPM"

            '/ Read Beacon TimeOut Adjustment value. 
            BeaconDelay = ERead EEPCW_BEACONDELAY_ADJUSTMENT   '/ [3,5,7,9,11,13,15,17,19,21] X seconds
            HRSFStrg(KYSTRG95,0)       '/ "BEACON TIMEOUT"
            HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
            HRSOut Dec BeaconDelay," Seconds",CR

            '/ TUNE transmitter time out.
            TuneONTimeMax = ERead EEPCW_TUNETIMEOUT_ADJUSTMENT  
            HRSFStrg(KYSTRG105,0)       '/ "TUNE TIME MAX"
            HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
            HRSOut Dec TuneONTimeMax," Seconds",CR

            '/ TONE Frequency.
            ValueInput = ERead EEPCW_TONEFREQUENCY_INDEX  
            KYTMR0LValue = KYToneFreqTable(ValueInput)
            KYLoadToneFreq(KYTMR0LValue)
            HRSFStrg(KYSTRG106,0)            '/ "TONE FREQUENCY"
            Save_FSR0 = KYReadToneFreqTable()
            HRSOut " ",Dec Save_FSR0," Hz",CR

            '/ Read the DOT & DASH time.
            HRSFStrg(KYSTRG09,0)       '/ "DOT TIME: "
            HRSOut Dec PTDotTime," mS",CR
            HRSFStrg(KYSTRG10,0)       '/ "DASH TIME: "
            HRSOut Dec PTDashTime," mS",CR

            '/ Read the LetterSpace time.
            HRSFStrg(KYSTRG77,0)       '/ "LetterSpace Delay: "
            HRSOut Dec PTLetterSpaceTime," mS",CR

            '/ Read the WordSpace time.
            HRSFStrg(KYSTRG78,0)       '/ "WordSpace Delay: "
            HRSOut Dec PTWordSpaceTime," mS",CR
            GoSub HRS_WORDSPACING_Sub

            '/ Read & load TX ON & RX ON DELAY value
            If F_EnablePTT = 1 Then
                ValueInput = ERead EEPCW_TXONDELAY  '/ TXONDelay = [25,50,75,100,125,150,175,200,225,250] X 1mS 
                CalcKYTXOnDelay(ValueInput)
                HRSFStrg(KYSTRG08,0)       '/ "TXON DELAY: "
                HRSOut Dec TXONDelay, " mS",CR

                ValueInput = ERead EEPCW_RXONDELAY  '/ RXONDelay [25,50,75,100,125,150,175,200,225,250] X 4mS
                CalcKYRXOnDelay(ValueInput)
                HRSFStrg(KYSTRG07,0)       '/ "RXON DELAY: "
                HRSOut Dec RXONDelay, " mS",CR
            Else
                CalcKYTXOnDelay(1)
                HRSFStrg(KYSTRG08,0)       '/ "TXON DELAY: "
                HRSFStrg(KYSTRG40,1)       '/ " DISABLED"

                CalcKYRXOnDelay(1)
                HRSFStrg(KYSTRG07,0)       '/ "RXON DELAY: "
                HRSFStrg(KYSTRG40,1)       '/ " DISABLED"
            EndIf
            ReturnState(ST_ENDCONFIG)
        '/----------------------------------------------------------------------
        Case "Q" '/ Read/Write/Erase a QSO Number.
            HRSFStrg(KYSTRG99,1)           '/ "READ/WRITE/ERASE THE QSO COUNTER" 
            HRSFStrg(KYSTRG62,0)           '/ "R :READ "           
            HRSFStrg(KYSTRG53,1)           '/ "QSO COUNTER: " 
            HRSFStrg(KYSTRG61,0)           '/ "W :WRITE ",0
            HRSFStrg(KYSTRG53,1)           '/ "QSO COUNTER: "
            HRSFStrg(KYSTRG63,0)           '/ "E :ERASE "           
            HRSFStrg(KYSTRG53,1)           '/ "QSO COUNTER: "               
            HRSFStrg(KYSTRG32,1)           '/ "CHOOSE OPTION? "
            ValueInput = HRSIn,{5000,STARTCONFIG2}  '/ Input ascii value from keyboard.
            '/ Change Low Case character to High Case.
            If ValueInput > 96 Then
                If ValueInput < 123 Then
                    ValueInput = ValueInput - 32
                EndIf
            EndIf   
            If ValueInput = "R" Then            '/ Input "R"
                HRSFStrg(KYSTRG62,0)            '/ "R :READ " 
                HRSFStrg(KYSTRG53,0)            '/ "CONTEST COUNTER: "
                HRSOut Dec KYContestNumber,CR

            ElseIf ValueInput = "W" Then        '/ Input "W"
                HRSFStrg(KYSTRG64,1)            '/ "PRESS ENTER TO FINISH"
                HRSFStrg(KYSTRG61,0)            '/ "W :WRITE "
                HRSFStrg(KYSTRG53,1)            '/ "QSO COUNTER: "                
                HRSFStrg(KYSTRG05,0)            '/ "NEW VALUE?"
                Clear CW_String2Temp            '/ Erase the string first.
                CWLoop = 0
                FSR1 = VarPtr(CW_String2Temp)
                Repeat
                    ValueInput = HRSIn,{5000,STARTCONFIG2}  '/ Input ascii value from keyboard.
                    If ValueInput = CR Then Break           '/ Carriage Return to finish the entry.
                    '/ Checking correct ASCII byte.
                    If ValueInput < 48 Then 
                        If ValueInput > 57 Then 
                            HRSFStrg(KYSTRG83,1)    '/ "ERROR! ENTRY VALUE NO VALID"
                            GoTo STARTCONFIG2)      '/ Try again.
                        EndIf
                    EndIf      
                    POSTINC1 = ValueInput           '/ Save value.
                    Inc CWLoop
                Until CWLoop > 3                            '/ 4 DIGITS max.
                KYContestNumber = Val(CW_String2Temp,Dec)   '/ Transform the string to a number.
                HRSOut Dec KYContestNumber,CR               '/ Print the new value.            

            ElseIf ValueInput = "E" Then
                KYContestNumber = 0
                HRSFStrg(KYSTRG63,1)     '/ "E :ERASE "           
                HRSFStrg(KYSTRG53,0)     '/ "QSO COUNTER: " 
                HRSFStrg(KYSTRG52,1)     '/ " CLEARED",0

            Else
                '/ If error then read the counter.
                HRSFStrg(KYSTRG83,1)     '/ "ERROR! ENTRY VALUE NO VALID"
                HRSFStrg(KYSTRG53,0)     '/ "CONTEST COUNTER: "
                HRSOut Dec KYContestNumber,CR            
            EndIf
        '/----------------------------------------------------------------------
        Case "R"    '/ Adjust TUNE ON/TUNE OFF Delay. 
            '/ TUNE ON:  [5,10,15,20,25,30,35,40,45,50] X 100mS
            '/ TUNE OFF: [5,10,15,20,25,30,35,40,45,50] X 100mS
            HRSFStrg(KYSTRG98,1)                        '/ "ADJUST TUNE ON/OFF DELAY"
            HRSFStrg(KYSTRG05,1)                        '/ "NEW VALUE?"
            ValueInput = HRSIn,{5000,STARTCONFIG2}      '/ ValueInput = 0 TO 9
            CWResultByte = TuneONOFFDelayTable(ValueInput)
            EWrite EEPCW_TUNEONOFFDELAY,[CWResultByte]
            CalcTuneONDelay(CWResultByte)               '/ Result in mS 
            HRSFStrg(KYSTRG96,0)                        '/ "TuneON Delay: "
            HRSOut Dec TuneONDelay,CR
            CalcTuneOFFDelay(CWResultByte)              '/ Result in mS 
            HRSFStrg(KYSTRG97,0)                        '/ "TuneOFF Delay: "
            HRSOut Dec TuneOFFDelay,CR
       '/----------------------------------------------------------------------
        Case "S"    '/ Toggle SideTone On/off
            Toggle F_EnableTone                     '/ Enabled/Disabled  the Side-Tone config On/OFF.           
            EWrite EEPCW_CONFIG,[CWCONFIGFlags]     '/ Write all configs again. 
            GoSub HRS_TONE_Sub                      '/ Print the new value.
        '/----------------------------------------------------------------------
        Case "T"    '/ Transmit PTT(On/off)
            Toggle F_EnablePTT                      '/ Enabled/Disabled the PTT On/OFF.           
            EWrite EEPCW_CONFIG,[CWCONFIGFlags]     '/ Write all configs again. 
            GoSub HRS_PTT_Sub                       '/ Print the new value.
            '/------------------------------------------------------------------
            '/ Read & load TX ON DELAY & RX ON DELAY valueS
            If F_EnablePTT = 1 Then
                ValueInput = ERead EEPCW_TXONDELAY  '/ TXONDelay = [25,50,75,100,125,150,175,200,225,250] X 1mS 
                CalcKYTXOnDelay(ValueInput)
                HRSFStrg(KYSTRG08,0)       '/ "TXON DELAY: "
                HRSOut Dec TXONDelay, " mS",CR
                '/--------------------------------------------------------------
                ValueInput = ERead EEPCW_RXONDELAY  '/ RXONDelay [25,50,75,100,125,150,175,200,225,250] X 4mS
                CalcKYRXOnDelay(ValueInput)
                HRSFStrg(KYSTRG07,0)       '/ "RXON DELAY: "
                HRSOut Dec RXONDelay, " mS",CR
            Else
                CalcKYTXOnDelay(1)
                HRSFStrg(KYSTRG08,0)       '/ "TXON DELAY: "
                HRSFStrg(KYSTRG40,1)       '/ " DISABLED"
                '/--------------------------------------------------------------
                CalcKYRXOnDelay(1)
                HRSFStrg(KYSTRG07,0)       '/ "RXON DELAY: "
                HRSFStrg(KYSTRG40,1)       '/ " DISABLED"
            EndIf
        '/----------------------------------------------------------------------
        Case "U"    '/Set TX-Delay. [25,50,75,100,125,150,175,200,225,250] X 1 mS.         
            HRSFStrg(KYSTRG05,1)            '/ "NEW VALUE?"
            ValueInput = HRSIn,{5000,STARTCONFIG2}
            CWResultByte = KYTXOnDelayTable(ValueInput)
            EWrite EEPCW_TXONDELAY,[CWResultByte]  
            CalcKYTXOnDelay(CWResultByte)
            HRSFStrg(KYSTRG08,0)            '/ "TXON DELAY: "
            HRSOut Dec TXONDelay," mS",CR
            GoSub HRS_PTT_Sub            
            If F_EnablePTT = 0 Then
                CalcKYTXOnDelay(1)
            EndIf
        '/----------------------------------------------------------------------
        Case "V"    '/Set RX-Delay. [25,50,75,100,125,150,175,200,225,250] X 4 mS. 
            HRSFStrg(KYSTRG05,1)            '/ "NEW VALUE?" 
            ValueInput = HRSIn,{5000,STARTCONFIG2}
            CWResultByte = KYRXOnDelayTable(ValueInput)           
            EWrite EEPCW_RXONDELAY,[CWResultByte]  
            CalcKYRXOnDelay(CWResultByte)
            HRSFStrg(KYSTRG07,0)            '/ "RXON DELAY: "
            HRSOut Dec RXONDelay," mS",CR
            GoSub HRS_PTT_Sub
            If F_EnablePTT = 0 Then
                CalcKYRXOnDelay(1)
            EndIf
        '/----------------------------------------------------------------------
        Case "W"    '/  Load my CallSign  
            '/ EXIT the routine writing a space after enter the ASCII values.
            '/ TimeOut 5 seconds (EACH CHARACTER) for security.
            HRSFStrg(KYSTRG05,1)       '/ "NEW VALUE?"
            LoadTXT_E2P(EEPCW_MYCALL,__CW_MyCAllStringLenght)
            If F_KeyerMemoryError = 1 Then
                F_KeyerMemoryError = 0
                HRSOut CR
                HRSFStrg(KYSTRG83,1)    '/ "ERROR! ENTRY VALUE NO VALID"
                GoTo STARTCONFIG2)      '/ Try again.
            EndIf
            ReadStrg_E2P(EEPCW_MYCALL)
        '/----------------------------------------------------------------------
        Case "X" '/ Load TUNE Time Out value (010 to 127 seconds max)
            HRSFStrg(KYSTRG105,0)      '/ "TUNE TIME MAX"
            HRSFStrg(KYSTRG20,1)       '/ " ADJUSTMENT "
            HRSFStrg(KYSTRG05,0)       '/ "NEW VALUE?"
            '/ Entry value of TimeOut.
            Clear CW_String2Temp       '/ Clear Temporal String.
            FSR1 = VarPtr(CW_String2Temp)    '/ Pointing to the beginning of string.
            '/------------------------------------------------------------------
            EEDATA = 0
            Repeat
                ValueInput = HRSIn,{5000,STARTCONFIG2}  '/ Input ascii Unit value from keyboard.
                If ValueInput = CR Then Break           '/ End entry numbers.
                If ValueInput < 48 Then    '/ Checking correct ASCII byte.
                    HRSFStrg(KYSTRG83,1)   '/ "ERROR! ENTRY VALUE NO VALID"
                    GoTo STARTCONFIG2)     '/ Try again.
                EndIf
                If ValueInput > 57 Then    '/ Checking correct ASCII byte.
                    HRSFStrg(KYSTRG83,1)   '/ "ERROR! ENTRY VALUE NO VALID"
                    GoTo STARTCONFIG2)     '/ Try again.
                EndIf            
                POSTINC1 = ValueInput      '/ Save value & increment FSR1.
                HRSOut ValueInput
                Inc EEDATA
            Until EEDATA = 3               '/ 3 DIGITS MAX.
            HRSOut CR
            TuneONTimeMax = Val(CW_String2Temp,Dec)
            TuneONTimeMax = TuneONTimeMax & CstTuneONTimeMax
            If TuneONTimeMax < 10 Then
                TuneONTimeMax = 10
            EndIf
            HRSFStrg(KYSTRG105,0)           '/ "TUNE TIME MAX"
            HRSOut " ",Dec TuneONTimeMax," Seconds",CR
            EWrite EEPCW_TUNETIMEOUT_ADJUSTMENT,[TuneONTimeMax]            
        '/----------------------------------------------------------------------
        Case "Y"    '/ Tone Frequency Index (input 0 to 9) 
            '/   0   1   2   3   4   5   6   7    8    9
            '/ [400,450,500,550,600,650,700,800,1000,1250] 
            '/ 
            '$if _xtal = 16
            ''/ Calculate: (16Mhz/4) / (1250 * 2) = 1600 / Prescaler(32) = 50 => 256 - 50 = 206
            'PRODH = LookUp MacroTemp,[100,117,131,143,152,160,167,178,194,206] 
            '$endif
            '$if _xtal = 64
            ''/ Calculate: (64Mhz/4) / (1250 * 2) = 6400 / Prescaler(128) = 50 => 256 - 50 = 206
            'PRODH = LookUp MacroTemp,[100,117,131,143,152,160,167,178,194,206] 
            '$endif
            HRSFStrg(KYSTRG106,0)      '/ "TONE FREQUENCY"
            HRSFStrg(KYSTRG20,0)       '/ " ADJUSTMENT "
            HRSFStrg(KYSTRG05,1)       '/ "NEW VALUE?" 
            ValueInput = HRSIn,{5000,STARTCONFIG2}
            If ValueInput < 48 Then    '/ Checking correct ASCII byte.
                HRSFStrg(KYSTRG83,1)   '/ "ERROR! ENTRY VALUE NO VALID"
                GoTo STARTCONFIG2)     '/ Try again.
            EndIf
            If ValueInput > 57 Then    '/ Checking correct ASCII byte.
                HRSFStrg(KYSTRG83,1)   '/ "ERROR! ENTRY VALUE NO VALID"
                GoTo STARTCONFIG2)     '/ Try again.
            EndIf
            ValueInput = ValueInput - 48        '/ Convert ASCII to numbers.        
            EWrite EEPCW_TONEFREQUENCY_INDEX,[ValueInput]    '/ Save the new index in eeprom.
            KYTMR0LValue = KYToneFreqTable(ValueInput)
            KYLoadToneFreq(KYTMR0LValue)        '/ Load the Timer0.
            Save_FSR0 = KYReadToneFreqTable()   '/ Read the frequency to control.
            HRSFStrg(KYSTRG106,0)               '/ "TONE FREQUENCY"
            HRSOut ": ",Dec Save_FSR0," Hz",CR  '/ Print the frequency value.
        '/----------------------------------------------------------------------
        Case "Z"    '/ Reset parameters to default settings
            HRSFStrg(KYSTRG33,1)            '/ "RESET DEFAULT PARAMETERS"
            EWrite EEPCW_INIT,[$FF]         '/ Reset parameters        
            ReturnState(ST_START_KEYER2)    '/ Make a false reset
        '/----------------------------------------------------------------------
        '/ Recording messages:  Point the encoder to the number To write.
        Case "0"    '/ LOAD a message: (0 To 15)  
            HRSFStrg(KYSTRG26,1)   '/ "ENTRY A NEW MESSAGE"
            HRSFStrg(KYSTRG80,1)   '/ "SET NUMBER OF MESSAGE WITH HEX ENCODER",0
            HRSFStrg(KYSTRG81,1)   '/ "NUMBER ENCODER READY: Y OR N",0
            ValueInput = HRSIn,{5000,STARTCONFIG2}
            '/ Change Low Case character to High Case.
            If ValueInput > 96 Then
                If ValueInput < 123 Then
                    ValueInput = ValueInput - 32
                EndIf
            EndIf   
            $ifdef _English_
            If ValueInput <> "Y" Then           '/ "Y Or N"
                GoTo STARTCONFIG2)              '/ Try again.
            EndIf            
            $endif
            $ifdef _Spanish_
            If ValueInput <> "S" Then           '/ "S O N"
                GoTo STARTCONFIG2)              '/ Try again.
            EndIf            
            $endif            
            $ifdef _French_
            If ValueInput <> "O" Then           '/ "O Ou N"
                GoTo STARTCONFIG2)              '/ Try again.
            EndIf            
            $endif
            '/ Set the Encoder Address: [0]
            Low SWEncoderAddPin0
            Low SWEncoderAddPin1        
            Low SWEncoderAddPin2 
            DelayUS 10                      '/ Delay to stabilizise the outputs of decoder.
            '/ HEX encoder: Valor 0 => %00001111 (all switches open)
            $ifdef _Proteus
            WREG = ~PORTA                   '/ Read HEX encoder, inverse because the connection.     
            $else
                $ifdef _EncoderCtsOpen
                WREG = ~PORTA               '/ Read HEX encoder with contacts Open, inverse because the connection.  
                $else
                WREG = PORTA                '/ Read DEC encoder with contacts closed.
                $endif
            $endif    
            WREG = WREG >> 2    
            NBMessageToSend = WREG & 15         '/ New number of message to send.
            HRSFStrg(KYSTRG74,0)                '/ "WRITING MESSAGE NB: ",0
            HRSOut Dec NBMessageToSend,CR       '/ Print number of message to write.
            TableResult = TableE2PAddress(NBMessageToSend)  '/ Looking for the EEP address. 
            CWData = TableE2PMsgLength(NBMessageToSend)     '/ Looking for the EEP lenght.
            LoadTXT_E2P(TableResult,CWData)
            If F_KeyerMemoryError = 1 Then
                F_KeyerMemoryError = 0
                HRSOut CR
                HRSFStrg(KYSTRG83,1)        '/ "ERROR! ENTRY VALUE NO VALID"
                GoTo STARTCONFIG2)          '/ Try again.
            EndIf
            HRSFStrg(KYSTRG27,0)            '/ "READ MESSAGE: "
            HRSOut Dec NBMessageToSend,CR   '/ Print number of message to read.
            ReadStrg_E2P(TableResult)

        '/ Erasing messages: Point to the encoder with number to erase.
        Case "1"    '/ ERASE a message: (0 to 15)   
            HRSFStrg(KYSTRG82,1)   '/ "ERASE A MESSAGE",0
            HRSFStrg(KYSTRG80,1)   '/ "SET NUMBER OF MESSAGE WITH HEX ENCODER",0
            HRSFStrg(KYSTRG81,1)   '/ "NUMBER ENCODER READY: Y OR N",0
            ValueInput = HRSIn,{5000,STARTCONFIG2}
            '/ Change Low Case character to High Case.
            If ValueInput > 96 Then
                If ValueInput < 123 Then
                    ValueInput = ValueInput - 32
                EndIf
            EndIf   
            $ifdef _English_
            If ValueInput <> "Y" Then           '/ "Y Or N"
                GoTo STARTCONFIG2)              '/ Try again.
            EndIf            
            $endif
            $ifdef _Spanish_
            If ValueInput <> "S" Then           '/ "S O N"
                GoTo STARTCONFIG2)              '/ Try again.
            EndIf            
            $endif            
            $ifdef _French_
            If ValueInput <> "O" Then           '/ "O Ou N"
                GoTo STARTCONFIG2)              '/ Try again.
            EndIf            
            $endif
            '/ Set the HEX Encoder Address: [0]
            Low SWEncoderAddPin0
            Low SWEncoderAddPin1        
            Low SWEncoderAddPin2
            DelayUS 10                      '/ Delay to stabilizise the outputs of decoder.
            '/ HEX encoder: Valor 0 => %00001111 (all switches open)
            $ifdef _Proteus
            WREG = ~PORTA                   '/ Read HEX encoder, inverse because the connection.     
            $else
                $ifdef _EncoderCtsOpen
                WREG = ~PORTA               '/ Read HEX encoder with contacts Open, inverse because the connection.  
                $else
                WREG = PORTA                '/ Read DEC encoder with contacts closed.
                $endif
            $endif     
            WREG = WREG >> 2    
            NBMessageToSend = WREG & 15     '/ New number of message to erase.
            HRSFStrg(KYSTRG73,0)            '/ "ERASING MESSAGE NB"
            HRSOut Dec NBMessageToSend,CR   '/ Print number of message to erase.
            HRSFStrg(KYSTRG75,1)            '/ "ARE YOU SURE: Y OR N"
            ValueInput = HRSIn,{5000,STARTCONFIG2}
            '/ Change Low Case character to High Case.
            If ValueInput > 96 Then
                If ValueInput < 123 Then
                    ValueInput = ValueInput - 32
                EndIf
            EndIf  
            $ifdef _English_
            If ValueInput <> "Y" Then           '/ "Y Or N"
                GoTo STARTCONFIG2)              '/ Try again.
            EndIf            
            $endif
            $ifdef _Spanish_
            If ValueInput <> "S" Then           '/ "S O N"
                GoTo STARTCONFIG2)              '/ Try again.
            EndIf            
            $endif            
            $ifdef _French_
            If ValueInput <> "O" Then           '/ "O Ou N"
                GoTo STARTCONFIG2)              '/ Try again.
            EndIf            
            $endif
            TableResult = TableE2PAddress(NBMessageToSend)    '/ Looking for the EEP address.
            EWrite TableResult,[92,51,54,0] '/ Write Macro NOMSG + final string. => "\36" "NO MESSAGE IN THIS MEMORY"
            HRSFStrg(KYSTRG52,1)            '/ " CLEARED"
            HRSFStrg(KYSTRG27,0)            '/ "READ MESSAGE: "
            HRSOut Dec NBMessageToSend,CR   '/ Print number of message to read.
            ReadStrg_E2P(TableResult)

        Case Else
            HRSFStrg(KYSTRG06,1)            '/ "ENTRY ERROR!",CR
            ReturnState(ST_STARTCONFIG2)
    EndSelect
    '/--------------------------------------------------------------------------
    Select ReturnStateVar
        Case ST_START_KEYER2
            HRSFStrg(KYSTRG02,1)    '/ "EXIT CONFIGURATION MODE:",CR
            GoTo START_KEYER2

        Case ST_EXITLOOPCFG
            GoTo EXITLOOPCFG

        Case ST_EXITLOOPCFG2
            GoTo EXITLOOPCFG2               

        Case ST_ENDCONFIG
            GoTo ENDCONFIG          

        Case ST_READALLMESSAGES
            HRSFStrg(KYSTRG02,1)   '/ "EXIT CONFIGURATION MODE:",CR
            GoTo READALLMESSAGES           

        Case ST_STARTCONFIG2
            GoTo STARTCONFIG2 

        Case Else
            GoTo STARTCONFIG2
    EndSelect
'/------------------------------------------------------------------------------
EXITLOOPCFG:
    Do
        #ifdef Watchdog_req
        Clrwdt
        #endif
        '/ Exits the Tune or other routine.
        If F_ButtonSTOPpressed = 1 Then '/ Buton Stop pressed?
            F_ButtonSTOPpressed = 0
            Break
        EndIf
        If IP_DOT = 0 Then          '/ Dot-paddle closed?
            Break
        EndIf
        If IP_DASH = 0 Then         '/ Dash-paddle closed?
            Break
        EndIf                    
    Loop
'/------------------------------------------------------------------------------
EXITLOOPCFG2:
    #ifdef Watchdog_req
    Clrwdt
    #endif
    CWDataPin = 0               '/ Key up CWDataPin
    If F_EnablePTT = 1 Then
        DelayMS RXONDelay       '/ Load & Start the RX delay.
        Low CWPTT               '/ Transmitter OFF
    EndIf
    HRSFStrg(KYSTRG04,1)        '/ "TUNE OFF",CR
'/------------------------------------------------------------------------------
ENDCONFIG:
'    HRSOut CR 
    HRSFStrg(KYSTRG02,1)        '/ "EXIT CONFIGURATION MODE:",CR
    StatusLED = 0               '/ Status LED. End of configuration mode.
'    INTCONBits_INT0IE = 1   '/ (STOP Button) Enable the RB0 interrupt.
'/------------------------------------------------------------------------------
    GoTo Prepare_wait               '/ Goto Iambic/Ultimatic Keyer
'/##############################################################################
    End
'/############################################################################## 
'/==============================================================================
'* Purpose : Configuration of proyect at reset (DEFAULT).
'* Input   : none                                 
'* Output  : None
'* Note    : 
'/
STARTSIZE(CONFIG_DEFAULT_DATA)
'/ TXOnDelays [25,50,75,100,125,150,175,200,225,250] X 1mS  
ROMCW_TXONDELAY: CData 150   '/ 1 Byte. Default value
'/------------------------------------------------------------------------------
'/ RXOnDelays [25,50,75,100,125,150,175,200,225,250] X 1mS 
ROMCW_RXONDELAY: CData 75   '/ 1 Byte. Default value
'/------------------------------------------------------------------------------
'/ Keyer TUNE ON Delays [10,15,20,25,30,35,40,45,50,55] X 1000mS
ROMCW_TUNEDELAYON: CData 20    '/ 1 Byte. Default value
'/------------------------------------------------------------------------------
'/ Keyer TUNE OFF Delays [10,15,20,25,30,35,40,45,50,55] X 1000mS
ROMCW_TUNEDELAYOFF: CData 30    '/ 1 Byte. Default value
'/------------------------------------------------------------------------------
'/ Dot/Dash Compensation (0 to 31mS)
ROMCW_DOTDASH_ADJUSTMENT: CData 0 '/ 1 Byte. Default value
'/------------------------------------------------------------------------------
'/ WordSpace Adjustment [0,5,10,15,20,25,30,35,40,45] X 1 Dot / 10
ROMCW_WDSPACE_ADJUSTMENT: CData 0   '/ 1 Byte. Default value
'/------------------------------------------------------------------------------
'/ LetterSpace Adjustment [0,25,50,75,100,100,100,100,100,100] x 1 Dot / 100
ROMCW_LTSPACE_ADJUSTMENT: CData 0   '/ 1 Byte. Default value   
'/------------------------------------------------------------------------------    
'/ Farnsworth Spacing Adjustment [95,90,85,80,75,70,65,60,55,50] % of WPM
ROMCW_FARNSWORTHSP: CData 85    '/ 1 Byte. (85% of WPM) Default value
'/------------------------------------------------------------------------------             
'/ BEACON Delay Adjustment [3,4,5,6,7,8,9,10,11,12] X seconds
ROMCW_BEACONDELAY_ADJUSTMENT: CData 5    '/ 1 Byte. (5 seconds) Default value
'/------------------------------------------------------------------------------        
'/ TUNE transmitter time out.
'/ ValueInput = 30  '/ Default value 30 seconds
ROMCW_TUNETIMEOUT_ADJUSTMENT: CData 30    '/ 1 Byte.        
'/----------------------------------------------------------------------        
'/ TONE Frequency Index.
'ValueInput = 4     '/ Default value 4 (600Hz)
ROMCW_TONEFREQUENCY_INDEX: CData 4    '/ 1 Byte.
'CopyROMtoE2P(ROMCW_TONEFREQUENCY_INDEX,EEPCW_TONEFREQUENCY_INDEX,1)  
'/------------------------------------------------------------------------------ 
'/ MyCall, Default 10 Bytes
ROMCW_MYCALL: CData "EA3AGV",0  '/ 10 Bytes MAX.
'/------------------------------------------------------------------------------ 
'/ My MYQTH, Default 16 Bytes
ROMCW_QTH: CData "BARCELONA",0  '/ 16 Bytes MAX.
'/------------------------------------------------------------------------------ 
'/ My MYQTH LOCATOR, Default 7 Bytes
ROMCW_QTHLOC: CData "JN11BL",0  '/ 7 Bytes MAX.   
'/------------------------------------------------------------------------------ 
'/ My NAME, Default 12 Bytes
ROMCW_NAME: CData "ALBERTO",0   '/ 12 Bytes MAX.   
'/------------------------------------------------------------------------------         
'/ My RIG, Default 18 Bytes
ROMCW_RIG: CData "ICOM IC703",0 '/ 18 Bytes MAX.
'/------------------------------------------------------------------------------ 
'/ My AMPLIFIER POWER, Default 4 Bytes
ROMCW_PWR: CData "5",0          '/ 4 Bytes MAX.  
'/------------------------------------------------------------------------------     
'/ My ANT, Default 14 Bytes
ROMCW_ANT: CData "WINDOM",0     '/ 14 Bytes MAX.
    '/--------------------------------------------------------------------------   
'    ETX0 "\00"   '/ Final of String in eeprom messages.  (loaded manually)
'    STX0 "\02" => %,PTT1             ([KA], PTT On, Start of message) (NOT used)
'    EOT1 "\03" => #,SP,K,PTT0        ([AR], K, PTT OFF + RXON Delay, End of message)     
'    EOT2 "\04" => K,PTT0             ([K], PTT OFF + RXON Delay, End of message) 
'    EOT3 "\05" => &,PTT0             ([KN], PTT OFF + RXON Delay, Go only, invite a specific station To transmit)            
'    EOT4 "\06" => <,PTT0             ([Bk], PTT OFF + RXON Delay, Invite receiving station To transmit  
'    EOT5 "\07" => ^,SP,E,SP,E,PTT0   ([SK], SP, E, SP, E, PTT OFF + RXON Delay, Caret End of contact (sent before Call)                         
'    EOT6 "\08" => ^,SP,PTT0          ([SK], SP, PTT OFF + RXON Delay, Caret End of contact (sent before Call) 
'    EOT7 "\09" => #,SP,PSE,SP,K,PTT0 ([AR], SP, PSE, SP, K, PTT OFF + RXON Delay, End of message)
'    EOT8 "\10" => PSE,SP,K,PTT0      ([K], PSE,SP,K End of Transmision. "K")
'    PTT0 "["   => PTT OFF + RXDelay  ([[],  PTT OFF + RXON Delay

'    NMSG1    "\17" '/ Send the next message in the list.
'    NMSG2    "\18" '/ Send the next second message in the list.
'    NMSG3    "\19" '/ Send the next third message in the list.
'    URCALL1  "\20" '/ Load corresponsal call in string to place first in the message to send.
'    URCALL2  "\21" '/ Load corresponsal call in string to place at the end of the message.
'    MYCALL   "\22" '/ Load MY CALL the CW_StringSend string array. (10 Bytes)    
'    YXX      "\23" '/ The macro <YXX> only increments & place the new contest number to the CW_StringSend string array..
'    XXX      "\24" '/ When playing this message, the keyer replaces the <XXX> by the current contest number.  
'    QTH      "\25" '/ Insert QTH (string) (16 Bytes)
'    LOC      "\26" '/ Insert QTH LOCATOR 6 characters string (7 bytes) 
'    MYNAME   "\27" '/ Insert MY NAME 11 characters String (12 Bytes)
'    MYRIG    "\28" '/ Insert MY RIG 17 characters String (18 Bytes)
'    MYANT    "\29" '/ Insert MY ANT 13 characters String (14 Bytes)
'    PWR      "\30" '/ Insert the RIG Power (4 Bytes)
'    SNUM     "\31" '/ Set to send Short Numbers for Contest Number.
'    CNUM     "\32" '/ Clear to send Short Numbers for Contest Number.
'    BEACON   "\33" '/ Macro to send the same Message forever with 5 seconds interval.
'    COPTXT   "\34" '/ Copy the last characters from CW string to the same string. (Repeat CQ)
'    CLURCALL "\35" '/ Clear all the URCALL parameters.
'    NOMSG    "\36" '/ "NO MESSAGE IN THIS MEMORY"
'    RST      "\37" ;/ Load the RST values from the 3 Decimal encoders. Send twice.
'    RSTS     "\38" ;/ Load the RST Short values from the 3 Decimal encoders. Send once.
'    HCUAGN   "\39" ;/ (HPE CUAGN) text. Macro because to save bytes in eeprom memory.
'    QSLB     "\40" ;/ (QSL VIA BURO)  text. Macro because To Save bytes in eeprom memory.
'    S7373    "\41" ;/ (_73_73) text. Macro because to save bytes in eeprom memory.
'/============================================================================== 
'/ SHORT MESSAGES ONLY: 32 Bytes MAX.
'/------------------------------------------------------------------------------   
'/ BLOCK 0
'/ Message Nb 0, 32 Bytes MAX.
ROMCW_MSG0: CData CLURCALL,"CQ CQ DE",MYCALL,MYCALL,EOT8,BEACON,0  '/ 32 Bytes MAX.
'/------------------------------------------------------------------------------ 
'/ Message Nb 1, 32 Bytes MAX.
ROMCW_MSG1: CData URCALL1," DE",MYCALL," GM UR RST IS",RST,NMSG2,0    '/ 32 Bytes MAX.
'/------------------------------------------------------------------------------ 
'/ Message Nb 2, 32 Bytes MAX.
ROMCW_MSG2: CData  URCALL1," DE",MYCALL," TNX QSO",S7373," #",CLURCALL,EOT5,0    '/ 32 Bytes MAX.
'/------------------------------------------------------------------------------ 
'/ Message Nb 3, 32 Bytes MAX.
ROMCW_MSG3: CData "= MY NAME IS",MYNAME," QTH IS",MYQTH,NMSG1,0   '/ 32 Bytes MAX.
'/------------------------------------------------------------------------------ 
'/ Message Nb 4, 32 Bytes MAX.
ROMCW_MSG4: CData "= HW?",URCALL2," DE",MYCALL,EOT1,0  '/ 32 Bytes MAX.
'/------------------------------------------------------------------------------ 
'/ END OF SHORT MESSAGES:
'/============================================================================== 
'/ BLOCK 1
'/ Message Nb 5, 64 Bytes MAX.
ROMCW_MSG5: CData "CQ CQ CQ DE",MYCALL,MYCALL,MYCALL,EOT8,BEACON,0   '/ 64 Bytes MAX.
'/------------------------------------------------------------------------------ 
'/ Message Nb 6, 64 Bytes MAX.
ROMCW_MSG6: CData URCALL1," DE",MYCALL," GM TNX CALL UR RST IS",RST," = MY NAME IS",MYNAME,NMSG3,0   '/ 64 Bytes MAX.
'/------------------------------------------------------------------------------     
'/ Message Nb 7, 64 Bytes MAX.
ROMCW_MSG7: CData URCALL1," DE",MYCALL," FB TNX FER NICE QSO",HCUAGN,S7373," =",URCALL2," DE",MYCALL,CLURCALL,EOT5,0   '/ 64 Bytes MAX.
'/------------------------------------------------------------------------------     
'/ Message Nb 8, 64 Bytes MAX.
ROMCW_MSG8: CData URCALL1,"DE",MYCALL," R TNX QSO CUL",URCALL2," DE",MYCALL,CLURCALL,EOT5,0   '/ 64 Bytes MAX.
'/------------------------------------------------------------------------------     
'/ Message Nb 9, 64 Bytes MAX.
ROMCW_MSG9: CData  "= MY QTH IS",MYQTH," RIG IS",MYRIG," ANT IS",MYANT," = HW?",URCALL2," DE",MYCALL,EOT2,0   '/ 64 Bytes MAX. '/ 64 Bytes MAX.
'/==============================================================================    
'/ BLOCK 2
'/ Message Nb 10, 64 Bytes MAX.
ROMCW_MSG10: CData NOMSG,0  '/ 64 Bytes MAX.
'/------------------------------------------------------------------------------     
'/ Message Nb 11, 64 Bytes MAX.
ROMCW_MSG11: CData NOMSG,0  '/ 64 Bytes MAX.
'/------------------------------------------------------------------------------     
'/ Message Nb 12, 64 Bytes MAX.
ROMCW_MSG12: CData NOMSG,0  '/ 64 Bytes MAX.
'/------------------------------------------------------------------------------     
'/ Message Nb 13, 64 Bytes MAX.
ROMCW_MSG13: CData NOMSG,0  '/ 64 Bytes MAX.
'/------------------------------------------------------------------------------  
'/ Message Nb 14, 64 Bytes MAX.
ROMCW_MSG14: CData NOMSG,0  '/ 64 Bytes MAX.
'/==============================================================================    
'/ BLOCK 3 : 1 MESSAGE
'/ Message Nb 15, 64 Bytes MAX.
ROMCW_MSG15: CData URCALL1," DE",MYCALL," TNX FER NICE QSO =",QSLB,HCUAGN,S7373," =",URCALL2," DE",MYCALL,CLURCALL,EOT5,0   '/ 64 Bytes MAX.
'/------------------------------------------------------------------------------ 
ENDSIZE(CONFIG_DEFAULT_DATA)    
'/==============================================================================
'/==============================================================================
STARTSIZE(MESSAGES_ROM)
KYMessagesTable0: CData Word CWTXT01,CWTXT02,CWTXT03,CWTXT04,CWTXT05

KYMessagesTable1: CData Word CWTXT06,CWTXT07,CWTXT08,CWTXT09,CWTXT10

KYMessagesTable2: CData Word CWTXT11,CWTXT12,CWTXT13,CWTXT14,CWTXT15

KYMessagesTable3: CData Word CWTXT16,CWTXT17,CWTXT18,CWTXT19,CWTXT20

KYMessagesTable4: CData Word CWTXT21,CWTXT22,CWTXT23,CWTXT24,CWTXT25

KYMessagesTable5: CData Word CWTXT26,CWTXT27,CWTXT28,CWTXT29,CWTXT30

KYMessagesTable6: CData Word CWTXT31,CWTXT32,CWTXT33,CWTXT34,CWTXT35

KYMessagesTable7: CData Word CWTXT36,CWTXT37,CWTXT38,CWTXT39,CWTXT40

KYMessagesTable8: CData Word CWTXT41,CWTXT42,CWTXT43,CWTXT44,CWTXT45

KYMessagesTable9: CData Word CWTXT46,CWTXT47,CWTXT48,CWTXT49,CWTXT50

KYMessagesTable10: CData Word CWTXT51,CWTXT52,CWTXT53,CWTXT54,CWTXT55

KYMessagesTable11: CData Word CWTXT56,CWTXT57,CWTXT58,CWTXT59,CWTXT60

KYMessagesTable12: CData Word CWTXT61,CWTXT62,CWTXT63,CWTXT64,CWTXT65

KYMessagesTable13: CData Word CWTXT66,CWTXT67,CWTXT68,CWTXT69,CWTXT70

KYMessagesTable14: CData Word CWTXT71,CWTXT72,CWTXT73,CWTXT74,CWTXT75

KYMessagesTable15: CData Word CWTXT76,CWTXT77,CWTXT78,CWTXT79,CWTXT80

KYMessagesTable16: CData Word CWTXT81,CWTXT82,CWTXT83,CWTXT84,CWTXT85

KYMessagesTable17: CData Word CWTXT86,CWTXT87,CWTXT88,CWTXT89,CWTXT90

KYMessagesTable18: CData Word CWTXT91,CWTXT92,CWTXT93,CWTXT94,CWTXT95

KYMessagesTable19: CData Word CWTXT96,CWTXT97,CWTXT98,CWTXT99,CWTXT100
'/------------------------------------------------------------------------------
'    ETX0 "\00"   '/ Final of String in eeprom messages.  (loaded manually)
'    STX0 "\02" => %,PTT1             ([KA], PTT On, Start of message) (NOT used)
'    EOT1 "\03" => #,SP,K,PTT0        ([AR], K, PTT OFF + RXON Delay, End of message)     
'    EOT2 "\04" => K,PTT0             ([K], PTT OFF + RXON Delay, End of message) 
'    EOT3 "\05" => &,PTT0             ([KN], PTT OFF + RXON Delay, Go only, invite a specific station To transmit)            
'    EOT4 "\06" => <,PTT0             ([Bk], PTT OFF + RXON Delay, Invite receiving station To transmit  
'    EOT5 "\07" => ^,SP,E,SP,E,PTT0   ([SK], SP, E, SP, E, PTT OFF + RXON Delay, Caret End of contact (sent before Call)                         
'    EOT6 "\08" => ^,SP,PTT0          ([SK], SP, PTT OFF + RXON Delay, Caret End of contact (sent before Call) 
'    EOT7 "\09" => #,SP,PSE,SP,K,PTT0 ([AR], SP, PSE, SP, K, PTT OFF + RXON Delay, End of message)
'    EOT8 "\10" => PSE,SP,K,PTT0      ([K], PSE,SP,K End of Transmision. "K")
'    PTT0 "["   => PTT OFF + RXDelay  ([[],  PTT OFF + RXON Delay

'    NMSG1    "\17" '/ Send the next message in the list.
'    NMSG2    "\18" '/ Send the next second message in the list.
'    NMSG3    "\19" '/ Send the next third message in the list.
'    URCALL1  "\20" '/ Load corresponsal call in string to place first in the message to send.
'    URCALL2  "\21" '/ Load corresponsal call in string to place at the end of the message.
'    MYCALL   "\22" '/ Load MY CALL the CW_StringSend string array. (10 Bytes)    
'    YXX      "\23" '/ The macro <YXX> only increments & place the new contest number to the CW_StringSend string array..
'    XXX      "\24" '/ When playing this message, the keyer replaces the <XXX> by the current contest number.  
'    QTH      "\25" '/ Insert QTH (string) (16 Bytes)
'    LOC      "\26" '/ Insert QTH LOCATOR 6 characters string (7 bytes) 
'    MYNAME   "\27" '/ Insert MY NAME 11 characters String (12 Bytes)
'    MYRIG    "\28" '/ Insert MY RIG 17 characters String (18 Bytes)
'    MYANT    "\29" '/ Insert MY ANT 13 characters String (14 Bytes)
'    PWR      "\30" '/ Insert the RIG Power (4 Bytes)
'    SNUM     "\31" '/ Set to send Short Numbers for Contest Number.
'    CNUM     "\32" '/ Clear to send Short Numbers for Contest Number.
'    BEACON   "\33" '/ Macro to send the same Message forever with 5 seconds interval.
'    COPTXT   "\34" '/ Copy the last characters from CW string to the same string. (Repeat CQ)
'    CLURCALL "\35" '/ Clear all the URCALL parameters.
'    NOMSG    "\36" '/ "NO MESSAGE IN THIS MEMORY"
'    RST      "\37" ;/ Load the RST values from the 3 Decimal encoders. Send twice.
'    RSTS     "\38" ;/ Load the RST Short values from the 3 Decimal encoders. Send once.
'    HCUAGN   "\39" ;/ (HPE CUAGN) text. Macro because to save bytes in eeprom memory.
'    QSLB     "\40" ;/ (QSL VIA BURO)  text. Macro because To Save bytes in eeprom memory.
'    S7373    "\41" ;/ ( 73 73) text. Macro because to save bytes in eeprom memory.

'        "\36" "NO MESSAGE IN THIS MEMORY"
' IMSG1  "\51" '/ Insert the MSG1.
' IMSGX  "\XX" '/ Insert the MSGX.
'/==============================================================================
'/ Special messages or Keyboard mode on the fly: 
'/ These Prosigns can be sent & written in the ASCII message.
'/ (# send AR), (% send KA), (& send KN), (* send AS), (< send BK), (= send BT),(> send VE), (] send AA]),
'/ (^ send SK), (| send EOM).
'/
KBTXTAA: CData " FB TNX FER NICE QSO =",0
KBTXTBB: CData " QSL VIA BURO =",0
KBTXTCC: CData " 73 73 HPE CUAGN #",0
KBTXTDD: CData " PSE K",0
KBTXTEE: CData " DE EA3AGV",0
'/==============================================================================   
'/ Lenght messages max 32 or 64 bytes.
'/==============================================================================   
'/ BLOCK 0
CWTXT01: CData "CQ DE",MYCALL,COPTXT,EOT1,BEACON,0
CWTXT02: CData "DE",MYCALL," UR RST",RST," =",NMSG1,0
CWTXT03: CData "MY NAME IS",MYNAME," MY QTH IS",MYQTH," ?",NMSG1,0
CWTXT04: CData URCALL1," DE",MYCALL,EOT2,0
CWTXT05: CData S7373," DE",MYCALL,CLURCALL,EOT4,0
'/==============================================================================               
'/ BLOCK 1
CWTXT06: CData "CQ CQ CQ DE",MYCALL,MYCALL," # PSE",EOT1,BEACON,0
CWTXT07: CData "CQ CQ DE",MYCALL,"/QRP",MYCALL," =QRP",EOT2,BEACON,0
CWTXT08: CData "UR RST IS",RST,EOT2,0
CWTXT09: CData "MY NAME IS",MYNAME,MYNAME," MY QTH IS",MYQTH,MYQTH,NMSG1,0
CWTXT10: CData "MY RIG IS",MYRIG," ANT",MYANT," HW? # DE",MYCALL,EOT2,0
'/==============================================================================
'/ BLOCK 2
CWTXT11: CData URCALL1," DE",MYCALL," TNX CALL UR RST IS",RST," MY NAME IS",MYNAME," ?",URCALL2," DE",MYCALL,EOT2,0
CWTXT12: CData "DE",MYCALL," FB MY RIG IS",MYRIG," AT PWR",PWR,"W TO ANT",MYANT," HW?",EOT2,0 
CWTXT13: CData "DE",MYCALL," FB ON ALL TNX QSO",HCUAGN,S7373," GE ^ DE",MYCALL,EOT1,0 
CWTXT14: CData NOMSG,0
CWTXT15: CData "FB TNX FER NICE QSO =",QSLB," /",HCUAGN,S7373,URCALL2," DE",MYCALL,EOT4,0
'/==============================================================================
'/ BLOCK 3
CWTXT16: CData "CQ",MYCALL,MYCALL," TEST",PTT0,BEACON,0
CWTXT17: CData URCALL1," DE",MYCALL,RSTS,YXX,SNUM,XXX,CNUM,CLURCALL,EOT3,0
CWTXT18: CData "< DE",MYCALL," R R",EOT5,0
CWTXT19: CData NOMSG,0
CWTXT20: CData NOMSG,0
'/==============================================================================
'/ BLOCK 4
CWTXT21: CData NOMSG,0
CWTXT22: CData NOMSG,0
CWTXT23: CData NOMSG,0
CWTXT24: CData NOMSG,0
CWTXT25: CData NOMSG,0
'/==============================================================================
'/ BLOCK 5
CWTXT26: CData NOMSG,0
CWTXT27: CData NOMSG,0
CWTXT28: CData NOMSG,0
CWTXT29: CData NOMSG,0 
CWTXT30: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 6
CWTXT31: CData NOMSG,0
CWTXT32: CData NOMSG,0
CWTXT33: CData NOMSG,0
CWTXT34: CData NOMSG,0 
CWTXT35: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 7
CWTXT36: CData NOMSG,0
CWTXT37: CData NOMSG,0
CWTXT38: CData NOMSG,0
CWTXT39: CData NOMSG,0 
CWTXT40: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 8
CWTXT41: CData NOMSG,0
CWTXT42: CData NOMSG,0
CWTXT43: CData NOMSG,0
CWTXT44: CData NOMSG,0 
CWTXT45: CData NOMSG,0
'/==============================================================================
'/ BLOCK 9
CWTXT46: CData NOMSG,0
CWTXT47: CData NOMSG,0
CWTXT48: CData NOMSG,0
CWTXT49: CData NOMSG,0 
CWTXT50: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 10
CWTXT51: CData NOMSG,0
CWTXT52: CData NOMSG,0
CWTXT53: CData NOMSG,0
CWTXT54: CData NOMSG,0 
CWTXT55: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 11
CWTXT56: CData NOMSG,0
CWTXT57: CData NOMSG,0
CWTXT58: CData NOMSG,0
CWTXT59: CData NOMSG,0 
CWTXT60: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 12
CWTXT61: CData NOMSG,0
CWTXT62: CData NOMSG,0
CWTXT63: CData NOMSG,0
CWTXT64: CData NOMSG,0 
CWTXT65: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 13
CWTXT66: CData NOMSG,0
CWTXT67: CData NOMSG,0
CWTXT68: CData NOMSG,0
CWTXT69: CData NOMSG,0 
CWTXT70: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 14
CWTXT71: CData NOMSG,0
CWTXT72: CData NOMSG,0
CWTXT73: CData NOMSG,0
CWTXT74: CData NOMSG,0 
CWTXT75: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 15
CWTXT76: CData NOMSG,0
CWTXT77: CData NOMSG,0
CWTXT78: CData NOMSG,0
CWTXT79: CData NOMSG,0
CWTXT80: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 16
CWTXT81: CData NOMSG,0
CWTXT82: CData NOMSG,0
CWTXT83: CData NOMSG,0
CWTXT84: CData NOMSG,0 
CWTXT85: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 17
CWTXT86: CData NOMSG,0
CWTXT87: CData NOMSG,0
CWTXT88: CData NOMSG,0
CWTXT89: CData NOMSG,0 
CWTXT90: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 18
CWTXT91: CData NOMSG,0
CWTXT92: CData NOMSG,0
CWTXT93: CData NOMSG,0
CWTXT94: CData NOMSG,0 
CWTXT95: CData NOMSG,0 
'/==============================================================================
'/ BLOCK 19
CWTXT96: CData "CQ CQ DE",MYCALL,"/QRP",MYCALL,"/QRP",EOT2,BEACON,0
CWTXT97: CData URCALL1," DE",MYCALL," UR RST IS",RST," MY NAME IS",MYNAME," ?",URCALL2," DE",MYCALL,EOT1,0
CWTXT98: CData URCALL1," DE",MYCALL," TNX FER CALL = UR RST IS",RST," MY NAME IS",MYNAME,NMSG2,0
CWTXT99: CData URCALL1," DE",MYCALL," FB TNX FER NICE QSO =",QSLB," =",HCUAGN," 73 73",URCALL2," DE",MYCALL,EOT4,0
CWTXT100: CData "QTH IS",MYQTH," RIG IS",MYRIG," ANT",MYANT," HW? # DE",MYCALL,EOT1,0 
'/==============================================================================
ENDSIZE(MESSAGES_ROM)
'/##############################################################################
'/##############################################################################
KEYERSTRINGS_TABLE:
STARTSIZE(KEYERSTRINGS_TABLE)
$ifdef _English_
KYSTRG01: CData "CONFIGURATION MODE:",0
KYSTRG02: CData "EXIT CONFIGURATION MODE",0
KYSTRG03: CData "TUNE ON",0
KYSTRG04: CData "TUNE OFF",0
KYSTRG05: CData "NEW VALUE? ",0
KYSTRG06: CData "ENTRY ERROR!",0
KYSTRG07: CData "RXON DELAY: ",0
KYSTRG08: CData "TXON DELAY: ",0
KYSTRG09: CData "DOT TIME: ",0
KYSTRG10: CData "DASH TIME: ",0
KYSTRG11: CData "RUNNING FILE: <EA3AGV_WinKeyer_V10.BAS>",0
KYSTRG12: CData "SYSTEM VARIABLES COUNT: ",0
KYSTRG13: CData "XTAL: ",0
KYSTRG14: CData "PROGRAM BYTES USED: ",0
KYSTRG15: CData "KEYBOARD MODE",0
KYSTRG16: CData "EA3AGV YAMBIC A/B & ULTIMATIC KEYER",0 
KYSTRG17: CData "MY CALLSIGN: ",0
KYSTRG18: CData "WATCHDOG DELAY: ",0
KYSTRG19: CData "KEYER WATCHDOG",0
KYSTRG20: CData " ADJUSTMENT ",0
KYSTRG21: CData " DELAY: ",0
KYSTRG22: CData "RECEIVING...",0
KYSTRG23: CData "INITIALIZE EEPROM...",0
KYSTRG24: CData "CODE ?",0
KYSTRG25: CData "CONFIG FLAGS: ",0
KYSTRG26: CData "WRITE A NEW MESSAGE",0
KYSTRG27: CData "READ MESSAGE ",0
KYSTRG28: CData "EEPROM MESSAGES",0
KYSTRG29: CData "READ ROM MESSAGES BLOCK: ",0
KYSTRG30: CData "WORD SPACE",0
KYSTRG31: CData "LETTER SPACE",0
KYSTRG32: CData "CHOOSE OPTION? ",0
KYSTRG33: CData "RESET DEFAULT PARAMETERS",0
KYSTRG34: CData "FARNSWORTH SPACE",0
KYSTRG35: CData "NO MESSAGE IN THIS MEMORY",0
KYSTRG36: CData "DOT/DASH RATIO 1:4",0
KYSTRG37: CData "DOT/DASH RATIO 1:3",0
KYSTRG38: CData "DECREMENT QSO COUNTER: ",0
KYSTRG39: CData " ENABLED",0
KYSTRG40: CData " DISABLED",0
KYSTRG41: CData "TONE",0
KYSTRG42: CData "BEACON",0
KYSTRG43: CData "MUTE",0
KYSTRG44: CData "KEYER",0
KYSTRG45: CData "PTT",0
KYSTRG46: CData "ULTIMATIC",0
KYSTRG47: CData "IAMBIC B",0
KYSTRG48: CData "TOO MUCH CHARACTERS FOR THIS EEPROM MEMORY MESSAGE",0
KYSTRG49: CData "A CORRECT STRING HAS NOT BEEN LOADED!",0
KYSTRG50: CData "PADDLES MODE",0
KYSTRG51: CData "TRANSMITING...",0
KYSTRG52: CData " CLEARED",0
KYSTRG53: CData "QSO COUNTER: ",0
KYSTRG54: CData "UR CALLSIGN IS ERASED",0
KYSTRG55: CData "LOAD UR CALLSIGN",0
KYSTRG56: CData "INPUT FROM ROM MESSAGES BLOCK: ",0
KYSTRG57: CData "OUTPUT TO EEPROM MESSAGES BLOCK: ",0
KYSTRG58: CData "COPY ROM BLOCK NB: ",0
KYSTRG59: CData " TO EEP BLOCK NB: ",0
KYSTRG60: CData "IAMBIC A",0
KYSTRG61: CData "W :WRITE ",0
KYSTRG62: CData "R :READ ",0
KYSTRG63: CData "E :ERASE ",0
KYSTRG64: CData "PRESS ENTER TO FINISH",0
KYSTRG65: CData "WORD SPACING",0
KYSTRG66: CData "KEYER MODE?",0
KYSTRG67: CData "ULIMATIC MODE: U",0
KYSTRG68: CData "IAMBIC A MODE: A",0
KYSTRG69: CData "IAMBIC B MODE: B",0
KYSTRG70: CData "INPUT TENS DIGIT: ",0
KYSTRG71: CData "INPUT UNITS DIGIT: ",0
KYSTRG72: CData "EEPROM BLOCK ",0
KYSTRG73: CData "ERASING MESSAGE: ",0
KYSTRG74: CData "WRITING MESSAGE: ",0
KYSTRG75: CData "ARE YOU SURE? Yes OR No",0
KYSTRG76: CData "FARNSWORTH",0
KYSTRG77: CData "LETTERSPACE DELAY: ",0
KYSTRG78: CData "WORDSPACE DELAY: ",0
KYSTRG79: CData "SHORT NBS",0
KYSTRG80: CData "SET NUMBER OF MESSAGE WITH HEX ENCODER",0
KYSTRG81: CData "ENCODER NUMBER READY: Y OR N",0
KYSTRG82: CData "ERASE A MESSAGE",0
KYSTRG83: CData "ERROR! ENTRY VALUE NO VALID",0
KYSTRG84: CData "READ CW TIMINGS",0
KYSTRG85: CData "READ ALL EEPROM MSG: E",0
KYSTRG86: CData "READ ALL ROM MSG: R",0
KYSTRG87: CData "CONTEST MODE",0
KYSTRG88: CData "DOT/DASH COMPENSATION, INTER-LETTER SPACING ADJ, WORD SPACE ADJ",0
KYSTRG89: CData "DOT/DASH COMPENSATION",0
KYSTRG90: CData "INTER-LETTER SPACING ADJUSTMENT",0
KYSTRG91: CData "WORD SPACING ADJUSTMENT",0
KYSTRG92: CData "% of LTSPACE",0
KYSTRG93: CData "% of WDSPACE",0
KYSTRG94: CData "% of WPM",0
KYSTRG95: CData "BEACON TIMEOUT",0
KYSTRG96: CData "TUNEON DELAY",0
KYSTRG97: CData "TUNEOFF DELAY",0
KYSTRG98: CData "ADJUST TUNE ON/OFF DELAY",0
KYSTRG99: CData "READ/WRITE/ERASE THE QSO COUNTER",0
KYSTRG100: CData "COPY ROM BLOCK TO EEPROM BLOCK",0
KYSTRG101: CData "LOAD FARNSWORTH SPACING VALUE",0
KYSTRG102: CData "MUTE OPTION",0
KYSTRG103: CData "MSG LETTER SPACE TIME: ",0
KYSTRG104: CData "MSG WORD SPACE TIME: ",0
KYSTRG105: CData "TUNE TIME MAX",0
KYSTRG106: CData "TONE FREQUENCY",0 
$endif
$ifdef _Spanish_
KYSTRG01: CData "MODE DE CONFIGURACION:",0
KYSTRG02: CData "SALIDA MODO DE CONFIGURACION",0
KYSTRG03: CData "TUNE ON",0
KYSTRG04: CData "TUNE OFF",0
KYSTRG05: CData "NUEVO VALOR?",0
KYSTRG06: CData "ENTRADA ERRONEA!",0
KYSTRG07: CData "RETARDO RXON: ",0
KYSTRG08: CData "RETARDO TXON: ",0
KYSTRG09: CData "DURACION PUNTO: ",0
KYSTRG10: CData "DURACION RAYA: ",0
KYSTRG11: CData "RUNNING FILE: <EA3AGV_WinKeyer_V10.BAS>",0
KYSTRG12: CData "TOTAL DE LAS VARIABLES SISTEMA: ",0
KYSTRG13: CData "XTAL: ",0
KYSTRG14: CData "BYTES UTILIZADOS EN EL PROGRAMA: ",0
KYSTRG15: CData "MODO TECLADO",0
KYSTRG16: CData "EA3AGV YAMBIC A/B & ULTIMATIC KEYER",0 
KYSTRG17: CData "MY CALLSIGN: ",0
KYSTRG18: CData "DURACION DEL WATCHDOG: ",0
KYSTRG19: CData "KEYER WATCHDOG",0
KYSTRG20: CData " AJUSTE",0
KYSTRG21: CData " RETARDO: ",0
KYSTRG22: CData "RECEPCION...",0
KYSTRG23: CData "INICIALIZANDO EEPROM...",0
KYSTRG24: CData "CODIGO?",0
KYSTRG25: CData "FLAGS DE CONFIGURACION: ",0
KYSTRG26: CData "TECLEAR UN NUEVO MENSAJE",0
KYSTRG27: CData "LEER MENSAJE ",0
KYSTRG28: CData "MENSAJES DE LA EEPROM",0
KYSTRG29: CData "LEER LOS BLOQUES DE MENSAJES DE LA ROM ",0
KYSTRG30: CData "ESPACIO ENTRE PALABRA",0
KYSTRG31: CData "ESPACIO ENTRE LETRA",0
KYSTRG32: CData "ESCOJER UNA OPCION? ",0
KYSTRG33: CData "VOLVER A LOS PARAMETROS POR DEFECTO",0
KYSTRG34: CData "ESPACIO FARNSWORTH",0
KYSTRG35: CData "NO HAY MENSAJE EN ESTA MEMORIA",0
KYSTRG36: CData "RELACION RAYA/PUNTO 1:4",0
KYSTRG37: CData "RELACION RAYA/PUNTO 1:3",0
KYSTRG38: CData "DECREMENTO DEL CONTADOR DE QSO: ",0
KYSTRG39: CData " HABILITADO",0
KYSTRG40: CData " DESHABILITADO",0
KYSTRG41: CData "TONE",0
KYSTRG42: CData "BEACON",0
KYSTRG43: CData "MUTE",0
KYSTRG44: CData "KEYER",0
KYSTRG45: CData "PTT",0
KYSTRG46: CData "ULTIMATIC",0
KYSTRG47: CData "IAMBIC B",0
KYSTRG48: CData "DEMASIADOS CARACTERES PARA ESTE MENSAJE DE LA MEORIA EEPROM",0
KYSTRG49: CData "UNA CADENA NO HA SIDO CORRECTAMENTE CARGADA!",0
KYSTRG50: CData "MODO PALAS",0
KYSTRG51: CData "TRANSMITIENDO...",0
KYSTRG52: CData " BORADO",0
KYSTRG53: CData "CONTADOR DE QSO: ",0
KYSTRG54: CData "UR CALLSIGN ESTA BORRADO",0
KYSTRG55: CData "CARGAR UR CALLSIGN",0
KYSTRG56: CData "ENTRADA DESDE EL BLOC DE MENSAGES DE LA ROM: ",0
KYSTRG57: CData "ENVIAR AL BLOQUE DE MENSAGES DE LA EEPROM: ",0
KYSTRG58: CData "COPIAR EL BLOQUE ROM NUM: ",0
KYSTRG59: CData " HACIA EL BLOQUE EEPROM NUM: ",0
KYSTRG60: CData "IAMBIC A",0
KYSTRG61: CData "W :ESCRIBIR ",0
KYSTRG62: CData "R :LEER ",0
KYSTRG63: CData "E :BORRAR ",0
KYSTRG64: CData "APRETAR ENTER PARA TERMINAR",0
KYSTRG65: CData "ESPACIO ENTRE PALABRA",0
KYSTRG66: CData "MODO DEL KEYER?",0
KYSTRG67: CData "MODO ULIMATIC: U",0
KYSTRG68: CData "MODO IAMBIC A: A",0
KYSTRG69: CData "MODO IAMBIC B: B",0
KYSTRG70: CData "ENTRAR DECENAS: ",0
KYSTRG71: CData "ENTRAR UNIDADES: ",0
KYSTRG72: CData "EEPROM BLOCK ",0
KYSTRG73: CData "BORRANDO MENSAJE: ",0
KYSTRG74: CData "ESCRIBIENDO MENSAJE: ",0
KYSTRG75: CData "ESTA SEGURO? SI O NO",0
KYSTRG76: CData "FARNSWORTH",0
KYSTRG77: CData "RETARDO ESPACIO LETRA: ",0
KYSTRG78: CData "RETARDO ESPACIO PALABRA: ",0
KYSTRG79: CData "OPCION NUMEROS CORTOS",0
KYSTRG80: CData "FIJAR EL NUMERO DEL MENSAJE CON EL ENCODER HEX",0
KYSTRG81: CData "NUMERO DEL ENCODER FIJADO?: SI O NO",0
KYSTRG82: CData "BORRAR UN MENSAJE",0
KYSTRG83: CData "ERROR! ENTRADA NO VALIDA",0
KYSTRG84: CData "LEER LOS TIEMPOS",0
KYSTRG85: CData "LEER TODOS LOS MSG DE LA EEPROM: E",0
KYSTRG86: CData "LEER TODOS LOS MSG DE LA ROM: R",0
KYSTRG87: CData "MODO CONCURSO",0
KYSTRG88: CData "COMPENSACION PUNTO/RAYA, AJUSTE ESPACIO INTER-LETRA, AJUSTE ESPACIO PALABRA",0
KYSTRG89: CData "COMPENSACION PUNTO/RAYA",0
KYSTRG90: CData "AJUSTE ESPACIO ENTRE LETRA",0
KYSTRG91: CData "AJUSTE ESPACIO ENTRE PALABRA",0
KYSTRG92: CData "% OF ESPACIO LETRA",0
KYSTRG93: CData "% OF ESPACIO PALABRA",0
KYSTRG94: CData "% OF WPM",0
KYSTRG95: CData "RETARDO BALISA",0
KYSTRG96: CData "RETARDO TUNEON",0
KYSTRG97: CData "RETARDO TUNEOFF",0
KYSTRG98: CData "ADJUSTE RETARDO TUNE ON/OFF",0
KYSTRG99: CData "LEER/ESCRIBIR/BORRAR EL CONTADOR DE QSO",0
KYSTRG100: CData "COPIAR EL BLOQUE ROM AL BLOQUE EEPROM",0
KYSTRG101: CData "CARGAR EL VALOR ESPACIO FARNSWORTH",0 
KYSTRG102: CData "OPTION MUTE",0
KYSTRG103: CData "MSG TIEMPO ESPACIO LETRA: ",0
KYSTRG104: CData "MSG TIEMPO ESPACIO PALABRA: ",0
KYSTRG105: CData "TIEMPO DE AJUSTE MAX",0 
KYSTRG106: CData "FRECUENCIA DEL TONO",0 
$endif
$ifdef _French_
KYSTRG01: CData "MODE DE CONFIGURATION:",0
KYSTRG02: CData "CONFIGURATION TERMINEE",0
KYSTRG03: CData "TUNE ON",0
KYSTRG04: CData "TUNE OFF",0
KYSTRG05: CData "NOUVELLE VALEUR?",0
KYSTRG06: CData "ENTREE MAUVAISE!",0
KYSTRG07: CData "RETARD RXON: ",0
KYSTRG08: CData "RETARD TXON: ",0
KYSTRG09: CData "DUREE DU POINT: ",0
KYSTRG10: CData "DUREE DU TRAIT: ",0
KYSTRG11: CData "FICHIER UTILISE: <EA3AGV_WinKeyer_V10.BAS>",0
KYSTRG12: CData "TOTAL VARIABLES SYSTEM UTILISEES: ",0
KYSTRG13: CData "XTAL: ",0
KYSTRG14: CData "BYTES DE PROGRAMME UTILISES: ",0
KYSTRG15: CData "MODE CLAVIER",0
KYSTRG16: CData "EA3AGV YAMBIC A/B & ULTIMATIC KEYER",0 
KYSTRG17: CData "MY CALLSIGN: ",0
KYSTRG18: CData "RETARD WATCHDOG: ",0
KYSTRG19: CData "WATCHDOG DU KEYER",0
KYSTRG20: CData " REGLAGE",0
KYSTRG21: CData " RETARD: ",0
KYSTRG22: CData "RECEPCTION...",0
KYSTRG23: CData "INITIALISANT LA EEPROM...",0
KYSTRG24: CData "OPTION ?",0
KYSTRG25: CData "FLAGS DE CONFIGURATION: ",0
KYSTRG26: CData "ECRIRE UN NOUVEAU MESSAGE",0
KYSTRG27: CData "LIRE UN MESSAGE ",0
KYSTRG28: CData "MESSAGES EEPROM ",0
KYSTRG29: CData "LIRE LES BLOCS DE MESSAGES DE LA ROM ",0
KYSTRG30: CData "ESPACE DU MOT",0
KYSTRG31: CData "ESPACE DE LA LETTRE",0
KYSTRG32: CData "CHOISIR UNE OPTION? ",0
KYSTRG33: CData "REVENIR AU PARAMETRAGE PAR DEFAUT",0
KYSTRG34: CData "ESPACE FARNSWORTH",0
KYSTRG35: CData "PAS DE MESSAGE DANS CETTE MEMOIRE",0
KYSTRG36: CData "RAPPORT POINT/TRAIT 1:4",0
KYSTRG37: CData "RAPPORT POINT/TRAIT 1:3",0
KYSTRG38: CData "DECREMENTER COMPTEUR QSO: ",0
KYSTRG39: CData " HABILITE",0
KYSTRG40: CData " NON HABILITE",0
KYSTRG41: CData "TONE",0
KYSTRG42: CData "BEACON",0
KYSTRG43: CData "MUTE",0
KYSTRG44: CData "KEYER",0
KYSTRG45: CData "PTT",0
KYSTRG46: CData "ULTIMATIC",0
KYSTRG47: CData "IAMBIC B",0
KYSTRG48: CData "TROP DE CARACTERES POUR LE MESSAGE DE CETTE MEMOIRE",0
KYSTRG49: CData "UNE CHAINE ASCII N'A PAS PU ETRE CHARGEE CORRECTEMENT!",0
KYSTRG50: CData "MODE PALES",0
KYSTRG51: CData "TRANSMITION...",0
KYSTRG52: CData " EFFACE",0
KYSTRG53: CData "COMPTEUR DE QSO: ",0
KYSTRG54: CData "URCALLSIGN EST EFFACE",0
KYSTRG55: CData "CHARGER URCALLSIGN",0
KYSTRG56: CData "ENTRER LE BLOC DE MESSAGE DE LA ROM: ",0
KYSTRG57: CData "ENVOYER LE BLOC DE MESSAGES A LA EEPROM: ",0
KYSTRG58: CData "COPIER LE BLOC ROM NUM: ",0
KYSTRG59: CData " AU BLOC DE LA EEPROM NUM: ",0
KYSTRG60: CData "IAMBIC A",0
KYSTRG61: CData "W :ECRIRE ",0
KYSTRG62: CData "R :LIRE ",0
KYSTRG63: CData "E :EFFACER ",0
KYSTRG64: CData "APPUYER <ENTER> POUR TERMINER",0
KYSTRG65: CData "ESPACE MOT",0
KYSTRG66: CData "MODE KEYER?",0
KYSTRG67: CData "MODE ULIMATIC: U",0
KYSTRG68: CData "MODE IAMBIC A: A",0
KYSTRG69: CData "MODE IAMBIC B: B",0
KYSTRG70: CData "ENTRER DECIMALS: ",0
KYSTRG71: CData "ENTRER UNITES: ",0
KYSTRG72: CData "BLOC EEPROM ",0
KYSTRG73: CData "EFFACER MESSAGE: ",0
KYSTRG74: CData "ECRIRE MESSAGE: ",0
KYSTRG75: CData "ETES VOUS CERTAIN? OUI OU NON",0
KYSTRG76: CData "FARNSWORTH",0
KYSTRG77: CData "RETARD ESPACE LETTRE: ",0
KYSTRG78: CData "RETARD ESPACE MOT: ",0
KYSTRG79: CData "OPTION NUMEROS COURS",0
KYSTRG80: CData "AFFICHER LE NUMERO DU MESSAGE AVEC L'ENCODER HEX",0
KYSTRG81: CData "NUMERO ENCODER PREPARE: OUI OU NON",0
KYSTRG82: CData "EFFACER UN MESSAGE",0
KYSTRG83: CData "ERREUR! VALEUR ENTREE NON VALIDE",0
KYSTRG84: CData "LIRE TOUS LES TIMINGS",0
KYSTRG85: CData "LIRE TOUS LES MSG EEPROM: E",0
KYSTRG86: CData "LIRE TOUS LES MSG ROM: R",0
KYSTRG87: CData "MODE CONCOURS",0
KYSTRG88: CData "COMPENSATION POINT/TRAIT, REGLAGE ESPACE ENTRE LETTRE, REGLAGE ESPACE ENTRE MOT",0
KYSTRG89: CData "COMPENSATION POINT/TRAIT",0
KYSTRG90: CData "REGLAGE ESPACEMENT ENTRE LETTRE",0
KYSTRG91: CData "REGLAGE ESPACEMENT ENTRE MOT",0
KYSTRG92: CData "% of LTSPACE",0
KYSTRG93: CData "% of WDSPACE",0
KYSTRG94: CData "% of WPM",0
KYSTRG95: CData "DELAI ATTENTE BALISE",0
KYSTRG96: CData "RETARD TUNEON",0
KYSTRG97: CData "RETARD TUNEOFF",0
KYSTRG98: CData "REGLAGE RETARD TUNE ON/OFF",0 
KYSTRG99: CData "LIRE/ECRIRE/EFFACER LE COMPTEUR DE QSO",0
KYSTRG100: CData "COPIER LE BLOC ROM VERS LE BLOC EEPROM",0
KYSTRG101: CData "CHARGER VALEUR ESPACE FARNSWORTH",0
KYSTRG102: CData "OPTION MUTE",0
KYSTRG103: CData "MSG ESPACE ENTRE LETTRE: ",0
KYSTRG104: CData "MSG ESPACE ENTRE MOT: ",0
KYSTRG105: CData "PAUSE TUNE MAX",0 
KYSTRG106: CData "FREQUENCE DU TON",0 
$endif
ENDSIZE(KEYERSTRINGS_TABLE)
'/==============================================================================
'/##############################################################################
'/------------------------------------------------------------------------------ 
 
