'****************************************************************
'*  Name    : Amicus18_26K20.inc                                *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 24/09/2018                                        *
'*  Version : 1.0                                               *
'*  Version : 2.1 15/11/2018                                    *
'*          :                                                   *
'****************************************************************
'
$ifndef _AMICUS18_INC
$define _AMICUS18_INC
'
' Header file for use with the Amicus18 board
' Declare Xtal 3, 4, 7, 8, 10, 12, 14, 16, 19, 20, 22, 24, 25, 29, 32, 33, 40, 48, 64, 80, 88 or 100.

    Device = 18F26K20

    $if DeclareXtal = 25_000 Or DeclareXtal = 24_576
        $if PLL_ConfigFuses = On
            Declare Xtal = 100
        $else
            Declare Xtal = 25
        $endif 
    $elseif DeclareXtal = 22_000
        $if PLL_ConfigFuses = On
            Declare Xtal = 88
        $else
            Declare Xtal = 22
        $endif     
    $elseif DeclareXtal = 20_000
        $if PLL_ConfigFuses = On
            Declare Xtal = 80
        $else
            Declare Xtal = 20
        $endif     
    $elseif DeclareXtal = 16_384
        $if PLL_ConfigFuses = On
            Declare Xtal = 64
        $else
            Declare Xtal = 16
        $endif  
    $elseif DeclareXtal = 16_000
        $if PLL_ConfigFuses = On
            Declare Xtal = 64
        $else
            Declare Xtal = 16
        $endif 
    $else
        $if PLL_ConfigFuses = On
            Declare Xtal = 64
        $else
            Declare Xtal = 16
        $endif 
    $endif       
'/==============================================================================
    $ifdef __WatchDog_ON
    #define Watchdog_req 1
    $endif
    $ifdef __TestInterruptsEnabled
    #define __INTERRUPTS_ENABLED 1
    $endif
'/==============================================================================
$ifndef __ExtraPICParameters
$define __ExtraPICParameters
$if _device = _18F26K20
    $define __DEVICE_ID 257
    $define __DEVICE_NAME "PIC18F26K20"
    ' Read the Datasheet to know the erase block value.
    $ifndef _erase
    $define _erase 64
    $endif
$endif

$endif
'/==============================================================================
    Declare Optimiser_Level = 3
    Declare Dead_Code_Remove = On
'/==============================================================================
'/ Control of the RCON register.
    Dim RCONBits As Byte
    $define __RCONBitsHeader
    $define __SWDTEN_CFG 
    #ifdef Watchdog_req
    RCONBits = RCON
    Clrwdt
    WDTCONBits_SWDTEN = 1
    #else
    WDTCONBits_SWDTEN = 0    
    #endif
'/==============================================================================    
$if _xtal = 100
    $if DeclareXtal = 24_576
        $ifdef _BaudRate_115200
        'Calculated Baudrate = 115023 @ Xtal 98MHz, Error = -0,15%
        Declare Hserial_RCSTA  = 144 ' Enable continuous receive
        Declare Hserial_TXSTA  = 36  ' Enable transmit, BRGH = 1
        Declare Hserial_Clear  = On  ' Clear overflow automatically
        Declare Hserial_SPBRG  = 212 ' Baud Rate Generator Low Byte Value
        SPBRGH    = 0                ' Baud Rate Generator High Byte Value
        BAUDCON.3 = 1                ' Enable the 16 bit Baud Rate Generator
        $else
        '/ 9600 Bauds
        'Calculated Baudrate = 9600 @ Xtal 98MHz, Error = 0,00%
        Declare Hserial_RCSTA  = 144 ' Enable continuous receive
        Declare Hserial_TXSTA  = 32  ' Enable transmit, BRGH = 0
        Declare Hserial_Clear  = On  ' Clear overflow automatically
        Declare Hserial_SPBRG  = 125 ' Baud Rate Generator Low Byte Value
        SPBRGH    = 2                ' Baud Rate Generator High Byte Value
        BAUDCON.3 = 1                ' Enable the 16 bit Baud Rate Generator
        $endif
    $else
        $ifdef _BaudRate_115200
        'Calculated Baudrate = 115207 @ Xtal 100MHz, Error = 0,01%
        Declare Hserial_RCSTA  = 144 ' Enable continuous receive
        Declare Hserial_TXSTA  = 36  ' Enable transmit, BRGH = 1
        Declare Hserial_Clear  = On  ' Clear overflow automatically
        Declare Hserial_SPBRG  = 216 ' Baud Rate Generator Low Byte Value
        SPBRGH    = 0                ' Baud Rate Generator High Byte Value
        BAUDCON.3 = 1                ' Enable the 16 bit Baud Rate Generator
        $else
        '/ 9600 Bauds
        'Calculated Baudrate = 9601 @ Xtal 100MHz, Error = 0,01%
        Declare Hserial_RCSTA  = 144 ' Enable continuous receive
        Declare Hserial_TXSTA  = 32  ' Enable transmit, BRGH = 0
        Declare Hserial_Clear  = On  ' Clear overflow automatically
        Declare Hserial_SPBRG  = 138 ' Baud Rate Generator Low Byte Value
        SPBRGH    = 2                ' Baud Rate Generator High Byte Value
        BAUDCON.3 = 1                ' Enable the 16 bit Baud Rate Generator
        $endif
    $endif
'-------------------------------------------------------------------------------
$elseif _xtal = 88
    $ifdef _BaudRate_115200
    ;Calculated Baudrate = 115183 @ Xtal 88MHz, Error = -0,01%
    Declare Hserial_RCSTA  = 144 ' Enable continuous receive
    Declare Hserial_TXSTA  = 36  ' Enable transmit, BRGH = 1
    Declare Hserial_Clear  = On  ' Clear overflow automatically
    Declare Hserial_SPBRG  = 190 ' Baud Rate Generator Low Byte Value
    SPBRGH    = 0                ' Baud Rate Generator High Byte Value
    BAUDCON.3 = 1                ' Enable the 16 bit Baud Rate Generator
    $else
    '/ 9600 Bauds
    'Calculated Baudrate = 9599 @ Xtal 88MHz, Error = -0,01%
    Declare Hserial_RCSTA  = 144 ' Enable continuous receive
    Declare Hserial_TXSTA  = 32  ' Enable transmit, BRGH = 0
    Declare Hserial_Clear  = On  ' Clear overflow automatically
    Declare Hserial_SPBRG  = 60  ' Baud Rate Generator Low Byte Value
    SPBRGH    = 2                ' Baud Rate Generator High Byte Value
    BAUDCON.3 = 1                ' Enable the 16 bit Baud Rate Generator
    $endif
'-------------------------------------------------------------------------------
$elseif _xtal = 80
    $ifdef _BaudRate_115200
    'Calculated Baudrate = 114943 @ Xtal 80MHz, Error = -0,22%
    Declare Hserial_RCSTA  = 144 ' Enable continuous receive
    Declare Hserial_TXSTA  = 36  ' Enable transmit, BRGH = 1
    Declare Hserial_Clear  = On  ' Clear overflow automatically
    Declare Hserial_SPBRG  = 173 ' Baud Rate Generator Low Byte Value
    SPBRGH    = 0                ' Baud Rate Generator High Byte Value
    BAUDCON.3 = 1                ' Enable the 16 bit Baud Rate Generator
    $else
    '/ 9600 Bauds
    Declare Hserial_Baud = 9600
    Declare Hserial_TXSTA = 36   ' Enable transmit and asynchronous mode
    Declare Hserial_RCSTA = 144  ' Enable serial port and continuous receive
    Declare Hserial_Clear = On   ' Enable Error clearing on received characters    
    $endif
'-------------------------------------------------------------------------------
$elseif _xtal = 64

    $ifdef _BaudRate_115200
    '/ 115200 Bauds
    Declare Hserial_Baud = 115200
    Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
    Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
    Declare Hserial_Clear = On      ' Enable Error clearing on received characters

'    'Calculated Baudrate = 115108 @ Xtal 64MHz, Error = -0,08%
'    Declare Hserial_RCSTA  = 144 ' Enable continuous receive
'    Declare Hserial_TXSTA  = 36  ' Enable transmit, BRGH = 1
'    Declare Hserial_Clear  = On  ' Clear overflow automatically
'    Declare Hserial_SPBRG  = 138 ' Baud Rate Generator Low Byte Value
'    SPBRGH                 = 0   ' Baud Rate Generator High Byte Value
    $endif

    $ifdef _BaudRate_57600
    '/ _BaudRate_57600 Bauds
    Declare Hserial_Baud = 57600    ' Set baud rate to 57600
    Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif

    $ifdef _BaudRate_19200
    '/ 19200 Bauds
    Declare Hserial_Baud = 19200    ' Set baud rate to 19200
    Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif

    $ifdef _BaudRate_9600        
    '/ 9600 Bauds
    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
    Declare Hserial_RCSTA  = 144    ' Enable continuous receive 
    Declare Hserial_TXSTA  = 36     ' Enable transmit, BRGH = 1
    Declare Hserial_Clear  = On     ' Clear overflow automatically
    Declare Hserial_SPBRG  = 130    ' Baud Rate Generator Low Byte Value
    SPBRGH = 6                      ' Baud Rate Generator High Byte Value
    BAUDCON.3 = 1                   ' Enable the 16 bit Baud Rate Generator
    $endif

'-------------------------------------------------------------------------------
$else
'    $ifdef _BaudRate_115200
'    '/ 115200 Bauds
'    Declare Hserial_Baud = 115200
'    Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
'    Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
'    Declare Hserial_Clear = On      ' Enable Error clearing on received characters
'    $else
'    '/ 9600 Bauds
'    Declare Hserial_Baud = 9600     ' Set baud rate to 9600
'    Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
'    Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
'    Declare Hserial_Clear = On      ' Enable Error clearing on received characters
'    $endif

    $ifdef _BaudRate_115200
    '/ 115200 Bauds
    Declare Hserial_Baud = 115200
    Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
    Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
    Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif

    $ifdef _BaudRate_57600
    '/ _BaudRate_57600 Bauds
    Declare Hserial_Baud = 57600    ' Set baud rate to 57600
    Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
    
    $ifdef _BaudRate_19200
    '/ 19200 Bauds
    Declare Hserial_Baud = 19200    ' Set baud rate to 9600
    Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif

    $ifdef _BaudRate_9600
    '/ 9600 Bauds
    Declare Hserial_Baud = 9600     ' Set baud rate to 9600
    Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
$endif
'-------------------------------------------------------------------------------
Config_Start
$if PLL_ConfigFuses = On
    $ifdef _InternalOSC_
        $if (_xtal = 32) Or (_xtal = 64)
            $ifdef CLKOUT_Function
            FOSC = INTIO7	;Internal oscillator block, CLKOUT in RA6, port function on RA7.        
            $else
            FOSC = INTIO67	;Internal oscillator block, port function on RA6 and RA7.
            $endif
        $else
            $error "Error in (Declare Xtal) with internal oscillator & PLL_ConfigFuses = On"
        $endif
    $else
        $if (_xtal >= 10) And (_xtal <= 100)
        FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)(Xtal piece 2,5 -> 20 MHz)
        $else
            $error "Error in (Declare Xtal) with external Xtal & PLL_ConfigFuses = On"
        $endif
    $endif
$else
    $ifdef _InternalOSC_
        $if (_xtal = 16)
            $ifdef CLKOUT_Function
            FOSC = INTIO7	;Internal oscillator block, CLKOUT in RA6, port function on RA7.        
            $else
            FOSC = INTIO67	;Internal oscillator block, port function on RA6 and RA7.
            $endif
        $else
            $error "Error in (Declare Xtal) with internal oscillator & PLL_ConfigFuses = OFF"
        $endif
    $else
        $if (_xtal >= 10) And (_xtal <= 25)
        FOSC = HS	    ;HS oscillator PLL disabled  (medium power 4-20 MHz) (Xtal piece 10 -> 25 MHz)
        $else
            $if (_xtal > 25) And (_xtal <= 100)
                $ifdef CLKOUT_Function
                FOSC = EC       ; External EC oscillator, CLKOUT function in RA6      
                $else
                FOSC = ECIO6    ; External EC oscillator, port function on RA6
                $endif
            $else
                $error "Error in (Declare Xtal) with external Xtal & PLL_ConfigFuses = OFF"
            $endif
       $endif
    $endif
$endif
    FCMEN = OFF	    ;Fail-Safe Clock Monitor disabled
    IESO = OFF	    ;Oscillator Switchover mode disabled
    PWRT = On	    ;PWRT enabled
    BOREN = On	    ;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 18	    ;VBOR set to 1.8 V nominal
    WDTEN = OFF     ; WDT disabled (control is placed on SWDTEN bit)
'    WDTEN = ON      ; WDT is always enabled. SWDTEN Bit has no effect.
    WDTPS = 512	    ;1:512
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = OFF	;PORTB<4:0> pins are configured as digital input on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	    ;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	    ;Stack full/underflow will cause Reset
    LVP = OFF	    ;Single-Supply ICSP disabled
    XINST = OFF	    ;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	    ;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	    ;Block 0 (000800-003FFFh) not code-protected
    CP1 = OFF	    ;Block 1 (004000-007FFFh) not code-protected
    CP2 = OFF	    ;Block 2 (008000-00BFFFh) not code-protected
    CP3 = OFF	    ;Block 3 (00C000-00FFFFh) not code-protected
    CPB = OFF	    ;Boot block (000000-0007FFh) not code-protected
    CPD = On	    ;Data EEPROM code-protected
    WRT0 = OFF	;Block 0 (000800-003FFFh) not write-protected
    WRT1 = OFF	;Block 1 (004000-007FFFh) not write-protected
    WRT2 = OFF	;Block 2 (008000-00BFFFh) not write-protected
    WRT3 = OFF	;Block 3 (00C000h-00FFFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = OFF	;Boot Block (000000-0007FFh) not write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-003FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (004000-007FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (008000-00BFFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (00C000-00FFFFh) not protected from table reads executed in other blocks
    EBTRB = OFF	;Boot Block (000000-0007FFh) not protected from table reads executed in other blocks    
Config_End

    Symbol BS = 08      ' Backspace
    Symbol ESC = $1B    ' Escape
    Symbol ACK = 6
    Symbol STX = 2
    Symbol ETX = 3
    Symbol SPACE = $20

    $ifndef CR
    $define CR 13
    $endif
    $ifndef LF
    $define LF 10
    $endif

    $ifndef False
    $define False 0
    $endif
    $ifndef True
    $define True 1
    $endif
'/==============================================================================
    ANSEL = 0
    ANSELH = 0
    ADCON0 = 0
    CM1CON0 = 0
    CM2CON0 = 0
'/==============================================================================
$endif
'/==============================================================================

