'****************************************************************
'*  Name    : EA3AGV_KEYER_V11.INC                              *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2019 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 16/07/2019                                        *
'*  Version : 1.0                                               *
'*  Compiler Version: 3.7.1.9                                   *
'*  Notes   : Library for the EA3AGV_KEYER_V10,bas file         *
'*          :                                                   *
'*  Please read the <MORSE_Code.txt> file                       *
'****************************************************************
'
'  /\\\\\\\\\\\\\\\     /\\\\\\\\\        /\\\\\\\\\\      /\\\\\\\\\        /\\\\\\\\\\\\  /\\\        /\\\        
'  \/\\\///////////    /\\\\\\\\\\\\\    /\\\///////\\\   /\\\\\\\\\\\\\    /\\\//////////  \/\\\       \/\\\       
'   \/\\\              /\\\/////////\\\  \///       /\\\  /\\\/////////\\\  /\\\             \//\\\      /\\\      
'    \/\\\\\\\\\\\     \/\\\       \/\\\         /\\\//   \/\\\       \/\\\ \/\\\    /\\\\\\\  \//\\\    /\\\     
'     \/\\\///////      \/\\\\\\\\\\\\\\\        \////\\\  \/\\\\\\\\\\\\\\\ \/\\\   \/////\\\   \//\\\  /\\\    
'      \/\\\             \/\\\/////////\\\           \//\\\ \/\\\/////////\\\ \/\\\       \/\\\    \//\\\/\\\   
'       \/\\\             \/\\\        \/\\\  /\\\     /\\\  \/\\\       \/\\\ \/\\\       \/\\\     \//\\\\\  
'        \/\\\\\\\\\\\\\\\ \/\\\        \/\\\ \///\\\\\\\\\/  \/\\\       \/\\\ \//\\\\\\\\\\\\/       \//\\\ 
'         \///////////////  \///         \///    \/////////    \///        \///   \////////////          \///
'
'===============================================================================
'/ PLEASE DO NOT COPY THIS CODE FOR COMMERCIAL USE.
'===============================================================================
' This program is free software for personal use only, you can redistribute it 
' and/or modify. The code is offered as-is and the author does not take any 
' responsibility for its use. This program is distributed in the hope that it will
' be useful, but WITHOUT ANY WARRANTY. However, a mention of the author and compiler
' would be appreciated.
'
' Este programa es un software libre para uso privado, puede redistribuirlo y/o
' modificarlo. Se entrega este cdigo tal como esta y el autor NO se hace responsable
' de su utilizacin. Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador sera
' muy apreciado.

' Ce programme est un logiciel libre pour utilisation prive, vous pouvez le
' redistribuer et/ou modifier. Ce logiciel est offert tel qu'il est, et son auteur
' NE prend AUCUNE responsabilit pour son utilization. Ce programme est distribu
' dans l'espoir qu'il sera util, ' mais SANS AUCUNE GARANTIE. Cependant mentionner
' l'auteur et le compileur serait trs aprci.
'-------------------------------------------------------------------------------
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
' PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHOR OR COPYRIGHT
' HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
' OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
' SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'/==============================================================================
'/##############################################################################
'/==============================================================================
'/ CW KEYER:
$ifndef __CWKeyer
$define __CWKeyer
    GoTo __OverCWKeyer
'/==============================================================================
'* Purpose  : Declaration of all variables for CW Keyer.
'* Input    : None                                       
'* Output   : None
'/
    $if _device != _18F26K20 And _device != _18F46K20 And _core != 16
        $SendError "This PIC is not allowed for this proyect: Check all FSRs for this new PIC."
    $endif 

    $ifndef _Proteus
    $if _xtal != 64
        $SendHint "The FOSC must to be 64Mhz for this proyect. (mandatory)"
    $endif 
    $endif
        
'/ Checking some declaration pins.
    $ifndef IP_DOT
        $SendError "The IP_DOT pin output is missing"
    $endif
    $ifndef IP_DASH
        $SendError "The IP_DASH pin output is missing"
    $endif
    $ifndef CWDataPin
        $SendError "The CW Data Pin output is missing"
    $endif
    $ifndef CWToneOut
        $SendError "The CW Tone Pin output is missing"
    $endif
    $ifndef CWPTT
        $SendError "The PTT Pin output is missing"
    $endif
    $ifndef ButtonFUNCTION
        $SendError "The STOP Button Pin input is missing"
    $endif
'/------------------------------------------------------------------------------
'/ Declare the variables of the Keyer proyect.
    Dim KYCWFlags As Word System
    Dim F_CWCounter As KYCWFlags.0
    Dim F_SendTone As KYCWFlags.1
    Dim F_ClearPTT As KYCWFlags.2
    Dim F_URCALLSIGN As KYCWFlags.3
    Dim F_StartRead As KYCWFlags.4
    Dim F_SendBits As KYCWFlags.5
    Dim F_KYBeaconStart As KYCWFlags.6
    Dim F_KeyerMemoryError As KYCWFlags.7
    Dim F_SpecialChar As KYCWFlags.8
    Dim F_PTTCWAlreadySet As KYCWFlags.9
    Dim F_LongDashTime As KYCWFlags.10
    Dim F_NewPWM As KYCWFlags.11
    Dim F_PaddlesMode As KYCWFlags.12
    Dim F_EnableLongDash As KYCWFlags.13
    Dim F_RunCWPractice As KYCWFlags.14
    
    Dim KYInputFlags As Byte System
    Dim F_ButtonSTOPpressed As KYInputFlags.0  
    Dim F_ButtonCFGpressed As KYInputFlags.1 
    Dim F_SendNewMessage As KYInputFlags.2
    Dim F_ButtonQCCpressed As KYInputFlags.3
    Dim F_ButtonNRQSOpressed As KYInputFlags.4
    Dim F_ButtonRSTpressed As KYInputFlags.5
    Dim F_ButtonTUNEOOpressed As KYInputFlags.6
    Dim F_ButtonTUNEpressed As KYInputFlags.7              

    Dim CWCONFIGFlags As Word System
    Dim F_EnableTone As CWCONFIGFlags.0
    Dim F_EnableBeacon As CWCONFIGFlags.1      
    Dim F_EnablePTT As CWCONFIGFlags.2
    Dim F_DashDotRatio As CWCONFIGFlags.3
    Dim F_EnableMUTE As CWCONFIGFlags.4
    Dim F_EnableToneCopy As CWCONFIGFlags.5
    Dim F_EnablePTTCopy As CWCONFIGFlags.6
    Dim F_FarnsworthSpacing As CWCONFIGFlags.7
    Dim F_UltimaticMode As CWCONFIGFlags.8
    Dim F_IambicMode As CWCONFIGFlags.9
    Dim F_ShortNumbers As CWCONFIGFlags.10
    Dim F_EnableLoadUrCallSign As CWCONFIGFlags.11
    Dim F_WordSpacing As CWCONFIGFlags.12
    Dim F_ContestMode As CWCONFIGFlags.13                          

    Dim EncoderNumber As Byte System
    Dim KCW_WPM As Byte System
    Dim WPM_OLD As Byte System
    Dim WPM_FARNSWORTH As Byte System 
    Dim CWPTTCounter As Word System
    Dim CW_DotTime As Word System
    Dim CW_DotTimeA As Word System
    Dim CW_DashTime As Word System
    Dim CW_DotDashSpaceTime Word System
    Dim CW_LongDashTime Word 'System
    Dim CWData As Byte System
    Dim CWLoop As Byte System
    Dim CW_LetterSpaceTime As Word System
    Dim CW_LetterSpaceTrueTime As Word System
    Dim CW_WordSpaceTime As Word 'System
    Dim CW_WordSpaceTrueTime As Word 'System
    Dim WSAdjustment As Word 'System
    Dim LSAdjustment As Word 'System    
    Dim CWRecChar As Byte 'System
    Dim CW_DotFwhTime As Word
    Dim PTLetterSpaceTime As Word
    Dim PTWordSpaceTime As Word
    Dim KYTMR0LValue As Byte
    Dim KYDotDashCompensation As Byte

    Dim PaddleStates As Byte System
    Dim F_Dot_Mem As PaddleStates.0
    Dim F_Dash_Mem As PaddleStates.1
    Dim F_Dot_First As PaddleStates.2
    Dim F_Dash_First As PaddleStates.3          

    Dim TXONDelay As Word System
'    Dim TXONDelay2 As Word System    
    Dim RXONDelay As Word System
'    Dim RXONDelay2 As Word System
    Dim TuneONDelay As Word 'System
    Dim TuneOFFDelay As Word 'System
'    Dim CWWDTCounter As Dword System

    Dim ValueInput As Byte System
    Dim CWResultByte As Byte System
    Dim MacroTemp As Byte System
    Dim KYResultDWord As Dword 'System     

    Dim NbCharsPrinted As Byte 'System
    Dim PTDotTime As Word 'System
    Dim PTDashTime As Word 'System     
    Dim KYContestNumber As Word 'System
    Dim CW_Exit As Byte
    Dim CWStringDone As Byte
    Dim NBMessageToSend As Byte 'System    

    $ifdef CWToneOut
    Dim Msg_DotTimeTone As Word 'System
    Dim Msg_DashTimeTone As Word 'System
    $endif
    Dim Msg_DotTime As Word 'System
    Dim Msg_DotTimeA As Word 'System
    Dim Msg_DashTime As Word 'System
    Dim Msg_DotDashSpaceTime As Word 'System
    Dim Msg_LetterSpaceTime As Word 'System
    Dim Msg_WordSpaceTime As Word 'System
    Dim iCW_MessageSpace As Word 'System
    Dim LenCWString As Byte
    Dim CW_CharToSend As Byte
    Dim Msg_DotTimeFWH As Word
    Dim Msg_LondDashTime As Word
    Dim Msg_LondDashTimeTone As Word
    Dim Msg_LetterSpaceTrueTime As Word
    Dim Msg_WordSpaceTrueTime As Word
    Dim Msg_PTLetterSpaceTime As Word
    Dim Msg_PTWordSpaceTime As Word    

    Dim KYBeaconCounter As Dword

    $if _eeprom > 256
    Dim TableResult As Word System 
    $else
    Dim TableResult As Byte System   
    $endif

    Dim KYData As Byte
    Dim NBMacro As Byte
    $if _eeprom > 256
    Dim KYAddress As Word
    $else
    Dim KYAddress As Byte   
    $endif  

    Dim BeaconDelay As Byte
    Dim ReturnStateVar As Byte
    Dim SumDELAYS As Word
    Dim Sum2DELAYS As Word
    Dim CSWordCounter As Byte
    Dim DESpacePointer As Byte
    
    Dim CWSeedDWord As Dword
'/------------------------------------------------------------------------------
    Dim UARTBuff_Head As Byte
    Dim UARTBuff_Tail As Byte
    Dim CWDataSend As Byte

    Dim UARTFlags As Byte
    Dim F_BufferLoading        As UARTFlags.0     '/ While the buffer is loading the buffer can not be read by interrupt.
    Dim F_UARTBuffFull         As UARTFlags.1     '/ If = 1 the UART buffer is full.  
    Dim F_UARTBuffEmpty        As UARTFlags.2     '/ If = 1 the UART buffer is empty.
    Dim F_UART_Buffer_Overflow As UARTFlags.3     '/ The buffer has been overflowed.    
    Dim F_PTTUartAlreadySet    As UARTFlags.4     '/ Image of PTT function.
'/------------------------------------------------------------------------------
    Dim KYWAddress As Word
    Dim KYMyDelayWord As Word
    Dim TuneONTimeMax As Byte   
'/------------------------------------------------------------------------------
    '/ Declare Strings.
    Symbol __CW_StringLenght = 128  '/ The String array lenght must have 128 or 256 Bytes.
    Dim CW_StringSend As String * __CW_StringLenght At 0X200  '/ CW message to be sent

    Symbol __CW_UrCallSignStringLenght = 16
    Dim CW_UrCallSignString As String * __CW_UrCallSignStringLenght Heap  '/ Corresponsal call in string.

    Symbol __CW_MyCAllStringLenght = 12

    Dim CW_StringTemp  As String * 96 Heap   '/ String array for anything.
    Dim CW_String2Temp  As String * 10 Heap  '/ String array for anything.    
'/------------------------------------------------------------------------------
    '/ Another Constants.
    Symbol CstNbROMBlockMax = 20   '/ 20 x 5 messages ROM block = 100 messages.
    Symbol CstNbE2PBlockMax = 3    '/ 3 x 5 messages Eeprom block = 15 messages + 1
    Symbol CstNbMsgPerBlockMax = 5 '/ 2 x 5 messages Eeprom block.    
    Symbol CstNbWPMFarnworthMax = 32
    Symbol CstWPMmin = 8
    Symbol CstTuneONTimeMax = 127    '/ (31, 63, 127, 255) Time Max(seconds) to Tune the Transmitter.
'/==============================================================================
'/ Writing some preprocessor macros.
    $define KYTimer2ON() T2CONBits_TMR2ON = 1

    $define KYTimer2OFF() T2CONBits_TMR2ON = 0

    $define KYClearTimer2Flag() PIR1Bits_TMR2IF = 0   

    $define KYTimer2Flag PIR1Bits_TMR2IF     

    $define KYInt0Flag INTCONBits_INT0IF

    $define KYInt1Flag INTCON3Bits_INT1IF
    
    $define KYInt2Flag INTCON3Bits_INT2IF    
    
    $define KYClearTone() CWToneOut = 0

'/##############################################################################
'/ KEYER EEPROM:
'    '/ Declare some parameters to control the keyer & Beacon in the eeprom.
    Symbol __CW_MSGLenght0 = 32      '/ Lenght of MSG1.
    Symbol __CW_MSGLenght1 = 32      '/ Lenght of MSG2.
    Symbol __CW_MSGLenght2 = 32      '/ Lenght of MSG3.
    Symbol __CW_MSGLenght3 = 32      '/ Lenght of MSG4.    
    Symbol __CW_MSGLenght4 = 32      '/ Lenght of MSG5.
    Symbol __CW_MSGLenght5 = 64      '/ Lenght of MSG6.    
    Symbol __CW_MSGLenght6 = 64      '/ Lenght of MSG7.
    Symbol __CW_MSGLenght7 = 64      '/ Lenght of MSG8.
    Symbol __CW_MSGLenght8 = 64      '/ Lenght of MSG9.
    Symbol __CW_MSGLenght9 = 64      '/ Lenght of MSG10.    
    Symbol __CW_MSGLenght10 = 64     '/ Lenght of MSG11.            
    Symbol __CW_MSGLenght11 = 64     '/ Lenght of MSG12.
    Symbol __CW_MSGLenght12 = 64     '/ Lenght of MSG13.
    Symbol __CW_MSGLenght13 = 64     '/ Lenght of MSG14.
    Symbol __CW_MSGLenght14 = 64     '/ Lenght of MSG15.    
    Symbol __CW_MSGLenght15 = 64     '/ Lenght of MSG16.    

    '/ Define the number of messages according to the lenght of the eeprom memory.
    Symbol __CW_NumberMSGmax = 16    
    Symbol __CW_NumberE2PBlocksmax = 3  '/ For PIC18F26K20       

    Symbol EEPCW_INIT = 0               '/ Byte
    Symbol EEPCW_CONFIG = 1             '/ Word
    Symbol EEPCW_WPM = 3                '/ Byte
    Symbol EEPCW_TXONDELAY = 4          '/ Byte
    Symbol EEPCW_RXONDELAY = 5          '/ Byte
    Symbol EEPCW_TUNEONOFFDELAY = 6     '/ Byte   
    Symbol EEPCW_TUNETIMEOUT_ADJUSTMENT = 7 '/ Byte
    Symbol EEPCW_DOTDASH_ADJUSTMENT = 8  '/ Byte
    Symbol EEPCW_WDSPACE_ADJUSTMENT = 9  '/ Byte
    Symbol EEPCW_LTSPACE_ADJUSTMENT = 10 '/ Byte
    Symbol EEPCW_FARNSWORTHSP = 11       '/ Byte
    Symbol EEPCW_BEACONDELAY_ADJUSTMENT = 12    '/ Byte
    Symbol EEPCW_TONEFREQUENCY_INDEX = 13  '/ Byte
    Symbol EEPCW_CONTESTCOUNTER = 14    '/ Word (Not used)
    
    Symbol EEPCW_MYCALL = 16        '/ 10 Bytes
    Symbol EEPCW_QTH = 27           '/ 16 Bytes
    Symbol EEPCW_QTHLOC = 44        '/ 7  Bytes
    Symbol EEPCW_NAME = 52          '/ 12 Bytes
    Symbol EEPCW_RIG = 65           '/ 18 Bytes
    Symbol EEPCW_PWR = 84           '/ 4 Bytes
    Symbol EEPCW_ANT = 89           '/ 14 Bytes

    '/ EEPROM Block0    
    Symbol EEPCW_MSG0 = 104         '/ 32 Bytes
    Symbol EEPCW_MSG1 = 137         '/ 32 Bytes  
    Symbol EEPCW_MSG2 = 170         '/ 32 Bytes
    Symbol EEPCW_MSG3 = 203         '/ 32 Bytes
    Symbol EEPCW_MSG4 = 236         '/ 32 Bytes (final 255)
    '/ EEPROM Block1
    Symbol EEPCW_MSG5 = 269         '/ 64 Bytes        
    Symbol EEPCW_MSG6 = 334         '/ 64 Bytes   
    Symbol EEPCW_MSG7 = 399         '/ 64 Bytes  
    Symbol EEPCW_MSG8 = 464         '/ 64 Bytes     
    Symbol EEPCW_MSG9 = 529         '/ 64 Bytes     
    '/ EEPROM Block2
    Symbol EEPCW_MSG10 = 594        '/ 64 Bytes  
    Symbol EEPCW_MSG11 = 659        '/ 64 Bytes      
    Symbol EEPCW_MSG12 = 724        '/ 64 Bytes
    Symbol EEPCW_MSG13 = 789        '/ 64 Bytes
    Symbol EEPCW_MSG14 = 854        '/ 64 Bytes    
    '/ EEPROM Block3
    Symbol EEPCW_MSG15 = 919        '/ 64 Bytes Last address 983
'/------------------------------------------------------------------------------    
'/ Address of Messages in EEPROM.
    $define MSG0 EEPCW_MSG0     ;/ 32 Bytes
    $define MSG1 EEPCW_MSG1     ;/ 32 Bytes  
    $define MSG2 EEPCW_MSG2     ;/ 32 Bytes
    $define MSG3 EEPCW_MSG3     ;/ 32 Bytes
    $define MSG4 EEPCW_MSG4     ;/ 32 Bytes
    $define MSG5 EEPCW_MSG5     ;/ 64 Bytes        
    $define MSG6 EEPCW_MSG6     ;/ 64 Bytes   
    $define MSG7 EEPCW_MSG7     ;/ 64 Bytes
    $define MSG8 EEPCW_MSG8     ;/ 64 Bytes
    $define MSG9 EEPCW_MSG9     ;/ 64 Bytes
    $define MSG10 EEPCW_MSG10   ;/ 64 Bytes
    $define MSG11 EEPCW_MSG11   ;/ 64 Bytes
    $define MSG12 EEPCW_MSG12   ;/ 64 Bytes
    $define MSG13 EEPCW_MSG13   ;/ 64 Bytes
    $define MSG14 EEPCW_MSG14   ;/ 64 Bytes    
    $define MSG15 EEPCW_MSG15   ;/ 64 Bytes

    '/ Declare some MACROS (insert this code into the Strings).
    $define ETX0 "\00"  ;/ Final of String in eeprom messages.  (loaded manually) 
    $define STX0 "\02"  ;/ => %,PTT1       ([KA], PTT ON, Start of message) (NOT used) 
    $define EOT1 "\03"  ;/ => #,SP,K,PTT0  ([AR], K, PTT OFF + RXON Delay, End of message) 
    $define EOT2 "\04"  ;/ => K,PTT0       ([K], PTT OFF + RXON Delay, End of message)
    $define EOT3 "\05"  ;/ => &,PTT0       ([KN], PTT OFF + RXON Delay, Go only, invite a specific station To transmit) 
    $define EOT4 "\06"  ;/ => <,PTT0       ([BK], PTT OFF + RXON Delay, Invite receiving station To transmit  
    $define EOT5 "\07"  ;/ => ^,SP,E,SP,E,PTT0   ([SK], SP, E, SP, E, PTT OFF + RXON Delay, Caret End of contact (sent before Call)
    $define EOT6 "\08"  ;/ => ^,SP,PTT0          ([SK], SP, PTT OFF + RXON Delay, Caret End of contact (sent before Call) 
    $define EOT7 "\09"  ;/ => #,SP,PSE,SP,K,PTT0 ([AR], SP, PSE, SP, K, PTT OFF + RXON Delay, End of message)
    $define EOT8 "\10"  ;/ => PSE,SP,K,PTT0      ([K], PSE,SP,K End of Transmision. "K")
    $define PTT0 "["    ;/ => PTT OFF + RXDelay  ([]], (91) PTT OFF + RXON Delay
'/------------------------------------------------------------------------------
    $define vETX0 0  ;/ Final of String in eeprom messages.  (loaded manually) 
    $define vSTX0 2  ;/ => %,PTT1       ([KA], PTT ON, Start of message) (NOT used)  
    $define vEOT1 3  ;/ => #,SP,K,PTT0  ([AR], K, PTT OFF + RXON Delay, End of message)   
    $define vEOT2 4  ;/ => K,PTT0       ([K], PTT OFF + RXON Delay, End of message)   
    $define vEOT3 5  ;/ => &,PTT0       ([KN], PTT OFF + RXON Delay, Go only, invite a specific station To transmit)   
    $define vEOT4 6  ;/ => <,PTT0             ([Bk], PTT OFF + RXON Delay, Invite receiving station To transmit    
    $define vEOT5 7  ;/ => ^,SP,E,SP,E,PTT0   ([SK], SP, E, SP, E, PTT OFF + RXON Delay, Caret End of contact (sent before Call)
    $define vEOT6 8  ;/ => ^,SP,PTT0          ([SK], SP, PTT OFF + RXON Delay, Caret End of contact (sent before Call) 
    $define vEOT7 9  ;/ => #,SP,PSE,SP,K,PTT0 ([AR], SP, PSE, SP, K, PTT OFF + RXON Delay, End of message)
    $define vEOT8 10 ;/ => PSE,SP,K,PTT0      ([K], PSE,SP,K End of Transmision. "K")
'/------------------------------------------------------------------------------
'    ETX0 "\00"   '/ Final of String in eeprom messages.  (loaded manually)
'    STX0 "\02" => %,PTT1             ([KA], PTT On, Start of message) (NOT used)
'    EOT1 "\03" => #,SP,K,PTT0        ([AR], K, PTT OFF + RXON Delay, End of message)     
'    EOT2 "\04" => K,PTT0             ([K], PTT OFF + RXON Delay, End of message) 
'    EOT3 "\05" => &,PTT0             ([KN], PTT OFF + RXON Delay, Go only, invite a specific station To transmit)            
'    EOT4 "\06" => <,PTT0             ([Bk], PTT OFF + RXON Delay, Invite receiving station To transmit  
'    EOT5 "\07" => ^,SP,E,SP,E,PTT0   ([SK], SP, E, SP, E, PTT OFF + RXON Delay, Caret End of contact (sent before Call)                         
'    EOT6 "\08" => ^,SP,PTT0          ([SK], SP, PTT OFF + RXON Delay, Caret End of contact (sent before Call) 
'    EOT7 "\09" => #,SP,PSE,SP,K,PTT0 ([AR], SP, PSE, SP, K, PTT OFF + RXON Delay, End of message)
'    EOT8 "\10" => PSE,SP,K,PTT0      ([K], PSE,SP,K End of Transmision. "K")
'    PTT0 "["   => PTT OFF + RXDelay  ([[],  PTT OFF + RXON Delay

'    NMSG1    "\17" '/ Send the next message in the list.
'    NMSG2    "\18" '/ Send the next second message in the list.
'    NMSG3    "\19" '/ Send the next third message in the list.
'    URCALL1  "\20" '/ Load corresponsal call in string to place first in the message to send.
'    URCALL2  "\21" '/ Load corresponsal call in string to place at the end of the message.
'    MYCALL   "\22" '/ Load MY CALL the CW_StringSend string array. (10 Bytes)    
'    YXX      "\23" '/ The macro <YXX> only increments & place the new contest number to the CW_StringSend string array..
'    XXX      "\24" '/ When playing this message, the keyer replaces the <XXX> by the current contest number.  
'    QTH      "\25" '/ Insert QTH (string) (16 Bytes)
'    LOC      "\26" '/ Insert QTH LOCATOR 6 characters string (7 bytes) 
'    MYNAME   "\27" '/ Insert MY NAME 11 characters String (12 Bytes)
'    MYRIG    "\28" '/ Insert MY RIG 17 characters String (18 Bytes)
'    MYANT    "\29" '/ Insert MY ANT 13 characters String (14 Bytes)
'    PWR      "\30" '/ Insert the RIG Power (4 Bytes)
'    SNUM     "\31" '/ Set to send Short Numbers for Contest Number.
'    CNUM     "\32" '/ Clear to send Short Numbers for Contest Number.
'    BEACON   "\33" '/ Macro to send the same Message forever with 5 seconds interval.
'    COPTXT   "\34" '/ Copy the last characters from CW string to the same string. (Repeat CQ)
'    CLURCALL "\35" '/ Clear all the URCALL parameters.
'    NOMSG    "\36" '/ "NO MESSAGE IN THIS MEMORY"
'    RST      "\37" ;/ Load the RST values from the 3 Decimal encoders. Send twice.
'    RSTS     "\38" ;/ Load the RST Short values from the 3 Decimal encoders. Send once.
'    HCUAGN   "\39" ;/ (HPE CUAGN) text. Macro because to save bytes in eeprom memory.
'    QSLB     "\40" ;/ (QSL VIA BURO)  text. Macro because To Save bytes in eeprom memory.
'    S7373    "\41" ;/ ( 73 73) text. Macro because to save bytes in eeprom memory.
'/------------------------------------------------------------------------------
'/ Macros in ASCII format.
    $define NMSG1    "\17" ;/ Send the next message in the list.
    $define NMSG2    "\18" ;/ Send the next second message in the list.
    $define NMSG3    "\19" ;/ Send the next third message in the list.
    $define URCALL1  "\20" ;/ Load corresponsal call in string to place first in the message to send.
    $define URCALL2  "\21" ;/ Load corresponsal call in string to place at the end of the message.
    $define MYCALL   "\22" ;/ Load MY CALL in string.    
    $define YXX      "\23" ;/ The macro <YXX> increments & sends the new contest number.
    $define XXX      "\24" ;/ The Macro <XXX> sends the current contest number.  
    $define MYQTH    "\25" ;/ MYQTH (string)
    $define MYLOC    "\26" ;/ MYQTH LOCATOR 6 characters string 
    $define MYNAME   "\27" ;/ MY NAME 11 characters String 
    $define MYRIG    "\28" ;/ MY RIG 11 characters String
    $define MYANT    "\29" ;/ MY ANT 11 characters String
    $define PWR      "\30" ;/ Insert the RIG Power String 
    $define SNUM     "\31" ;/ Set the Short Numbers Flag for Contest Number.
    $define CNUM     "\32" ;/ Clear the Short Numbers Flag for Contest Number.
    $define BEACON   "\33" ;/ Macro to send the same Message forever with 5 seconds stop.
    $define COPTXT   "\34" ;/ Copy the last characters from CW string to the same string.
    $define CLURCALL "\35" ;/ Clear all the URCALL parameters.
    $define NOMSG    "\36" ;/ "NO MESSAGE IN THIS MEMORY"
    $define RST      "\37" ;/ Load the RST values from the 3 Decimal encoders. Send twice.
    $define RSTS     "\38" ;/ Load the RST Short values from the 3 Decimal encoders. Send once.
    $define HCUAGN   "\39" ;/ (HPE CUAGN) text. Macro because to save bytes in eeprom memory.
    $define QSLB     "\40" ;/ (QSL VIA BURO)  text. Macro because To Save bytes in eeprom memory.
    $define S7373    "\41" ;/ ( 73 73) text. Macro because to save bytes in eeprom memory.

    '/ Macros to Insert the MSGX.
    $define IMSG0 "\51"
    $define IMSG1 "\52"  
    $define IMSG2 "\53"
    $define IMSG3 "\54"    
    $define IMSG4 "\55"
    $define IMSG5 "\56"    
    $define IMSG6 "\57"
    $define IMSG7 "\58"
    $define IMSG8 "\59"
    $define IMSG9 "\60"    
    $define IMSG10 "\61"
    $define IMSG11 "\62"   
    $define IMSG12 "\63"
    $define IMSG13 "\64"
    $define IMSG14 "\65"
    $define IMSG15 "\66"  
    
'/ Macros in Decimal Number format.
    $define vNMSG1    17  ;/ Send the next message in the list.
    $define vNMSG2    18  ;/ Send the next second message in the list.
    $define vNMSG3    19  ;/ Send the next third message in the list.
    $define vURCALL1  20  ;/ Load corresponsal call in string to place first in the message to send.
    $define vURCALL2  21  ;/ Load corresponsal call in string to place at the end of the message.
    $define vMYCALL   22  ;/ Load MY CALL in string.    
    $define vYXX      23  ;/ The macro <YXX> only increments & place the new contest number.
    $define vXXX      24  ;/ When playing this message, the keyer replaces the <XXX> by the current contest number.  
    $define vQTH      25  ;/ MYQTH (string)
    $define vLOC      26  ;/ MYQTH LOCATOR 6 characters string  (No more than value 31) 
    $define vMYNAME   27  ;/ MY NAME 11 characters String 
    $define vMYRIG    28  ;/ MY RIG 11 characters String
    $define vMYANT    29  ;/ MY ANT 11 characters String
    $define vPWR      30  ;/ Insert the RIG Power
    $define vSNUM     31  ;/ Set to send Short Numbers for Contest Number.
    $define vCNUM     32  ;/ Clear to send Short Numbers for Contest Number.
    $define vBEACON   33  ;/ Macro to send Message 1 forever with 5 seconds stop.
    $define vCOPTXT   34  ;/ Copy the last characters from string to the same string.       
    $define vCLURCALL 35  ;/ Clear all the URCALL parameters.
    $define vNOMSG    36  ;/ "NO MESSAGE IN THIS MEMORY"
    $define vRST      37  ;/ Load the RST values from the 3 Decimal encoders. Send twice.
    $define vRSTS     38  ;/ Load the RST Short values from the 3 Decimal encoders. Send once.
    $define vHCUAGN   39  ;/ (HPE CUAGN) text. Macro because to save bytes in eeprom memory.
    $define vQSLB     40  ;/ (QSL VIA BURO)  text. Macro because To Save bytes in eeprom memory.
    $define vS7373    41  ;/ ( 73 73) text. Macro because to save bytes in eeprom memory.

    '/ Insert the MSGX.
    $define vIMSG0 51   
    $define vIMSG1 52
    $define vIMSG2 53
    $define vIMSG3 54    
    $define vIMSG4 55
    $define vIMSG5 56   
    $define vIMSG6 57
    $define vIMSG7 58
    $define vIMSG8 59
    $define vIMSG9 60   
    $define vIMSG10 61
    $define vIMSG11 62   
    $define vIMSG12 63
    $define vIMSG13 64
    $define vIMSG14 65
    $define vIMSG15 66      
          
'/==============================================================================
'/  See definitions below for some examples how CW letters are stored in memory.
'/
Symbol CW_0 = %00111111   ' "0" (-----)
Symbol CW_1 = %00101111   ' "1" (----)
Symbol CW_2 = %00100111   ' "2" (---)
Symbol CW_3 = %00100011   ' "3" (--)
Symbol CW_4 = %00100001   ' "4" (-)
Symbol CW_5 = %00100000   ' "5" ()
Symbol CW_6 = %00110000   ' "6" (-)
Symbol CW_7 = %00111000   ' "7" (--)
Symbol CW_8 = %00111100   ' "8" (---)
Symbol CW_9 = %00111110   ' "9" (----)
 
Symbol CW_A = %00000101   ' 'A' (-)
Symbol CW_B = %00011000   ' 'B' (-)
Symbol CW_C = %00011010   ' 'C' (--)
Symbol CW_D = %00001100   ' 'D' (-)
Symbol CW_E = %00000010   ' 'E' ()
Symbol CW_F = %00010010   ' 'F' (-)
Symbol CW_G = %00001110   ' 'G' (--)
Symbol CW_H = %00010000   ' 'H' ()
Symbol CW_I = %00000100   ' 'I' ()
Symbol CW_J = %00010111   ' 'J' (---)
Symbol CW_K = %00001101   ' 'K' (--)
Symbol CW_L = %00010100   ' 'L' (-)
Symbol CW_M = %00000111   ' 'M' (--)
Symbol CW_N = %00000110   ' 'N' (-)
Symbol CW_O = %00001111   ' 'O' (---)
Symbol CW_P = %00010110   ' 'P' (--)
Symbol CW_Q = %00011101   ' 'Q' (---)
Symbol CW_R = %00001010   ' 'R' (-)
Symbol CW_S = %00001000   ' 'S' ()
Symbol CW_T = %00000011   ' 'T' (-)
Symbol CW_U = %00001001   ' 'U' (-)
Symbol CW_V = %00010001   ' 'V' (-)
Symbol CW_W = %00001011   ' 'W' (--)
Symbol CW_X = %00011001   ' 'X' (--)
Symbol CW_Y = %00011011   ' 'Y' (---)
Symbol CW_Z = %00011100   ' 'Z' (--)
'/ End of ASCII characters.

'/ Short numbers.
Symbol CW_SHORT5 = %00001000  '/ Short 5' ()  [S]
Symbol CW_SHORT7 = %00011000  '/ Short 7' (-) [B]
Symbol CW_SHORT8 = %00001100  '/ Short 8' (-)  [D]
Symbol CW_SHORT9 = %00000110  '/ Short 9' (-)   [N]
Symbol CW_SHORT0 = %00000011  '/ Short 0' (-)    [Long T]

'/ Special characters.
Symbol CW_EXCMARK = %01101011  '/ [!]   (----)  ! Exclamation MARK 
Symbol CW_SPACE   = %01000011  '/ [SP]  (--)  SPACE 
Symbol CW_RPT     = %01001111  '/ [RP]  (----)  Repeat the last word.
Symbol CW_RPT2    = %01000111  '/ [RP2] (---)  Repeat twice the last Word.
Symbol CW_SEPAR   = %00110001  '/ [=]   (--)   = Double Dash, Pause Or Break [=] "official" separator 
Symbol CW_SEPA2   = %01100001  '/ [-]   (--)  - but this is also frequenty used. Hyphen Or Dash
Symbol CW_DOT     = %01010101  '/ [.]   (---)  . DOT or Period 
Symbol CW_COMMA   = %01110011  '/ [,]   (----)  , COMMA 
Symbol CW_FSLASH  = %00110010  '/ [/]   (--)   / FORWARD SLASH 
Symbol CW_QMARK   = %01001100  '/ [?]   (--)  ? QESTION MARCK 
Symbol CW_PLUS    = %00101010  '/ [+]   (--)   + PLUS End of Message Or Cross [+] error modificar 
Symbol CW_DQUOTE  = %01010010  '/ ["]   (--)  " DOBLE QUOTE  (Quotation marks)
Symbol CW_SQUOTE  = %01011110  '/ [']   (----)  ' SINGLE QUOTE (Apostrophe) 
Symbol CW_UNSCORE = %01001101  '/ [_]   (---)  _ UNDERSCORE, Underline 
Symbol CW_DOLLAR  = %10001001  '/ [$]   (--) $ DOLLAR 
Symbol CW_OPAREN  = %00110110  '/ [(]   (---)   ( OPEN PARENTHESIS 
Symbol CW_CPAREN  = %01101101  '/ [)]   (----)  ) CLOSE PARENTHESIS
Symbol CW_COLON   = %01111000  '/ [:]   (---)  : COLON
Symbol CW_SCOLON  = %01101010  '/ [;]   (---)  ; SEMI COLON
Symbol CW_WARNING = %00101001  '/ [ ]   (--)   (96) WARNING (NO SYMBOL)
Symbol CW_ATSYMB  = %01011010  '/ [@]   (---)  @ AT SYMBOL
Symbol CW_BSLASH  = %01011110  '/ [\]   (----)  \ BACK SLASH
Symbol CW_EOM     = %01011111  '/ [EOM] (-----)  | used for "partitions" of msg
                                                     
'/ Special commands. (Prosigns) more used.
Symbol CW_AR  = %00101010   '/ [AR]  (--)    [#] End of message
Symbol CW_AS  = %00101000   '/ [AS]  (-)    [*] Asterisk Standby (Wait)
Symbol CW_BK  = %11000101   '/ [BK]  (---)  [<] Invite receiving station To transmit
Symbol CW_BT  = %00110001   '/ [BT]  (--)    [=] Double Dash, Pause Or Break [=] "official" separator
Symbol CW_KA  = %00110101   '/ [KA]  (---)    [%] Beginning of message, Starting Signal
Symbol CW_KN  = %00110110   '/ [KN]  (---)    [&] Go only, invite a specific station To transmit
Symbol CW_SK  = %01000101   '/ [SK]  (--)   [^] Caret End of contact (sent before Call)
Symbol CW_VE  = %00100010   '/ [VE]  (-)    [>] Understood (VE) 
Symbol CW_AA  = %00010101   '/ [AA]  (--)     []] New line 
Symbol CW_AL  = %01010100   '/ [AL]  (--)   [ ] Paragraph (NO Symbol)

'/ Special commands. Used??
Symbol CW_CL  = %00000000   '/ [CL]  (---) [ ] Going off the air. "Clear" (NO Symbol too much bits) (NO Symbol) 
Symbol CW_CT  = %00110101   '/ [CT]  (---)    [ ] Start copying (NO Symbol)


'    '/ With LookUp Table, all CW characters have the same delay.
'    '/                                 ! (33)   " (34)   #(35) $ (36)
'    CW_CharToSend = LookUp CWData,[CW_EXCMARK,CW_DQUOTE,CW_AR,CW_DOLLAR,_
'    '/ %    &      '         (         )        *     +        ,        -
'    CW_KA,CW_KN,CW_SQUOTE,CW_OPAREN,CW_CPAREN,CW_AS,CW_PLUS,CW_COMMA,CW_SEPA2,_
'    '/ .      /        0    1    2    3    4    5    6    7    8    9    :
'    CW_DOT,CW_FSLASH,CW_0,CW_1,CW_2,CW_3,CW_4,CW_5,CW_6,CW_7,CW_8,CW_9,CW_COLON,_
'    '/ ;        <      =       >      ?        @ (64)   A    B    C    D    E    F    G
'    CW_SCOLON,CW_BK,CW_SEPAR,CW_VE,CW_QMARK,CW_ATSYMB,CW_A,CW_B,CW_C,CW_D,CW_E,CW_F,CW_G,_
'    '/ H   I    J    K    L    M    N    O    P    Q    R    S    T    U
'    CW_H,CW_I,CW_J,CW_K,CW_L,CW_M,CW_N,CW_O,CW_P,CW_Q,CW_R,CW_S,CW_T,CW_U,_
'    '/ V   W    X    Y    Z   [(91)  \(92)    ](93)  ^     _(95)
'    CW_V,CW_W,CW_X,CW_Y,CW_Z,CW_AL,CW_BSLASH,CW_AA,CW_SK,CW_UNSCORE]

'/==============================================================================
(*
PROSIGNS FOR MORSE CODE:
Prosigns are symbols formed by running together two characters into one
(without the intercharacter space) to make an abbreviation for the most common procedural signals.

    AR ----- End of message
    AS ----- Stand by
    BK ----- Invite receiving station to transmit
    BT ----- Pause; Break For Text
    KA ----- Beginning of message
    KN ----- end of transmission. Go only, invite a specific station to transmit
    CL ----- Going off the air (clear) (Too long For 1 Byte)
    CQ ----- Calling any amateur radio station (Too long for 1 byte)
    K ------ Go, invite any station to transmit
    R ------ All received OK
    SK ----- End of contact (sent before call)
    VE ----- Understood [VE] [SN] 
*)
'/##############################################################################
'/==============================================================================
'* Purpose  : Dead Operator Watchdog delay To go Sleep without operation (nn= 04 To 22 seconds)
'* Input    : None                                       
'* Output   : None
'/
    $if _xtal = 16
    '/ Xtal 16Mhz NO PLL => 20mS, Timer1 => 4000000-1 X 8 X 65536 = 0,131072       
    Symbol Cst_WDTCount = 7629 
    $endif                               
    $if _xtal = 20
    '/ Xtal 20Mhz NO PLL => 20mS, Timer1 => 5000000-1 X 8 X 65536 = 0,104856        
    Symbol Cst_WDTCount = 9536
    $endif
    $if _xtal = 25    
    '/ Xtal 25Mhz NO PLL => 20mS, Timer1 => 6250000-1 X 8 X 65536 = 0,083886       
    Symbol Cst_WDTCount = 11920
    $endif
    $if _xtal = 64
    '/ Xtal 16Mhz + PLL => 20mS, Timer1 => 16000000-1 X 8 X 65536 = 0,032768        
    Symbol Cst_WDTCount = 30517
    $endif
    $if _xtal = 80
    '/ Xtal 20Mhz + PLL => 20mS, Timer1 => 20000000-1 X 8 X 65536 = 0,026214        
    Symbol Cst_WDTCount = 38147    
    $endif                
    $if _xtal = 100
    '/ Xtal 25Mhz + PLL => 20mS, Timer1 => 25000000-1 X 8 X 65536 = 0,020972
    Symbol Cst_WDTCount = 47682    
    $endif 
'/==============================================================================
'* Purpose  : TUNE ON Delays Table.
'* Input    : None                                       
'* Output   : [5,10,15,20,25,30,35,40,45,50] X 100mSec
'/
$define TuneONOFFDelayTable(pValue) _mTuneONOFFDelayTable pValue

_mTuneONOFFDelayTable Macro- pValue
STARTSIZE(TuneONOFFDelay_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mTuneONOFFDelayTable macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mTuneONOFFDelayTable macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,MacroTemp
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,MacroTemp
            #endif
        #endif
    #endif
    GoSub TuneONOFFDelayTable_Sub
    #if (_mTuneONOFFDelayTable_RETURN != 1)
        #error "_mTuneONOFFDelayTable - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mTuneONOFFDelayTable - Return variable should be a Byte variable"
            Exitm
        #else
            Byte_Byte PRODH,Return_Var
        #endif
    #endif    
ENDSIZE(TuneONOFFDelay_MACRO)
Endm

#ifMacro- _mTuneONOFFDelayTable
TuneONOFFDelayTable_Sub: 
STARTSIZE(TuneONOFFDelay_LIB)
    PRODH = ERead EEPCW_TUNEONOFFDELAY     '/ Current value in case of error.
    If MacroTemp > 47 Then 
        If MacroTemp < 58 Then 
            WREG = MacroTemp - 48
            PRODH = LookUp WREG,[5,10,15,20,25,30,35,40,45,50]
        EndIf
    EndIf  
    Return
ENDSIZE(TuneONOFFDelay_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------
$define CalcTuneONDelay(pValue) _mCalcTuneONDelay pValue

_mCalcTuneONDelay Macro- pValue
STARTSIZE(TuneONDelay_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mCalcTuneONDelay macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mCalcTuneONDelay macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Wreg pValue
            #endif
            #if (Prm_1 == Byte)
            Byte_Wreg pValue
            #endif
        #endif
    #endif
    GoSub CalcTuneONDelay_Sub
Endm

#ifMacro- _mCalcTuneONDelay
CalcTuneONDelay_Sub:
    TuneONDelay = WREG * 100            '/ Result in mS
    Return
#endIfMacro-
'/------------------------------------------------------------------------------
$define CalcTuneOFFDelay(pValue) _mCalcTuneOFFDelay pValue

_mCalcTuneOFFDelay Macro- pValue
STARTSIZE(CalcTuneOFFDelay_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mCalcTuneOFFDelay macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mCalcTuneOFFDelay macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Wreg pValue
            #endif
            #if (Prm_1 == Byte)
            Byte_Wreg pValue
            #endif
        #endif
    #endif
    GoSub CalcDelayTuneOFF_Sub
ENDSIZE(CalcTuneOFFDelay_MACRO)
Endm

#ifMacro- _mCalcTuneOFFDelay
STARTSIZE(CalcTuneOFFDelay_LIB)
CalcDelayTuneOFF_Sub:
    TuneOFFDelay = WREG * 100            '/ Result in mS
    Return
ENDSIZE(CalcTuneOFFDelay_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose : Insert the Callsign into the CW_StringSend Buffer..
'* Input   : none                                       
'* Output  : Data Port bit.
'* Note    : 
'/
'$define KYInsertCallSIgn() _mKYInsertCallSIgn

'_mKYInsertCallSIgn Macro-
'    GoSub KYInsertCallSign_Sub
'Endm

'#ifMacro- _mKYInsertCallSIgn
'KYInsertCallSign_Sub: 
'STARTSIZE(KYInsertCallSIgn_LIB)
'    Do
'        #ifdef Watchdog_req
'        Clrwdt
'        #endif
'        If INDF2 > 0 Then            '/ Using FSR2 for UR CALL SIGN.
'            POSTINC1 = POSTINC2
'        Else
'            Return           '/ Exit this loop.
'        EndIf
'    Loop
'ENDSIZE(KYInsertCallSIgn_LIB)
'#endIfMacro-
'/==============================================================================
'* Purpose : Calculation of all timing of Keyer.
'* Input   : WPM value                                       
'* Output  : None
'* Note    : Morse Rules: 
'/   KCW_DotTime (mS) = 1200 / CW_WPM
'/   KCW_DashTime (mS) = 3600 / CW_WPM
(*
    If you send PARIS 5 times in a minute (5WPM) you have sent 250
    elements (using correct spacing). 250 elements into 60 seconds
    per minute = 240 milliseconds per element.
    13 words-per-minute is one element every 92.31 milliseconds.
    The Farnsworth method sends the dits and dahs and intracharacter
    spacing at a higher speed, then increasing the intercharacter
    and inter-word spacing to slow the sending speed down
    to the overall speed. 
    For example, to send at 5 wpm with 13 wpm characters in Farnsworth method,
    the dits and intra-character
    spacing would be 92.3 milliseconds, the dah would be 276.9
    milliseconds, the inter-character spacing would be 1.443 seconds
    and inter-word spacing would be 3.367 seconds.
    T = 1200 / W
    W = Words per minute.
    T is one dit-time in milliseconds
*)
'/ The Timer2 is used for this timing.
'/ The Timer2 frequency is 10 000Hz for better acuaracy.
'/------------------------------------------------------------------------------
'/ Calculate the values of Keyer timings.
$define KYCW_Timings() _mKYCW_Timings 

_mKYCW_Timings Macro- 
    GoSub KYCW_Timings_Sub
Endm
(*
#ifMacro- _mKYCW_Timings 
KYCW_Timings_Sub:
STARTSIZE(CfgCWTiming_CODE)
    '/ Dinamic Parameters for the Keyer.
    '/ The timer2 is counting every 830uS.
    '/--------------------------------------------------------------------------
    '/ Calculate Dot & Dash Time
'    CW_DotTime = 1452 / KCW_WPM     '/ 1 Dot time in MS. (Timer2 1202Hz = 830uS)
    CW_DotTimeA = 1451 / KCW_WPM    '/ Standard DotTime For CW Paddles. (Timer2 1202Hz = 830uS)
    '/-------------------------------------------------------------------------- 
    '/ Dot/Dash compensation
    ValueInput = ERead EEPCW_DOTDASH_ADJUSTMENT '/ Return: (0 to 31mS)
    ValueInput = (ValueInput * 121) / 100       '/ Because for Paddles timings.
    If ValueInput > 0 Then
        CW_DotTime = CW_DotTimeA + ValueInput
    Else
        CW_DotTime = CW_DotTimeA
    EndIf
    '/-------------------------------------------------------------------------- 
    CW_DotDashSpaceTime = (CW_DotTimeA * 101) / 100  '/ CW_DotTime + 1% Correction for delay between Dot & Dash.
    '/--------------------------------------------------------------------------    
    If F_DashDotRatio = 0 Then
        CW_DashTime = (1440 * 3) / KCW_WPM          '/ 1 Dash time (3 dots).
    Else
        CW_DashTime = (1440 * 4) / KCW_WPM          '/ 1 Dash time (4 dots).
    EndIf
    CW_LongDashTime = CW_DashTime * 4
    If ValueInput > 0 Then
        CW_DashTime = CW_DashTime + ValueInput          '/ Dot/Dash compensation.
        CW_LongDashTime = CW_LongDashTime + ValueInput  '/ Dot/Dash compensation. 
    EndIf
    '/--------------------------------------------------------------------------
    '/ Calculate new Delay Letter Space value (CW_LetterSpaceTime = CW_DotTime * 3)
    If F_FarnsworthSpacing = 0 Then     '/ NO Farnsworth Spacing
        '/ LetterSpaceTime Standard
        CW_LetterSpaceTrueTime = (1445 * 3) / KCW_WPM   '/ 3 Dots time. (CORRECTION)
        CW_LetterSpaceTime = CW_LetterSpaceTrueTime - CW_DotTimeA  
        ValueInput = ERead EEPCW_LTSPACE_ADJUSTMENT     '/ Return: [0,5,10,15,20,25,30,35,40,45] % of LTSPACE.
        If ValueInput > 0 Then
            LSAdjustment = (CW_LetterSpaceTrueTime * ValueInput) / 100  '/ LetterSpace Adjustment
            CW_LetterSpaceTime = CW_LetterSpaceTime + LSAdjustment
        EndIf
     Else
        '/ LetterSpaceTime FARNSWORTH
        '/ Calculate the WPM FARNSWORTH
        ValueInput = ERead EEPCW_FARNSWORTHSP       '/ [95,90,85,80,75,70,65,60,55,50] % of WPM
        WPM_FARNSWORTH = (KCW_WPM * ValueInput) / 100
        CW_DotFwhTime = 1445 / WPM_FARNSWORTH       '/ New value for CW_DotTime Farnsworth.       
        CW_LetterSpaceTrueTime = (1445 * 3) / WPM_FARNSWORTH  '/ 3 Dots Farnsworth time.
        CW_LetterSpaceTime = CW_LetterSpaceTrueTime - CW_DotFwhTime
    EndIf
    '/--------------------------------------------------------------------------
    '/ Calculate new Delay Word Space value  (CW_WordSpaceTime = CW_DotTime * 7)
    If F_FarnsworthSpacing = 0 Then     '/ NO Farnsworth Spacing
        '/ WordSpaceTime Standard
        CW_WordSpaceTrueTime = (1445 * 7) / KCW_WPM        '/ 1 Dot time * 7 (CORRECTION)
        CW_WordSpaceTime = CW_WordSpaceTrueTime - CW_LetterSpaceTrueTime
        ValueInput = ERead EEPCW_WDSPACE_ADJUSTMENT        '/ Return: [0,5,10,15,20,25,30,35,40,45] % of WDSPACE.
        If ValueInput > 0 Then
            WSAdjustment = (CW_WordSpaceTrueTime * ValueInput) / 100    '/ WordSpace Adjustment
            CW_WordSpaceTime = CW_WordSpaceTime + WSAdjustment          '/ WordSpace Adjustment
        EndIf
    Else
        '/ WordSpaceTime FARNSWORTH
        CW_WordSpaceTrueTime = (1445 * 7) / WPM_FARNSWORTH   '/ 1 Dot Farnsworth * 7
        CW_WordSpaceTime = CW_WordSpaceTrueTime - CW_LetterSpaceTrueTime
    EndIf
    '/##########################################################################
    '/ Read TUNE ON/OFF DELAY value
    CWResultByte = ERead EEPCW_TUNEONOFFDELAY  '/ [5,10,15,20,25,30,35,40,45,50] X 100mS 
    CalcTuneONDelay(CWResultByte)
    CalcTuneOFFDelay(CWResultByte)
    '/##########################################################################
    '/ Calculate some CW timings for Beacon/Messages.
    PTDotTime = (1200 / KCW_WPM) + ValueInput   '/ 1 Dot time in MS. (Value to print to LCD or Terminal)  
    PTLetterSpaceTime = (1200 * 3) / KCW_WPM    '/ (Value To Print To LCD Or Terminal)
    PTWordSpaceTime = (1200 * 7) / KCW_WPM      '/ (Value To Print To LCD Or Terminal)
    '/--------------------------------------------------------------------------
    Msg_DotTimeA = 1200 / KCW_WPM               '/ Standard DotTime for Beacon/messages.
    '/--------------------------------------------------------------------------
    '/ Dot/Dash compensation
    Msg_DotTime = Msg_DotTimeA
    ValueInput = ERead EEPCW_DOTDASH_ADJUSTMENT     '/ Return: (0 to 31mS)     
    If ValueInput > 0 Then
        Msg_DotTime = Msg_DotTimeA + ValueInput     '/ Dot/Dash compensation.
    EndIf
    '/--------------------------------------------------------------------------
    Msg_DotDashSpaceTime = (Msg_DotTimeA * 101) / 100 '/ + 1% Correction.
    '/--------------------------------------------------------------------------
    If F_DashDotRatio = 0 Then
        Msg_DashTime = (1200 * 3) / KCW_WPM    '/ 1 Dash time (3 dots) in MS. 
    Else
        Msg_DashTime = (1200 * 4) / KCW_WPM    '/ 1 Dash time (4 dots) in MS.     
    EndIf
    Msg_LondDashTime = Msg_DashTime * 4
    If ValueInput > 0 Then
        Msg_DashTime = Msg_DashTime + ValueInput   '/ Dot/Dash compensation. 
        Msg_LondDashTime = Msg_LondDashTime + ValueInput    '/ Dot/Dash compensation.
    EndIf
    '/--------------------------------------------------------------------------
    PTDashTime = Msg_DashTime                   '/ Timings to print + Dot/Dash compensation.
    '/--------------------------------------------------------------------------
    If F_FarnsworthSpacing = 0 Then    
        '/ LetterSpaceTime Standard
        Msg_LetterSpaceTrueTime = (1200 * 3) / KCW_WPM   '/ LetterSpace = Msg_DotTime * 3
        Msg_LetterSpaceTime = Msg_LetterSpaceTrueTime - Msg_DotTimeA    '/ LetterSpace = Msg_DotTime * 3
        Msg_LetterSpaceTime = Msg_LetterSpaceTime + 4                   '/ Little correction.
        ValueInput = ERead EEPCW_LTSPACE_ADJUSTMENT      '/ Return: [0,5,10,15,20,25,30,35,40,45] % of LTSPACE.
        If ValueInput > 0 Then
            LSAdjustment = (Msg_LetterSpaceTrueTime * ValueInput) / 100  '/ LetterSpace Adjustment
            Msg_LetterSpaceTime = Msg_LetterSpaceTime + LSAdjustment
            PTLetterSpaceTime = PTLetterSpaceTime + LSAdjustment
        EndIf
        '/----------------------------------------------------------------------
        '/ WordSpaceTime Standard
        Msg_WordSpaceTrueTime = (1200 * 7) / KCW_WPM        '/ Msg_WordSpaceTime = Msg_DotTime * 7         
        Msg_WordSpaceTime = Msg_WordSpaceTrueTime - Msg_LetterSpaceTrueTime '/ Msg_WordSpaceTime = Msg_DotTime * 7
        ValueInput = ERead EEPCW_WDSPACE_ADJUSTMENT         '/ Return: [0,5,10,15,20,25,30,35,40,45] % of WDSPACE.
        If ValueInput > 0 Then
            WSAdjustment = (Msg_WordSpaceTrueTime * ValueInput) / 100 '/ WordSpace Adjustment
            Msg_WordSpaceTime = Msg_WordSpaceTime + WSAdjustment
            PTWordSpaceTime = PTWordSpaceTime + WSAdjustment 
        EndIf
    Else
        '/ FARNSWORTH
        '/ DotTime FARNSWORTH
        Msg_DotTimeFWH = 1200 / WPM_FARNSWORTH   '/ 1 Dot FARNSWORTH
        '/----------------------------------------------------------------------
        '/ LetterSpaceTime FARNSWORTH
        Msg_LetterSpaceTrueTime = (1200 * 3) / WPM_FARNSWORTH '/ LetterSpace = Msg_DotTime * 3
        Msg_LetterSpaceTime = Msg_LetterSpaceTrueTime - Msg_DotTimeFWH 
        '/----------------------------------------------------------------------
        PTLetterSpaceTime = Msg_LetterSpaceTrueTime         '/ (Value To Print To LCD Or Terminal)
        '/----------------------------------------------------------------------
        '/ WordSpaceTime FARNSWORTH
        Msg_WordSpaceTrueTime = (1200 * 7) / WPM_FARNSWORTH '/ New value for WordSpace (7 dots)
        Msg_WordSpaceTime = Msg_WordSpaceTrueTime - Msg_LetterSpaceTrueTime
        '/----------------------------------------------------------------------
        PTWordSpaceTime = Msg_WordSpaceTrueTime             '/ (Value To Print To LCD Or Terminal)
        '/----------------------------------------------------------------------
    EndIf
    '/--------------------------------------------------------------------------
    Return
ENDSIZE(CfgCWTiming_CODE)
    '/ Execution Time of config delays = 71,5uS At 64Mhz.
#endIfMacro-
*)

#ifMacro- _mKYCW_Timings 
KYCW_Timings_Sub:
STARTSIZE(CfgCWTiming_CODE)
    '/ Dinamic Parameters for the Keyer.
    '/ The timer2 is counting every 830uS.
    '/--------------------------------------------------------------------------
    '/ Calculate Dot & Dash Time
    '/ Standard: CW_DotTimeA = 12000 / KCW_WPM 
    CW_DotTimeA = 12010 / KCW_WPM    '/ Standard DotTime For CW Paddles. (Timer2 = 10kHz)
    CW_DotTime = CW_DotTimeA
    '/-------------------------------------------------------------------------- 
    '/ Time Delay between Dot/Dash & DotSpace/DashSpace.
    KYResultDWord = CW_DotTimeA * 92
    CW_DotDashSpaceTime = KYResultDWord / 100        '/ CW_DotTime - 8% Correction for delay between Dot & Dash.
'    CW_DotDashSpaceTime = CW_DotTimeA 
    '/--------------------------------------------------------------------------    
    If F_DashDotRatio = 0 Then
        CW_DashTime = (12010 * 3) / KCW_WPM          '/ 1 Dash time (3 dots).
    Else
        CW_DashTime = (12010 * 4) / KCW_WPM          '/ 1 Dash time (4 dots).
    EndIf
    '/--------------------------------------------------------------------------
    CW_LongDashTime = CW_DashTime * 4   '/ Special long Dash for number 0.
    '/-------------------------------------------------------------------------- 
    '/ Dot/Dash compensation
    KYDotDashCompensation = ERead EEPCW_DOTDASH_ADJUSTMENT  '/ Return: (0 to 31mS)
    If KYDotDashCompensation > 0 Then
        Save_FSR0 = KYDotDashCompensation * 10
        CW_DotTime = CW_DotTimeA + Save_FSR0
        CW_DashTime = CW_DashTime + Save_FSR0            '/ Dot/Dash compensation.
        CW_LongDashTime = CW_LongDashTime + Save_FSR0    '/ Dot/Dash compensation. 
    EndIf
    '/--------------------------------------------------------------------------
    If F_FarnsworthSpacing = 0 Then     '/ NO Farnsworth Spacing
        '/ Calculate new Delay Letter Space value (CW_LetterSpaceTime = CW_DotTime * 3)
        '/ LetterSpaceTime Standard
        CW_LetterSpaceTrueTime = (12350 * 3) / KCW_WPM  '/ 3 Dots time. (CORRECTION)
        ValueInput = ERead EEPCW_LTSPACE_ADJUSTMENT     '/ Return: [0,5,10,15,20,25,30,35,40,45] % of LTSPACE.
        If ValueInput > 0 Then
            KYResultDWord = CW_LetterSpaceTrueTime * ValueInput            
            LSAdjustment = KYResultDWord / 100          '/ LetterSpace Adjustment
            CW_LetterSpaceTrueTime = CW_LetterSpaceTrueTime + LSAdjustment
            CW_LetterSpaceTime = CW_LetterSpaceTrueTime - CW_DotTimeA 
        Else
            CW_LetterSpaceTime = CW_LetterSpaceTrueTime - CW_DotTimeA
        EndIf
        '/----------------------------------------------------------------------
        '/ Calculate new Delay Word Space value  (CW_WordSpaceTime = CW_DotTime * 7)
        '/ WordSpaceTime Standard
        Symbol CstWordSpaceParam = 12175 * 7                '/ Constant tested.
        CW_WordSpaceTrueTime = CstWordSpaceParam / KCW_WPM  '/ 1 Dot time * 7 (CORRECTION)
        ValueInput = ERead EEPCW_WDSPACE_ADJUSTMENT         '/ Return: [0,5,10,15,20,25,30,35,40,45] % of WDSPACE.
        If ValueInput > 0 Then
            KYResultDWord = CW_WordSpaceTrueTime * ValueInput
            WSAdjustment = KYResultDWord / 100              '/ WordSpace Adjustment
            CW_WordSpaceTrueTime = CW_WordSpaceTrueTime + WSAdjustment          '/ WordSpace Adjustment
            CW_WordSpaceTime = CW_WordSpaceTrueTime - CW_LetterSpaceTrueTime
        Else
            CW_WordSpaceTime = CW_WordSpaceTrueTime - CW_LetterSpaceTrueTime
        EndIf
    '/--------------------------------------------------------------------------
     Else
    '/--------------------------------------------------------------------------
        '/ LetterSpaceTime FARNSWORTH
        '/ Calculate the WPM FARNSWORTH
        ValueInput = ERead EEPCW_FARNSWORTHSP       '/ [95,90,85,80,75,70,65,60,55,50] % of WPM
        Save_FSR1 = KCW_WPM * ValueInput
        WPM_FARNSWORTH = Save_FSR1 / 100
        CW_DotFwhTime = 12010 / WPM_FARNSWORTH      '/ New value for CW_DotTime Farnsworth.       
        CW_LetterSpaceTrueTime = (12350 * 3) / WPM_FARNSWORTH  '/ 3 Dots Farnsworth time.
        CW_LetterSpaceTime = CW_LetterSpaceTrueTime - CW_DotFwhTime
        '/----------------------------------------------------------------------
        '/ WordSpaceTime FARNSWORTH
        Symbol CstWordSpaceFWparam = 12175 * 7              '/ Constant tested.
        CW_WordSpaceTrueTime = CstWordSpaceFWparam / WPM_FARNSWORTH   '/ 1 Dot Farnsworth * 7
        CW_WordSpaceTime = CW_WordSpaceTrueTime - CW_LetterSpaceTrueTime
    EndIf
    '/##########################################################################
    '/ Read TUNE ON/OFF DELAY value
    CWResultByte = ERead EEPCW_TUNEONOFFDELAY  '/ [5,10,15,20,25,30,35,40,45,50] X 100mS 
    CalcTuneONDelay(CWResultByte)
    CalcTuneOFFDelay(CWResultByte)
    '/##########################################################################
    '/ Calculate some CW timings for Beacon/Messages.
    PTDotTime = (1200 / KCW_WPM)                '/ 1 Dot time in MS. (Value to print to LCD or Terminal)  
    PTLetterSpaceTime = (1200 * 3) / KCW_WPM    '/ (Value To Print To LCD Or Terminal)
    PTWordSpaceTime = (1200 * 7) / KCW_WPM      '/ (Value To Print To LCD Or Terminal)
    '/==========================================================================
    Msg_DotTimeA = 1200 / KCW_WPM               '/ Standard DotTime for Beacon/messages.
    Msg_DotTime = Msg_DotTimeA
    '/--------------------------------------------------------------------------
    '/ Msg_DotDashSpaceTime / Time between Dot/Dot, Dash/Dash & Dot/Dash.
    KYResultDWord = Msg_DotTimeA * 101
    Msg_DotDashSpaceTime = KYResultDWord / 100 '/ + 1% Correction.
    '/--------------------------------------------------------------------------
    If F_DashDotRatio = 0 Then
        Msg_DashTime = (1200 * 3) / KCW_WPM    '/ 1 Dash time (3 dots) in MS. 
    Else
        Msg_DashTime = (1200 * 4) / KCW_WPM    '/ 1 Dash time (4 dots) in MS.     
    EndIf
    Msg_LondDashTime = Msg_DashTime * 4
    '/--------------------------------------------------------------------------
    '/ Msg_DotTime / Dot/Dash compensation. 
    If KYDotDashCompensation > 0 Then          '/ Return: (0 to 31mS)
        Msg_DotTime = Msg_DotTime + Save_FSR0
        PTDotTime = PTDotTime + Save_FSR0        
        Msg_DashTime = Msg_DashTime + Save_FSR0         
        Msg_LondDashTime = Msg_LondDashTime + Save_FSR0
    EndIf
    '/--------------------------------------------------------------------------
    PTDashTime = Msg_DashTime                   '/ Timings to print + Dot/Dash compensation.
    '/--------------------------------------------------------------------------
    If F_FarnsworthSpacing = 0 Then    
        '/ LetterSpaceTime Standard
        Msg_LetterSpaceTrueTime = (1200 * 3) / KCW_WPM  '/ LetterSpace = Msg_DotTime * 3
        ValueInput = ERead EEPCW_LTSPACE_ADJUSTMENT     '/ Return: [0,5,10,15,20,25,30,35,40,45] % of LTSPACE.
        If ValueInput > 0 Then
            KYResultDWord = Msg_LetterSpaceTrueTime * ValueInput
            LSAdjustment = KYResultDWord / 100          '/ LetterSpace Adjustment
            Msg_LetterSpaceTrueTime = Msg_LetterSpaceTrueTime + LSAdjustment
            Msg_LetterSpaceTime = Msg_LetterSpaceTrueTime - Msg_DotTimeA
            PTLetterSpaceTime = PTLetterSpaceTime + LSAdjustment
        Else
            Msg_LetterSpaceTime = Msg_LetterSpaceTrueTime - Msg_DotTimeA    '/ LetterSpace = Msg_DotTime * 3
        EndIf
        '/----------------------------------------------------------------------
        '/ WordSpaceTime Standard
        Msg_WordSpaceTrueTime = (1200 * 7) / KCW_WPM    '/ Msg_WordSpaceTime = Msg_DotTime * 7         
        ValueInput = ERead EEPCW_WDSPACE_ADJUSTMENT     '/ Return: [0,5,10,15,20,25,30,35,40,45] % of WDSPACE.
        If ValueInput > 0 Then
            KYResultDWord = Msg_WordSpaceTrueTime * ValueInput
            WSAdjustment = KYResultDWord / 100          '/ WordSpace Adjustment
            Msg_WordSpaceTrueTime = Msg_WordSpaceTrueTime + WSAdjustment
            Msg_WordSpaceTime = Msg_WordSpaceTrueTime - Msg_LetterSpaceTrueTime
            PTWordSpaceTime = PTWordSpaceTime + WSAdjustment 
        Else
            Msg_WordSpaceTime = Msg_WordSpaceTrueTime - Msg_LetterSpaceTrueTime '/ Msg_WordSpaceTime = Msg_DotTime * 7        
        EndIf
    '/--------------------------------------------------------------------------
    Else
    '/--------------------------------------------------------------------------
        '/ FARNSWORTH
        '/ DotTime FARNSWORTH
        Msg_DotTimeFWH = 1200 / WPM_FARNSWORTH   '/ 1 Dot FARNSWORTH
        '/----------------------------------------------------------------------
        '/ LetterSpaceTime FARNSWORTH
        Msg_LetterSpaceTrueTime = (1200 * 3) / WPM_FARNSWORTH   '/ LetterSpace = Msg_DotTime * 3
        Msg_LetterSpaceTime = Msg_LetterSpaceTrueTime - Msg_DotTimeFWH 
        '/----------------------------------------------------------------------
        PTLetterSpaceTime = Msg_LetterSpaceTrueTime             '/ (Value To Print To LCD Or Terminal)
        '/----------------------------------------------------------------------
        '/ WordSpaceTime FARNSWORTH
        Msg_WordSpaceTrueTime = (1200 * 7) / WPM_FARNSWORTH     '/ New value for WordSpace (7 dots)
        Msg_WordSpaceTime = Msg_WordSpaceTrueTime - Msg_LetterSpaceTrueTime
        '/----------------------------------------------------------------------
        PTWordSpaceTime = Msg_WordSpaceTrueTime                 '/ (Value To Print To LCD Or Terminal)
        '/----------------------------------------------------------------------
    EndIf
    '/--------------------------------------------------------------------------
    Return
ENDSIZE(CfgCWTiming_CODE)
    '/ Execution Time of config delays = 90uS at 64Mhz.
#endIfMacro-

'/==============================================================================    
'* Purpose : Reading the WPM potentiometer macro.
'* Input   : PORTA.1 hannel 1 input.                                       
'* Output  : Return_Var (Not mandatory)
'* Note    : Reading on the fly 32 Or 64 Steps only. 
'/
' Definition of global variables.
'    Dim WPM_OLD As Byte System

'/ Run the WPM potentiometer reading.
'$define CWReadWPMpot() _mCWReadWPMpot

'_mCWReadWPMpot Macro-
'    STARTSIZE(CWReadWPMpot_MACRO)
'    GoSub CWReadWPMpot_Sub
'    #if (_mCWReadWPMpot_RETURN == 1)
'        #if (Return_Type == Byte)
'            Byte_Byte KCW_WPM,Return_Var
'        #else
'            #error "_mCWReadWPMpot - Return variable should be a Byte variable"
'            Exitm
'        #endif
'    #endif
'    ENDSIZE(CWReadWPMpot_MACRO)
'Endm
'/============================================================================== 
'* Purpose : Read the WPM potentiometer and calculate the timings for CW Paddles mode.
'* Input   : none                                      
'* Output  : none 
'* Note    : 
'/
$define CWConfigWPM() _mCWConfigWPM

_mCWConfigWPM Macro-
    GoSub CWConfigWPM_Sub
Endm

#ifMacro- _mCWConfigWPM
CWConfigWPM_Sub:
    STARTSIZE(CWConfigWPM_LIB)
    '/ While the code is waiting for something, read the WPM Value.
    '/ Using the KCW_WPM variable, 1uS of code is saved.
    F_NewPWM = 0
'    CWReadWPMpot()                   '/ Read the WPM potentiometer => KCW_WPM.
    GoSub CWReadWPMpot_Sub      '/ Read the WPM potentiometer => KCW_WPM.
    If F_NewPWM = 1 Then
        F_NewPWM = 0
        KYCW_Timings()          '/ Calculate timings.
        HRSOut "WPM: ", Dec KCW_WPM,CR        
    EndIf
    Return
    ENDSIZE(CWConfigWPM_LIB)
    '/ Execution Time of reading Pot & config delays = 2,75uS At 64Mhz.
#endIfMacro-
'/============================================================================== 
'* Purpose : Read the WPM potenciometer and calculate the timings for Keyboard/MSG mode.
'* Input   : none                                      
'* Output  : none 
'* Note    : 
'/
'$define MSGConfigWPM() _mMSGConfigWPM

'_mMSGConfigWPM Macro-
'    GoSub MSGConfigWPM_Sub
'Endm

'#ifMacro- _mMSGConfigWPM
'MSGConfigWPM_Sub:
'    STARTSIZE(MSGConfigWPM_LIB)
'    '/ While the code is waiting for something, read the WPM Value.
'    '/ Using the KCW_WPM variable, 1uS of code is saved.
'    F_NewPWM = 0
'    CWReadWPMpot()               '/ Read the WPM potentiometer => KCW_WPM.
'    If F_NewPWM = 1 Then
'        F_NewPWM = 0
'        KYMSG_Timings()         '/ Calculate timings.
'        HRSOut "WPM Value: ", Dec KCW_WPM,CR        
'    EndIf
'    Return
'ENDSIZE(MSGConfigWPM_LIB)
'    '/ Execution Time of reading Pot & config delays = 1,0uS At 64Mhz.
'#endIfMacro-
'*******************************************************************************
'/ Name    : LoadTXT_E2P                                              
'/ Author  : [Alberto Freixanet] 07/04/2019                                   
'/ Purpose : Load characters ASCII from terminal keyboard into eeprom         
'/ Input   : UART                                                              
'/ Output  : none                                                             
'/ Note    : Using HSerIn with 5 Sec Timeout                                  
'/           Copy the incomming data to a string first then copy all to the 
'/           eeprom if no error detected.
'/
'/ Declare Local Variables.
    $if _eeprom > 256
    LocalWord0(EEPAddressW)
    $else
    LocalByte0(EEPAddressW)
    $endif
    LocalByte1(EEPTxtLenghtW)
    LocalByte2(EEPdataW)        
    
$define LoadTXT_E2P(pAddress,pTextLenght) _mLoadTXT_E2P pAddress,pTextLenght

_mLoadTXT_E2P Macro- pAddress,pTextLenght
    STARTSIZE(LoadTXT_to_E2P_MACRO)
	#if (Prm_Count != 2)         
		#error "Incorrect amount of parameters for _mLoadTXT_E2P macro. 2 Parameters required!"	
		Exitm
    #else
    $if _eeprom > 256
        #if (Prm_1 != Num8) && (Prm_1 != Byte) && (Prm_1 != Num16) && (Prm_1 != Word)
            #error "_mLoadTXT_E2P macro - (Param1) Should be a Num8, Num16, Byte or Word variable"
            Exitm
        #else
                #if (Prm_1 == Num8)
                Num_Word pAddress,EEPAddressW 
                #endif
                #if (Prm_1 == Byte)
                Byte_Word pAddress,EEPAddressW 
                #endif
                #if (Prm_1 == Num16)
                Num_Word pAddress,EEPAddressW 
                #endif
                #if (Prm_1 == Word)
                Word_Word pAddress,EEPAddressW 
                #endif
        #endif
    $else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mLoadTXT_E2P macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pAddress,EEPAddressW 
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pAddress,EEPAddressW 
            #endif
        #endif
    $endif
        '/----------------------------------------------------------------------
        #if (Prm_2 != Num8) && (Prm_2 != Byte)
            #error "_mLoadTXT_to_E2P macro - (Param2) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_2 == Num8)
            Num_Byte pTextLenght,EEPTxtLenghtW 
            #endif
            #if (Prm_2 == Byte)
            Byte_Byte pTextLenght,EEPTxtLenghtW 
            #endif
        #endif
    #endif
    GoSub LoadTXT_E2P_Sub
    ENDSIZE(LoadTXT_to_E2P_MACRO)
Endm

#ifMacro- _mLoadTXT_E2P
LoadTXT_E2P_Sub:
    STARTSIZE(LoadTXT_to_E2P_LIB)
    F_KeyerMemoryError = 0
    '/ Loading all characters into a string first.
    FSR2 = VarPtr(CW_StringTemp)
    Do
        #ifdef Watchdog_req
        Clrwdt
        #endif
        EEPdataW = HRSIn,{5000,WriteTXT_E2PEXIT}    '/ Waiting an ASCII character, TimeOut 5 seconds. 
        If EEPdataW = 13 Then                       '/ Carriage Return to exit the routine.
            POSTINC2 = 0                            '/ Final String.
            Break                                   '/ Exit Loop.
        EndIf
        '/ Checking the character validity. (ASCII value)
        Select EEPdataW
            Case < 47, > 90
                F_KeyerMemoryError = 1
                Return
            Case 58 To 64
                F_KeyerMemoryError = 1
                Return
        EndSelect
        POSTINC2 = EEPdataW             '/ Load the charatcer into the String.
        HRSOut EEPdataW
    Loop
    '/ Then copy the string to the eeprom memory.
    FSR2 = VarPtr(CW_StringTemp)
    Dec EEPAddressW
    Repeat
        EEPdataW = POSTINC2
        Inc EEPAddressW
        EWrite EEPAddressW,[EEPdataW]   '/ Write the character into eeprom.
        If EEPdataW = 0 Then Break      '/ Final string then exit.
        Dec EEPTxtLenghtW
    Until EEPTxtLenghtW = 0
    EWrite EEPAddressW,[0]      '/ Final string for security.
    HRSOut CR
    Return
WriteTXT_E2PEXIT:
    F_KeyerMemoryError = 1      '/ Timeout => error.
    Return    
    ENDSIZE(LoadTXT_to_E2P_LIB) 
#endIfMacro-
'/==============================================================================
'* Name    : ReadStrg_E2P
'* Author  : [Alberto Freixanet] 04/06/2019
'* Purpose  : Read an ASCII message from the eeprom memory.
'* Input    : None                                       
'* Output   : None
'/
'/ Declare Local Variables.
'/ using same as above

$define ReadStrg_E2P(pAddress) _mReadStrg_E2P pAddress

_mReadStrg_E2P Macro- pAddress
    STARTSIZE(ReadStrg_E2P_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mReadStrg_E2P macro. 1 Parameter required!"	
		Exitm
    #else
    $if _eeprom > 256
        '/----------------------------------------------------------------------
        #if (Prm_1 != Num8) && (Prm_1 != Byte) && (Prm_1 != Num16) && (Prm_1 != Word)
            #error "_mReadStrg_E2P - (Param1) Should be a Num8, Num16, Byte or Word variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Word pAddress,EEPAddressW 
            #endif
            #if (Prm_1 == Byte)
            Byte_Word pAddress,EEPAddressW 
            #endif
            #if (Prm_1 == Num16)
            Num_Word pAddress,EEPAddressW 
            #endif
            #if (Prm_1 == Word)
            Word_Word pAddress,EEPAddressW 
            #endif
        #endif
        '/----------------------------------------------------------------------
    $else
        '/----------------------------------------------------------------------
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mReadStrg_E2P - (Param1) Should be a Num8, or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pAddress,EEPAddressW 
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pAddress,EEPAddressW 
            #endif            
        #endif        
        '/----------------------------------------------------------------------
    $endif
    #endif
    GoSub ReadStrg_E2P_Sub
    ENDSIZE(ReadStrg_E2P_MACRO)
Endm

#ifMacro- _mReadStrg_E2P
ReadStrg_E2P_Sub:
    STARTSIZE(ReadStrg_E2P_LIB)
    Do
        #ifdef Watchdog_req
        Clrwdt
        #endif
        EEPdataW = ERead EEPAddressW    '/ Read the character into eeprom.
        If EEPdataW > 126 Then Break    '/ Error in ASCII character then Exit the loop.
        If EEPdataW = 0 Then Break      '/ Final string then Exit the loop.
        HRSOut EEPdataW
        Inc EEPAddressW
    Loop
    HRSOut CR
    Return
    ENDSIZE(ReadStrg_E2P_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Tone Frequency Table.
'* Input    : ASCII character (0 to 9)                                       
'* Output   : Value To load the TIMER0L register.
'/
$define KYToneFreqTable(pValue) _mKYToneFreqTable pValue

_mKYToneFreqTable Macro- pValue
STARTSIZE(KYToneFreqTable_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mKYToneFreqTable macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mKYToneFreqTable macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,MacroTemp
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,MacroTemp
            #endif
        #endif
    #endif
    GoSub KYToneFreqTable_Sub
    #if (_mKYToneFreqTable_RETURN != 1)
        #error "_mKYToneFreqTable - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mKYToneFreqTable - Return variable should be a Byte variable"
            Exitm
        #else
            #if (Return_Type == Byte)
            Byte_Byte PRODH,Return_Var
            #endif
        #endif
    #endif    
ENDSIZE(KYToneFreqTable_MACRO)
Endm

#ifMacro- _mKYToneFreqTable
KYToneFreqTable_Sub: 
STARTSIZE(KYToneFreqTable_LIB)
    $if _xtal = 16
    '/ Calculate: (16Mhz/4) / (1250 * 2) = 1600 / Prescaler(32) = 50 => 256 - 50 = 206
    PRODH = LookUp MacroTemp,[100,117,131,143,152,160,167,178,194,206] 
    $endif
    $if _xtal = 20
    '/ Calculate: (20Mhz/4) / (1250 * 2) = 2000 / Prescaler(32) = 62 => 256 - 62 = 194
    PRODH = LookUp MacroTemp,[61,83,100,114,126,136,144,199,178,194]
    $endif            
    $if _xtal = 25
    '/ Calculate: (25Mhz/4) / (1250 * 2) = 2500 / Prescaler(32) = 78 => 256 - 78 = 178
    PRODH = LookUp MacroTemp,[12,39,61,79,93,106,117,134,159,178] 
    $endif
    $if _xtal = 64
    '/ Calculate: (64Mhz/4) / (1250 * 2) = 6400 / Prescaler(128) = 50 => 256 - 50 = 206
    PRODH = LookUp MacroTemp,[100,117,131,143,152,160,167,178,194,206] 
    $endif
    $if _xtal = 80
    '/ Calculate: (80Mhz/4) / (1250 * 2) = 8000 / Prescaler(128) = 62.5 => 256 - 62 = 194
    PRODH = LookUp MacroTemp,[61,83,100,114,126,136,144,199,178,194]
    $endif
    $if _xtal = 100
    '/ Calculate: (100Mhz/4) / (1250 * 2) = 10000 / Prescaler(128) = 78 => 256 - 78 = 178
    PRODH = LookUp MacroTemp,[12,39,61,79,93,106,117,134,159,178] 
    $endif
    Return
ENDSIZE(KYToneFreqTable_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Read Frequency Table.
'* Input    : ASCII character (0 to 9)                                       
'* Output   : 1250,1008,801,702,651,600,553,500,449,400 Hz
'/
$define KYReadToneFreqTable() _mKYReadToneFreqTable 

_mKYReadToneFreqTable Macro- 
STARTSIZE(ReadToneFreqTable_MACRO)
    GoSub KYReadToneFreqTable_Sub
    #if (_mKYReadToneFreqTable_RETURN != 1)
        #error "_mKYReadToneFreqTable - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Word)
            #error "_mKYReadToneFreqTable - Return variable should be a Byte variable"
            Exitm
        #else
            Word_Word PROD,Return_Var
        #endif
    #endif    
ENDSIZE(ReadToneFreqTable_MACRO)
Endm

#ifMacro- _mKYReadToneFreqTable
KYReadToneFreqTable_Sub: 
STARTSIZE(ReadToneFreqTable_LIB)
    WREG = ERead EEPCW_TONEFREQUENCY_INDEX    '/ Current value in case of error.
    PROD = LookUpL WREG,[400,450,500,550,600,650,700,800,1000,1250] '/ X 1 Hz 
    Return
ENDSIZE(ReadToneFreqTable_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Load the Timer0.
'* Input    : Input macro value.                                      
'* Output   : TMR0L
'/
$define KYLoadToneFreq(pValue) _mKYLoadToneFreq pValue

_mKYLoadToneFreq Macro- pValue
STARTSIZE(KYLoadToneFreq_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mCalcKYToneFrequency macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mCalcKYToneFrequency macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,MacroTemp
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,MacroTemp
            #endif
        #endif
    #endif
    GoSub KYLoadToneFreq_Sub
ENDSIZE(KYLoadToneFreq_MACRO)
Endm

#ifMacro- _mKYLoadToneFreq
KYLoadToneFreq_Sub:
STARTSIZE(KYLoadToneFreq_LIB)
    INTCONBits_TMR0IE = 0
    T0CONBits_TMR0ON = 0    '/ Stop Timer0
    Nop
    TMR0L = MacroTemp
'    Nop
'    T0CONBits_TMR0ON = 1    '/ Restart Timer0
    INTCONBits_TMR0IF = 0
    Return
ENDSIZE(KYLoadToneFreq_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------
$define KYToneOut()                   '
    If F_EnableTone = 1 Then          '
        If INTCONBits_TMR0IF = 1 Then '
            INTCONBits_TMR0IF = 0     '
            Toggle CWToneOut          '
            T0CONBits_TMR0ON = 0      '
            Nop                       '
            TMR0L = KYTMR0LValue      '
            T0CONBits_TMR0ON = 1      '
        EndIf                         '
    EndIf

$define KYStartTone()        '
    If F_EnableTone = 1 Then '
        TMR0L = KYTMR0LValue '
        Nop                  '
        T0CONBits_TMR0ON = 1 '
    EndIf
    
$define KYToneOFF() T0CONBits_TMR0ON = 0

'/==============================================================================
'* Purpose  : TX ON Delays.
'* Input    : None                                       
'* Output   : [25,50,75,100,125,150,175,200,225,250] X 1 mS
'/          '/ 10 Values
'/
$define KYTXOnDelayTable(pValue) _mKYTXOnDelayTable pValue

_mKYTXOnDelayTable Macro- pValue
STARTSIZE(KYTXOnDelayTable_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mKYTXOnDelayTable macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mKYTXOnDelayTable macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,MacroTemp
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,MacroTemp
            #endif
        #endif
    #endif
    GoSub KYTXOnDelayTable_Sub
    #if (_mKYTXOnDelayTable_RETURN != 1)
        #error "_mKYTXOnDelayTable - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mKYTXOnDelayTable - Return variable should be a Byte variable"
            Exitm
        #else
            #if (Return_Type == Byte)
            Byte_Byte PRODH,Return_Var
            #endif
        #endif
    #endif    
ENDSIZE(KYTXOnDelayTable_MACRO)
Endm

#ifMacro- _mKYTXOnDelayTable
KYTXOnDelayTable_Sub: 
STARTSIZE(KYTXOnDelayTable_LIB)
    PRODH = ERead EEPCW_TXONDELAY      '/ Current value in case of error.
    If MacroTemp > 47 Then 
        If MacroTemp < 58 Then
            WREG = MacroTemp - 48
            PRODH = LookUp WREG,[25,50,75,100,125,150,175,200,225,250] 
        EndIf
    EndIf 
    Return
ENDSIZE(KYTXOnDelayTable_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------
$define CalcKYTXOnDelay(pValue) _mCalcKYTXOnDelay pValue

_mCalcKYTXOnDelay Macro- pValue
STARTSIZE(CalcKYTXOnDelay_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mCalcKYTXOnDelay macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mCalcKYTXOnDelay macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,MacroTemp
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,MacroTemp
            #endif
        #endif
    #endif
    GoSub CalcKYTXOnDelay_Sub
ENDSIZE(CalcKYTXOnDelay_MACRO)
Endm

#ifMacro- _mCalcKYTXOnDelay
CalcKYTXOnDelay_Sub:
STARTSIZE(CalcKYTXOnDelay_LIB)
    TXONDelay = MacroTemp
'    TXONDelay2 = (MacroTemp * 121) / 100   '/ (TXONDelay * 145200) / 1200 
    Return
ENDSIZE(CalcKYTXOnDelay_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : RX ON Delays.
'* Input    : None                                       
'* Output   : [25,50,75,100,125,150,175,200,225,250] X 1 mS
'/          '/ 10 Values
'/
$define KYRXOnDelayTable(pValue) _mKYRXOnDelayTable pValue

_mKYRXOnDelayTable Macro- pValue
STARTSIZE(KYRXOnDelayTable_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mKYRXOnDelayTable macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mKYRXOnDelayTable macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,MacroTemp
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,MacroTemp
            #endif
        #endif
    #endif
    GoSub KYRXOnDelayTable_Sub
    #if (_mKYRXOnDelayTable_RETURN != 1)
        #error "_mKYRXOnDelayTable - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mKYRXOnDelayTable - Return variable should be a Byte variable"
            Exitm
        #else
            #if (Return_Type == Byte)
            Byte_Byte PRODH,Return_Var
            #endif
        #endif
    #endif    
ENDSIZE(KYRXOnDelayTable_MACRO)
Endm

#ifMacro- _mKYRXOnDelayTable
KYRXOnDelayTable_Sub: 
STARTSIZE(KYRXOnDelayTable_LIB)
    PRODH = ERead EEPCW_RXONDELAY      '/ Current value in case of error.
    If MacroTemp > 47 Then 
        If MacroTemp < 58 Then
            WREG = MacroTemp - 48
            PRODH = LookUp WREG,[25,50,75,100,125,150,175,200,225,250] 
        EndIf
    EndIf 
    Return
ENDSIZE(KYRXOnDelayTable_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Compute the value of RXONDelay. 
'* Input    : None                                       
'* Output   : None
'/
$define CalcKYRXOnDelay(pValue) _mCalcKYRXOnDelay pValue

_mCalcKYRXOnDelay Macro- pValue
STARTSIZE(CalcKYRXOnDelay_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mCalcKYRXOnDelay macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mCalcKYRXOnDelay macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,MacroTemp
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,MacroTemp
            #endif
        #endif
    #endif
    GoSub CalcKYRXOnDelay_Sub
ENDSIZE(CalcKYRXOnDelay_MACRO)
Endm

#ifMacro- _mCalcKYRXOnDelay
CalcKYRXOnDelay_Sub:
STARTSIZE(CalcKYRXOnDelay_LIB)
    RXONDelay = MacroTemp * 4
'    RXONDelay2 = (MacroTemp * 480) / 100   '/ (RXONDelay * 145200) / 1200 
    Return
ENDSIZE(CalcKYRXOnDelay_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Check a number validity 0 to 9. 
'* Input    : None                                       
'* Output   : None
'/
$define CheckNumber(pValue) _mCheckNBInput pValue

_mCheckNBInput Macro- pValue
STARTSIZE(CheckNBInput_Sub_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mCheckNBInput macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Byte)
            #error "_mCheckNBInput macro - (Param1) Should be Byte variable"
            Exitm
        #else
            Byte_Byte pValue,MacroTemp
        #endif
    #endif
    GoSub CheckNBInput_Sub
    #if (_mCheckNBInput_RETURN != 1)
        #error "_mCheckNBInput - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mCheckNBInput - Return variable should be a Byte variable"
            Exitm
        #else
            Wreg_Byte Return_Var
        #endif
    #endif    
ENDSIZE(CheckNBInput_Sub_MACRO)
Endm

#ifMacro- _mCheckNBInput
CheckNBInput_Sub:
    STARTSIZE(CheckNBInput_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    If MacroTemp < 48 Then '/ Checking correct ASCII byte.
        WREG = 255
        Return
    EndIf
    If MacroTemp > 57 Then '/ Checking correct ASCII byte.
        WREG = 255
        Return
    EndIf
    WREG = MacroTemp - 48  '/ Transform ASCIi to number.
    Return
    ENDSIZE(CheckNBInput_LIB)
#endIfMacro-
'/==============================================================================
HRS_TONE_Sub:
    If F_EnableTone = 1 Then
        HRSFStrg(KYSTRG41,0)   '/ "TONE"
        HRSFStrg(KYSTRG39,1)   '/ " ENABLED"    
    Else
        HRSFStrg(KYSTRG41,0)   '/ "TONE"
        HRSFStrg(KYSTRG40,1)   '/ " DISABLED"    
    EndIf
    Return
'/------------------------------------------------------------------------------
HRS_BEACON_Sub:
    If F_EnableBeacon = 1 Then
        HRSFStrg(KYSTRG42,0)   '/ "BEACON"
        HRSFStrg(KYSTRG39,0)   '/ " ENABLED"   
        HRSOut ": ",Dec BeaconDelay," Sec",CR
    Else
        HRSFStrg(KYSTRG42,0)   '/ "BEACON"    
        HRSFStrg(KYSTRG40,1)   '/ " DISABLED" 
    EndIf
    Return
'/------------------------------------------------------------------------------
HRS_PTT_Sub:    
    If F_EnablePTT = 1 Then
        HRSFStrg(KYSTRG45,0)   '/ "PTT"
        HRSFStrg(KYSTRG39,1)   '/ " ENABLED" 
    Else
        HRSFStrg(KYSTRG45,0)   '/ "PTT"    
        HRSFStrg(KYSTRG40,1)   '/ " DISABLED" 
    EndIf
    Return
'/------------------------------------------------------------------------------
HRS_DDRATIO_Sub:    
    If F_DashDotRatio = 1 Then
        HRSFStrg(KYSTRG36,1)   '/ "DASH/DOT RATIO 1:4"
    Else
        HRSFStrg(KYSTRG37,1)   '/ "DASH/DOT RATIO 1:3"    
    EndIf    
    Return
'/------------------------------------------------------------------------------
HRS_MUTE_Sub:
    If F_EnableMUTE = 1 Then
        HRSFStrg(KYSTRG43,0)   '/ "MUTE"
        HRSFStrg(KYSTRG39,1)   '/ " ENABLED" 
    Else
        HRSFStrg(KYSTRG43,0)   '/ "MUTE"    
        HRSFStrg(KYSTRG40,1)   '/ " DISABLED" 
    EndIf  
    Return
'/------------------------------------------------------------------------------
HRS_FARNSWORTH_Sub:
    If F_FarnsworthSpacing = 1 Then
        HRSFStrg(KYSTRG76,0)   '/ "FARNWORTH"
        HRSFStrg(KYSTRG39,0)   '/ " ENABLED" 
        CWResultByte = ERead EEPCW_FARNSWORTHSP
        HRSOut " ",Dec CWResultByte
        HRSFStrg(KYSTRG94,1)   '/ "% of WPM"         
    Else
        HRSFStrg(KYSTRG76,0)   '/ "FARNWORTH"         
        HRSFStrg(KYSTRG40,1)   '/ " DISABLED" 
    EndIf
    Return
'/------------------------------------------------------------------------------
HRS_CONSTESTMODE_Sub:
    If F_ContestMode = 1 Then
        HRSFStrg(KYSTRG87,0)   '/ "CONTEST MODE"
        HRSFStrg(KYSTRG39,1)   '/ " ENABLED" 
    Else
        HRSFStrg(KYSTRG87,0)   '/ "CONTEST MODE"         
        HRSFStrg(KYSTRG40,1)   '/ " DISABLED" 
    EndIf
    Return
'/------------------------------------------------------------------------------
HRS_KEYERMODE_Sub:
    If F_UltimaticMode = 1 Then
        HRSFStrg(KYSTRG46,0)   '/ "ULTIMATIC"
        HRSFStrg(KYSTRG39,1)   '/ " ENABLED" 
    Else
        If F_IambicMode = 1 Then
            HRSFStrg(KYSTRG47,0)   '/ "IAMBIC B"
            HRSFStrg(KYSTRG39,1)   '/ " ENABLED" 
        Else
            HRSFStrg(KYSTRG60,0)   '/ "IAMBIC A"          
            HRSFStrg(KYSTRG39,1)   '/ " ENABLED" 
        EndIf        
    EndIf
    Return
'/------------------------------------------------------------------------------
HRS_URCALLSIGN_Sub:
    If F_WordSpacing = 0 Then
        F_EnableLoadUrCallSign = 0
        HRSFStrg(KYSTRG65,0)   '/ "WORD SPACING OPTION"          
        HRSFStrg(KYSTRG40,1)   '/ " DISABLED"     
    EndIf
    If F_EnableLoadUrCallSign = 1 Then
        HRSFStrg(KYSTRG55,0)   '/ "LOAD UR CALLSIGN"
        HRSFStrg(KYSTRG39,1)   '/ " ENABLED" 
    Else
        HRSFStrg(KYSTRG55,0)   '/ "LOAD UR CALLSIGN"          
        HRSFStrg(KYSTRG40,1)   '/ " DISABLED" 
    EndIf
    Return
'/------------------------------------------------------------------------------
HRS_WORDSPACING_Sub:
    If F_WordSpacing = 1 Then
        HRSFStrg(KYSTRG65,0)   '/ "WORD SPACING OPTION"
        HRSFStrg(KYSTRG39,1)   '/ " ENABLED" 
    Else
        F_EnableLoadUrCallSign = 0
        HRSFStrg(KYSTRG65,0)   '/ "WORD SPACING OPTION"          
        HRSFStrg(KYSTRG40,1)   '/ " DISABLED" 
        HRSFStrg(KYSTRG55,0)   '/ "LOAD UR CALLSIGN"          
        HRSFStrg(KYSTRG40,1)   '/ " DISABLED" 
    EndIf
    Return
'/------------------------------------------------------------------------------
HRS_SORTNUMBERS_Sub:
    If F_ShortNumbers = 1 Then
        HRSOut "["
        HRSFStrg(KYSTRG79,0)   '/ "SHORT NUMBERS OPTION"
        HRSFStrg(KYSTRG39,0)   '/ " ENABLED" 
        HRSOut "] "
    Else
        HRSOut "["
        HRSFStrg(KYSTRG79,0)   '/ "SHORT NUMBERS OPTION"          
        HRSFStrg(KYSTRG40,0)   '/ " DISABLED" 
        HRSOut "] "
    EndIf
    Return
'/------------------------------------------------------------------------------
'/==============================================================================
'* Purpose : Check all buttons OFF
'* Input   : none                                       
'* Output  : none
'* Note    : Security control of Buttons. 
'/
$define CheckAllButtonsOFF() _mCheckAllButtonsOFF

_mCheckAllButtonsOFF Macro- 
    GoSub CheckAllButtonsOFF_Sub
Endm

#ifMacro- _mCheckAllButtonsOFF
CheckAllButtonsOFF_Sub:
    GIE_Save()                  '/ Save & Clear GIE
    High StatusLED
    While ButtonFUNCTION = 0
        #ifdef Watchdog_req
        Clrwdt
        #endif     
        DelayMS 10
    Wend
    GIE_Restore()               '/ Restore GIE    
    StatusLED = 0               '/ All buttons OFF the Led status => OFF
    Return
#endIfMacro-
    
'/==============================================================================
'* Purpose : Compute a list of Goto's.
'* Input   : none                                       
'* Output  : none
'* Note    :  
'/
    Symbol ST_START_KEYER2    = 0
    Symbol ST_EXITLOOPCFG     = 1
    Symbol ST_EXITLOOPCFG2    = 2    
    Symbol ST_ENDCONFIG       = 3
    Symbol ST_READALLMESSAGES = 4
    Symbol ST_STARTCONFIG2    = 5    

$define ReturnState(pValue) ReturnStateVar = pValue

'/==============================================================================
'* Purpose : Clear memory Paddles
'* Input   : none                                       
'* Output  : none
'* Note    :  
'/
$define ClearKeyFlags() PaddleStates = 0

'/==============================================================================
'* Purpose : Read memory Paddles
'* Input   : none                                       
'* Output  : none
'* Note    :  
'/
'    $define IP_DOT  PORTB.4     '/ [Input] Dot-paddle
'    $define IP_DASH PORTB.5     '/ [Input] Dash-paddle

$define ReadPaddles()   '
    If IP_DOT = 0 Then  '
        F_Dot_Mem = 1   '
    EndIf               '
    If IP_DASH = 0 Then '
        F_Dash_Mem = 1  '
    EndIf    

'/==============================================================================
(*
    It is very common to send RST reports in abbreviated form, for example 599, is sent as
    5NN. "N" in place of the number "9". Also another time saver is for the zero using a
    long "T". "T" is sent in place of the number zero as in " POWER HR IS 3TT WATTS".
    There is a number code for all numbers; however, the N and T codes are the most
    common ones.
    Also CW stations sometimes report their zones as "A4" or "A5" instead of sending "14"
    or "15". 1 = A, 2 = U, 3 = V, 4 = 4, 5 = E, 6 = 6, 7 = B, 8 = D, 9 = N, 0 = T
*)
'/------------------------------------------------------------------------------
'* Purpose : Transform numbers to an abbreviated form for contest for example.
'* Input   : None                                       
'* Output  : None
'* Note    : In contest mode the numbers could be different.
'/         : Use macro (SNUM) to start transformation and (CNUM) to stop it in
'/           the text message.
'/ 
'    LocalByte0(SNCWData)
    Dim SNCWData As Byte

$define WriteShortNumbers() _mWriteShortNumbers

_mWriteShortNumbers Macro-
    GoSub WriteShortNumbers_Sub
Endm

#ifMacro- _mWriteShortNumbers    
WriteShortNumbers_Sub:
STARTSIZE(WriteShortNumbers_LIB)
    If F_ShortNumbers = 1 Then
        SNCWData = WREG
        Select SNCWData
            Case "0"           
                WREG = "T"    '/ (-) = 0   
            Case "1"
                WREG = "A"    '/ (.-) = 1   
            Case "2"
                WREG = "U"    '/ (..-) = 2
            Case "3"
                WREG = "V"    '/ (...-) = 3                    
'            Case "5"
'                WREG = "S"    '/ (...) = 5    
            Case "7"
                WREG = "B"    '/ (-...) = 7           
            Case "8"
                WREG = "D"    '/ (-..) = 8          
            Case "9"           
                WREG = "N"    '/ (-.) = 9                      
            Case Else
                WREG = SNCWData
        EndSelect
    EndIf
    Return
ENDSIZE(WriteShortNumbers_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose : Running the Timer for CW pulses.
'* Input   : none                                       
'* Output  : None
'* Note    :  
'/
'/ Assembler macro. For lower code.
$define KYStartTimer2(pValue) _mKYStartTimer2 pValue

_mKYStartTimer2 Macro- pValue
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mKYStartTimer macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Word) && (Prm_1 != Num16)
            #error "_mKYStartTimer Macro - Input Value(Param1) Should be a Byte Variable or a Num8"
            Exitm
        #else    
            #if (Prm_1 == Word)
                Word_Word pValue,CWPTTCounter
            #endif
            #if (Prm_1 == Num16)
                Num_Word pValue,CWPTTCounter
            #endif     
            #if (Prm_1 == Byte)
                Byte_Word pValue,CWPTTCounter
            #endif
            #if (Prm_1 == Num8)
                Num_Word pValue,CWPTTCounter
            #endif            
            GoSub KYStartTimer_Sub
        #endif
    #endif
Endm

#ifMacro- _mKYStartTimer2,_mKYStartTimer2CP 
KYStartTimer_Sub:
    STARTSIZE(KYStartTimer_LIB)
    F_CWCounter = 1
    F_ClearPTT = 1
    KYClearTimer2Flag()
    KYTimer2ON()
    Return
    ENDSIZE(KYStartTimer_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------
    '/ Save_FSR2 Word variable used as temporal variable.

'/ Assembler macro. For lower code.
$define KYStartTimer2CP(pValue) _mKYStartTimer2CP pValue

_mKYStartTimer2CP Macro- pValue
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mKYStartTimer2CP macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Word) && (Prm_1 != Num16)
            #error "_mKYStartTimer2CP Macro - Input Value(Param1) Should be a Byte Variable or a Num8"
            Exitm
        #else    
            #if (Prm_1 == Word)
                Word_Word pValue,Save_FSR2
            #endif
            #if (Prm_1 == Num16)
                Num_Word pValue,Save_FSR2
            #endif     
            #if (Prm_1 == Byte)
                Byte_Word pValue,Save_FSR2
            #endif
            #if (Prm_1 == Num8)
                Num_Word pValue,Save_FSR2
            #endif            
            GoSub KYStartTimer2CP_Sub
        #endif
    #endif
Endm

'#ifMacro- _mKYStartTimer2CP
'KYStartTimer2CP_Sub:
'    STARTSIZE(KYStartTimer_LIB)
'    If RXONDelay2 > Save_FSR2 Then
'        CWPTTCounter = RXONDelay2 - Save_FSR2 
'    Else
'        CWPTTCounter = 1
'    EndIf
'    GoTo KYStartTimer_Sub
'    ENDSIZE(KYStartTimer_LIB)
'#endIfMacro-

#ifMacro- _mKYStartTimer2CP
KYStartTimer2CP_Sub:
    STARTSIZE(KYStartTimer_LIB)
    If RXONDelay > Save_FSR2 Then
        CWPTTCounter = RXONDelay - Save_FSR2 
    Else
        CWPTTCounter = 1
    EndIf
    GoTo KYStartTimer_Sub
    ENDSIZE(KYStartTimer_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------
'/ Preprocessor macro. For lower code.
$define KYCountTimer2() _mCountTimer2

_mCountTimer2 Macro-
    GoSub CountTimer_Sub
Endm

'#ifMacro- _mCountTimer2
'CountTimer_Sub:
'    STARTSIZE(KYCountTimer_LIB)
'    If KYTimer2Flag = 1 Then
'        KYClearTimer2Flag()
'        If F_SendTone = 1 Then
'            Toggle CWToneOut    '/ Send a tone = 601 Hz
'        EndIf
'        Dec CWPTTCounter
'        If CWPTTCounter = 0 Then
'            KYTimer2OFF()
'            F_CWCounter = 0
'            CWToneOut = 0
'            F_SendTone = 0
'        EndIf
'    EndIf
'    Return
'    ENDSIZE(KYCountTimer_LIB)
'#endIfMacro-

#ifMacro- _mCountTimer2
CountTimer_Sub:
    STARTSIZE(KYCountTimer_LIB)
    If KYTimer2Flag = 1 Then
        KYClearTimer2Flag()
        Dec CWPTTCounter
        If CWPTTCounter = 0 Then
            KYTimer2OFF()
            KYToneOFF()
            CWToneOut = 0
            F_CWCounter = 0
        EndIf
    EndIf
    Return
    ENDSIZE(KYCountTimer_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : TUNE OFF Delays Table.
'* Input    : None                                       
'* Output   : [5,10,15,20,25,30,35,40,45,50] X 100mSec
'/
'$define TuneOFFDelayTable(pValue) _mTuneOFFDelayTable pValue

'_mTuneOFFDelayTable Macro- pValue
'STARTSIZE(TuneOFFDelay_MACRO)
'	#if (Prm_Count != 1)         
'		#error "Incorrect amount of parameters for _mTuneOFFDelayTable macro. 1 Parameter required!"	
'		Exitm
'    #else
'        #if (Prm_1 != Num8) && (Prm_1 != Byte)
'            #error "_mTuneOFFDelayTable macro - (Param1) Should be a Num8 or Byte variable"
'            Exitm
'        #else
'            #if (Prm_1 == Num8)
'            Num_Byte pValue,MacroTemp
'            #endif
'            #if (Prm_1 == Byte)
'            Byte_Byte pValue,MacroTemp
'            #endif
'        #endif
'    #endif
'    GoSub TuneOFFDelayTable_Sub
'    #if (_mTuneOFFDelayTable_RETURN != 1)
'        #error "_mTuneOFFDelayTable - Macro - Mandatory return parameter misssing"
'        Exitm
'    #else
'        #if (Return_Type != Byte)
'            #error "_mTuneOFFDelayTable - Return variable should be a Byte variable"
'            Exitm
'        #else
'            Byte_Byte PRODH,Return_Var
'        #endif
'    #endif    
'ENDSIZE(TuneOFFDelay_MACRO)
'Endm

'#ifMacro- _mTuneOFFDelayTable
'TuneOFFDelayTable_Sub: 
'STARTSIZE(TuneOFFDelay_LIB)
'    PRODH = ERead EEPCW_TUNEOFFDELAY       '/ Current value in case of error.
'    If MacroTemp > 47 Then 
'        If MacroTemp < 58 Then 
'            WREG = MacroTemp - 48
'            PRODH = LookUp WREG,[5,10,15,20,25,30,35,40,45,50]
'        EndIf
'    EndIf 
'    Return
'ENDSIZE(TuneOFFDelay_LIB)
'#endIfMacro-

'/==============================================================================
'* Purpose  : Word Space Adjustment Table.
'* Input    : 0,1,2,3,4,5,6,7,8,9                                       
'* Output   : [0,5,10,15,20,25,30,35,40,45] % of WDSPACE
'/ Note:
'/
$define WordSpaceAdjTable(pValue) _mWordSpaceAdjTable pValue

_mWordSpaceAdjTable Macro- pValue
STARTSIZE(WordSpaceAdjTable_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mWordSpaceAdjTable macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mCalcWordSpaceAdjustment macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,MacroTemp
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,MacroTemp
            #endif
        #endif
    #endif
    GoSub WordSpaceAdjTable_Sub
    #if (_mWordSpaceAdjTable_RETURN != 1)
        #error "_mWordSpaceAdjTable - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mWordSpaceAdjTable - Return variable should be a Byte variable"
            Exitm
        #else
            Byte_Byte PRODH,Return_Var
        #endif
    #endif    
ENDSIZE(WordSpaceAdjTable_MACRO)
Endm

#ifMacro- _mWordSpaceAdjTable
WordSpaceAdjTable_Sub: 
STARTSIZE(WordSpaceAdjTable_LIB)
    PRODH = ERead EEPCW_WDSPACE_ADJUSTMENT       '/ Current value in case of error.
    If MacroTemp > 47 Then 
        If MacroTemp < 58 Then 
            WREG = MacroTemp - 48
            PRODH = LookUp WREG,[0,5,10,15,20,25,30,35,40,45]
        EndIf
    EndIf 
    Return
ENDSIZE(WordSpaceAdjTable_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Letter Space Adjustment Table.
'* Input    : 0,1,2,3,4,5,6,7,8,9                                        
'* Output   : [0,5,10,15,20,25,30,35,40,45] % of LTSPACE.
'/ Note:
'/ 
$define LetterSpaceAdjTable(pValue) _mLetterSpaceAdjTable pValue

_mLetterSpaceAdjTable Macro- pValue
STARTSIZE(LetterSpaceAdjTable_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mLetterSpaceAdjTable macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mLetterSpaceAdjTable macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,MacroTemp
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,MacroTemp
            #endif
        #endif
    #endif
    GoSub LetterSpaceAdjTable_Sub
    #if (_mLetterSpaceAdjTable_RETURN != 1)
        #error "_mLetterSpaceAdjTable - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mLetterSpaceAdjTable - Return variable should be a Byte variable"
            Exitm
        #else
            #if (Return_Type == Byte)
            Byte_Byte PRODH,Return_Var
            #endif
        #endif
    #endif    
ENDSIZE(LetterSpaceAdjTable_MACRO)
Endm

#ifMacro- _mLetterSpaceAdjTable
LetterSpaceAdjTable_Sub: 
STARTSIZE(LetterSpaceAdjTable_LIB)
    PRODH = ERead EEPCW_LTSPACE_ADJUSTMENT       '/ Current value in case of error.
    If MacroTemp > 47 Then 
        If MacroTemp < 58 Then 
            WREG = MacroTemp - 48
            PRODH = LookUp WREG,[0,5,10,15,20,25,30,35,40,45]
        EndIf
    EndIf 
    Return                           
ENDSIZE(LetterSpaceAdjTable_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Farnsworth spacing
'* Input    : 0 to 31                                       
'* Output   : [95,90,85,80,75,70,65,60,55,50] % of WPM]
'/ Note:      -5% WPM step
'/ 
$define FarnsworthSpacingTable(pValue) _mFarnsworthSpacingTable pValue

_mFarnsworthSpacingTable Macro- pValue
STARTSIZE(FarnsworthSpacing_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mFarnsworthSpacingTable macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mFarnsworthSpacingTable macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,MacroTemp
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,MacroTemp
            #endif
        #endif
    #endif
    GoSub FarnsworthSpacingTable_Sub
    #if (_mFarnsworthSpacingTable_RETURN != 1)
        #error "_mFarnsworthSpacingTable - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mFarnsworthSpacingTable - Return variable should be a Byte variable"
            Exitm
        #else
            #if (Return_Type == Byte)
            Byte_Byte PRODH,Return_Var
            #endif
        #endif
    #endif    
ENDSIZE(FarnsworthSpacing_MACRO)
Endm

#ifMacro- _mFarnsworthSpacingTable
FarnsworthSpacingTable_Sub: 
STARTSIZE(FarnsworthSpacing_LIB)
    PRODH = ERead EEPCW_FARNSWORTHSP    '/ Current value in case of error.
    If MacroTemp > 47 Then 
        If MacroTemp < 58 Then 
            WREG = MacroTemp - 48
            PRODH = LookUp WREG,[95,90,85,80,75,70,65,60,55,50] '/ % of WPM
        EndIf
    EndIf 
    Return 
ENDSIZE(FarnsworthSpacing_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Looking for the E2P address address.
'* Input    : Number of message.                                       
'* Output   : eeprom address (0 to 1024)
'/ Note     :   
'/
    LocalByte0(IndexTableE2P)
    $if _eeprom > 256
    LocalWord0(RltE2PAddress)    
    $else
    LocalByte1(RltE2PAddress)    
    $endif

$define TableE2PAddress(pValue) _mTableE2PAddress pValue

_mTableE2PAddress Macro- pValue
STARTSIZE(TableE2PAddress_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mTableE2PAddress macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mTableE2PAddress macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,IndexTableE2P 
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,IndexTableE2P
            #endif
        #endif
    #endif
    GoSub TableE2PAddress_Sub
    $if _eeprom > 256
        #if (_mTableE2PAddress_RETURN != 1)
            #error "_mTableE2PAddress - Macro - Mandatory return parameter misssing"
            Exitm
        #else
            #if (Return_Type != Word)
                #error "_mTableE2PAddress - Return variable should be a Word variable"
                Exitm
            #else
                Word_Word RltE2PAddress,Return_Var
            #endif
        #endif
    $else
        #if (_mTableE2PAddress_RETURN != 1)
            #error "_mTableE2PAddress - Macro - Mandatory return parameter misssing"
            Exitm
        #else
            #if (Return_Type != Byte)
                #error "_mTableE2PAddress - Return variable should be a Byte or Word variable"
                Exitm
            #else
                Byte_Byte RltE2PAddress,Return_Var
            #endif
        #endif    
    $endif
ENDSIZE(TableE2PAddress_MACRO)
Endm

#ifMacro- _mTableE2PAddress
TableE2PAddress_Sub: 
STARTSIZE(TableE2PAddress_LIB)
    RltE2PAddress = 0        '/ Output value in case of error.
    RltE2PAddress = LookUpL IndexTableE2P,[MSG0,MSG1,MSG2,MSG3,MSG4,MSG5,MSG6,_
    MSG7,MSG8,MSG9,MSG10,MSG11,MSG12,MSG13,MSG14,MSG15]  
    Return    
ENDSIZE(TableE2PAddress_LIB)
#endIfMacro- 
'/==============================================================================
'* Purpose  : print Marks to the terminal to indicate the lenght of every memory..
'* Input    : None                                       
'* Output   : None
'/ Note     :   
'/ 
$define PrintMarks1() _mPrintMarks1

_mPrintMarks1 Macro-
    GoSub PrintMarks1_Sub
Endm

#ifMacro- _mPrintMarks1
PrintMarks1_Sub:
STARTSIZE(PrintMarks1_LIB)
    '/ Print marks [#] for different lenght of messages: 32 Bytes.
    For PRODH = 0 To 16
        HRSOut "*"
    Next
    For PRODH = 0 To 30
        HRSOut "-"        
    Next
    HRSOut "#"
    HRSOut CR
    Return
ENDSIZE(PrintMarks1_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------
$define PrintMarks2() _mPrintMarks2

_mPrintMarks2 Macro-
    GoSub PrintMarks2_Sub
Endm

#ifMacro- _mPrintMarks2
PrintMarks2_Sub:
STARTSIZE(PrintMarks2_LIB)
    '/ Print marks [#] for different lenght of messages: 30,64 Bytes.
    For PRODH = 0 To 16
        HRSOut "*"
    Next
    For PRODH = 0 To 63
        If PRODH = 31 Then
            HRSOut "#"
        ElseIf PRODH = 63 Then
            HRSOut "#"        
        Else
            HRSOut "-"        
        EndIf
    Next
    HRSOut CR
    Return
ENDSIZE(PrintMarks2_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Looking for the eeprom message length.
'* Input    : NBMessageToSend (Byte)                                      
'* Output   : Return_Var (Byte) 
'/ Note     :   
'/
    LocalByte0(IndexTableE2PLt)
    LocalByte1(RltE2PLenght)    

$define TableE2PMsgLength(pValue) _mTableE2PMsgLength pValue

_mTableE2PMsgLength Macro- pValue
STARTSIZE(TableE2PMsgLength_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mLookingForEEPMsgLength macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mTableE2PMsgLength macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,IndexTableE2PLt 
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,IndexTableE2PLt
            #endif
        #endif
    #endif
    GoSub TableE2PMsgLength_Sub
    '/ The return value is in WREG.
    #if (_mTableE2PMsgLength_RETURN != 1)
        #error "_mTableE2PMsgLength - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mTableE2PMsgLength - Return variable should be a Byte variable"
            Exitm
        #else
            Byte_Byte RltE2PLenght,Return_Var
        #endif
    #endif
ENDSIZE(TableE2PMsgLength_MACRO)
Endm
 
#ifMacro- _mTableE2PMsgLength
TableE2PMsgLength_Sub: 
STARTSIZE(TableE2PMsgLength_LIB)
    RltE2PLenght = __CW_MSGLenght0
    RltE2PLenght = LookUp IndexTableE2PLt,[__CW_MSGLenght0,__CW_MSGLenght1,__CW_MSGLenght2,_
    __CW_MSGLenght3,__CW_MSGLenght4,__CW_MSGLenght5,__CW_MSGLenght6,__CW_MSGLenght7,_
    __CW_MSGLenght8,__CW_MSGLenght9,__CW_MSGLenght10,__CW_MSGLenght11,__CW_MSGLenght12,_
    __CW_MSGLenght13,__CW_MSGLenght14,__CW_MSGLenght15]  
    Return 
ENDSIZE(TableE2PMsgLength_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Read CData strings in ROM & write the characters to the eeprpom.
'* Input    : Number of ROM block, Number of EEPROM block                                      
'* Output   : Write to Eeprom messages blocks.
'/ Note     : Input numbers only
'/
    Dim MSgROMAddressX As Word
    Dim NbROMBlockX As Byte
    Dim NbE2PBlockX As Byte
    Dim NbCHaractersX As Byte        
 
'/ Number of BLOCKS         0 TO 15    0, 1, 2
$define LoadROMBLOCKStoE2P(pROMBlock,pE2PBlock) _mLoadROMBLOCKStoE2P pROMBlock,pE2PBlock
    
_mLoadROMBLOCKStoE2P Macro- pROMBlock,pE2PBlock
	#if (Prm_Count != 2)         
		#error "Incorrect amount of parameters for _mLoadROMBLOCKStoE2P macro. 1 Parameter required!"	
		Exitm
    #else
    	#if (Prm_1 != Num8) && (Prm_1 != Byte)
    		#error "_mLoadROMBLOCKStoE2P- Macro - (First Char) should be a Num8 or Byte!"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pROMBlock,NbROMBlockX
            #endif 
            #if (Prm_1 == Byte)
            Byte_Byte pROMBlock,NbROMBlockX
            #endif 
        #endif       
    	#if (Prm_2 != Num8) && (Prm_2 != Byte)
    		#error "_mLoadROMBLOCKStoE2P - Macro - (Second Char) should be a Num8 or Byte!"
            Exitm
        #else
            #if (Prm_2 == Num8)
            Num_Byte pE2PBlock,NbE2PBlockX
            #endif 
            #if (Prm_2 == Byte)
            Byte_Byte pE2PBlock,NbE2PBlockX
            #endif 
        #endif
    #endif
    GoSub LoadROMMsgToE2P_Sub    
Endm

#ifMacro- _mLoadROMBLOCKStoE2P
LoadROMMsgToE2P_Sub:
    #ifdef Watchdog_req
    Clrwdt
    #endif
    TBLPTRU = 0
    F_KeyerMemoryError = 0
    '/ Checking the correct values.
    If NbE2PBlockX > CstNbE2PBlockMax - 1 Then
        HRSOut "Incorrect number of EEP Block for _mLoadROMBLOCKStoE2P Macro!",CR
        F_KeyerMemoryError = 1
        Return      '/ Exit this routine.
    EndIf
    If NbROMBlockX > CstNbROMBlockMax - 1 Then
        HRSOut "Incorrect number of ROM Block for _mLoadROMBLOCKStoE2P Macro!",CR
        F_KeyerMemoryError = 1
        Return      '/ Exit this routine.
    EndIf
    '/--------------------------------------------------------------------------
    NbCHaractersX = 0
    '/--------------------------------------------------------------------------
    '/ First message in the eeprom block.
    NBMessageToSend = NbE2PBlockX * CstNbMsgPerBlockMax    '/ First message to write. Number message destination in eeprom.
    TableResult = TableE2PAddress(NBMessageToSend)      '/ NBMessageToSend => TableResult (EEP address) Looking for the Eeprom address.
    '/ First message in the ROM Block.
    CWLoop = 0                          '/ Number of FIRST message in the ROM Block.    
    GoSub ReadROMAddress_Sub            '/ NbROMBlock => MSgROMAddress[CWLoop]
    '/--------------------------------------------------------------------------
    '/ Copy the ROM string to eeprom string.
    Do
        #ifdef Watchdog_req
        Clrwdt
        #endif
        '/----------------------------------------------------------------------
        '/ Reading from ROM => Origin. 
        CWRecChar  = cPtr8(MSgROMAddressX++) '/ Retrieve from Cdata table with post increment
        '/----------------------------------------------------------------------
        '/ Writing to EEPROM => destination.
        '/ Checking the number of characters because the slots messages have a limited space.
        '/ Input: NBMessageToSend => Return (Message Lenght)=> CWData
        CWData = TableE2PMsgLength(NBMessageToSend)      
        Inc NbCHaractersX
        If NbCHaractersX > (CWData - 1) Then
            EWrite TableResult,[0]          '/ Error then Write a final string array to eeprom 
            HRSFStrg(KYSTRG48,1)   '/ HRSOut "TOO MUCH CHARACTERS FOR THIS EEPROM MEMORY MESSAGE",CR,CR           
            Return                          '/ Exit this routine.
        EndIf
        '/----------------------------------------------------------------------
        '/ Write data to eeprom.
        EWrite TableResult,[CWRecChar]      '/ Write the ASCII character to eeprom 
        If CWRecChar = 0 Then               '/ Is the final string in ROM detected?
            NbCHaractersX = 0
            Inc NBMessageToSend             '/ Increment next message in eeprom to write.
            TableResult = TableE2PAddress(NBMessageToSend)  '/ Looking for the next message Eeprom address. 
            Inc CWLoop                      '/ Increment address to next string in ROM.
            If CWLoop > (CstNbMsgPerBlockMax - 1) Then Return       '/ Numbers of messages MAX in a rom/eeprom Block. (0 to 4) => 5 max.           
            GoSub ReadROMAddress_Sub        '/ Next message in the ROM Block.
        Else
            Inc TableResult '/ Next address to write to eeprom.
        EndIf
    Loop
'    Return
'/------------------------------------------------------------------------------
'/ Reading the Address of ROM message.
ReadROMAddress_Sub:
    '/ Looking for the ROM address. NbROMBlock => MSgROMAddress.
    Select NbROMBlockX
        Case 0
            MSgROMAddressX = CRead16 KYMessagesTable0[CWLoop]  '/ Point to the next message address.
        Case 1
            MSgROMAddressX = CRead16 KYMessagesTable1[CWLoop]  '/ Point to the next message address.            
        Case 2
            MSgROMAddressX = CRead16 KYMessagesTable2[CWLoop]  '/ Point to the next message address.
        Case 3
            MSgROMAddressX = CRead16 KYMessagesTable3[CWLoop]  '/ Point to the next message address.
        Case 4
            MSgROMAddressX = CRead16 KYMessagesTable4[CWLoop]  '/ Point to the next message address.
        Case 5
            MSgROMAddressX = CRead16 KYMessagesTable5[CWLoop]  '/ Point to the next message address.                
        Case 6
            MSgROMAddressX = CRead16 KYMessagesTable6[CWLoop]  '/ Point to the next message address.  
        Case 7
            MSgROMAddressX = CRead16 KYMessagesTable7[CWLoop]  '/ Point to the next message address.  
        Case 8
            MSgROMAddressX = CRead16 KYMessagesTable8[CWLoop]  '/ Point to the next message address.  
        Case 9
            MSgROMAddressX = CRead16 KYMessagesTable9[CWLoop]  '/ Point to the next message address.  
        Case 10
            MSgROMAddressX = CRead16 KYMessagesTable10[CWLoop]  '/ Point to the next message address.  
        Case 11
            MSgROMAddressX = CRead16 KYMessagesTable11[CWLoop]  '/ Point to the next message address.  
        Case 12
            MSgROMAddressX = CRead16 KYMessagesTable12[CWLoop]  '/ Point to the next message address.  
        Case 13
            MSgROMAddressX = CRead16 KYMessagesTable13[CWLoop]  '/ Point to the next message address.  
        Case 14
            MSgROMAddressX = CRead16 KYMessagesTable14[CWLoop]  '/ Point to the next message address.  
        Case 15
            MSgROMAddressX = CRead16 KYMessagesTable15[CWLoop]  '/ Point to the next message address.  
        Case 16
            MSgROMAddressX = CRead16 KYMessagesTable16[CWLoop]  '/ Point to the next message address.  
        Case 17
            MSgROMAddressX = CRead16 KYMessagesTable17[CWLoop]  '/ Point to the next message address.  
        Case 18
            MSgROMAddressX = CRead16 KYMessagesTable18[CWLoop]  '/ Point to the next message address.  
        Case 19
            MSgROMAddressX = CRead16 KYMessagesTable19[CWLoop]  '/ Point to the next message address.  
    EndSelect    
    Return
#endIfMacro-    
'/==============================================================================
'* Purpose  : Convert the CW code to ASCII byte.
'* Input    : None                                       
'* Output   : None
'/ Note     : If the input character is not included in the table then an error is sent.
'/          : WREG = "?"
'/
'/ Declare Local Variables.
    LocalByte0(TableCWDataY)
    LocalByte1(TableCWIndexY)    

$define CWCharToAscii(pCWCode) _mCWCharToAscii pCWCode
    
_mCWCharToAscii Macro- pCWCode
STARTSIZE(CWConvertToAscii_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mCWBeacon_Start macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mCWCharToAscii macro - (Param1 CWCode) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pCWCode,TableCWIndexY 
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pCWCode,TableCWIndexY 
            #endif
        #endif
    #endif
    GoSub CWConvertToAscii_Sub
    '/ The Return_Var is not mandatory.
    '/ The return value is in WREG.
    #if (_mCWCharToAscii_RETURN == 1)
        #if (Return_Type != Byte)
            #error "_mCWCharToAscii - Return variable should be a Byte variable"
            Exitm
        #else
            Wreg_Byte Return_Var
        #endif
    #endif
ENDSIZE(CWConvertToAscii_MACRO)
Endm

#ifMacro- _mCWCharToAscii
CWConvertToAscii_Sub:
STARTSIZE(CWConvertToAscii_CODE)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    '/ Go through the string
    '/ Very special characters out of the list.
    Select TableCWIndexY
        Case CW_EOM     '/ CW format.
            WREG = "|"
            Return
    EndSelect    

    '/ See ASCII table. Table Starts with 0.
    TableCWDataY = 255
    '/                               " " 32     ! (33)     "        #     $
    TableCWDataY = LookDown TableCWIndexY,[CW_SPACE,CW_EXCMARK,CW_DQUOTE,CW_AR,CW_DOLLAR,_
    '/ %    &      '         (         )        *     +       ,        -
    CW_KA,CW_KN,CW_SQUOTE,CW_OPAREN,CW_CPAREN,CW_AS,CW_PLUS,CW_COMMA,CW_SEPA2,_
    '/ .      /        0    1    2    3    4    5    6    7    8    9    :
    CW_DOT,CW_FSLASH,CW_0,CW_1,CW_2,CW_3,CW_4,CW_5,CW_6,CW_7,CW_8,CW_9,CW_COLON,_
    '/ ;        <     =        >     ?         @        A    B    C    D    E    F    G
    CW_SCOLON,CW_BK,CW_SEPAR,CW_VE,CW_QMARK,CW_ATSYMB,CW_A,CW_B,CW_C,CW_D,CW_E,CW_F,CW_G,_
    '/ H   I    J    K    L    M    N    O    P    Q    R    S    T    U
    CW_H,CW_I,CW_J,CW_K,CW_L,CW_M,CW_N,CW_O,CW_P,CW_Q,CW_R,CW_S,CW_T,CW_U,_
    '/ V   W    X    Y    Z  [(91)   \(92)   ](93)   ^     _ (95)      96
    CW_V,CW_W,CW_X,CW_Y,CW_Z,CW_AL,CW_BSLASH,CW_AA,CW_SK,CW_UNSCORE,CW_WARNING]
    If TableCWDataY = 255 Then
        WREG = "?"  '/ The CW character is not in the table => error.
    Else
        WREG = TableCWDataY + 32  '/ + Offset to convert to ASCII value.
        '/ The CW ASCII character is in WREG.
    EndIf
    Return       
ENDSIZE(CWConvertToAscii_CODE)
#endIfMacro-
'/==============================================================================
'* Purpose  : Load the RST values from the 3 Decimal encoders for RST value.
'* Input    : Macro RST                                     
'* Output   : CW_StringTemp Array.
'* Note     : 
'/
KYReadRSTEncoders_Sub:
    #ifdef Watchdog_req
    Clrwdt
    #endif
    TRISA = %00111111
    High SWEncoderAddPin0            '/ Address Hundreds digit. 
    High SWEncoderAddPin1
    Low SWEncoderAddPin2
    DelayUS 10
    $ifdef _Proteus
    WREG = ~PORTA                   '/ Read HEX encoder, inverse because the connection.     
    $else
        $ifdef _EncoderCtsOpen
        WREG = ~PORTA               '/ Read HEX encoder with contacts Open, inverse because the connection.  
        $else
        WREG = PORTA                '/ Read DEC encoder with contacts closed.
        $endif
    $endif
    WREG = WREG >> 2
    WREG = WREG & 15
    CW_StringTemp#0 = WREG + 48     '/ ASCII value
    '/--------------------------------------------------------------------------
    Low SWEncoderAddPin0            '/ Address Tens digit.
    High SWEncoderAddPin1
    Low SWEncoderAddPin2
    DelayUS 10
    $ifdef _Proteus
    WREG = ~PORTA                   '/ Read HEX encoder, inverse because the connection.     
    $else
        $ifdef _EncoderCtsOpen
        WREG = ~PORTA               '/ Read HEX encoder with contacts Open, inverse because the connection.  
        $else
        WREG = PORTA                '/ Read DEC encoder with contacts closed.
        $endif
    $endif                   
    WREG = WREG >> 2
    WREG = WREG & 15
    CW_StringTemp#1 = WREG + 48     '/ ASCII value                    
    '/--------------------------------------------------------------------------
    High SWEncoderAddPin0           '/ Address Units digit.
    Low SWEncoderAddPin1
    Low SWEncoderAddPin2
    DelayUS 10
    $ifdef _Proteus
    WREG = ~PORTA                   '/ Read HEX encoder, inverse because the connection.     
    $else
        $ifdef _EncoderCtsOpen
        WREG = ~PORTA               '/ Read HEX encoder with contacts Open, inverse because the connection.  
        $else
        WREG = PORTA                '/ Read DEC encoder with contacts closed.
        $endif
    $endif
    WREG = WREG >> 2
    WREG = WREG & 15
    CW_StringTemp#2 = WREG + 48     '/ ASCII value   
    '/--------------------------------------------------------------------------
    Low SWEncoderAddPin0
    Low SWEncoderAddPin1
    Low SWEncoderAddPin2
    Return
'/==============================================================================
'* Purpose  : Load a string with characters to send and decoding Macros.
'* Input    : eeprom or RAM strings.                                       
'* Output   : CW_StringSend String (ASCII characters)
'* Syntax   : LoadKYMsgToString()
'/
$define LoadKYMsgToString() _mLoadKYMsgToString 

_mLoadKYMsgToString Macro- 
    GoSub LoadKYMsgToString_Sub
Endm

#ifMacro- _mLoadKYMsgToString
LoadKYMsgToString_Sub:
    STARTSIZE(LoadKeyerMsgToString_LIB)
    '/--------------------------------------------------------------------------
    #ifdef Watchdog_req
    Clrwdt
    #endif
    F_KeyerMemoryError = 0
    CWStringDone = 0
    '/ Point to the address of the message in RAM.
    FSR1 = VarPtr(CW_StringSend) '/ (FSR1) Point to the destination string.
    '/--------------------------------------------------------------------------
LoadNewE2PMsg:
    '/ Looking for the address of the string in eeprom.
    '/ Input: NBMessageToSend; Output: TableResult
    TableResult = TableE2PAddress(NBMessageToSend) 
    If TableResult = 0 Then
        HRSOut "ERROR IN LookingForE2PAddress_Sub",CR
    EndIf
    '/ Loop to write the CW_String to Send.
    '/ And read the macros.
    Do
        #ifdef Watchdog_req
        Clrwdt
        #endif
        CWData = ERead TableResult     '/ Retrieve from eeprom.
        Select CWData
            Case 0                      '/ Check if the end of string.
                POSTINC1 = 0            '/ End of String.
                EECON1 = 0              '/ Disable Access Flash memory.
                TBLPTRU = 0             '/ Necessary.
                CWStringDone = 85       '/ Loading CW String is done.                
                Return                  '/ Exit the routine.

            Case 92    '/ "\" Reading a Macro.
                '/ Macros code.
                Inc TableResult                 '/ Next character in the string.
                WREG = ERead TableResult        '/ Reading first character.
                WREG = WREG - 48                '/ Convert ASCII to number.
                NBMacro = WREG * 10             '/ Transform to decimal TENS.
                Inc TableResult                 '/ Next character in the string.
                WREG = ERead TableResult        '/ Reading second character.
                WREG = WREG - 48                '/ Convert ASCII to number.               
                NBMacro =  NBMacro + WREG       '/ Transform to decimal UNITS & Sum.
                POSTINC1 = " "                  '/ Insert a SPACE before the Macros.                
                '/==============================================================  
                '/ Compute the Macros: number 00 to 99.
                '/ The macros must fill the String array with true ASCII characters 
                '/ only, for compatibility with all terminals.
                Select NBMacro
                Case vETX0              '/ Write a Final String to the eeprom messages. (loaded manually)
                    POSTINC1 = 0        '/ 0 => final of string.

                'Case vSTX0              '/ Not used for the moment.    
                    'POSTINC1 = "%"      '/ [KA] [%], PTT ON, Start of message. 
                    'POSTINC1 = PTT1     '/ PTT ON + TXDelay      

                Case vEOT1                  
                    POSTINC1 = "#"      '/ [AR] [#] End of message.
                    POSTINC1 = " "
                    POSTINC1 = "K"
                    POSTINC1 = PTT0     '/ PTT OFF + RXDelay                                

                Case vEOT2              '/ [K] End of Transmision when all messages are gone.
                    POSTINC1 = "K"
                    POSTINC1 = PTT0     '/ PTT OFF + RXDelay
            
                Case vEOT3                  
                    POSTINC1 = "&"      '/ [KN] [&] Go only, invite a specific station To transmit
                    POSTINC1 = PTT0     '/ PTT OFF + RXDelay
            
                Case vEOT4                  
                    POSTINC1 = "<"      '/ [BK] [<] Invite receiving station To transmit
                    POSTINC1 = PTT0     '/ PTT OFF + RXDelay

                Case vEOT5              '/ [SK] [^] Caret End of contact (sent before Call)
                    POSTINC1 = "^"      '/ [SK]
                    POSTINC1 = " "      '/ SPACE
                    POSTINC1 = "E"
                    'POSTINC1 = " "      '/ SPACE                                        
                    POSTINC1 = "E"
                    POSTINC1 = PTT0     '/ PTT OFF + RXDelay

                Case vEOT6              '/ PSE,K,PTT0 End of call.
                    POSTINC1 = "^"      '/ [SK]
                    POSTINC1 = " "      '/ SPACE 
                    POSTINC1 = PTT0     '/ PTT OFF + RXDelay

                Case vEOT7              '/ [AR],SP,PSE,SP,K,PTT0, End of message)
                    POSTINC1 = "#"      '/ [SK]
                    POSTINC1 = " "      '/ SPACE 
                    POSTINC1 = "P"      '/ 
                    POSTINC1 = "S"      '/
                    POSTINC1 = "E"      '/                    
                    POSTINC1 = " "      '/
                    POSTINC1 = "K"      '/ K
                    POSTINC1 = PTT0     '/ PTT OFF + RXDelay

                Case vEOT8              '/ [K] PSE,SP,K End of Transmision. "K"
                    POSTINC1 = "P"      '/ 
                    POSTINC1 = "S"      '/
                    POSTINC1 = "E"      '/                    
                    POSTINC1 = " "      '/
                    POSTINC1 = "K"      '/ K
                    POSTINC1 = PTT0     '/ PTT OFF + RXDelay

                Case vNMSG1              '/ (\17) Send the next message in the memory.
                    '/ There is a space.
                    Inc NBMessageToSend
                    If NBMessageToSend > (__CW_NumberMSGmax - 1)  Then '/ Checking if next memory available?
                        F_SendNewMessage = 0            '/ NO memory available then disable sending.
                        Dec NBMessageToSend             '/ Same message number as before.
                        F_KeyerMemoryError = 1
                        HRSFStrg(KYSTRG35,1)   '/ NO MESSAGE IN THIS MEMORY
                    EndIf   
                    GoTo LoadNewE2PMsg  '/ Start again the code.

                Case vNMSG2              '/ (\18) Send the next message in the memory.
                    '/ There is a space.
                    Inc NBMessageToSend
                    Inc NBMessageToSend
                    If NBMessageToSend > (__CW_NumberMSGmax - 1)  Then '/ Checking if next memory available?
                        F_SendNewMessage = 0            '/ NO memory available then disable sending.
                        Dec NBMessageToSend             '/ Same message number as before.
                        Dec NBMessageToSend             '/ Same message number as before.
                        F_KeyerMemoryError = 1
                        HRSFStrg(KYSTRG35,1)   '/ NO MESSAGE IN THIS MEMORY
                    EndIf   
                    GoTo LoadNewE2PMsg  '/ Start again the code.

                Case vNMSG3              '/ (\19) Send the next message in the memory.
                    '/ There is a space.
                    Inc NBMessageToSend
                    Inc NBMessageToSend
                    Inc NBMessageToSend
                    If NBMessageToSend > (__CW_NumberMSGmax - 1)  Then '/ Checking if next memory available?
                        F_SendNewMessage = 0                    '/ NO memory available then disable sending.
                        NBMessageToSend = NBMessageToSend - 3   '/ Same message number as before.
                        F_KeyerMemoryError = 1
                        HRSFStrg(KYSTRG35,1)   '/ NO MESSAGE IN THIS MEMORY
                    EndIf   
                    GoTo LoadNewE2PMsg  '/ Start again the code.

                Case vURCALL1           '/ Special To Add the "UR CALL SIGN" to the CW_StringSend.
                    If F_URCALLSIGN = 1 Then
                        WREG = POSTDEC1 '/ NO SPACE before URCALL1. Do not increment the String index. 
                        FSR2 = VarPtr(CW_UrCallSignString)  '/ Using FSR2 for UR CALL SIGN.
                        'GoSub KYInsertCallSign_Sub  'KYInsertCallSIgn()  'GoSub KYInsertCallSign_Sub
                        Do
                            #ifdef Watchdog_req
                            Clrwdt
                            #endif
                            If INDF2 > 0 Then       '/ Using FSR2 for UR CALL SIGN.
                                POSTINC1 = POSTINC2
                            Else
                                Return              '/ Exit this loop.
                            EndIf
                        Loop
                    Else
                        '/ String empty.
                        WREG = POSTDEC1 '/ NO SPACE before URCALL1. Do not increment the String index.
                    EndIf

                Case vURCALL2            '/ Special To Add the "UR CALL SIGN" to the CW_StringSend.
                    If F_URCALLSIGN = 1 Then
                        '/ With SPACE space before URCALL
                        FSR2 = VarPtr(CW_UrCallSignString)  '/ Using FSR2 for UR CALL SIGN.
                        'GoSub KYInsertCallSign_Sub  'KYInsertCallSIgn()  'GoSub KYInsertCallSign_Sub
                        Do
                            #ifdef Watchdog_req
                            Clrwdt
                            #endif
                            If INDF2 > 0 Then       '/ Using FSR2 for UR CALL SIGN.
                                POSTINC1 = POSTINC2
                            Else
                                Return              '/ Exit this loop.
                            EndIf
                        Loop
                    Else
                        '/ String empty.
                        WREG = POSTDEC1 '/ NO SPACE before URCALL2. Do not increment the String index.
                    EndIf
            
                Case vMYCALL                    '/ Special to Add the "MY CALL SIGN" to the CW_StringSend
                    KYAddress = EEPCW_MYCALL    '/ Message eeprom address.
                    GoSub KYInsertStringE2p_Sub 'KYInsertStringE2p(EEPCW_MYCALL) 'GoSub KYInsertStringE2p_Sub

                Case vYXX                       '/ Increment & insert the contest number. (max 9999)
                    Inc KYContestNumber
                    If KYContestNumber > 9999 Then
                        KYContestNumber = 0
                    EndIf
                    GoSub KYInsertContestNB_Sub
                                                
                Case vXXX                       '/ Insert the current contest number. (max 9999)
                    GoSub KYInsertContestNB_Sub
            
                Case vQTH                       '/ MYQTH (string)
                    KYAddress = EEPCW_QTH       '/ Insert Message 12 characters from eeprom.
                    GoSub KYInsertStringE2p_Sub 'KYInsertStringE2p(EEPCW_QTH) 'GoSub KYInsertStringE2p_Sub                  
                    
                Case vLOC                       '/ MYQTH LOCATOR. Message 6 characters 
                    KYAddress = EEPCW_QTHLOC    '/ Insert Message from eeprom address.
                    GoSub KYInsertStringE2p_Sub 'KYInsertStringE2p(EEPCW_QTHLOC) 'GoSub KYInsertStringE2p_Sub
                    
                Case vMYNAME                    '/ MY NAME 11 characters String 
                    KYAddress = EEPCW_NAME      '/ Insert Message eeprom address.
                    GoSub KYInsertStringE2p_Sub 'KYInsertStringE2p(EEPCW_NAME) 'GoSub KYInsertStringE2p_Sub

                Case vMYRIG                     '/ MY RIG 11 characters String 
                    KYAddress = EEPCW_RIG       '/ Insert Message from eeprom address.
                    GoSub KYInsertStringE2p_Sub 'KYInsertStringE2p(EEPCW_RIG) 'GoSub KYInsertStringE2p_Sub

                Case vMYANT                     '/ MY ANT 11 characters String 
                    KYAddress = EEPCW_ANT       '/ Insert Message eeprom address.
                    GoSub KYInsertStringE2p_Sub 'KYInsertStringE2p(EEPCW_ANT) 'GoSub KYInsertStringE2p_Sub

                Case vPWR                       '/ MY POWER.
                    KYAddress = EEPCW_PWR       '/ Insert Message eeprom address.
                    GoSub KYInsertStringE2p_Sub 'KYInsertStringE2p(EEPCW_PWR) 'GoSub KYInsertStringE2p_Sub

                Case vSNUM                
                    WREG = POSTDEC1       '/ NO SPACE before SNUM. Do not increment the String index. 
                    POSTINC1 = 126        '/ [~] Tilde character.
                    F_ShortNumbers = 1    '/ Set Flag to send Short Numbers for Contest.

                Case vCNUM                
                    WREG = POSTDEC1       '/ NO SPACE before CNUM. Do not increment the String index.
                    POSTINC1 = 126        '/ [~] Tilde character.
                    F_ShortNumbers = 0    '/ Clear Flag to send Short Numbers for Contest.
                    
                Case vBEACON              '/ Macro to send the same Message forever with 5 seconds stop.
                    WREG = POSTDEC1       '/ NO SPACE before BEACON. Do not increment the String index. 
                    CWCONFIGFlags = ERead EEPCW_CONFIG
                    If F_EnableBeacon = 1 Then 
                        F_KYBeaconStart = 1         '/ Enable to start this message.
                        High StatusLED              '/ Beacon Mode is running.
                    EndIf

                Case vCOPTXT                        '/ Copy the text written in the fisrt part of string.
                    FSR2 = VarPtr(CW_StringSend)    '/ (FSR2) Point to the top of destination string.
                    FSR0 = FSR1                     '/ Save last pointer in the string.
                    Repeat
                        POSTINC1 = POSTINC2     '/ Copy characters.
                    Until FSR2 = FSR0           '/ Copy until to find the last pointer in the String.
                    WREG = POSTDEC1             '/ Update the pointer of current string. (too much space)
                    
                Case vCLURCALL                  '/ Clear all the URCALL parameters.  
                    WREG = POSTDEC1             '/ NO SPACE before CLURCALL, decrement FSR1. 
                    F_URCALLSIGN = 0
                    CW_UrCallSignString#0 = 0   '/ Trick to clear the string.
                    DESpacePointer = 0                       
                    CSWordCounter = 0                    
                    Low StatusLED

                Case vNOMSG       
                    F_KeyerMemoryError = 1          '/ Do not send the bits.
                    HRSFStrg(KYSTRG35,1)   '/ "NO MESSAGE IN THIS MEMORY"                

                Case vRST                         '/ Load the RST values from the Decimal encoders. Write twice.
                    GoSub KYReadRSTEncoders_Sub         
                    POSTINC1 = CW_StringTemp#0      '/ Byte MSB
                    POSTINC1 = CW_StringTemp#1      '/ Byte DSB
                    POSTINC1 = CW_StringTemp#2      '/ Byte LSB              
                    POSTINC1 = " "                  '/ Insert a space.
                    POSTINC1 = CW_StringTemp#0      '/ Byte MSB
                    POSTINC1 = CW_StringTemp#1      '/ Byte DSB
                    POSTINC1 = CW_StringTemp#2      '/ Byte LSB   
                    If CW_StringTemp#1 = "9" Then
                        If CW_StringTemp#2 = "9" Then
                            WREG = POSTDEC1         '/ Decrement FSR1
                            WREG = POSTDEC1         '/ Decrement FSR1 one more.
                            POSTINC1 = "N"          '/ Byte DSB
                            POSTINC1 = "N"          '/ Byte LSB                        
                        EndIf
                    EndIf

                Case vRSTS                          '/ Load the RST values from the Decimal encoders. Write once.
                    GoSub KYReadRSTEncoders_Sub         
                    POSTINC1 = CW_StringTemp#0      '/ Byte MSB
                    POSTINC1 = CW_StringTemp#1      '/ Byte DSB
                    POSTINC1 = CW_StringTemp#2      '/ Byte LSB   
                    If CW_StringTemp#1 = "9" Then
                        If CW_StringTemp#2 = "9" Then
                            WREG = POSTDEC1         '/ Decrement FSR1
                            WREG = POSTDEC1         '/ Decrement FSR1 one more.
                            POSTINC1 = "N"          '/ Byte DSB
                            POSTINC1 = "N"          '/ Byte LSB                        
                        EndIf
                    EndIf

                Case vHCUAGN        '/ (HPE CUAGN) text. Macro because to save bytes in eeprom memory. 
                    POSTINC1 = "H"
                    POSTINC1 = "P"
                    POSTINC1 = "E"                  
                    POSTINC1 = " "
                    POSTINC1 = "C"
                    POSTINC1 = "U"
                    POSTINC1 = "A"                  
                    POSTINC1 = "G"
                    POSTINC1 = "N"
                    
                Case vQSLB          '/ (QSL VIA BURO) text. Macro because to save bytes in eeprom memory.   
                    POSTINC1 = "Q"
                    POSTINC1 = "S"
                    POSTINC1 = "L"                  
                    POSTINC1 = " "
                    POSTINC1 = "V"
                    POSTINC1 = "I"
                    POSTINC1 = "A"                  
                    POSTINC1 = " "
                    POSTINC1 = "B"
                    POSTINC1 = "U"
                    POSTINC1 = "R"                  
                    POSTINC1 = "O"

                Case vS7373         '/ ( 73 73) text. Macro because to save bytes in eeprom memory.   
                    POSTINC1 = "7"
                    POSTINC1 = "3"
                    POSTINC1 = " "                  
                    POSTINC1 = "7"
                    POSTINC1 = "3"

                Case > 50                           '/ Insert a new message pressing MEM Button.(0 to 15)
                    NBMessageToSend  = NBMacro - 51 '/ Number of message to send.                              
                    GoTo LoadNewE2PMsg              '/ Start again the code.
                EndSelect
                '/ End of Macros code.
                '/==============================================================               
            Case Else                               '/ ASCII standard character.
                '/ Now check the standard characters.
                '/--------------------------------------------------------------
                '/ Low Case to High Case.
                If CWData > 96 Then
                    If CWData < 123 Then
                        CWData = CWData - 32
                    EndIf
                EndIf
                '/--------------------------------------------------------------
                WREG = CWData
                '/ In contest mode the numbers could be different.
                WriteShortNumbers() '/ Output WREG.
                POSTINC1 = WREG     '/ Write data into the string.
                '/--------------------------------------------------------------
        EndSelect    
        Inc TableResult             '/ Next ASCII character to read from eeprom.
    Loop
    Return  '/ in case of error.
    ENDSIZE(LoadKeyerMsgToString_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Insert a String from eeprom within the UART transmision.
'* Input    : Address of eeprom                                      
'* Output   : String pointed by POSTINC1
'* Note     : 
'/
#ifMacro- _mLoadKYMsgToString
KYInsertStringE2p_Sub:
STARTSIZE(KYInsertStringE2p_LIB)
    Do
        #ifdef Watchdog_req
        Clrwdt
        #endif
        KYData = ERead KYAddress    '/ Read the call from eeprom.
        If KYData = 0 Then Return
        POSTINC1 = KYData 
        Inc KYAddress
    Loop
ENDSIZE(KYInsertStringE2p_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose  : Beacon Delay Adjustment Table.
'* Input    : 0,1,2,3,4,5,6,7,8,9                                        
'* Output   : [0,5,10,15,20,25,30,35,40,45] % of LTSPACE.
'/ Note:
'/ 
$define BeaconDelayAdjTable(pValue) _mBeaconDelayAdjTable pValue

_mBeaconDelayAdjTable Macro- pValue
STARTSIZE(LetterSpaceAdjTable_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mBeaconDelayAdjTable macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mBeaconDelayAdjTable macro - (Param1) Should be a Num8 or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pValue,MacroTemp
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pValue,MacroTemp
            #endif
        #endif
    #endif
    GoSub BeaconDelayAdjTable_Sub
    #if (_mLetterSpaceAdjTable_RETURN != 1)
        #error "_mBeaconDelayAdjTable - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mBeaconDelayAdjTable - Return variable should be a Byte variable"
            Exitm
        #else
            #if (Return_Type == Byte)
            Byte_Byte PRODH,Return_Var
            #endif
        #endif
    #endif    
ENDSIZE(LetterSpaceAdjTable_MACRO)
Endm

#ifMacro- _mBeaconDelayAdjTable
BeaconDelayAdjTable_Sub: 
STARTSIZE(BeaconDelayAdjTable_LIB)
    PRODH = ERead EEPCW_BEACONDELAY_ADJUSTMENT  '/ Current value in case of error.
    If MacroTemp > 47 Then 
        If MacroTemp < 58 Then 
            WREG = MacroTemp - 48
            PRODH = LookUp WREG,[3,5,7,9,11,13,15,17,19,21]
        EndIf
    EndIf 
    Return                           
ENDSIZE(BeaconDelayAdjTable_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose : Check If BEACON Mode is running To start a delay beetwen messages.
'* Input   : none                                       
'* Output  : Start the TIMER1.
'* Note    : 
'/
$define StartBeaconDelay()  '
If F_KYBeaconStart = 1 Then '
    _mStartBeaconDelay      '
EndIf

_mStartBeaconDelay Macro-
    GoSub KYStartBeaconDelay_Sub 
Endm 

'/ Same timer as Keyer Watchdog is used because it is not running at the same time.
#ifMacro- _mStartBeaconDelay
KYStartBeaconDelay_Sub:
    PIE1Bits_TMR1IE = 0
    T1CONBits_TMR1ON = 0    
    TMR1H = $FF
    Nop
    TMR1L = $FF
    Nop
    PIR1Bits_TMR1IF = 0
    T1CONBits_TMR1ON = 1    '/ Starting to count the delay.
    '/ The Cst_WDTCount value depends of _Xtal (FOSC).
'    KYBeaconCounter = (Cst_WDTCount * 6) / 1000     '/ 5,7 seconds
'    KYBeaconCounter = (Cst_WDTCount * 6) / 965     '/ 6,029 seconds
    KYBeaconCounter = (Cst_WDTCount * BeaconDelay) / 961     '/ 6,029 seconds
    $ifdef __TestBeacon
    High PORTC.5
    $endif
    Return
#endIfMacro-
'/==============================================================================
'* Purpose : Option Beacon Watchdog: Start Counting the timeout.
'* Input   : None                                       
'* Output  : None
'* Note    :  
'/
$define BeaconTimeOut() _mBeaconTimeOut 

_mBeaconTimeOut Macro-
    GoSub Beacon_TimeOut_Sub
Endm

#ifMacro- _mBeaconTimeOut
Beacon_TimeOut_Sub:
    If F_EnableBeacon = 1 Then
        If F_KYBeaconStart = 1 Then
            If PIR1Bits_TMR1IF = 1 Then     '/ Checking the interrupt flag.
                PIR1Bits_TMR1IF = 0
                Dec KYBeaconCounter
                If KYBeaconCounter = 0 Then
                    T1CONBits_TMR1ON = 0    '/ Stop the timer1.
                    F_SendNewMessage = 1    '/ send a new message.
                    F_KYBeaconStart = 0
                    '/ The message number is in NBMessageToSend variable.
                    $ifdef __TestBeacon
                    Low PORTC.5
                    $endif
                EndIf
            EndIf
        EndIf
    EndIf
    Return
#endIfMacro-
'/==============================================================================
'* Purpose : Insert EEPROM String within the keyboard transmision.
'* Input   : none                                       
'* Output  : none
'* Note    : 
'/
'/ Declare Local Variables.
    $if _eeprom > 256
    LocalWord0(KBEEPAddrressW)
    $else
    LocalByte0(KBEEPAddrressW)
    $endif

$define KBReadE2P(pAddress) _mKBReadE2P pAddress

_mKBReadE2P Macro- pAddress
    STARTSIZE(KBReadE2P_MACRO)
	#if (Prm_Count != 1)         
		#error "Incorrect amount of parameters for _mKBReadE2P macro. 1 Parameter required!"	
		Exitm
    #else
    $if _eeprom > 256
        #if (Prm_1 != Num8) && (Prm_1 != Byte) && (Prm_1 != Num16) && (Prm_1 != Word)
            #error "_mKBReadE2P - (Param1) Should be a Num8, Num16, Byte or Word variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Word pAddress,KBEEPAddrressW 
            #endif
            #if (Prm_1 == Byte)
            Byte_Word pAddress,KBEEPAddrressW 
            #endif
            #if (Prm_1 == Num16)
            Num_Word pAddress,KBEEPAddrressW 
            #endif
            #if (Prm_1 == Word)
            Word_Word pAddress,KBEEPAddrressW 
            #endif
        #endif    
    $else
        #if (Prm_1 != Num8) && (Prm_1 != Byte)
            #error "_mKBReadE2P - (Param1) Should be a Num8, or Byte variable"
            Exitm
        #else
            #if (Prm_1 == Num8)
            Num_Byte pAddress,KBEEPAddrressW 
            #endif
            #if (Prm_1 == Byte)
            Byte_Byte pAddress,KBEEPAddrressW 
            #endif            
        #endif    
    $endif
    #endif
    GoSub KBReadE2P_Sub
    ENDSIZE(KBReadE2P_MACRO)
Endm

#ifMacro- _mKBReadE2P
KBReadE2P_Sub:
    STARTSIZE(KBReadE2P_LIB)
    Do
        #ifdef Watchdog_req
        Clrwdt
        #endif
        CWData = ERead KBEEPAddrressW   '/ Read the character into eeprom.
        If CWData > 125 Then EXITKBReadE2P_Sub   '/ Error in ASCII character then Exit the loop.
        If CWData = 0 Then EXITKBReadE2P_Sub     '/ Final string then Exit the loop.
        HRSOut CWData
        GoSub KBSendBits_Sub            '/ Transform one ASCII Byte To dot/dash bits.
        DelayMS Msg_LetterSpaceTime     '/ Delay between characters.
        Inc KBEEPAddrressW
    Loop
EXITKBReadE2P_Sub:
    DelayMS Msg_WordSpaceTime           '/ Delay between Word.
    HRSOut " "
    Return
    ENDSIZE(KBReadE2P_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose : Insert the RST & QSO number in Paddles Mode for contest.
'* Input   : none                                       
'* Output  : none
'* Note    : 
'/
$define CWSendRSTNumberQSO() _mCWSendRSTNumberQSO
    
_mCWSendRSTNumberQSO Macro-
    GoSub CWSendRSTNbQSO_Sub
Endm

#ifMacro- _mCWSendRSTNumberQSO
CWSendRSTNbQSO_Sub:
    STARTSIZE(CWSendRSTNumberQSO_LIB)
    F_EnableLongDash = 0
    Inc KYContestNumber                 '/ Increment the QSO number.
    If KYContestNumber > 9999 Then
        KYContestNumber = 0
    EndIf
    '/--------------------------------------------------------------------------
    Clear CW_StringSend                 '/ Clear the destination string.
    FSR1 = VarPtr(CW_StringSend)
    POSTINC1 = "5"
    POSTINC1 = "N"
    POSTINC1 = "N"
    POSTINC1 = " "               '/ Write a space after RST.
    F_ShortNumbers = 0
    GoSub KYInsertContestNB_Sub
    POSTINC1 = " "
    POSTINC1 = 126                      '/ "~" Tilde character. Insert a Long Dash for "T".
    F_ShortNumbers = 1
    GoSub KYInsertContestNB_Sub    
    POSTINC1 = 126                      '/ "~" Tilde character. Disable the Long Dash.
    POSTINC1 = 0                        '/ Final string.
    F_ShortNumbers = 0
    KYCW_Timings()
    '/ Sending a full message (for RAM strings).

    SumDELAYS = Msg_WordSpaceTrueTime - Msg_LetterSpaceTrueTime
    Sum2DELAYS = Msg_LetterSpaceTrueTime - Msg_DotDashSpaceTime

    LenCWString = Len(CW_StringSend)    '/ Lenght of this new string.
    FSR1 = VarPtr(CW_StringSend)        '/ (FSR1) Point to the string.    
    Repeat                              '/ Go through the string
        #ifdef Watchdog_req
        Clrwdt
        #endif
        CWData = INDF1                  '/ Read the current character from String array.
        If CWData = 126 Then            '/ "~" Tilde character. Insert a Long Dash.
            Toggle F_EnableLongDash
            GoTo CWContinueSendRSTNbQSO '/ Check the next byte.
        EndIf
        HRSOut CWData                   '/ Send all standard ASCII character to the terminal.
        If CWData = " " Then
            DelayMS SumDELAYS           '/ WordSpace
            GoTo CWContinueSendRSTNbQSO '/ Check the next byte.
        EndIf
        '/----------------------------------------------------------------------
        GoSub KBSendBits_Sub    '/ Send every byte.
        '/----------------------------------------------------------------------
        '/ Now that all the dits and dahs are sent...
        DelayMS Sum2DELAYS  '/ LetterSpace DelayMS length of 3 dits        
CWContinueSendRSTNbQSO:
        WREG = POSTINC1     '/ Increment FSR1. 
        Dec LenCWString     '/ Go to the next character of the text.
    Until LenCWString = 0
    HRSOut " "              '/ Insert a space.
    DelayMS SumDELAYS
    Return    
    ENDSIZE(CWSendRSTNumberQSO_LIB)
#endIfMacro-              
'/==============================================================================
'* Purpose : Insert the QSO number
'* Input   : none                                       
'* Output  : none
'* Note    : 
'/
'#ifMacro- _mLoadKYMsgToString
KYInsertContestNB_Sub:
STARTSIZE(KYInsertContestNB_LIB)
    Select KYContestNumber
        Case < 10
            WREG = "0"                  
            WriteShortNumbers()     
            POSTINC1 = WREG             '/ Hundreds
    
            WREG = "0"                  
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            POSTINC1 = WREG             '/ Tens
    
            'WREG = KYContestNumber ? 0
            'WREG = WREG + 48            '/ Conversion to ASCII number.
            WREG = KYContestNumber + 48 '/ Conversion to ASCII number.
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub
            POSTINC1 = WREG             '/ Units

        Case < 100
            WREG = "0"                  
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            POSTINC1 = WREG             '/ Hundreds
    
            WREG = KYContestNumber ? 1
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            POSTINC1 = WREG             '/ Tens
            
            WREG = KYContestNumber ? 0
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            POSTINC1 = WREG             '/ Units

        Case < 1000                             
            WREG = KYContestNumber ? 2
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            POSTINC1 = WREG             '/ Hundreds
    
            WREG = KYContestNumber ? 1
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            POSTINC1 = WREG             '/ Tens
    
            WREG = KYContestNumber ? 0
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            POSTINC1 = WREG             '/ Units
        
        Case < 10000 
            WREG = KYContestNumber ? 3
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            POSTINC1 = WREG             '/ Thousands
    
            WREG = KYContestNumber ? 2
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            POSTINC1 = WREG             '/ Hundreds
    
            WREG = KYContestNumber ? 1
            WREG = WREG + 48
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            POSTINC1 = WREG             '/ Tens
    
            WREG = KYContestNumber ? 0
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            POSTINC1 = WREG             '/ Units        
    EndSelect
    Return
ENDSIZE(KYInsertContestNB_LIB)
'#endIfMacro-
'/==============================================================================
'* Purpose : Insert the contest number by the keyboard
'* Input   : none                                       
'* Output  : Data Port bit.
'* Note    : 
'/
$define KBSendBitsQSONb() _mKBSendBitsQSONb

_mKBSendBitsQSONb Macro-
    GoSub KBSendBitsQSONb_Sub
Endm

#ifMacro- _mKBSendBitsQSONb
KBSendBitsQSONb_Sub:
STARTSIZE(KBInsertQSONb_LIB)
    Select KYContestNumber
        Case < 10
            WREG = "0"                  
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            CWData = WREG           '/ Hundreds
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.
            
            WREG = "0"                  
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            CWData = WREG           '/ Tens
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.
    
            'WREG = KYContestNumber ? 0
            'WREG = WREG + 48            '/ Conversion to ASCII number.
            WREG = KYContestNumber + 48 '/ Conversion to ASCII number.
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub
            CWData = WREG           '/ Units
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.

        Case < 100
            WREG = "0"                  
            WriteShortNumbers() 'GoSub WriteShortNumbers_Sub      
            CWData = WREG           '/ Hundreds
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.
    
            WREG = KYContestNumber ? 1
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers()     
            CWData = WREG               '/ Tens
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.
            
            WREG = KYContestNumber ? 0
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers()      
            CWData = WREG               '/ Units
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.

        Case < 1000                             
            WREG = KYContestNumber ? 2
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers()     
            CWData = WREG               '/ Hundreds
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.
    
            WREG = KYContestNumber ? 1
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers()     
            CWData = WREG               '/ Tens
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.
    
            WREG = KYContestNumber ? 0
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers()     
            CWData = WREG               '/ Units
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.        

        Case < 10000 
            WREG = KYContestNumber ? 3
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers()    
            CWData = WREG               '/ Thousands
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.
    
            WREG = KYContestNumber ? 2
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers()     
            CWData = WREG               '/ Hundreds
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.
    
            WREG = KYContestNumber ? 1
            WREG = WREG + 48
            WriteShortNumbers()    
            CWData = WREG               '/ Tens
            HRSOut CWData
            GoSub KBSendBits_Sub
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.
    
            WREG = KYContestNumber ? 0
            WREG = WREG + 48            '/ Conversion to ASCII number.
            WriteShortNumbers()   
            CWData = WREG               '/ Units
            HRSOut CWData
            GoSub KBSendBits_Sub        '/ Delay 1 Dot.
            DelayMS Msg_LetterSpaceTime '/ Delay 2 Dots.
            DelayMS Msg_WordSpaceTime   '/ Delay 4 Dots.

    EndSelect
    Return
ENDSIZE(KBInsertQSONb_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose : Transform & send an ASCII character to CWDataPin.
'* Input   : CW_StringSend String                                       
'* Output  : Return_Var => 225 error of code.
'* Note    : Calculations are a little different than beacon mode. 
'/
'/ Run the keyer messages program.
(*
$define SendCWBuffer() _mSendCWBuffer
    
_mSendCWBuffer Macro-
    GoSub SendCWBuffer_Sub
    #if (_mSendCWBuffer_RETURN == 1)
        #if (Return_Type != Byte)
            #error "_mCWMSG_CharSend - Return variable should be a Byte variable"
            Exitm
        #else
            Byte_Byte iCW_Exit,Return_Var
        #endif
    #endif
Endm

#ifMacro- _mSendCWBuffer
SendCWBuffer_Sub:
    STARTSIZE(SendCWBuffer_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
'    $ifdef _ANSEL
'    ANSEL = 0
'    $endif
'    $ifdef _ANSELH
'    ANSELH = 0
'    $endif
'    $ifdef _ANSELA
'    ANSELA = 0
'    $endif
'    $ifdef _ANSELB
'    ANSELB = 0
'    $endif
'    $ifdef _ANSELC
'    ANSELC = 0
'    $endif

    CW_Exit = 0
    CWDataPin = 0           '/ CWDataPin for transmitter.
    CWToneOut = 0           '/ Output Tone Pin.
    NbCharsPrinted = 0
    '/--------------------------------------------------------------------------    
    MSGConfigWPM()  'KYMSG_Timings() 'GoSub KYMSG_Timings_Sub
    '/--------------------------------------------------------------------------
    '/ Enable again the MEM Button. Like a debounce system.
'    INTCON3Bits_INT2IF = 0      '/ Clear RB2 interrupt flag for MEM Button.
'    INTCON3Bits_INT2IE = 1      '/ Enable the RB2 interrupt For MEM Button.
    INTCONBits_INT0IE = 1       '/ STOP Button. Enable again the RB0 interrupt. 
    '/--------------------------------------------------------------------------
    '/ Checking if the message in RAM is available.
    If F_KeyerMemoryError = 1 Then
        GoTo KYCWMESSEXIT
    EndIf
    '/--------------------------------------------------------------------------
    '/ Check an error in loading String.
    If CWStringDone <> 85 Then      '/ Has the CW_StringSend been loaded?
        CW_Exit = 225               '/ NO, then Break the infinite loop,
        CWPTT = 0                   '/ Disable the transmitter too.
        #ifdef Hserial_TXSTA
        HRSFStrg(KYSTRG49,AllChars,1)   '/ HRSOut "A CORRECT STRING HAS NOT BEEN LOADED!",CR
        #endif
        GoTo KYCWMESSEXIT           '/ Exit the routine.
    EndIf
    '/--------------------------------------------------------------------------
    '/ Set the PTT with Delay. 
    If F_EnablePTT = 1 Then
        If CWPTT = 0 Then           '/ Avoid to repeat the TXONDelay.
            High CWPTT              '/ Transmitter on, receiver off
            F_ClearPTT = 0          '/ Do not clear the PTT if there is not a specific order.
            DelayMS TXONDelay       '/ Load & Start the TX delay.  
        EndIf
    EndIf
    '/--------------------------------------------------------------------------
    '/ Sending a full message (for RAM strings).
    LenCWString = Len(CW_StringSend)    '/ Lenght of this new string.
    FSR1 = VarPtr(CW_StringSend)        '/ (FSR1) Point to the string.
    Repeat                              '/ Go through the string
        #ifdef Watchdog_req
        Clrwdt
        #endif
        CWData = INDF1                  '/ Read the current character from String array.
        '/----------------------------------------------------------------------
        '/ Looking for specials characters.
        Select CWData                  
            Case 0
                GoTo KYCWMESSEXIT           '/ Exit, end of message.

            Case " "                        '/ Compute a SPACE.
                HRSOut " "                  '/ Send a Space to the terminal too.
                DelayMS Msg_WordSpaceTime       '/ This is a Word Space between characters for 7 dots
                GoTo KYCWCHAREXIT           '/ Continue Repeat/Until to next character. 

'            Case "["                        '/ Macro = PTT OFF
'                GoTo KYCWMESSEXIT           '/ Exit the code.
            '/------------------------------------------------------------------
            '/ Send special characters to the terminal.
            Case "#"
                HRSOut "AR"     '/ [#] End of message.
            Case "*"
                HRSOut "AS"     '/ [*] Stand by.               
            Case "%"
                HRSOut "KA"     '/ [%] Beginning of message, Starting Signal.
            Case "&"
                HRSOut "KN"     '/ [&] Go only, invite a specific station To transmit.
            Case "<"
                HRSOut "BK"     '/ [<] End of transmission. Go only, invite a specific station To transmit.        
            Case "="
                HRSOut "BT"     '/ [=] Double Dash, Pause Or Break. "official" separator.
            Case ">"
                HRSOut "VE"     '/ [>] Understood.
            Case "]"
                HRSOut "AA"     '/ [[] 93 New Line.
            Case "^"
                HRSOut "SK"     '/ [^] End of contact (sent before Call).             
            '/------------------------------------------------------------------
            Case < 33,> 95                  '/ Check if error in character String.
                'CW_CharToSend = CW_ERROR    '/ CW_ERROR => error CW character.
                CW_Exit = 225               '/ Exit an error
                High StatusLED                  '/ Set the LED for error.
                GoTo KYCWCHAREXIT           '/ Goto the next character.
            Case Else
                HRSOut CWData   '/ Send ASCII standard characters to the terminal.
        EndSelect
        '/----------------------------------------------------------------------
        '/ Looking for the CW equivalent of ASCII character.        
        '/ Go through the string.
        CWData = CWData - 33  '/ See ASCII table. Start table with 0.
        '/ With LookUp Table, all CW characters have the same delay.
         '/----------------------------------------------------------------------
        '/ Bits Char           ASCII      ! (33)     "        #      $
        CW_CharToSend = LookUp CWData,[CW_EXCMARK,CW_DQUOTE,CW_AR,CW_DOLLAR,_
        '/ %    &      '         (         )        *     +        ,        -
        CW_KA,CW_KN,CW_SQUOTE,CW_OPAREN,CW_CPAREN,CW_AS,CW_PLUS,CW_COMMA,CW_SEPA2,_
        '/ .      /        0    1    2    3    4    5    6    7    8    9    :
        CW_DOT,CW_FSLASH,CW_0,CW_1,CW_2,CW_3,CW_4,CW_5,CW_6,CW_7,CW_8,CW_9,CW_COLON,_
        '/ ;        <      =       >     ?        @ (64)    A    B    C    D    E    F    G
        CW_SCOLON,CW_BK,CW_SEPAR,CW_VE,CW_QMARK,CW_ATSYMB,CW_A,CW_B,CW_C,CW_D,CW_E,CW_F,CW_G,_
        '/ H   I    J    K    L    M    N    O    P    Q    R    S    T    U
        CW_H,CW_I,CW_J,CW_K,CW_L,CW_M,CW_N,CW_O,CW_P,CW_Q,CW_R,CW_S,CW_T,CW_U,_
        '/ V   W    X    Y    Z  [(91)    \(92)  ](93)   ^     _(95)
        CW_V,CW_W,CW_X,CW_Y,CW_Z,CW_AL,CW_BSLASH,CW_AA,CW_SK,CW_UNSCORE]
        '/----------------------------------------------------------------------
'KYSENDBITSCW:
        '/ This section sends the individual dots and dashs.
        F_StartRead = 0
        CWLoop = 0
        STATUS.0 = 0        '/ Clear the Carry Bit first.
        Repeat              '/ For 8 Bits.
            #ifdef Watchdog_req
            Clrwdt
            #endif
            Rol CW_CharToSend              '/ Rotate all bits to Left through Carry.
            F_SendBits = STATUS.0           '/ Copy the Carry Bit.
            If F_StartRead = 0 Then         '/ Looking for the start bit.
                If F_SendBits = 1 Then
                    F_StartRead = 1         '/ Start bit OK.
                EndIf
                Inc CWLoop                  '/ Use the next bit only?
                Continue                    '/ Do not send CW, Continue looking for bits.
            EndIf
            '/------------------------------------------------------------------
            '/ Send Dot & Dash.             '/ OK there is a bit to send!
            If F_SendBits = 0 Then          '/ Check for dit
'                CWDataPin = 1               '/ Key down CWDataPin
'                $ifdef CWToneOut
'                Sound CWToneOut,[111,Msg_DotTimeTone]    '/ 621 Hz, Output Tone.                 
'                CWToneOut = 0               '/ Because the Output level could stay High.
'                $else
'                DelayMS Msg_DotTime         '/ Wait for one dit                
'                $endif
'                CWDataPin = 0               '/ Unkey CWDataPin
                '/--------------------------------------------------------------
                CWDataPin = 1               '/ Key down CWDataPin
                If F_EnableTone = 1 Then
                    CWPTTCounter = CW_DotTime
                    KYClearTimer2Flag()
                    KYTimer2ON()
                    Do
                        #ifdef Watchdog_req
                        Clrwdt
                        #endif
                        If KYTimer2Flag = 1 Then
                            KYClearTimer2Flag()
                            Toggle CWToneOut    '/ Send a tone = 601 Hz
                            Dec CWPTTCounter
                            If CWPTTCounter = 0 Then
                                KYTimer2OFF()
                                CWToneOut = 0
                                Break
                            EndIf
                        EndIf
                    Loop
                Else
                    DelayMS Msg_DotTime     '/ Wait for one dit
                EndIf
                CWDataPin = 0               '/ Unkey CWDataPin
                '/--------------------------------------------------------------
            Else                            '/ Check for dah
                '/--------------------------------------------------------------
'                CWDataPin = 1               '/ Key down CWDataPin
'                $ifdef CWToneOut
'                Sound CWToneOut,[111,Msg_DashTimeTone]    '/ 621 Hz, Output Tone.                
'                CWToneOut = 0               '/ Because the output level could stay high.
'                $else
'                DelayMS Msg_DashTime         '/ Wait for one dah                
'                $endif
'                CWDataPin = 0               '/ Unkey CWDataPin
                '/--------------------------------------------------------------
                CWDataPin = 1               '/ Key down CWDataPin
                If F_EnableTone = 1 Then
                    CWPTTCounter = CW_DashTime
                    KYClearTimer2Flag()
                    KYTimer2ON()
                    Do
                        #ifdef Watchdog_req
                        Clrwdt
                        #endif
                        If KYTimer2Flag = 1 Then
                            KYClearTimer2Flag()
                            Toggle CWToneOut    '/ Send a tone = 601 Hz
                            Dec CWPTTCounter
                            If CWPTTCounter = 0 Then
                                KYTimer2OFF()
                                CWToneOut = 0
                                Break
                            EndIf
                        EndIf
                    Loop
                Else
                    DelayMS Msg_DotTime     '/ Wait for one dash
                EndIf
                CWDataPin = 0               '/ Unkey CWDataPin
                '/--------------------------------------------------------------
            EndIf
            DelayMS Msg_DotTime             '/ Wait for one dit between Dot/Dash.
            Inc CWLoop                      '/ Next Bit to send.
        Until CWLoop = 8
         '/======================================================================
        '/ Checking special conditions.
        '/ Looking for PTT OFF character. (next character?)
        CWData = PREINC1        '/ Read the next character from String array.
        WREG = POSTDEC1         '/ Then Dec FSR1. Come back To current character.
        If CWData = 91 Then     '/ "[" Macro = PTT OFF           
            HRSOut 91           '/ "["
            SumDELAYS = (Msg_DotTime * 121) / 100   '/ Delay for PTT OFF. (Delay_RXON)             
            F_ClearPTT = 1
            F_PTTCWAlreadySet = 0   '/ Start the RXONDelay.
            GoTo KYCWMESSEXIT       '/ Exit the code.
        EndIf        
        '/======================================================================
        '/ Stop a message between letters with the Stop Button. (memory Keyer)
        If F_ButtonSTOPpressed = 1 Then
            F_ButtonSTOPpressed = 0
            F_KYBeaconStart = 0     '/ Stops the Beacon Watchdog
            F_SendNewMessage = 0    '/ Stops to send a message.
            F_PTTCWAlreadySet = 0   '/ Start the RXONDelay.
            F_ClearPTT = 1
            High StatusLED
            INTCON3Bits_INT2IF = 0  '/ Clear the MEM interrupt flag.            
            While ButtonFUNCTION = 0  '/ Waiting Button depressed.
                #ifdef Watchdog_req
                Clrwdt
                #endif             
            Wend
            StatusLED = 0               '/ Clear Status LED.
            GoTo KYCWMESSEXIT       '/ Fast exit.        
        EndIf
        '/----------------------------------------------------------------------
        '/ Now that all the dits and dahs are sent...
        DelayMS Msg_LetterSpaceTime     '/ DelayMS (1 + 2) = 3, Delay the length of 3 dits
        '/----------------------------------------------------------------------
KYCWCHAREXIT:
        '/----------------------------------------------------------------------
        '/ Check the number of chracters printed
        Inc NbCharsPrinted
        If NbCharsPrinted >= 75 Then
            If CWData = " " Then        '/ Waiting a space for line feed.
                NbCharsPrinted = 0
                HRSOut CR
            Else
                If NbCharsPrinted > 82 Then '/ If not a space => line feed.
                    NbCharsPrinted = 0
                    HRSOut CR                     
                EndIf
            EndIf    
        EndIf 
        '/----------------------------------------------------------------------
        Inc FSR1
        Dec LenCWString             '/ Go to the next character of the text.
    Until LenCWString = 0               
    '/==========================================================================
KYCWMESSEXIT:
    '/-----------------------------------------------------------------------
    '/ Dlays accumulated after end of message.
'    SumDELAYS = Msg_DotTime + Msg_LetterSpaceTime
    '/ DelayMS before a new message like a SPACE => 7 dits
'    If F_SendNewMessage = 1 Then
'        'DelayMS iCW_MessageSpace    '/ (1 + 2 + 4) + 3 = 10 Dits
'        DelayMS Msg_WordSpaceTime       '/ This is a Space between characters for 7 dits
'    EndIf

    '/ All characters in the string have been sent.    
    CWDataPin = 0                   '/ Sure CW output is shutt down.
    CWStringDone = 0
    Return
    ENDSIZE(SendCWBuffer_LIB)
#endIfMacro-
*)
'/==============================================================================
'* Purpose : Checking If a new message has been called by interruption.
'* Input   : None                                       
'* Output  : None
'* Note    : The number of message is in the "NBMessageToSend" variable.
'/         : KEYBOARD MODE
'/
$define CheckingMessage() _mCheckingMessage

_mCheckingMessage Macro-
    GoSub CheckingMessage_Sub
Endm

#ifMacro- _mCheckingMessage
CheckingMessage_Sub:
STARTSIZE(CheckingMessage_CODE)
        CWDataSend = 0
        F_EnableLongDash = 0
        F_SendNewMessage = 0
        F_SpecialChar = 0
        NbCharsPrinted = 0
        INTCONBits_INT0IE = 1   '/ Function Button. Enable again the RB0 interrupt. 
        LoadKYMsgToString()     '/ Load a new string to send.
        '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '/----------------------------------------------------------------------
        HRSOut "MSG Nb: ", Dec NBMessageToSend," "
        GoSub HRS_BEACON_Sub
        
        '/ Print the string to send to check it.
        FSR2 = VarPtr(CW_StringSend)
        Do
            #ifdef Watchdog_req
            Clrwdt
            #endif
            CWData = POSTINC2
            If CWData = 0 Then
                HRSOut CR
                Break
            EndIf
            HRSOut CWData
            '/ Check the number of characters printed
            Inc NbCharsPrinted
            If NbCharsPrinted >= 75 Then
                If CWData = " " Then        '/ Waiting a space for line feed.
                    NbCharsPrinted = 0
                    HRSOut CR
                Else
                    If NbCharsPrinted > 82 Then '/ If not a space => line feed.
                        NbCharsPrinted = 0
                        HRSOut CR                     
                    EndIf
                EndIf    
            EndIf
        Loop 
        NbCharsPrinted = 0
        '/----------------------------------------------------------------------
        '/ Checking if the message in RAM is available.
        If F_KeyerMemoryError = 1 Then
            GoTo KBCWMESSEXIT
        EndIf    
        '/----------------------------------------------------------------------
        '/ Check an error in loading String.
        If CWStringDone <> 85 Then '/ Has the CW_StringSend been loaded?
            CWPTT = 0              '/ Disable the transmitter too.
            HRSFStrg(KYSTRG49,1)   '/ HRSOut "A CORRECT STRING HAS NOT BEEN LOADED!",CR
            GoTo KBCWMESSEXIT      '/ Exit the routine.
        EndIf
        CWStringDone = 0
        '/----------------------------------------------------------------------    
        CWConfigWPM()    '/ Read CW Speed potenciometer.
        '/----------------------------------------------------------------------
        '/ Set the PTT with Delay. 
        If F_EnablePTT = 1 Then
            If CWPTT = 0 Then           '/ Avoid to repeat the TXONDelay.
                High CWPTT              '/ Transmitter on, receiver off
                F_ClearPTT = 0          '/ Do not clear the PTT if there is not a specific order.
                DelayMS TXONDelay       '/ Load & Start the TX delay.  
            EndIf
        EndIf
        '/----------------------------------------------------------------------
        '/ Sending a full message (for RAM strings).
        LenCWString = Len(CW_StringSend)    '/ Lenght of this new string.
        FSR1 = VarPtr(CW_StringSend)        '/ (FSR1) Point to the string.
        '/
        Repeat                              '/ Go through the string
            #ifdef Watchdog_req
            Clrwdt
            #endif
            CWData = INDF1                  '/ Read the current character from String array.
            '/----------------------------------------------------------------------
            '/ Looking for specials characters.
            Select CWData                  
                Case 0
                    GoTo KBCWMESSEXIT           '/ Exit, end of message. (security)
                '/--------------------------------------------------------------
                Case " "                        '/ Compute a SPACE => Word Space delay = 7 dots.
                    HRSOut " "                  '/ Send a Space to the terminal.
                    DelayMS Msg_WordSpaceTime   '/ This is a Space between characters for 7 dots.
                    GoTo KBCWCHAREXIT           '/ Continue Repeat/Until to next character. 
                '/--------------------------------------------------------------
                Case 126            '/ "~" Tilde character. Insert a Long Dash. 
                    'F_ShortNumbers = 1      '/ Set Flag to send Short Numbers
                    Toggle F_EnableLongDash
                    GoTo KBContinueSendByte '/ Next byte to send.
                '/--------------------------------------------------------------
                '/ Send special characters to the terminal. (Prosigns)
                Case "#"
                    HRSOut "AR"     '/ [#] End of message.
                Case "*"
                    HRSOut "AS"     '/ [*] Stand by.               
                Case "%"
                    HRSOut "KA"     '/ [%] Beginning of message, Starting Signal.
                Case "&"
                    HRSOut "KN"     '/ [&] Go only, invite a specific station To transmit.
                Case "<"
                    HRSOut "BK"     '/ [<] End of transmission. Go only, invite a specific station To transmit.        
                Case "="
                    HRSOut "BT"     '/ [=] Double Dash, Pause Or Break. "official" separator.
                Case ">"
                    HRSOut "VE"     '/ [>] Understood.
                Case "]"
                    HRSOut "AA"     '/ [[] New Line.
                Case "^"
                    HRSOut "SK"     '/ [^] End of contact (sent before Call).             
                Case "|"                '/ PROSIGN ("|") This character is not included in the table of symbols.
                    F_SpecialChar = 1
                    CWData = CW_EOM
                    HRSOut "EOM"    '/ [EOM] [|] used for "partitions" of message.
                '/------------------------------------------------------------------    
                Case < 33,> 95              '/ Check if error in character String.
                    F_KeyerMemoryError = 1
                    GoTo KBCWCHAREXIT       '/ Goto over the LookUp Table.
                Case Else
                    HRSOut CWData   '/ Send all standard ASCII character to the terminal.
            EndSelect
            '/------------------------------------------------------------------
            GoSub KBSendBits_Sub    '/ Send every byte.
            '/------------------------------------------------------------------
            '/ Checking special conditions.
            '/ Looking for PTT OFF character. (next character?)
            CWData = PREINC1        '/ Read the next character from String array.
            WREG = POSTDEC1         '/ Then Dec FSR1. Come back To current character.
            If CWData = 91 Then     '/ "[" Macro = PTT OFF           
                HRSOut 91           '/ "["
                GoTo KBCWMESSEXIT   '/ Exit the code.
            EndIf
            '/==================================================================
            '/ Stop a message between letters with the Stop Button. (memory Keyer)
            If F_ButtonSTOPpressed = 1 Then
                F_ButtonSTOPpressed = 0
                F_KYBeaconStart = 0     '/ Stops the Beacon Watchdog
                F_SendNewMessage = 0    '/ Stops to send a message.
                While ButtonFUNCTION = 0  '/ Waiting Button depressed.
                    #ifdef Watchdog_req
                    Clrwdt
                    #endif             
                Wend
                Low StatusLED                '/ Clear Status LED.
                'INTCON3Bits_INT2IF = 0  '/ Clear the MEM interrupt flag.
                'INTCONBits_INT0IE = 1   '/ (STOP Button) Enable the RB0 interrupt.
                GoTo KBCWMESSEXIT       '/ Fast exit.        
            EndIf
            '/------------------------------------------------------------------
            '/ Now that all the dits and dahs are sent...
            DelayMS Msg_LetterSpaceTime '/ DelayMS (1 + 2) = 3, Delay the length of 3 dits
            '/------------------------------------------------------------------
KBCWCHAREXIT:
            '/----------------------------------------------------------------------
            '/ Check the number of chracters printed
            Inc NbCharsPrinted
            If NbCharsPrinted >= 75 Then
                If CWData = " " Then        '/ Waiting a space for line feed.
                    NbCharsPrinted = 0
                    HRSOut CR
                Else
                    If NbCharsPrinted > 82 Then '/ If not a space => line feed.
                        NbCharsPrinted = 0
                        HRSOut CR                     
                    EndIf
                EndIf    
            EndIf 
            '/----------------------------------------------------------------------
KBContinueSendByte:
            'Inc FSR1
            WREG = POSTINC1     '/ Increment FSR1. 
            Dec LenCWString     '/ Go to the next character of the text.
        Until LenCWString = 0               
        '/======================================================================
KBCWMESSEXIT:
        '/----------------------------------------------------------------------
        If F_PaddlesMode = 1 Then   '/ Paddles Mode?
            'SumDELAYS = (Msg_DotTime * 121) / 100   '/ Delay for PTT OFF. (Delay_RXON)             
            SumDELAYS = Msg_LetterSpaceTrueTime  '/ Delay for PTT OFF. (Delay_RXON)  
            F_ClearPTT = 1
            F_PTTCWAlreadySet = 0   '/ Start the RXONDelay.   
        Else
            CWDataSend = CR         '/ Keyboard Mode?
        EndIf      
        '/----------------------------------------------------------------------
        '/ All characters in the string have been sent.    
        CWStringDone = 0                
    '/----------------------------------------------------------------------
    Return
ENDSIZE(CheckingMessage_CODE)
#endIfMacro-
'/==============================================================================
'* Purpose : Send the bits of CW character to output.
'* Input   : CWData                                       
'* Output  : CWDataPin
'* Note    : LookUp Table. To send Messages / Keyboard MODE
'/
$define SendCWBits() GoSub KBSendBits_Sub

KBSendBits_Sub:
STARTSIZE(KBSendBits_CODE)
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    PIE1Bits_TMR2IE = 0
    Low CWToneOut
    Low CWPracticePin
    If F_EnableLongDash = 1 Then
        If CWData = "T" Then
            F_LongDashTime = 1
        EndIf
    EndIf
    '/ Looking for the CW equivalent of ASCII character.        
    CWData = CWData - 33  '/ See ASCII table. Start table with 0.
    '/ With LookUp Table, all CW characters have the same delay.
    If F_SpecialChar = 0 Then
        '/----------------------------------------------------------------------
        '/ Bits Char           ASCII      ! (33)     "        #      $
        CW_CharToSend = LookUp CWData,[CW_EXCMARK,CW_DQUOTE,CW_AR,CW_DOLLAR,_
        '/ %    &      '         (         )        *     +        ,        -
        CW_KA,CW_KN,CW_SQUOTE,CW_OPAREN,CW_CPAREN,CW_AS,CW_PLUS,CW_COMMA,CW_SEPA2,_
        '/ .      /        0    1    2    3    4    5    6    7    8    9    :
        CW_DOT,CW_FSLASH,CW_0,CW_1,CW_2,CW_3,CW_4,CW_5,CW_6,CW_7,CW_8,CW_9,CW_COLON,_
        '/ ;        <      =       >     ?        @ (64)    A    B    C    D    E    F    G
        CW_SCOLON,CW_BK,CW_SEPAR,CW_VE,CW_QMARK,CW_ATSYMB,CW_A,CW_B,CW_C,CW_D,CW_E,CW_F,CW_G,_
        '/ H   I    J    K    L    M    N    O    P    Q    R    S    T    U
        CW_H,CW_I,CW_J,CW_K,CW_L,CW_M,CW_N,CW_O,CW_P,CW_Q,CW_R,CW_S,CW_T,CW_U,_
        '/ V   W    X    Y    Z   [(91)    \(92)  ](93)  ^     _(95)
        CW_V,CW_W,CW_X,CW_Y,CW_Z,CW_AL,CW_BSLASH,CW_AA,CW_SK,CW_UNSCORE]
        '/----------------------------------------------------------------------
    Else
        '/ Send a special character in CW mode too.
        CW_CharToSend = CWData
        F_SpecialChar = 0
    EndIf
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    '/ This section sends the individual dots and dashs.
    F_StartRead = 0
    CWLoop = 0
    STATUS.0 = 0        '/ Clear the Carry Bit first.
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    Repeat              '/ For 8 Bits.
        #ifdef Watchdog_req
        Clrwdt
        #endif
        Rol CW_CharToSend              '/ Rotate all bits to Left through Carry.
        F_SendBits = STATUS.0           '/ Copy the Carry Bit.
        If F_StartRead = 0 Then         '/ Looking for the start bit.
            If F_SendBits = 1 Then
                F_StartRead = 1         '/ Start bit OK.
            EndIf
            Inc CWLoop                  '/ Use the next bit only?
            Continue                    '/ Do not send CW, Continue looking for bits.
        EndIf
        '/------------------------------------------------------------------
        '/ Send Dot & Dash.             '/ OK there is a bit to send!
        If F_SendBits = 0 Then          '/ Check for dot
            '/ Making Dot.
'            CWDataPin = 1               '/ Key down CWDataPin
'            If F_EnableTone = 1 Then
'                Sound CWToneOut,[111,Msg_DotTimeTone]    '/ 621 Hz, Output Tone.                 
'                CWToneOut = 0           '/ Because the Output level could stay High.
'            Else
'                DelayMS Msg_DotTime     '/ Wait for one dot time.               
'            EndIf
'            CWDataPin = 0               '/ Unkey CWDataPin
            '/--------------------------------------------------------------
            '/ Making Dot.
            If F_EnableMUTE = 0 Then    '/ If MUTE = OFF then send CW data.
                CWDataPin = 1           '/ Key down CWDataPin
            Else
                CWPracticePin = 1
            EndIf
            If F_EnableTone = 1 Then
                CWPTTCounter = CW_DotTime
                KYClearTimer2Flag()
                KYTimer2ON()
                KYStartTone()
                Do
                    #ifdef Watchdog_req
                    Clrwdt
                    #endif
                    KYToneOut()
                    If KYTimer2Flag = 1 Then
                        KYClearTimer2Flag()
                        'Toggle CWToneOut    '/ Send a tone = 601 Hz
                        Dec CWPTTCounter
                        If CWPTTCounter = 0 Then
                            KYTimer2OFF()
                            CWToneOut = 0
                            Break
                        EndIf
                    EndIf
                Loop
            Else
                DelayMS Msg_DotTime     '/ Wait for one dit
            EndIf
            CWDataPin = 0               '/ Unkey CWDataPin
            CWPracticePin = 0
            '/--------------------------------------------------------------
        Else                            '/ Check for dash
            '/--------------------------------------------------------------
'            '/ Making Dash.
'            CWDataPin = 1               '/ Key down CWDataPin
'            If F_EnableTone = 1 Then
'                If F_LongDashTime = 1 Then   '/ Option short number 0.
'                    Sound CWToneOut,[111,Msg_LondDashTimeTone]   '/ 621 Hz, Output Tone. 
'                Else
'                    Sound CWToneOut,[111,Msg_DashTimeTone]       '/ 621 Hz, Output Tone.                
'                EndIf
'                CWToneOut = 0           '/ Because the output level could stay high.
'            Else
'                If F_LongDashTime = 1 Then   '/ Option short number 0.
'                    DelayMS Msg_LondDashTime '/ Wait for one dash time. 
'                Else
'                    DelayMS Msg_DashTime     '/ Wait for one dash time.               
'                EndIf
'            EndIf
'            F_LongDashTime = 0
'            CWDataPin = 0               '/ Unkey CWDataPin
            '/--------------------------------------------------------------
            '/ Making Dash.
            If F_EnableMUTE = 0 Then    '/ If MUTE = OFF then send CW data.
                CWDataPin = 1           '/ Key down CWDataPin
            Else
                CWPracticePin = 1
            EndIf
            If F_EnableTone = 1 Then
                If F_LongDashTime = 1 Then   '/ Option short number 0.
                    F_LongDashTime = 0
                    CWPTTCounter = CW_LongDashTime
                Else
                    CWPTTCounter = CW_DashTime
                EndIf
                KYClearTimer2Flag()
                KYTimer2ON()
                KYStartTone()
                Do
                    #ifdef Watchdog_req
                    Clrwdt
                    #endif
                    KYToneOut()
                    If KYTimer2Flag = 1 Then
                        KYClearTimer2Flag()
                        'Toggle CWToneOut    '/ Send a tone = 601 Hz
                        Dec CWPTTCounter
                        If CWPTTCounter = 0 Then
                            KYTimer2OFF()
                            CWToneOut = 0
                            Break
                        EndIf
                    EndIf
                Loop
            Else
                If F_LongDashTime = 1 Then   '/ Option short number 0.
                    F_LongDashTime = 0
                    DelayMS Msg_LondDashTime '/ Wait for one long dash
                Else
                    DelayMS Msg_DashTime     '/ Wait for one dash
                EndIf
            EndIf
            CWDataPin = 0               '/ Unkey CWDataPin
            CWPracticePin = 0
            '/--------------------------------------------------------------
        EndIf
        '/ Space beetwen dot/dash.
        DelayMS Msg_DotDashSpaceTime    '/ Waiting a delay for one dot between Dot & Dash.
        Inc CWLoop                      '/ Next Bit to send.
    Until CWLoop = 8
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    CWDataPin = 0   '/ Unkey CWDataPin
    CWPracticePin = 0
    CWToneOut = 0
    Return          '/ KBSendBits_Sub Routine.
ENDSIZE(KBSendBits_CODE)
'/==============================================================================
'* Purpose : Send the RST number in Paddles Mode for normal operation.
'* Input   : none                                       
'* Output  : none
'* Note    : The flag is set By interrupt.
'/
$define CWSendRST() _mCWSendRST
    
_mCWSendRST Macro-
    GoSub CWSendRST_Sub
Endm

#ifMacro- _mCWSendRST
CWSendRST_Sub:
STARTSIZE(CWSendRST_LIB)
'/ Read the RST values from the Decimal encoders & send To CW Datapin
    SumDELAYS = Msg_LetterSpaceTrueTime - Msg_DotDashSpaceTime 
    Sum2DELAYS = Msg_WordSpaceTrueTime - Msg_DotDashSpaceTime

    GoSub KYReadRSTEncoders_Sub         
    CWData = CW_StringTemp#0     '/ Byte MSB
    HRSOut CWData
    SendCWBits()
    DelayMS SumDELAYS           '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots.                
    
    CWData = CW_StringTemp#1    '/ Byte DSB
    HRSOut CWData
    SendCWBits()
    DelayMS SumDELAYS           '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots. 

    CWData = CW_StringTemp#2    '/ Byte LSB              
    HRSOut CWData
    SendCWBits()
            
    HRSOut " "              '/ Insert a space.
    DelayMS Sum2DELAYS      '/ This is a Word Space between characters for 7 dots

    F_ShortNumbers = 1 
    F_EnableLongDash = 0
    WREG = CW_StringTemp#0
    WriteShortNumbers()
    CWData = WREG
    HRSOut CWData
    SendCWBits()
    DelayMS SumDELAYS       '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots. 

    WREG = CW_StringTemp#1
    WriteShortNumbers()
    CWData = WREG
    HRSOut CWData
    SendCWBits()
    DelayMS SumDELAYS       '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots. 
    
    WREG = CW_StringTemp#2  '/ Byte LSB 
    WriteShortNumbers()
    CWData = WREG
    HRSOut CWData
    SendCWBits()
    DelayMS Sum2DELAYS      '/ DelayMS (1 + 2) = 3, Delay the length of 3 dots. 
    HRSOut " "              '/ Insert a space.
    Return
ENDSIZE(CWSendRST_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose : Running the PTT Watchdog. (RXON_Delay)
'* Input   : none                                       
'* Output  : None
'* Note    :  
'/
'    SMLocalWord0(WordTemp1)
    Dim WordTemp1 As Word

$define KYStartRXON_Delay() _mKYStartRXON_Delay

_mKYStartRXON_Delay Macro-
    GoSub KYStartDelayRXONT2_Sub
Endm

'#ifMacro- _mKYStartRXON_Delay
'KYStartDelayRXONT2_Sub:
'STARTSIZE(KYStartDelayRXONT2_LIB)
'    '/ Start a TimeOut for PTT.
'    '/ RXONDelay2, CW_LetterSpaceTime & CW_WordSpaceTime have the same reference.  
'    WordTemp1 = CW_LetterSpaceTime + CW_WordSpaceTime
'    If RXONDelay2 > WordTemp1 Then
'        WordTemp1 = WordTemp1 - RXONDelay2
'    Else
'        WordTemp1 = 1
'    EndIf
'    KYStartTimer2(WordTemp1)     '/ Start TimeOut for PTT. 
'    Return
'ENDSIZE(KYStartDelayRXONT2_LIB)
'#endIfMacro-

#ifMacro- _mKYStartRXON_Delay
KYStartDelayRXONT2_Sub:
STARTSIZE(KYStartDelayRXONT2_LIB)
    '/ Start a TimeOut for PTT.
    '/ RXONDelay2, CW_LetterSpaceTime & CW_WordSpaceTime have the same reference.  
    WordTemp1 = CW_LetterSpaceTime + CW_WordSpaceTime
    If RXONDelay > WordTemp1 Then
        WordTemp1 = WordTemp1 - RXONDelay
    Else
        WordTemp1 = 1
    EndIf
    KYStartTimer2(WordTemp1)     '/ Start TimeOut for PTT. 
    Return
ENDSIZE(KYStartDelayRXONT2_LIB)
#endIfMacro-
'/==============================================================================
'* Purpose : Tune Transmitter with TUNE ON/TUNE OFF delays.
'* Input   : none                                       
'* Output  : None
'* Note    : with security Timeout: CstTuneONTimeMax 
'/
$define TUNETX_ONOFF() _mTUNETX_ONOFF

_mTUNETX_ONOFF Macro-
    GoSub TUNETX_ONOFF_Sub
Endm

#ifMacro- _mTUNETX_ONOFF,_mTUNETX_ON
TUNETX_ONOFF_Sub:
    HRSFStrg(KYSTRG03,1)    '/ "TUNE ON"
    If F_EnablePTT = 1 Then
        High CWPTT          '/ Transmitter ON
        DelayMS TXONDelay   '/ Load & Start the TX delay.
    EndIf
    '/ Security Time Out for Tuning the transmitter.
    '/ Compute the number of loops.
    '/ Time Out value defined by the constant: CstTuneONTimeMax.
    Save_FSR0 = TuneONDelay + TuneOFFDelay
    KYMyDelayWord = (TuneONTimeMax * 1000) / Save_FSR0
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::         
    Do
        CWDataPin = 1           '/ Key down CWDataPin
        PROD = TuneONDelay
        Repeat
            #ifdef Watchdog_req
            Clrwdt
            #endif
            DelayUS 996
            '/------------------------------------------------------------------
            If F_ButtonSTOPpressed = 1 Then '/ Buton Stop pressed?
                F_ButtonSTOPpressed = 0
                GoTo EXITTUNE_ONOFF
            EndIf
            If IP_DOT = 0 Then         '/ dot-paddle closed:
                GoTo EXITTUNE_ONOFF
            EndIf
            If IP_DASH = 0 Then        '/ dash-paddle closed:
                GoTo EXITTUNE_ONOFF
            EndIf                    
            '/------------------------------------------------------------------
            Dec PROD
        Until PROD = 0
        '/----------------------------------------------------------------------
        CWDataPin = 0               '/ Key UP CWDataPin
        PROD = TuneOFFDelay
        Repeat
            #ifdef Watchdog_req
            Clrwdt
            #endif
            DelayUS 996
            '/------------------------------------------------------------------
            '/ Exits the Tune routine.
            If F_ButtonSTOPpressed = 1 Then '/ Buton Stop pressed?
                F_ButtonSTOPpressed = 0
                GoTo EXITTUNE_ONOFF
            EndIf
            If IP_DOT = 0 Then         '/ dot-paddle closed:
                GoTo EXITTUNE_ONOFF
            EndIf
            If IP_DASH = 0 Then        '/ dash-paddle closed:
                GoTo EXITTUNE_ONOFF
            EndIf                    
            '/------------------------------------------------------------------
            Dec PROD
        Until PROD = 0           
        INTCONBits_INT0IE = 1   '/ Enable again the RB0 interrupt.
    '/--------------------------------------------------------------------------
        Dec KYMyDelayWord
        If KYMyDelayWord = 0 Then
            GoTo EXITTUNE_ONOFF
        EndIf    
    '/--------------------------------------------------------------------------
    Loop
    '/::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
EXITTUNE_ONOFF:
    While ButtonFUNCTION = 0
        #ifdef Watchdog_req
        Clrwdt
        #endif            
        CWDataPin = 0       '/ Key up CWDataPin
    Wend  
    While IP_DOT = 0
        #ifdef Watchdog_req
        Clrwdt
        #endif
        CWDataPin = 0       '/ Key up CWDataPin
    Wend
    While IP_DASH = 0
        #ifdef Watchdog_req
        Clrwdt
        #endif
        CWDataPin = 0       '/ Key up CWDataPin
    Wend
    CWDataPin = 0           '/ Key up CWDataPin
    If F_EnablePTT = 1 Then
        DelayMS RXONDelay   '/ Load & Start the RX delay.
        Low CWPTT           '/ Transmitter OFF
    EndIf
    HRSFStrg(KYSTRG04,1)    '/ "TUNE OFF"
    INTCONBits_INT0IE = 1   '/ Enable again the RB0 interrupt.
    Return
#endIfMacro-
'/==============================================================================
'* Purpose : Tune Transmitter continuously.
'* Input   : none                                       
'* Output  : None
'* Note    :  
'/
$define TUNETX_ON() _mTUNETX_ON

_mTUNETX_ON Macro-
    GoSub TUNETX_ON_Sub
Endm

#ifMacro- _mTUNETX_ON
TUNETX_ON_Sub:
'/"Tune" Turns the transmitter ON continuously
    HRSFStrg(KYSTRG03,1)    '/ HRSOut "TUNE ON"
    If F_EnablePTT = 1 Then
        High CWPTT          '/ Transmitter ON
        DelayMS TXONDelay   '/ Load & Start the TX delay.
    EndIf
    While ButtonFUNCTION = 0
        #ifdef Watchdog_req
        Clrwdt
        #endif            
        DelayMS 100
    Wend 
    INTCONBits_INT0IE = 1   '/ Enable again the RB0 interrupt.
    KYMyDelayWord = 0
    Do
        #ifdef Watchdog_req
        Clrwdt
        #endif
        '/----------------------------------------------------------------------
        CWDataPin = 1               '/ Key down CWDataPin
        '/----------------------------------------------------------------------
        '/ Exits the Tune routine.
        If F_ButtonSTOPpressed = 1 Then '/ Buton Stop pressed?
            F_ButtonSTOPpressed = 0
            GoTo EXITTUNE_ONOFF
        EndIf
        If IP_DOT = 0 Then         '/ dot-paddle closed:
            GoTo EXITTUNE_ONOFF
        EndIf
        If IP_DASH = 0 Then        '/ dash-paddle closed:
            GoTo EXITTUNE_ONOFF
        EndIf                    
        '/----------------------------------------------------------------------
        '/ The transmitter is tuned 30 seconds maximum.
        DelayMS 100
        Inc KYMyDelayWord
        If KYMyDelayWord > (TuneONTimeMax * 10) Then
            GoTo EXITTUNE_ONOFF
        EndIf    
    Loop
#endIfMacro-
'/==============================================================================
'* Purpose : Configure the Timer0 for 16, 20, 25, 64, 80, 100 Mhz xtal for Tone Out.
'* Input   : None                                       
'* Output  : None
'/ Note    : Same structure for 18F2xk22 & 18F2xk20 & 18F452 series.
'/
(*
T0CON: TIMER0 CONTROL REGISTER
    bit 7 TMR0ON: Timer0 On/Off Control bit
        1 = Enables Timer0
        0 = Stops Timer0
    bit 6 T08BIT: Timer0 8-bit/16-bit Control bit
        1 = Timer0 is configured as an 8-bit timer/counter
        0 = Timer0 is configured as a 16-bit timer/counter
    bit 5 T0CS: Timer0 Clock Source Select bit
        1 = Transition on T0CKI pin
        0 = Internal instruction cycle clock (CLKOUT)
    bit 4 T0SE: Timer0 Source Edge Select bit
        1 = Increment on high-to-low transition on T0CKI pin
        0 = Increment on low-to-high transition on T0CKI pin
    bit 3 PSA: Timer0 Prescaler Assignment bit
        1 = TImer0 prescaler is NOT assigned. Timer0 clock input bypasses prescaler.
        0 = Timer0 prescaler is assigned. Timer0 clock input comes from prescaler output.
    bit 2-0 T0PS<2:0>: Timer0 Prescaler Select bits
        111 = 1:256 prescale value
        110 = 1:128 prescale value
        101 = 1:64 prescale value
        100 = 1:32 prescale value
        011 = 1:16 prescale value
        010 = 1:8 prescale value
        001 = 1:4 prescale value
        000 = 1:2 prescale value
*)
'/------------------------------------------------------------------------------
    $define KYConfigTime0() GoSub KYConfigTime0_Sub

KYConfigTime0_Sub:
    $if _xtal = 16
        '/ (Xtal: Xtal 16 without PLL) => FOSC = 4 Mhz
        '/ Prescaler = 32
        '/ [400,450,500,550,600,650,700,800,1000,1250] Frequency
        '/ Divisor 4.000.000Mh / 32 / 104 = 1201 Hz
        '/ [156,139,125,113,104,96,89,78,62,50]
        T0CON = %01000100
    $endif
    $if _xtal = 20
        '/ (Xtal: Xtal 20 without PLL) => FOSC = 5 Mhz
        '/ Prescaler = 32
        '/ [400,450,500,550,600,650,700,800,1000,1250] Frequency
        '/ Divisor 5.000.000Mh / 2500 / 32
        '/ [195,173,156,142,130,120,112,97,78,62]
        T0CON = %01000100
    $endif
    $if _xtal = 25
        '/ (Xtal: Xtal 20 without PLL) => FOSC = 6,25 Mhz
        '/ Prescaler = 32
        '/ [400,450,500,550,600,650,700,800,1000,1250] Frequency
        '/ Divisor 6.250.000Mh / 2500 / 32
        '/ [244,217,195,177,163,150,139,122,97,78]
        T0CON = %01000100
    $endif
    $if _xtal = 64
        '/ Prescaler = 128
        '/ [400,450,500,550,600,650,700,800,1000,1250] Frequency
        '/ Divisor 16.000.000Mh / 2500 / 128
        '/ [156,139,125,113,104,96,89,78,62,50]
        T0CON = %01000110
    $endif
    $if _xtal = 80
        '/ Prescaler = 128
        '/ [400,450,500,550,600,650,700,800,1000,1250] Frequency
        '/ Divisor 20.000.000Mh / 2500 / 128
        '/ [195,173,156,142,130,120,112,97,78,62]
        T0CON = %01000110    
    $endif       
    $if _xtal = 100
        '/ Prescaler = 128
        '/ [400,450,500,550,600,650,700,800,1000,1250] Frequency
        '/ Divisor 25.000.000Mh / 2500 / 128
        '/ [244,217,195,177,163,150,139,122,97,78]
        T0CON = %01000110  
    $endif 
    '/--------------------------------------------------------------------------
    TMR0H = 0
    Nop
    TMR0L = 0    
    INTCONBits_TMR0IF = 0
    INTCONBits_TMR0IE = 0   
    Return
'/==============================================================================
'* Purpose : Configure the Timer2 for 16, 20, 25, 64, 80, 100 Mhz xtal.
'* Input   : None                                       
'* Output  : None
'/ Note    : Same structure for 18F2xk22 & 18F2xk20 & 18F452 series.
'/ 
(*
T1CON: TIMER1 CONTROL REGISTER
    bit 7 RD16: 16-bit Read/Write Mode Enable bit
        1 = Enables register read/write of TImer1 in one 16-bit operation
        0 = Enables register read/write of Timer1 in two 8-bit operations
    bit 6 T1RUN: Timer1 System Clock Status bit
        1 = Main system clock is derived from Timer1 oscillator
        0 = Main system clock is derived from another source
    bit 5-4 T1CKPS<1:0>: Timer1 Input Clock Prescale Select bits
        11 = 1:8 Prescale value
        10 = 1:4 Prescale value
        01 = 1:2 Prescale value
        00 = 1:1 Prescale value
    bit 3 T1OSCEN: Timer1 Oscillator Enable bit
        1 = Timer1 oscillator is enabled
        0 = Timer1 oscillator is shut off
        The oscillator inverter and feedback resistor are turned off to eliminate power drain.
    bit 2 T1SYNC: Timer1 External Clock Input Synchronization Select bit
        When TMR1CS = 1:
        1 = Do not synchronize external clock input
        0 = Synchronize external clock input
    When TMR1CS = 0:
        This bit is ignored. Timer1 uses the internal clock when TMR1CS = 0.     
    bit 1 TMR1CS: Timer1 Clock Source Select bit
        1 = External clock from pin RC0/T1OSO/T13CKI (on the rising edge)
        0 = Internal clock (FOSC/4)
    bit 0 TMR1ON: Timer1 On bit
        1 = Enables Timer1
        0 = Stops Timer1  65535
*)
'/ TMR1 16Bits counter, Prescaler 1/8
    $define KYConfigTime1() '
    PIE1Bits_TMR1IE = 0     '
    PIR1Bits_TMR1IF = 0     '
    T1CON = %10110000   

'/==============================================================================
'* Purpose : Configure the Timer2 for 16, 20, 25, 64, 80, 100 Mhz xtal for CW Timings.
'* Input   : None                                       
'* Output  : None
'/ Note    : Same structure for 18F2xk22 & 18F2xk20 & 18F452 series.
'/         : Adjust Timer2 to 10000Hz for better precision.
(*
T2CON: TIMER2 CONTROL REGISTER
    bit 7 Unimplemented: Read as 0

    bit 6-3 T2OUTPS<3:0>: Timer2 Output Postscale Select bits
        0000 = 1:1 Postscale
        0001 = 1:2 Postscale
        0010 = 1:3 Postscale
        0011 = 1:4 Postscale
        0100 = 1:5 Postscale
        
        
        1110 = 1:15 Postscale
        1111 = 1:16 Postscale

    bit 2 TMR2ON: Timer2 On bit
        1 = Timer2 is on
        0 = Timer2 is off

    bit 1-0 T2CKPS<1:0>: Timer2 Clock Prescale Select bits
        00 = Prescaler is 1
        01 = Prescaler is 4
        1x = Prescaler is 16
*)
$define KYConfigTime2() GoSub KYConfigTime2_Sub

KYConfigTime2_Sub:
    PIE1Bits_TMR2IE = 0
    '/-------------------------------------------------------------------------- 
    $if _xtal = 16
        '/ FOSC = 16Mhz => Freq input = 16Mhz/4 = 4Mhz
        '/ TMR2 8Bits counter, Postscaler 1/1, Prescaler 1/4, PR2 = 99, Osc Off, Clock Xtal/4 (Xtal: Xtal 16, NO PLL = 16Mhz)
        '/ For Timer2 Clock (10000 Hz) 100uS
        T2CON = %00000001
        PR2 = 99                               
    $endif
    $if _xtal = 20
        '/ FOSC = 20Mhz => Freq input = 20Mhz/4 = 5Mhz
        '/ 5Mhz / Prescaler / 10000 = PR2
        '/ TMR2 8Bits counter, Postscaler 1/1, Prescaler 1/4, PR2 = 124, Osc Off, Clock Xtal/4 (Xtal: Xtal 20, NO PLL = 20Mhz)
        '/ For Timer2 Clock (10000 Hz) 100uS
        T2CON = %00000001        
        PR2 = 124
    $endif  
    $if _xtal = 25
        '/ FOSC = 25Mhz => Freq input = 25Mhz/4 = 6,25Mhz
        '/ TMR2 8Bits counter, Postscaler 1/5, Prescaler 1/1, PR2 = 125, Osc Off, Clock Xtal/4 (Xtal: Xtal 25, NO PLL = 25Mhz)
        '/ For Timer2 Clock (10000 Hz) 100uS
        T2CON = %00100000        
        PR2 = 125
    $endif
    $if _xtal = 64
        '/ FOSC = 64Mhz => Freq input = 64Mhz/4 = 16Mhz
        '/ TMR2 8Bits counter, Postscaler 1/1, Prescaler 1/16, PR2 = 99, Osc Off, Clock Xtal/4 (Xtal: Xtal 16 + PLL = 64Mhz)
        '/ For Timer2 Clock (10000 Hz) 100uS
        T2CON = %00000010
        PR2 = 99                               
    $endif
    $if _xtal = 80
        '/ FOSC = 80Mhz => Freq input = 80Mhz/4 = 20Mhz
        '/ 20Mhz / Prescaler / 10000 = PR2
        '/ TMR2 8Bits counter, Postscaler 1/1, Prescaler 1/16, PR2 = 124, Osc Off, Clock Xtal/4 (Xtal: Xtal 20, NO PLL = 20Mhz)
        '/ For Timer2 Clock (10000 Hz) 99,5uS
        T2CON = %00000010        
        PR2 = 124
    $endif       
    $if _xtal = 100
        '/ FOSC = 100Mhz => Freq input = 100Mhz/4 = 25Mhz
        '/ TMR2 8Bits counter, Postscaler 1/5, Prescaler 1/4, PR2 = 125, Osc Off, Clock Xtal/4 (Xtal: Xtal 25, NO PLL = 25Mhz)
        '/ For Timer2 Clock (10000 Hz) 100uS
        T2CON = %00100001        
        PR2 = 124
    $endif 
    '/--------------------------------------------------------------------------
    TMR2 = 0                '/ Clear the Timer2 counter.
    PIR1Bits_TMR2IF = 0     '/ Clear Timer2 interrupt flag
    Return
'/==============================================================================
'* Purpose  : Print to the terminal all messages in EEPROM.
'* Input    : None                                       
'* Output   : None
'/ Note     :   
'/ 
PrintEEPMessages_Sub:
    '/ Read all messages available in the eeprom.
    '/--------------------------------------------------------------------------
    '/ Print marks [#] for different lenght of messages: 30,64 Bytes.
    PrintMarks1() 'GoSub PrintMarks1_Sub
    '/--------------------------------------------------------------------------
    HRSFStrg(KYSTRG28,1)   '/ "EEPROM MESSAGES"
    '/--------------------------------------------------------------------------
    HRSOut "EEPROM BLOCK 0:",CR
    CWLoop = 0
    NBMessageToSend = 0
    Repeat
        HRSFStrg(KYSTRG27,0)       '/ "READ MESSAGE NB "  
        HRSOut Dec2 NBMessageToSend,": "
        TableResult = TableE2PAddress(NBMessageToSend)    '/ Checking E2P address (TableResult)
        ReadStrg_E2P(TableResult)

        If NBMessageToSend = 4 Then
            PrintMarks1()   '/ Print marks [#] for different lenght of messages: 32 Bytes.            
            PrintMarks2()   '/ Print marks [#] for different lenght of messages: 64 Bytes.
            HRSFStrg(KYSTRG71,0) '/ "EEPROM BLOCK"
            HRSOut "1:",CR
        EndIf        
        If NBMessageToSend = 9 Then
            PrintMarks2()   '/ Print marks [#] for different lenght of messages: 64 Bytes.
            HRSFStrg(KYSTRG71,0) '/ "EEPROM BLOCK"
            HRSOut "2:",CR
        EndIf
        If NBMessageToSend = 14 Then
            PrintMarks2()   '/ Print marks [#] for different lenght of messages: 64 Bytes.
            HRSFStrg(KYSTRG71,0) '/ "EEPROM BLOCK"
            HRSOut "3:",CR
        EndIf         
        Inc NBMessageToSend
        Inc CWLoop
    Until CWLoop > 15
    '/--------------------------------------------------------------------------
    '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    PrintMarks2()
    '/--------------------------------------------------------------------------
    Return
'/==============================================================================
'* Purpose  : Print to the terminal all messages in ROM.
'* Input    : None                                       
'* Output   : None
'/ Note     :   
'/ 
PrintROMMessages_Sub:
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "0",CR    
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT01,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT02,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT03,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT04,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT05,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)       '/ "ROM MESSAGE BLOCK "
    HRSOut "1",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT06,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT07,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT08,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT09,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT10,1)
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)       '/ "ROM MESSAGE BLOCK "
    HRSOut "2",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT11,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT12,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT13,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT14,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT15,1)
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)       '/ "ROM MESSAGE BLOCK "
    HRSOut "3",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT16,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT17,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT18,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT19,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT20,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)       '/ "ROM MESSAGE BLOCK "
    HRSOut "4",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT21,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT22,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT23,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT24,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT25,1)
    '/--------------------------------------------------------------------------    
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "5",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT26,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT27,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT28,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT29,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT30,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "6",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT31,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT32,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT33,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT34,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT35,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "7",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT36,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT37,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT38,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT39,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT40,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "8",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT41,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT42,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT43,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT44,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT45,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "9",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT46,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT47,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT48,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT49,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT50,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "10",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT51,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT52,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT53,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT54,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT55,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "11",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT56,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT57,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT58,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT59,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT60,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "12",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT61,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT62,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT63,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT64,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT65,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "13",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT66,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT67,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT68,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT69,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT70,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "14",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT71,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT72,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT73,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT74,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT75,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "15",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT76,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT77,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT78,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT79,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT80,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "16",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT81,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT82,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT83,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT84,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT85,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "17",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT86,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT87,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT88,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT89,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT90,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "18",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT91,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT92,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT93,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT94,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT95,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()' GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    HRSFStrg(KYSTRG29,0)   '/ "ROM MESSAGE BLOCK "
    HRSOut "19",CR
    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "00: "
    HRSFStrg(CWTXT96,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "01: "
    HRSFStrg(CWTXT97,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "02: "
    HRSFStrg(CWTXT98,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "03: "
    HRSFStrg(CWTXT99,1)

    HRSFStrg(KYSTRG27,0)   '/ "READ MESSAGE "
    HRSOut "04: "
    HRSFStrg(CWTXT100,1)    
    '/--------------------------------------------------------------------------
    PrintMarks2()   'GoSub PrintMarks2_Sub        '/ Print marks [#] for different lenght of messages: 30,64 Bytes.  
    '/--------------------------------------------------------------------------
'    For CWLoop = 0 To 79
'        HRSOut "*"
'    Next
'    HRSOut CR
    Return
'/============================================================================== 
'* Purpose : Run a Random byte value for CW test
'* Input   : none                                      
'* Output  : Using one byte Random output.
'* Note    :  
'/    
    Dim RDLoopRD As Byte
    Dim RDLoopTR As Byte
    Dim CWRandomMode As Byte     
    
$define RunCWSeed() MySeed(CWSeedDWord)


$define RunCWPractice() _mRunCWTEST

_mRunCWTEST Macro-
    GoSub RunCWTEST_Sub
Endm

#ifMacro- _mRunCWTEST
RunCWTEST_Sub:
    RDLoopRD = 0
    RDLoopTR = 0
    Do
        #ifdef Watchdog_req
        Clrwdt
        #endif
        Repeat
            #ifdef Watchdog_req
            Clrwdt
            #endif

            Select CWRandomMode
            Case 0      '/ High Case Letters
MyRandomAgain0:
                Repeat
                    CWData = MyRandom(0)    '/ Running the Random number.
                    CWData = (CWData + 19) & 127
                    If CWData < 65 Then MyRandomAgain0
                Until CWData < 91

            Case 1      '/ Numbers
MyRandomAgain1:
                Repeat
                    CWData = MyRandom(1)    '/ Running the Random number.
                    CWData = (CWData + 14) & 63
                    If CWData < 48 Then MyRandomAgain1
                Until CWData < 58

            Case 2      '/ Numbers & Letters
MyRandomAgain2:
                Repeat
                    CWData = MyRandom(2)    '/ Running the Random number.
                    CWData = (CWData + 11) & 127
                    Select CWData
                        Case < 48
                            GoTo MyRandomAgain2
                        Case 58 To 64
                            GoTo MyRandomAgain2
                    EndSelect
                Until CWData < 91

            Case 3      '/ Punctuation characters
MyRandomAgain3:
                Repeat
                    CWData = MyRandom(3)    '/ Running the Random number.
                    CWData = (CWData + 16) & 127
                    Select CWData
                        Case < 33
                            GoTo MyRandomAgain3
                        Case 48 To 57
                            GoTo MyRandomAgain3
                        Case > 64
                            GoTo MyRandomAgain3                            
                    EndSelect
                Until CWData < 91

            Case 4      '/ All
MyRandomAgain4:
                Repeat
                    CWData = MyRandom(0)    '/ Running the Random number.
                    CWData = (CWData + 13) & 127
                    If CWData < 33 Then MyRandomAgain4
                Until CWData < 91            

            Case Else
                CWRandomMode = 0
                GoTo RunCWTEST_Sub
            EndSelect
            '/------------------------------------------------------------------
            HRSOut CWData               '/ Send the character to the terminal.
            GoSub KBSendBits_Sub        '/ Send every byte.
            DelayMS Msg_LetterSpaceTime
            '/------------------------------------------------------------------
            If F_ButtonSTOPpressed = 1 Then '/ Stop button.
                F_ButtonSTOPpressed = 0
                CWRandomMode = 0
                GoTo CWRANDOMEXIT
            EndIf
            If IP_DOT = 0 Then          '/ Stop practice with Dot Paddle. 
                CWRandomMode = 0
                GoTo CWRANDOMEXIT
            EndIf
            If IP_DASH = 0 Then 
                Inc CWRandomMode        '/ Change Mode for next practice with Dash Paddle.
                If CWRandomMode > 4 Then
                    CWRandomMode = 0
                EndIf
                GoTo CWRANDOMEXIT
            EndIf
            '/------------------------------------------------------------------
            INTCONBits_INT0IE = 1       '/ Enable the RB0 interrupt.
            Inc RDLoopRD
        Until RDLoopRD > 4              '/ Until block of 5 characters
        DelayMS Msg_WordSpaceTime   
        HRSOut " "
        '/----------------------------------------------------------------------
        RDLoopRD = 0
        Inc RDLoopTR
        If RDLoopTR > 12 Then           '/ End of the line.
            RDLoopTR = 0
            HRSOut CR
        EndIf
    Loop    

CWRANDOMEXIT:
    F_EnableMUTE = 0                '/ Disabled the MUTE option.   
    '/ Restore options.
    F_EnablePTT = F_EnablePTTCopy
    F_EnableTone = F_EnableToneCopy
    '/ New Seed function for next practice.
    CWSeedDWord = CWSeedDWord + $1038D35A
    '/--------------------------------------------------------------------------
    High StatusLED
    Repeat 
        #ifdef Watchdog_req
        Clrwdt
        #endif     
        DelayMS 10
    Until IP_DOT = 1
    Repeat 
        #ifdef Watchdog_req
        Clrwdt
        #endif      
        DelayMS 10
    Until IP_DASH = 1
    StatusLED = 0
    DelayMS 250
    HRSOut CR
    Return
#endIfMacro-
'/##############################################################################
'/==============================================================================
__OverCWKeyer:
'/============================================================================== 
'* Purpose : Configure the OpenADC Macro for some libraries
'* Input   : none                                      
'* Output  : none
'* Note    :  
'/
STARTSIZE(ADCCONFIG_CODE)
    '/ ADC library file.
'    $ifdef __CWKeyer
    Include "D:\MyIncFiles\Amicus_ADCbeta.Inc"
    '/ Configuration of the ADC library.
    ADC_IntDisable()
    OpenADC(ADC_FOSC_64 & ADC_RIGHT_JUST & ADC_12_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_0ANA)
'    $endif
ENDSIZE(ADCCONFIG_CODE)
'/============================================================================== 
'* Purpose : Reading the WPM potentiometer macro subroutine.
'* Input   : PORTA.1 hannel 1 input.                                       
'* Output  : Return_Var
'* Note    : Reading on the fly 32 Or 64 Steps only. 
'/
    GoTo OverCWReadWPMpot
'#ifMacro- _mCWReadWPMpot
CWReadWPMpot_Sub:
'/ Dinamic Parameters for the Keyer. (Configurable by a potentiometer)
'/ Set the WPM with an external potentiometer to set the CW WPM in ADC Channel 1.
'/
STARTSIZE(SET_WPM_CODE)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    ANSELBits_ANS0 = 1      '/ Configure channel 0 for analog.
    Input ADCpin            '/ Configure channel 0 for input.

    SetChanADC(ADC_CH0)     '/ AN0 for potentiometer.
    ADC8Bits()              '/ Using 8 bits of ADC
    ADCON0Bits_ADON = 1     '/ Start again the ADC.
    StartConvADC()          '/ Read the ADC value.
    WaitBusyADC()           '/ Waiting the ADC result.

    ADRESH = ADRESH >> 2    '/ 64 Threshold Values: Using 64 steps only of the ADC For Better immunity For noise.
'    ADRESH = ADRESH >> 3    '/ 32 Threshold Values: Using 32 steps only of the ADC. Better immunity for noise.
    KCW_WPM = ADRESH + CstWPMmin   '/ Add an offset to obtain the new WPM. (min 8)
    '/--------------------------------------------------------------------------
'    KCW_WPM = 12            '/ Only for test.
    '/--------------------------------------------------------------------------
    '/ Option: Send the new value of WPM to the terminal.
    If KCW_WPM <> WPM_OLD Then           '/ Check if value was changed.
        F_NewPWM = 1
        WPM_OLD = KCW_WPM                '/ Copy the new WPM.
    EndIf 
    '/--------------------------------------------------------------------------
    Return
    '/ Execution time min 4,7uS at 64Mhz.
ENDSIZE(SET_WPM_CODE)
'#endIfMacro-
'/------------------------------------------------------------------------------
OverCWReadWPMpot:
'/============================================================================== 
'* Purpose : Initializing parameters for the CW keyer library.
'* Input   : none                                       
'* Output  : None
'* Note    :  
'/
STARTSIZE(INITIALIZATION_CODE)
    INTCON = 0              '/ All interrupts disabled.
    INTCON2Bits_RBPU = 1    '/ 1 = All PORTB pull-ups are disabled
    '/--------------------------------------------------------------------------
    '/ PORTA
    ANSELBits_ANS0 = 0
    ANSELBits_ANS1 = 0
    ANSELBits_ANS2 = 0
    ANSELBits_ANS3 = 0
    ANSELBits_ANS4 = 0
    Input ADCpin            '/ PORTA.0
    Input COMPpin           '/ PORTA.1
    Input SWEncoderpin0     '/ PORTA.2
    Input SWEncoderpin1     '/ PORTA.3
    Input SWEncoderpin2     '/ PORTA.4
    Input SWEncoderpin3     '/ PORTA.5
    '/ PORTB    
    ANSELHBits_ANS12 = 0
    ANSELHBits_ANS10 = 0    
    ANSELHBits_ANS8 = 0
    ANSELHBits_ANS9 = 0
    Input ButtonFUNCTION      '/ PORTB.0
'    Input CWButtonCFG       '/ PORTB.1
'    Input CWButtonMEM       '/ PORTB.2
    Input IP_DASH           '/ PORTB.3
    Input IP_DOT            '/ PORTB.4
    Low SWEncoderAddPin0    '/ PORTB.5
    Low SWEncoderAddPin1    '/ PORTB.6
    Low SWEncoderAddPin2    '/ PORTB.7
    '/ PORTC  
    Low CWDataPin           '/ LATC.0  [Output] Keyer data to port RC0.
    Low StatusLED               '/ LATC.1  [Output] (Enable/Disable) Status LED to port RC1.
    Low CWToneOut           '/ LATC.2  [Output] "CWTonePin" to port RC2.
    Low CWPTT               '/ LATC.3  [Output] (enable/disable) PTT output to port RC3.
'    Input CWButtonQCC       '/ PORTC.4 [Input] Button QSO Contest Counter in PORTB.3. Decrement the QSO counter.
'    Input CWKEYBOARD        '/ PORTC.5 [Input] (enable/disable) using keyboard to send CW characters.   
    '/--------------------------------------------------------------------------
    WPM_OLD = 0     '/ Force to update CW speed (WPM).
    KYContestNumber = 0
    
    CW_Exit = 255
    CWStringDone = 0
    NbCharsPrinted = 0

    Clear CW_UrCallSignString   '/ Clear Your CallSign String.  
    CSWordCounter = 0
    DESpacePointer = 0

    '/ Clear all Flags
    KYCWFlags = 0
    KYInputFlags = 0
    PaddleStates = 0       
    CWCONFIGFlags = 0

    '/ CW Practice.
    CWSeedDWord = $759E13B5
    CWRandomMode = 0
ENDSIZE(INITIALIZATION_CODE)
'/==============================================================================
$endif  ' __CWKeyer
'/##############################################################################


