'****************************************************************
'*  Name    : TIPS_AND_TRICKS_V17.inc                           *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 24/07/2019                                        *
'*  Version : 1.0                                               *
'*  Notes   : Insert this file in first place in the main file  *
'*          : after the UART & LCD declarations                 *
'*          : This library needs the DeclareLocalVars.Inc. file *
'*  For PIC18FxxK22, xxK40, xxK42 some code must be changed     *
'*          : Using the compiler version 3.7.0.8                *
'****************************************************************
'
'/ Files needed:
'/ DeclareLocalVars.Inc
'/ PICslist.inc
'/ Amicus18_25K22.inc
'/ Amicus18_25K20.inc
'/ Proton18_16.Inc (new)

'/ Update 06/09/2018 BCD_Counters
'/ Update 19/09/2018 N-Bits BCD Maths with BCD counters.
'/ Inc / Dec / ADD / SUB / MUL / DIV.

'/ Update 03/10/2018 Version 1.4
'/ Fixed some parameters.
'/ Add new macros: MeasurePeriod(), MeasureTime(), HRSOut_RCON(), ConvToFloat().

'/ Update 09/10/2018 Version 1.5
'/ Added new macros: ReadTSensorTSH(), VarToStrg()
'/ Modification in demo files of ConvToFloat & Macros ConvAToFloat/ConvBToFloat.

'/ Update 14/10/2018 Version 1.6
'/ Added a new code for the VarToStrg() macro.
'/ Modified the MyDelayMS(pValue) for the special Watchdog.
'/ Added new macros: CWBeacon_Init()/CWBeacon_Send() to write a CW Beacon proyect.
'/
'/ Update 22/10/2018 Version 1.7
'/ For CW_Beacon macro: Added CWToneOut & CWPTT_TXON_Delay to be defined by user.
'/ Add Goertzel Algorithm library.

'/##############################################################################
'===============================================================================
' This library contains free software for personal use only, you can redistribute it 
' and/or modify. The code is offered as-is and the author does not take any 
' responsibility for its use. This program is distributed in the hope that it will
' be useful, but WITHOUT ANY WARRANTY. However, a mention of the author and compiler
' would be appreciated.
'
' Esta libreria contiene un software libre para uso privado, puede redistribuirlo y/o
' modificarlo. Se entrega este cdigo tal como esta y el autor NO se hace responsable
' de su utilizacin. Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador sera
' muy apreciado.

' Cette librairie contient un logiciel libre pour utilisation prive, vous pouvez le
' redistribuer et/ou modifier. Ce logiciel est offert tel qu'il est, et son auteur
' NE prend AUCUNE responsabilit pour son utilization. Ce programme est distribu
' dans l'espoir qu'il sera util, ' mais SANS AUCUNE GARANTIE. Cependant mentionner
' l'auteur et le compileur serait trs aprci.
'-------------------------------------------------------------------------------
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
' PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHOR OR COPYRIGHT
' HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
' OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
' SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'/==============================================================================
$ifndef __TIPS_AND_TRICKS_INC_
$define __TIPS_AND_TRICKS_INC_
'/##############################################################################
    GoTo END_TIPS_AND_TRICKS_INC
'/==============================================================================
    '/ Check the Core
    #if _core != 16
        #error "Theses Macros are for PIC18 devices ONLY!"
    #endif
'/==============================================================================
    '/ Create your own path in the Hard disk D:\MyIncFiles. 
    Include "D:\MyIncFiles\DeclareLocalVars.inc"
'    Include "D:\MyIncFiles\PICslist.inc"
'/==============================================================================
    $ifndef __DeclareLocals_Inc_
        $error "Cannot locate the Include file: DeclareLocalVars.inc!"
    $endif

'    $ifndef __PICsList_Inc_
'        $error "Cannot locate the Include file: PICsList.inc!"
'    $endif
'/==============================================================================
    '/ Check Parameters of PIC.def file.
    $ifndef _block
        $error "Error in the PIC.def in \ProtonIDE\PDS\Includes\Defs. The _block parameter is missing"       
    $endif

$ifdef __ExtraPICParameters
    $ifndef _erase
        $error "_erase parameter is missing! Edit the PICsList.inc or your PIC header and add the _erase parameter for this PIC"  
    $endif

    '/ Check Parameters of PICsList.inc file.
    $ifndef __DEVICE_ID
        $error "__DEVICE_ID parameter is missing! Edit the PICsList.inc Or your PIC header and add the __DEVICE_ID parameter for this PIC"      
    $endif
$endif
'/==============================================================================
' Declarations for the KEYPAD INKEYX for PICs.
'/ Because the asm does not have these datas.
'/ Declare the addresses of PORTs TRISx & LATx
'/ Valid for asm code only. It is running also with Num_SFR macro.
'$ifndef _KeypadDeclare_
'$define _KeypadDeclare_
'/------------------------------------------------------------------------------
#ifdef __KEYPAD_PORT
    #if (__KEYPAD_PORT == PORTA)
        #define __KEYPAD_TRIS TRISA
        #define __KEYPAD_LAT LATA
    #endif

    #if (__KEYPAD_PORT == PORTB)
        #define __KEYPAD_TRIS TRISB
        #define __KEYPAD_LAT LATB
    #endif

    $ifdef _PORTC
        #if (__KEYPAD_PORT == PORTC)
            #define __KEYPAD_TRIS TRISC
            #define __KEYPAD_LAT LATC
        #endif
    $endif

    $ifdef _PORTD
        #if (__KEYPAD_PORT == PORTD)
            #define __KEYPAD_TRIS TRISD
            #define __KEYPAD_LAT LATD
        #endif
    $endif

    $ifdef _PORTE
        #if (__KEYPAD_PORT == PORTE)
            #define __KEYPAD_TRIS TRISE
            #define __KEYPAD_LAT LATE
        #endif
    $endif

    $ifdef _PORTF    
        #if (__KEYPAD_PORT == PORTF)
            #define __KEYPAD_TRIS TRISF
            #define __KEYPAD_LAT LATF
        #endif
    $endif

    $ifdef _PORTG    
        #if (__KEYPAD_PORT == PORTG)
            #define __KEYPAD_TRIS TRISG
            #define __KEYPAD_LAT LATG
        #endif
    $endif

    $ifdef _PORTH    
        #if (__KEYPAD_PORT == PORTH)
            #define __KEYPAD_TRIS TRISH
            #define __KEYPAD_LAT LATH
        #endif
    $endif
#endif
'$endif
'/==============================================================================

    Asm
    messg proton#main#start#Address = #v(proton#main#start)
    EndAsm
   
'/==============================================================================
    '/ You can define:
    '/$define _English_
    '/Or $define _Spanish_
    '/Or $define _French_
    '/ Check the language (English as default)
    $if !_defined(_English_) And !_defined(_Spanish_) And !_defined(_French_) 
        $define _English_
    $endif    

    $ifndef False
        $define False 0
    $endif

    $ifndef True
        $define True 1
    $endif

    $ifndef CR
        $define CR 13
    $endif

    $ifndef LF
        $define LF 10
    $endif

    '/ Check the HRSOut command.
    '/ You can define:
    '/ $define _HRSOut_ HRSOut
    '/ $define _HRSOut_ HRSOut1
    '/ $define _HRSOut_ HRSOut2
    '/ $define _HRSOut_ HRSOut3
    '/ etc...            
    $ifndef _HRSOut_
        $define _HRSOut_ HRSOut
    $endif

    '/ Declare the LCD Lenght
    $ifndef _LCD_CharsLenght_
        $define _LCD_CharsLenght_ 16
    $endif
    Symbol __LCD_CharsLenght = _LCD_CharsLenght_

    '/ EEPROM Address
    $ifdef _EEADR
        $if _eeprom > 256
        Dim EEADDR As EEADR.Word
        $else
        Dim EEADDR As EEADR
        $endif
    $else
        $ifdef _NVMADRL
            $if _eeprom > 256
            Dim EEADDR As NVMADRL.Word
            $else
            Dim EEADDR As NVMADRL
            $endif
        $endif
    $endif
    
    '/ ADC     
    Dim ADCResult As ADRESL.Word
    
    '/ PROD
    Dim PROD As PRODL.Word           
'/==============================================================================
    '/ Standard constant for Maths calculations.
'    Symbol PI = 3.14159
    Symbol PI = 3.141592
'    Symbol PI = 3.14159265
    Symbol TwoPI = PI * 2
'/==============================================================================
'/ Some data for this must edited in the PICsList.Inc file.
    '/ Data from the compiler.
    $ifdef _block
        $define WRITE_FLASH_BLOCKSIZE _block
        Symbol __WRITE_FLASH_BLOCKSIZE = _block
    $endif
'/------------------------------------------------------------------------------
$ifdef __ExtraPICParameters
    '/ Device ID number of the current PIC.
    $ifdef __DEVICE_ID
        Symbol __DEV_ID =__DEVICE_ID    '/ To be seen in the asm file.
    $endif

    '/ Check if _erase value is defined for this PIC.
    $ifdef _erase
        $define ERASE_FLASH_BLOCKSIZE _erase
        Symbol __Erase = _erase         '/ To be seen in the asm file.
    $endif

    $if ERASE_FLASH_BLOCKSIZE > 1024
        $error "ERASE_FLASH_BLOCKSIZE must be 64, 128, 256, 512 or 1024!"
    $endif
    $if ERASE_FLASH_BLOCKSIZE < 64
        $error "ERASE_FLASH_BLOCKSIZE value seems not correct, see the datatsheet!"
    $endif
$else
    Symbol __Erase = 0
    Symbol __DEV_ID = 0
$endif
'-------------------------------------------------------------------------------
$if ERASE_FLASH_BLOCKSIZE = 1024
    $define MASK_ERASE_BLOCK 64512
$endif

$if ERASE_FLASH_BLOCKSIZE = 512
    $define MASK_ERASE_BLOCK 65024
$endif

$if ERASE_FLASH_BLOCKSIZE = 256
    $define MASK_ERASE_BLOCK 65280
$endif

$if ERASE_FLASH_BLOCKSIZE = 128
    $define MASK_ERASE_BLOCK 65408
$endif

$if ERASE_FLASH_BLOCKSIZE = 64
    $define MASK_ERASE_BLOCK 65472
$endif

$if ERASE_FLASH_BLOCKSIZE = 32
    $define MASK_ERASE_BLOCK 65504
$endif

'/------------------------------------------------------------------------------
    $if WRITE_FLASH_BLOCKSIZE = 256
    Symbol __WRITE_BLOCK_SHIFT_BITS = 8
    Symbol __MASK_HEAD_ADDRESS_OFFSET = $0000FF
    Symbol __MASK_WRITE_BLOCK = $FFFF00
    $endif

    $if WRITE_FLASH_BLOCKSIZE = 128
    Symbol __WRITE_BLOCK_SHIFT_BITS = 7
    Symbol __MASK_HEAD_ADDRESS_OFFSET = $00007F
    Symbol __MASK_WRITE_BLOCK = $FFFF80
    $endif

    $if WRITE_FLASH_BLOCKSIZE = 64
    Symbol __WRITE_BLOCK_SHIFT_BITS = 6
    Symbol __MASK_HEAD_ADDRESS_OFFSET = $00003F
    Symbol __MASK_WRITE_BLOCK = $FFFFC0
    $endif

    $if WRITE_FLASH_BLOCKSIZE = 32
    Symbol __WRITE_BLOCK_SHIFT_BITS = 5
    Symbol __MASK_HEAD_ADDRESS_OFFSET = $00001F
    Symbol __MASK_WRITE_BLOCK = $FFFFE0
    $endif

    $if WRITE_FLASH_BLOCKSIZE = 16
    Symbol __WRITE_BLOCK_SHIFT_BITS = 4
    Symbol __MASK_HEAD_ADDRESS_OFFSET = $00000F
    Symbol __MASK_WRITE_BLOCK = $FFFFF0
    $endif

    $if WRITE_FLASH_BLOCKSIZE = 8
    Symbol __WRITE_BLOCK_SHIFT_BITS = 3
    Symbol __MASK_HEAD_ADDRESS_OFFSET = $000007
    Symbol __MASK_WRITE_BLOCK = $FFFFF8
    $endif

'/------------------------------------------------------------------------------
$ifdef __ExtraPICParameters
'/ Syncronize ORG with the ERASE BLOCK
'$define ORG_EBlock(pAddress) Org (pAddress & MASK_ERASE_BLOCK)
    $define ORG_EBlock(pAddress) Org $eval (pAddress & MASK_ERASE_BLOCK)

'/ Built a constant.
'/ Syncronize an address with the ERASE BLOCK
'/ pAddressIn is the input address.
'/ The real Blocks size are = 0 to ((pAddressIn & MASK_ERASE_BLOCK) / _erase) - 1 
'/ The result is the Erase Block number not the number of Erase Blocks from address 0.

    $define Sync_EBlock(pName,pAddressIn)          '
    Symbol pName = (pAddressIn & MASK_ERASE_BLOCK) '
    Symbol NumberBlock#pName = ((pAddressIn & MASK_ERASE_BLOCK) / _erase) - 1
   
$endif
'/==============================================================================
'/##############################################################################
'*******************************************************************************
'* Name    : List of Library Commands                                          *
'* Author  : [Alberto Freixanet 2018]                                          *
'* Purpose : To use the necessary resources of RAM only.                       *
'* Notes   : Copy & paste this list before Include ["TIPS_AND_TRICKS_V10.Inc"] *
'*           in your main code                                                 *
'*******************************************************************************
'    $define __MEASURE_CODE_
'    $define _GIE_Save_
'    $define _HRSOutTwoStopBitsInc_
'    $define _VarToStrgRS_
'    $define _VarToSTrgStr_
'    $define _VarToStrg_
'    $define _IDLOCS_
'    $define _DEVID1_
'    $define _MyRandom_
'    $define _Manchester_
'    $define _GetParity_
'    $define _DebounceByte_
'    $define _LENArray_
'    $define _HEXtoASCII_
'    $define _BCD_BIN_
'    $define _BIN_BCD_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_
'    $define _StringToFloat_
'    $define _ConvToFloat_
'    $define _CLL_
'    $define _CRC16_
'    $define _BCDCounters_
'/ Keypads InkeyX
'    $define _Disable_Keypad_Pullups_
'    $define _4x4KEYPAD_
'    $define _4x3KEYPAD_
'    $define _4x2KEYPAD_
'/ Others Macros
'    $define _MidPointDW_
'    $define _MidPointW_
'    $define _MidPointB_
'    $define _MedianFilter_
'    $define _BubbleSort_
'    $define _CountUntil_
'    $define _BinaryTo3BCD_
'    $define _BCD2ToBinary_
'    $define _WordTo5BCD_
'    $define _RotateBits_
'    $define _DwordArray_
'    $define _ArrayROL_
'    $define _ArrayROR_
'    $define _ArrayROLR_
'    $define _ArrayRORR_
'    $define _ArrayBit_
'    $define _Multi_DIM_Array_
'    $define _GrayCode_
'    $define _GetMinMax_
'    $define _DegC_DegF_
'    $define _HRSLStrg_
'    $define _HRSFStrg_
'    $define _PrintStrg_
'    $define _HRSE2PStrg_
'    $define _CopyROMtoE2P_
'    $define _PrintE2PStrg_
'    $define _ADCaverageA_
'    $define _ADCaverageB_
'    $define _MeasurePeriod_
'    $define _MeasureTime_
'    $define _CheckRCONBits_
'    $define _ReadTSensorTSH_
'    $define _Beep_
'    $define _CWBeacon_
'    $define _CWKeyer_
'    $define _Goertzel_
'*******************************************************************************
'* Name    : STARTSIZE / ENDSIZE                                               *
'* Author  : [Darrel Taylor] modified by Alberto Feixanet                      *
'* Purpose : Measure the number of lines of code                               *
'* Input   : Macro name                                                        *
'* Output  : Messages in project.asm or project.lst files                      *
'* Syntax  : STARTSIZE(ROUTINE1) / ENDSIZE(ROUTINE1)                           *
'* Notes   : The 2 texts must be the same                                      *
'*           Need a $define to enable the macros. ($define __MEASURE_CODE_)    *
'*           No bytes in the asm file, only messages.                          *
'*           Fore Core = 14 & Core = 16                                        *
'* Compiler: Compiled with PDS Version 3.6.1.7                                 *
'*******************************************************************************
'/ Write this macro before the code to measure.
'/ Write a text to recognize the piece of code. For example [LookUp_Routine].
'/ STARTSIZE(LookUp_Routine)
'/
$define STARTSIZE(pText)              '
    $ifdef __MEASURE_CODE_            '
        Asm                           '
        messg "NEW_MEASURE_"#pText    '
        NOlist                        '
        Variable STARTCODE#pText = $  '
        list                          '    
        EndAsm                        '
    $else                             '
        Asm                           '
        messg "START_CODE"#pText      '
        EndAsm                        '
    $endif

'/------------------------------------------------------------------------------
'/ Write this macro after the code to measure.
'/ Write a text to recognize the piece of code, same as STARTSIZE.
'/ ENDSIZE(LookUp_Routine)
'/
$define ENDSIZE(pText)             '
    $ifdef __MEASURE_CODE_         '
        Asm                        '
        NOlist                     '
        Variable ENDCODE#pText = $ '
        list                       '
        EndAsm                     '
        #ifdef BSR                 '
            Asm                    '
            NOlist                 '
            Variable SIZE_CODE#pText = ENDCODE#pText - STARTCODE#pText                       '
            Variable TIME_CODE#pText = (#v(SIZE_CODE#pText) * 4000) / Xtal                   ' 
            TOTAL_LIB_SIZE = TOTAL_LIB_SIZE + SIZE_CODE#pText                                '
            list                                                                             '
            messg SIZE_CODE#pText = #v(SIZE_CODE#pText)[BYTEs]= #v(SIZE_CODE#pText/2)[WORDs] '
            messg TIME_CODE#pText = #v(TIME_CODE#pText)[nanoS]                               '
            messg "END_MEASURE"#pText                                                        '
            EndAsm                                                                           '
        #else                                                                                '
            Asm                                                                              '
            NOlist                                                                           '        
            Variable SIZE_CODE#pText = ENDCODE#pText - STARTCODE#pText                       '
            Variable TIME_CODE#pText = (#v(SIZE_CODE#pText) * 4000) / Xtal                   ' 
            TOTAL_LIB_SIZE = TOTAL_LIB_SIZE + SIZE_CODE#pText                                '
            list                                                                             '        
            messg SIZE_CODE#pText = #v(SIZE_CODE#pText)[BYTEs]                               '
            messg TIME_CODE#pText = #v(TIME_CODE#pText)[nanoS]                               '
            messg "END_MEASURE"#pText '
            EndAsm                    '
        #endif                        '
    $else                             '
        Asm                           '
        messg "END_CODE"#pText        '
        EndAsm                        '
    $endif
    
'/------------------------------------------------------------------------------
'/ Write this macro before the file to init the counter of lines of code.
$define STARTLIBSIZE()       '
    $ifdef __MEASURE_CODE_   '
    Asm                      '
    NOlist                   '
    TOTAL_LIB_SIZE = 0       '
    list                     '
    EndAsm                   '
    $endif
    
'/------------------------------------------------------------------------------
'/ Write this macro after the file to measure all routines used.
$define ENDLIBSIZE(pText)                                  '
    $ifdef __MEASURE_CODE_                                 '
        Asm                                                '
        messg "TOTAL_FILE_SIZE"#pText = #v(TOTAL_LIB_SIZE)BYTES '
        NOlist                                             '
        TOTAL_LIB_SIZE = 0                                 '
        list                                               '
        EndAsm                                             '
    $else                                                  '
        Asm                                                '
        messg "END_FILE_"#pText                            '
        EndAsm                                             '
    $endif

'/------------------------------------------------------------------------------
'/ Init the variable TOTAL_LIB_SIZE.
    $ifdef __MEASURE_CODE_
    Asm
    NOlist
    Variable TOTAL_LIB_SIZE = 0
    list
    EndAsm
    $endif

'/==============================================================================
'STARTLIBSIZE(TIPS_AND_TRICKS_INC)
'*******************************************************************************
'* Name    : ASMnumParam                                                       *
'* Author  : [Alberto Feixanet]                                                *
'* Purpose : Show the numeric value of ASM parameter (could be a RAM address)  *
'* Input   : a parameter name                                                  *
'* Output  : pResult (Byte/Word/Dword)                                         *
'* Syntax  : ASMnumParam(BankA_End, VarByte)                                   *
'* Notes   : VarPtr doesn't run when the Variable is declared after the macro  *
'*           For core = 16                                                     *
'*           05/09/2018 _ParameterAddr is a Local Dword system variable        *
'*******************************************************************************

$define ASMParameter(pValueIn,pMode,pResult)   '
$if pMode < 255                                '
    Asm                                        '
    messg "NEW_MACRO_PARAMETER"#pMode#pValueIn '
    EndAsm                                 '
        $ifndef _ParameterAddr_Var         '
        $define _ParameterAddr_Var         '
        Dim _ParameterAddr As Dword System '
        $endif                           '
        Asm-                             '
        Movlw Low (pValueIn)             '
        Movff WREG,_ParameterAddr        '
        Movlw High (pValueIn)            '
        Movff WREG,_ParameterAddrH       '
        Movlw Upper (pValueIn)           '
        Movff WREG,_ParameterAddrHH      '
        Clrf  _ParameterAddrHHH          '
        Endasm-                          '        
    pResult = _ParameterAddr             '
    Asm                                  '
    messg Value_Parameter#pMode#pValueIn = #v(pValueIn) '
    messg "END_MACRO"                                   '
    EndAsm                                              '
$else                                                   '
    Asm                                                 '
    messg "MACRO_RESULT"#pMode#_Value_Parameter_#pValueIn = #v(pValueIn) '
    EndAsm                                                               '    
$endif

'$define ASMParameter(pValueIn,pMode,pResult)   '
'$if pMode < 255                                '
'    Asm                                        '
'    messg "NEW_MACRO_PARAMETER"#pMode#pValueIn '
'    EndAsm                                 '
'        $ifndef _ParameterAddr_Var         '
'        $define _ParameterAddr_Var         '
'        Dim _ParameterAddr As Dword System '
'        $endif                           '
'        $if _code > 65535                '
'        Asm-                             '
'        Movlw Low (pValueIn)             '
'        Movff WREG,_ParameterAddr        '
'        Movlw High (pValueIn)            '
'        Movff WREG,_ParameterAddrH       '
'        Movlw Upper (pValueIn)           '
'        Movff WREG,_ParameterAddrHH      '
'        Clrf  _ParameterAddrHHH          '
'        Endasm-                          '        
'        $else                            '
'        Asm-                             '
'        Movlw Low (pValueIn)             '
'        Movff WREG,_ParameterAddr        '
'        Movlw High (pValueIn)            '
'        Movff WREG,_ParameterAddrH       '
'        Clrf  _ParameterAddrHH           '
'        Clrf  _ParameterAddrHHH          '
'        Endasm-                          '        
'        $endif                           '
'    pResult = _ParameterAddr             '
'    Asm                                  '
'    messg Value_Parameter#pMode#pValueIn = #v(pValueIn) '
'    messg "END_MACRO"                                   '
'    EndAsm                                              '
'$else                                                   '
'    Asm                                                 '
'    messg "MACRO_RESULT"#pMode#_Value_Parameter_#pValueIn = #v(pValueIn) '
'    EndAsm                                                               '    
'$endif

'*******************************************************************************
'* Name    : BankRam (Bank0 to Bank15)                                         *
'* Author  : [Alberto Feixanet]                                                *
'* Purpose : Shows the Address and Bank of a RAM variable                      *
'* Input   : Variable namne                                                    *
'* Output  : RAM Address (Byte/Word), Number of Bank (Byte)                    *
'* Syntax  : BankRAM(Name/Label, Return Address RAM, Return number Bank)       *
'* Notes   : VarPtr doesn't run when the Variable is declared after the macro  *
'*           If Number of Bank = 255 then the variable is in BankA             *
'*******************************************************************************

$define BankRAM(pValueIn,pMode,pRamAddr,pNumBank) '
    Asm                                           '
    messg "NEW_MACRO_BANKRAM"#pMode#pValueIn      '
    EndAsm                                        '
    $if pMode < 255                               '
        $ifndef _ParameterAddr_Var                '
        $define _ParameterAddr_Var                '
        Dim _ParameterAddr As PRODL.Word          '
        $endif                                    '
        Asm-                                      '
        Movlw Low (pValueIn)                      '
        Movff WREG,PRODL                          '
        Movlw High (pValueIn)                     '
        Movff WREG,PRODH                          '
        Endasm-                                   '
        pRamAddr = _ParameterAddr                 '
    $endif                                        '
    #if (pValueIn >= BankA_Start) && (pValueIn <= BankA_End) '
        $if pMode < 255                                      '
        Set_Bank pNumBank                                    '
        pNumBank = 255                                       '
        Reset_Bank                                           '
        $endif                                               '
        Asm                                                  '
        NOlist                                               '
        Variable VNumBank = 255                              '
        list                                                 '
        EndAsm                                               '
    #endif                                                   '
    #if (pValueIn >= Bank0_Start) && (pValueIn <= Bank0_End) '
        $if pMode < 255                                      '
        Set_Bank pNumBank                                    '
        pNumBank = 0                                         '
        Reset_Bank                                           '
        $endif                                               '
        Asm                                                  '
        NOlist                                               '
        Variable VNumBank = 0                                '
        list                                                 '
        EndAsm                                               '
    #endif                                                   '
    #if (pValueIn >= Bank1_Start) && (pValueIn <= Bank1_End) '
        $if pMode < 255                                      '
        Set_Bank pNumBank                                    '
        pNumBank = 1                                         '
        Reset_Bank                                           '
        $endif                                               '
        Asm                                                  '
        NOlist                                               '
        Variable VNumBank = 1                                '
        list                                                 '
        EndAsm                                               '
    #endif                                                   '
    #ifdef Bank2_Start                                       '
        #if (pValueIn >= Bank2_Start) && (pValueIn <= Bank2_End) '
            $if pMode < 255                                      '
            Set_Bank pNumBank                                    '
            pNumBank = 2                                         '
            Reset_Bank                                           '
            $endif                                               '
            Asm                                                  '
            NOlist                                               '
            Variable VNumBank = 2                                '
            list                                                 '
            EndAsm                                               '
        #endif                                                   '
    #endif                                                       '
    #ifdef Bank3_Start                                           '
        #if (pValueIn >= Bank3_Start) && (pValueIn <= Bank3_End) '
            $if pMode < 255                                      '
            Set_Bank pNumBank                                    '
            pNumBank = 3                                         '
            Reset_Bank                                           '
            $endif                                               '
            Asm                                                  '
            NOlist                                               '
            Variable VNumBank = 3                                '
            list                                                 '
            EndAsm                                               '
        #endif                                                   '
    #endif                                                       '
    #ifdef Bank4_Start                                           '
        #if (pValueIn >= Bank4_Start) && (pValueIn <= Bank4_End) '
            $if pMode < 255                                      '
            Set_Bank pNumBank                                    '
            pNumBank = 4                                         '
            Reset_Bank                                           '
            $endif                                               '
            Asm                                                  '
            NOlist                                               '
            Variable VNumBank = 4                                '
            list                                                 '
            EndAsm                                               '
        #endif                                                   '
    #endif                                                       '
    #ifdef Bank5_Start                                           '
        #if (pValueIn >= Bank5_Start) && (pValueIn <= Bank5_End) '
            $if pMode < 255                                      '
            Set_Bank pNumBank                                    '
            pNumBank = 5                                         '
            Reset_Bank                                           '
            $endif                                               '
            Asm                                                  '
            NOlist                                               '
            Variable VNumBank = 5                                '
            list                                                 '
            EndAsm                                               '
        #endif                                                   '
    #endif                                                       '
    #ifdef Bank6_Start                                           '
        #if (pValueIn >= Bank6_Start) && (pValueIn <= Bank6_End) '
            $if pMode < 255                                      '
            Set_Bank pNumBank                                    '
            pNumBank = 6                                         '
            Reset_Bank                                           '
            $endif                                               '
            Asm                                                  '
            NOlist                                               '
            Variable VNumBank = 6                                '
            list                                                 '
            EndAsm                                               '
        #endif                                                   '
    #endif                                                       '
    #ifdef Bank7_Start                                           '
        #if (pValueIn >= Bank7_Start) && (pValueIn <= Bank7_End) '
            $if pMode < 255                                      '
            Set_Bank pNumBank                                    '
            pNumBank = 7                                         '
            Reset_Bank                                           '
            $endif                                               '
            Asm                                                  '
            NOlist                                               '
            Variable VNumBank = 7                                '
            list                                                 '
            EndAsm                                               '
        #endif                                                   '
    #endif                                                       '
    #ifdef Bank8_Start                                           '
        #if (pValueIn >= Bank8_Start) && (pValueIn <= Bank8_End) '
            $if pMode < 255                                      '
            Set_Bank pNumBank                                    '
            pNumBank = 8                                         '
            Reset_Bank                                           '
            $endif                                               '
            Asm                                                  '
            NOlist                                               '
            Variable VNumBank = 8                                '
            list                                                 '
            EndAsm                                               '
        #endif                                                   '
    #endif                                                       '
    #ifdef Bank9_Start                                           '
        #if (pValueIn >= Bank9_Start) && (pValueIn <= Bank9_End) '
            $if pMode < 255                                      '
            Set_Bank pNumBank                                    '
            pNumBank = 9                                         '
            Reset_Bank                                           '
            $endif                                               '
            Asm                                                  '
            NOlist                                               '
            Variable VNumBank = 9                                '
            list                                                 '
            EndAsm                                               '
        #endif                                                   '
    #endif                                                       '
    #ifdef Bank10_Start                                          '
        #if (pValueIn >= Bank10_Start) && (pValueIn <= Bank10_End) '
            $if pMode < 255                                        '
            Set_Bank pNumBank                                      '
            pNumBank = 10                                          '
            Reset_Bank                                             '
            $endif                                                 '
            Asm                                                    '
            NOlist                                                 '
            Variable VNumBank = 10                                 '
            list                                                   '
            EndAsm                                                 '
        #endif                                                     '
    #endif                                                         '
    #ifdef Bank11_Start                                            '
        #if (pValueIn >= Bank11_Start) && (pValueIn <= Bank11_End) '
            $if pMode < 255                                        '
            Set_Bank pNumBank                                      '
            pNumBank = 11                                          '
            Reset_Bank                                             '
            $endif                                                 '
            Asm                                                    '
            NOlist                                                 '
            Variable VNumBank = 11                                 '
            list                                                   '
            EndAsm                                                 '
        #endif                                                     '
    #endif                                                         '
    #ifdef Bank12_Start                                            '
        #if (pValueIn >= Bank12_Start) && (pValueIn <= Bank12_End) '
            $if pMode < 255                                        '
            Set_Bank pNumBank                                      '
            pNumBank = 12                                          '
            Reset_Bank                                             '
            $endif                                                 '
            Asm                                                    '
            NOlist                                                 '
            Variable VNumBank = 12                                 '
            list                                                   '
            EndAsm                                                 '
        #endif                                                     '
    #endif                                                         '    
    #ifdef Bank13_Start                                            '
        #if (pValueIn >= Bank13_Start) && (pValueIn <= Bank13_End) '
            $if pMode < 255                                        '
            Set_Bank pNumBank                                      '
            pNumBank = 13                                          '
            Reset_Bank                                             '
            $endif                                                 '
            Asm                                                    '
            NOlist                                                 '
            Variable VNumBank = 13                                 '
            list                                                   '
            EndAsm                                                 '
        #endif                                                     '
    #endif                                                         '
    #ifdef Bank14_Start                                            '
        #if (pValueIn >= Bank14_Start) && (pValueIn <= Bank14_End) '
            $if pMode < 255                                        '
            Set_Bank pNumBank                                      '
            pNumBank = 14                                          '
            Reset_Bank                                             '
            $endif                                                 '
            Asm                                                    '
            NOlist                                                 '
            Variable VNumBank = 14                                 '
            list                                                   '
            EndAsm                                                 '
        #endif                                                     '
    #endif                                                         '
    #ifdef Bank15_Start                                            '
        #if (pValueIn >= Bank15_Start) && (pValueIn <= Bank15_End) '
            $if pMode < 255                                        '
            Set_Bank pNumBank                                      '
            pNumBank = 15                                          '
            Reset_Bank                                             '
            $endif                                                 '
            Asm                                                    '
            NOlist                                                 '
            Variable VNumBank = 15                                 '
            list                                                   '
            EndAsm                                                 '
        #endif                                                     '
    #endif                                                         '
    $if pMode < 255                                                '
    Asm                                                            '
    messg "MACRO_BANKRAM"#pMode#_Address_Variable_#pValueIn = #v(pValueIn) '
    messg "MACRO_BANKRAM"#pMode#_Bank_Variable_#pValueIn = #v(VNumBank)    '
    messg "END_MACRO"                                                      '
    EndAsm                                                                 '
    $else                                                                  '
    Asm                                                                    '
    messg "MACRO_BANKRAM"#pMode#_Address_Variable_#pValueIn = #v(pValueIn) '
    messg "MACRO_BANKRAM"#pMode#_Bank_Variable_#pValueIn = #v(VNumBank)    '    
    EndAsm                                                                 '
    $endif
'/==============================================================================
'*******************************************************************************
'* Name    : ClearGIE / SetGIE                                                 *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Clear & Set the GIE interrupt flag                                *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    :                                                                   *
'*******************************************************************************
' Clear the GIE Flag
    $ifndef ClearGIE
        $define ClearGIE()          '
        #ifdef __INTERRUPTS_ENABLED '
        INTCONBits_GIE = 0          '
        #endif

    $endif
    
    ' Set the GIE Flag
    $ifndef SetGIE
        $define SetGIE()            '
        #ifdef __INTERRUPTS_ENABLED '        
        INTCONBits_GIE = 1          '
        #endif

    $endif

'*******************************************************************************
'* Name    : GIE_Save() / GIE_Restore()                                        *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Save/Clear & Restore/Set the GIE                                  *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    :                                                                   *
'*******************************************************************************
'$ifdef _GIE_Save_
'/------------------------------------------------------------------------------
'/ Defined in the DeclareLocalVars.inc.
'/ Global variable.
    $ifndef xINTCON_Save_Var
    $define xINTCON_Save_Var
    Dim xINTCON_Save As Byte System
    $endif

'/ Save and clear the GIE global interrupt.
$ifndef GIE_Save
    $define GIE_Save()          '              
    #ifdef __INTERRUPTS_ENABLED '
    Asm                         '
    messg "GIE_SAVE_MACRO"      '
    EndAsm                      '
    xINTCON_Save = INTCON       '
    INTCONbits_GIE = 0          '
    #endif
    
$endif
    
'/ Restore and set the GIE global interrupt.
$ifndef GIE_Restore
    $define GIE_Restore()       '
    #ifdef __INTERRUPTS_ENABLED '
    Asm                         '
    messg "GIE_RESTORE_MACRO"   '
    EndAsm                      '
    If xINTCON_Save.7 = 1 Then  '
        INTCONbits_GIE = 1      '
    EndIf                       '
    #endif

$endif
'/------------------------------------------------------------------------------
'$endif    
'/==============================================================================
'/ Declare some important variables.
    Dim HRSByte As Byte System
    Dim Save_FSR0 As Word System
    Dim Save_FSR1 As Word System 
    Dim Save_FSR2 As Word System
'*******************************************************************************
'* Name    : Watchdog commands                                                 *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Clear / Disable / Enable the Watchdog                             *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    : Some commands To drive the Watchdog If used by the compiler       *
'*******************************************************************************
   
$define ClearWatchdog() '
    #ifdef Watchdog_req '
    Clrwdt              '
    #endif

' Watchdog is OFF 
$define Disable_SWDTEN() WDTCONBits_SWDTEN = 0

' Watchdog is On
$define Enable_SWDTEN() WDTCONBits_SWDTEN = 1

'*******************************************************************************
'* Name    : Load_TBLPTR                                                       *
'* Author  : [Alberto Freixanet 2018]                                          *
'* Purpose : Load a label into the poInters TBLPTRL/TBLPTRH/TBLPTRU            *
'* Input   : LABEL                                                             *
'* Output  : TBLPTRL/TBLPTRH/TBLPTRU                                           *
'* Note    : The macro does not use external variable.                         *
'*******************************************************************************
$define Load_TBLPTR(pLoadLabelIn)      '
#if pLoadLabelIn > 65536               '
    Asm-                               '
    Movlw (pLoadLabelIn & 255)         '
    Movff WREG,TBLPTRL                 '
    Movlw ((pLoadLabelIn >> 8) & 255)  '
    Movff WREG,TBLPTRH                 '
    Movlw ((pLoadLabelIn >> 16) & 255) '
    Movff WREG,TBLPTRU                 '
    Endasm-                            '
#else                                  '
    Asm-                               '
    Movlw (pLoadLabelIn & 255)         '
    Movff WREG,TBLPTRL                 '
    Movlw ((pLoadLabelIn >> 8) & 255)  '
    Movff WREG,TBLPTRH                 '           
    Clrf  TBLPTRU                      '
    Endasm-                            '
#endif

'*******************************************************************************
'* Name    : LCD_Reset                                                         *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Force a Reset to the LCD                                          *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_Reset()                                                       *
'* Note    : Reset the LCD to force an initialization.                         *
'*******************************************************************************
$ifndef LCD_Reset
    $define LCD_Reset()        ' 
    STARTSIZE(LCD_Reset_MACRO) '
    BPF = 0                    '
    Cls                        '
    ENDSIZE(LCD_Reset_MACRO)

$endif

'*******************************************************************************
'* Name    : LCD_Clear                                                         *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Clear the LCD                                                     *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_Clear()                                                       *
'* Note    :                                                                   *
'*******************************************************************************
$ifndef LCD_Clear
    $define LCD_Clear()        ' 
    STARTSIZE(LCD_Clear_MACRO) '
    Print $FE,1                '
    ENDSIZE(LCD_Clear_MACRO)

$endif

'*******************************************************************************
'* Name    : LCD_ReturnHome                                                    *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Return home (beginning of first Line)                             *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_ReturnHome()                                                  *
'* Note    :                                                                   *
'*******************************************************************************
$ifndef LCD_ReturnHome
    $define LCD_ReturnHome()     ' 
    STARTSIZE(LCD_RetHome_MACRO) '
    Print $FE,2                  '
    ENDSIZE(LCD_RetHome_MACRO)

$endif

'*******************************************************************************
'* Name    : LCD_CursorOff                                                     *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Underline Cursor Off                                              *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_CursorOff()                                                   *
'* Note    :                                                                   *
'*******************************************************************************
$ifndef LCD_CursorOff
    $define LCD_CursorOff()        ' 
    STARTSIZE(LCD_CursorOff_MACRO) '
    Print $FE,$0C                  '
    ENDSIZE(LCD_CursorOff_MACRO)

$endif

'*******************************************************************************
'* Name    : LCD_CursorOn                                                      *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Underline Cursor On                                               *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_CursorOn()                                                    *
'* Note    :                                                                   *
'*******************************************************************************
$ifndef LCD_CursorOn
    $define LCD_CursorOn()        ' 
    STARTSIZE(LCD_CursorOn_MACRO) '
    Print $FE,$0E                 '
    ENDSIZE(LCD_CursorOn_MACRO)

$endif

'*******************************************************************************
'* Name    : LCD_BlkCursorOn                                                   *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Blinking Cursor On                                                *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_BlkCursorOn()                                                 *
'* Note    :                                                                   *
'*******************************************************************************
$ifndef LCD_BlkCursorOn
    $define LCD_BlkCursorOn()        ' 
    STARTSIZE(LCD_BlkCursorOn_MACRO) '
    Print $FE,$0F                    '
    ENDSIZE(LCD_BlkCursorOn_MACRO)

$endif

'*******************************************************************************
'* Name    : LCD_MoveCursorLeft                                                *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Move Cursor left one position                                     *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_MoveCursorLeft()                                              *
'* Note    :                                                                   *
'*******************************************************************************
$ifndef LCD_MoveCursorLeft
    $define LCD_MoveCursorLeft()        ' 
    STARTSIZE(LCD_MoveCursorLeft_MACRO) '
    Print $FE,$10                       '
    ENDSIZE(LCD_MoveCursorLeft_MACRO)

$endif

'*******************************************************************************
'* Name    : LCD_MoveCursorRight                                               *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Move Cursor right one position                                    *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_MoveCursorRight()                                             *
'* Note    :                                                                   *
'*******************************************************************************
$ifndef LCD_MoveCursorRight
    $define LCD_MoveCursorRight()        ' 
    STARTSIZE(LCD_MoveCursorRight_MACRO) '
    Print $FE,$14                        '
    ENDSIZE(LCD_MoveCursorRight_MACRO)

$endif

'*******************************************************************************
'* Name    : LCD_MoveCursorLine2                                               *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Move Cursor To beginning of second Line                           *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_MoveCursorLine2()                                             *
'* Note    :                                                                   *
'*******************************************************************************
$ifndef LCD_MoveCursorLine2
    $define LCD_MoveCursorLine2()             ' 
    STARTSIZE(LCD_MoveCursorSecondLine_MACRO) '
    Print $FE,$C0                             '
    ENDSIZE(LCD_MoveCursorSecondLine_MACRO)

$endif

'*******************************************************************************
'* Name    : LCD_MoveCursorLine3                                               *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Move Cursor To beginning of third Line                            *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_MoveCursorLine3()                                             *
'* Note    :                                                                   *
'*******************************************************************************
$ifndef LCD_MoveCursorLine3
    $define LCD_MoveCursorLine3()        ' 
    STARTSIZE(LCD_MoveCursorLine3_MACRO) '
    Print $FE,$94                        '
    ENDSIZE(LCD_MoveCursorLine3_MACRO)

$endif

'*******************************************************************************
'* Name    : LCD_MoveCursorLine4                                               *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Move Cursor To beginning of fourth Line                           *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_MoveCursorLine4()                                             *
'* Note    :                                                                   *
'*******************************************************************************
$ifndef LCD_MoveCursorLine4
    $define LCD_MoveCursorLine4()        ' 
    STARTSIZE(LCD_MoveCursorLine4_MACRO) '
    Print $FE,$D4                        '
    ENDSIZE(LCD_MoveCursorLine4_MACRO)

$endif
'*******************************************************************************
'* Name    : DEwrite                                                           *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Write a Byte value to the eeprom directl                          *
'* Input   : pValue in WREG, Address in EEADDR                                 *
'* Output  : none                                                              *
'* Syntax  : DEwrite(pValue)                                                   *
'* Note    : Use EEADDR for addresss of the eeprom                             *
'*******************************************************************************

$define DEwrite()     '
    Asm               '
    Call __eewrite_w_ '
    EndAsm
    
'*******************************************************************************
'*  Name    : VarToStrg()                                                      *
'*  Author  : [Alberto Freixanet]                                              *
'*  Notice  : Copyright (c) 2018 [Alberto Freixanet]                           *
'*          : All Rights Reserved                                              *
'*  Date    : 09/10/2018                                                       *
'*  Version : 1.0                                                              *
'* Purpose : Convert a Byte/Word/DWord/SByte/SWord/SDword/Float into a String  *
'* Input   : Variable                                                          *
'* Output  : USer String                                                       *
'* Syntax  : VarToStrgRS(pModifier,pVar,pStringOut)                            *
'* Note    : Declare a correct number of bytes for the string                  *
'*           Read the PDS manual for RSOut identifiers                         *
'*******************************************************************************
$ifdef _VarToSTrgRS_
$ifndef __VarToStrg
$define __VarToStrg
'/------------------------------------------------------------------------------
$ifndef __RSOutDisable
    $define __RSOutDisable
    Symbol __RSOut_Disable = 1  '/ To see this parameter in the asm file.
$else
    $error "It is not possible Disable twice the RsOut command!" 
$endif
'/------------------------------------------------------------------------------
    #Disable RsOut      '/ Disable the RsOut command to be changed for a code
                        '/ to extract the digits of a variable to String.
'/==============================================================================
'/ New RsOut Routine.
    Asm
    RsOut
    EndAsm

    #ifdef watchdog_req
    Clrwdt
    #endif

    POSTINC0 = WREG     '/ Put the value into the array.
    Return              '/ Come back for more bytes; The RsOut commant is in use.
'/------------------------------------------------------------------------------

$define VarToStrg(pModifier,pVarIn,pStringOut) '
    STARTSIZE(VarToStrg_MACRO)                 '
    #ifdef WatchDog_Req                        '
    Clrwdt                                     '
    #endif                                     '
    Clear pStringOut                           '
    FSR0 = VarPtr(pStringOut)                  '
    _mVarToStrg pVarIn,pStringOut              '
    RsOut pModifier pVarIn                     '
    ENDSIZE(VarToStrg_MACRO)

_mVarToStrg Macro- pVarIn,pStringOut
	#if (Prm_Count != 2)         
 		#error "Incorrect amount of parameters for _mVarToStrg macro. 3 Parameters required!"	
		Exitm
    #else
        '/ Check type of variables.
        #if (Prm_1 != Float) && (Prm_1 != Dword) && (Prm_1 != Word) && (Prm_1 != Byte) && (Prm_1 != SDword) && (Prm_1 != SWord) && (Prm_1 != SByte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
            #error "_mVarToStrg - (Param2) Incorrect type of Variable!"
            Exitm
        #endif
        '/ Check if String is present.
        #if (Prm_2 != String)
            #error "_mVarToStrg - (Param3) Should be a String!"
            Exitm
        #endif
    #endif
Endm
'/------------------------------------------------------------------------------
$endif
$endif
'*******************************************************************************
'*  Name    : VarToStrg()                                                      *
'*  Author  : [Alberto Freixanet]                                              *
'*  Notice  : Copyright (c) 2018 [Alberto Freixanet]                           *
'*          : All Rights Reserved                                              *
'*  Date    : 14/10/2018                                                       *
'*  Version : 1.0                                                              *
'* Purpose : Convert a Byte/Word/DWord/SByte/SWord/SDword into a String        *
'* Input   : Variable                                                          *
'* Output  : String [VarToString]                                              *
'* Syntax  : VarToStrg(Modier,VarIn,StringOut)                                 *
'* Note    :                                                                   *
'*******************************************************************************
$ifdef _VarToSTrgStr_
$ifndef __VarToStrg
$define __VarToStrg
'/------------------------------------------------------------------------------
$define VarToStrg(pModifier,pVarIn,pStringOut) '
    STARTSIZE(VarToStrg_MACRO)                 '
    #ifdef WatchDog_Req                        '
    Clrwdt                                     '
    #endif                                     '
    _mVarToStrg2 pVarIn,pStringOut             '
    Declare Reminders = OFF                    '
    StrN pStringOut = Str$(pModifier pVarIn)   '
    Declare Reminders = On                     '
    ENDSIZE(VarToStrg_MACRO)

_mVarToStrg2 Macro- pVarIn,pStringOut
	#if (Prm_Count != 2)         
 		#error "Incorrect amount of parameters for _mVarToStrg macro. 3 Parameters required!"	
		Exitm
    #else
        '/ Check type of variables.
        #if (Prm_1 != Float) && (Prm_1 != Dword) && (Prm_1 != Word) && (Prm_1 != Byte) && (Prm_1 != SDword) && (Prm_1 != SWord) && (Prm_1 != SByte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
            #error "_mVarToStrg2 - (Param2) Incorrect type of Variable!"
            Exitm
        #endif
        '/ Check if String is present.
        #if (Prm_2 != String)
            #error "_mVarToStrg2 - (Param3) Should be a String!"
            Exitm
        #endif
    #endif
Endm
'/------------------------------------------------------------------------------
$endif
$endif
'*******************************************************************************
'*  Name    : VarToStrg()                                                      *
'*  Author  : [Alberto Freixanet]                                              *
'*  Notice  : Copyright (c) 2018 [Alberto Freixanet]                           *
'*          : All Rights Reserved                                              *
'*  Date    : 10/10/2018                                                       *
'*  Version : 1.0                                                              *
'* Purpose : Convert a Byte/Word/DWord/SByte/SWord/SDword into a String        *
'* Input   : Variable                                                          *
'* Output  : String [VarToString]                                              *
'* Syntax  : VarToStrg(pVar)                                                   *
'* Note    : Convert decimals numbers to ASCII only.                           *
'*******************************************************************************
$ifdef _VarToSTrg_
$ifndef __VarToStrg
$define __VarToStrg
'/------------------------------------------------------------------------------
'#ifMacro- _mVarToStrg
    LocalByte0(zVarByte)
    LocalByte1(zNumberDigits)
    LocalDword0(zVarDWord)
    LocalSDword0(zVarSDWord)            
    Dim F_SignedzVar As Bit
    Dim F_FirstNumbers As Bit
    Symbol VarToStringLenght = 12
    Dim VarToString As String * VarToStringLenght Heap
'#endIfMacro-

$define VarToStrg(pVarIn) _mVarToStrg pVarIn

_mVarToStrg Macro- pVarIn
    STARTSIZE(VarToStrg_MACRO)
    #if (Prm_Count > 1)
        #error "_mVarToStrg - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 1)
            #error "_mVarToStrg - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte) && (Prm_1 != Word) && (Prm_1 != Dword) && (Prm_1 != SByte) && (Prm_1 != SWord) && (Prm_1 != SDword)
                #error "_mVarToStrg Macro - (Param1) Should be a number or Byte/Word/Dword/SByte/SWord/SDWord"
                Exitm
            #else
                F_SignedzVar = 0
                #if (Prm_1 == Byte)
                    Asm-
                    Clrf zVarDWord+3
                    Clrf zVarDWord+2
                    Clrf zVarDWord+1
                    Movff pVarIn,zVarDWord                                     
                    Endasm-
                    zNumberDigits = 3
                #endif
                #if (Prm_1 == Word)
                    Asm-
                    Clrf zVarDWord+3
                    Clrf zVarDWord+2
                    Movff pVarIn+1,zVarDWord+1 
                    Movff pVarIn,zVarDWord                                     
                    Endasm-
                    zNumberDigits = 5
                #endif
                #if (Prm_1 == Dword)
                    Dword_Dword pVarIn,zVarDWord
                    zNumberDigits = 10             
                #endif
                #if (Prm_1 == SByte)
                    Byte_SDword pVarIn,zVarSDWord
                    F_SignedzVar = 1
                    zNumberDigits = 3
                #endif
                #if (Prm_1 == SWord)
                    Word_SDword pVarIn,zVarSDWord
                    zNumberDigits = 5
                    F_SignedzVar = 1
                #endif
                #if (Prm_1 == SDword)
                    Dword_Dword pVarIn,zVarSDWord
                    zNumberDigits = 10
                    F_SignedzVar = 1
                #endif
            #endif
        #endif
    #endif
    GoSub _mVarToStrg_Sub
    ENDSIZE(VarToStrg_MACRO)
Endm

#ifMacro- _mVarToStrg
_mVarToStrg_Sub:
    STARTSIZE(VarToStrg_LIB)
    '/ Clear the string.
    FSR0 = VarPtr(VarToString)  '/ Point to the string.
    WREG = VarToStringLenght    '/ Load the number of bytes of the String.
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        POSTINC0 = 0            '/ Clear every byte of the array.
        Dec WREG
    Until WREG = 0  
    INDF0 = 0                   '/ Make string again.
    
    '/ Check the Variable sign.
    FSR0 = VarPtr(VarToString)          '/ Point to the string again.
    If F_SignedzVar = 1 Then            '/ Is it a signed variable?
        If zVarSDWord.31 = 1 Then       '/ Check if negative.
            POSTINC0 = "-"              '/ Then write a (-).
            zVarDWord = Abs(zVarSDWord) '/ It is negative.
        Else                            
            zVarDWord = zVarSDWord      '/ It is positive.
        EndIf
    EndIf

    '/ Load the String with ascii numbers.
    F_FirstNumbers = 0
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        Dec zNumberDigits
        PRODL = Dig zVarDWord,zNumberDigits
        If PRODL > 0 Then
            F_FirstNumbers = 1      '/ Avoid load zeros before the value.
        EndIf
        If F_FirstNumbers = 0 Then
            If PRODL = 0 Then
                Continue            '/ Jump to next iteration.
            EndIf
        EndIf
        POSTINC0 = PRODL + 48       '/ Write the ASCII value into the string.
    Until zNumberDigits = 0
    Return
    ENDSIZE(VarToStrg_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------
$endif
$endif
'*******************************************************************************
'* Name    : LoadArray / LoadString                                            *
'* Author  : [Alberto Freixanet 2018]                                          *
'* Purpose : Load all the Array/String with user characters.                   *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    : The macros do not use external variable.                          *
'*******************************************************************************

$define LoadArray(pArray,pArrayLenght,pValueIn) '
    STARTSIZE(LoadArray_MACRO)                  '
    PRODL = pValueIn                            '
    PRODH = pArrayLenght                        '
    FSR0 = VarPtr(pArray)                       '
    _mLoadArray                                 '
    ENDSIZE(LoadArray_MACRO)

_mLoadArray Macro-
    GoSub _mLoadArray_Sub
Endm

#ifMacro- _mLoadArray
_mLoadArray_Sub:
    STARTSIZE(LoadArray_LIB)
    Repeat
        #ifdef watchdog_req
        Clrwdt
        #endif
        POSTINC0 = PRODL        '/ Load the new value
        Dec PRODH
    Until PRODH = 0
    Return
    ENDSIZE(LoadArray_LIB)
#endIfMacro-    
'/------------------------------------------------------------------------------
'/ Fixed errata 24/09/2018.

$define LoadString(pString,pStringLenght,pValueIn) '
    STARTSIZE(LoadString_MACRO)      '
    PRODL = pValueIn                 '
    PRODH = pStringLenght            '
    FSR0 = VarPtr(pString)           '
    _mLoadString                     '
    STARTSIZE(LoadString_MACRO)

_mLoadString Macro-
    GoSub _mLoadString_Sub
Endm

#ifMacro- _mLoadString
_mLoadString_Sub:
    STARTSIZE(LoadString_LIB)
    Repeat
        #ifdef watchdog_req
        Clrwdt
        #endif
        POSTINC0 = PRODL        '/ Load the new value
        Dec PRODH
    Until PRODH = 0
    INDF0 = 0                   '/ Set Array as String again.
    Return
    ENDSIZE(LoadString_LIB)
#endIfMacro- 
'*******************************************************************************
'* Name    : HRSOut                                                            *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Generates HRSOut with 2 stop bits                                 *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    : For 5 UARTs                                                       *
'* Note    : For compiler version 3.6.1.7  Onwards.                            *
'*******************************************************************************
$if _uart > 0
$ifndef CleanUART1
$define CleanUART1()            '
    STARTSIZE(CleanUART1_MACRO) '
    $ifdef _RC1STA              '
    Clear RC1STABits_CREN       ' 
    Set RC1STABits_CREN         ' 
    WREG = RC1REG               '
    WREG = RC1REG               '
    $else                       '
    Clear RCSTABits_CREN        ' 
    Set RCSTABits_CREN          ' 
    WREG = RCREG                '
    WREG = RCREG                '
    $endif                      '
    ENDSIZE(CleanUART1_MACRO)

$endif
$endif
'/------------------------------------------------------------------------------
$if _uart > 1
$ifndef CleanUART2
$define CleanUART2()            '
    STARTSIZE(CleanUART2_MACRO) '
    Clear RC2STABits_CREN       ' 
    Set RC2STABits_CREN         ' 
    WREG = RC2REG               '
    WREG = RC2REG               '
    ENDSIZE(CleanUART2_MACRO)

$endif
$endif
'/------------------------------------------------------------------------------
$if _uart > 2
$ifndef CleanUART3
$define CleanUART3()            '
    STARTSIZE(CleanUART3_MACRO) '
    Clear RC3STABits_CREN       ' 
    Set RC3STABits_CREN         ' 
    WREG = RC3REG               '
    WREG = RC3REG               '
    ENDSIZE(CleanUART3_MACRO)

$endif
$endif
'/------------------------------------------------------------------------------
$if _uart > 3
$ifndef CleanUART4
$define CleanUART4()            '
    STARTSIZE(CleanUART4_MACRO) '
    Clear RC4STABits_CREN       ' 
    Set RC4STABits_CREN         ' 
    WREG = RC4REG               '
    WREG = RC4REG               '
    ENDSIZE(CleanUART4_MACRO)

$endif
$endif
'/------------------------------------------------------------------------------
$if _uart > 4
$ifndef CleanUART5
$define CleanUART5()            '
    STARTSIZE(CleanUART5_MACRO) '
    Clear RC5STABits_CREN       ' 
    Set RC5STABits_CREN         ' 
    WREG = RC5REG               '
    WREG = RC5REG               '
    ENDSIZE(CleanUART5_MACRO)
    
$endif
$endif
'/##############################################################################
$ifdef _HRSOutTwoStopBitsInc_
$ifndef __HRSOutTwoStopBits
$define __HRSOutTwoStopBits
'/------------------------------------------------------------------------------
'#ifdef __SYSCOM_HRSOUT1_REQ_
'#ifdef HRSOUT#REQ           '/ Because the new compiler V3617.
#ifdef Hserial_TXSTA
'===============================================================================
    #Disable HRSOut             ' Bypass the compiler's HRSOut library subroutine
'===============================================================================
'Asm
'HRSOUT
'EndAsm
Asm
__HRSOut1__     ;/ Because the new compiler V3617.
EndAsm

STARTSIZE(HRSOut1_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif 
    #ifdef __INTERRUPTS_ENABLED
    xINTCON_Save = INTCON           '/ Save the state of INTCONBits_GIE.
    INTCONBits_GIE = 0              '/ Clear the GIE bit.
    #endif
    
    ' This code take care of the different Banks of TXxSTA.
    ' Waiting UART ready.
    While 1 = 1
        $ifdef _TX1STA
        HRSByte = TX1STA
        $else
        HRSByte = TXSTA    
        $endif
        If HRSByte.1 = 1 Then Break
    Wend
    
    ' To avoid some old PIC's errata the bits are set after sent the last byte.
'    $ifdef _2StopBits_
        $ifdef _TX1STA
        TX1STABits_TX9 = 1          ' Nine bit mode for 2 stop bits for transmision.
        TX1STABits_TX9D = 1         ' Send the first stop bit. The second stop bit is set by the UART.
        $else
        TXSTABits_TX9 = 1
        TXSTABits_TX9D = 1
        $endif
'    $endif

    $ifdef _TX1REG
    TX1REG = WREG                   ' Start sending the Byte
    $else
    TXREG = WREG                    ' Start sending the Byte
    $endif

    #ifdef __INTERRUPTS_ENABLED
    If xINTCON_Save.7 = 1 Then      '/ Check the state of INTCONBits_GIE.
        INTCONBits_GIE = 1          '/ Restore the GIE interrupt condition.
    EndIf
    #endif

    Return 
'-------------------------------------------------------------------------------
ENDSIZE(HRSOut1_LIB)
#endif  ' #ifdef Hserial_TXSTA
'===============================================================================
'-------------------------------------------------------------------------------
OverHRSOut1Exit:
'/##############################################################################
'*******************************************************************************
$if _uart > 1
'#ifdef __SYSCOM_HRSOUT2_REQ_
'#ifdef HRSOUT2#REQ           '/ Because the new compiler V3617.
#ifdef Hserial2_TXSTA
'===============================================================================
    #Disable HRSOut2             ' Bypass the compiler's HRSOut2 library subroutine
'===============================================================================
'Asm
'HRSOUT@2
'EndAsm
Asm
__HRSOut2__     '/ Because the new compiler V3617.
EndAsm
STARTSIZE(HRSOut2_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif 
    #ifdef __INTERRUPTS_ENABLED
    xINTCON_Save = INTCON
    INTCONBits_GIE = 0              ' Clear the GIE bit.
    #endif

    ' This code take care of the different Banks of TXxSTA.
    ' Waiting UART ready.
    While 1 = 1
        HRSByte = TX2STA
        If HRSByte.1 = 1 Then Break
    Wend

    ' To avoid some old PIC's errata the bits are set after sent the last byte.
'    $ifdef _2StopBits_
    TX2STABits_TX9 = 1              ' Nine bit mode for 2 stop bits for transmision.
    TX2STABits_TX9D = 1             ' Send the first stop bit. The second stop bit is set by the UART.
'    $endif

    TX2REG = WREG                   ' Start sending the Byte

    #ifdef __INTERRUPTS_ENABLED
    If xINTCON_Save.7 = 1 Then
        INTCONBits_GIE = 1          ' Restore the GIE interrupt condition.
    EndIf
    #endif

    Return 
ENDSIZE(HRSOut2_LIB)
'-------------------------------------------------------------------------------
#endif  '#ifdef Hserial2_TXSTA
'===============================================================================
'-------------------------------------------------------------------------------
OverHRSOut2Exit:
'-------------------------------------------------------------------------------
$endif  ' $if _uart > 1
'/##############################################################################
'*******************************************************************************
$if _uart > 2
'#ifdef __SYSCOM_HRSOUT3_REQ_
'#ifdef HRSOUT3#REQ           '/ Because the new compiler V3617.
#ifdef Hserial3_TXSTA
'===============================================================================
    #Disable HRSOut3             ' Bypass the compiler's HRSOut3 library subroutine
'===============================================================================
'Asm
'HRSOUT@3
'EndAsm
Asm
__HRSOut3__     '/ Because the new compiler V3617.
EndAsm

STARTSIZE(HRSOut3_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif 
    #ifdef __INTERRUPTS_ENABLED
    xINTCON_Save = INTCON
    INTCONBits_GIE = 0                  ' Clear the GIE bit.
    #endif

    ' This code take care of the different Banks of TXxSTA.
    ' Waiting UART ready.
    While 1 = 1
        HRSByte = TX3STA
        If HRSByte.1 = 1 Then Break
    Wend

    ' To avoid some old PIC's errata the bits are set after sent the last byte.
'    $ifdef _2StopBits_
    TX3STABits_TX9 = 1              ' Nine bit mode for 2 stop bits for transmision.
    TX3STABits_TX9D = 1             ' Send the first stop bit. The second stop bit is set by the UART.
'    $endif

    TX3REG = WREG                   ' Start sending the Byte

    #ifdef __INTERRUPTS_ENABLED
    If xINTCON_Save.7 = 1 Then
        INTCONBits_GIE = 1          ' Restore the GIE interrupt condition.
    EndIf
    #endif

    Return 
ENDSIZE(HRSOut3_LIB)
'-------------------------------------------------------------------------------
#endif  '#ifdef Hserial3_TXSTA
'===============================================================================
'-------------------------------------------------------------------------------
OverHRSOut3Exit:
'-------------------------------------------------------------------------------
$endif  '$if _uart > 2
'/##############################################################################
'*******************************************************************************
$if _uart > 3
'#ifdef __SYSCOM_HRSOUT4_REQ_
'#ifdef HRSOUT4#REQ           '/ Because the new compiler V3617.
#ifdef Hserial4_TXSTA
'===============================================================================
    #Disable HRSOut4             ' Bypass the compiler's HRSOut4 library subroutine
'===============================================================================
'Asm
'HRSOUT@4
'EndAsm
Asm
__HRSOut4__     '/ Because the new compiler V3617.
EndAsm

STARTSIZE(HRSOut4_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif 
    #ifdef __INTERRUPTS_ENABLED
    xINTCON_Save = INTCON
    INTCONBits_GIE = 0                  ' Clear the GIE bit.
    #endif

    ' This code take care of the different Banks of TXxSTA.
    ' Waiting UART ready.
    While 1 = 1
        HRSByte = TX4STA
        If HRSByte.1 = 1 Then Break
    Wend

    ' To avoid some old PIC's errata the bits are set after sent the last byte.
'    $ifdef _2StopBits_
    TX4STABits_TX9 = 1                  ' Nine bit mode for 2 stop bits for transmision.
    TX4STABits_TX9D = 1                 ' Send the first stop bit. The second stop bit is set by the UART.
'    $endif

    TX4REG = WREG                       ' Start sending the Byte

    #ifdef __INTERRUPTS_ENABLED
    If xINTCON_Save.7 = 1 Then
        INTCONBits_GIE = 1              ' Restore the GIE interrupt condition.
    EndIf
    #endif

    Return 
ENDSIZE(HRSOut4_LIB)
'-------------------------------------------------------------------------------
#endif  ' #ifdef Hserial4_TXSTA
'===============================================================================
'-------------------------------------------------------------------------------
OverHRSOut4Exit:
'-------------------------------------------------------------------------------
$endif  '$if _uart > 3
'/##############################################################################
'*******************************************************************************
$if _uart > 4
'#ifdef __SYSCOM_HRSOUT5_REQ_
'#ifdef HRSOUT5#REQ           '/ Because the new compiler V3617.
#ifdef Hserial5_TXSTA
'===============================================================================
    #Disable HRSOut5             ' Bypass the compiler's HRSOut5 library subroutine
'===============================================================================
'    GoTo OverHRSOut5Exit
'-------------------------------------------------------------------------------
'Asm
'HRSOUT@5
'EndAsm
Asm
__HRSOut5__     '/ Because the new compiler V3617.
EndAsm

STARTSIZE(HRSOut5_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif 
    #ifdef __INTERRUPTS_ENABLED
    xINTCON_Save = INTCON
    INTCONBits_GIE = 0              ' Clear the GIE bit.
    #endif

    ' This code take care of the different Banks of TXxSTA.
    ' Waiting UART ready.
    While 1 = 1
        HRSByte = TX5STA
        If HRSByte.1 = 1 Then Break
    Wend

    ' To avoid some old PIC's errata the bits are set after sent the last byte.
'    $ifdef _2StopBits_
    TX5STABits_TX9 = 1              ' Nine bit mode for 2 stop bits for transmision.
    TX5STABits_TX9D = 1             ' Send the first stop bit. The second stop bit is set by the UART.
'    $endif

    TX5REG = WREG                   ' Start sending the Byte

    #ifdef __INTERRUPTS_ENABLED
    If xINTCON_Save.7 = 1 Then
        INTCONBits_GIE = 1          ' Restore the GIE interrupt condition.
    EndIf
    #endif

    Return 
ENDSIZE(HRSOut5_LIB)
'-------------------------------------------------------------------------------
#endif  '#ifdef Hserial5_TXSTA
'===============================================================================
'-------------------------------------------------------------------------------
OverHRSOut5Exit:
'-------------------------------------------------------------------------------
$endif  ' $if _uart > 4
'-------------------------------------------------------------------------------
$endif  '__HRSOutTwoStopBits
$endif  ' _HRSOutTwoStopBitsInc_
'/##############################################################################
'*******************************************************************************
'* Name    : CheckErrorsFloat()                                                *
'* Author  : [Alberto Freixanet] Based on PDS manual                           *
'* Purpose : Check the flags of Float calculations.                            *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : CheckErrorsFloat()                                                *
'* Notes   : NO new variables used.                                            *
'*******************************************************************************
    LocalByte0(CKERRORByte)

$define CheckErrorsFloat() _mCheckErrorsFloat

_mCheckErrorsFloat Macro-
    GoSub CheckErrorsFloat_Sub
Endm


#ifMacro- _mCheckErrorsFloat
CheckErrorsFloat_Sub:
    STARTSIZE(CheckErrorsFloat_LIB)
    '/ Check Float errors.
    Byte_Byte _FP_FLAGS,CKERRORByte   '/ Access to the _FP_FLAGS variable by an assembler macro.

    If CKERRORByte.1 = 1 Then
        Asm
        Bcf _FP_FLAGS,1
        EndAsm
        #ifdef Hserial_TXSTA
        HRSOut "ERROR: Floating point overflow!",CR
        #endif
    EndIf
    If CKERRORByte.2 = 1 Then
        Asm
        Bcf _FP_FLAGS,2
        EndAsm
        #ifdef Hserial_TXSTA
        HRSOut "ERROR: Floating point underflow!",CR    
        #endif
    EndIf
    If CKERRORByte.3 = 1 Then
        Asm
        Bcf _FP_FLAGS,3
        EndAsm
        #ifdef Hserial_TXSTA
        HRSOut "ERROR: Floating point divide by zero!",CR    
        #endif
    EndIf    
    If CKERRORByte.5 = 1 Then
        Asm
        Bcf _FP_FLAGS,5
        EndAsm
        #ifdef Hserial_TXSTA
        HRSOut "ERROR: Domain error exception!",CR    
        #endif
    EndIf
    Return
    ENDSIZE(CheckErrorsFloat_LIB)
#endIfMacro-
'*******************************************************************************
'* Name    : ReadIDLOCS                                                        *
'* Author  : [Alberto Feixanet]                                                *
'* Purpose : Read the ID LOCATIONS                                             *
'* Input   : IDLOCS in ROM                                                     *
'* Output  : IDLOCSStrg, a 8 bytes string                                      *
'* Syntax  : ReadIDLOCS()                                                      *
'* Notes   : No variable used.                                                 *           
'******************************************************************************* 
$ifdef _IDLOCS_
$ifndef __ReadIDLOCS
$define __ReadIDLOCS

    LocalByte0(IDLOCByte)

$define ReadIDLOCS() _mReadIDLOCS

_mReadIDLOCS Macro-
    GoSub _mReadIDLOCS_Sub
Endm

#ifMacro- _mReadIDLOCS
    Reminders = Off
    $ifndef __IDLOCSStrg_Array
    $define __IDLOCSStrg_Array
    Dim IDLOCSStrg As String * 8 Heap
    $endif
    Reminders = On

_mReadIDLOCS_Sub:
    STARTSIZE(ReadIDLOCS_LIB)
    GIE_Save()                          '/ Clear the interrupt if enabled.
    #ifdef Watchdog_req
    Clrwdt
    #endif
    GoSub Load_IDLOCs_ADDR_Sub          '/ Load IDLOCs address
    For IDLOCByte = 0 To 7              '/ Start the loop
        Tblrd*+                         '/ Read one memory position.
        IDLOCSStrg[IDLOCByte] = TABLAT  '/ Write IDLOCS characters to the array.
    Next  
    EECON1 = 0  '/ Disable read the Configuration registers
    TBLPTRU = 0 '/ The HRSOut command of the compiler does not clear the "TBLPTRU", then take care of that.
                '/ The HRSOut command can crash if the TBLPTRU SFR is not cleared.
    GIE_Restore()                       '/ Restore the interrupts if necessary.
    Return
    ENDSIZE(ReadIDLOCS_LIB)
#endIfMacro-
$endif
$endif
'/------------------------------------------------------------------------------
$ifdef _IDLOCS_
#ifMacro- _mReadIDLOCS,_mWriteIDLOCS
'/ Load the address of ID_LOCATION from the asm file
Load_IDLOCs_ADDR_Sub:
    EECON1 = %11000000                  '/ Access Configuration registers 
    Load_TBLPTR(IDLOC0)
    Return
#endIfMacro-
$endif
'*******************************************************************************
'* Name    : WriteIDLOCS                                                       *
'* Author  : [Alberto Feixanet]                                                *
'* Purpose : Write the ID LOCATIONS in ROM                                     *
'* Input   : IDLOCS 8 bytes array or string                                    *
'* Output  : IDLOCS in ROM                                                     *
'* Syntax  : WriteIDLOCS()                                                     *
'* Notes   : No external variable used.                                        *           
'******************************************************************************* 
$ifdef _IDLOCS_
$ifndef __WriteIDLOCS
$define __WriteIDLOCS

    LocalByte0(IDLOCS_WriteError)
    LocalByte1(IDLOCS_Loop)    
'    Dim IDLOCS_WriteError As PRODL
'    Dim IDLOCS_Loop As PRODH

$define WriteIDLOCS() _mWriteIDLOCS

_mWriteIDLOCS Macro-
    STARTSIZE(WriteIDLOCS_MACRO)
    GoSub _mWriteIDLOCS_Sub
    #if (_mWriteIDLOCS_RETURN != 1)
        #error "_mWritreIDLOCS - Mandatory return parameter misssing"
    #else
        #if (Return_Type != Byte)
            #error "_mWritreIDLOCS - Return variable should be a Byte variable"
            Exitm
        #else
            Byte_Byte IDLOCS_WriteError,Return_Var
        #endif
    #endif
    ENDSIZE(WriteIDLOCS_MACRO)
Endm

'*******************************************************************************
'* Name    : WRITE_IDLOCS MACRO SUBROUTINE                                     *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Write INFO to the ID LOCATIONS                                    *
'* Note     : Read the IDLOC address from the asm file                         *
'*******************************************************************************
#ifMacro- _mWriteIDLOCS
_mWriteIDLOCS_Sub:
    $ifndef __IDLOCSStrg_Array
    $define __IDLOCSStrg_Array
    Dim IDLOCSStrg As String * 8 Heap
    $endif

    STARTSIZE(WriteIDLOCS_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    GIE_Save()
'===============================================================================
' Write the IDLOCS in ROM
'===============================================================================
    GoSub Load_IDLOCs_ADDR_Sub          '/ Load the address of ID_LOCATION
    GoSub Make_EraseBlockFLASH_Sub      '/ Setup write, Start erase block, ERASE_BLOCK, required write sequence, Disable writes

'/ Write the data of the ID Locations (preview)
    IDLOCS_Loop = 0                     '/ Clear the Buffer read pointer.
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        TABLAT =  IDLOCSStrg[IDLOCS_Loop] '/ Buffer Data => WREG
        Asm
        tblwt*+
        EndAsm
        Inc IDLOCS_Loop                 '/ Next byte to extract from the Buffer.
    Until IDLOCS_Loop > 7

'/ Write the ID Locations, Flash the ROM.
    GoSub Load_IDLOCs_ADDR_Sub          '/ Load Address of the first ID Locations version 4.2
    GoSub Make_WriteFLASH_Sub           '/ Setup writes + write sequence + Disable writes
'===============================================================================
' Verifiy the IDLOCS in ROM & compare with the buffer.
'===============================================================================
    GoSub Load_IDLOCs_ADDR_Sub          '/ Load Address of the first ID Locations version 4.2
    IDLOCS_WriteError = 0               '/ Init the error byte.
    IDLOCS_Loop = 0                     '/ Clear the Buffer read pointer.
    Repeat                              '/ Start the loop
        #ifdef Watchdog_req
        Clrwdt
        #endif
        Tblrd*+                         '/ Read one memory position.
        WREG =  IDLOCSStrg[IDLOCS_Loop] '/ Buffer Data => WREG
        If WREG <> TABLAT Then          '/ Compare the buffer with the ROM.
            IDLOCS_WriteError = 1       '/ If error then exit.
            Break                       '/ Exit, fatal error.
        EndIf
        Inc IDLOCS_Loop                 '/ The Buffer points to the next byte to read. 
    Until IDLOCS_Loop > 7
    TBLPTRU = 0     '/ VERYIMPORTANT: The HRSout command could crash if TBLPTRU is not = 0.
    GIE_Restore()
    Return          '/ from Gosub _mWriteIDLOCS_Sub
'*******************************************************************************
'* Name    : Make_EraseBlockFLASH_Sub                                          *
'* Purpose : Confirm To erase one block of the  FLASH memory                   *
'*******************************************************************************
Make_EraseBlockFLASH_Sub:
    EECON1 = %10010100          '/ Flash acces + Start erase flash + Setup write flash 
    GoTo  WriteSequence_Sub     '/ Required write sequence 
'*******************************************************************************
'* Name    : Make_WriteFLASH_Sub                                               *
'* Purpose : Confirm To write the data To FLASH memory                         *
'*******************************************************************************
Make_WriteFLASH_Sub:
    EECON1 = %10000100          '/ Setup write flash 
    '/ Required write sequence 
'*******************************************************************************
'* Name    : WriteSequence                                                     *
'* Purpose : A required write sequence for EEPROM and FLASH writes             *
'*******************************************************************************
WriteSequence_Sub:
    EECON2 = $55                    '/ EECON2 <- $55
    EECON2 = $AA                    '/ EECON2 <- $AA
    Set EECON1Bits_WR               '/ Set WR Bit For write
    Nop
    While EECON1Bits_WR = 1 : Wend  '/ Waiting to complete.
    EECON1 = 0                      '/ Disable write
    Return    
    ENDSIZE(WriteIDLOCS_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------
$endif
$endif
'*******************************************************************************
'* Name    : ReadDEVID1                                                        *
'* Author  : [Alberto Feixanet]                                                *
'* Purpose : Read the DEVID1 as single Word from ROM                           *
'* Input   : asm file                                                          *
'* Output  : (pPartNumber,pRevision)                                           *
'* Syntax  : ReadDEVID1(pPartNumber[Word],pRevision[Byte])                     *
'* Note    : Read the DEVID1 address from the asm file                         *
'*           NO variable used                                                  *
'*           Use the Devicelist.inc file to print the name of the PIC.         *
'*******************************************************************************
$ifdef _DEVID1_
$ifndef __DEVID1
$define __DEVID1

    Dim DEVID1Parameters As PRODL.Word 

$define ReadDEVID1(pPartNumber,pRevision) '
    STARTSIZE(ReadDEVID1_MACRO)           '
    _mReadDEVID1                          '
    pPartNumber = DEVID1Parameters        '
    pRevision = EEDATA                    '
    ENDSIZE(ReadDEVID1_MACRO)

_mReadDEVID1 Macro-
    GoSub _mReadDEVID1_Sub
Endm

#ifMacro- _mReadDEVID1
_mReadDEVID1_Sub:
    STARTSIZE(ReadDEVID1_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    GIE_Save()
    ' Read the DEVID1 (Device ID) address from the asm file.
    EECON1 = %10000000              '/ Access flash memory
    Load_TBLPTR(DEVID1)

    Tblrd*+                         '/ perform table read with post-increment
    PRODL = TABLAT
    Tblrd*+                         '/ perform table read with post-increment
    PRODH = TABLAT        
    EECON1 = 0                      '/ Disable Access the Configuration registers
    TBLPTRU = 0                     '/ For security.
    EEDATA = PRODL & %00011111      '/ Extract the PIC Revision
    DEVID1Parameters = DEVID1Parameters >> 5   '/ Calculate the PIC Part Number
    GIE_Restore()
    Return
    ENDSIZE(ReadDEVID1_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : MyRandom()                                                        *
'* Author  : [??????] modified by Alberto Feixanet                             *
'* Purpose : Generate a Dword random number                                    *
'* Input   : MySeed() command                                                  *
'* Output  : Return_Var (Byte, Word or Dword)                                  *
'* Syntax  : MySeed(pValueIn), MyRandom(0)                                     *
'* Notes   : System Variables used.                                            *           
'*******************************************************************************
$ifdef _MyRandom_
$ifndef __MyRandom
$define __MyRandom

'#ifMacro- _mMyRandom
'/ Declare Local System Variables
    LocalByte0(rdTEMP_REG3A)
    LocalByte1(rdTEMP_REG3B)
    LocalByte2(rdTEMP_REG2A)    
    LocalByte3(rdTEMP_REG2B)
    LocalByte4(rdNEW_REG0)
                
'/ Declare Global System Variables
    Dim RDSHIFT_REG As Dword System
'#endIfMacro-

$define MySeed(pValueIn)                '
    STARTSIZE(MySeed_MACRO)             '
    RDSHIFT_REG.Byte3 = pValueIn.Byte3  '
    RDSHIFT_REG.Byte2 = pValueIn.Byte2  '
    RDSHIFT_REG.Byte1 = pValueIn.Byte1  '
    RDSHIFT_REG.Byte0 = pValueIn.Byte0  '
    ENDSIZE(MySeed_MACRO)
    
$define MyRandom(pNumber) _mMyRandom pNumber

_mMyRandom Macro- pNumber
    STARTSIZE(MyRandom_MACRO)
    #ifdef BankA_End
        #if (RDSHIFT_REGHHH > BankA_End)
            #error "The variables of _mMyRandom Macro must reside in BankA" 
        #endif      
    #endif
    #if (Prm_Count == 1)
        #if (Prm_1 != Num8)
            #error "_mMyRandom - Should be a number8"
            Exitm
        #endif
    #endif
    GoSub _mMyRandom_Sub
    #if (_mMyRandom_RETURN != 1)
        #error "_mMyRandom - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword) 
            #error "_mMyRandom - Return variable should be a Byte, Word or Dword variable"
            Exitm
        #else
            #if (Return_Type == Byte)
                #if (pNumber == 0) 
                    Asm-
                    Movff RDSHIFT_REG,Return_Var 
                    Endasm-
                #else                 
                    #if (pNumber == 1) 
                        Asm-
                        Movff RDSHIFT_REGH,Return_Var 
                        Endasm-
                    #else              
                        #if (pNumber == 2) 
                            Asm-
                            Movff RDSHIFT_REGHH,Return_Var 
                            Endasm-
                        #else               
                            #if (pNumber == 3) 
                                Asm-
                                Movff RDSHIFT_REGHHH,Return_Var 
                                Endasm-
                            #else
                                Dword_Byte RDSHIFT_REG,Return_Var                           
                            #endif
                       #endif
                   #endif
                #endif
            #endif
            #if (Return_Type == Word)
                #if (pNumber == 0) 
                    Asm-
                    Movff RDSHIFT_REG,Return_Var 
                    Movff RDSHIFT_REGH,Return_Var + 1 
                    Endasm-
                #else                 
                    #if (pNumber == 1) 
                        Asm-
                        Movff RDSHIFT_REGHH,Return_Var 
                        Movff RDSHIFT_REGHHH,Return_Var + 1 
                        Endasm-
                    #else   
                        Dword_Word RDSHIFT_REG,Return_Var
                    #endif
                #endif
            #endif
            #if (Return_Type == Dword)
                #if (pNumber == 0)
                    Dword_Dword RDSHIFT_REG,Return_Var
                #else
                    #if (pNumber == 1)
                        Asm-
                        Movff RDSHIFT_REGHHH,Return_Var 
                        Movff RDSHIFT_REGHH,Return_Var + 1 
                        Movff RDSHIFT_REGH,Return_Var + 2 
                        Movff RDSHIFT_REG,Return_Var + 3 
                        Endasm-                
                    #else                 
                        #if (pNumber == 2)
                            Asm-
                            Movff RDSHIFT_REGHH,Return_Var 
                            Movff RDSHIFT_REGHHH,Return_Var + 1 
                            Movff RDSHIFT_REG,Return_Var + 2 
                            Movff RDSHIFT_REGH,Return_Var + 3 
                            Endasm- 
                        #else
                            #if (pNumber == 3)
                                Asm-
                                Movff RDSHIFT_REGH,Return_Var 
                                Movff RDSHIFT_REG,Return_Var + 1 
                                Movff RDSHIFT_REGHHH,Return_Var + 2 
                                Movff RDSHIFT_REGHH,Return_Var + 3 
                                Endasm- 
                            #else
                                Dword_Dword RDSHIFT_REG,Return_Var
                            #endif
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(MyRandom_MACRO)
Endm

#ifMacro- _mMyRandom
_mMyRandom_Sub:
    STARTSIZE(MyRandom_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    rdTEMP_REG3A = RDSHIFT_REG.Byte3
    rdTEMP_REG3B = RDSHIFT_REG.Byte3
    rdNEW_REG0 =   RDSHIFT_REG.Byte3
    rdTEMP_REG2A = RDSHIFT_REG.Byte2
    rdTEMP_REG2B = RDSHIFT_REG.Byte2
    STATUS = 0
    Asm
    Rlcf rdTEMP_REG2A,F
    Rlcf rdTEMP_REG3A,F
    Rlcf rdTEMP_REG2A,F
    Rlcf rdTEMP_REG3A,W
    Xorwf rdNEW_REG0,F
    Rrcf rdTEMP_REG3B,F
    Rrcf rdTEMP_REG2B,F
    Movf rdTEMP_REG2B,W
    Xorwf rdNEW_REG0,F
    Rrcf rdTEMP_REG3B,F
    Rrcf rdTEMP_REG2B,W
    Xorwf rdNEW_REG0,F 
    EndAsm
    RDSHIFT_REG.Byte3 = RDSHIFT_REG.Byte2 ^ rdTEMP_REG3B
    RDSHIFT_REG.Byte2 = RDSHIFT_REG.Byte1 ^ rdTEMP_REG2A
    RDSHIFT_REG.Byte1 = RDSHIFT_REG.Byte0 ^ rdNEW_REG0
    RDSHIFT_REG.Byte0 = rdNEW_REG0
    Return
    ENDSIZE(MyRandom_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : ManchEncode                                                       *
'* Author  : [Les Johnson 2005] modified by Alberto Feixanet                   *
'* Purpose : Coding Manchester                                                 *
'* Input   : none                                                              *
'* Output  : Return type (Byte, Word)                                          *
'* Syntax  : ManchEncode(VarByte), ManchDecode(VarWord)                        *
'* Notes   : Method 2, using the Rol (rotate left) instruction                 *
'*******************************************************************************
$ifdef _Manchester_
$ifndef __Manchester
$define __Manchester

    Dim F_Carry As STATUS.0      ' Alias the CARRY flag

' Declare the local variables
'    LocalByte0(InLibB)           ' BYTE to ENCODE
'    LocalByte1(OutLibB)          ' BYTE DECODED
    Dim InLibB As PRODH
    Dim OutLibB As PRODL
    LocalByte2(CountLibB)        ' Bit counter
    LocalWord0(TempManchW)

'-------------------------------------------------------------------------------
$define ManchEncode(pValue) _mManchEncode pValue

_mManchEncode Macro- pValue
    STARTSIZE(ManchEncode_MACRO)
    #if (Prm_Count > 1)
	   #error "_mManchEncode - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 1)
            #error "_mManchEncode - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte) && (Prm_1 != Num8)
                #error "_mManchEncode - Should be a variable or a number"
                Exitm
            #else
                #if (Prm_1 == Byte) 
                    Byte_Byte pValue, InLibB         
                #endif
                #if (Prm_1 == Num8) 
                    Num_Byte pValue, InLibB         
                #endif
                GoSub mManchEncode_Sub
                #if (_mManchEncode_RETURN != 1)
                    #error "_mManchEncode - Mandatory return parameter misssing"
                #else
                    #if (Return_Type != Word)
                        #error "_mManchEncode - Return variable should be a Word variable"
                        Exitm
                    #else
                        Word_Word TempManchW, Return_Var
                    #endif
                #endif
            #endif
        #endif
    #endif                
    ENDSIZE(ManchEncode_MACRO)
Endm

' CONVERT BYTE TO MANCHESTER WORD
' Data to convert is in InLibB
' Result is in TempManchW
'
#ifMacro- _mManchEncode
mManchEncode_Sub:
    STARTSIZE(ManchEncode_LIB)
    CountLibB = 8                ' 8 bits per byte
EN_REPEAT:                       ' Create a loop for All the bits
    #ifdef Watchdog_req
    Clrwdt
    #endif
    Rol InLibB                   ' Rotate in order to test the CARRY flag
    If F_Carry = 1 Then          ' Bit to convert = 1 ?
        Rol TempManchW, Set      ' Place '1' into manchester bytes
        Rol TempManchW, Clear    ' Place '0' into manchester bytes
    Else                            ' Bit to convert = 0
        Rol TempManchW, Clear    ' Place '0' into manchester bytes
        Rol TempManchW, Set      ' Place '1' into manchester bytes
    EndIf
    Declare Reminders = Off
    Djnz CountLibB, EN_REPEAT       ' Close the loop
    Declare Reminders = On
    Return
    ENDSIZE(ManchEncode_LIB)
#endIfMacro-
'-------------------------------------------------------------------------------
$define ManchDecode(pValue) _mManchDecode pValue

_mManchDecode Macro- pValue
    STARTSIZE(ManchDecode_MACRO)
    #if (Prm_Count > 1)
	   #error "_mManchDecode - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 1)
            #error "_mManchDecode - Too few parameters"
            Exitm
        #else
            #if(Prm_1 != Word) && (Prm_1 != Num16)
                #error "_mManchDecode - Should be a variable or a number"
                Exitm
            #endif
            #if (Prm_1 == Word) 
                Word_Word pValue, TempManchW         
            #endif
            #if (Prm_1 == Num16) 
                Num_Word pValue, TempManchW         
            #endif
            GoSub mManch_Decode_Sub
        #endif
    #endif
    #if (_mManchDecode_RETURN != 1)
        #error "_mManchDecode - Mandatory return parameter misssing"
    #else
        #if (Return_Type != Byte)
            #error "_mManchDecode - Return variable should be a Byte variable"
            Exitm
        #else
            Byte_Byte OutLibB, Return_Var
        #endif
    #endif
    ENDSIZE(ManchDecode_MACRO)
Endm
'
' CONVERT MANCHESTER WORD TO BYTE
' Data to convert is in TempManchW
' Data is returned in OutLibB
' TempManchW remains untouched
'
' BIT PATTERN 10 - RESULT BIT = 1
' BIT PATTERN 01 - RESULT BIT = 0
'
#ifMacro- _mManchDecode
mManch_Decode_Sub:
    STARTSIZE(ManchDecode_LIB)
    CountLibB = 8                   ' 8 bit pairs to convert
DE_REPEAT:                          ' Create a loop for All the bits
    #ifdef Watchdog_req
    Clrwdt
    #endif
    Rol TempManchW               ' 1st bit determines result bit
    Rol OutLibB                  ' Rotate CARRY flag into BYTEOUT
    Rol TempManchW               ' skip unused 2nd bit
    Declare Reminders = Off
    Djnz CountLibB, DE_REPEAT       ' Close the loop
    Declare Reminders = On
    Return
    ENDSIZE(ManchDecode_LIB)
#endIfMacro-    
'/------------------------------------------------------------------------------
$endif
$endif
'*******************************************************************************
'* Name    : GetParity                                                         *
'* Author  : [Les Johnson 2005] modified by Alberto Feixanet                   *
'* Purpose : Get the parity of a Byte                                          *
'* Input   : Byte                                                              *
'* Output  : Return type (Byte)                                                *
'* Syntax  : Var1 = GetParity(VarByte)                                         *
'* Notes   :                                                                   *
'*******************************************************************************
$ifdef _GetParity_
$ifndef __GetParity
$define __GetParity

' Declare the local variables
'    LocalByte0(_ParityTempB)      ' BYTE to ENCODE
    Dim _ParityTempB As PRODH

$define GetParity(pValue) _mGetParity pValue

_mGetParity Macro- pValue 
    STARTSIZE(GetParity_MACRO)
    #ifdef BankA_End
        #if (_ParityTempB > BankA_End)
            #error "The variables of _mDebounceByte Macro must reside in BankA" 
        #endif      
    #endif
    #if (Prm_Count > 1) 
        #error "_mGetParity - Too many parameters" 
    #else 
        #if (Prm_Count < 1) 
            #error "_mGetParity - Too few parameters" 
            Exitm
        #else 
            #if (Prm_1 != Byte) && (Prm_1 != Num8) 
                #error "_mGetParity - DataByte(Param1) Should be a Byte variable or number 0-255" 
                Exitm
            #endif 
            #if (Prm_1 == Byte) 
                Byte_Byte pValue, _ParityTempB 
            #endif 
            #if (Prm_1 == Num8) 
                Num_Byte pValue, _ParityTempB 
            #endif 
            GoSub _mGetParity_Sub 
        #endif 
        #if (_mGetParity_RETURN != 1) 
            #error "_mGetParity - Mandatory return parameter misssing"
            Exitm 
        #else 
            #if (Return_Type != Byte) 
                #error "_mGetParity - Return variable should be a Byte" 
                Exitm
            #else 
                Byte_Byte _ParityTempB, Return_Var 
            #endif 
        #endif 
    #endif 
    ENDSIZE(GetParity_MACRO)
Endm 
'
#ifMacro- _mGetParity
_mGetParity_Sub:
    STARTSIZE(GetParity_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    Asm
    Swapf  _ParityTempB,W,0
    Xorwf  _ParityTempB,F,0
    ;rrf    _ParityTempB,W
    Rrcf   _ParityTempB,W,0
    Xorwf  _ParityTempB,F,0
    Btfsc  _ParityTempB,2,0
    Incf   _ParityTempB,F,0
    EndAsm
    If _ParityTempB.0 = 1 Then 
        _ParityTempB = 1
    Else
        _ParityTempB = 0
    EndIf
    Return
    ENDSIZE(GetParity_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : DebounceByte                                                      *
'* Author  : [???????] Modified by Alberto Feixanet                            *
'* Purpose : Debounce 8 bits with vertical counters                            *
'* Input   : a Byte of PORTX to _INPUT_BITS                                    *
'* Output  : _OUT_FILTER => Return_Var                                         *
'* Syntax  : ResultByteVar = DebounceByte(PORTB)                               *
'* Notes   : All the variables are Global.                                     *
'*           Call this routine every 10mS. Result debounce = 10mS x 4          *
'*           Updated 30/08/2018                                                *
'*******************************************************************************
$ifdef _DebounceByte_
$ifndef __DebounceByte
$define __DebounceByte

'/ Declare Global System Variables 
'#ifMacro- _mDebounceByte
    Dim _INPUT_BITS As Byte System
    Dim _CONT_A As Byte System
    Dim _CONT_B As Byte System    
    Dim _OUT_FILTER As Byte System  
'#endIfMacro-

$define DebounceByte(pValueIn) _mDebounceByte pValueIn

_mDebounceByte Macro- pValueIn
    STARTSIZE(DebounceByte_MACRO)
    #ifdef BankA_End
        #if (_OUT_FILTER > BankA_End)
            #error "The variables of _mDebounceByte Macro must reside in BankA" 
        #endif      
    #endif
    #if (Prm_1 != Byte) && (Prm_1 != Num8)     
        #error "_mDebounceByte Macro - (Param1) Should be a Byte Variable or Num8"
        Exitm
    #else    
        #if (Prm_1 == Byte)
            Asm-
            Movff pValueIn,_INPUT_BITS
            Endasm-
        #endif
        #if (Prm_1 == Num8)
            '/ If pValueIn = 0 NO code is compiled. Clear all bytes only.
            #if (pValueIn == 0)
                _INPUT_BITS = 0
                _CONT_A = 0
                _CONT_B = 0   
                _OUT_FILTER = 0              
                ENDSIZE(DebounceByte_MACRO)
                Exitm
            #else
                Num_Byte pValueIn,_INPUT_BITS
            #endif
        #endif
    #endif
    GoSub _mDebounceByte_Sub
    #if (_mDebounceByte_RETURN != 1)
        #error "_mDebounceByte - Mandatory return parameter misssing"
    #else
        #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword)
            #error "_mDebounceByte - Return variable should be a Byte variable"
        #else
            #if (Return_Type == Byte)
                Byte_Byte _OUT_FILTER,Return_Var
            #endif
            #if (Return_Type == Word)
                Byte_Word _OUT_FILTER,Return_Var
            #endif
            #if (Return_Type == Dword)
                Byte_Dword _OUT_FILTER,Return_Var
            #endif
        #endif
    #endif
    ENDSIZE(DebounceByte_MACRO)
Endm

#ifMacro- _mDebounceByte
_mDebounceByte_Sub:
    ' The is written near the assembler method. (more efficient)
    ' The current sample is _INPUT_BITS            
    ' Increment the vertical counter
    STARTSIZE(DebounceByte_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    WREG = _CONT_B
    _CONT_A = _CONT_A ^ WREG
    _CONT_B = ~_CONT_B
    'See if any changes occurred 
    WREG = _INPUT_BITS
    WREG = _OUT_FILTER ^ WREG
    _CONT_B = _CONT_B & WREG
    _CONT_A = _CONT_A & WREG       
    'Determine the counter's state
    WREG = _CONT_B
    WREG = _CONT_A | WREG    
    'Clear all bits that are filtered-or more accurately,
    'save the state of those that are being filtered
    _OUT_FILTER = _OUT_FILTER & WREG
    Xorlw   255
    'Re-write the bits that haven't changed.
    WREG = _INPUT_BITS & WREG     
    _OUT_FILTER = _OUT_FILTER | WREG
    'The 8 filtered bits are in _OUT_FILTER Variable
    Return
    ENDSIZE(DebounceByte_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : LENArray                                                          *
'* Author  : [Alberto Feixanet Sept 2018]                                      *
'* Purpose : Calculate the number of bytes in an array loaded with numbers     *
'* Input   : Number of Array, Declared Lenght of array                         *
'* Output  : => Return_Var (Byte/Word/Dword)                                   *
'* Syntax  : ResultByteVar = LENArray(ArrayName,Lenght of Array)               *
'* Notes   :                                                                   *
'*******************************************************************************
$ifdef _LENArray_
$ifndef __LENArray
$define __LENArray

$define LENArray(pArrayName,pLenghtArray) _mLENArray pArrayName,pLenghtArray

_mLENArray Macro- pArrayName,pLenghtArray
    STARTSIZE(MULA_BCD_MACRO)
    #if (Prm_Count > 2)
	   #error "_mLENArray - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mLENArray - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte_Array_Ptr)
                #error "_mLENArray - Number Array(Param1) Should be an array"
                Exitm
            #else
                Num_FSR0 pArrayName
            #endif
            #if (Prm_2 != Num8) && (Prm_2 != Byte)
                #error "_mLENArray - Number Array(Param2) Should be a Byte or Num8"
                Exitm
            #else
                #if (Prm_2 == Byte)
                    Byte_Byte pLenghtArray, EEDATA
                #endif
                #if (Prm_2 == Num8)
                    Num_Byte pLenghtArray, EEDATA
                #endif                  
            #endif
        #endif
    #endif
    GoSub LenghtOfArray_Sub
    #if (_mLENArray_RETURN != 1)
        #error "_mLENArray - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword) 
            #error "_mLENArray - Return variable should be a Byte, Word or Dword variable"
            Exitm
        #else
            #if (Return_Type == Byte)
                '/ Because to avoid the Bank.
                Asm-
                Movff EEDATA,Return_Var
                Endasm-
            #endif
            #if (Return_Type == Word)
                '/ Because to avoid the Bank.
                Asm-
                Movff EEDATA,Return_Var
                Clrf  Return_Var +1
                Endasm-
            #endif
            #if (Return_Type == Dword)
                '/ Because to avoid the Bank.
                Asm-
                Movff EEDATA,Return_Var
                Clrf  Return_Var +1
                Clrf  Return_Var +2
                Clrf  Return_Var +3                
                Endasm-
            #endif
        #endif
    #endif
    ENDSIZE(MULA_BCD_MACRO)
Endm

#ifMacro- _mLENArray
LenghtOfArray_Sub:
    STARTSIZE(MULA_BCD_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    WREG = EEDATA - 1
    FSR0 = FSR0 + WREG
    Repeat
        WREG = POSTDEC0
        If WREG > 0 Then
            Break
        EndIf
        Dec EEDATA
    Until EEDATA = 0
    Return
    ENDSIZE(MULA_BCD_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : HEXtoASCII                                                        *
'* Author  : [??????] modified by Alberto Freixanet                            *
'* Purpose : Convert a low nibble to ASCII character                           *
'* Input   : Data in WREG                                                      *
'* Output  : Data out in WREG                                                  *
'* Note    : No variable used                                                  *
'*******************************************************************************
$ifdef _HEXtoASCII_
$ifndef __HEXtoASCII
$define __HEXtoASCII

$define HEXtoASCII(pValueIn,pReturn) '
    STARTSIZE(HEXtoASCII_MACRO)      '
    WREG = pValueIn                  '
    _mHEXtoASCII                     '
    pReturn = WREG                   '
    ENDSIZE(HEXtoASCII_MACRO)

_mHEXtoASCII Macro-
    GoSub _mHEXtoASCII_Sub
Endm

#ifMacro- _mHEXtoASCII, _mHEXtoASCII2
_mHEXtoASCII_Sub:
    STARTSIZE(HEXtoASCII_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    WREG = WREG & $0F   ' Take the lower nibble only.
    Asm-
    Addlw   -10         ; Test to see if W < 10
    Btfsc   STATUS,0    ; If yes, skip ahead
    Addlw   "A"-"0"-10  ; Add ASCII 'A', and negate next line
    Addlw   "0"+10      ; Add ASCII '0' and original 10
    Endasm-
    Return 
    ENDSIZE(HEXtoASCII_LIB)
#endIfMacro-
'*******************************************************************************
'* Name    : HEXtoASCII2                                                       *
'* Author  : [??????] modified by Alberto Freixanet                            *
'* Purpose : Convert a Byte to 2 ASCII characters                              *
'* Input   : Data in EEDATA                                                    *
'* Output  : PRODH in pReturn1, PRODL in pReturn2                              *
'* Note    : No variable used                                                  *
'*******************************************************************************
$define HEXtoASCII2(pValueIn,pReturn1,pReturn2) '
    STARTSIZE(HEXtoASCII2_MACRO)                '
    EEDATA = pValueIn                           '
    _mHEXtoASCII2                               '
    pReturn1 = PRODH                            '
    pReturn2 = PRODL                            '
    ENDSIZE(HEXtoASCII2_MACRO)

_mHEXtoASCII2 Macro-
    GoSub HEXtoASCII2_Sub
Endm

#ifMacro- _mHEXtoASCII2
HEXtoASCII2_Sub:
    STARTSIZE(HEXtoASCII2_LIB)
    WREG = EEDATA
    GoSub _mHEXtoASCII_Sub
    PRODL = WREG
    Swapf EEDATA,W
    GoSub _mHEXtoASCII_Sub
    PRODH = WREG
    Return    
    ENDSIZE(HEXtoASCII2_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : BCD_BIN                                                           *
'* Author  : [Alberto Feixanet]                                                *
'* Purpose : Convert one Byte with 2 BCD To one binary Byte                    *
'* Input   : Enter with value in pValue                                        *
'* Output  : Return_Type (Byte)                                                *
'* Syntax  : ResultByteVar = BCD_BIN(VAR1)                                     *
'* Notes   : 2 Local System Variables Used                                     *
'*******************************************************************************
$ifdef _BCD_BIN_ 
$ifndef __BCD_BIN
$define __BCD_BIN

' Declare local variables
'#ifMacro- _mBCD_BIN
'    LocalByte0(_nConvert)
'    LocalByte1(_nTemp_Convert)    
    Dim _nConvert As PRODL
    Dim _nTemp_Convert As PRODH
'#endIfMacro-

$define BCD_BIN(pValueIn) _mBCD_BIN pValueIn

_mBCD_BIN Macro- pValueIn
    STARTSIZE(BCD_BIN_MACRO)
	#if (Prm_Count != 1)         
        ' Ensure the correct amount of parameters
		#error "Incorrect amount of parameters for _mBCD_BIN macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Byte) && (Prm_1 != Num8)
            ' Ensure the parameter is a byte or Num8.
            #error "_mBCD_BIN Macro - Input Variable(Param1) Should be a Byte Variable or a Num8"
            Exitm
        #else    
            #if (Prm_1 == Byte)
                Byte_Byte pValueIn, _nConvert
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValueIn, _nConvert
            #endif            
            GoSub _mBCD_BIN_Sub
            #if (_mBCD_BIN_RETURN != 1)
                #error "_mBCD_BIN - Mandatory return parameter misssing"
            #else
                #if (Return_Type != Byte)
                    #error "_mBCD_BIN - Return variable should be a Byte variable"
                    Exitm
                #else
                    Wreg_Byte Return_Var
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(BCD_BIN_MACRO)
Endm

#ifMacro- _mBCD_BIN
_mBCD_BIN_Sub:
    STARTSIZE(BCD_BIN_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    ' This is the code
    ' Enter with value in PRODH, return is in WREG.            
    _nTemp_Convert = _nConvert & $F0        ' take the high nibble BCD Value only by masking the low nibble with a bitwise and
    Swapf _nTemp_Convert,1                  ' place in the low nibble
    _nTemp_Convert = _nTemp_Convert * 10    ' make _nTemp_Convert = _nTemp_Convert * 10 , hte 10's digits
    WREG = _nConvert & $0F                  ' place the low digit of WREG in the low nibble by masking with a bitwise and
    WREG = _nTemp_Convert + WREG            ' the result of the addition of the two is the binary value of the orignal bcd
    Return
    ENDSIZE(BCD_BIN_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : BIN_BCD                                                           *
'* Author  : [Alberto Feixanet]                                                *
'* Purpose : Convert one Byte with 2 BCD To one binary Byte                    *
'* Input   : Enter with value in pValue                                        *
'* Output  : Return_Type (Byte)                                                *
'* Syntax  : ResultByteVar = BCD_BIN(VAR1)                                     *
'* Notes   : 2 Local System Variables Used                                     *
'*******************************************************************************
$ifdef _BIN_BCD_
$ifndef __BIN_BCD
$define __BIN_BCD

' Declare local variables
'#ifMacro- _mBIN_BCD
'    LocalByte0(_mConvert)
'    LocalByte1(_mTemp_Convert)    
    Dim _mConvert As PRODL
    Dim _mTemp_Convert As PRODH
'#endIfMacro-

$define BIN_BCD(pValueIn) _mBIN_BCD pValueIn

_mBIN_BCD Macro- pValueIn
    STARTSIZE(BIN_BCD_MACRO)
	#if (Prm_Count != 1)         
        ' Ensure the correct amount of parameters
		#error "Incorrect amount of parameters for _mBIN_BCD macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Byte) && (Prm_1 != Num8)
            ' Ensure the parameter is a byte or Num8.
            #error "_mBIN_BCD Macro - Input Variable(Param1) Should be a Byte Variable or a Num8"
            Exitm
        #else    
            #if (Prm_1 == Byte)
                Byte_Byte pValueIn, _mConvert
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValueIn, _mConvert
            #endif            
            GoSub _mBIN_BCD_Sub
            #if (_mBIN_BCD_RETURN != 1)
                #error "_mBIN_BCD - Mandatory return parameter misssing"
            #else
                #if (Return_Type != Byte)
                    #error "_mBIN_BCD - Return variable should be a Byte variable"
                    Exitm
                #else
                    Wreg_Byte Return_Var
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(BIN_BCD_MACRO)
Endm

#ifMacro- _mBIN_BCD
_mBIN_BCD_Sub:
    STARTSIZE(BIN_BCD_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    ' This is the code
    _mTemp_Convert = _mConvert // 10    ' Temp_Convert has the remainder of the divide by 10 in the low nibble
    _mConvert = _mConvert / 10          ' Convert has the integer value of the divide by 10 in the low nibble
    Swapf _mConvert,1                   ' Swap the high and low nibbles of Temp_Convert and 
    WREG = _mConvert ^ _mTemp_Convert   ' Bitwise XOR the two results to form the BCD Value   
    Return
    ENDSIZE(BIN_BCD_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : Map8                                                              *
'* Author  : [Les Johnson] modified by Alberto Freixanet                       *
'* Purpose : Scale one 8-Bit value To another 8-Bit value                      *
'* Input     : Map_bXin holds the value to scale                               *
'*           : Map_bInMin is the lower bound of the value's current range      *
'*           : Map_bInMax is the upper bound of the value's current range      *
'*           : Map_bOutMin is the lower bound of the value's target range      *
'*           : Map_bOutMax is the upper bound of the value's target range      *
'* Output  : pResult holds the Result                                          *
'* Syntax  : Result = Map8(pX, pInMin, pInMax, pOutMin, pOutMax)               *
'* Notes   : Traps a zero value For extra speed                                *
'*******************************************************************************
$ifdef _Map8_
$ifndef __Map8
$define __Map8

'/ Declare local variables
'#ifMacro- _mMap8
    SMLocalByte0(Map_bTemp1)
    SMLocalByte1(Map_bTemp2)  
    Dim Map_bXin As Map_bTemp1      '/ Value is the value to Scale  
    SMLocalByte2(Map_bInMin)        '/ Lower bound of the value's current range
    SMLocalByte3(Map_bInMax)        '/ Upper bound of the value's current range
    SMLocalByte4(Map_bOutMin)       '/ Lower bound of the value's target range
    Dim Map_bOutMax As Map_bTemp2   '/ Upper bound of the value's target range
    SMLocalWord0(Map_wTemp)         '/ Holds the result of the scale calculation         
'#endIfMacro-

$define Map8(pX, pInMin, pInMax, pOutMin, pOutMax) _mMap8 pX, pInMin, pInMax, pOutMin, pOutMax

_mMap8 Macro pX, pInMin, pInMax, pOutMin, pOutMax
    STARTSIZE(Map8_MACRO)
	#if (Prm_Count != 5)         
        ' Ensure the correct amount of parameters
		#error "Incorrect amount of parameters for _Map8 macro. 5 Parameters required!"	
		Exitm
    #else
        #if (Prm_1 != Byte)
            ' Ensure the input parameter is a byte.
            #error "_mMap8 Macro - Input Variable(Param1) Should be a Byte Variable"
            Exitm
        #endif    
        #if (Prm_2 != Byte) && (Prm_2 != Num8)
            #error "_mMap8 Macro - Input Variable(Param2) Should be a Byte Variable or Num8"
            Exitm
        #endif  
        #if (Prm_3 != Byte) && (Prm_3 != Num8)
            #error "_mMap8 Macro - Input Variable(Param3) Should be a Byte Variable or Num8"
            Exitm
        #endif 
        #if (Prm_4 != Byte) && (Prm_4 != Num8)
            #error "_mMap8 Macro - Input Variable(Param4) Should be a Byte Variable or Num8"
            Exitm
        #endif 
        #if (Prm_5 != Byte) && (Prm_5 != Num8)
            #error "_mMap8 Macro - Input Variable(Param5) Should be a Byte Variable or Num8"
            Exitm
        #endif 
        #if (Prm_1 == Byte)
            Byte_Byte pX, Map_bXin
        #endif
        #if (Prm_2 == Byte)
            Byte_Byte pInMin, Map_bInMin
        #endif
        #if (Prm_2 == Num8)
            Num_Byte pInMin, Map_bInMin
        #endif            
        #if (Prm_3 == Byte)
            Byte_Byte pInMax, Map_bInMax
        #endif
        #if (Prm_3 == Num8)
            Num_Byte pInMax, Map_bInMax
        #endif 
        #if (Prm_4 == Byte)
            Byte_Byte pOutMin, Map_bOutMin
        #endif            
        #if (Prm_4 == Num8)
            Num_Byte pOutMin, Map_bOutMin
        #endif
        #if (Prm_5 == Byte)
            Byte_Byte pOutMax, Map_bOutMax
        #endif                        
        #if (Prm_5 == Num8)
            Num_Byte pOutMax, Map_bOutMax
        #endif 
        GoSub _mMap8_Sub
        #if (_mMap8_RETURN != 1)
            #error "_mMap8 - Mandatory return parameter misssing"
            Exitm
        #else
            #if (Return_Type != Byte) && (Return_Type != Word) 
                #error "_mMap8 - Return variable should be a Byte or Word variable"
                Exitm
            #else
                #if (Return_Type == Byte)
                    Word_Byte Map_wTemp, Return_Var
                #endif
                #if (Return_Type == Word)
                    Word_Word Map_wTemp, Return_Var
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(Map8_MACRO)
Endm

#ifMacro- _mMap8
_mMap8_Sub:
    STARTSIZE(Map8_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    If Map_bXin = 0 Then                        ' Is the value to scale zero?
        Map_wTemp = 0                           ' Yes. So return a zero
    Else                                        ' Otherwise...
        Map_bTemp1 = Map_bXin - Map_bInMin
        Map_bTemp2 = Map_bOutMax - Map_bOutMin
        Map_wTemp = Map_bTemp1 * Map_bTemp2
        Map_bTemp1 = Map_bInMax - Map_bInMin
        Map_bTemp2 = Map_wTemp / Map_bTemp1
        Map_wTemp = Map_bTemp2 + Map_bOutMin
    EndIf
    Return
    ENDSIZE(Map8_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : Map16                                                             *
'* Author  : [Les Johnson] modified by Alberto Freixanet                       *
'* Purpose : Scale one 8-Bit value To another 8-Bit value                      *
'* Input     : Map_bXin holds the value to scale                               *
'*           : Map_bInMin is the lower bound of the value's current range      *
'*           : Map_bInMax is the upper bound of the value's current range      *
'*           : Map_bOutMin is the lower bound of the value's target range      *
'*           : Map_bOutMax is the upper bound of the value's target range      *
'* Output  : pResult holds the Result                                          *
'* Syntax  : Result = Map16(pX, pInMin, pInMax, pOutMin, pOutMax)              *
'* Notes   : Traps a zero value For extra speed                                *
'*******************************************************************************
$ifdef _Map16_
$ifndef __Map16
$define __Map16

'/ Declare local variables
'#ifMacro- _mMap16
    SMLocalWord0(Map16_bTemp1)
    SMLocalWord1(Map16_bTemp2)  
    Dim Map16_bXin As Map16_bTemp1    '/ Value is the value to Scale  
    SMLocalWord2(Map16_bInMin)        '/ Lower bound of the value's current range
    SMLocalWord3(Map16_bInMax)        '/ Upper bound of the value's current range
    SMLocalWord4(Map16_bOutMin)       '/ Lower bound of the value's target range
    Dim Map16_bOutMax As Map16_bTemp2 '/ Upper bound of the value's target range
    SMLocalDword0(Map16_wTemp)        '/ Holds the result of the scale calculation         
'#endIfMacro-

$define Map16(pX, pInMin, pInMax, pOutMin, pOutMax) _mMap16 pX, pInMin, pInMax, pOutMin, pOutMax

_mMap16 Macro pX, pInMin, pInMax, pOutMin, pOutMax
    STARTSIZE(Map16_MACRO)
	#if (Prm_Count != 5)         
        ' Ensure the correct amount of parameters
		#error "Incorrect amount of parameters for _Map8 macro. 5 Parameters required!"	
		Exitm
    #else
        #if (Prm_1 != Byte) && (Prm_1 != Word)
            #error "_mMap16 Macro - Input Variable(Param1) Should be a Byte or Word Variable"
            Exitm
        #endif    
        #if (Prm_2 != Byte) && (Prm_2 != Word) && (Prm_2 != Num8) && (Prm_2 != Num16)
            #error "_mMap16 Macro - Input Variable(Param2) Should be a Byte, Word Variable or Num8. Num16"
            Exitm
        #endif  
        #if (Prm_3 != Byte) && (Prm_3 != Word) && (Prm_3 != Num8) && (Prm_3 != Num16)
            #error "_mMap16 Macro - Input Variable(Param3) Should be a Byte, Word Variable Or Num8. Num16"
            Exitm
        #endif 
        #if (Prm_4 != Byte) && (Prm_4 != Word) && (Prm_4 != Num8) && (Prm_4 != Num16)
            #error "_mMap16 Macro - Input Variable(Param4) Should be a Byte, Word Variable Or Num8. Num16"
            Exitm
        #endif 
        #if (Prm_5 != Byte) && (Prm_5 != Word) && (Prm_5 != Num8) && (Prm_5 != Num16)
            #error "_mMap16 Macro - Input Variable(Param5) Should be a Byte, Word Variable Or Num8. Num16"
            Exitm
        #endif 
        #if (Prm_1 == Byte)
            Byte_Word pX, Map16_bXin
        #endif
        #if (Prm_1 == Word)
            Word_Word pX, Map16_bXin
        #endif        
        #if (Prm_2 == Byte)
            Byte_Word pInMin, Map16_bInMin
        #endif
        #if (Prm_2 == Word)
            Word_Word pInMin, Map16_bInMin
        #endif 
        #if (Prm_2 == Num8) || (Prm_2 == Num16)
            Num_Word pInMin, Map16_bInMin
        #endif            
        #if (Prm_3 == Byte)
            Byte_Word pInMax, Map16_bInMax
        #endif
        #if (Prm_3 == Word)
            Word_Word pInMax, Map_bInMax
        #endif 
        #if (Prm_3 == Num8) || (Prm_3 == Num16)
            Num_Word pInMax, Map16_bInMax
        #endif 
        #if (Prm_4 == Byte)
            Byte_Word pOutMin, Map16_bOutMin
        #endif            
        #if (Prm_4 == Word)
            Word_Word pOutMin, Map16_bOutMin
        #endif
        #if (Prm_4 == Num8) || (Prm_4 == Num16)
            Num_Word pOutMin, Map16_bOutMin
        #endif
        #if (Prm_5 == Byte)
            Byte_Word pOutMax, Map16_bOutMax
        #endif                        
        #if (Prm_5 == Word)
            Word_Word pOutMax, Map_bOutMax
        #endif 
        #if (Prm_5 == Num8) || (Prm_5 == Num16)
            Num_Word pOutMax, Map16_bOutMax
        #endif 
        GoSub _mMap16_Sub
        #if (_mMap16_RETURN != 1)
            #error "_mMap16 - Mandatory return parameter misssing"
            Exitm
        #else
            #if (Return_Type != Word) && (Return_Type != Dword) 
                #error "_mMap16 - Return variable should be a Word or Dword variable"
                Exitm
            #else
                #if (Return_Type == Word)
                    Dword_Word Map16_wTemp, Return_Var
                #endif
                #if (Return_Type == Dword)
                    Dword_Dword Map16_wTemp, Return_Var
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(Map16_MACRO)
Endm

#ifMacro- _mMap16
_mMap16_Sub:
    STARTSIZE(Map16_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    If Map16_bXin = 0 Then                      ' Is the value to scale zero?
        Map16_wTemp = 0                         ' Yes. So return a zero
    Else                                        ' Otherwise...
        Map16_bTemp1 = Map16_bXin - Map16_bInMin
        Map16_bTemp2 = Map16_bOutMax - Map16_bOutMin
        Map16_wTemp = Map16_bTemp1 * Map16_bTemp2
        Map16_bTemp1 = Map16_bInMax - Map16_bInMin
        Map16_bTemp2 = Map16_wTemp / Map16_bTemp1
        Map16_wTemp = Map16_bTemp2 + Map16_bOutMin
    EndIf
    Return
    ENDSIZE(Map16_LIB)
#endIfMacro-
$endif
$endif
'**********************************************************************************
'* Name    : MapF                                                                 *
'* Author  : [Les Johnson] modified by Alberto Freixanet                          *
'* Purpose : Floating point scale                                                 *
'* Input   : pValue is the Floating Point value to scale                          *
'*         : pInMin is the Floating Point lower bound of the value's current range*
'*         : pInMax is the Floating Point upper bound of the value's current range*
'*         : pOutMin is the Floating Point lower bound of the value's target range*
'*         : pOutMax is the Floating Point upper bound of the value's target range*
'* Output  : pResult holds the Floating Point result                              *
'* Syntax  : MapF(pValue, pInMin, pInMax, pOutMin, pOutMax, pResult)              *
'* Notes   : Traps a zero value For extra speed                                   *
'**********************************************************************************
$ifdef _MapF_
$ifndef __MapF
$define __MapF

'/ Declare local variables
'#ifMacro- _mMapF
    SMLocalFloat0(Scl_fTemp1)
    SMLocalFloat1(Scl_fTemp2)
    SMLocalFloat2(Scl_fTemp)        '/ Holds the floating point result of the calculation      
    Dim Scl_fXin As Scl_fTemp1      '/ Holds the floating point value to Scale
    SMLocalFloat3(Scl_fInMin)       '/ Lower bound of the value's current range
    SMLocalFloat4(Scl_fInMax)       '/ Upper bound of the value's current range
    SMLocalFloat5(Scl_fOutMin)      '/ Lower bound of the value's target range
    Dim Scl_fOutMax As Scl_fTemp2   '/ Upper bound of the value's target range
'#endIfMacro-
      
$define MapF(pValue, pInMin, pInMax, pOutMin, pOutMax, pResult) ' 
    STARTSIZE(MapF_MACRO) '
    Scl_fXin = pValue     '
    Scl_fInMin = pInMin   '
    Scl_fInMax = pInMax   '
    Scl_fOutMin = pOutMin '
    Scl_fOutMax = pOutMax '
    _mMapF                '
    pResult = Scl_fTemp   '
    ENDSIZE(MapF_MACRO)

_mMapF Macro-
    GoSub _mMapF_Sub
Endm    

#ifMacro- _mMapF
_mMapF_Sub:
    STARTSIZE(MapF_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    Scl_fTemp1 = Scl_fXin - Scl_fInMin
    Scl_fTemp2 = Scl_fOutMax - Scl_fOutMin   
    Scl_fTemp = Scl_fTemp1 * Scl_fTemp2
    Scl_fTemp1 = Scl_fInMax - Scl_fInMin    
    Scl_fTemp2 = Scl_fTemp / Scl_fTemp1  
    Scl_fTemp = Scl_fTemp2 + Scl_fOutMin
    Return
    ENDSIZE(MapF_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : StringToFloat                                                     *
'* Author  : [Les Johnson] modified by Alberto Freixanet                       *
'* Purpose : Convert an ASCII representation of a Floating Point value into    *
'*           a Floating Point Variable                                         *
'* Input  : StringIn holds the ASCII representation of the floating point value*
'* Output : Return_Var = nResult holds the converted floating point value      *
'* Syntax : MyFloatResult = StringToFloat(MyString1)                           *
'* Notes  : Recognises -, +, And . As the beginning of the ASCII floating point*
'*          value                                                              *
'*******************************************************************************
$ifdef _StringToFloat_
$ifndef __StringToFloat
$define __StringToFloat

'#ifMacro- _mStringToFloat
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On    

' Declare global variables    
    $ifndef PP_AARG_Var
    $define PP_AARG_Var
    Dim PP_AARG As Float System  '/ Compiler variable      
    $endif
 
' Declare local variables System
    LocalByte0(nChar)
    LocalBit0(nSign)
    LocalFloat0(nPow10)
    LocalFloat1(nResult)        
'#endIfMacro-

$define StringToFloat(pString) _mStringToFloat pString
 
_mStringToFloat Macro pString
    STARTSIZE(StringToFloat_MACRO)
	#if (Prm_Count != 1)         
        ' Ensure the correct amount of parameters
		#error "Incorrect amount of parameters for _mStringToFloat macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != String)
            #error "_mStringToFloat - Array(Param1) Should be a BYTE array only!"
            Exitm
        #else    
'            #if (Prm_1 == String)
                Num_FSR0 pString        ;/ Point FSR0L/H to the start of the string
'            #endif
            GoSub _mStringToFloat_Sub
            #if (_mStringToFloat_RETURN != 1)
                #error "_mStringToFloat - Mandatory return parameter misssing"
                Exitm
            #else
                #if (Return_Type != Float)
                    #error "_mStringToFloat - Return variable should be a Float variable"
                    Exitm
                #else
                    Float_Float nResult,Return_Var
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(StringToFloat_MACRO)
Endm

#ifMacro- _mStringToFloat
_mStringToFloat_Sub:
    STARTSIZE(StringToFloat_LIB)
    nPow10 = 1
    nResult = 0
    nChar = POSTINC0                         '/ Get a character from the String
    nSign = 0
    If nChar = "-" Then                      '/ Have we found a "-" character?
        nChar = POSTINC0                     '/ Yes. So Discard the "-" character
        nSign = 1                            '/ Indicate that the value is negative
    ElseIf nChar = "+" Then                  '/ Have we found a "+" character?
        nChar = POSTINC0                     '/ Yes. So Discard the "+" character
    EndIf
    While 1 = 1                              '/ Scan the digits before the decimal point (if included)
        #ifdef Watchdog_req
        Clrwdt
        #endif
        If nChar < "0" Then Break            '/ \
        If nChar > "9" Then Break            '/ / Exit the loop if non numeric characters found
        nResult = nResult * 10               '/ \
        PP_AARG = nResult + nChar            '/  | Calculate the whole part of the floating point value
        nResult = PP_AARG - "0"              '/ /
        nChar = POSTINC0                     '/ Get another character from the string
    Wend
    If nChar = "." Then                      '/ Have we found a "." character?
        nChar = POSTINC0                     '/ Yes. So Discard the "." character
        While 1 = 1                          '/ Scan the digits after the decimal point (if included)
            #ifdef Watchdog_req
            Clrwdt
            #endif
            If nChar < "0" Then Break        '/ \
            If nChar > "9" Then Break        '/ / Exit the loop if non numeric characters found
            nPow10 = nPow10 * 10             '/ \
            PP_AARG = nChar - "0"            '/  | Calculate the fractional part of the floating point value
            PP_AARG = PP_AARG / nPow10       '/  |
            nResult = nResult + PP_AARG      '/ /
            nChar = POSTINC0                 '/ Get another character from the string
        Wend
    EndIf
    If nSign = 1 Then
        nResult = -nResult                   '/ Convert to negative if required
    EndIf
    Return
    ENDSIZE(StringToFloat_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : ConvAToFloat (assembler Macro)                                    *
'* Author  : [Alberto Freixanet] 03/10/2018                                    *
'* Purpose : Convert an Integer/negative variable + decimals to a Floating     *
'*           Point Variable                                                    *
'* Input   : Whole number[Byte/Word/Dword,SByte,SWord,SDword],                 *
'*           Decimals[Word,SWord], Number of Decimals[Number]                  *
'* Output  : Return_Var = nResult holds the converted floating point value     *
'* Syntax  : FloatVar = ConvAToFloat(Whole Number,Decimals,Number of Decimals) *
'* Notes   : Take care with the Number of Decimals                             *
'*                                                                             *
'* Important Note: With assembler Macros, it not possible pass the input to    *
'*                 Float. There are some deviations. Then all variables are    *
'*                 passed via SDword.                                          *
'*           ConvAToFloat() Macro has less bytes than ConvBToFloat()           *
'*******************************************************************************
$ifdef _ConvToFloat_
$ifndef __ConvToFloat
$define __ConvToFloat
'/------------------------------------------------------------------------------
$define _HRS_ConvToFltEnable_

'#ifMacro- _mIntegerToFloat
' Declare global variables    
    $ifndef PP_AARG_Var
    $define PP_AARG_Var
    Dim PP_AARG As Float System  '/ Compiler variable      
    $endif

    Dim F_iSign As Bit
    Dim F_iSVar As Bit
    
' Declare local variables 
    LocalByte0(_iFltLoop)
    LocalWord0(_inDecimalsScale)
    LocalSWord0(_iInpDecSWord) 
    LocalSDword0(_iInpSDWord)    
    LocalFloat0(_iFltResult)
'#endIfMacro-

$define ConvAToFloat(pWholeV,pDecimalsV,pNbDecimals) _mConvAToFloat pWholeV,pDecimalsV,pNbDecimals

_mConvAToFloat Macro- pWholeV,pDecimalsV,pNbDecimals
    STARTSIZE(ConvAToFloat_MACRO)
	#if (Prm_Count != 3)         
 		#error "Incorrect amount of parameters for _mConvAToFloat macro. 3 Parameters required!"	
		Exitm
    #else
        #if (Prm_1 != Dword) && (Prm_1 != Word) && (Prm_1 != Byte) && (Prm_1 != SDword) && (Prm_1 != SWord) && (Prm_1 != SByte)
            #error "_mConvAToFloat - (Param1) Should be a Word, SWord,Byte or SByte!"
            Exitm
        #else   
            '/ Whole number. (positive or negative) 
            F_iSVar = 0
            #if (Prm_1 == Byte)
                Byte_SDword pWholeV,_iInpSDWord
            #endif
            #if (Prm_1 == Word)
                Word_SDword pWholeV,_iInpSDWord
            #endif
            #if (Prm_1 == Dword)
                Dword_Dword pWholeV,_iInpSDWord
            #endif
            #if (Prm_1 == SByte)
                Byte_SDword pWholeV,_iInpSDWord
                F_iSVar = 1                     '/ This is a Signed variable.
            #endif
            #if (Prm_1 == SWord)
                Word_SDword pWholeV,_iInpSDWord    
                F_iSVar = 1                     '/ This is a Signed Variable.
            #endif
            #if (Prm_1 == SDword)
                Dword_Dword pWholeV,_iInpSDWord    
                F_iSVar = 1                     '/ This is a Signed Variable.
            #endif
        #endif
        #if (Prm_2 != Word) && (Prm_2 != SWord)
            #error "_mConvAToFloat - (Param2) Should be a Word or Sdword!"
            Exitm
        #else   
            '/ Decimal input. (Positive or negative)
            #if (Prm_2 == Word)
                Word_Word pDecimalsV,_iInpDecSWord
            #endif
            #if (Prm_2 == SWord)
                Word_Word pDecimalsV,_iInpDecSWord
            #endif
        #endif
        '/ Number of decimals.
        #if (Prm_3 != Num8) && (Prm_3 != Byte)
            #error "_mConvAToFloat - (Param3) Should be a Num8 or a Byte!"
            Exitm
        #else   
            #if (Prm_3 == Num8)          
                Num_Byte pNbDecimals,_iFltLoop
            #endif
            #if (Prm_3 == Byte)          
                Byte_Byte pNbDecimals,_iFltLoop
            #endif
        #endif
    #endif
    GoSub _mConvAToFloat_Sub
    #if (_mConvAToFloat_RETURN != 1)
        #error "_mConvAToFloat - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Float)
            #error "_mInToFloat - Return variable should be a Float variable"
            Exitm
        #else
            Float_Float PP_AARG,Return_Var
        #endif
    #endif
    ENDSIZE(ConvAToFloat_MACRO)
Endm

#ifMacro- _mConvAToFloat
_mConvAToFloat_Sub:
    STARTSIZE(ConvAToFloat_LIB)
    '/ Load the whole part (Negative or Positive).
    F_iSign = 0
    If F_iSVar = 1 Then             '/ If signed variable.             
        If _iInpSDWord.31 = 1 Then  '/ If signed variable is negative.
            F_iSign = 1
            _iFltResult = Abs(_iInpSDWord)  '/ It is negative.
        EndIf
    Else
        _iFltResult = _iInpSDWord       '/ It is positive.
    EndIf
    CheckErrorsFloat()

    '/ Decimals scale.
    If _iFltLoop = 1 Then
        _inDecimalsScale = 10   '/ For 1 decimal.    
    ElseIf _iFltLoop = 2 Then
        _inDecimalsScale = 100  '/ For 2 decimals.
    ElseIf _iFltLoop = 3 Then
        _inDecimalsScale = 1000 '/ For 3 decimals.     
    Else
        _inDecimalsScale = 1000 '/ For 3 decimals.
    EndIf

    '/ Load the decimal part.
    If _iInpDecSWord.15 = 1 Then
        _iInpDecSWord = Abs(_iInpDecSWord)      '/ If the decimals are negative then change them. 
    EndIf
    PP_AARG = _iInpDecSWord / _inDecimalsScale  '/ Decimals / 10,100,1000
    PP_AARG = _iFltResult +  PP_AARG
    If F_iSign = 1 Then
        PP_AARG = -PP_AARG  '/ If the Dividend is negative then Float = Negative.
    EndIf

    Return
    ENDSIZE(ConvAToFloat_LIB)
#endIfMacro-
'*******************************************************************************
'* Name    : ConvBToFloat (preprocessor Macro)                                 *
'* Author  : [Alberto Freixanet] 03/10/2018                                    *
'* Purpose : Convert an Integer/negative variable + decimals to a Floating     *
'*           Point Variable                                                    *
'* Input   : Whole number[Byte/Word/Dword,SByte,SWord,SDword],                 *
'*           Decimals[Word,SWord], Number of Decimals[Number]                  *
'* Output  : Return_Var = nResult holds the converted floating point value     *
'* Syntax  : FloatVar = ConvAToFloat(Whole Number,Decimals,Number of Decimals, *
'*           Return_Var)                                                       *
'* Notes   : Take care with the Number of Decimals                             *
'*                                                                             *
'* Important Note: With preprocessor macro, the whole variable is passed       *
'*                 directly to Float PP_AARG.                                  *
'*******************************************************************************
$define ConvBToFloat(pWholeV,pDecimalsV,pNbDecimals,pReturnFloat) '
    STARTSIZE(ConvBToFloat_MACRO)                                 '
    PP_AARG = pWholeV                                             '
    _iInpDecSWord = pDecimalsV                                    '
    _iFltLoop = pNbDecimals                                       '
    _mConvBToFloat pWholeV,pDecimalsV,pNbDecimals,pReturnFloat    '
    pReturnFloat = PP_AARG                                        '
    ENDSIZE(ConvBToFloat_MACRO)

_mConvBToFloat Macro- pWholeV,pDecimalsV,pNbDecimals,pReturnFloat
	#if (Prm_Count != 4)         
 		#error "Incorrect amount of parameters for _mConvBToFloat macro. 4 Parameters required!"	
		Exitm
    #else
        '/ Check Whole value.
        #if (Prm_1 != Float) && (Prm_1 != Dword) && (Prm_1 != Word) && (Prm_1 != Byte) && (Prm_1 != SDword) && (Prm_1 != SWord) && (Prm_1 != SByte)
            #error "_mConvBToFloat - (Param1) Should be a Word, SWord,Byte or SByte!"
            Exitm
        #endif
        '/ Check Decimals value.
        #if (Prm_2 != Word) && (Prm_2 != SWord)
            #error "_mConvBToFloat - (Param2) Should be a Word or SWord!"
            Exitm
        #endif
        '/ Check Number of decimals.
        #if (Prm_3 != Num8) && (Prm_3 != Byte)
            #error "_mConvBToFloat - (Param3) Should be a Num8 or a Byte!"
            Exitm
        #endif
    #endif
    GoSub _mConvBToFloat_Sub
Endm

#ifMacro- _mConvBToFloat
_mConvBToFloat_Sub:
    STARTSIZE(ConvBToFloat_LIB)
    '/ Check Float errors.
    CheckErrorsFloat()
 
    F_iSign = 0

    '/ Load the Whole part.
    If PP_AARG < 0 Then
        F_iSign = 1
    EndIf
    _iFltResult = PP_AARG

    '/ Decimals scale.
    If _iFltLoop = 1 Then
        _inDecimalsScale = 10   '/ For 1 decimal.    
    ElseIf _iFltLoop = 2 Then
        _inDecimalsScale = 100  '/ For 2 decimals.
    ElseIf _iFltLoop = 3 Then
        _inDecimalsScale = 1000 '/ For 3 decimals.     
    Else
        _inDecimalsScale = 1000 '/ For 3 decimals.    
    EndIf

    '/ Load the Decimal part.
    '/ Check if error in Decimals format.
    '/ In Signed Division PDS version 2.6.2.3
    If F_iSign = 1 Then                     '/ If the input value is negative.
        If _iInpDecSWord.15 = 0 Then        '/ If the decimals are positive then 
            _iInpDecSWord = -_iInpDecSWord  '/ Transform decimals to negative.
        EndIf
    Else
        If _iInpDecSWord.15 = 1 Then            '/ If the decimals are negative then 
            _iInpDecSWord = Abs(_iInpDecSWord)  '/ Transform decimals to positive.
        EndIf
    EndIf 
    '/ Calculate the Decimals.
    PP_AARG = _iInpDecSWord / _inDecimalsScale  '/ Decimals / 10,100,1000
    '/ Sum with the whole Float.
    PP_AARG = _iFltResult + PP_AARG

    Return
    ENDSIZE(ConvBToFloat_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------
$endif
$endif
'*******************************************************************************
'* Name    : CLL                                                               *
'* Author  : [Tim Box] modified by Alberto Freixanet                           *
'* Purpose : Alternative To the standard Proton Cls command                    *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : CLL {Line, {Pos}} Command                                         *
'* Notes   : This command takes a long time! 0,5mS                             *
'*******************************************************************************
' For users still using an alphanumeric LCD this provides a useful enhanced
' alternative to the standard Proton CLS command.  When invoked with no parameters
' it will perform a standard Proton CLS, however, if you add a line number argument
' it will clear just that line, if you add a second argument (Position) it will clear
' from that position to the end of the line leaving the cursor at the beginning of the clear.
'
' CLL {Line, {Pos}} Command
'
'      With no arguments same as proton CLS
'
'      With 1 argument (Line), clears line specified in argument
'      Con 1 argumento (Linea), borra la lnea especificada en el argumento
'
'      With 2 arguments (Line, Pos), clears to end of Line from Position
'      Con 2 argumentos (Linea, Posicin), borra el final de la lnea desde el argumento Posicin
'
$ifdef _CLL_
$ifndef __CLL
$define __CLL 

' Declare the constant
'    $ifndef _LCD_CharsLenght_
'        $define _LCD_CharsLenght_ 16
'        Symbol __LCD_CharsLenght = _LCD_CharsLenght_
'    $endif
' Declare the Locals variables
    LocalByte0(bCUR_RowB)
    LocalByte1(bCUR_ColB)    
    LocalByte2(bCUR_ChrsB)    

$define CLL(pValue1,pValue2) _mCLL pValue1,pValue2
 
_mCLL Macro- pValue1,pValue2
    STARTSIZE(CLL_MACRO)
    #if (Prm_Count == 0)
    Cls    ' Here is the additional code added after the generator has produced the outline
    #else
        #if (Prm_Count == 1)           
            #if (Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
                #error "_mCLL - Line(Param 1) should be a Byte variable or number"
            #endif
            #if (Prm_1 == Byte)
                Byte_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num16)
                Num_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num32)
                Num_Byte pValue1, bCUR_RowB
            #endif
            bCUR_ColB = 1
        #endif
        #if (Prm_Count == 2)
            #if (Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
                #error "_mCLL - Line(Param 1) should be a Byte variable or number"
            #endif
            #if (Prm_1 == Byte)
                Byte_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num16)
                Num_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num32)
                Num_Byte pValue1, bCUR_RowB
            #endif

            #if (Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
                #error "_mCLL - Pos(Param 2) should be a Byte variable or number"
            #endif
            #if (Prm_2 == Byte)
                Byte_Byte pValue2, bCUR_ColB
            #endif
            #if (Prm_2 == Num8)
                Num_Byte pValue2, bCUR_ColB
            #endif
            #if (Prm_2 == Num16)
                Num_Byte pValue2, bCUR_ColB
            #endif
            #if (Prm_2 == Num32)
                Num_Byte pValue2, bCUR_ColB
            #endif
        #endif
        GoSub _mCLL_Sub
    #endif
    ENDSIZE(CLL_MACRO)
Endm

#ifMacro- _mCLL
_mCLL_Sub:
    STARTSIZE(CLL_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    ' Checking the correct values.
    If bCUR_RowB > __LCD_LINES Then
        bCUR_RowB = __LCD_LINES
    EndIf
    If bCUR_ColB > __LCD_CharsLenght Then
        bCUR_ColB = __LCD_CharsLenght - 1
    EndIf

    Cursor bCUR_RowB, bCUR_ColB
    bCUR_ChrsB = __LCD_CharsLenght - bCUR_ColB + 1
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        Print $20                    ' Send a SPACE to the LCD
        Dec bCUR_ChrsB               ' Increment the index
    Until bCUR_ChrsB = 0             ' Until the last number of characters deleted
    Cursor bCUR_RowB,bCUR_ColB       ' Set the Cursor to the Origin position.
    Return
    ENDSIZE(CLL_LIB)
#endIfMacro-
$endif
$endif
'Note  This macro requires a constant __LCD_CharsLenght to be defined to reflect your
' hardware configuration.  E.g. Symbol __LCD_CharsLenght = 16 for a 16 character display. 

'*******************************************************************************
'* Name    : CRC16                                                             *
'* Author  : [Les Johnson 2005]                                                *
'* Purpose : Calculate a xcrc_CRC checksum based on the rather unusual C       *
'*           expression shown below:                                           *
'* xcrc_CRC = (xcrc_CRC >> 8) = ^ yyCRC_TABLE [*buffer++ ^ (xcrc_CRC & 0xFF)]; *
'* Input   : Array + CRCInitValue                                              *
'* Output  : Return_Var (Word)                                                 *
'* Syntax  :                                                                   *
'*       CRC16(pArrayInput,pNumberBytestoTake,pNumberBytesOffset,pCRCInitValue)*
'* Notes:                                                                      *           
'******************************************************************************* 
$ifdef _CRC16_
$ifndef __CRC16
$define __CRC16

' Declare the Local Variables of this library.
    SMLocalByte0(xcrc_loop)           ' Loop variable
    SMLocalByte1(xcrc_CRC_Offset)    
    SMLocalByte2(xcrc_LengthArray)    ' xcrc_LengthArray of BUFFER array -1
    SMLocalWord0(xcrc_temp)           'General purpose variable
    SMLocalWord1(xcrc_CRC)

' Declare global variables

'-------------------------------------------------------------------------------
' 'The main program starts here
'		DelayMS 100  'Wait for everything to stabilise
' 'cls  'Clear the LCD
' xcrc_LengthArray = 19  'The xcrc_LengthArray of the BUFFER array - 1
'		Str buffer = 10, 20, 30, 40, 50, 60, 70, 80, 90, 100, 110, 120, 130, 140, 150, 160, 170, 180, 190, 200  'Put some values in the buffer
' xcrc_CRC = 0  'Clear the initial xcrc_CRC value for now
'
' CRC_Result = CRC16(buffer,20,0,$1745)
' GoSub calculate_crc  'Calculate the xcrc_CRC
' Print At 1, 1, IHex4 xcrc_CRC  'Display the xcrc_CRC value in hexadecimal notation on the LCD
' Stop  'Stop here

'-------------------------------------------------------------------------------
'Calculate a xcrc_CRC checksum based on the rather unusual C expression shown below: -
'xcrc_CRC = (xcrc_CRC >> 8) = ^ yyCRC_TABLE [*buffer++ ^ (xcrc_CRC & 0xFF)];

'The code is actually based upon the Z80 representation of the same expression.

'Input  : xcrc_CRC holds the 16-bit xcrc_CRC value
': BUFFER holds the values to xcrc_CRC
': xcrc_LengthArray holds the xcrc_LengthArray of the BUFFER array (minus 1)
'Output : xcrc_CRC holds the new xcrc_CRC checksum
'
'-------------------------------------------------------------------------------

$define CRC16(pArrayInput,pNumberBytestoTake,pNumberBytesOffset,pCRCInitValue) _mCRC_16 pArrayInput, pNumberBytestoTake, pNumberBytesOffset, pCRCInitValue

_mCRC_16 Macro- pArrayInput, pNumberBytestoTake, pNumberBytesOffset, pCRCInitValue
    STARTSIZE(CRC16_MACRO)
    #if (Prm_Count > 4)
        #error "CRC_16 - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 4)
            #error "CRC_16 - Too few parameters"
            Exitm
        #else
            #if(Prm_1 != Byte_Array_Ptr) && (Prm_1 != String)
                #error "_mCRC_16 macro - (Param1) Should be a Byte Array or a String"
                Exitm
            #endif
            #if(Prm_2 != Num8) && (Prm_2 != Byte)
                #error "_mCRC_16 Macro - (Param2) Should be a Byte or Num8"
                Exitm
            #endif
            #if(Prm_3 != Num8) && (Prm_3 != Byte)
                #error "_mCRC_16 Macro - (Param3) Should be a Byte or Num8"
                Exitm
            #endif
            #if(Prm_4 != Num8) && (Prm_4 != Num16)
                #error "_mCRC_16 Macro - (Param4) Should be a Num8, Num16"
                Exitm
            #endif
            #if (Prm_1 == Byte_Array_Ptr)
                Num_FSR0 pArrayInput
            #endif
            #if(Prm_1 == String)
                Num_FSR0 pArrayInput
            #endif
    
            #if (Prm_2 == Byte)
                Byte_Byte pNumberBytestoTake, xcrc_LengthArray
            #endif
            #if (Prm_2 == Num8)
                Num_Byte pNumberBytestoTake, xcrc_LengthArray
            #endif
    
            #if (Prm_3 == Byte)
                Byte_Byte pNumberBytesOffset, xcrc_CRC_Offset
            #endif
            #if (Prm_3 == Num8)
                Num_Byte pNumberBytesOffset, xcrc_CRC_Offset
            #endif            
    
            #if (Prm_4 == Num8)
                Num_Word pCRCInitValue, xcrc_CRC
            #endif
            #if (Prm_4 == Num16)
                Num_Word pCRCInitValue, xcrc_CRC
            #endif
            GoSub xx#CRC_16_Sub
        #endif
        #if (_mCRC_16_RETURN != 1)
            #error "_mCRC_16 - Macro - Mandatory return parameter misssing"
            Exitm
        #else
            #if(Return_Type != Word)
                #error "_mCRC_16 - Macro - Return variable should be a Word"
                Exitm
            #else
                #if(Return_Type == Word)
                    Word_Word xcrc_CRC, Return_Var
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(CRC16_MACRO)
Endm

#ifMacro- _mCRC_16
xx#CRC_16_Sub:								
STARTSIZE(CRC_16_LIB)
    TBLPTRU = 0
    FSR0 = FSR0 + xcrc_CRC_Offset
    'xcrc_LengthArray = Number of bytes to calculate the xcrc_CRC
    xcrc_LengthArray = xcrc_LengthArray - 1   ' The xcrc_LengthArray is the number of characters.
    xcrc_loop = 0
    Repeat                                              ' Create a loop for All the values in BUFFER
        #ifdef Watchdog_req
        Clrwdt
        #endif
        ClearGIE()
        EECON1 = 128                                    ' Access Flash memory
        xcrc_temp = POSTINC0 ^ xcrc_CRC.LowByte         ' Find the table offset by XORing low xcrc_CRC byte with data in BUFFER
        xcrc_temp = xcrc_temp * 2				        ' Correct for 16-bit reads from the table
'        TBLPTR = yyCRC_TABLE + xcrc_temp 	            ' Point to location within xcrc_CRC table 
        TBLPTR = AddressOf(yyCRC_TABLE) + xcrc_temp 	' Point to location within xcrc_CRC table 
        Tblrd*+									        ' Read the low BYTE of the 16-bit value from the table, and auto increment
        xcrc_CRC.LowByte = xcrc_CRC.HighByte ^ TABLAT   ' XOR high xcrc_CRC with low (table) and becomes new low xcrc_CRC byte 
        Tblrd*										    ' Read the high byte of the 16-bit value from the table
        xcrc_CRC.HighByte = TABLAT 					    ' The Hi byte (table) becomes the new hi xcrc_CRC byte
        Inc xcrc_loop								    ' Move up the BUFFER array
    Until xcrc_loop > xcrc_LengthArray					' Do All the values in the BUFFER array
    EECON1 = 0                                          ' End Access Flash memory
    SetGIE()
    Return 											    ' Exit the subroutine
'
yyCRC_TABLE:
CData As Word  $0000, $1189, $2312, $329b, $4624, $57ad, $6536, $74bf,_
            $8c48, $9dc1, $af5a, $bed3, $ca6c, $dbe5, $e97e, $f8f7,_
            $1081, $0108, $3393, $221a, $56a5, $472c, $75b7, $643e,_
            $9cc9, $8d40, $bfdb, $ae52, $daed, $cb64, $f9ff, $e876,_
            $2102, $308b, $0210, $1399, $6726, $76af, $4434, $55bd,_
            $ad4a, $bcc3, $8e58, $9fd1, $eb6e, $fae7, $c87c, $d9f5,_
            $3183, $200a, $1291, $0318, $77a7, $662e, $54b5, $453c,_
            $bdcb, $ac42, $9ed9, $8f50, $fbef, $ea66, $d8fd, $c974,_
            $4204, $538d, $6116, $709f, $0420, $15a9, $2732, $36bb,_
            $ce4c, $dfc5, $ed5e, $fcd7, $8868, $99e1, $ab7a, $baf3,_
            $5285, $430c, $7197, $601e, $14a1, $0528, $37b3, $263a,_
            $decd, $cf44, $fddf, $ec56, $98e9, $8960, $bbfb, $aa72,_
            $6306, $728f, $4014, $519d, $2522, $34ab, $0630, $17b9,_
            $ef4e, $fec7, $cc5c, $ddd5, $a96a, $b8e3, $8a78, $9bf1,_
            $7387, $620e, $5095, $411c, $35a3, $242a, $16b1, $0738,_
            $ffcf, $ee46, $dcdd, $cd54, $b9eb, $a862, $9af9, $8b70,_
            $8408, $9581, $a71a, $b693, $c22c, $d3a5, $e13e, $f0b7,_
            $0840, $19c9, $2b52, $3adb, $4e64, $5fed, $6d76, $7cff,_
            $9489, $8500, $b79b, $a612, $d2ad, $c324, $f1bf, $e036,_
            $18c1, $0948, $3bd3, $2a5a, $5ee5, $4f6c, $7df7, $6c7e,_
            $a50a, $b483, $8618, $9791, $e32e, $f2a7, $c03c, $d1b5,_
            $2942, $38cb, $0a50, $1bd9, $6f66, $7eef, $4c74, $5dfd,_
            $b58b, $a402, $9699, $8710, $f3af, $e226, $d0bd, $c134,_
            $39c3, $284a, $1ad1, $0b58, $7fe7, $6e6e, $5cf5, $4d7c,_
            $c60c, $d785, $e51e, $f497, $8028, $91a1, $a33a, $b2b3,_
            $4a44, $5bcd, $6956, $78df, $0c60, $1de9, $2f72, $3efb,_
            $d68d, $c704, $f594, $e416, $90a9, $8120, $b3bb, $a232,_
            $5ac5, $4b4c, $79d7, $685e, $1ce1, $0d68, $3ff3, $2e7a,_
            $e70e, $f687, $c41c, $d595, $a12a, $b1a3, $8238, $93b1,_
            $6b46, $7acf, $4854, $59dd, $2d62, $3ceb, $0e70, $1ff9,_
            $f78f, $e606, $d49d, $c514, $b1ab, $a022, $92b9, $8330,_
            $7bc7, $6a4e, $58d5, $495c, $3de3, $2c6a, $1ef1, $0f78
ENDSIZE(CRC_16_LIB)
#endIfMacro-

$endif
$endif
'*******************************************************************************
'* Name    : MATHS with BCD counters (original code)                           *
'* Author  : [Alberto Freixanet sept 2018]                                     *
'* Purpose : Commands to make calculations for integer BCD Maths               *
'* Notes   : The numer of BCD Arrays must be defined first. InitBCDcounters(25)*           
'******************************************************************************* 
'===============================================================================
' This is an original code written by Alberto Freixanet on September of 2018.
' This program is free software, you can redistribute it and/or modify.
' The code is offered as-is and the author take any responsibility for its use.
' This program is distributed in the hope that it will be useful, but WITHOUT ANY
' WARRANTY. However, a mention of the author and compiler would be appreciated.
'
' Es un cdigo original escrito por Alberto Freixanet en Septiembre de 2018.
' Este programa es un software libre, puede redistribuirlo y/o modificarlo.
' Se entrega este cdigo tal como esta y el autor NO se hace responsable de
' su utilizacin. Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.
'
' C'est un progamme original crit par Alberto Freixanet en Septiembre de 2018.
' Ce programme est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' Ce logiciel est offert tel qu'il est, et son auteur NE prend AUCUNE responsabilit
' pour son utilization. Ce programme est distribu dans l'espoir qu'il sera util,
' mais SANS AUCUNE GARANTIE. Cependant mentionner l'auteur et le compileur serait
' aprci.
'===============================================================================
$ifdef _BCDCounters_
$ifndef __BCDCounters
$define __BCDCounters

'/ In case of the value is not defined by the user.
$ifndef NumberBCDCounters
    $define NumberBCDCounters 12
$endif

' Declare the Local Variables of this Macro.
'#ifMacro- _mConvArrayToVar
    Dim PP0 As Dword System
'#endIfMacro

'#ifMacro- _mAddBCDcounters,_mMulVBCDcounters,_mMulABCDcounters,_mSUBBCDcounters,_
'          _mDivVBCDcounters,_mDivABCDcounters,_mSTR_BCDArray,_mConvArrayToVar,_mDivVBCDcounters
    Dim F_BCDCarryFlag As Bit
    Dim F_ADDCarryFlag As Bit
    Dim F_SUBCarryFlag As Bit
    Dim F_MULCarryFlag As Bit    
    Dim F_DIVCarryFlag As Bit
    Dim F_BCDZeroFlag  As Bit
'    Dim _BCD_CounterLenght As Byte System

'/ Macro to Init the BCD counters.
'/ Declare the number of digits of the array counter.
'/ Dim all the arrays.
'/
    Symbol __VBCD_CounterLenght = NumberBCDCounters
    Dim BCDArray1[NumberBCDCounters] As Byte Heap
    Dim BCDArray2[NumberBCDCounters] As Byte Heap
    Dim BCDArray3[NumberBCDCounters] As Byte Heap
    Dim BCDArray4[NumberBCDCounters] As Byte Heap
    Dim BCDArray5[NumberBCDCounters] As Byte Heap
    Dim BCDArray6[NumberBCDCounters] As Byte Heap
    Dim BCDArray7[NumberBCDCounters] As Byte Heap
    Dim BCDArray8[NumberBCDCounters] As Byte Heap
'#endIfMacro 
'/==============================================================================
'* LENBCDArray                                                         
'* Author  : [Alberto Feixanet Sept 2018]                                     
'* Purpose : Calculate the lenght of a BCD array loaded with numbers              
'* Input   : Number of Array                                                  
'* Output  : => Return_Var (Byte/Word/Dword)                                   
'* Syntax  : ResultByteVar = LENBCDArray(1)  (array 1)                          
'* Notes   :                                                                  
   
$define LENBCDArray(pNumberArray1) _mLENBCDArray pNumberArray1

_mLENBCDArray Macro- pNumberArray1
    STARTSIZE(MULA_BCD_MACRO)
    #if (Prm_Count > 1)
	   #error "_mLENBCDArray - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 1)
            #error "_mLENBCDArray - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mLENBCDArray - Number Array(Param1) Should be a number8"
                Exitm
            #else
                #if (pNumberArray1 == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNumberArray1 == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNumberArray1 == 3)
                            Num_FSR0 BCDArray3
                        #else 
                            #if (pNumberArray1 == 4)
                                Num_FSR0 BCDArray4
                            #else 
                                #if (pNumberArray1 == 5)
                                    Num_FSR0 BCDArray5
                                #else 
                                    #if (pNumberArray1 == 6)
                                        Num_FSR0 BCDArray6
                                    #else 
                                        #if (pNumberArray1 == 7)
                                            Num_FSR0 BCDArray7
                                        #else                                                         
                                            #if (pNumberArray1 == 8)
                                                Num_FSR0 BCDArray8
                                            #else 
                                                #error "_mLENBCDArray - Number Array(Param1) Should be a 1,2,3,4,5,6,7,8"
                                                Exitm
                                            #endif
                                        #endif
                                    #endif
                                #endif
                            #endif
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif
    GoSub LenghtOfBCDArray_Sub
    #if (_mLENBCDArray_RETURN != 1)
        #error "_mLENBCDArray - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword) 
            #error "_mLENArray - Return variable should be a Byte, Word or Dword variable"
            Exitm
        #else
            #if (Return_Type == Byte)
                Byte_Byte EEDATA, Return_Var
            #endif
            #if (Return_Type == Word)
                Byte_Word EEDATA, Return_Var
            #endif
            #if (Return_Type == Dword)
                Byte_Dword EEDATA, Return_Var
            #endif
        #endif
    #endif
    ENDSIZE(MULA_BCD_MACRO)
Endm

#ifMacro- _mLENBCDArray
LenghtOfBCDArray_Sub:
    STARTSIZE(MULA_BCD_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    WREG = __VBCD_CounterLenght - 1
    FSR0 = FSR0 + WREG
    EEDATA = __VBCD_CounterLenght
    Repeat
        WREG = POSTDEC0
        If WREG > 0 Then
            Break
        EndIf
        Dec EEDATA
    Until EEDATA = 0
    Return
    ENDSIZE(MULA_BCD_LIB)
#endIfMacro-
'/==============================================================================
'/ Increment the BCD counters. Array nb 1 to nb 6.           
'#ifMacro- _mIncBCDcounters
    LocalByte0(_icBCD_Loop)
'    Dim _icBCD_Loop As Byte System
'#endIfMacro-

$define IncBCD(pNumberArray) _mIncBCDcounters pNumberArray

_mIncBCDcounters Macro- pNumberArray
    STARTSIZE(IncBCD_MACRO)
    #if (Prm_Count > 1)
	   #error "_mIncBCDcounters - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 1)
            #error "_mIncBCDcounters - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mIncBCDcounters - _ReadDelay(Param1) Should be a number8"
                Exitm
            #else
                #if (pNumberArray == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNumberArray == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNumberArray == 3)
                            Num_FSR0 BCDArray3
                        #else  
                            #if (pNumberArray == 4)
                                Num_FSR0 BCDArray4
                            #else 
                                #if (pNumberArray == 5)
                                    Num_FSR0 BCDArray5
                                #else 
                                    #error "_mIncBCDcounters - Number Arry(Param1) Should be a 1,2,3,4,5"
                                    Exitm
                                #endif 
                            #endif
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif
    GoSub IncBCDcounters_Sub
    #if (_mIncBCDcounters_RETURN == 1)
        #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword)
            #error "_mIncBCDcounters - Return variable should be a Byte, Word or Dword"
            Exitm
        #else
            #if (Return_Type == Byte)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Endasm-
            #endif
            #if (Return_Type == Word)
                '/ Because the Wreg_Word Macro is not optimized.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Endasm-
            #endif
            #if (Return_Type == Dword)
                '/ Because the Wreg_Dword Macro is not optimized.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Clrf  Return_Var +2
                Clrf  Return_Var +3                
                Endasm-
            #endif
        #endif
    #endif        
    ENDSIZE(IncBCD_MACRO)
Endm

'#ifMacro- _mIncBCDcounters,_mDivABCDcounters
#ifMacro- _mIncBCDcounters
IncBCDcounters_Sub:
    STARTSIZE(IncBCD_LIB)
    ' The BCD counters are built with an array of N bytes.
    _icBCD_Loop = __VBCD_CounterLenght  '/ Loading the number of BCD bytes.
    F_BCDCarryFlag = 0
    Inc INDF0                           ' Increment the Low BCD counter
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        If F_BCDCarryFlag = 1 Then  ' If Carry set?
            Inc INDF0               ' Then increment again
            F_BCDCarryFlag = 0      ' Done
        EndIf
        If INDF0 = 10 Then          ' 1 increment?
            INDF0 = 0               ' Counter cleared.
            F_BCDCarryFlag = 1      ' Set Carry flag for next BCD counter
        EndIf
        Inc FSR0
        Dec _icBCD_Loop
    Until _icBCD_Loop = 0

    '/ Pass an error to Return_Var. (This form is the less code)
    WREG = 0
    If F_BCDCarryFlag = 1 Then              
        WREG = 1                   '/ Counter overrun.
    EndIf
    Return
    ENDSIZE(IncBCD_LIB)
#endIfMacro-
'/==============================================================================
'/ Decrement the BCD counters.  Array nb 1 To nb 6.

'#ifMacro- _mDecBCDcounters
    LocalByte0(_dcBCD_Loop)
'    Dim _dcBCD_Loop As Byte System
'#endIfMacro-

$define DecBCD(pNumberArray) _mDecBCDcounters pNumberArray

_mDecBCDcounters Macro- pNumberArray
    STARTSIZE(DecBCD_MACRO)
    #if (Prm_Count > 1)
	   #error "_mDecBCDcounters - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 1)
            #error "_mDecBCDcounters - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mDecBCDcounters - _ReadDelay(Param1) Should be a number8"
                Exitm
            #else
                #if (pNumberArray == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNumberArray == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNumberArray == 3)
                            Num_FSR0 BCDArray3
                        #else 
                            #if (pNumberArray == 4)
                                Num_FSR0 BCDArray4
                            #else 
                                #if (pNumberArray == 5)
                                    Num_FSR0 BCDArray5
                                #else 
                                    #error "_mDecBCDcounters - Number Arry(Param1) Should be a 1,2,3,4,5"
                                    Exitm
                                #endif 
                            #endif
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif
    GoSub DecBCDcounters_Sub
    #if (_mDecBCDcounters_RETURN == 1)
        #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword)
            #error "_mDecBCDcounters - Return variable should be a Byte, Word or Dword"
            Exitm
        #else
            #if (Return_Type == Byte)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Endasm-
            #endif
            #if (Return_Type == Word)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Endasm-
            #endif
            #if (Return_Type == Dword)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Clrf  Return_Var +2
                Clrf  Return_Var +3                
                Endasm-
            #endif
        #endif
    #endif        
    ENDSIZE(DecBCD_MACRO)
Endm

#ifMacro- _mDecBCDcounters
DecBCDcounters_Sub:
    STARTSIZE(DecBCD_LIB)
    ' The BCD counters are built with an array of N bytes.
    _dcBCD_Loop = __VBCD_CounterLenght  '/ Loading the number of BCD bytes.
    F_BCDZeroFlag = 0                   '/ Init the Zero flag.
    Dec INDF0                           '/ Begins to decrement the lowest digit.
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        If F_BCDZeroFlag = 1 Then   '/ If Number-1 Zero set?
            Dec INDF0               '/ Then decrement the digit.
            F_BCDZeroFlag = 0       '/ Done
        EndIf
        If INDF0 = 255 Then         '/ If override then set the zero flag for next decrement.
            INDF0 = 9               '/ Decrement the digit. (0 => 9)
            F_BCDZeroFlag = 1       '/ Decrement the next digit.
        EndIf
        Inc FSR0                    '/ Move the pointer up to the array values.
        Dec _dcBCD_Loop             '/ Check all digits.
    Until _dcBCD_Loop = 0

    '/ Pass an error to Return_Var. (This form is the less code)
    WREG = 0
    If F_BCDZeroFlag = 1 Then              
        WREG = 1                    '/ Counter overrun.
    EndIf
    Return
    ENDSIZE(DecBCD_LIB)    
#endIfMacro-
'/==============================================================================
'/ Send a BCD array to the terminal: any array from 1 to 8.
'/ Syntax  : HRSOut_BCDarray(pNumberArray,pCarriageReturn)
'/ Parameters from left to right:
'/ Parameter 1: Number of the Array (1 to 4)
'/ Parameter 2: Number of Carriage Return
'/              If a simple HEX value (o to 15) = $01, send 1 CR and all bytes, zeros not printed.
'/              If a doble HEX value: eg $F1, send 1 CR And all zeros printed before the value.
'/
'/ Could be used for debugging inside the macros.
'#ifMacro- _mHRSOut_BCDarray
    Dim _NumberCR As Byte System
    Dim _hrsBCD_Loop As Byte System
    Dim F_HRSHeadZeros As Bit
'#endIfMacro-
    
$define HRSOut_BCDarray(pNumberArray,pCarriageReturn) _mHRSOut_BCDarray pNumberArray,pCarriageReturn
    
_mHRSOut_BCDarray Macro- pNumberArray,pCarriageReturn
    STARTSIZE(HRSOut_BCDarray_MACRO)
    #if (Prm_Count > 2)
	   #error "_mHRSOut_BCDarray - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mHRSOut_BCDarray - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mHRSOut_BCDarray - Number of Array(Param1) Should be a number8"
                Exitm
            #else
                #if (pNumberArray == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNumberArray == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNumberArray == 3)
                            Num_FSR0 BCDArray3
                        #else 
                            #if (pNumberArray == 4)
                                Num_FSR0 BCDArray4
                            #else 
                                #if (pNumberArray == 5)
                                    Num_FSR0 BCDArray5
                                #else 
                                    #if (pNumberArray == 6)
                                        Num_FSR0 BCDArray6
                                    #else 
                                        #if (pNumberArray == 7)
                                            Num_FSR0 BCDArray7
                                        #else 
                                            #if (pNumberArray == 8)
                                                Num_FSR0 BCDArray8
                                            #else 
                                                #error "_mHRSOut_BCDarray - Number Array(Param1) Should be a 1,2,3,4,5,6,7,8"
                                                Exitm
                                            #endif
                                        #endif
                                    #endif
                                #endif
                            #endif
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_2 != Num8)
                #error "_mHRSOut_BCDarray - Number of Carriage Return(Param2) Should be a number8"
                Exitm
            #else
                Num_Byte pCarriageReturn,_NumberCR
            #endif
        #endif
    #endif
    GoSub _mHRSOut_BCDarray_Sub
    ENDSIZE(HRSOut_BCDarray_MACRO)
Endm    
    
#ifMacro- _mHRSOut_BCDarray    
_mHRSOut_BCDarray_Sub:    
    STARTSIZE(HRSOut_BCDarray_LIB)
    _hrsBCD_Loop = __VBCD_CounterLenght '/ Load the lenght of array to do loop. 
    WREG = __VBCD_CounterLenght - 1     '/ Load the number of bytes to point the top address of the array.
    FSR0 = FSR0 + WREG                  '/ Array pointer to the top of the array and count down.
    F_HRSHeadZeros = 0
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        EEDATA = POSTDEC0 + "0"         '/ Convert BCD character to ASCII to save execution time.
        If (_NumberCR & $F0) = 0 Then   '/ Is the printing zeros options enabled?
            If _hrsBCD_Loop = 1 Then
                F_HRSHeadZeros = 1      '/ Because the last number could be = 0.
            EndIf
            If F_HRSHeadZeros = 0 Then
                If EEDATA > "0" Then    '/ Check if = zero. The zero characters are not sent.
                    HRSOut EEDATA       '/ NO zero then Send the ASCII character to the terminal
                    F_HRSHeadZeros = 1  '/ First number
                EndIf
            Else
                HRSOut EEDATA           '/ Send the ASCII character to the terminal
            EndIf
        Else
            HRSOut EEDATA               '/ Send the ASCII character to the terminal
        EndIf
        Dec _hrsBCD_Loop
    Until _hrsBCD_Loop = 0                '/ Until all bytes out.
    _NumberCR = _NumberCR & $0F
    While _NumberCR > 0                 '/ Send the Carriage Return.
        HRSOut CR
        Dec _NumberCR
    Wend   
    Return
    ENDSIZE(HRSOut_BCDarray_LIB)
#endIfMacro-
'/==============================================================================
'/ Print a BCD array to the LCD: any array from 1 to 4.
'/ Syntax  : Print_BCDarray(pNumberArray,pLine,pPosition)
'/ Parameters from left to right:
'/ Parameter 1: Number of the Array (1 to 4)
'/ Parameter 2: Number of Line (1 to 4)
'/ Parameter 3: Position of first character to print (1 to 16)
'/              If a simple HEX value (o to 15) = $01, send the position And print zeros before value.
'/              If a doble HEX value: eg $F1, send the position And print all zeros before the value.
'/
'#ifMacro- _mPrint_BCDarray
    LocalByte0(_BCDLine)
    LocalByte1(_BCDPosition)
    LocalByte2(_BCDZeros)
    LocalByte3(_prtBCD_Loop)        
    LocalBit0(F_PRTHeadZeros)
'#endIfMacro-

$define Print_BCDarray(pNumberArray,pLine,pPosition) _mPrint_BCDarray pNumberArray,pLine,pPosition
    
_mPrint_BCDarray Macro- pNumberArray,pLine,pPosition
    STARTSIZE(Print_BCDarray_MACRO)
    #if (Prm_Count > 3)
	   #error "_mPrint_BCDarray - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 3)
            #error "_mPrint_BCDarray - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mPrint_BCDarray - Number of Array(Param1) Should be a number8"
                Exitm
            #else
                #if (pNumberArray == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNumberArray == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNumberArray == 3)
                            Num_FSR0 BCDArray3
                        #else 
                            #if (pNumberArray == 4)
                                Num_FSR0 BCDArray4
                            #else 
                                #if (pNumberArray == 5)
                                    Num_FSR0 BCDArray5
                                #else 
                                    #if (pNumberArray == 6)
                                        Num_FSR0 BCDArray6
                                    #else 
                                        #if (pNumberArray == 7)
                                            Num_FSR0 BCDArray7
                                        #else 
                                            #if (pNumberArray == 8)
                                                Num_FSR0 BCDArray8
                                            #else 
                                                #error "_mPrint_BCDarray - Number Array(Param1) Should be a 1,2,3,4,5,6,7,8"
                                                Exitm
                                            #endif
                                        #endif
                                    #endif
                                #endif 
                            #endif
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Num8)
                #error "_mPrint_BCDarray Macro - Input LCD Line(Param2) Should be a Byte Or Num8"
                Exitm
            #else 
                #if (Prm_2 == Byte)
                    Byte_Byte pLine, _BCDLine
                #endif
                #if (Prm_2 == Num8)
                    Num_Byte pLine, _BCDLine
                #endif        
            #endif
            #if (Prm_3 != Byte) && (Prm_2 != Num8)
                #error "_mPrint_BCDarray Macro - Input LCD Position(Param3) Should be a Byte Or Num8"
                Exitm
            #else 
                #if (Prm_3 == Byte)
                    Byte_Byte pPosition, _BCDPosition
                #endif
                #if (Prm_3 == Num8)
                    Num_Byte pPosition, _BCDPosition
                #endif        
            #endif
        #endif
    #endif
    GoSub _mPrint_BCDarray_Sub
    ENDSIZE(Print_BCDarray_MACRO)
Endm    
    
#ifMacro- _mPrint_BCDarray    
_mPrint_BCDarray_Sub:    
    STARTSIZE(Print_BCDarray_LIB)
    _prtBCD_Loop = __VBCD_CounterLenght     '/ Load the lenght of array To Do Loop.  
    WREG = __VBCD_CounterLenght - 1         '/ Load the number of bytes to point the top address of the array.
    FSR0 = FSR0 + WREG                      '/ Array pointer to the top of the array and count down.
    _BCDZeros = _BCDPosition & $F0          '/ Extract the option to print all zeros before value.
    _BCDPosition = _BCDPosition & $0F       '/ Extract the true position of the character on LCD.
    Cursor _BCDLine,_BCDPosition
    F_PRTHeadZeros = 0
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        EEDATA = POSTDEC0 + "0"             '/ Convert BCD character to ASCII to save execution time.
        If _BCDZeros = 0 Then               '/ Option NO print zeros enabled?
            If _prtBCD_Loop = 1 Then
                F_PRTHeadZeros = 1          '/ Because the last number could be = 0.
            EndIf
            If F_PRTHeadZeros = 0 Then
                If EEDATA > "0" Then        '/ If Character = 0 then NO print.
                    Print EEDATA            '/ Send the ASCII character to the terminal
                    F_PRTHeadZeros = 1    
                EndIf
            Else
                Print EEDATA                '/ Send the ASCII character to the terminal
            EndIf
        Else
            Print EEDATA                    '/ Send the ASCII character to the terminal
        EndIf
        Dec _prtBCD_Loop
    Until _prtBCD_Loop = 0                  '/ Until all bytes out.
    Return
    ENDSIZE(Print_BCDarray_LIB)
#endIfMacro-
'/==============================================================================
'/ Addition the BCD counters.
'/ BCD_Array1 + BCD_Array2 = BCD_Array3
'/ The destination Array is always clear before addition.
'/ The error return_Variable is not mandatory
'/ 
'#ifMacro- _mAddBCDcounters
    LocalByte0(_adBCD_Loop)
'#endIfMacro-

'/              ARRAY first  + ARRAY second = ARRAY Result
$define ADD_BCD(pNumberArray1,pNumberArray2,pNumberArray3) _mAddBCDcounters pNumberArray1,pNumberArray2,pNumberArray3

_mAddBCDcounters Macro- pNumberArray1,pNumberArray2,pNumberArray3
    STARTSIZE(ADD_BCD_MACRO)
    #if (Prm_Count > 3)
	   #error "_mAddBCDcounters - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 3)
            #error "_mAddBCDcounters - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mAddBCDcounters - Number Array(Param1) Should be a number8"
                Exitm
            #else
                #if (pNumberArray1 == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNumberArray1 == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNumberArray1 == 3)
                            Num_FSR0 BCDArray3
                        #else 
                            #if (pNumberArray1 == 4)
                                Num_FSR0 BCDArray4
                            #else 
                                #error "_mAddBCDcounters - Number Array(Param1) Should be a 1,2,3 or 4"
                                Exitm
                            #endif 
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_2 != Num8)
                #error "_mAddBCDcounters - Number Array(Param2) Should be a number8"
                Exitm
            #else
                #if (pNumberArray2 == 1)
                    Num_FSR1 BCDArray1
                #else  
                    #if (pNumberArray2 == 2)
                        Num_FSR1 BCDArray2
                    #else 
                        #if (pNumberArray2 == 3)
                            Num_FSR1 BCDArray3
                        #else 
                            #if (pNumberArray2 == 4)
                                Num_FSR1 BCDArray4
                            #else 
                                #error "_mAddBCDcounters - Number Array(Param2) Should be a 1,2,3 or 4"
                                Exitm
                            #endif 
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_3 != Num8)
                #error "_mAddBCDcounters - Number Array(Param3) Should be a number8"
                Exitm
            #else            
                #if (pNumberArray3 == 1)
                    Num_FSR2 BCDArray1
                #else  
                    #if (pNumberArray3 == 2)
                        Num_FSR2 BCDArray2
                    #else 
                        #if (pNumberArray3 == 3)
                            Num_FSR2 BCDArray3
                        #else 
                            #if (pNumberArray3 == 4)
                                Num_FSR2 BCDArray4
                            #else 
                                #error "_mAddBCDcounters - Number Array(Param3) Should be a 1,2,3 or 4"
                                Exitm
                            #endif 
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif
    GoSub AddBCDcounters_Sub
    '/ The Return_Var for error is not mandatory!
    #if (_mAddBCDcounters_RETURN == 1)
        #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword)
            #error "_mAddBCDcounters - Return variable should be a Byte, Word or Dword"
            Exitm
        #else
            #if (Return_Type == Byte)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Endasm-
            #endif
            #if (Return_Type == Word)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Endasm-
            #endif
            #if (Return_Type == Dword)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Clrf  Return_Var +2
                Clrf  Return_Var +3                
                Endasm-
            #endif
        #endif
    #endif        
    ENDSIZE(ADD_BCD_MACRO)
Endm

#ifMacro- _mAddBCDcounters,_mMulVBCDcounters
AddBCDcounters_Sub:
    STARTSIZE(ADD_BCD_LIB)
    Save_FSR2 = FSR2               '/ Save FSR2 because is used for other calculations.

    '/ Clear the Result of destination Array. (DO NOT use the "Clear BCDArrayX" command)
    '/ The FSR2 is used for the destination Array.
    WREG = __VBCD_CounterLenght    '/ Load the number of bytes of the array.
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        POSTINC2 = 0               '/ Clear every byte of the array.
        Dec WREG
    Until WREG = 0    
    FSR2 = Save_FSR2               '/ Restore FSR2
    '/==========================================================================
    '/ Make addition.    
    _adBCD_Loop = 0
    F_ADDCarryFlag = 0
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        WREG = INDF0 + INDF1                '/ Sum all bytes.
        EEDATA = INDF2 + WREG
        If EEDATA > 9 Then                  '/ Check the carry
            POSTINC2 = EEDATA - 10          '/ Load the new LSB into result.
            F_ADDCarryFlag = 1              '/ Carry to add for the next byte.
        Else
            POSTINC2 = EEDATA               '/ Load the new LSB into Result Without carry.
        EndIf
        '/ Point to the next byte. FSR2 is incremented already.
        Inc FSR0
        Inc FSR1
        If F_ADDCarryFlag = 1 Then              '/ Is there a carry before? then...
            WREG = __VBCD_CounterLenght - 1     '/ Check if it is the last byte of the array.
            If WREG = _adBCD_Loop Then Break    '/ Last byte with Carry then exit = error.
            Inc INDF2                           '/ If not the last byte then 1 => Result.
            F_ADDCarryFlag = 0                  '/ Done
        EndIf
        Inc _adBCD_Loop
    Until _adBCD_Loop = __VBCD_CounterLenght
    '/==========================================================================
    '/ Pass an error to Return_Var. (This form is the less code)
    WREG = 0
    If F_ADDCarryFlag = 1 Then              
        WREG = 1                            '/ Counter overrun.
    EndIf
    Return
    ENDSIZE(ADD_BCD_LIB)
#endIfMacro-
'/==============================================================================
'/ Multiplication the BCD counters by a Variable (Byte/Word/Dword/Number).
'/ The destination Array (PRODUCT) is always clear before multiplication.
'/ The error Return_Variable is not mandatory

'/ Declare the local variables.
'#ifMacro- _mMulVBCDcounters
    LocalByte0(_mvBCD_Loop)
    LocalDword0(_mvDwordBCD_Loop)
    LocalDword1(_mvBCD_Multiplicand)
'#endIfMacro-

'/                MULTIPLIER      PRODUCT      MULTIPLICAND         
'/              ARRAY(1,2,3,4),ARRAY(1,2,3,4),Byte/Word/Dword 
$define MULV_BCD(pNbArrayInput,pNbArrayOutput,pMultiplicand) _mMulVBCDcounters pNbArrayInput,pNbArrayOutput,pMultiplicand

_mMulVBCDcounters Macro- pNbArrayInput,pNbArrayOutput,pMultiplicand
    STARTSIZE(MULV_BCD_MACRO)
    #if (Prm_Count > 3)
	   #error "_mMulVBCDcounters - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 3)
            #error "_mMulVBCDcounters - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mMulVBCDcounters - Number of Array(Param1) Should be a number8"
                Exitm
            #else
                #if (pNbArrayInput == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNbArrayInput == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNbArrayInput == 3)
                            Num_FSR0 BCDArray3
                        #else 
                            #if (pNbArrayInput == 4)
                                Num_FSR0 BCDArray4
                            #else 
                                #error "_mMulVBCDcounters - Number of Array(Param1) Should be a 1,2,3 or 4"
                                Exitm
                            #endif
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_2 != Num8)
                #error "_mMulVBCDcounters - Number of Array(Param2) Should be a number8"
                Exitm
            #else
                #if (pNbArrayOutput == 1)
                    Num_FSR2 BCDArray1
                #else  
                    #if (pNbArrayOutput == 2)
                        Num_FSR2 BCDArray2
                    #else 
                        #if (pNbArrayOutput == 3)
                            Num_FSR2 BCDArray3
                        #else 
                            #if (pNbArrayOutput == 4)
                                Num_FSR2 BCDArray4
                            #else 
                                #error "_mMulVBCDcounters - Number of Array(Param2) Should be a 1,2,3 or 4"
                                Exitm
                            #endif
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_3 != Byte) && (Prm_3 != Word) && (Prm_3 != Dword) && (Prm_3 != Num8) && (Prm_3 != Num16) && (Prm_3 != Num32)
                #error "_mMulVBCDcounters Macro - Multiplier(Param3) Should be a Byte, Word Variable Or Num8. Num16"
                Exitm
            #else
                #if (Prm_3 == Byte)
                    '/ Because to avoid the Bank.
                    Asm-
                    Clrf  _mvBCD_Multiplicand+3
                    Clrf  _mvBCD_Multiplicand+2                    
                    Clrf  _mvBCD_Multiplicand+1
                    Movff pMultiplicand,_mvBCD_Multiplicand
                    Endasm-
                #endif
                #if (Prm_3 == Word)
                    '/ Because to avoid the Bank.
                    Asm-
                    Clrf  _mvBCD_Multiplicand+3
                    Clrf  _mvBCD_Multiplicand+2                    
                    Movff pMultiplicand+1,_mvBCD_Multiplicand+1
                    Movff pMultiplicand,_mvBCD_Multiplicand
                    Endasm-
                #endif
                #if (Prm_3 == Dword)
                    Dword_Dword pMultiplicand,_mvBCD_Multiplicand
                #endif
                #if (Prm_3 == Num8)
                    '/ Because to avoid the Bank.
                    Asm-
                    Clrf  _mvBCD_Multiplicand+3
                    Clrf  _mvBCD_Multiplicand+2 
                    Clrf  _mvBCD_Multiplicand+1
                    Movlw pMultiplicand
                    Movff WREG,_mvBCD_Multiplicand  
                    Endasm-
                #endif
                #if (Prm_3 == Num16)
                    '/ Because to avoid the Bank.
                    Asm-
                    Movlw Low (pMultiplicand)
                    Movff WREG,_mvBCD_Multiplicand 
                    Movlw High (pMultiplicand)
                    Movff WREG,_mvBCD_Multiplicand+1
                    Clrf  _mvBCD_Multiplicand+2
                    Clrf  _mvBCD_Multiplicand+3 
                    Endasm-
                #endif
                #if (Prm_3 == Num32)
                    Num_Dword pMultiplicand,_mvBCD_Multiplicand
                #endif
            #endif
        #endif
    #endif
    GoSub MulVBCDcounters_Sub
    '/ The Return_Var for error is not mandatory!
    #if (_mMulVBCDcounters_RETURN == 1)
        #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword)
            #error "_mMulVBCDcounters - Return variable should be a Byte, Word or Dword"
            Exitm
        #else
            #if (Return_Type == Byte)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Endasm-
            #endif
            #if (Return_Type == Word)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Endasm-
            #endif
            #if (Return_Type == Dword)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Clrf  Return_Var +2
                Clrf  Return_Var +3                
                Endasm-
            #endif
        #endif
    #endif        
    ENDSIZE(MULV_BCD_MACRO)
Endm

#ifMacro- _mMulVBCDcounters
MulVBCDcounters_Sub:
    STARTSIZE(MULV_BCD_LIB)
    Save_FSR0 = FSR0               '/ Save FSR0 for the input array.
    Save_FSR2 = FSR2               '/ Save FSR2 For the output array.

    '/ Clear the Result of destination array. (DO NOT use the "Clear BCDcounterArrayX" command)
    '/ The FSR2 is used for the destination array.
    WREG = __VBCD_CounterLenght    '/ Load the number of bytes of the array.
    Repeat                          
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        POSTINC2 = 0               '/ Clear every byte of the array.
        Dec WREG
    Until WREG = 0    
    '/--------------------------------------------------------------------------
    '/ Make Multiplication.    
    _mvDwordBCD_Loop = 0
    F_MULCarryFlag = 0
    Repeat
        '/----------------------------------------------------------------------
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        '/ Restore Pointers in every addition.
        FSR0 = Save_FSR0               '/ Restore FSR0
        FSR2 = Save_FSR2               '/ Restore FSR2        
        '/ Make Addition.    
        _mvBCD_Loop = 0
        Repeat
            EEDATA = INDF0 + INDF2              '/ Sum input and result bytes. (Using EEDATA as temporal variable)
            If EEDATA > 9 Then                  '/ Check the carry
                POSTINC2 = EEDATA - 10          '/ Load the new LSB into result.
                F_MULCarryFlag = 1              '/ Carry to add for the next byte.
            Else
                POSTINC2 = EEDATA               '/ Load the new LSB into Result Without carry.
            EndIf
            '/ Point to the next byte. FSR2 is incremented already.
            Inc FSR0
            If F_MULCarryFlag = 1 Then                  '/ Is there a carry before? then...
                WREG = __VBCD_CounterLenght - 1         '/ Check if it is the last byte of the array.
                If WREG = _mvBCD_Loop Then MULVTIEXIT   '/ Last byte with Carry then exit.
                Inc INDF2                               '/ If not the last byte then 1 => Result.
                F_MULCarryFlag = 0                      '/ Done
            EndIf
            Inc _mvBCD_Loop
        Until _mvBCD_Loop = __VBCD_CounterLenght        
        '/----------------------------------------------------------------------
        '/ Make Multiplication.
        Inc _mvDwordBCD_Loop
    Until _mvDwordBCD_Loop = _mvBCD_Multiplicand
    '/--------------------------------------------------------------------------
MULVTIEXIT:
    '/ Pass an error to Return_Var. (This form is the less code)
    WREG = 0
    If F_MULCarryFlag = 1 Then              
        WREG = 1                            '/ Counter overrun.
    EndIf
    Return
    ENDSIZE(MULV_BCD_LIB)
#endIfMacro-
'/==============================================================================
'/ Multiplication the BCD counters by another array. (Array1, Array2, Array3, Array4)
'/ The result array is always clear before multiplication.
'/ The error return_Variable is not mandatory

'/ Declare the local variables.
'#ifMacro- _mMulABCDcounters
    LocalByte0(_maBCD_Loop1)
    LocalByte1(_maBCD_Loop2)
    LocalByte2(_maBCD_Loop3)
    LocalByte3(_maBCD_ShiftMultiplier)
    LocalWord0(_maShiftArrayPtr)
'#endIfMacro-
'/                MULTIPLIER     MULTIPLICAND     PRODUCT    
'/            ARRAY(1,2,3,4)  X ARRAY(1,2,3,4) = ARRAY(1,2,3,4) 
$define MUL_BCD(pNumberArray1,pNumberArray2,pNumberArray3) _mMulABCDcounters pNumberArray1,pNumberArray2,pNumberArray3

_mMulABCDcounters Macro- pNumberArray1,pNumberArray2,pNumberArray3
    STARTSIZE(MUL_BCD_MACRO)
    #if (Prm_Count > 3)
	   #error "_mMulABCDcounters - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 3)
            #error "_mMulABCDcounters - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mMulABCDcounters - Number Array(Param1) Should be a number8"
                Exitm
            #else
                #if (pNumberArray1 == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNumberArray1 == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNumberArray1 == 3)
                            Num_FSR0 BCDArray3
                        #else 
                            #if (pNumberArray1 == 4)
                                Num_FSR0 BCDArray4
                             #else 
                                #error "_mMulABCDcounters - Number Array(Param1) Should be a 1, 2, 3 or 4"
                                Exitm
                            #endif
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_2 != Num8)
                #error "_mMulABCDcounters - Number Array(Param2) Should be a number8"
                Exitm
            #else
                #if (pNumberArray2 == 1)
                    Num_FSR1 BCDArray1
                #else  
                    #if (pNumberArray2 == 2)
                        Num_FSR1 BCDArray2
                    #else 
                        #if (pNumberArray2 == 3)
                            Num_FSR1 BCDArray3
                        #else 
                            #if (pNumberArray2 == 4)
                                Num_FSR1 BCDArray4
                            #else 
                                #error "_mMulBBCDcounters - Number Arry(Param1) Should be a 1, 2, 3 or 4"
                                Exitm
                            #endif
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_3 != Num8)
                #error "_mMulABCDcounters - Number Array(Param3) Should be a number8"
                Exitm
            #else
                #if (pNumberArray3 == 1)
                    Num_FSR2 BCDArray1
                #else  
                    #if (pNumberArray3 == 2)
                        Num_FSR2 BCDArray2
                    #else 
                        #if (pNumberArray3 == 3)
                            Num_FSR2 BCDArray3
                        #else 
                            #if (pNumberArray3 == 4)
                                Num_FSR2 BCDArray4
                            #else 
                                #error "_mMulABCDcounters - Number Arry(Param1) Should be a 1, 2, 3 or 4"
                                Exitm
                            #endif
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif
    GoSub _mMulABCDcounters_Sub
    '/ The Return_Var for error is not mandatory!
    #if (_mMulABCDcounters_RETURN == 1)
        #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword)
            #error "_mMulABCDcounters - Return variable should be a Byte, Word or Dword"
            Exitm
        #else
            #if (Return_Type == Byte)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Endasm-
            #endif
            #if (Return_Type == Word)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Endasm-
            #endif
            #if (Return_Type == Dword)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Clrf  Return_Var +2
                Clrf  Return_Var +3                
                Endasm-
            #endif
        #endif
    #endif        
    ENDSIZE(MUL_BCD_MACRO)
Endm

#ifMacro- _mMulABCDcounters
_mMulABCDcounters_Sub:
    STARTSIZE(MUL_BCD_LIB)
    '/    FSR0    X    FSR1      =  FSR2
    '/ MULTIPLIER X MULTIPLICAND = PRODUCT
    '/ MULTIPLIER   => FSR0
    '/ MULTIPLICAND => FSR1
    '/ PRODUCT      => FSR2
 
    Save_FSR0 = FSR0    '/ Save FSR0 for the MULTIPLIER.
    Save_FSR1 = FSR1    '/ Save FSR1 for the MULTIPLICAND.
    Save_FSR2 = FSR2    '/ Save FSR2 For the PRODUCT.

    '/ Create the shift array pointer.
    '/ Acces constant "__VBCD_CounterLenght" by assembler MACRO because it is not possible with Basic PDS.
    WREG = __VBCD_CounterLenght - 2     '/ Load the number of bytes to point the top address - 2 of the array.
    _maShiftArrayPtr = FSR0 + WREG      '/ Array pointer to the top of the array to count down.

    '/ Save the MULTIPLIER before to use because it will be destroyed.
    FSR1 = VarPtr(BCDArray5)      '/ Array nb 5 to copy.
    WREG = __VBCD_CounterLenght
    Repeat
        POSTINC1 = POSTINC0
        Dec WREG 
    Until WREG = 0             
    '/ It is not necessary restore FSR1 now.

    '/ Clear the Result destination Array first. (DO NOT use the "Clear BCDcounterArrayX" command)
    '/ Acces constant "__VBCD_CounterLenght" by assembler MACRO because it is not possible with Basic PDS.
'    Num_Byte __VBCD_CounterLenght,_BCD_CounterLenght
    FSR2 = Save_FSR2
    WREG = __VBCD_CounterLenght
    Repeat                          
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        POSTINC2 = 0              '/ Clear every byte of the PRODUCT array.
        Dec WREG
    Until WREG = 0    
    '/ It is not necessary restore FSR2 now.

    '/==========================================================================
    '/ Start to count.
    '/ The FSR1 is pointing to the MULTIPLICAND already.
    FSR1 = Save_FSR1        '/ Restore FSR1 For the MULTIPLICAND.
    F_MULCarryFlag = 0
    _maBCD_Loop3 = 0
START_MULTA:
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        '/ Check the MULTIPLICAND
        _maBCD_ShiftMultiplier = POSTINC1   '/ Extract the MULTIPLICAND of the array and increment the position. 
        If _maBCD_ShiftMultiplier = 0 Then  '/ If MULTIPLICAND = 0 then do not count.
            GoTo MULAEXIT1                  '/ Shift counting.
        EndIf
        '/====================================================================== 
        '/ Make multiplication. (by additions)
        _maBCD_Loop2 = 0
        Repeat
            '/xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
            '/ Restore Pointers for every addition.
            FSR0 = Save_FSR0               '/ Restore FSR0
            FSR2 = Save_FSR2               '/ Restore FSR2        
            '/ Make Addition for all bytes of the array.    
            _maBCD_Loop1 = 0
            Repeat
                EEDATA = INDF0 + INDF2              '/ Sum input and result bytes. (Using EEDATA as temporal variable)
                If EEDATA > 9 Then                  '/ Check the carry
                    POSTINC2 = EEDATA - 10          '/ Load the new LSB into result.
                    F_MULCarryFlag = 1              '/ Carry to add for the next byte.
                Else
                    POSTINC2 = EEDATA               '/ Load the new LSB into Result Without carry.
                EndIf
                '/ Point to the next byte. FSR2 is incremented already.
                Inc FSR0
                If F_MULCarryFlag = 1 Then                  '/ Is there a carry before? then...
                    WREG = __VBCD_CounterLenght - 1         '/ Check if it is the last byte of the array.
                    If WREG = _maBCD_Loop1 Then MULAEXIT2   '/ Last byte with Carry then exit.
                    Inc INDF2                               '/ If not the last byte then 1 => Result.
                    F_MULCarryFlag = 0                      '/ Done
                EndIf
                Inc _maBCD_Loop1
            Until _maBCD_Loop1 = __VBCD_CounterLenght        
            '/xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
            Inc _maBCD_Loop2                             '/ Increment the byte in the array.
        Until _maBCD_Loop2 = _maBCD_ShiftMultiplier
        '/======================================================================
MULAEXIT1:
        '/ Multiplier = Multiplier x 10
        '/ Shift the MULTIPLIER array 1 byte to the left. (X10 the value each time)
        '/ Very fast to shift the BCD array.
        FSR0 = _maShiftArrayPtr  '/ Point to the top - 2 of the array.
        _maBCD_Loop1 = 0
        Repeat
            #ifdef Watchdog_req
            Clrwdt
            #endif
            PRODL = POSTINC0    '/ Copy the current value and prepare the position to save it.
            POSTDEC0 = PRODL    '/ And Restore it to the position + 1 (left) and come back the pointer.
            Dec FSR0            '/ See next byte.
            Inc _maBCD_Loop1
        Until _maBCD_Loop1 = __VBCD_CounterLenght  '/  Make all bytes of the array. 
        FSR0 = Save_FSR0
        INDF0 = 0               '/ Load a 0 to the new byte from the right.
        '/======================================================================
        '/ Next byte of the multiplicand.
        Inc _maBCD_Loop3
    Until _maBCD_Loop3 = __VBCD_CounterLenght
    '/==========================================================================
MULAEXIT2:
    '/ Restore the MULTIPLIER because it is destroyed.
    FSR1 = VarPtr(BCDArray5)
    FSR0 = Save_FSR0        '/ Restore FSR0
    WREG = __VBCD_CounterLenght
    Repeat
        POSTINC0 = POSTINC1
        Dec WREG 
    Until WREG = 0             

    '/ Pass an error to Return_Var. (This form is the less code)
    WREG = 0
    If F_MULCarryFlag = 1 Then              
        WREG = 1                            '/ Counter overrun.
    EndIf
    Return
    ENDSIZE(MUL_BCD_LIB)
#endIfMacro-
'/==============================================================================
'/ Subtraction the BCD counters. Choose the arrays: 1,2,3,4
'/ e.g. BCD_Array1 - BCD_Array2 = BCD_Array3
'/ The destination Array is always clear before Subtraction.
'/ BCDArray5 is used for Save/Restore arrays only.
'/ The error return_Variable is not mandatory
'/ 
'#ifMacro- _mSUBBCDcounters
    LocalByte0(_suBCD_Loop)
'#endIfMacro-

'/               ARRAY nb 1  - ARRAY nb 2  = ARRAY nb 3
'/               MINUEND     -  SUBTRACT   = DIFFERENCE
$define SUB_BCD(pNumberArray1,pNumberArray2,pNumberArray3) _mSUBBCDcounters pNumberArray1,pNumberArray2,pNumberArray3

_mSUBBCDcounters Macro- pNumberArray1,pNumberArray2,pNumberArray3
    STARTSIZE(SUB_BCD_MACRO)
    #if (Prm_Count > 3)
	   #error "_mSUBBCDcounters - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 3)
            #error "_mSUBBCDcounters - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mSUBBCDcounters - Number Array(Param1) Should be a number8"
                Exitm
            #else
                #if (pNumberArray1 == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNumberArray1 == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNumberArray1 == 3)
                            Num_FSR0 BCDArray3
                        #else 
                            #if (pNumberArray1 == 4)
                                Num_FSR0 BCDArray4
                            #else 
                                #error "_mSUBBCDcounters - Number Array(Param1) Should be a 1, 2, 3 or 4"
                                Exitm
                            #endif 
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_2 != Num8)
                #error "_mSUBBCDcounters - Number Array(Param2) Should be a number8"
                Exitm
            #else
                #if (pNumberArray2 == 1)
                    Num_FSR1 BCDArray1
                #else  
                    #if (pNumberArray2 == 2)
                        Num_FSR1 BCDArray2
                    #else 
                        #if (pNumberArray2 == 3)
                            Num_FSR1 BCDArray3
                        #else 
                            #if (pNumberArray2 == 4)
                                Num_FSR1 BCDArray4
                            #else 
                                #error "_mSUBBCDcounters - Number Array(Param2) Should be a 1, 2, 3 Or 4"
                                Exitm
                            #endif 
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_3 != Num8)
                #error "_mSUBBCDcounters - Number Array(Param3) Should be a number8"
                Exitm
            #else            
                #if (pNumberArray3 == 1)
                    Num_FSR2 BCDArray1
                #else  
                    #if (pNumberArray3 == 2)
                        Num_FSR2 BCDArray2
                    #else 
                        #if (pNumberArray3 == 3)
                            Num_FSR2 BCDArray3
                        #else 
                            #if (pNumberArray3 == 4)
                                Num_FSR2 BCDArray4
                            #else 
                                #error "_mSUBBCDcounters - Number Array(Param3) Should be a 1, 2, 3 Or 4"
                                Exitm
                            #endif 
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif
    GoSub SUBBCDcounters_Sub
    '/ The Return_Var for error is not mandatory!
    #if (_mSUBBCDcounters_RETURN == 1)
        #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword)
            #error "_mSUBBCDcounters - Return variable should be a Byte, Word or Dword"
            Exitm
        #else
            #if (Return_Type == Byte)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Endasm-
            #endif
            #if (Return_Type == Word)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Endasm-
            #endif
            #if (Return_Type == Dword)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Clrf  Return_Var +2
                Clrf  Return_Var +3                
                Endasm-
            #endif
        #endif
    #endif        
    ENDSIZE(SUB_BCD_MACRO)
Endm

#ifMacro- _mSUBBCDcounters
SUBBCDcounters_Sub:
    STARTSIZE(SUB_BCD_LIB)
    '/ Clear the Result of ArrayX pointed by FSR2. (DO NOT use the "Clear BCDArray3" command)
    '/ The FSR2 is used for the destination Array.
    Save_FSR1 = FSR1               '/ Save FSR1 because it is used for other calculations.
    Save_FSR2 = FSR2               '/ Save FSR2 because it is used for other calculations.

    '/ Acces constant "__VBCD_CounterLenght" by assembler because it is not possible in Basic PDS.
'    Num_Byte __VBCD_CounterLenght, _BCD_CounterLenght   ' Constant => Byte variable.
    WREG = __VBCD_CounterLenght
    '/ Using FSR2.
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        POSTINC2 = 0               '/ Clear every byte of the array.
        Dec WREG
    Until WREG = 0    
    '/ Restore FSR2 (not necessary)

    '/ Save the MINUEND (in FSR1) because it will be destroyed.
    FSR2 = VarPtr(BCDArray5)       '/ Point to Array nb 5 to copy.
    WREG = __VBCD_CounterLenght
    Repeat
        POSTINC2 = POSTINC1
        Dec WREG 
    Until WREG = 0             
    FSR1 = Save_FSR1        '/ Restore FSR1
    FSR2 = Save_FSR2        '/ Restore FSR2

    '/==========================================================================
    '/ Make Subtraction.    
    _suBCD_Loop = 0
    F_SUBCarryFlag = 0
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        If INDF1 > INDF0 Then           '/ Check if the second number is >.
            PRODL = INDF0 + 10          '/ Then sum 10 at the first number.
            POSTINC2 = PRODL - INDF1
            F_SUBCarryFlag = 1          '/ Then sum 10 from the next byte INDF1.
        Else
            POSTINC2 = INDF0 - INDF1        
        EndIf
        Inc FSR0
        Inc FSR1
        '/ The FSR2 is incremented already. (code more faster)
        If F_SUBCarryFlag = 1 Then            '/ Check the carry
            WREG = __VBCD_CounterLenght - 1   '/ Check if it is the last byte of the array.
            If WREG = _suBCD_Loop Then Break  '/ Last byte with Carry then exit.
            Inc INDF1
            F_SUBCarryFlag = 0
        EndIf
        Inc _suBCD_Loop
    Until _suBCD_Loop = __VBCD_CounterLenght
    '/==========================================================================
    '/ Restore the MINUEND because it is destroyed.
    FSR1 = Save_FSR1 
    FSR2 = VarPtr(BCDArray5)      '/ From copy Array nb 5.
    WREG = __VBCD_CounterLenght
    Repeat
        POSTINC1 = POSTINC2
        Dec WREG 
    Until WREG = 0             

    '/ Pass an error to Return_Var. (This form is the less code)
    WREG = 0
    If F_SUBCarryFlag = 1 Then              
        WREG = 1                            '/ Counter overrun (negative number) The result is not valid.
    EndIf
    Return
    ENDSIZE(SUB_BCD_LIB)
#endIfMacro-
'/==============================================================================
'/ Division of the integer BCD counters for very large numbers.
'/ Syntax:
'/ ErrorByte = DIVX_BCD(pNumberArray1,pNumberArray2,pNumberArray3)
'/ pNumberArray1 = Number of array for the Dividend. (nb1 to nb4)
'/ pNumberArray2 = Number of array for the Divisor. (nb1 To nb4)
'/ pNumberArray3 = Number of array for the Quotient. (nb1 To nb4)
'/ BCDArray3 = Array to return the Remainder.
'/
'/ The Divisor & Dividend Arrays are always copy before counting.
'/ The error Return_Variable is not mandatory

'/ Declare the local variables. (System Variables)
'#ifMacro- _mDivXBCDcounters
    Dim F_DIVXCarryFlag As Bit
    LocalByte0(_xDividendLenght)
    LocalByte1(_xDivisorLenght)    
    LocalByte2(_dvxBCD_Loop)   
    LocalByte3(_xPosToExtractDividend) 
    LocalByte4(_BCDQuotientX)
'    LocalByte5(_DividendData)

    LocalWord0(Save_FSR0X)
    LocalWord1(Save_FSR1X)
    LocalWord2(_aDividendHighPtr)
    LocalWord3(_aDivisorHighPtr)
    LocalWord4(_xDividendHighPtr)
    LocalWord5(_xDivisorHighPtr)
    LocalWord6(_ShiftQuotientPtr)    
    LocalWord7(_ShiftDividendPtr)
'#endIfMacro-

'/ Prm1 = Dividend  (Array nb1 or nb2 or nb3)
'/ Prm2 = Divisor   (Array nb2 Or nb2 Or nb3)
'/ Prm3 = Quotient  (Array nb3 Or nb2 Or nb1)
'/        Remainder (Array nb4)        
'/                   Dividend = 1 / Divisor = 2 = Quotient => Remainder = 4
'/
'/                  (Prm1)    /   (Prm2)    =   (Prm3)
$define DIV_BCD(pNumberArray1,pNumberArray2,pNumberArray3) _mDivXBCDcounters pNumberArray1,pNumberArray2,pNumberArray3

_mDivXBCDcounters Macro- pNumberArray1,pNumberArray2,pNumberArray3
    STARTSIZE(DIV_BCD_MACRO)
    #if (Prm_Count > 3)
	   #error "_mDivXBCDcounters - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 3)
            #error "_mDivXBCDcounters - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mDivXBCDcounters - Number Array(Param1) Should be a number8"
                Exitm
            #else
                #if (pNumberArray1 == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNumberArray1 == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNumberArray1 == 3)
                            Num_FSR0 BCDArray3
                        #else 
                            #if (pNumberArray1 == 4)
                                Num_FSR0 BCDArray4
                            #else 
                                #error "_mDivXBCDcounters - Number Array(Param1) Should be a 1,2,3,4"
                                Exitm
                            #endif 
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_2 != Num8)
                #error "_mDivXBCDcounters - Number Array(Param2) Should be a number8"
                Exitm
            #else
                #if (pNumberArray2 == 1)
                    Num_FSR1 BCDArray1
                #else  
                    #if (pNumberArray2 == 2)
                        Num_FSR1 BCDArray2
                    #else 
                        #if (pNumberArray2 == 3)
                            Num_FSR1 BCDArray3
                        #else 
                            #if (pNumberArray2 == 4)
                                Num_FSR1 BCDArray4
                            #else 
                                #error "_mDivXBCDcounters - Number Array(Param2) Should be a 1,2,3,4"
                                Exitm
                            #endif 
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_3 != Num8)
                #error "_mDivXBCDcounters - Number Array(Param3) Should be a number8"
                Exitm
            #else            
                #if (pNumberArray3 == 1)
                    Num_FSR2 BCDArray1
                #else  
                    #if (pNumberArray3 == 2)
                        Num_FSR2 BCDArray2
                    #else 
                        #if (pNumberArray3 == 3)
                            Num_FSR2 BCDArray3
                        #else 
                            #if (pNumberArray3 == 4)
                                Num_FSR2 BCDArray4
                            #else 
                                #error "_mDivXBCDcounters - Number Array(Param3) Should be a 1,2,3,4"
                                Exitm
                            #endif 
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif
    GoSub DivXBCDcounters_Sub
    '/ The Return_Var for error is not mandatory!
    #if (_mDivXBCDcounters_RETURN == 1)
        #if (Return_Type != Byte) && (Return_Type != Word)
            #error "_mDivXBCDcounters - Return variable should be a Byte, Word"
            Exitm
        #else
            #if (Return_Type == Byte)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Endasm-
            #endif
            #if (Return_Type == Word)
                '/ Because to avoid the Bank.
                Asm-
                Movff WREG,Return_Var
                Clrf  Return_Var +1
                Endasm-
            #endif
        #endif
    #endif        
    ENDSIZE(DIV_BCD_MACRO)
Endm

#ifMacro- _mDivXBCDcounters
DivXBCDcounters_Sub:
    STARTSIZE(DIV_BCD_LIB)
    '/ DIVIDEND 1st level => FSR0
    '/ DIVISOR  1st level => FSR1
    '/ QUOTIENT 1st level => FSR2
    #ifdef WatchDog_Req
    Clrwdt
    #endif

    Save_FSR0 = FSR0                '/ Save FSR0 for the Dividend array 1st level.
    Save_FSR1 = FSR1                '/ Save FSR1 for the Divisor array 1st level.
    Save_FSR2 = FSR2                '/ Save FSR2 for the Quotient output 1st level.
    Save_FSR0X = VarPtr(BCDArray5)  '/ Save FSR0 For the DIVIDEND 2nd level
    Save_FSR1X = VarPtr(BCDArray6)  '/ Save FSR1 For the DIVISOR 2nd level 
    '/--------------------------------------------------------------------------
    '/ Arrays of first level.
    WREG = __VBCD_CounterLenght - 1    '/ Load the number of bytes to point the top address of the array.
    _aDividendHighPtr = FSR0 + WREG    '/ Array pointer to the top of the array to count down.
    WREG = __VBCD_CounterLenght - 1    '/ Load the number of bytes to point the top address of the array.
    _aDivisorHighPtr = FSR1 + WREG     '/ Array pointer to the top of the array to count down.  
    WREG = __VBCD_CounterLenght - 1    '/ Load the number of bytes to point the top address of the array.
'    _aQuotientHighPtr = FSR2 + WREG    '/ Array pointer to the top of the array to count down. 

    '/ Calculate pointer to shift the quotient (1st level).
'    FSR2 = Save_FSR2
    WREG = __VBCD_CounterLenght - 2
    _ShiftQuotientPtr = FSR2 + WREG
    '/--------------------------------------------------------------------------
    '/ Calculate Pointers for Arrays of second level.
    WREG = __VBCD_CounterLenght - 1         '/ Load the number of bytes to point the top address of the array.
    _xDividendHighPtr = Save_FSR0X + WREG   '/ Array pointer to the top of the array to count down.
    WREG = __VBCD_CounterLenght - 1         '/ Load the number of bytes to point the top address of the array.
    _xDivisorHighPtr = Save_FSR1X + WREG    '/ Array pointer to the top of the array to count down. 

    '/ Calculate pointer to shift the dividend (2nd level).
    _ShiftDividendPtr = VarPtr(BCDArray5)
    WREG = __VBCD_CounterLenght - 2
    _ShiftDividendPtr = _ShiftDividendPtr + WREG

    '/--------------------------------------------------------------------------
    '/ Clear the Quotient ? (1st level) (FSR2) before to count.
    FSR2 = Save_FSR2
    WREG = __VBCD_CounterLenght
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        POSTINC2 = 0
        Dec WREG
    Until WREG = 0   
    '/--------------------------------------------------------------------------
    '/ Calculate the lenght of DIVISOR (1st level).
    FSR1 = _aDivisorHighPtr
    _xDivisorLenght = __VBCD_CounterLenght
    Repeat
        WREG = POSTDEC1
        If WREG > 0 Then
            Break
        EndIf
        Dec _xDivisorLenght
    Until _xDivisorLenght = 0

    '/ Calculate the lenght of DIVIDEND (1st level).
    FSR0 = _aDividendHighPtr
    _xDividendLenght = __VBCD_CounterLenght
    Repeat
        WREG = POSTDEC0
        If WREG > 0 Then
            Break
        EndIf
        Dec _xDividendLenght
    Until _xDividendLenght = 0
    '/--------------------------------------------------------------------------
    '/ Check if Divisor lenght > Dividend lenght?
    If _xDivisorLenght > _xDividendLenght Then
        F_DIVXCarryFlag = 1     '/ Generate an error.
        GoTo DIVX_EXIT22
    EndIf
    '/--------------------------------------------------------------------------
    '/ Calculate the pointer to extract the next number of the dividend
    _xPosToExtractDividend = _xDividendLenght - _xDivisorLenght
    '/--------------------------------------------------------------------------
    '/ Copy the divisor ? (1st level) (FSR1)
    '/ To (BCDArray6) (2nd level) for calculations. 
    '/ To (BCDArray8) (2nd level) for copy.
    FSR1 = Save_FSR1             '/ DIVISOR 1st level (origin).
    FSR2 = VarPtr(BCDArray6)     '/ Copy to DIVISOR 2nd level.
    FSR0 = VarPtr(BCDArray8)     '/ Copy to Array8 2nd level.
    PRODL = __VBCD_CounterLenght '/ Lenght of arrays.
    Repeat                          
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        WREG = POSTINC1         '/ From Array FRS1 + Inc FSR1
        POSTINC2 = WREG         '/ To Array FRS2 + Inc FSR2
        POSTINC0 = WREG         '/ To Array FRS0 + Inc FSR0   
        Dec PRODL
    Until PRODL = 0  
    '/--------------------------------------------------------------------------
    '/ Clear the Dividend (2nd level) before to load a number.
    FSR2 = VarPtr(BCDArray5)
    WREG = __VBCD_CounterLenght
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        POSTINC2 = 0
        Dec WREG
    Until WREG = 0   

    '/ Extract the left bytes of dividend (1st level) & copy To the new dividend (2nd level).
    '/ Point to the 1st number from the left of the Dividend.
    '/ Point to the dividend ? (1st level)
    WREG = _xDividendLenght - 1
    FSR0 = Save_FSR0 + WREG      
    '/ Point to the new dividend (2nd level)
    FSR2 = VarPtr(BCDArray5)    
    WREG = _xDivisorLenght - 1
    FSR2 = FSR2 + WREG
    '/ Copy N bytes (Divisor lenght) from the dividend (1st level) to the dividend (2nd level)
    WREG = _xDivisorLenght
    Repeat                          
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        POSTDEC2 = POSTDEC0
        Dec WREG
    Until WREG = 0  
'/%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
START_DIVX:
    '/==========================================================================
    '/==========================================================================
    '/ Make all Divisions.    
    _BCDQuotientX = 0   '/ Variable Byte for Quotient.
    F_DIVXCarryFlag = 0 '/ Reset error flag.
DIVX_LOOP:
    '/##########################################################################
    '/ Checking if Dividend < Divisor.  Compare 2 arrays.
    FSR0 = _xDividendHighPtr     '/ Restore Pointer To count down the divisor array.
    FSR1 = _xDivisorHighPtr      '/ Restore Pointer To count down the remainder array.                
    PRODH = __VBCD_CounterLenght
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        If INDF0 <> INDF1 Then
            If INDF0 < INDF1 Then   '/ If the Dividend < remainder?
                _BCDQuotientX = 0   '/ Can't be divided then Insert a quotient null to the array.
                GoTo DIVX_EXIT      '/ Don't make division but generate new parameters.
            Else
                Break               '/ Good, The Dividend part is > divisor to divide it.
            EndIf    
        EndIf
        Dec FSR0
        Dec FSR1
        Dec PRODH
    Until PRODH = 0   
    '/==========================================================================
    Do  '/ Make a division.
        '/======================================================================
        '/----------------------------------------------------------------------
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        '/ Always Restore Pointers.
        FSR0 = Save_FSR0X       '/ Restore FSR0 for DIVIDEND. (BCDArray5)
        FSR1 = Save_FSR1X       '/ Restore FSR1 for DIVISOR.  (BCDArray6)
        '/ Make Subtraction.    
        _dvxBCD_Loop = 0        '/ Number of bytes to count.
        Repeat
            If INDF1 > INDF0 Then           '/ Check if the second number is >.
                PRODL = INDF0 + 10          '/ Then sum 10 at the first number.
                EEDATA = PRODL - INDF1      '/ Save the remainder.
                F_SUBCarryFlag = 1          '/ Then sum 10 from the next byte INDF1.
            Else
                EEDATA = INDF0 - INDF1      '/ Save the remainder.  
            EndIf
            POSTINC0 = EEDATA               '/ Reload the Dividend with the remainder after calculation.
            '/ FSR0 is indremented already.
            Inc FSR1                        '/ Goto the next byte.
            If F_SUBCarryFlag = 1 Then                  '/ Check the carry
'/                WREG = _BCD_CounterLenght - 1           '/ Check if it is the last byte of the array.
'/                If WREG = _dvxBCD_Loop Then DIVX_EXIT22 '/ Last byte with Carry then exit. (error)
                Inc INDF1
                F_SUBCarryFlag = 0
            EndIf
            Inc _dvxBCD_Loop
        Until _dvxBCD_Loop = __VBCD_CounterLenght       
        '/----------------------------------------------------------------------
        Inc _BCDQuotientX               '/ QUOTIENT to Byte variable (BCD 0 to 9).

        '/ Restore the divisor (FSR1) again for next subtraction.
        '/ Because the divisor is destroyed after every subtraction.         
        FSR2 = VarPtr(BCDArray8)        '/ Divisor copy in BCDArray8.
        FSR1 = VarPtr(BCDArray6)        '/ Restore To Old destroyed divisor BCDArray6.
        WREG = __VBCD_CounterLenght     '/ Loading to WREG the number of bytes to copy.
        Repeat                          
            #ifdef WatchDog_Req
            Clrwdt
            #endif
            POSTINC1 = POSTINC2         '/ Restore the divisor.
            Dec WREG
        Until WREG = 0

        '/ Checking the partial division count (2nd level). Compare the 2 arrays.
        FSR0 = _xDividendHighPtr     '/ Restore Pointer To count down the divisor array.
        FSR1 = _xDivisorHighPtr      '/ Restore Pointer To count down the remainder array.                
        _dvxBCD_Loop = __VBCD_CounterLenght
        Repeat
            #ifdef WatchDog_Req
            Clrwdt
            #endif
            If INDF0 <> INDF1 Then
                If INDF0 < INDF1 Then       '/ If the Dividend < remainder?
                    If _xPosToExtractDividend > 0 Then
                        GoTo DIVX_EXIT      '/ YES, Final partial count then exit.
                    Else
                        '/ No more numbers to divide.
                        GoSub LoadNewQuotient_Sub   '/ Load the last quotient. (_BCDQuotientX)
                        GoTo DIVX_EXIT22            '/ END ROUTINE.
                    EndIf
                Else
                    GoTo DIVX_LOOP      '/ Dividend > remainder Then divide again.
                EndIf    
            EndIf
            Dec FSR0                    '/ Move pointers to next byte.
            Dec FSR1
            Dec _dvxBCD_Loop
        Until _dvxBCD_Loop = 0          '/ Until all bytes are checked. 
    Loop    '/ Infinite Loop.
    '/==========================================================================
DIVX_EXIT:
'/%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'/
    GoSub LoadNewQuotient_Sub   '/ Load the New quotient. (_BCDQuotientX)

    '/ Check if there is a new dividend (byte) to extract.
    If _xPosToExtractDividend > 0 Then
        Dec _xPosToExtractDividend      '/ Move the pointer to the right of dividend.
    Else
        GoTo DIVX_EXIT22                '/ Division finished.
    EndIf
    '/ Extract the next byte from the Dividend 1st level.
    FSR0 = Save_FSR0 + _xPosToExtractDividend
'    _DividendData = INDF0
    PRODH = INDF0       '/ Transfer data to next routine.

    '/ Shift the array Dividend (2nd level)(Remainder), 1 byte to the the left to insert the new dividend byte. (X10 the value each time)
    '/ The last value, at the left position of the array, is lost.
    '/ The new dividend byte is written to the position 0 of the array.
    FSR0 = _ShiftDividendPtr
    _dvxBCD_Loop = 0
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        EEDATA = POSTINC0    '/ Copy the current value and prepare the position to save it.
        POSTDEC0 = EEDATA    '/ And Restore it to the position + 1 (left) and come back the pointer.
        Dec FSR0             '/ See next byte.
        Inc _dvxBCD_Loop
    Until _dvxBCD_Loop = __VBCD_CounterLenght   '/ Shift all bytes of the array.
'    BCDArray5#0 = _DividendData                 '/ Load the new dividend (Byte) to position zero of the array.         
    BCDArray5#0 = PRODH                         '/ Load the new dividend (Byte) to position zero of the array.

    _BCDQuotientX = 0       '/ Clear quotient for next division.
    GoTo DIVX_LOOP          '/ Make division again.
    '/##########################################################################
DIVX_EXIT22:
    '/ Send an error to Return_Var. (This form is the less code)
    WREG = 0
    If F_DIVXCarryFlag = 1 Then              
        WREG = 1                    '/ Counter overflow.
    EndIf
    Return
'/$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'/ Subroutines for calculations.
LoadNewQuotient_Sub:
    '/ Load the New quotient. (First level) (_BCDQuotientX)
    '/ Shift the array quotient 1 byte to the the left. (X10 the value each time)
    '/ The value at the left position of the array, is lost.
    FSR2 = _ShiftQuotientPtr 
    _dvxBCD_Loop = 0
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        PRODL = POSTINC2    '/ Copy the current value and prepare the position to save it.
        POSTDEC2 = PRODL    '/ And Restore it to the position + 1 (left) and come back the pointer.
        Dec FSR2            '/ See next byte.
        Inc _dvxBCD_Loop
    Until _dvxBCD_Loop = __VBCD_CounterLenght  '/  Shift all bytes of the array.
    FSR2 = Save_FSR2        '/ Load pointer in position 0 of the Quotient array?.
    INDF2 = _BCDQuotientX   '/ Write the quotient (Byte).
    Return
    ENDSIZE(DIV_BCD_LIB)
#endIfMacro-
'/******************************************************************************
'/******************************************************************************
'/ Convert a Byte/Word/Dword/any Number to an BCD array.
'/ This command is very hungry of code, using the Dig command.
'/
'#ifMacro- _mSTR_BCDArray
    LocalByte0(_srBCD_Loop)
    LocalDword0(_srTempDwordBCD)
'#endIfMacro 

$define STR_BCDArray(pNumberArray, pValueIn) _mSTR_BCDArray pNumberArray, pValueIn
    
_mSTR_BCDArray Macro- pNumberArray, pValueIn
    STARTSIZE(STR_BCDArray_MACRO)
    #if (Prm_Count > 2)
	   #error "_mSTR_BCDArray - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mSTR_BCDArray - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mSTR_BCDArray - Number of Array(Param1) Should be a number8"
                Exitm
            #else
                #if (pNumberArray == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNumberArray == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNumberArray == 3)
                            Num_FSR0 BCDArray3
                        #else 
                            #if (pNumberArray == 4)
                                Num_FSR0 BCDArray4
                            #else 
                                #if (pNumberArray == 5)
                                    Num_FSR0 BCDArray5
                                #else 
                                    #error "_mSTR_BCDArray - Number Array(Param1) Should be a 1,2,3,4,5"
                                    Exitm
                                #endif 
                            #endif
                        #endif
                    #endif
                #endif
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Word)  && (Prm_2 != Dword) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
                #error "_mSTR_BCDArray - Input Variable(Param2) Should be a Byte, Word, Dword or a Number" 
                Exitm
            #else
                #if (Prm_2 == Dword)            
                    #if __VBCD_CounterLenght > 9
                    Dword_Dword pValueIn,_srTempDwordBCD
                    #else
                        #error "_mSTR_BCDArray - Input Variable(Param2) - Too few array lenght for this variable!"
                        Exitm
                    #endif
                #endif
                #if (Prm_2 == Word)            
                    #if __VBCD_CounterLenght > 4
                    '/ Because the Word_Dword Macro is not optimized.
                    Asm-
                    Clrf  _srTempDwordBCD+3
                    Clrf  _srTempDwordBCD+2
                    Movff pValueIn+1,_srTempDwordBCD+1
                    Movff pValueIn,_srTempDwordBCD
                    Endasm-
                    #else
                        #error "_mSTR_BCDArray - Input Variable(Param2) - Too few array lenght for this variable!"
                        Exitm
                    #endif
                #endif
                #if (Prm_2 == Byte)            
                    #if __VBCD_CounterLenght > 2
                    '/ Because the Byte_Dword Macro is not optimized.
                    Asm-
                    Clrf _srTempDwordBCD+3
                    Clrf _srTempDwordBCD+2                    
                    Clrf _srTempDwordBCD+1
                    Movff pValueIn,_srTempDwordBCD                   
                    Endasm-
                    #else
                        #error "_mSTR_BCDArray - Input Variable(Param2) - Too few array lenght for this variable!"
                        Exitm
                    #endif
                #endif 
                #if (Prm_2 == Num32)          
                    #if __VBCD_CounterLenght > 9
                    Num_Dword pValueIn,_srTempDwordBCD
                    #else
                        #error "_mSTR_BCDArray - Input Variable(Param2) - Too few array lenght for this number!"
                        Exitm
                    #endif
                #endif 
                #if (Prm_2 == Num16)           
                    #if __VBCD_CounterLenght > 4
                    '/ Because the Num_Dword Macro is not optimized.
                    Asm-
                    Movlw Low (pValueIn)
                    Movff WREG,_srTempDwordBCD 
                    Movlw High (pValueIn)
                    Movff WREG,_srTempDwordBCD+1
                    Clrf _srTempDwordBCD+2
                    Clrf _srTempDwordBCD+3 
                    Endasm-
                    #else
                        #error "_mSTR_BCDArray - Input Variable(Param2) - Too few array lenght for this number!"
                        Exitm
                    #endif
                #endif 
                #if (Prm_2 == Num8)           
                    #if __VBCD_CounterLenght > 2
                    '/ Because the Num_Dword Macro is not optimized.
                    Asm-
                    Clrf _srTempDwordBCD+3
                    Clrf _srTempDwordBCD+2                    
                    Clrf _srTempDwordBCD+1
                    Movlw pValueIn
                    Movff WREG,_srTempDwordBCD                   
                    Endasm-
                    #else
                        #error "_mSTR_BCDArray - Input Variable(Param2) - Too few array lenght for this number!"
                        Exitm
                    #endif
                #endif
            #endif
            GoSub _mSTR_BCDArray_Sub                       
        #endif
    #endif
    ENDSIZE(STR_BCDArray_MACRO)
Endm

#ifMacro- _mSTR_BCDArray    
_mSTR_BCDArray_Sub:
    STARTSIZE(STR_BCDArray_LIB)
    '/ Load the array with the BCD values
    _srBCD_Loop = 0
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        POSTINC0 = Dig _srTempDwordBCD,_srBCD_Loop
        Inc _srBCD_Loop
    Until _srBCD_Loop = __VBCD_CounterLenght
    Return
    ENDSIZE(STR_BCDArray_LIB)
#endIfMacro-
'/******************************************************************************
'/******************************************************************************
'/ Convert a BCD Array (3 digits/ 5 digits/ 10 digits) to variable (Byte(Word/Dword).
'/ With the limitations of the Dword. (max $FFFFFFFF)
'#ifMacro- _mConvArrayToVar
    LocalByte0(_cvBCD_Loop)
    LocalDword0(_cvBCDConvMultiplier)
    LocalDword1(_cvDwordBCD)
'#endIfMacro 

$define VAL_BCDArray(pNumberArray) _mConvArrayToVar pNumberArray
    
_mConvArrayToVar Macro- pNumberArray
    STARTSIZE(VALBCD_MACRO)
    #if (Prm_Count > 1)
	   #error "_mConvArrayToVar - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 1)
            #error "_mConvArrayToVar - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mConvArrayToVar - Number of Array(Param1) Should be a number8"
                Exitm
            #else
                #if (pNumberArray == 1)
                    Num_FSR0 BCDArray1
                #else  
                    #if (pNumberArray == 2)
                        Num_FSR0 BCDArray2
                    #else 
                        #if (pNumberArray == 3)
                            Num_FSR0 BCDArray3
                        #else 
                            #if (pNumberArray == 4)
                                Num_FSR0 BCDArray4
                            #else 
                                #if (pNumberArray == 5)
                                    Num_FSR0 BCDArray5
                                #else
                                    #if (pNumberArray == 6)
                                        Num_FSR0 BCDArray6
                                    #else 
                                        #if (pNumberArray == 7)
                                            Num_FSR0 BCDArray7
                                        #else
                                            #if (pNumberArray == 8)
                                                Num_FSR0 BCDArray8
                                            #else 
                                                #error "_mConvArrayToVar - Number Array(Param1) Should be a 1,2,3,4,5,6,7,8"
                                                Exitm
                                            #endif 
                                        #endif
                                    #endif                                    
                                #endif
                            #endif
                        #endif
                    #endif
                #endif
            #endif
            GoSub _mConvArrayToVar_Sub                       
            #if (_mConvArrayToVar_RETURN != 1)
                #error "_mConvArrayToVar - Macro - Mandatory return parameter misssing"
                Exitm
            #else
                #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword)
                    #error "_mDivBCDcounters - Return variable should be a Byte, Word or Dword"
                    Exitm
                #else
                    #if (Return_Type == Byte)
                        Dword_Byte _cvDwordBCD,Return_Var
                    #endif
                    #if (Return_Type == Word)
                        Dword_Word _cvDwordBCD,Return_Var
                    #endif
                    #if (Return_Type == Dword)
                        Dword_Dword _cvDwordBCD,Return_Var
                    #endif
                #endif
            #endif        
        #endif
    #endif
    ENDSIZE(VALBCD_MACRO)
Endm

#ifMacro- _mConvArrayToVar    
_mConvArrayToVar_Sub:
    STARTSIZE(VALBCD_LIB)
    '/ Load the array with the BCD values
    _cvDwordBCD = 0 
    _cvBCDConvMultiplier = 1
    _cvBCD_Loop = 0
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        WREG = POSTINC0                       '/ Read the array value.
        PP0 = WREG * _cvBCDConvMultiplier     '/ Sum every digit. 
        _cvDwordBCD = _cvDwordBCD + PP0
        _cvBCDConvMultiplier = _cvBCDConvMultiplier * 10
        Inc _cvBCD_Loop
    Until _cvBCD_Loop = __VBCD_CounterLenght
    Return
    ENDSIZE(VALBCD_LIB)
#endIfMacro-
'/******************************************************************************
$endif
$endif
'*******************************************************************************
'* Name    : InkeyX                                                            *
'* Author  : [Alberto Freixanet 2014] Modified 01/09/2018                      *
'* Purpose : Read a 4x4, 4x3 Or 4x2 KEYPAD                                     *
'* Input   : EMI filter Delay (ReadDelay (Byte))                               *
'* Output  : Return_Var (Byte)                                                 *
'* Syntax  : Var1 = InkeyX(ReadDelay)                                          *
'* Notes   : This command is usefull for EMI compliance                        *
'*         : ReadDelay: must to be a Number8 (5 to 255) uS                     *
'*         : Using the Declare of the compiler, e.g Declare Keypad_Port = PORTB*
'*           The code is compatible for all PICs                               *
'*           Read the "Declare_parameters.lpb" file                            *
'*******************************************************************************

$ifndef __InkeyX
$define __InkeyX

$if _defined(_4x4KEYPAD_) Or _defined(_4x3KEYPAD_) Or _defined(_4x2KEYPAD_)
' Define the Global variables used :

' Define the Local variables used 
    LocalByte0(KPInkeyDelayX)
    LocalByte1(KPColumnData)    
    LocalByte2(KPRead_PortX)
    LocalByte3(KPScanResult)        

' Define the Symbols used:
    $ifdef _4x4KEYPAD_
    Symbol SetColumn0 = %11110111   ' For 4x4 Keypad.
    $endif
    $ifdef _4x3KEYPAD_
    Symbol SetColumn0 = %11101111   ' For 4x3 Keypad. 
    $endif
    $ifdef _4x2KEYPAD_
    Symbol SetColumn0 = %11011111   ' For 4x2 Keypad.
    $endif
'-------------------------------------------------------------------------------
$define InkeyX(pReadDelay) _mInkeyX pReadDelay 

_mInkeyX Macro- pReadDelay  
    STARTSIZE(InkeyX_MACRO)
    #if (Prm_Count > 1)
	   #error "_mInkeyX - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 1)
            #error "_mInkeyX - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mInkeyX - _ReadDelay(Param1) Should be a number8"
                Exitm
            #endif
            ' Check the _ReadDelay value
            #if (pReadDelay < 5)
                KPInkeyDelayX = 5                     ' If Read Delay < 5 this line is compiled.
            #else
                Num_Byte pReadDelay, KPInkeyDelayX    ' If Read Delay >= 5 this line is compiled. 
            #endif                
            GoSub _Scan_Keypad_Sub                  ' Check the Keypad.
        #endif
    #endif
    #if (_mInkeyX_RETURN != 1)
        #error "_mInkeyX - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mInkeyX - Return variable should be a BYTE variable"
            Exitm
        #endif
        Byte_Byte KPScanResult,Return_Var
    #endif
    ENDSIZE(InkeyX_MACRO)
Endm
'-------------------------------------------------------------------------------
$ifdef _4x4KEYPAD_
#ifMacro- _mInkeyX
_Scan_Keypad_Sub:
    STARTSIZE(InkeyX_4x4KEYPAD_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
' 4x4 KEYPAD
' Config the Keypad bits of the PORTX:
' RX0 to RX3 = outputs, RX4 to RX7 = inputs 

'    Asm
'    Movlw 11110000b                     ; %11110000 High nible for inputs, Low nible for outputs.
'    Movwf (__KEYPAD_PORT + 0x12),0      ; Configure TRISX register with the correct half of the port to output (+18)
'    EndAsm
    Num_SFR 240,__KEYPAD_TRIS

    ' If PORTB is declared, connect the pullup resistors.   18
    ' The pull-ups could be disabled.
$ifndef _Disable_Keypad_Pullups_
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 0                   ' Pull-ups resistors are enabled only if PORTB is declared.
        $ifdef _WPUB
        WPUB = $F0                      ' Not All PIC18 have a WPUB register. (config high nibble)
        $endif
    #endif
$else
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 1                   ' Pull-ups resistors are disabled only if PORTB is declared.
        $ifdef _WPUB
        WPUB = 0                        ' NO Pull-ups bits. Not All PIC18 have a WPUB register.
        $endif
    #endif    
$endif
' Configuration the SLRCON register to reduce EMI output for the keypad PORT.
$ifdef _SLRCON
    #if (__KEYPAD_PORT == PORTA)        ' If keypad connected to PORTA.
    SLRCON.0 = 1                        ' All outputs on PORTB slew at a limited rate. 
    #endif

    #if (__KEYPAD_PORT == PORTB)        ' If keypad connected to PORTB.
    SLRCON.1 = 1                        ' All outputs on PORTA slew at a limited rate. 
    #endif

    $ifdef _PORTC
    #if (__KEYPAD_PORT == PORTC)        ' If keypad connected to PORTC.
    SLRCON.2 = 1                        ' All outputs on PORTC slew at a limited rate. 
    #endif
    $endif

    $ifdef _PORTD
    #if (__KEYPAD_PORT == PORTD)        ' If keypad connected to PORTD.
    SLRCON.3 = 1                        ' All outputs on PORTD slew at a limited rate. 
    #endif
    $endif

    $ifdef _PORTE
    #if (__KEYPAD_PORT == PORTE)        ' If keypad connected to PORTE.
    SLRCON.4 = 1                        ' All outputs on PORTE slew at a limited rate. 
    #endif
    $endif
$endif

' Scan columns routine
' It is a good practice to insert some 1K resistors to the outputs of the PIC to Keyboard.                  
' Using PORT KEYPAD Low nibble for scanning output and High nibble for Inputs.
'                                           ' Column0    Column1    Column2    Column3
    KPColumnData = SetColumn0               ' %11110111, %01111011, %00111101, %00011110
    KPScanResult = 16                       ' Init the Scan result (keypad 4x4).
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif 
'        Asm
'        Movf  KPColumnData,W,0              ; Load the value of the column
'        Movwf (__KEYPAD_PORT + 0x09),0      ; Write SetColumn0/1/2/3 to LATX KEYPAD register
'        EndAsm
        WREG = KPColumnData                 ' Load the value of the column
        Wreg_Byte __KEYPAD_LAT              ' Write SetColumn0/1/2/3 to LATX KEYPAD register
        ' The port has been loaded with the bit column pulse.

        ' The code is running very fast to read some Keypad.
        ' With very high crystal > 10Mhz, sometimes keys could not be read with parasitic
        ' capacitance and long wiring. Also this code runs more faster than the original
        ' inkey command, some reading errors would be occur without a delay.
        ' Then a little programmable delay resolves the problem and allows using RC filters 
        ' inserted in keypad lines to reduce EMI. 
        ' An empiric formula would be: KPInkeyDelayX = (T1+T2)x3 in uS
        ' If R1,R2= 1K and C1,C2= 2,2nF: (2,2x10-6 + 2,2x10-6)x3 = 13,2uS + (Slew Rate Port)
        ' Then round the value: then KPInkeyDelayX = 13 uS  
        DelayUS KPInkeyDelayX                       

        ' Reading the input port to a byte buffer.
        KPRead_PortX = __KEYPAD_PORT
                                               
        ' Now Check All ROWs, reading the bits of the buffer.
        KPRead_PortX.0 = 1    
        If KPRead_PortX.7 = 0 Then GoTo ReadPortOUT0   ' Check for RX7 = 0 Keydown
        Dec KPScanResult
        If KPRead_PortX.6 = 0 Then GoTo ReadPortOUT0   ' Check for RX6 = 0 Keydown
        Dec KPScanResult
        If KPRead_PortX.5 = 0 Then GoTo ReadPortOUT0   ' Check for RX5 = 0 Keydown 
        Dec KPScanResult
        If KPRead_PortX.4 = 0 Then GoTo ReadPortOUT0   ' Check for RX4 = 0 Keydown
        Dec KPScanResult
        KPRead_PortX.0 = 0
ReadPortOUT0:
        If KPRead_PortX.0 = 1 Then Break  ' Exit the loop. If key pressed then return. 
        ' If key NO pressed, scan again moving the column to right (the bit 0).
        KPColumnData = KPColumnData >> 1    ' RB3        RB2        RB1        RB0        Final step
'                                       ' %11110111, %01111011, %00111101, %00011110, %00001111.
    Until KPColumnData = %00001111        ' All columns have been checked?    
    ' If there is NO KEY pressed the variable KPRead_PortX = 0.
    ' If there is a KEY pressed the variable KPRead_PortX = X, a value depending of the KEY pressed.

    ' This code keep the same frecuency pulses and width in the keypad lines (avoid more EMI variations).
'    Asm
'    Movlw  0x0F                         ; Set All columns high.
'    Movwf (__KEYPAD_PORT + 0x09),0      ; Write to LATX KEYPAD register.
'    EndAsm
    Num_SFR 15,__KEYPAD_LAT     ' Set All columns high & Write To LATX KEYPAD register.

    ' All keys have been read, exit the scan routine.
    Return
    ENDSIZE(InkeyX_4x4KEYPAD_LIB)
#endIfMacro-
$endif  ' _4x4KEYPAD_
'-------------------------------------------------------------------------------
$ifdef _4x3KEYPAD_
#ifMacro- _mInkeyX
_Scan_Keypad_Sub:
    STARTSIZE(InkeyX_4x3KEYPAD_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
' 4x3 KEYPAD
' Config the Keypad PORTX (TRISX)
' RX1 to RX4 = outputs, RX5 to RX7 = inputs 
'    Asm           
'    Movlw 225                           ; %11100001, low nible for outputs, RX1,RX2,RX3,RX4
'    Andwf (__KEYPAD_PORT + 0x12),F,0    ; AND with TRISX
'    Movlw 224                           ; %11100000, 3 high bits for inpputs RX5,RX6,RX7
'    Iorwf (__KEYPAD_PORT + 0x12),F,0    ; OR with TRISX. Don't modify the PORTB.0 bit.
'    EndAsm
    Asm           
    Movlw 225                   ; %11100001, low nible for outputs, RX1,RX2,RX3,RX4
    Andwf __KEYPAD_TRIS,F,0     ; AND with TRISX
    Movlw 224                   ; %11100000, 3 high bits for inpputs RX5,RX6,RX7
    Iorwf __KEYPAD_TRIS,F,0     ; OR with TRISX. Don't modify the PORTB.0 bit.
    EndAsm

    ' If PORTB is declared, the pull-up resistors are connected.
    ' The pull-ups resistors could be disabled.
$ifndef _Disable_Keypad_Pullups_
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 0                   ' Pull-ups resistors are enabled only if PORTB is declared.
        $ifdef _WPUB
        WPUB = %11100000                ' Not All PIC18 have a WPUB register. (config high nibble)
        $endif
    #endif
$else
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 1                   ' Pull-ups resistors are disabled only if PORTB is declared.
        $ifdef _WPUB
        WPUB = 0                        ' NO Pull-ups bits. Not All PIC18 have a WPUB register.
        $endif    
    #endif    
$endif
' Configuration the SLRCON register to reduce EMI output for the keypad PORT.
$ifdef _SLRCON
    #if (__KEYPAD_PORT == PORTA)        ' If keypad connected to PORTA.
    SLRCON.0 = 1                        ' All outputs on PORTB slew at a limited rate. 
    #endif

    #if (__KEYPAD_PORT == PORTB)        ' If keypad connected to PORTB.
    SLRCON.1 = 1                        ' All outputs on PORTA slew at a limited rate. 
    #endif

    $ifdef _PORTC
    #if (__KEYPAD_PORT == PORTC)        ' If keypad connected to PORTC.
    SLRCON.2 = 1                        ' All outputs on PORTC slew at a limited rate. 
    #endif
    $endif
    
    $ifdef _PORTD
    #if (__KEYPAD_PORT == PORTD)        ' If keypad connected to PORTD.
    SLRCON.3 = 1                        ' All outputs on PORTD slew at a limited rate. 
    #endif
    $endif
    
    $ifdef _PORTE
    #if (__KEYPAD_PORT == PORTE)        ' If keypad connected to PORTE.
    SLRCON.4 = 1                        ' All outputs on PORTE slew at a limited rate. 
    #endif
    $endif    
$endif

' Scan columns routine
' It is a good practice to insert some 1K resistors to the outputs of the PIC to Keyboard.                  
' Using PORT KEYPAD LOW nibble for scan and HIGH nibble for receive.
    KPScanResult = 12                        ' Init the Scan result variable (12 keys)
    KPColumnData = SetColumn0                ' %11101111, %11110111, %11111011, %11111101
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
'        Asm
'        Movlw 30                            ; %00011110, Clear the old data in LATX, All bits to high.
'        Iorwf (__KEYPAD_PORT + 0x09),F,0    ; Don't modify the lower bit for user. (__KEYPAD_PORT.0)
'        Movf  KPColumnData,W,0              ; Load the value of the column: %11101111, %01110111, %00111011, %00011101, %00001110.
'        Andwf (__KEYPAD_PORT + 0x09),F,0    ; Write 0 in Column 0/1/2/3 to LATX KEYPAD register
'        EndAsm
        Asm
        Movlw 30                        ; %00011110, Clear the old data in LATX, All bits to high.
        Iorwf __KEYPAD_LAT,F,0          ; Don't modify the lower bit for user. (__KEYPAD_PORT.0)
        Movf  KPColumnData,W,0          ; Load the value of the column: %11101111, %01110111, %00111011, %00011101, %00001110.
        Andwf __KEYPAD_LAT,F,0          ; Write 0 in Column 0/1/2/3 to LATX KEYPAD register
        EndAsm

        ' The port has been loaded with the bit column pulse.

        ' The code is running very fast to read some Keypad.
        ' With very high crystal > 10Mhz, sometimes keys could not be read with parasitic
        ' capacitance and long wiring. Also this code runs more faster than the original
        ' inkey command, some reading errors would be occur without a delay.
        ' Then a little programmable delay resolves the problem and allows using RC filters 
        ' inserted in keypad lines to reduce EMI. 
        ' An empiric formula would be: KPInkeyDelayX = (T1+T2)x3 in uS
        ' Example:
        ' If R1,R2= 1K and C1,C2= 2,2nF: (2,2x10-6 + 2,2x10-6)x3 = 13,2uS + (Slew Rate Port)
        ' Round the value: then KPInkeyDelayX = 13 uS  
        DelayUS KPInkeyDelayX
        
        ' Load a buffer with the PORTX input.
        KPRead_PortX = __KEYPAD_PORT
                                               
        ' Now Check All ROWs
        KPRead_PortX.0 = 1    
        If KPRead_PortX.7 = 0 Then ReadPortOUT0   ' Check for RX7 = 0 Keydown
        Dec KPScanResult
        If KPRead_PortX.6 = 0 Then ReadPortOUT0   ' Check for RX6 = 0 Keydown 
        Dec KPScanResult
        If KPRead_PortX.5 = 0 Then ReadPortOUT0   ' Check for RX5 = 0 Keydown
        Dec KPScanResult
        KPRead_PortX.0 = 0
ReadPortOUT0:
        If KPRead_PortX.0 = 1 Then Break          ' If key pressed then return.
        ' If key NO pressed, scan again moving the column to right (Bit4 to Bit1).
        ' Rotate the KPColumnData bits to the right.
'                                       ' RB4        RB3        RB2        RB1        Final step 
'                                       ' %11101111, %01110111, %00111011, %00011101, %00001110.
        KPColumnData = KPColumnData >> 1    '
    Until KPColumnData = %00001110        ' All columns have been checked?
 
    ' This code keep the same frecuency pulses and width in the keypad lines.
'    Asm
'    Movlw 30                            ; %00011110, Clear the old data in LATX, All bits to high.
'    Iorwf (__KEYPAD_PORT + 0x09),F,0    ; Write to LATX. Don't modify the lower bit.
'    EndAsm
    Asm
    Movlw 30                            ; %00011110, Clear the old data in LATX, All bits to high.
    Iorwf __KEYPAD_LAT,F,0              ; Write to LATX. Don't modify the lower bit.
    EndAsm
    Return
    ENDSIZE(InkeyX_4x3KEYPAD_LIB)
#endIfMacro-
$endif  ' _4x3KEYPAD_
'-------------------------------------------------------------------------------
$ifdef _4x2KEYPAD_
#ifMacro- _mInkeyX
_Scan_Keypad_Sub:
    STARTSIZE(InkeyX_4x2KEYPAD_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
' 4x2 KEYPAD
' Config the Keypad PORTX in every scanning.
' RX0 to RX3 = outputs, RX4 to RX5 = inputs 
    '/ Configure the Inputs/outputs.
'    Asm           
'    Movlw 11000011b                     ; %11000011, 4 pins RX2,RX3,RX4,RX5 for outputs,
'    Andwf (__KEYPAD_PORT + 0x12),F,0
'    Movlw 11000000b                     ; %11000000, 2 pins RX6,RX7 for inputs 
'    Iorwf (__KEYPAD_PORT + 0x12),F,0
'    EndAsm
    Asm           
    Movlw 11000011b                     ; %11000011, 4 pins RX2,RX3,RX4,RX5 for outputs,
    Andwf __KEYPAD_TRIS,F
    Movlw 11000000b                     ; %11000000, 2 pins RX6,RX7 for inputs 
    Iorwf __KEYPAD_TRIS,F
    EndAsm

    ' If PORTB is declared, connect the pullup resistors.
    ' The pull-ups resistors could be disabled, see main code.
$ifndef _Disable_Keypad_Pullups_
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 0                   ' Pull-ups resistors are enabled only if PORTB is declared.
        $ifdef _WPUB
        WPUB = %11000000                ' Config the input bits. Not All PIC18 have a WPUB register.
        $endif
    #endif
$else
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 1                   ' Pull-ups resistors are disabled only if PORTB is declared.
        $ifdef _WPUB
        WPUB = 0                        ' NO Pull-ups bits. Not All PIC18 have a WPUB register.
        $endif
    #endif    
$endif
' Configuration of the SLRCON register to reduce EMI output for the keypad PORT.
$ifdef _SLRCON
    #if (__KEYPAD_PORT == PORTA)        ' If keypad connected to PORTA.
    SLRCON.0 = 1                        ' All outputs on PORTB slew at a limited rate. 
    #endif

    #if (__KEYPAD_PORT == PORTB)        ' If keypad connected to PORTB.
    SLRCON.1 = 1                        ' All outputs on PORTA slew at a limited rate. 
    #endif

    $ifdef _PORTC
    #if (__KEYPAD_PORT == PORTC)        ' If keypad connected to PORTC.
    SLRCON.2 = 1                        ' All outputs on PORTC slew at a limited rate. 
    #endif
    $endif
    
    $ifdef _PORTD
    #if (__KEYPAD_PORT == PORTD)        ' If keypad connected to PORTD.
    SLRCON.3 = 1                        ' All outputs on PORTD slew at a limited rate. 
    #endif
    $endif

    $ifdef _PORTE
    #if (__KEYPAD_PORT == PORTE)        ' If keypad connected to PORTE.
    SLRCON.4 = 1                        ' All outputs on PORTE slew at a limited rate. 
    #endif
    $endif    
$endif

' Scan columns routine
' It is a good practice to insert some 1K resistors to the outputs of the PIC to Keyboard.                  
    KPScanResult = 8                        ' Init the Scan result variable (8 keys to scan).
    KPColumnData = SetColumn0                ' %11011111, load the first column to scan.
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        ' The bits PORTX.0 and PORTX.1 are reserved for the user.
'        Asm
'        Movlw 00111100b                     ; Clear the old data in LATX, All bits to high.
'        Iorwf (__KEYPAD_PORT + 0x09),F,0    ; Don't modify the low nibble (2 bits).
'        Movf  KPColumnData,W,0                ; Load the value of the column
'        Andwf (__KEYPAD_PORT + 0x09),F,0    ; Write 0 in Column 0/1/2/3 to LATX KEYPAD register
'        EndAsm
        Asm
        Movlw 00111100b                     ; %00111100 Clear the old data in LATX, All bits to high.
        Iorwf __KEYPAD_LAT,F                ; Don't modify the low nibble (2 bits).
        Movf  KPColumnData,W,0              ; Load the value of the column
        Andwf __KEYPAD_LAT,F                ; Write 0 in Column 0/1/2/3 to LATX KEYPAD register
        EndAsm

        ' The port has been loaded with the bit column pulse.
    
        ' The code is running very fast to read some Keypad.
        ' With very high crystal > 10Mhz, sometimes keys could not be read with parasitic
        ' capacitance and long wiring. Also this code runs more faster than the original
        ' inkey command, some reading errors would be occur without a delay.
        ' Then a little programmable delay resolves the problem and allows using RC filters 
        ' inserted in keypad lines to reduce EMI. 
        ' An empiric formula would be: KPInkeyDelayX = (T1+T2)x3 in uS
        ' If R1,R2= 1K and C1,C2= 2,2nF: (2,2x10-6 + 2,2x10-6)x3 = 13,2uS + (Slew Rate Port)
        ' Round the value: then KPInkeyDelayX = 13 uS 
        DelayUS KPInkeyDelayX

        ' Reading the input port to a byte buffer.
        KPRead_PortX = __KEYPAD_PORT
                                               
        ' Now Check All ROWs
        KPRead_PortX.0 = 1    
        If KPRead_PortX.7 = 0 Then ReadPortOUT0   ' Check for RX2 = 0 Keydown 
        Dec KPScanResult
        If KPRead_PortX.6 = 0 Then ReadPortOUT0   ' Check for RX1 = 0 Keydown
        Dec KPScanResult
        KPRead_PortX.0 = 0
ReadPortOUT0:
        If KPRead_PortX.0 = 1 Then Break          ' If key pressed then return.
        Asm
        Bsf STATUS,0,0                  ; Load again one bit lost from the left.
        Rrcf KPColumnData,F,0             ; Rotate the KPColumnData bits to the right.
        EndAsm
'   All columns have been checked?      ' RB5        RB4        RB3        RB2        Final step 
    Until KPColumnData = %11111101        ' %11011111, %11101111, %11110111, %11111011, %11111101.
    ' This code keeps the same frecuency pulses and width in the keypad lines.
'    Asm      
'    Movlw 00111100b                     ; %00111100, RX2,RX3,RX4,RX5 for outputs, 
'    Iorwf (__KEYPAD_PORT + 0x09),F,0    ; IOR with PORTX. Clear All columns , All bits to high level.
'    EndAsm    
    Asm      
    Movlw 00111100b                 ; %00111100, RX2,RX3,RX4,RX5 for outputs, 
    Iorwf __KEYPAD_LAT,F,0          ; IOR with PORTX. Clear All columns , All bits to high level.
    EndAsm 
    Return
    ENDSIZE(InkeyX_4x2KEYPAD_LIB)
#endIfMacro-
$endif ' _4x2KEYPAD_
'-------------------------------------------------------------------------------
$endif
$endif
'*******************************************************************************
'* Name    : MidPoint                                                          *
'* Author  : [?????????]                                                       *
'* Purpose : Compute middle point of 2 values                                  *
'* Input   : 2 Values                                                          *
'* Output  : Return_Type (Byte, Word or Dword)                                 *
'* Syntax  : Result = MidPoint(X,Y)                                            *
'* Notes   : The MidPoint library is divided in 3 commands (DWord, Word, Byte) *
'*           to save a lot of bytes in the calculation subroutine.             *
'*******************************************************************************
$ifdef _MidPointDW_
$ifndef __MidPointDW
$define __MidPointDW
'-------------------------------------------------------------------------------
' Definition of local variables
    SMLocalDword0(MidPointDW1)
    SMLocalDword1(MidPointDW2)
     
$define MidPointDW(pValue1,pValue2) _mMidPointDW pValue1,pValue2

_mMidPointDW Macro- pValue1,pValue2
    STARTSIZE(MidPointDW_MACRO)
    #if (Prm_Count > 2)
        #error "_mMidPoint - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mMidPoint - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Word) && (Prm_1 != Num16) && (Prm_1 != Num8) && (Prm_1 != Num32) && (Prm_1 != Byte) && (Prm_1 != Dword)
                #error "_mMidPointDW - (Param1) Should be a Word, Byte, DWord variable or number"
            #endif
            #if (Prm_2 != Word) && (Prm_2 != Num16) && (Prm_2 != Num8) && (Prm_2 != Num32) && (Prm_2 != Byte) && (Prm_2 != Dword)
                    #error "_mMidPointDW - (Param2) Should be a Word, Byte, DWord variable or number"
            #endif
            #if (Prm_1 == Dword)
                Dword_Dword pValue1, MidPointDW1
            #endif
            #if (Prm_1 == Word)
                Word_Dword pValue1, MidPointDW1
            #endif
            #if (Prm_1 == Byte)
                Byte_Dword pValue1, MidPointDW1
            #endif
            #if (Prm_1 == Num32)
                Num_Dword pValue1, MidPointDW1
            #endif 
            #if (Prm_1 == Num16)
                Num_Dword pValue1, MidPointDW1
            #endif
            #if (Prm_1 == Num8)
                Num_Dword pValue1, MidPointDW1
            #endif
            #if (Prm_2 == Dword)
                Dword_Dword pValue2, MidPointDW2
            #endif
            #if (Prm_2 == Word)
                Word_Dword pValue2, MidPointDW2
            #endif
            #if (Prm_2 == Byte)
                Byte_Dword pValue2, MidPointDW2
            #endif
            #if (Prm_2 == Num32)
                Num_Dword pValue2, MidPointDW2
            #endif
            #if (Prm_2 == Num16)
                Num_Dword pValue2, MidPointDW2
            #endif
            #if (Prm_2 == Num8)
                Num_Dword pValue2, MidPointDW2
            #endif
            GoSub _mMidPointDW_Sub
        #endif
        #if (_mMidPointDW_RETURN != 1)
            #error "_mMidPointDW - Mandatory return parameter misssing"
        #else
            #if (Return_Type != Dword) && (Return_Type != Word) && (Return_Type != Byte)
                #error "_mMidPointDW - Return variable should be a DWord, Word or Byte variable"
            #else
                #if (Return_Type == Dword)
                    Dword_Dword MidPointDW1,Return_Var
                #endif
                #if (Return_Type == Word)
                    Dword_Word MidPointDW1,Return_Var
                #endif
                #if (Return_Type == Byte)
                    Dword_Byte MidPointDW1,Return_Var
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(MidPointDW_MACRO)
Endm

#ifMacro- _mMidPointDW
_mMidPointDW_Sub:
    STARTSIZE(MidPointDW_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    If MidPointDW2 > MidPointDW1 Then
        Swap MidPointDW1,MidPointDW2
    EndIf
    MidPointDW1 = MidPointDW1 - MidPointDW2
    MidPointDW1 = MidPointDW1 / 2
    MidPointDW1 = MidPointDW1 + MidPointDW2 
    Return
    ENDSIZE(MidPointDW_LIB)
#endIfMacro-
$endif
$endif
'-------------------------------------------------------------------------------
$ifdef _MidPointW_
$ifndef __MidPointW
$define __MidPointW

' Declare the local variables
    SMLocalWord0(MidPointW1)
    SMLocalWord1(MidPointW2)    
    
$define MidPointW(pValue1,pValue2) _mMidPointW pValue1,pValue2

_mMidPointW Macro-  pValue1,pValue2
    STARTSIZE(MidPointW_MACRO)
    #if (Prm_Count > 2)
        #error "_mMidPointW - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mMidPointW - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Word) && (Prm_1 != Num16) && (Prm_1 != Num8) && (Prm_1 != Byte)
                #error "_mMidPointW - (Param1) Should be a Word, Byte variable or number"
            #endif
            #if (Prm_2 != Word) && (Prm_1 != Num16) && (Prm_1 != Num8) && (Prm_1 != Byte)
                    #error "_mMidPointW - (Param2) Should be a Word, Byte variable or number"
            #endif
            #if (Prm_1 == Word)
                Word_Word pValue1, MidPointW1
            #endif
            #if (Prm_1 == Byte)
                Byte_Word pValue1, MidPointW1
            #endif
            #if (Prm_1 == Num16)
                Num_Word pValue1, MidPointW1
            #endif
            #if (Prm_1 == Num8)
                Num_Word pValue1, MidPointW1
            #endif
            #if (Prm_2 == Word)
                Word_Word pValue2, MidPointW2
            #endif
            #if (Prm_2 == Byte)
                Byte_Word pValue2, MidPointW2
            #endif
            #if (Prm_2 == Num16)
                Num_Word pValue2, MidPointW2
            #endif
            #if (Prm_2 == Num8)
                Num_Word pValue2, MidPointW2
            #endif
            GoSub _mMidPointW_Sub
        #endif
        #if (_mMidPointW_RETURN != 1)
            #error "_mMidPointW - Mandatory return parameter misssing"
        #else
            #if (Return_Type != Dword) && (Return_Type != Word) && (Return_Type != Byte)
                #error "_mMidPointW - Return variable should be a DWord or a Word variable"
            #else
                #if (Return_Type == Dword)
                    Word_Dword MidPointW1,Return_Var
                #endif
                #if (Return_Type == Word)
                    Word_Word MidPointW1,Return_Var
                #endif
                #if (Return_Type == Byte)
                    Word_Byte MidPointW1,Return_Var
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(MidPointW_MACRO)
Endm

#ifMacro- _mMidPointW
_mMidPointW_Sub:
    STARTSIZE(MidPointW_LIB)
    If MidPointW2 > MidPointW1 Then
        Swap MidPointW1,MidPointW2
    EndIf
    MidPointW1 = MidPointW1 - MidPointW2
    MidPointW1 = MidPointW1 / 2
    MidPointW1 = MidPointW1 + MidPointW2 
    Return
    ENDSIZE(MidPointW_LIB)
#endIfMacro-
$endif
$endif
'-------------------------------------------------------------------------------
$ifdef _MidPointB_
$ifndef __MidPointB
$define __MidPointB

' Declare the local variables
'    SMLocalByte0(MidPointB1)
'    SMLocalByte1(MidPointB2)    
    Dim MidPointB1 As PRODL
    Dim MidPointB2 As PRODH    

$define MidPointB(pValue1,pValue2) _mMidPointB pValue1,pValue2

_mMidPointB Macro-  pValue1,pValue2
    STARTSIZE(MidPointB_MACRO)
    #if (Prm_Count > 2)
        #error "_mMidPoint - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mMidPoint - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8) && (Prm_1 != Byte)
                #error "_mMidPoint - (Param1) Should be a Byte variable or number"
            #endif
            #if (Prm_1 != Num8) && (Prm_1 != Byte)
                    #error "_mMidPoint - (Param2) Should be a Byte variable or number"
            #endif
            #if (Prm_1 == Byte)
                Byte_Byte pValue1, MidPointB1
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValue1, MidPointB1
            #endif
            #if (Prm_2 == Byte)
                Byte_Byte pValue2, MidPointB2
            #endif
            #if (Prm_2 == Num8)
                Num_Byte pValue2, MidPointB2
            #endif
            GoSub _mMidPointB_Sub
        #endif
        #if (_mMidPointB_RETURN != 1)
            #error "_mMidPointB - Mandatory return parameter misssing"
        #else
            #if (Return_Type != Word) && (Return_Type != Byte)
                #error "_mMidPointB - Return variable should be a Word or a Byte variable"
            #else
                #if (Return_Type == Word)
                    Byte_Word MidPointB1, Return_Var
                #endif
                #if (Return_Type == Byte)
                    Byte_Byte MidPointB1, Return_Var
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(MidPointB_MACRO)
Endm

#ifMacro- _mMidPointB
_mMidPointB_Sub:
    STARTSIZE(MidPointB_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    If MidPointB2 > MidPointB1 Then
        Swap MidPointB1,MidPointB2
    EndIf
    MidPointB1 = MidPointB1 - MidPointB2
    MidPointB1 = MidPointB1 / 2
    MidPointB1 = MidPointB1 + MidPointB2 
    Return
    ENDSIZE(MidPointB_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : MedianFilter                                                      *
'* Author  : [???????]                                                         *
'* Purpose : Calculate the Median value of N Array values                      *
'* Input   : none                                                              *
'* Output  : Return_Type (Byte)                                                *
'* Syntax  : ByteVar = MedianFilter(ByteArray, SamplesToTake)                  *
'* Notes   :                                                                   *
'*******************************************************************************
$ifdef _MedianFilter_
$ifndef __MedianFilter
$define __MedianFilter

' Declare the local variables
    SMLocalByte0(qMedianFilterTemp1B)
    SMLocalByte1(qMedianFilterTemp2B)    
    SMLocalByte2(qMedianIndexB)
    SMLocalByte3(qMedianSamplesToTakeB)
    SMLocalWord0(qMedianFilterFSRW)
    SMLocalBit0(qMedianSwapOccuredb)
        
$define MedianFilter(pArray, pValue2) _nMedianFilter pArray, pValue2

_nMedianFilter Macro  pArray, pValue2
    STARTSIZE(MedianFilter_MACRO)
    #if (Prm_Count > 2)
        #error "_nMedianFilter - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "_nMedianFilter - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte_Array_Ptr)
                #error "_nMedianFilter - Array(Param1) Should be a BYTE array"
                Exitm
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
                #error "_nMedianFilter - NoSamples(Param2) Should be a Byte variable or number"
            #endif
            #if (Prm_1 == Byte_Array_Ptr)
                Num_Word pArray, qMedianFilterFSRW
            #endif
            #if (Prm_2 == Byte)
                Byte_Byte pValue2, qMedianSamplesToTakeB
            #endif
            #if (Prm_2 == Num8)
                Num_Byte pValue2, qMedianSamplesToTakeB
            #endif
            #if (Prm_2 == Num16)
                Num_Byte pValue2, qMedianSamplesToTakeB
            #endif
            #if (Prm_2 == Num32)
                Num_Byte pValue2, qMedianSamplesToTakeB
            #endif
            GoSub _nMedianFilter_Sub
        #endif
        #if (_nMedianFilter_RETURN != 1)
            #error "_nMedianFilter - Mandatory return parameter misssing"
        #else
            #if (Return_Type != Byte)
                #error "_nMedianFilter - Return variable should be a Byte variable"
            #else
                #if (Return_Type == Byte)
                    Byte_Byte qMedianFilterTemp1B, Return_Var
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(MedianFilter_MACRO)
Endm

#ifMacro- _nMedianFilter
_nMedianFilter_Sub:
    STARTSIZE(MedianFilter_LIB)
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        qMedianSwapOccuredb = 0                                 ' CLEAR FLAG THAT INDICATES SWAP. 								
        qMedianIndexB = 0
        Repeat	
            FSR0L = qMedianFilterFSRW + qMedianIndexB           ' FOR EACH CELL OF THE ARRAY...
        	qMedianFilterTemp1B = POSTINC0
            qMedianFilterTemp2B = INDF0            
            If qMedianFilterTemp1B > qMedianFilterTemp2B Then  	' MOVE LARGER VALUES UP. 
                FSR0L = qMedianFilterFSRW + qMedianIndexB                                     
                qMedianFilterTemp2B = POSTINC0			        ' ..BY SWAPPING THEM. 
                qMedianFilterTemp1B = INDF0
                POSTDEC0 = qMedianFilterTemp2B
                INDF0 = qMedianFilterTemp1B
                qMedianSwapOccuredb = 1						    ' SET BIT IF SWAP OCCURRED.  
            EndIf
            Inc qMedianIndexB
        Until qMedianIndexB = qMedianSamplesToTakeB - 1			' CHECK OUT NEXT CELL OF THE ARRAY. 
    Until qMedianSwapOccuredb = 0								' KEEP SORTING UNTIL NO MORE SWAPS.
    FSR0L = qMedianSamplesToTakeB / 2 + qMedianFilterFSRW
    Dec FSR0L
    qMedianFilterTemp1B = INDF0
    Return 
    ENDSIZE(MedianFilter_LIB)
#endIfMacro-    
$endif
$endif
'*******************************************************************************
'* Name    : BubbleSort                                                        *
'* Author  : [????????????]                                                    *
'* Purpose : Performs a bubble sort On N number of elements On a Byte array    *
'          : in either direction.                                              *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : BubbleSort(Array, Elements, Direction)                            *
'* Notes   :                                                                   *
'*******************************************************************************
' Operators:
' Array  any Byte array 
' Elements - a constant, or byte variable indicating the number of elements
'            within the array to sort 
' Direction - a constant, or byte variable indicating the direction of sorting 0 or 1.
'            Any number > 0 will be taken as 1. 1 = high numbers first 0 = low numbers first 

$ifdef _BubbleSort_ 
$ifndef __BubbleSort
$define __BubbleSort

' Declare the local variables   
    SMLocalBit0(rBubbleSwapOccuredb)
    SMLocalBit1(rBubbleSortDirectionb)    
    SMLocalByte0(rBubbleSortTemp1B)
    SMLocalByte1(rBubbleSortTemp2B)    
    SMLocalByte2(rBubbleSortIndexB)    
    SMLocalByte3(rBubbleSortElementsB)
    SMLocalWord0(rBubbleSortFSRW)

$define BubbleSort(pArray,Pvalue2,PValue3) _mBubbleSort pArray,Pvalue2,PValue3

_mBubbleSort Macro  pArray,Pvalue2,PValue3
    STARTSIZE(BubbleSort_MACRO)
    #if (Prm_Count > 3)
        #error "_mBubbleSort - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 3)
            #error "_mBubbleSort - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte_Array_Ptr)
                #error "_mBubbleSort - Array(Param1) Should be a BYTE array"
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
                #error "_mBubbleSort - NoElements(Param2) Should be a Byte variable or number"
            #endif
            #if (Prm_3 != Byte) && (Prm_3 != Num8)
                #error "_mBubbleSort - Direction(Param3) Should be a Byte variable or number8"
            #endif
            #if (Prm_1 == Byte_Array_Ptr)
                Num_Word pArray, rBubbleSortFSRW
            #endif
            #if (Prm_2 == Byte)
                Byte_Byte Pvalue2, rBubbleSortElementsB
            #endif
            #if (Prm_2 == Num8)
                Num_Byte Pvalue2, rBubbleSortElementsB
            #endif
            #if (Prm_2 == Num16)
                Num_Byte Pvalue2, rBubbleSortElementsB
            #endif
            #if (Prm_2 == Num32)
                Num_Byte Pvalue2, rBubbleSortElementsB
            #endif
            #if (Prm_3 == Byte)
                Byte_Bit PValue3, rBubbleSortDirectionb
            #endif
            #if (Prm_3 == Num8)
                Num_Bit PValue3, rBubbleSortDirectionb
            #endif
            GoSub _mBubbleSort_Sub
        #endif  
    #endif
    ENDSIZE(BubbleSort_MACRO)
Endm

#ifMacro- _mBubbleSort
_mBubbleSort_Sub:
    STARTSIZE(BubbleSort_LIB)
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        rBubbleSwapOccuredb = 0                                ' CLEAR FLAG THAT INDICATES SWAP. 								
        rBubbleSortIndexB = 0
        Repeat	
            FSR0L = rBubbleSortFSRW + rBubbleSortIndexB         ' FOR EACH CELL OF THE ARRAY...
        	rBubbleSortTemp1B = POSTINC0
            rBubbleSortTemp2B = INDF0  
            If rBubbleSortDirectionb = 0 Then
                If rBubbleSortTemp1B > rBubbleSortTemp2B Then _BubbleSortSwap_Sub ' MOVE LARGER VALUES UP.
            Else
                If rBubbleSortTemp1B< rBubbleSortTemp2B Then _BubbleSortSwap_Sub 
            EndIf
            GoTo _OverBubbleSortSwap_Sub
_BubbleSortSwap_Sub:  	                                    ' MOVE VALUES AROUND                                             
                FSR0L = rBubbleSortFSRW + rBubbleSortIndexB                                     
                rBubbleSortTemp2B = POSTINC0					' ..BY SWAPPING THEM. 
                rBubbleSortTemp1B = INDF0
                POSTDEC0 = rBubbleSortTemp2B
                INDF0 = rBubbleSortTemp1B
                rBubbleSwapOccuredb = 1						' SET BIT IF SWAP OCCURRED.  
_OverBubbleSortSwap_Sub:
            Inc rBubbleSortIndexB
        Until rBubbleSortIndexB = rBubbleSortElementsB - 1    ' CHECK OUT NEXT CELL OF THE ARRAY. 
    Until rBubbleSwapOccuredb = 0							' KEEP SORTING UNTIL NO MORE SWAPS.
    Return 
    ENDSIZE(BubbleSort_LIB)
#endIfMacro-    
$endif
$endif
'*******************************************************************************
'* Name    : CountUntil (Beta)                                                 *
'* Author  : [Alberto Freixanet] 01/09/2018                                    *
'* Purpose : Count pulses in a Pin until another pin changes the state         *
 '* Input   : PORTX,Piny, PORTY,Pinx, State Pin                                 *
'* Output  : Return_Var                                                        *
'* Syntax  : CountUntil(pCountPort,pCounterPin,pCounterStopPort,pCounterStopPin*
'*           ,pCounterStopValue)                                               *
'* Notes   : Seams to be faster of the original CountUntil command             *
'*           The variable count (_CountPulses) could be changed to Word to     *
'*           increase speed. It depends of number of number of pulses to count *
'*           The code counts the edges of input pin & convert them to pulses   *
'*******************************************************************************
$ifdef _CountUntil_
$ifndef __CountUntil
$define __CountUntil
'/==============================================================================
'/ To Dim a Dword Variable for counting, uncomment the following line.
'$define _CountUntilDword_Var_

$ifndef _CountUntilDword_Var_
    LocalWord0(_CountPulses)
$else
    LocalDword0(_CountPulses)
$endif

'#ifMacro- _mCountUntilPin, _mCountUntilM
' Declare the Local variables
    LocalByte0(_CounterStopPinMask)
    LocalByte1(_CounterInputPinMask)
    LocalByte2(CounterStopPinInit)
    LocalByte3(CounterInputPinInit)
    LocalByte4(_CounterStopMask)
    LocalByte5(_CounterInputMask)
'#endIfMacro-

'/==============================================================================
$define CountUntilPin(pCountPort,pCounterPin,pCounterStopPort,pCounterStopPin,pReturnValue) '
    STARTSIZE(CountUntilPin_MACRO)         '
    _CounterInputPinMask = pCounterPin     '
    _CounterStopPinMask = pCounterStopPin  '
    FSR0 = VarPtr(pCountPort)              '
    FSR1 = VarPtr(pCounterStopPort)        '
    _mCountUntilPin                        '
    pReturnValue = _CountPulses            '
    ENDSIZE(CountUntilPin_MACRO)

_mCountUntilPin Macro-
    GoSub _mCountUntilPin_Sub 
Endm 

#ifMacro- _mCountUntilPin, _mCountUntilM
_mCountUntilPin_Sub:
STARTSIZE(CountUntilPin_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
'/Built the Counter Input Pin Mask in FSR0
    _CounterInputMask = 1
    If _CounterInputPinMask > 0 Then
        Asm
_LB_Y22NN
        Rlncf   _CounterInputMask,F,0       '/ Shift one bit To the left.
        Decfsz  _CounterInputPinMask,F,0    '/ _CounterInputPinMask is destroyed.
        Bra     _LB_Y22NN
        EndAsm 
    EndIf

'/ Built the Counter Stop Pin Mask in FSR1
    _CounterStopMask = 1
    If _CounterStopPinMask > 0 Then
        Asm
_LB_Y11MM
        Rlncf   _CounterStopMask,F,0       '/ Shift one bit to the left.
        Decfsz  _CounterStopPinMask,F,0    '/ _CounterStopPinMask is destroyed.
        Bra     _LB_Y11MM
        EndAsm 
    EndIf
    
    '/ The FSR0 & FSR1 are pointing already to the different PORTS
    CounterStopPinInit = INDF1 & _CounterStopMask    '/ Copy the state of the CounterStopPin
    CounterInputPinInit = INDF0 & _CounterInputMask  '/ Copy the state of the CounterInput

    '/ Start counting
    Do
        #ifdef Watchdog_req
        Clrwdt
        #endif
        '/ Read the Stop Pin
        WREG = INDF1 & _CounterStopMask     '/ Mask the pin
        If WREG <> CounterStopPinInit Then  '/ Did The pin toggle?
            Break                           '/ YES then Stops to count
        EndIf

        '/ Read the Counter Pin edge.
        PRODH = INDF0 & _CounterInputMask   '/ Mask the pin
        If WREG <> CounterInputPinInit Then '/ Are the 2 states different?? (Using WREG saves one line of asm code.)
            CounterInputPinInit = PRODH     '/ Then Copy this state for next reading.
            Inc _CountPulses                '/ YES there is an edge (0 or 1), then increment the counter.
        EndIf
    Loop
    _CountPulses = _CountPulses / 2         '/ Convert edges to number of pulses.
    Return
ENDSIZE(CountUntilPin_LIB)
#endIfMacro-
'/==============================================================================
$define CountUntil(pCountPort,pCounterPin,pCounterStopPort,pCounterStopPin) _mCountUntilM pCountPort,pCounterPin,pCounterStopPort,pCounterStopPin 

_mCountUntilM Macro-  pCountPort,pCounterPin,pCounterStopPort,pCounterStopPin
    STARTSIZE(CountUntil_MACRO)
    #if (Prm_Count > 4) 
        #error "_mCountUntilM - Too many parameters" 
    #else 
        #if (Prm_Count < 4) 
            #error "_mCountUntilM - Too few parameters" 
        #else 
            #if (Prm_1 != Num8) && (Prm_1 != Byte) 
                #error "_mCountUntilM - CountPort(Param1) Should be a Valid Port" 
            #else
                Num_FSR0 pCountPort     '/ Load directly the address of the PORT to FSR0
            #endif 
            #if (Prm_2 != Byte) && (Prm_2 != Num8) 
                #error "_mCountUntilM - CounterPin(Param2) Should be a Byte variable or number" 
            #else
                #if (Prm_2 == Byte) 
                    Byte_Byte pCounterPin, _CounterInputPinMask 
                #endif 
                #if (Prm_2 == Num8) 
                    Num_Byte pCounterPin, _CounterInputPinMask 
                #endif 
            #endif 
            #if (Prm_3 != Num8) && (Prm_3 != Byte) 
                #error "_mCountUntilM - CounterStopPort(Param3) Should be a Valid Port" 
            #else
                Num_FSR1 pCounterStopPort   '/ Load directly the address of the PORT to FSR1
            #endif 
            #if (Prm_4 != Byte) && (Prm_4 != Num8) 
                #error "_mCountUntilM - CounterStopPin(Param4) Should be a Byte variable or number" 
            #else
                #if (Prm_4 == Byte) 
                    Byte_Byte pCounterStopPin, _CounterStopPinMask 
                #endif 
                #if (Prm_4 == Num8) 
                    Num_Byte pCounterStopPin, _CounterStopPinMask 
                #endif 
            #endif 
            GoSub _mCountUntilPin_Sub 
        #endif 
        #if (_mCountUntilM_RETURN != 1) 
            #error "_mCountUntilM - Mandatory return parameter misssing" 
        #else 
            #if (Return_Type !=Dword) && (Return_Type !=Word) && (Return_Type !=Byte) 
                #error "_mCountUntilM - Return variable should be a Word, Byte, DWord variable" 
            #else 
                $ifndef _CountUntilDword_Var_
                    #if (Return_Type == Dword) 
                        Word_Dword _CountPulses,Return_Var 
                    #endif 
                    #if (Return_Type == Word) 
                        Word_Word _CountPulses,Return_Var 
                    #endif 
                    #if (Return_Type == Byte) 
                        Word_Byte _CountPulses,Return_Var 
                    #endif 
                $else
                    #if (Return_Type == Dword) 
                        Dword_Dword _CountPulses,Return_Var 
                    #endif 
                    #if (Return_Type == Word) 
                        Dword_Word _CountPulses,Return_Var 
                    #endif 
                    #if (Return_Type == Byte) 
                        Dword_Byte _CountPulses,Return_Var 
                    #endif                 
                $endif
            #endif 
        #endif 
    #endif 
    ENDSIZE(CountUntil_MACRO)
Endm 
'/==============================================================================
$endif
$endif
'*******************************************************************************
'* Name    : Binary_to_3BCD                                                    *
'* Author  : [????] Modified by Alberto Freixanet                              *
'* Purpose : Convert one binary Byte (0 To 255) To 3 BCD bytes                 *
'* Input   : Byte Or Num8                                                      *
'* Output  : Byte_LSB, Byte_DSB, Byte_MSB                                      *
'* Syntax  : Binary_to_3BCD(pValue)                                            *
'* Notes   :                                                                   *
'*******************************************************************************
$ifdef _Binaryto3BCD_
$ifndef __Binaryto3BCD
$define __Binaryto3BCD

' Declare local variables
'    SMLocalByte0(BinaryTempB)
    Dim BinaryTempB As PRODL

' Declare global variables
    Dim Byte_MSB As Byte
    Dim Byte_DSB As Byte
    Dim Byte_LSB As Byte

$define Binaryto3BCD(pValue) mBinaryto3BCD pValue

mBinaryto3BCD Macro- pValue
    STARTSIZE(Binaryto3BCD_MACRO)
	#if (Prm_Count != 1)         
        ' Ensure the correct amount of parameters
		#error "Incorrect amount of parameters for Binary_to_BCD3 macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Byte) && (Prm_1 != Num8)
            ' Ensure the parameter is a byte
            #error "Binary_to_BCD3 Macro - Input Value(Param1) Should be a Byte Variable or a Num8"
            Exitm
        #else    
            #if (Prm_1 == Byte)
                Byte_Byte pValue, BinaryTempB
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValue, BinaryTempB
            #endif            
             GoSub mBinaryto3BCD_Sub
        #endif
    #endif
    ENDSIZE(Binaryto3BCD_MACRO)
Endm

#ifMacro- mBinaryto3BCD
mBinaryto3BCD_Sub:
    STARTSIZE(Binaryto3BCD_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    Byte_MSB = BinaryTempB / 100
    Byte_DSB = BinaryTempB // 100
    Byte_LSB = Byte_DSB // 10
    Byte_DSB = Byte_DSB / 10
    Return
    ENDSIZE(Binaryto3BCD_LIB)
#endIfMacro-    
$endif
$endif
'*******************************************************************************
'* Name    : BCD2toBinary                                                      *
'* Author  : [????] Modified by Alberto Freixanet                              *
'* Purpose : Convert one Byte with 2 BCD To one binary Byte                    *
'* Input   : Variable (Byte)                                                   *
'* Output  : Return_Type (Byte)                                                *
'* Syntax  : ResultByteVar = BCD2toBinary(VAR1)                                *
'* Notes   :                                                                   *
'*******************************************************************************
$ifdef _BCD2ToBinary_
$ifndef __BCD2ToBinary
$define __BCD2ToBinary

' Declare local variables
'    SMLocalByte0(_BcdBinaryTempB)
'    SMLocalByte1(_2BCD_Byte)    
    Dim _BcdBinaryTempB As PRODL
    Dim _2BCD_Byte As PRODH
    
$define BCD2ToBinary(pValue) _mBCD2_to_Binary pValue
 
_mBCD2_to_Binary Macro pValue
    STARTSIZE(BCD2ToBinary_MACRO)
	#if (Prm_Count != 1)         
        ' Ensure the correct amount of parameters
		#error "Incorrect amount of parameters for _mBCD2_to_Binary macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Byte) && (Prm_1 != Num8)
            ' Ensure the parameter is a byte
            #error "_mBCD2_to_Binary Macro - Input Variable(Param1) Should be a Byte Variable or a Num8"
            Exitm
        #else    
            #if (Prm_1 == Byte)
                Byte_Byte pValue, _2BCD_Byte
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValue, _2BCD_Byte
            #endif            
            GoSub _mBCD2_to_Binary_Sub
            #if (_mBCD2_to_Binary_RETURN != 1)
                #error "_mBCD2_to_Binary - Mandatory return parameter misssing"
            #else
                #if (Return_Type != Byte)
                    #error "_mBCD2_to_Binary - Return variable should be a Byte variable"
                    Exitm
                #else
                    Byte_Byte _BcdBinaryTempB, Return_Var
                #endif
            #endif
        #endif
    #endif
    ENDSIZE(BCD2ToBinary_MACRO)
Endm

#ifMacro- _mBCD2_to_Binary
_mBCD2_to_Binary_Sub:
    STARTSIZE(BCD2ToBinary_LIB)
    ' This is the code
    #ifdef Watchdog_req
    Clrwdt
    #endif
    Clear _BcdBinaryTempB          'this temporal variable must to be defined first
    If _2BCD_Byte.0 = 1 Then _BcdBinaryTempB = 1
    If _2BCD_Byte.1 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 2
    If _2BCD_Byte.2 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 4
    If _2BCD_Byte.3 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 8
    If _2BCD_Byte.4 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 10
    If _2BCD_Byte.5 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 20      
    If _2BCD_Byte.6 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 40
    If _2BCD_Byte.7 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 80
    Return
    ENDSIZE(BCD2ToBinary_LIB)
#endIfMacro-    
$endif
$endif
'*******************************************************************************
'* Name    : WordTo5BCD                                                        *
'* Author  : [????] Modified by Alberto Freixanet                              *
'* Purpose : Convert a binary Word To 5 BCD Bytes (Array)                      *
'* Input   : Variable (Byte)                                                   *
'* Output  : Return_Type (Array 5 Bytes)                                       *
'* Syntax  : WordTo5BCD(Value (Word), Mode (Bit))                              *
'* Notes   : The Results could be BCD (Mode = 0) or ASCII (Mode = 1)           *
'*******************************************************************************
' If Mode = 0 The result in the array is BCD Byte. 
' If Mode = 1 The array in the array is ASCII Byte.

$ifdef _WordTo5BCD_
$ifndef __WordTo5BCD
$define __WordTo5BCD

' Declare Global variables
    Dim BCDArray[5] As Byte 

' Declare local variables
    SMLocalByte0(OutMode)
    SMLocalWord1(TempWordLib)
    SMLocalWord2(Temp2WordLib)    

$define WordTo5BCD(pValue1, pValue2) _mWord_to_5BCD pValue1, pValue2
    
_mWord_to_5BCD Macro pValue1, pValue2 
    STARTSIZE(WordTo5BCD_MACRO)
    #if (Prm_Count > 2)
	   #error "_mWord_to_5BCD - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mWord_to_5BCD - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Word) && (Prm_1 != Byte) && (Prm_1 != Num16) && (Prm_1 != Num8)
                #error "_mWord_to_5BCD - (Param1) Should be a Byte/Word variable or a Number8 or Number16" 
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Num8)
                #error "_mWord_to_5BCD - (Param2) Should be a Byte or a Number8" 
            #endif
            #if (Prm_1 == Word)            
                Word_Word pValue1, TempWordLib
            #endif
            #if (Prm_1 == Byte)            
                Byte_Word pValue1, TempWordLib
            #endif 
            #if (Prm_1 == Num16)            
                Num_Word pValue1, TempWordLib
            #endif
            #if (Prm_1 == Num8)            
                Num_Word pValue1, TempWordLib
            #endif
            #if (Prm_2 == Byte)            
                Byte_Byte pValue2, OutMode
            #endif                        
            #if (Prm_2 == Num8)            
                Num_Byte pValue2, OutMode
            #endif
            GoSub _WordBin_5BCD_Sub            
        #endif
    #endif
    ENDSIZE(WordTo5BCD_MACRO)
Endm

#ifMacro- _mWord_to_5BCD    
_WordBin_5BCD_Sub:
    STARTSIZE(WordTo5BCD_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    BCDArray#0 =    TempWordLib / 10000     '= 6        '6 X 10.000 'BYTE
    TempWordLib =   TempWordLib // 10000    '= 4785                 'WORD
    Temp2WordLib =  TempWordLib // 1000     '= 785                  'WORD
    BCDArray#1 =    TempWordLib / 1000      '= 4        '4 X 1000   'BYTE
    TempWordLib =   Temp2WordLib // 100     '= 85                   'BYTE
    BCDArray#4 =    TempWordLib // 10       '= 5        '5 X 1      'BYTE
    BCDArray#2 =    Temp2WordLib / 100      '= 7        '7 X 100    'BYTE
    BCDArray#3 =    TempWordLib / 10        '= 8        '8 X 10     'BYTE
    If OutMode = 1 Then
        BCDArray#0 = BCDArray#0 + 48    ' ASCII result
        BCDArray#1 = BCDArray#1 + 48    ' ASCII result
        BCDArray#2 = BCDArray#2 + 48    ' ASCII result
        BCDArray#3 = BCDArray#3 + 48    ' ASCII result
        BCDArray#4 = BCDArray#4 + 48    ' ASCII result
    EndIf 
    Return
    ENDSIZE(WordTo5BCD_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : RotateBitsLeft                                                    *
'* Author  : [????] Modified by Alberto Freixanet                              *
'* Purpose : Move the Bits of a Byte to the Left                               *
'* Input   : Byte Or Num8                                                      *
'* Output  : Return Type (Byte)                                                *
'* Syntax  : ResultByte = RotateBitsLeft(Var1,Shift)                           *
'* Notes   :                                                                   *
'*******************************************************************************
$ifdef _RotateBits_
$ifndef __RotateBits
$define __RotateBits

' Declare local variables
'    LocalByte0(_mzLoopShiftB)
'    LocalByte1(_zmValueToShiftB)    
    Dim _mzLoopShiftB As PRODL
    Dim _zmValueToShiftB As PRODH

$define RotateBitsLeft(pValue,pShift) _mRotateBitsLeft pValue,pShift

_mRotateBitsLeft Macro- pValue,pShift
    STARTSIZE(RotateBitsLeft_MACRO)
    #if (Prm_Count > 2)
	   #error "_mRotateBitsLeft - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mRotateBitsLeft - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte) && (Prm_1 != Num8)
                #error "_mRotateBitsLeft - (Param1) Should be a Byte or Num8"
                Exitm
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Num8)
                #error "_mRotateBitsLeft - (Param2) Should be a Byte Or Num8"
                Exitm
            #else
                #if (Prm_2 == Byte) 
                Byte_Byte pShift,_mzLoopShiftB         
                #endif   
                #if (Prm_2 == Num8) 
                Num_Byte pShift,_mzLoopShiftB
                #endif
                #if (Prm_1 == Byte) 
                Byte_Byte pValue,_zmValueToShiftB
                #endif
                #if (Prm_1 == Num8) 
                Num_Byte pValue,_zmValueToShiftB
                #endif                                 
                GoSub _mRotateBitsLeft_sub            
                #if (_mRotateBitsLeft_RETURN != 1)
                    #error "_mRotateBitsLeft - Mandatory return parameter misssing"
                #else
                    #if (Return_Type != Byte)
                        #error "_mRotateBitsLeft - Return variable should be a Byte variable"
                    #else
                        #if (Return_Type == Byte)
                        Byte_Byte _zmValueToShiftB, Return_Var
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif        
    ENDSIZE(RotateBitsLeft_MACRO)
Endm
 
#ifMacro- _mRotateBitsLeft
_mRotateBitsLeft_sub:
    STARTSIZE(RotateBitsLeft_LIB)
' Better write the in assembler, => more eficient.
    GIE_Save()
Asm
_LBLX__Y11MM
    #ifdef Watchdog_req
    Clrwdt
    #endif
    Rlncf   _zmValueToShiftB,F,0
    Decfsz  _mzLoopShiftB,F,0    ; Modified 21/04/2013
    Bra     _LBLX__Y11MM        ; Modified 21/04/2013
EndAsm
    GIE_Restore()
    Return
    ENDSIZE(RotateBitsLeft_LIB)
#endIfMacro-
'*******************************************************************************
'* Name    : RotateBitsRight                                                   *
'* Author  : [????] Modified by Alberto Freixanet                              *
'* Purpose : Move the Bits of a Byte to the Right                              *
'* Input   : Byte Or Num8                                                      *
'* Output  : Return Type (Byte)                                                *
'* Syntax  : ResultByte = RotateBitsRight(Var1,Shift)                          *
'* Notes   :                                                                   *
'*******************************************************************************
$define RotateBitsRight(pValue, pShift) _mRotateBitsRight pValue, pShift

_mRotateBitsRight Macro- pValue, pShift
    STARTSIZE(RotateBitsRight_MACRO)
    #if (Prm_Count > 2)
	   #error "_mRotateBitsRight - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mRotateBitsRight - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte) && (Prm_1 != Num8)
                #error "_mRotateBitsRight - (Param1) Should be a Byte or Num8"
                Exitm
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Num8)
                #error "_mRotateBitsRight - (Param2) Should be a Byte Or Num8"
                Exitm
            #else
                #if (Prm_2 == Byte) 
                Byte_Byte pShift,_mzLoopShiftB         
                #endif   
                #if (Prm_2 == Num8) 
                Num_Byte pShift,_mzLoopShiftB
                #endif
                #if (Prm_1 == Byte) 
                Byte_Byte pValue,_zmValueToShiftB
                #endif
                #if (Prm_1 == Num8) 
                Num_Byte pValue,_zmValueToShiftB
                #endif                                 
                GoSub _mRotateBitsRight_sub            
                #if (_mRotateBitsRight_RETURN != 1)
                    #error "_mRotateBitsRight - Mandatory return parameter misssing"
                #else
                    #if (Return_Type != Byte)
                        #error "_mRotateBitsRight - Return variable should be a Byte variable"
                    #else
                        #if (Return_Type == Byte)
                        Byte_Byte _zmValueToShiftB, Return_Var
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif        
    ENDSIZE(RotateBitsRight_MACRO)
Endm
 
#ifMacro- _mRotateBitsRight
_mRotateBitsRight_sub:
    STARTSIZE(RotateBitsRight_LIB)
' Se hace con el asemblador, no hay remedio...
    GIE_Save()
Asm
_LBLX__Y22MM
    #ifdef Watchdog_req
    Clrwdt
    #endif
    Rrncf   _zmValueToShiftB,F,0
    Decfsz  _mzLoopShiftB,F,0    ; Modified 21/04/2013
    Bra     _LBLX__Y22MM        ; Modified 21/04/2013
EndAsm
    GIE_Restore()
    Return
    ENDSIZE(RotateBitsRight_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : Dword Array Load And Retrieve                                     *
'* Author  : [Les Johnson]                                                     *
'* Purpose : Load and Retreive a value from a Dword Array                      *
'* Input   : none                                                              *
'* Output  : Return_Type (Byte)                                                *
'* Syntax  : Retreive from a Dword Array                                       *
'*           Var = DwordArray Array Name , [Array Index]                       *
'* Syntax  : Load into a Dword Array                                           *
'*           DwordArray Array Name , [Array Index] , Var                       *
'* Notes   : Author: Les Johnson                                               *
'*******************************************************************************
' Dword Array Load and Retrieve Macro
'
' The Actual array is build from a single or multiple byte arrays
' If a Dword array of size 20 is required, the byte array must be four times this
' because 32-bit (Dword) variables and constants require 4 bytes to hold their value
' So create the array:
'
' Dim MyArray[80] as Byte			' Room for 20 Dword (32-bit) elements

$ifdef _DwordArray_
$ifndef __DwordArray
$define __DwordArray

'$if (_core <> 16)
'    $error "DwordArray Macro only suitable For 18F devices!"
'$endif
'---------------------------------------------------------------------------------------
' Declare a Dword Array
'
' Syntax:
' DeclareDwordArray [ Array Name , Array Size ]
'
    $define Declare_DwordArray(pArrayName,pArraySize) '
    Reminders = Off                                   '
    Dim pArrayName[pArraySize * 4] As Byte            '
    Reminders = On

$define DwordArray(pArrayName, pArrayIndex, pValueToPlace ) _mDwordArray pArrayName, pArrayIndex, pValueToPlace

_mDwordArray Macro- pArrayName, pArrayIndex, pValueToPlace \ Dword
    STARTSIZE(DwordArray_MACRO)
    #if ((Prm_1 != Byte_Array_Ptr) && (Prm_1 != Word_Array_Ptr))
        #error "Parameter 1 must be an Array's Name"
        Exitm
    #endif
	#if((Prm_2 == Float) || (Prm_2 == Fnum))
     	#error "DwordArray macro index value cannot be a Floating Point Variable or Constant"
    	Exitm
    #endif
    #ifdef Watchdog_req
    Clrwdt
    #endif
    Asm-
    Lfsr 0,pArrayName
    Endasm-

    #if((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32))    ; Index is a Constant value
        #if (pArrayIndex > 0)
        Movlw ((pArrayIndex * 4) & 255)         ; Multiply index by four and extract the low byte
        Addwf FSR0L,F                           ; Add it to the value already held in FSR0L
        Movlw (((pArrayIndex * 4) >> 8) & 255)  ; Multiply index by four and extract the high byte
        Addwfc FSR0H,F                          ; Add it to the value already held in FSR0H
        #endif
    #endif

    #if(Prm_2 == Byte)                          ; Index is a Byte Variable?
        #if(pArrayIndex != WREG)
        Asm-
        Movff pArrayIndex,WREG
        Endasm-
        #endif
        Mullw 4                                 ; Multiply index by four (immune from bank changes)
        Movf PRODL,W                            ; \
        Addwf FSR0L,F                           ;  | Add it to the value already held in FSR0L\H
        Movf PRODH,W                            ;  |
        Addwfc FSR0H,F                          ; /
    #endif

    #if((Prm_2 == Word) || (Prm_2 == Dword))    ; Index is a Word or Dword Variable?
        Asm-
        Lfsr 1,pArrayIndex                      ; Load the index variable's address into FSR1
        Bcf STATUS,0                            ; \
        Rlcf POSTINC1,W                         ;  |
        Movwf PRODL                             ;  | 
        Rlcf INDF1,W                            ;  |
        Movwf PRODH                             ;  | Multiply index by four (immune from bank changes)
        Bcf STATUS,0                            ;  |
        Rlcf PRODL,F                            ;  |
        Rlcf PRODH,F                            ; /
        Movf PRODL,W                            ; \
        Addwf FSR0L,F                           ;  |
        Movf PRODH,W                            ;  | Add it To the value already held in FSR0L\H
        Addwfc FSR0H,F                          ; /
        Endasm-
    #endif
'
' Load or Retrieve from the array depending on whether the macro has an assignment variable preceeding it
    #if (_mDwordArray_Return == 0)        		; No assignment variable found, so it is a loading macro
        #if (Prm_Count != 3)
             #error "Missing Loading Operand with DwordArray macro"
        #else
            #if((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32) || (Prm_3 == SNum8) || (Prm_3 == SNum16) || (Prm_3 == SNum32))
            	#if((pValueToPlace & 255) == 255)
        			Setf POSTINC0
        		#else
        			#if((pValueToPlace & 255) == 0)					; Operate on low byte
        				Clrf POSTINC0
        			#else
        				Num_SFR (pValueToPlace & 255),POSTINC0
        			#endif
        		#endif
        
        		#if(((pValueToPlace >> 8) & 255) == 255)				; Operate on mid 1 byte
        			Setf POSTINC0
        		#else
        			#if(((pValueToPlace >> 8) & 255) == 0)
        				Clrf POSTINC0
        			#else
        				Num_SFR ((pValueToPlace >> 8) & 255),POSTINC0
        			#endif
        		#endif
        
        		#if(((pValueToPlace >> 16) & 255) == 255)			; Operate on mid 2 byte
        			Setf POSTINC0
        		#else
        			#if(((pValueToPlace >> 16) & 255) == 0)
        				Clrf POSTINC0
        			#else
        				Num_SFR ((pValueToPlace >> 16) & 255),POSTINC0
        			#endif
        		#endif
        
        		#if(((pValueToPlace >> 24) & 255) == 255)			; Operate on high byte
        			Setf POSTINC0
        		#else
        			#if(((pValueToPlace >> 24) & 255) == 0)
        				Clrf POSTINC0
        			#else
        				Num_SFR ((pValueToPlace >> 24) & 255),POSTINC0
        			#endif
        		#endif
        	#endif
            #if(Prm_3 == Byte)
                Asm-
            	Movff pValueToPlace,POSTINC0
            	Endasm-
                Clrf POSTINC0
            	Clrf POSTINC0
            	Clrf POSTINC0     
            #endif
        	#if(Prm_3 == Word)
                Asm-
            	Movff pValueToPlace,POSTINC0
            	Movff pValueToPlace + 1,POSTINC0
            	Endasm-
                Clrf POSTINC0
            	Clrf POSTINC0
            #endif
        	#if((Prm_3 == Dword) || (Prm_3 == Float))
                Asm-
            	Movff pValueToPlace,POSTINC0
            	Movff pValueToPlace + 1,POSTINC0
            	Movff pValueToPlace + 2,POSTINC0
            	Movff pValueToPlace + 3,POSTINC0
                Endasm-
            #endif
        #endif
    #else                               ; Otherwise it is a Retrieving macro
        Asm-
        Movff POSTINC0,Return_Var
        Movff POSTINC0,Return_Var + 1
        Movff POSTINC0,Return_Var + 2
        Movff POSTINC0,Return_Var + 3
        Endasm-
    #endif
    ENDSIZE(DwordArray_MACRO)
Endm
$endif
$endif
'*******************************************************************************
'* Name   : ArrayROL                                                           *
'* Author  : [??????] Modified by Alberto Freixanet                            *
'* Purpose: Rotate All bits of an Array to the LEFT.  Not reload lowest bits   *
'* Input  : Bytes Array                                                        *
'* Ouput  : Same array                                                         *
'* Syntax : ArrayROL_NR(Array Name, Array Lenght)                              *
'* Notes  :                                                                    *
'-------------------------------------------------------------------------------
$ifdef _ArrayROL_
$ifndef __ArrayROL
$define __ArrayROL

' Declare the local variables for this library.
'    LocalByte0(mya_STATUS_RegB)
'    LocalByte1(mya_ArrayLenghtB)
    Dim mya_STATUS_RegB As PRODL
    Dim mya_ArrayLenghtB As PRODH 

$define ArrayROL(pArray,pLenght) _mArray_RolNR pArray,pLenght

_mArray_RolNR  Macro- pArray,pLenght
    STARTSIZE(ArrayROL_MACRO)
    #if (Prm_Count > 2)
        #error "ArrayROL Macro - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "ArrayROL Macro - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte_Array_Ptr)
                #error "ArrayROL - ByteArray -(Param1) Should be a Byte Array!"
                Exitm
            #else
                GoSub MyA_SaveFSR0_Sub
                #if (Prm_1 == Byte_Array_Ptr)
                    Num_FSR0 pArray
                #endif
            #endif
    
            #if (Prm_2 != Num8)
                #error "ArrayROL - Lenght -(Param2) Should be a Num8"
                Exitm
            #else
                #if(Prm_2 == Num8)
                    #if (pLenght == 0)
                        #error "ArrayROL - Lenght -(Param1) The lenght of an array cannot be null!"
                        Exitm                    
                    #endif
                    Num_Byte pLenght, mya_ArrayLenghtB
                #endif
            #endif
            GoSub _mArray_RolNR_Sub
            GoSub MyA_RestoreFSR0_Sub
        #endif
    #endif
    ENDSIZE(ArrayROL_MACRO)
    Endm

#ifMacro- _mArray_RolNR
_mArray_RolNR_Sub:
    STARTSIZE(Array_RolNR_LIB)
    STATUS.0 = 0                    ' Clear the Carry Bit
    mya_STATUS_RegB = STATUS         ' Save the STATUS REG to mya_STATUS_RegB
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        STATUS = mya_STATUS_RegB     ' Restore the STATUS REG from mya_STATUS_RegB
        Asm
        Rlcf INDF0,F,0              ' Roll All bits to the left with carry
        EndAsm
        mya_STATUS_RegB = STATUS     ' Save the STATUS REG to mya_STATUS_RegB
        Inc FSR0                    ' Modified original routine. The RAM pointer is WORD.
        Dec mya_ArrayLenghtB         ' Check if All bits are ROTATED 
    Until mya_ArrayLenghtB = 0 
    Return
    ENDSIZE(Array_RolNR_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name   : ArrayROR                                                           *
'* Author  : [??????] Modified by Alberto Freixanet                            *
'* Purpose: Rotate All bits of an Array To the RIGHT.  Not reload lowest bits  *
'* Input  : Bytes Array                                                        *
'* Ouput  : Same array                                                         *
'* Syntax : ArrayROR(Array Name, Array Lenght)                                 *
'* Notes  :                                                                    *
'*******************************************************************************
$ifdef _ArrayROR_
$ifndef __ArrayROR
$define __ArrayROR

' Declare the local variables for this library.
'    LocalByte0(myb_STATUS_Reg)
'    LocalByte1(myb_ArrayLenght)    
    Dim myb_STATUS_Reg As PRODL
    Dim myb_ArrayLenght As PRODH    

$define ArrayROR(pArray,pLenght) _mArray_RorNR pArray,pLenght

_mArray_RorNR  Macro- pArray,pLenght
    STARTSIZE(ArrayROR_MACRO)
    #if (Prm_Count > 2)
        #error "ArrayROR Macro - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "ArrayROR Macro - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte_Array_Ptr)
                #error "ArrayROR - ByteArray -(Param1) Should be a Byte Array!"
                Exitm
            #else
                GoSub MyA_SaveFSR0_Sub
                #if (Prm_1 == Byte_Array_Ptr)
                    Num_FSR0 pArray
                #endif
            #endif
    
            #if (Prm_2 != Num8)
                #error "ArrayROR - Shift -(Param2) Should be a Num8"
                Exitm
            #else
                #if(Prm_2 == Num8)
                    #if (pLenght == 0)
                        #error "ArrayROR - Lenght -(Param1) The lenght of an array cannot be null!"
                        Exitm                    
                    #endif
                    Num_Byte pLenght, myb_ArrayLenght
                #endif
            #endif
            GoSub _mArray_RorNR_Sub
            GoSub MyA_RestoreFSR0_Sub
        #endif
    #endif
    ENDSIZE(ArrayROR_MACRO)
Endm

#ifMacro- _mArray_RorNR
_mArray_RorNR_Sub:
    STARTSIZE(Array_RorNR_LIB)
    STATUS.0 = 0                        ' Clear the Carry Bit
    myb_STATUS_Reg = STATUS             ' Save the STATUS to mya_STATUS_RegB 
    FSR0 = FSR0 + (myb_ArrayLenght - 1) ' Goto the upper byte of the array 
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        STATUS = myb_STATUS_Reg         ' Restore the STATUS REG from mya_STATUS_RegB
        Asm
        Rrcf INDF0,F,0
        EndAsm
        myb_STATUS_Reg = STATUS         ' Save the STATUS to mya_STATUS_RegB 
        Dec FSR0                        ' Modified original routine. The RAM pointer is WORD.
        Dec myb_ArrayLenght
    Until myb_ArrayLenght = 0           ' Check if All bits are ROTATED
    Return
    ENDSIZE(Array_RorNR_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name   : ArrayROLR                                                          *
'* Author  : [??????] Modified by Alberto Freixanet                            *
'* Purpose: Rotate All bits of an Array To the LEFT. With reload lowest bits   *
'* Input  : Bytes Array                                                        *
'* Ouput  : Same array                                                         *
'* Syntax : ArrayROLR(Array Name,Array Lenght)                                 *
'* Notes  :                                                                    *
'*******************************************************************************
$ifdef _ArrayROLR_
$ifndef __ArrayROLR
$define __ArrayROLR

' Declare the local variables for this library.
'    LocalByte0(myc_STATUS_Reg)
'    LocalByte1(myc_ArrayLenght)    
    Dim myc_STATUS_Reg As PRODL
    Dim myc_ArrayLenght As PRODH
        
$define ArrayROLR(pArray,pLenght) _mArray_RolWR pArray,pLenght

_mArray_RolWR  Macro- pArray,pLenght
    STARTSIZE(ArrayROLR_MACRO)
    #if (Prm_Count > 2)
        #error "_mArray_RolWR Macro - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mArray_RolWR Macro - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte_Array_Ptr)
                #error "_mArray_RolWR - ByteArray -(Param1) Should be a Byte Array!"
                Exitm
            #else
                GoSub MyA_SaveFSR0_FSR1_Sub
                #if (Prm_1 == Byte_Array_Ptr)
                    Num_FSR0 pArray
                    Num_FSR1 pArray
                #endif
            #endif
    
            #if (Prm_2 != Num8)
                #error "_mArray_RolWR - Shift -(Param2) Should be a Num8"
                Exitm
            #else
                #if(Prm_2 == Num8)
                    #if (pLenght == 0)
                        #error "_mArray_RolWR - Lenght -(Param1) The lenght of an array cannot be null!"
                        Exitm                    
                    #endif
                    Num_Byte pLenght, myc_ArrayLenght
                #endif
            #endif
            GoSub _mArray_RolWR_Sub
            GoSub MyA_RestoreFSR0_FSR1_Sub
        #endif
    #endif
    ENDSIZE(ArrayROLR_MACRO)
Endm

#ifMacro- _mArray_RolWR
_mArray_RolWR_Sub:
    STARTSIZE(Array_RolWR_LIB)
    myc_STATUS_Reg = STATUS         ' Save the STATUS to mya_STATUS_RegB
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        STATUS = myc_STATUS_Reg     ' Restore the STATUS REG from mya_STATUS_RegB
        Asm
        Rlcf INDF0,F,0              ' Roll All bits to the left with carry
        EndAsm
        myc_STATUS_Reg = STATUS     ' Save the STATUS to mya_STATUS_RegB
        Inc FSR0                    ' Modified original routine. The RAM pointer is WORD.
        Dec myc_ArrayLenght         
    Until myc_ArrayLenght = 0       ' Check if All bits are ROTATED 
    Asm
    Bcf   INDF1,0,0
    Btfsc myc_STATUS_Reg,0,0        ; Check the highest bit of the highest Byte to be rotated.
    Bsf   INDF1,0,0
    EndAsm
    Return
    ENDSIZE(Array_RolWR_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Macro Name        : ArrayRORR                                               *
'* Author  : [??????] Modified by Alberto Freixanet                            *
'* Input Variables   : Bytes Array                                             *
'* Destination       : Same array                                              *
'* Definition        : Rotate All bits of an Array to the RIGHT                *
'*                   : Not reload the highest bits                             *
'* Syntax            : ArrayRORR(Array Name, Array Lenght)                     *
'* Notes             : With reload the lowest bits                             *
'*******************************************************************************
$ifdef _ArrayRORR_
$ifndef __ArrayRORR
$define __ArrayRORR

' Declare the local variables for this library.
'    LocalByte0(myd_STATUS_Reg)
'    LocalByte1(myd_ArrayLenght)    
    Dim myd_STATUS_Reg As PRODL
    Dim myd_ArrayLenght As PRODH 
    
$define ArrayRORR(pArray,pLenght) _mArray_RorWR pArray,pLenght

_mArray_RorWR  Macro- pArray,pLenght
    STARTSIZE(ArrayRORR_MACRO)
    #if (Prm_Count > 2)
        #error "_mArray_RorWR Macro - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mArray_RorWR Macro - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte_Array_Ptr)
                #error "_mArray_RorWR - ByteArray -(Param1) Should be a Byte Array!"
                Exitm
            #else
                GoSub MyA_SaveFSR0_FSR1_Sub
                #if (Prm_1 == Byte_Array_Ptr)
                    Num_FSR0 pArray
                #endif
            #endif
    
            #if (Prm_2 != Num8)
                #error "_mArray_RorWR - Shift -(Param2) Should be a Byte or a Num8"
                Exitm
            #else
                #if(Prm_2 == Num8)
                    #if (pLenght == 0)
                        #error "_mArray_RorWR - Lenght -(Param1) The lenght of an array cannot be null!"
                        Exitm                    
                    #endif
                    Num_Byte pLenght, myd_ArrayLenght
                #endif
            #endif
            GoSub _mArray_RorWR_Sub
            GoSub MyA_RestoreFSR0_FSR1_Sub
        #endif
    #endif
    ENDSIZE(ArrayRORR_MACRO)
Endm

#ifMacro- _mArray_RorWR
_mArray_RorWR_Sub:
    STARTSIZE(Array_RorWR_LIB)
    myd_STATUS_Reg = STATUS             ' Save the STATUS REG to mya_STATUS_RegB 
    FSR0 = FSR0 + (myd_ArrayLenght - 1) ' Goto the upper byte of the array 
    FSR1 = FSR0                         ' Copy the address of the array to FSR1
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        STATUS = myd_STATUS_Reg         ' Restore the STATUS from mya_STATUS_RegB
        Asm
        Rrcf INDF0,F,0
        EndAsm
        myd_STATUS_Reg = STATUS         ' Save the STATUS REG to mya_STATUS_RegB 
        Dec FSR0
        Dec myd_ArrayLenght
    Until myd_ArrayLenght = 0           ' Check if All bits are ROTATED
    Asm
    Bcf   INDF1,7,0
    Btfsc myd_STATUS_Reg,0,0            ; Check the lowest bit of the lowest Byte to be rotated.
    Bsf   INDF1,7,0
    EndAsm
    Return
    ENDSIZE(Array_RorWR_LIB)
#endIfMacro-
'*******************************************************************************
'$if _defined(_ArrayROL_) Or _defined(_ArrayROR_) Or _defined(_ArrayROLR_) Or _defined(_ArrayRORR_)
' Declare the local variables for this subroutine.
    LocalWord0(mya_FSR0W)
    LocalWord1(mya_FSR1W)
    
'#ifMacro- _mHRSOutArrayASCII, _mHRSOutArrayHex,_mArray_RolNR,_mArray_RorNR,_mArray_RolWR,_mArray_RorWR
#ifMacro- _mArray_RolNR,_mArray_RorNR,_mArray_RolWR,_mArray_RorWR
MyA_SaveFSR0_FSR1_Sub:
    mya_FSR1W = FSR1   
MyA_SaveFSR0_Sub:
    mya_FSR0W = FSR0
    Return
MyA_RestoreFSR0_FSR1_Sub:
    FSR1 = mya_FSR1W    
MyA_RestoreFSR0_Sub:
    FSR0 = mya_FSR0W
    Return    
#endIfMacro-
'#endif
$endif
$endif
'*******************************************************************************
'* Name    : GetArrayBit, WriteArrayBit, SetArrayBit, ClearArrayBit            *
'* Author  : [??????] Modified by Alberto Freixanet                            *
'* Purpose : get/write/Set/Clear a bit from an array                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : GetArrayBit(pBitArray,pIndex)                                     *
'*           GetArrayBit command                                               *
'*           30/08/2018 Corrected original error when the index bit is equal 0 *
'******************************************************************************* 
$ifdef _ArrayBit_
$ifndef __ArrayBit
$define __ArrayBit

' Declare the Local Variables of this library.
    LocalByte0(BitArrayIndex)
    LocalByte1(BitArrayTemp1)    
    LocalByte2(BitArrayTemp2)
    LocalByte3(SetbitArrayValue)        

$define GetArrayBit(pBitArray,pIndex) _mGetArrayBit pBitArray,pIndex

'GetArrayBitM Macro  BitArray, Index
_mGetArrayBit Macro-  pBitArray,pIndex 
    STARTSIZE(GetArrayBit_MACRO)
    #if (Prm_Count > 2) 
        #error "GetArrayBit - Too many parameters" 
    #else 
        #if (Prm_Count < 2) 
            #error "GetArrayBit - Too few parameters" 
        #else 
            #if(Prm_1 != Byte_Array_Ptr) 
                #error "GetArrayBit - BitArray(Param1) Should be a BYTE Array" 
            #endif 
            #if(Prm_2 != Byte) && (Prm_2 != Num8) 
                #error "GetArrayBit - Index(Param2) Should be a Byte variable or number" 
            #endif 
            #if (Prm_1 == Byte_Array_Ptr) 
                Num_FSR0 pBitArray 
            #endif 
            #if (Prm_2 == Byte) 
                Byte_Byte pIndex, BitArrayIndex 
            #endif 
            #if (Prm_2 == Num8) 
                Num_Byte pIndex, BitArrayIndex 
            #endif  
            GoSub TestBitArray_Sub 
        #endif 
        #if (_mGetArrayBit_RETURN != 1) 
            #error "GetArrayBit - Mandatory return parameter misssing" 
        #else 
            #if(Return_Type !=Byte) 
                #error "GetArrayBit - Return variable should be a Byte variable" 
            #else 
                #if (Return_Type == Byte) 
                    Byte_Byte BitArrayTemp2, Return_Var 
                #endif 
            #endif 
        #endif 
    #endif 
    ENDSIZE(GetArrayBit_MACRO)
Endm

#ifMacro- _mGetArrayBit
TestBitArray_Sub:
    #ifdef BankA_End
        #if (SetbitArrayValue > BankA_End)
            #error "The variables of _mGetArrayBit Macro must reside in BankA" 
        #endif      
    #endif
    STARTSIZE(GetArrayBit_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    GoSub SetBitArrayPointer
    If BitArrayTemp2 > 0 Then
        BitArrayTemp2 = INDF0 >> BitArrayTemp2
        BitArrayTemp2 = BitArrayTemp2 & 1
    Else
        BitArrayTemp2 = INDF0 & 1    
    EndIf
    Return
    ENDSIZE(GetArrayBit_LIB)
#endIfMacro-
'-------------------------------------------------------------------------------
$define WriteArrayBit(pBitArray, pIndex, pValue) _mWriteArrayBit pBitArray, pIndex, pValue

'WriteArrayBitM Macro  P1, P2, P3    
_mWriteArrayBit Macro- pBitArray, pIndex, pValue
    STARTSIZE(WriteArrayBit_MACRO)
    #if (Prm_Count > 3)
    	#error "WriteArrayBit - Too many parameters"
    #else
    	#if (Prm_Count < 3)
    		#error "WriteArrayBit - Too few parameters"
    	#else
    		#if(Prm_1 != Byte_Array_Ptr)
    			#error "WriteArrayBit - BitArray(Param1) Should be a BYTE array pointer"
    		#endif
    		#if(Prm_2 != Byte) && (Prm_2 != Num8)
    			#error "WriteArrayBit - Index(Param2) Should be a Byte variable or number"
    		#endif
    		#if(Prm_3 != Byte) && (Prm_3 != Num8)
    			#error "WriteArrayBit - Value(Param3) Should be a Byte variable or number"
    		#endif    		
    		#if (Prm_1 == Byte_Array_Ptr)
    		Num_FSR0 pBitArray
            #endif
    		#if (Prm_2 == Byte)
    			Byte_Byte pIndex, BitArrayIndex
    		#endif
    		#if (Prm_2 == Num8)
    			Num_Byte pIndex, BitArrayIndex
    		#endif
    		#if (Prm_3 == Byte)
    			Byte_Byte pValue, SetbitArrayValue
    		#endif
    		#if (Prm_3 == Num8)
    			Num_Byte pValue, SetbitArrayValue
    		#endif
    		GoSub SetBitArraySub
    	#endif
    #endif
    ENDSIZE(WriteArrayBit_MACRO)
Endm
'-------------------------------------------------------------------------------
$define SetArrayBit(pBitArray, pIndex) _mSetArrayBit pBitArray, pIndex

'SetArrayBitM Macro  BitArray, Index    
_mSetArrayBit Macro-  pBitArray, pIndex
    STARTSIZE(SetArrayBit_MACRO)
    #if (Prm_Count > 2)
    	#error "SetArrayBit - Too many parameters"
    #else
    	#if (Prm_Count < 2)
    		#error "SetArrayBit - Too few parameters"
    	#else
    		#if(Prm_1 != Byte_Array_Ptr)
    			#error "SetArrayBit - BitArray(Param1) Should be a BYTE array pointer"
    		#endif
    		#if(Prm_2 != Byte) && (Prm_2 != Num8)
    			#error "SetArrayBit - Index(Param2) Should be a Byte variable or number"
    		#endif
    		#if (Prm_1 == Byte_Array_Ptr) && ((Prm_2 == Byte) || (Prm_2 == Num8))
	    		#if (Prm_1 == Byte_Array_Ptr)
	    		Num_FSR0 pBitArray
                #endif
	    		#if (Prm_2 == Byte)
	    			Byte_Byte pIndex, BitArrayIndex
	    		#endif
	    		#if (Prm_2 == Num8)
	    			Num_Byte pIndex, BitArrayIndex
	    		#endif
                #ifMacro- _mSetArrayBit
	   			SetbitArrayValue = 1
	    		#endIfMacro-
                GoSub SetBitArraySub
            #endif 
    	#endif
    #endif
    ENDSIZE(SetArrayBit_MACRO)
Endm
'-------------------------------------------------------------------------------
$define ClearArrayBit(pBitArray, pIndex) _mClearArrayBit pBitArray, pIndex
   
'ClearArrayBitM Macro  BitArray, Index    
_mClearArrayBit Macro- pBitArray, pIndex
    STARTSIZE(ClearArrayBit_MACRO)
    #if (Prm_Count > 2)
    	#error "ClearArrayBit - Too many parameters"
    #else
    	#if (Prm_Count < 2)
    		#error "ClearArrayBit - Too few parameters"
    	#else
    		#if(Prm_1 != Byte_Array_Ptr)
    			#error "ClearArrayBit - BitArray(Param1) Should be a BYTE array pointer"
    		#endif
    		#if(Prm_2 != Byte) && (Prm_2 != Num8)
    			#error "ClearArrayBit - Index(Param2) Should be a Byte variable or number"
    		#endif
    		#if (Prm_1 == Byte_Array_Ptr) && ((Prm_2 == Byte) || (Prm_2 == Num8))
	    	    #if (Prm_1 == Byte_Array_Ptr)
	  		       Num_FSR0 pBitArray
                #endif
	    		#if (Prm_2 == Byte)
	   			Byte_Byte pIndex, BitArrayIndex
	    		#endif
	    		#if (Prm_2 == Num8)
	    		Num_Byte pIndex, BitArrayIndex
	    		#endif
	   			#ifMacro- _mClearArrayBit
                SetbitArrayValue = 0
	    		#endIfMacro-
                GoSub SetBitArraySub 
            #endif               
    	#endif
    #endif
    ENDSIZE(ClearArrayBit_MACRO)
Endm

#ifMacro- _mGetArrayBit, _mWriteArrayBit, _mSetArrayBit, _mClearArrayBit
SetBitArrayPointer:
    #ifdef BankA_End
        #if (SetbitArrayValue > BankA_End)
            #error "The variables of _mGetArrayBit Macro must reside in BankA" 
        #endif      
    #endif
    STARTSIZE(SetBitArrayPointer_LIB)
    BitArrayTemp1 = BitArrayIndex / 8
    '/ code modified 30/08/2018
    FSR0 = FSR0 + BitArrayTemp1
    BitArrayTemp2 = BitArrayIndex & 7    
    Return
    ENDSIZE(SetBitArrayPointer_LIB)
#endIfMacro-
'
#ifMacro- _mWriteArrayBit, _mSetArrayBit, _mClearArrayBit
SetBitArraySub:
    #ifdef BankA_End
        #if (SetbitArrayValue > BankA_End)
            #error "The variables of _mGetArrayBit Macro must reside in BankA" 
        #endif      
    #endif
    STARTSIZE(SetBitArraySub_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
	GoSub SetBitArrayPointer 
'	Movff INDF0,BitArrayTemp1
'	Movf BitArrayTemp2,W,0
'	Bz SetBitArrayL2	

    '/ code changed to basic 30/08/2018
    BitArrayTemp1 = INDF0
    WREG = BitArrayTemp2
    If WREG = 0 Then GoTo SetBitArrayL2 

SetBitArrayL1:
	Rrncf INDF0,F,0
	Decfsz WREG,F,0
	Bra SetBitArrayL1

SetBitArrayL2: 
    INDF0.0 = SetbitArrayValue
'	Movf BitArrayTemp2,W,0
'	Bz SetBitArrayL3                                          
'	Bcf STATUS,0,0	

    '/ code changed to basic 30/08/2018
    WREG = BitArrayTemp2
    If WREG = 0 Then GoTo SetBitArrayL3
    STATUS.0 = 0
    
SetBitArrayL4:
	Rlncf INDF0,F,0
	Decfsz WREG,F,0
	Bra SetBitArrayL4
SetBitArrayL3:                                              
    Return
    ENDSIZE(SetBitArraySub_LIB)
#endIfMacro-
'
$endif
$endif
'*******************************************************************************
'* Name   : Multi_RAM_Byte_Array.Inc                                           *
'*  Author: [Les Johnson] 2015                                                 *
'*  Purpose : Create a 2 dimensional Byte array                                *
'*  Notes   : This will also create several constants:                         *
'*           ArrayName#SizeY holds the amount of Columns                       *
'*           ArrayName#SizeX holds the amount of Rows                          *
'*           ArrayName#Size  holds the overall amount of elements              *
'*           contained in the array                                            *
'*  Syntax  : Create_MBArray ( ArrayName , Array Columns, Array Rows)          *
'*  Core    : 16, For 18F devices only. Using Proton+ Version 3.3.4.0 Onwards. *
'******************************************************************************* 
      
$ifdef _Multi_DIM_Array_
$ifndef __Multi_DIM_Array
$define __Multi_DIM_Array
'------------------------------------------------------------------------------------------
$define Create_MByteArray(pName, pDimY, pDimX) '
    Dim pName[pDimY * pDimX] As Byte Heap      '
    Symbol pName#SizeY = pDimY                 '
    Symbol pName#SizeX = pDimX                 '
    Symbol pName#Size = pDimY * pDimX          '
Asm-                                           '
    pName#v(91) = pDimY                        '
    pName#v(92) = pDimX                        '
Endasm-

'------------------------------------------------------------------------------------------
'
' Simulate a two dimension RAM Byte array Read
' The macro uses No variable RAM other that SFR registers, and no Call Stack space is used.
'
' For 18F devices only. Using Proton+ Version 3.3.4.0 Onwards.
'
' The calculation for accessing an element is: -
' FSR0 = RAM Array_Name
' FSR0 = FSR0 + Index2
' PROD = Index1 * Index2_Length    
' FSR0 = FSR0 + PROD

' Syntax: 
'   Variable = Read_MultiByteArray pRAM_ArrayName , [pIndex1 , pIndex2]
'
' Where:- 
' Variable is the 8-bit value extracted from the array
' pRAM_ArrayName is the name of the RAM array in question. i.e. a Byte array
' pIndex1 is the first index value of the array
' pIndex2 is the second index value of the array
'
'   For example, create a 4x6 RAM array
'                     
'   Create_MByteArray(MyArray, 4, 6)  ' Declare the array
'                <   X Axis    >
'                < Dimension 2 >
'             ^ 00,01,02,03,04,05  ^
' (Y Axis)    | 10,11,12,13,14,15  | (Y Axis)
' Dimension 1 | 20,21,22,23,24,25  | Dimension 1
'             v 30,31,32,33,34,35  v
'
' In order to access the 4th element from the 3rd dimension element and the 4th dimension element. i.e. value 34 in the table above, use:
'   Variable = Read_MultiByteArray MyArray,[3,4]
'
' This is analogous of Read_MultiByteArray MyArray[Y Axis, X Axis] 

$define Read_MultiByteArray(pArrayName, pIndexY, pIndexX) _mRead_MultiByteArray pArrayName, pIndexY, pIndexX

_mRead_MultiByteArray Macro- pArrayName, pIndexY, pIndexX \Byte
    STARTSIZE(Read_MultiByteArray_MACRO)
    #if((Prm_1 != String) && (Prm_1 != Byte_Array_Ptr) && (Prm_1 != Word_Array_Ptr))
        #error "_mRead_MultiByteArray parameter must be a String, byte array or word array"
        Exitm
    #endif
        #ifdef Watchdog_req
        Clrwdt
        #endif
    #if(((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32)) && ((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32)))
        Lfsr 0,(pArrayName + ((pIndexY * pArrayName#v(92)) + pIndexX))
    #else
    
        Lfsr 0,(pArrayName)                                             ' Point FSR0L/H to the start of the RAM array
        #if((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32))
            Movlw (pIndexX)
        #endif 
        #if((Prm_3 == Byte) || (Prm_3 == Word) || (Prm_3 == Dword))
            Movff (pIndexX,WREG)                                        ' Get pIndexX into WREG
        #endif
        Addwf FSR0L,F                                                   ' \
        Movlw 0                                                         ' |  Add this to FRS0L/H
        Addwfc FSR0H,F                                                  ' /
    
        #if((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32))
            Movlw (pIndexY)
        #endif
        #if((Prm_2 == Byte) || (Prm_2 == Word) || (Prm_2 == Dword))  
            Movff (pIndexY,WREG)                                        ' Get pIndexY into WREG 
        #endif
        Mullw (pArrayName#v(92))                                        ' Multiply by the length of Index 2 (Result in PRODL\H)
        Movf PRODL,W                                                    ' \ 
        Addwf FSR0L,F                                                   ' | Calculate the offset within the RAM array
        Movf PRODH,W                                                    ' |
        Addwfc FSR0H,F                                                  ' /      
    #endif
'
' At this point FSR0L/H is pointing to the correct element based on pIndexY, pIndexX and the length of pIndexX
'                
    #if(_mRead_MultiByteArray_Return == 1)                              ' Is there a return variable?
        #if((Return_Type == String) || (Return_Type == Byte_Array_Ptr) || (Return_Type == Word_Array_Ptr))  
            #error "RamByteArray macro cannot return into a String, Byte Array or Word Array"
            Exitm
        #endif
        
        #if(Return_Type == Byte)                                        ' \
            Movff (INDF0,Return_Var)                                    ' |
        #endif                                                          ' |
                                                                        ' |
        #if((Return_Type == Word) || (Return_Type == SWord))            ' |
            Movff (INDF0,Return_Var)                                    ' | Place the contents of the element into the return variable
            Clrf (Return_Var + 1)                                       ' |
        #endif                                                          ' |
                                                                        ' |
        #if(Return_Type == Dword)                                       ' |
            Movff (INDF0,Return_Var)                                    ' |
            Clrf (Return_Var + 1)                                       ' |
            Clrf (Return_Var + 2)                                       ' |
            Clrf (Return_Var + 3)                                       ' /
        #endif                                                        
    #endif
    ENDSIZE(Read_MultiByteArray_MACRO)
Endm        
'------------------------------------------------------------------------------------------
'
' Simulate a two dimension RAM Byte array Write and Read
' The macro uses No variable RAM other that SFR registers, and no Call Stack space is used.
'
' For 18F devices only. Using Proton+ Version 3.3.4.0 Onwards.
'
' The calculation for accessing an element is: -
' FSR0 = RAM Array_Name
' FSR0 = FSR0 + Index2
' PROD = Index1 * Index2_Length    
' FSR0 = FSR0 + PROD
'
' Syntax:
'   Write_MultiByteArray pRAM_ArrayName, [pIndex1, pIndex2], pValueToWrite
'
' Where:- 
' Variable is the 8-bit value extracted from the array
' pRAM_ArrayName is the name of the RAM array in question. i.e. a Byte array
' pIndex1 is the first index value of the array
' pIndex2 is the second index value of the array
'
'   For example, create a 4x6 RAM array
'                     
'   DeclareMBArray(MyArray, 4, 6)  ' Declare the array
'                <   X Axis    >
'                < Dimension 2 >
'             ^ 00,01,02,03,04,05  ^
' (Y Axis)    | 10,11,12,13,14,15  | (Y Axis)
' Dimension 1 | 20,21,22,23,24,25  | Dimension 1
'             v 30,31,32,33,34,35  v
'
' In order to access the 4th element from the 3rd dimension element and the 4th dimension element. i.e. value 34 in the table above, use:
'   Variable = Write_MultiByteArray MyArray,[3,4]
'
' This is analogous of Write_MultiByteArray MyArray,[Y Axis, X Axis] 

$define Write_MultiByteArray(pArrayName, pIndexY, pIndexX, pValueOut) _mWrite_MultiByteArray pArrayName, pIndexY, pIndexX, pValueOut

_mWrite_MultiByteArray Macro- pArrayName, pIndexY, pIndexX, pValueOut \Byte
    STARTSIZE(Write_MultiByteArray_MACRO)
    #if((Prm_1 != String) && (Prm_1 != Byte_Array_Ptr) && (Prm_1 != Word_Array_Ptr))
        #error "_mWrite_MultiByteArray parameter must be a String, byte array or word array"
        Exitm
    #endif
        #ifdef Watchdog_req
        Clrwdt
        #endif
    #if(((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32)) && ((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32)))
        Lfsr 0,(pArrayName + ((pIndexY * pArrayName#v(92)) + pIndexX))
    #else
    
        Lfsr 0,(pArrayName)                                             ' Point FSR0L/H to the start of the RAM array
        #if((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32))
            Movlw (pIndexX)
        #endif 
        #if((Prm_3 == Byte) || (Prm_3 == Word) || (Prm_3 == Dword))
            Movff (pIndexX,WREG)                                        ' Get pIndexX into WREG
        #endif
        Addwf FSR0L,F                                                   ' \
        Movlw 0                                                         ' | Add this to FRS0L/H
        Addwfc FSR0H,F                                                  ' /
    
        #if((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32))
            Movlw (pIndexY)
        #endif
        #if((Prm_2 == Byte) || (Prm_2 == Word) || (Prm_2 == Dword))  
            Movff (pIndexY,WREG)                                        ' Get pIndexY into WREG 
        #endif
        Mullw (pArrayName#v(92))                                        ' Multiply by the length of Index 2 (Result in PRODL\H)
        Movf PRODL,W                                                    ' \ 
        Addwf FSR0L,F                                                   ' | Calculate the offset within the RAM array
        Movf PRODH,W                                                    ' |
        Addwfc FSR0H,F                                                  ' /      
    #endif
    '
    ' Check the value to place into the array
    '
    #if((Prm_4 == Num8) || (Prm_4 == Num16) || (Prm_4 == Num32))     
        Num_SFR pValueOut,INDF0                                              
    #endif                                                         
    #if((Prm_4 == Byte) || (Prm_4 == Word) || (Prm_4 == Dword))    
        Movff (pValueOut,INDF0)                                    
    #endif 
    ENDSIZE(Write_MultiByteArray_MACRO)
Endm  
'-------------------------------------------------------------------------------    
$endif  ' _MULTI_DIM_ARRAY_
$endif
'*******************************************************************************
'* Name   : Gray code                                                          *
'* Author: [Alberto Freixanet] 09/11/2015                                      *
'* Purpose : Create a Gray code                                                *
'* Input   : Binary Number                                                     *
'* Output  : Gray Number                                                       *
'* Syntax  : BinToGray(pValue), GrayToBin(pValue)                              *
'* Notes   : Coding a Binary number (8 Or 16 bits) To a Gray coded number.     *
'* Core    : For 18F devices only. Using Proton+ Version 3.3.4.0 Onwards.      *
'*******************************************************************************
$ifdef _GrayCode_
$ifndef __GrayCode
$define __GrayCode

'===============================================================================
' Define the code you want.
$define _GraySmallCode_
'===============================================================================
' Declare the Local Variables of this library.
'#ifMacro- _mBinToGray,_mGrayToBin
    LocalByte0(nXOR_result)
    LocalByte1(xNumberBits)    
    LocalByte2(xStatusResult)
    LocalWord0(xGrayNumber)
    LocalWord1(xBinaryNumber)    
'#endIfMacro-
    
$define BinToGray(pValue) _mBinToGray pValue

_mBinToGray Macro- pValue
STARTSIZE(BinToGray_MACRO)
#if (Prm_Count != 1)
   #error "Incorrect amount of parameters for _mBinToGray macro. 1 Parameter required!"
   Exitm
#else
    #if (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Byte) && (Prm_1 != Word)
        #error "_mBinToGray Macro - (Param1) Should be a Number8, Number16, Byte or a Word"
        Exitm
    #else
        #if (Prm_1 == Num8) || (Prm_1 == Num16)
            Num_Word pValue, xBinaryNumber
        #endif
        #if (Prm_1 == Byte)
            Byte_Word pValue, xBinaryNumber
        #endif
        #if (Prm_1 == Word)
            Word_Word pValue, xBinaryNumber
        #endif
        GoSub xBinToGray_Sub
        #if (_mBinToGray_RETURN == 1)
            #if(Return_Type == Byte)
                Word_Byte xGrayNumber, Return_Var
            #else
                #if(Return_Type == Word)
                    Word_Word xGrayNumber, Return_Var
                #else
                    #error "_mBinToGray Macro - Return variable should be a Byte or a Word!"
                    Exitm
                #endif
            #endif
        #else
            #error "_mBinToGray Macro - Mandatory return parameter misssing"
        #endif
    #endif
#endif
ENDSIZE(BinToGray_MACRO)
Endm

$ifdef _GraySmallCode_
#ifMacro- _mBinToGray
xBinToGray_Sub:
STARTSIZE(BinToGray_LIB)
    xGrayNumber = 0                         ' xBinaryNumber result, clear first.
    nXOR_result = 0                         ' Temporal variable for Carry Bit.
    xNumberBits = 16                        ' Number of bits to encode.

xBinToGray_Loop:
    #ifdef Watchdog_req
    Clrwdt
    #endif
    xBinaryNumber = xBinaryNumber << 1      ' Shift 1 bit to the left to load the Carry.
    xStatusResult = STATUS                  ' Save the Status Carry
    WREG = nXOR_result ^ STATUS             ' XOR Carry with the previous MSB bit.
    xGrayNumber.0 = xGrayNumber.0 | WREG.0  ' Place the result in the Gray Number bit 0.
    nXOR_result = xStatusResult             ' Restore the last MSB bit of xBinaryNumber.
    Dec xNumberBits                         ' Look for the next bit.
    If xNumberBits > 0 Then
        xGrayNumber = xGrayNumber << 1      ' Shift 1 bit to the left to load the next bit.
        GoTo xBinToGray_Loop                 ' Until all bits are done.
    EndIf
    Return
ENDSIZE(BinToGray_LIB)
#endIfMacro-

$else

#ifMacro- _mBinToGray
xBinToGray_Sub:
STARTSIZE(BinToGray_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    xGrayNumber.15 = xBinaryNumber.15
    xGrayNumber.14 = xBinaryNumber.15 ^ xBinaryNumber.14
    xGrayNumber.13 = xBinaryNumber.14 ^ xBinaryNumber.13       
    xGrayNumber.12 = xBinaryNumber.13 ^ xBinaryNumber.12
    xGrayNumber.11 = xBinaryNumber.12 ^ xBinaryNumber.11
    xGrayNumber.10 = xBinaryNumber.11 ^ xBinaryNumber.10
    xGrayNumber.9  = xBinaryNumber.10 ^ xBinaryNumber.9                
    xGrayNumber.8  = xBinaryNumber.9  ^ xBinaryNumber.8
    xGrayNumber.7  = xBinaryNumber.8  ^ xBinaryNumber.7
    xGrayNumber.6  = xBinaryNumber.7  ^ xBinaryNumber.6    
    xGrayNumber.5  = xBinaryNumber.6  ^ xBinaryNumber.5
    xGrayNumber.4  = xBinaryNumber.5  ^ xBinaryNumber.4    
    xGrayNumber.3  = xBinaryNumber.4  ^ xBinaryNumber.3
    xGrayNumber.2  = xBinaryNumber.3  ^ xBinaryNumber.2    
    xGrayNumber.1  = xBinaryNumber.2  ^ xBinaryNumber.1                    
    xGrayNumber.0  = xBinaryNumber.1  ^ xBinaryNumber.0
    Return
ENDSIZE(BinToGray_LIB)
#endIfMacro-
$endif
'===============================================================================
' Decoding a Gray number (8 or 16 bits) to a Binary number.
' Input: Gray Number
' Output: Binary Number
' 
$define GrayToBin(pValue) _mGrayToBin pValue

_mGrayToBin Macro- pValue
STARTSIZE(GrayToBin_MACRO)
#if (Prm_Count != 1)
   #error "Incorrect amount of parameters for _mGrayToBin macro. 1 Parameter required!"
   Exitm
#else
    #if (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Byte) && (Prm_1 != Word)
        #error "_mGrayToBin Macro - (Param1) Should be a Number8, NUmber16, Byte or a Word"
        Exitm
    #else
        #if (Prm_1 == Num8) || (Prm_1 == Num16)
            Num_Word pValue, xGrayNumber
        #endif
        #if (Prm_1 == Byte)
            Byte_Word pValue, xGrayNumber
        #endif
        #if (Prm_1 == Word)
            Word_Word pValue, xGrayNumber
        #endif
        GoSub xGrayToBin_Sub
        #if (_mGrayToBin_RETURN == 1)
            #if (Return_Type == Byte) || (Return_Type == SByte)
                Word_Byte xBinaryNumber, Return_Var
            #else
                #if (Return_Type == Word) || (Return_Type == SWord)
                    Word_Word xBinaryNumber, Return_Var
                #else
                    #error "_mGrayToBin Macro - Return variable should be a Byte or a Word!"
                    Exitm
                #endif
            #endif
        #else
            #error "_mGrayToBin Macro - Mandatory return parameter misssing"
        #endif
    #endif
#endif
ENDSIZE(GrayToBin_MACRO)
Endm

$ifdef _GraySmallCode_
#ifMacro- _mGrayToBin
xGrayToBin_Sub:
STARTSIZE(GrayToBin_LIB)
    xBinaryNumber = 0                               ' BinaryNumber result, clear first.
    nXOR_result = 0                                 ' Temporal variable for Carry Bit.
    xNumberBits = 16                                ' Number GRAY bits to decode.
  
xGrayToBin_Loop:
    #ifdef Watchdog_req
    Clrwdt
    #endif
    xGrayNumber = xGrayNumber << 1                  ' Shift 1 bit to the left to load the Carry.
    nXOR_result = nXOR_result ^ STATUS              ' XOR Carry with the previous bit of BinaryNumber output.
    xBinaryNumber = xBinaryNumber | nXOR_result.0   ' Load the Bit to the BinaryNumber.0 position.
    Dec xNumberBits                                 ' Look for the next bit.
    If xNumberBits > 0 Then
        xBinaryNumber = xBinaryNumber << 1          ' Shift 1 bit to the left to load the next Binary bit.
        GoTo xGrayToBin_Loop                        ' Until all bits are done.
    EndIf
    Return
ENDSIZE(GrayToBin_LIB)
#endIfMacro-

$else

#ifMacro- _mGrayToBin
xGrayToBin_Sub:
STARTSIZE(GrayToBin_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    xBinaryNumber.15 = xGrayNumber.15
    xBinaryNumber.14 = xBinaryNumber.15 ^ xGrayNumber.14   
    xBinaryNumber.13 = xBinaryNumber.14 ^ xGrayNumber.13
    xBinaryNumber.12 = xBinaryNumber.13 ^ xGrayNumber.12
    xBinaryNumber.11 = xBinaryNumber.12 ^ xGrayNumber.11
    xBinaryNumber.10 = xBinaryNumber.11 ^ xGrayNumber.10
    xBinaryNumber.9  = xBinaryNumber.10 ^ xGrayNumber.9
    xBinaryNumber.8  = xBinaryNumber.9  ^ xGrayNumber.8    
    xBinaryNumber.7  = xBinaryNumber.8  ^ xGrayNumber.7    
    xBinaryNumber.6  = xBinaryNumber.7  ^ xGrayNumber.6 
    xBinaryNumber.5  = xBinaryNumber.6  ^ xGrayNumber.5 
    xBinaryNumber.4  = xBinaryNumber.5  ^ xGrayNumber.4         
    xBinaryNumber.3  = xBinaryNumber.4  ^ xGrayNumber.3 
    xBinaryNumber.2  = xBinaryNumber.3  ^ xGrayNumber.2 
    xBinaryNumber.1  = xBinaryNumber.2  ^ xGrayNumber.1     
    xBinaryNumber.0  = xBinaryNumber.1  ^ xGrayNumber.0 
    Return
ENDSIZE(GrayToBin_LIB)
#endIfMacro-
$endif
'/------------------------------------------------------------------------------
$endif
$endif
'*******************************************************************************
'* Name    : GetMAxMin, GetMAx, GetMin                                         *
'* Author  : [Tunde] Nick name in the forum                                    *
'*           Adapted by Alberto Freixanet                                      *
'* Purpose : Get the valors max & min of a bytes array                         *
'* Input   : Array                                                             *
'* Output  : pMaxValOut, pMinValOut                                            *
'* Syntax  : GetMAxMin(pArray,pBuffersize,pMaxValOut,pMinValOut)               *
'* Notes   :                                                                   *
'* PDS     : Using PDS Version 3.6.1.7                                         *
'*******************************************************************************
$ifdef _GetMinMax_

' Declare the Local Variables of this Macro.
    Dim xMaxVal As PRODH
    Dim xMinVal As PRODL    
    Dim xBuffersize As EEDATA
    
$ifndef GetMAxMin
'/ NO variable required
$define GetMAxMin(pArray,pBuffersize,pMaxValOut,pMinValOut) _mGetMAxMin pArray,pBuffersize,pMaxValOut,pMinValOut

_mGetMAxMin Macro pArray,pBuffersize,pMaxValOut,pMinValOut
    STARTSIZE(GetMAxMin_MACRO)
	#if (Prm_Count != 4)         
		#error "Incorrect amount of parameters for _mGetMAxMin macro. 4 Parameters required!"	
		Exitm
    #else
        #if (Prm_1 != Byte_Array_Ptr)
            #error "_mGetMAxMin macro - (Param1) Should be a Byte Array"
            Exitm
        #else
            #if (Prm_1 == Byte_Array_Ptr)
                Num_FSR0 pArray        ;/ Point FSR0L/H to the start of the string
            #endif
        #endif
        #if (Prm_2 != Byte) && (Prm_2 != Num8) 
            #error "_mGetMAxMin macro - (Param2) Should be a Byte or a Num8"
            Exitm
        #else
            #if (Prm_2 == Byte)
                Byte_Byte pBuffersize, xBuffersize
            #endif
            #if (Prm_2 == Num8)
                Num_Byte pBuffersize, xBuffersize
            #endif
        #endif
        #if (Prm_3 != Byte) && (Prm_3 != Word) 
            #error "_mGetMAxMin macro - (Param3) Should be a Byte or a Word Variable"
            Exitm
        #endif
        #if (Prm_4 != Byte) && (Prm_4 != Word) 
            #error "_mGetMAxMin macro - (Param4) Should be a Byte Or a Word Variable"
            Exitm
        #endif
    #endif
    GoSub _mGetMAxMin_Sub
    '/ Return_Vars
    #if (Prm_3 == Byte)
    Byte_Byte xMaxVal,pMaxValOut
    #endif
    #if (Prm_3 == Word)
    Byte_Word xMaxVal,pMaxValOut
    #endif
    #if (Prm_4 == Byte)
    Byte_Byte xMinVal,pMinValOut
    #endif
    #if (Prm_4 == Word)
    Byte_Word xMinVal,pMinValOut
    #endif
    ENDSIZE(GetMAxMin_MACRO)
Endm

#ifMacro- _mGetMAxMin
_mGetMAxMin_Sub:  
    STARTSIZE(GetMAxMin_LIB)
    xMaxVal = INDF0
    xMinVal = INDF0
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        If INDF0 > xMaxVal Then 
            xMaxVal = INDF0
        ElseIf INDF0 < xMinVal Then
            xMinVal = INDF0
        EndIf
        Inc FSR0
        Dec xBuffersize
    Until xBuffersize = 0
    Return
    ENDSIZE(GetMAxMin_LIB)
#endIfMacro-
$endif
'/------------------------------------------------------------------------------
$ifndef GetMAx
'/ NO variable required
'/ Bytes Array Input
$define GetMAx(pArray,pBuffersize,pMaxValOut) _mGetMAx pArray,pBuffersize,pMaxValOut

_mGetMAx Macro pArray,pBuffersize,pMaxValOut
    STARTSIZE(GetMAx_MACRO)
	#if (Prm_Count != 3)         
		#error "Incorrect amount of parameters for _mGetMAx macro. 3 Parameters required!"	
		Exitm
    #else
        #if (Prm_1 != Byte_Array_Ptr)
            #error "_mGetMAx macro - (Param1) Should be a Byte Array"
            Exitm
        #else
            #if (Prm_1 == Byte_Array_Ptr)
                Num_FSR0 pArray
            #endif
        #endif
        #if (Prm_2 != Byte) && (Prm_2 != Num8) 
            #error "_mGetMAx macro - (Param2) Should be a Byte or a Num8"
            Exitm
        #else
            #if (Prm_2 == Byte)
                Byte_Byte pBuffersize, xBuffersize
            #endif
            #if (Prm_2 == Num8)
                Num_Byte pBuffersize, xBuffersize
            #endif
        #endif
        #if (Prm_3 != Byte) && (Prm_3 != Word)  
            #error "_mGetMAx macro - (Param3) Should be a Byte or a Word variable"
            Exitm
        #endif
    #endif
    GoSub _mGetMAx_Sub
    '/ Return_Var
    #if (Prm_3 == Byte)
    Byte_Byte xMaxVal,pMaxValOut
    #endif
    #if (Prm_3 == Word)
    Byte_Word xMaxVal,pMaxValOut
    #endif
    ENDSIZE(GetMAx_MACRO)
Endm

#ifMacro- _mGetMAx
_mGetMAx_Sub:  
    STARTSIZE(GetMAx_LIB)
    xMaxVal = INDF0
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        If INDF0 > xMaxVal Then 
            xMaxVal = INDF0
        EndIf
        Inc FSR0
        Dec xBuffersize
    Until xBuffersize = 0
    Return
    ENDSIZE(GetMAx_LIB)
#endIfMacro-
$endif
'/------------------------------------------------------------------------------
$ifndef GetMin
'/ NO variable required
'/ Bytes Array Input
$define GetMin(pArray,pBuffersize,pMinValOut) _mGetMin pArray,pBuffersize,pMinValOut

_mGetMin Macro pArray,pBuffersize,pMinValOut
    STARTSIZE(GetMin_MACRO)
	#if (Prm_Count != 3)         
		#error "Incorrect amount of parameters for _mGetMin macro. 3 Parameters required!"	
		Exitm
    #else
        #if (Prm_1 != Byte_Array_Ptr)
            #error "_mGetMin macro - (Param1) Should be a Byte Array"
            Exitm
        #else
            #if (Prm_1 == Byte_Array_Ptr)
                Num_FSR0 pArray        ;/ Point FSR0L/H to the start of the string
            #endif
        #endif
        #if (Prm_2 != Byte) && (Prm_2 != Num8) 
            #error "_mGetMin macro - (Param2) Should be a Byte or a Num8"
            Exitm
        #else
            #if (Prm_2 == Byte)
                Byte_Byte pBuffersize, xBuffersize
            #endif
            #if (Prm_2 == Num8)
                Num_Byte pBuffersize, xBuffersize
            #endif
        #endif
        #if (Prm_3 != Byte) && (Prm_3 != Word)  
            #error "_mGetMin macro - (Param3) Should be a Byte"
            Exitm
        #endif
    #endif
    GoSub _mGetMin_Sub
    '/ Return_Var
    #if (Prm_3 == Byte)
    Byte_Byte xMinVal,pMinValOut
    #endif
    #if (Prm_3 == Word)
    Byte_Word xMinVal,pMinValOut
    #endif
    ENDSIZE(GetMin_MACRO)
Endm

#ifMacro- _mGetMin
_mGetMin_Sub:  
    STARTSIZE(GetMin_LIB)
    xMinVal = INDF0
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        If INDF0 < xMinVal Then
            xMinVal = INDF0
        EndIf
        Inc FSR0
        Dec xBuffersize
    Until xBuffersize = 0
    Return
    ENDSIZE(GetMin_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : ConvertDegC_DegF / ConvertDegF_DegC                               *
'* Author  : [All77 & Norm]                                                    *
'*           Adapted & modified by Alberto Freixanet                           *
'* Purpose : Convert the degC to degF & degF to degC                           *
'* Input   : Float variable of number                                          *
'* Output  : Return_Var Float                                                  *
'* Syntax  : ConvertDegC_DegF(pValueFloat1,pValueFloat2)                       *
'* Notes   : Using PP_AARG As Float (compiler variable) the code is shorter    *
'*******************************************************************************
$ifdef _DegC_DegF_
$ifndef __DegC_DegF
$define __DegC_DegF 

' Declare local variables 

' Declare global variables    
    $ifndef PP_AARG_Var
    $define PP_AARG_Var
    Dim PP_AARG As Float System '/ Compiler variable    
    $endif
    
$define ConvertDegC_DegF(pValueFloatIn,pValueFloatOut) '
    STARTSIZE(ConvertDegC_DegF_MACRO)                  '
    PP_AARG = pValueFloatIn                            '
    _mConvertDegC_DegF pValueFloatIn,pValueFloatOut

_mConvertDegC_DegF Macro- pValueFloatIn,pValueFloatOut
    GoSub ConvertDegC_DegF_Sub
    '/ Return_Var
    #if (Prm_2 == Float)
        Float_Float PP_AARG,pValueFloatOut
    #else
        #error "_mConvertDegC_DegF Macro - Return variable should be a Float variable!"
        Exitm
    #endif
    ENDSIZE(ConvertDegC_DegF_MACRO)
Endm

#ifMacro- _mConvertDegC_DegF
ConvertDegC_DegF_Sub:
    STARTSIZE(ConvertDegC_DegF_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    PP_AARG = (PP_AARG * 1.8) + 32
    Return
    ENDSIZE(ConvertDegC_DegF_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------

$define ConvertDegF_DegC(pValueFloatIn,pValueFloatOut) '
    PP_AARG = pValueFloatIn                            '
    _mConvertDegF_DegC pValueFloatIn,pValueFloatOut

_mConvertDegF_DegC Macro- pValueFloatIn,pValueFloatOut
    STARTSIZE(ConvertDegF_DegC_MACRO)
    GoSub ConvertDegF_DegC_Sub
    '/ Return_Var
    #if (Prm_2 == Float)
        Float_Float PP_AARG,pValueFloatOut
    #else
        #error "_mConvertDegF_DegC Macro - Return variable should be a Float variable!"
        Exitm
    #endif
    ENDSIZE(ConvertDegF_DegC_MACRO)
Endm

#ifMacro- _mConvertDegF_DegC
ConvertDegF_DegC_Sub:
    STARTSIZE(ConvertDegF_DegC_LIB)
    PP_AARG = (PP_AARG - 32) * 0.55556
    Return
    ENDSIZE(ConvertDegF_DegC_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : HRSLStrg(x,y,z)                                                   *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Send a Cdata String to the Terminal                               *
'* Input   : x=>Label String, y=>Nb Characters, z=>Nb Carriage Return          *
'* Output  : none                                                              *
'* Syntax  : HRSLStrg(pLabel,pNbChars,pNumberCR)                               *
'* Note    : Send a String defined As a Label To the terminal                  *
'*           Code optimized 27/08/2018                                         *
'* Modif   : EECON1 = 0 disable this line 11/06/2019                           *
'*******************************************************************************
$ifdef _HRSLStrg_
$ifndef __HRSLStrg
$define __HRSLStrg

    ' Check the HRSOut command.
    $ifndef _HRSOut_
        $define _HRSOut_ HRSOut
    $endif

    $ifndef AllChars
    $define AllChars 255
    $endif
    
' Declare the aliases of this library
'    LocalByte0(bHRS_NumberCR)
'    LocalByte1(bHRS_NbChars)    
    Dim bHRS_NumberCR As Byte System
    Dim bHRS_NbChars As Byte System
    
' This routine take care of ROM memory > 64KB & Cdata written in the high side
' of the memory.

$define HRSLStrg(pLabel,pNbChars,pNumberCR) _mHRSLStrg pLabel,pNbChars,pNumberCR

_mHRSLStrg Macro- pLabel,pNbChars,pNumberCR
    STARTSIZE(HRSLStrg_MACRO)
    #if (Prm_Count < 2)
        #error "_mHRSLStrg - Too few parameters"
    #else
        #if (Prm_Count == 2)
        	#if (Prm_1 != Label)
        		#error "_mHRSLStrg - (First Char) should be a LABEL!"
                Exitm
            #else
                Load_TBLPTR(pLabel)
            #endif
        	#if (Prm_2 != Num8)
        		#error "_mHRSLStrg - (Number CR) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, bHRS_NumberCR         
                bHRS_NbChars = 255
                GoSub _mHRSLStrg_Sub
            #endif
        #endif
        #if (Prm_Count == 3)
        	#if (Prm_1 != Label)
        		#error "_mHRSLStrg - (First Char) should be a LABEL!"
                Exitm
            #else
                Load_TBLPTR(pLabel)
            #endif
        	#if (Prm_2 != Num8)
        		#error "_mHRSLStrg - (Number Characters) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, bHRS_NbChars 
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mHRSLStrg - (Number CR) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNumberCR, bHRS_NumberCR        
                GoSub _mHRSLStrg_Sub
            #endif
        #endif
    #endif
    ENDSIZE(HRSLStrg_MACRO)
Endm

#ifMacro- _mHRSLStrg
_mHRSLStrg_Sub:
    STARTSIZE(HRSLStrg_LIB)
    #if (_MAXMEM < 65537)
    TBLPTRU = 0                 ' Save a lot of Bytes.
    #endif
    EECON1 = 128                ' Access Flash memory
    While 1 = 1
        #ifdef Watchdog_req
        Clrwdt
        #endif
        Tblrd*+  
        If TABLAT > 0 Then           ' Check  if final of the string.
            If bHRS_NbChars > 0 Then
                _HRSOut_ TABLAT
                Dec bHRS_NbChars
            EndIf
        Else
            While bHRS_NumberCR > 0 ' While there is a CR character to send.
                _HRSOut_ 13         ' Sending CR character to the terminal
                $ifndef _NOTuseLF_
                _HRSOut_ 10         ' Sending a LF character to the terminal
                $endif
                Dec bHRS_NumberCR   ' Decrements the number of CR 
            Wend 
            'EECON1 = 0              ' Disable Access Flash memory.
            TBLPTRU = 0
            Return 
        EndIf
    Wend
    ENDSIZE(HRSLStrg_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : HRSFStrg(x,y,z)                                                   *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Send a full Cdata String to the Terminal                          *
'* Input   : x=>Label String, y=>Nb Characters, z=>Nb Carriage Return          *
'* Output  : none                                                              *
'* Syntax  : HRSLStrg(pLabel,pNumberCR)                                        *
'* Note    : Send a String defined As a Label To the terminal                  *
'*           Code 16/06/2019                                                   *
'* Modif   : EECON1 = 0 disable this line 11/06/2019                           *
'*******************************************************************************
$ifdef _HRSFStrg_
$ifndef __HRSFStrg
$define __HRSFStrg

    ' Check the HRSOut command.
    $ifndef _HRSOut_
        $define _HRSOut_ HRSOut
    $endif
   
' Declare the aliases of this library
'    LocalByte0(bHRS_NumberCR)
'    LocalByte1(bHRS_NbChars)    
    Dim bHRSF_NumberCR As Byte System
'    Dim bHRS_NbChars As Byte System
    
' This routine take care of ROM memory > 64KB & Cdata written in the high side
' of the memory.

$define HRSFStrg(pLabel,pNumberCR) _mHRSFStrg pLabel,pNumberCR

_mHRSFStrg Macro- pLabel,pNumberCR
    STARTSIZE(HRSLStrg_MACRO)
    #if (Prm_Count < 2)
        #error "_mHRSFStrg - Too few parameters"
    #else
    	#if (Prm_1 != Label)
    		#error "_mHRSFStrg - (First Char) should be a LABEL!"
            Exitm
        #else
            Load_TBLPTR(pLabel)
        #endif
    	#if (Prm_2 != Num8)
    		#error "_mHRSFStrg - (Number CR) should be a NUM8!"
            Exitm
        #else
            Num_Byte pNumberCR, bHRSF_NumberCR         
            GoSub _mHRSFStrg_Sub
        #endif
    #endif
    ENDSIZE(HRSLStrg_MACRO)
Endm

#ifMacro- _mHRSFStrg
_mHRSFStrg_Sub:
    STARTSIZE(HRSFStrg_LIB)
    #if (_MAXMEM < 65537)
    TBLPTRU = 0                 ' Save a lot of Bytes.
    #endif
    EECON1 = 128                ' Access Flash memory
    While 1 = 1
        #ifdef Watchdog_req
        Clrwdt
        #endif
        Tblrd*+  
        If TABLAT > 0 Then          ' Check  if final of the string.
            _HRSOut_ TABLAT
        Else
            While bHRSF_NumberCR > 0 ' While there is a CR character to send.
                _HRSOut_ 13          ' Sending CR character to the terminal
                $ifndef _NOTuseLF_
                _HRSOut_ 10          ' Sending a LF character to the terminal
                $endif
                Dec bHRSF_NumberCR   ' Decrements the number of CR 
            Wend 
            'EECON1 = 0              ' Disable Access Flash memory.
            TBLPTRU = 0
            Return 
        EndIf
    Wend
    ENDSIZE(HRSFStrg_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : PrintStrg(x,y,z,v)                                                *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Print a Cdata String to the LCD                                   *
'* Input   : x = Label String, y = Line Number, z = Column Number              *
'*           v = Number of Characters                                          *
'* Output  : none                                                              *
'* Note    : The lenght of string is limited by the LCD                        *
'*           Code optimized 27/08/2018                                         *
'*******************************************************************************
$ifdef _PrintStrg_
$ifndef __PrintStrg
$define __PrintStrg

' This routine take care of ROM memory > 64KB & Cdata written in the high side
' of the memory.
'    $ifndef _LCD_CharsLenght_
'        $define _LCD_CharsLenght_
'        Symbol __LCD_CharsLenght = 16
'    $endif

    LocalByte0(yHRS_NumberCR)
    LocalByte1(yHRS_NbChars)    
'    LocalByte2(xPos)    
'    LocalByte3(xLine)    
    Dim xPos As PRODL
    Dim xLine As PRODH    
    
$define PrintStrg(pLabel,pLine,pPos,pNbChars) _mPrintStrg pLabel,pLine,pPos,pNbChars 

_mPrintStrg Macro- pLabel,pLine,pPos,pNbChars 
    STARTSIZE(PrintStrg_MACRO)
    #if (Prm_Count < 3)
        #error "_mHRSLStrg - Too few parameters"
    #else
        #if (Prm_Count == 3)
        	#if (Prm_1 != Label)
        		#error "_mPrintStrg - (First Char) should be a LABEL!"
                Exitm
            #else
                Load_TBLPTR(pLabel)
            #endif
        	#if (Prm_2 != Num8)
                #error "_mPrintStrg Macro - (pLine) should be a NUM8!"
                Exitm
            #else
                Num_Byte pLine, xLine
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mPrintStrg Macro - (pPos) should be a NUM8!"
                Exitm
            #else
                Num_Byte pPos, xPos                
                yHRS_NbChars = 255
                GoSub _mPrintStrg_Sub
            #endif
        #endif
        #if (Prm_Count == 4)
        	#if (Prm_1 != Label)
        		#error "_mPrintStrg - (First Char) should be a LABEL!"
                Exitm
            #else
                Load_TBLPTR(pLabel)
            #endif
        	#if (Prm_2 != Num8)
                #error "_mPrintStrg Macro - (pLine) should be a NUM8!"
                Exitm
            #else
                Num_Byte pLine, xLine
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mPrintStrg Macro - (pPos) should be a NUM8!"
                Exitm
            #else
                Num_Byte pPos, xPos  
            #endif
        	#if (Prm_4 != Num8)
        		#error "_mPrintStrg - (Number Characters) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, yHRS_NbChars                    
                GoSub _mPrintStrg_Sub
            #endif
        #endif
    #endif
    ENDSIZE(PrintStrg_MACRO)
Endm

#ifMacro- _mPrintStrg
_mPrintStrg_Sub:
    STARTSIZE(PrintStrg_LIB)
    #if (_MAXMEM < 65537)
    TBLPTRU = 0                 ' Save a lot of Bytes.
    #endif
    If xLine > __LCD_LINES Then
        xLine = __LCD_LINES
    EndIf
    If xPos > __LCD_CharsLenght Then
        xPos = __LCD_CharsLenght - 1
    EndIf
    If yHRS_NbChars > __LCD_CharsLenght Then    ' Added 10/04/2017 V01
        yHRS_NbChars = __LCD_CharsLenght
    EndIf
    Cursor xLine, xPos

    EECON1 = 128                ' Access Flash memory
    GIE_Save()
    While 1 = 1
        #ifdef Watchdog_req
        Clrwdt
        #endif
        Tblrd*+  
        If TABLAT = 0 Then       ' Check  if final of the string.
            Break
        EndIf
        If yHRS_NbChars > 0 Then
            Print TABLAT
            Dec yHRS_NbChars
        Else
            Break
        EndIf
    Wend
    EECON1 = 0          ' Disable Access Flash memory.
    TBLPTRU = 0
    GIE_Restore()
    Return
    ENDSIZE(PrintStrg_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : HRSE2PStrg                                                        *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Read an E2P string and sent it to the Terminal                    *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    : Write Address, Number of ASCII characters, Number of CR,LF        *
'*******************************************************************************
$ifdef _HRSE2PStrg_
$ifndef __HRSE2PStrg
$define __HRSE2PStrg

    ' Check the HRSOut command.
    $ifndef _HRSOut_
        $define _HRSOut_ HRSOut
    $endif

    $ifndef AllChars
        $define AllChars 255
    $endif
    
' Declare the global variables.

' Definition of local Words variables.
    $if _eeprom > 256
    LocalWord0(HRSEepAddress)
    $else
    LocalByte0(HRSEepAddress)    
    $endif

    LocalByte1(xHRSe2p_NbChars)
    LocalByte2(xHRSe2p_NumberCR) 
    LocalByte3(bHRSE2PData)     
'    Dim xHRSe2p_NumberCR As PRODL
'    Dim bHRSE2PData As PRODH 
    
$define HRSE2PStrg(pAddress,pNbChars,pNumberCR) _mHRSE2PStrg pAddress,pNbChars,pNumberCR

_mHRSE2PStrg Macro- pAddress,pNbChars,pNumberCR
    STARTSIZE(HRSE2PStrg_MACRO)
    #if (Prm_Count < 2)
        #error "_mHRSE2PStrg - Too few parameters"
    #else
        #if (Prm_Count == 2)
        	#if (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Byte) && (Prm_1 != Word)
        		#error "_mHRSE2PStrg - (First Char) should be a Num8, Num16, Byte or Word!"
                Exitm
            #else
                #if (Prm_1 == Num8) || (Prm_1 == Num16)
                    $if _eeprom > 256
                    Num_Word pAddress, HRSEepAddress
                    $else
                    Num_Byte pAddress, HRSEepAddress
                    $endif
                #endif
                #if (Prm_1 == Byte)
                    $if _eeprom > 256
                    Byte_Word pAddress, HRSEepAddress
                    $else
                    Byte_Byte pAddress, HRSEepAddress
                    $endif
                #endif
                #if (Prm_1 == Word)
                    $if _eeprom > 256
                    Word_Word pAddress, HRSEepAddress
                    $else
                    Word_Byte pAddress, HRSEepAddress
                    $endif
                #endif
            #endif
        	#if (Prm_2 != Num8)
        		#error "_mHRSE2PStrg - (Number CR) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, xHRSe2p_NumberCR         
                xHRSe2p_NbChars = 255
                GoSub HRSE2PString_Sub
            #endif
        #endif
        #if (Prm_Count == 3)
        	#if (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Byte) && (Prm_1 != Word)
        		#error "_mHRSE2PStrg - (First Char) should be a Num8, Num16, Byte or Word!"
                Exitm
            #else
                #if (Prm_1 == Num8) || (Prm_1 == Num16)
                    $if _eeprom > 256
                    Num_Word pAddress, HRSEepAddress
                    $else
                    Num_Byte pAddress, HRSEepAddress
                    $endif
                #endif
                #if (Prm_1 == Byte)
                    $if _eeprom > 256
                    Byte_Word pAddress, HRSEepAddress
                    $else
                    Byte_Byte pAddress, HRSEepAddress
                    $endif
                #endif
                #if (Prm_1 == Word)
                    $if _eeprom > 256
                    Word_Word pAddress, HRSEepAddress
                    $else
                    Word_Byte pAddress, HRSEepAddress
                    $endif
                #endif
            #endif
        	#if (Prm_2 != Num8)
        		#error "_mHRSE2PStrg - (Number Characters) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, xHRSe2p_NbChars 
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mHRSE2PStrg - (Number CR) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNumberCR, xHRSe2p_NumberCR        
                GoSub HRSE2PString_Sub
            #endif
        #endif
    #endif
    ENDSIZE(HRSE2PStrg_MACRO)
Endm

#ifMacro- _mHRSE2PStrg
' Read a string written in the eeprom memory.
HRSE2PString_Sub:
    STARTSIZE(HRSE2PStrg_LIB)
    While 1 = 1
        #ifdef Watchdog_req
        Clrwdt
        #endif
        bHRSE2PData = ERead HRSEepAddress
        If bHRSE2PData > 0 Then         ' Check  if final of the string.
            If xHRSe2p_NbChars > 0 Then
                _HRSOut_ bHRSE2PData
                Dec xHRSe2p_NbChars
                Inc HRSEepAddress
            EndIf
        Else                            ' String ended
            While xHRSe2p_NumberCR > 0  ' While there is a CR character to send.
                _HRSOut_ 13             ' Sending CR character to the terminal
                _HRSOut_ 10             ' Sending a LF character to the terminal
                Dec xHRSe2p_NumberCR    ' Decrements the number of CR 
            Wend 
            Return 
        EndIf
    Wend
    ENDSIZE(HRSE2PStrg_LIB)
#endIfMacro-
$endif
$endif
'/==============================================================================
'* Purpose  : Read CData data or strings in ROM & write the characters to the eeprom.
'* Input    : ROM Lable, Number of bytes (255 => for strings)                                     
'* Output   : EEPROM
'/ Note     : If pNumberBytes = 255 then copy Strings only.
'/          : Code for small or large ROM memory
'/ Date     : 07/06/2019 by Alberto Freixanet
'/ Syntax   : CopyROMtoE2P(ROMCW_PWR,EEPCW_PWR,255) to copy string array.
'/ Syntax   : CopyROMtoE2P(ROMCW_WPM,EEPCW_WPM,1) to copy 1 byte.
'/
$ifdef _CopyROMtoE2P_
$ifndef __CopyROMtoE2P
$define __CopyROMtoE2P
'/==============================================================================
'/ Declare some Local variables.
    'Dim EEPAddress As Save_FSR2    
    LocalByte0(NbBytesROM)
    LocalWord0(EEPAddress)
                      
'/ For eeprom Label: please use eeprom address defined with Symbol.
'/ For example: Symbol EEPCW_PWR = 81
$define CopyROMtoE2P(pLableROM,pLabelEEPROM,pNumberBytes) _mReadROMWriteE2P pLableROM,pLabelEEPROM,pNumberBytes
    
_mReadROMWriteE2P Macro- pLableROM,pLabelEEPROM,pNumberBytes
	#if (Prm_Count != 3)         
		#error "Incorrect amount of parameters for _mReadROMWriteE2P - macro. 3 Parameters required!"	
		Exitm
    #else
        #if (Prm_1 != Label)
            #error "_mReadROMWriteE2P - (Param1) Should be a Num8, Num16, Byte or Word variable"
            Exitm
        #else
            '/ Loading address ROM TO TBLPTRL/TBLPTRH/TBLPTRU directly save a lot of bytes.
            #if pLableROM > 65536
                Asm-
                Movlw (pLableROM & 255)
                Movff WREG,TBLPTRL
                Movlw ((pLableROM >> 8) & 255)
                Movff WREG,TBLPTRH
                Movlw ((pLableROM >> 16) & 255)
                Movff WREG,TBLPTRU
                Endasm-
            #else
                Asm-
                Movlw (pLableROM & 255)
                Movff WREG,TBLPTRL
                Movlw ((pLableROM >> 8) & 255)
                Movff WREG,TBLPTRH           
                Endasm-
            #endif
        #endif
        '/ For this Label: please use eeprom address defined with Symbol.
        '/ For example: Symbol EEPCW_PWR = 81
        #if (Prm_2 != Num8) && (Prm_2 != Num16)
            #error "_mReadROMWriteE2P - (Param2) Should be a Num8, Num16"
            Exitm
        #else
            #if (Prm_2 == Num8) || (Prm_2 == Num16) 
            Num_Word pLabelEEPROM,EEPAddress
            #endif
        #endif
        #if (Prm_3 != Num8) && (Prm_3 != Byte)
            #error "_mReadROMWriteE2P - (Param3) Should be a Num8 or a Byte variable"
            Exitm
        #else
            #if (Prm_3 == Num8)
            Num_Byte pNumberBytes,NbBytesROM
            #endif
            #if (Prm_3 == Byte)
            Byte_Byte pNumberBytes,NbBytesROM
            #endif
        #endif
    #endif
    GoSub ReadROMWriteE2P_Sub
Endm

#ifMacro- _mReadROMWriteE2P
ReadROMWriteE2P_Sub:
    #if (_MAXMEM < 65537)
    TBLPTRU = 0     '/ Write this line here instead into the macro saves bytes.
    #endif    
    '/ Copy the ROM Data/String to eeprom.
    Do
        #ifdef Watchdog_req
        Clrwdt
        #endif
        EECON1 = 128                    '/ Access Flash memory
        Asm
        Tblrd*+
        EndAsm
        PRODH = TABLAT
        EWrite EEPAddress,[PRODH]      '/ Write the ASCII character/Numbers to eeprom 
        If NbBytesROM < 255 Then       '/ Option to copy a number of bytes.
            Dec NbBytesROM             '/ Copy Bytes.
            If NbBytesROM = 0 Then Break
        Else
            If PRODH = 0 Then Break    '/ Copy a String.    
        EndIf
        Inc EEPAddress
    Loop
    Return
#endIfMacro-
'/==============================================================================
$endif
$endif
'*******************************************************************************
'* Name    : PrintE2PStrg                                                      *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Read an E2P string and print to the LCD                           *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    : Write Address, Number of ASCII characters, Number of CR,LF        *
'*******************************************************************************
$ifdef _PrintE2PStrg_
$ifndef __PrintE2PStrg
$define __PrintE2PStrg
    
' Declare the global variables.

' Definition of local Words variables.
'    $ifndef _LCD_CharsLenght_
'        $define _LCD_CharsLenght_ 16
'        Symbol __LCD_CharsLenght = _LCD_CharsLenght_
'    $endif

    $if _eeprom > 256
    LocalWord0(zEepAddress)
    $else
    LocalByte0(zEepAddress)    
    $endif

    LocalByte1(ze2p_NbChars)
    LocalByte2(zPos)    
'    LocalByte3(zLine)    
    Dim zLine As PRODL
    
$define PrintE2PStrg(pAddress,pLine,pPos,pNbChars) _mPrintE2PStrg pAddress,pLine,pPos,pNbChars

_mPrintE2PStrg Macro- pAddress,pLine,pPos,pNbChars
    STARTSIZE(PrintE2PStrg_MACRO)
    #if (Prm_Count < 3)
        #error "_mPrintE2PStrg - Too few parameters"
    #else
        #if (Prm_Count == 3)
        	#if (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Byte) && (Prm_1 != Word)
        		#error "_mPrintE2PStrg - (First Char) should be a Num8, Num16, Byte or Word!"
                Exitm
            #else
                #if (Prm_1 == Num8) || (Prm_1 == Num16)
                    $if _eeprom > 256
                    Num_Word pAddress, zEepAddress
                    $else
                    Num_Byte pAddress, zEepAddress
                    $endif
                #endif
                #if (Prm_1 == Byte)
                    $if _eeprom > 256
                    Byte_Word pAddress, zEepAddress
                    $else
                    Byte_Byte pAddress, zEepAddress
                    $endif
                #endif
                #if (Prm_1 == Word)
                    $if _eeprom > 256
                    Word_Word pAddress, zEepAddress
                    $else
                    Word_Byte pAddress, zEepAddress
                    $endif
                #endif
            #endif
        	#if (Prm_2 != Num8)
                #error "_mPrintStrg Macro - (pLine) should be a NUM8!"
                Exitm
            #else
                Num_Byte pLine, zLine
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mPrintStrg Macro - (pPos) should be a NUM8!"
                Exitm
            #else
                Num_Byte pPos, zPos                
                #ifMacro- _mPrintE2PStrg
                ze2p_NbChars = __LCD_CharsLenght
                #endIfMacro-
                GoSub _mPrintE2PStrg_Sub
            #endif
        #endif
        #if (Prm_Count == 4)
        	#if (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Byte) && (Prm_1 != Word)
        		#error "_mPrintE2PStrg - (First Char) should be a Num8, Num16, Byte or Word!"
                Exitm
            #else
                #if (Prm_1 == Num8) || (Prm_1 == Num16)
                    $if _eeprom > 256
                    Num_Word pAddress, zEepAddress
                    $else
                    Num_Byte pAddress, zEepAddress
                    $endif
                #endif
                #if (Prm_1 == Byte)
                    $if _eeprom > 256
                    Byte_Word pAddress, zEepAddress
                    $else
                    Byte_Byte pAddress, zEepAddress
                    $endif
                #endif
                #if (Prm_1 == Word)
                    $if _eeprom > 256
                    Word_Word pAddress, zEepAddress
                    $else
                    Word_Byte pAddress, zEepAddress
                    $endif
                #endif
            #endif
        	#if (Prm_2 != Num8)
                #error "_mPrintE2PStrg Macro - (pLine) should be a NUM8!"
                Exitm
            #else
                Num_Byte pLine, zLine
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mPrintE2PStrg Macro - (pPos) should be a NUM8!"
                Exitm
            #else
                Num_Byte pPos, zPos                
            #endif
        	#if (Prm_4 != Num8)
        		#error "_mPrintE2PStrg Macro - (pNbChars) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, ze2p_NbChars                
                GoSub _mPrintE2PStrg_Sub
            #endif
        #endif
    #endif
    ENDSIZE(PrintE2PStrg_MACRO)
Endm

#ifMacro- _mPrintE2PStrg
_mPrintE2PStrg_Sub:
    STARTSIZE(PrintE2PStrg_LIB)
    If xLine > __LCD_LINES Then
        xLine = __LCD_LINES
    EndIf
    If xPos > __LCD_CharsLenght Then
        xPos = __LCD_CharsLenght - 1
    EndIf
    If ze2p_NbChars > __LCD_CharsLenght Then    
        ze2p_NbChars = __LCD_CharsLenght
    EndIf
    Cursor xLine, xPos

    While 1 = 1
        #ifdef Watchdog_req
        Clrwdt
        #endif
        PRODH = ERead zEepAddress
        If PRODH = 0 Then       ' Check  if final of the string.
            Return
        EndIf
        If yHRS_NbChars > 0 Then
            Print PRODH
            Dec ze2p_NbChars
            Inc zEepAddress
        Else
            Return
        EndIf
    Wend
    ENDSIZE(PrintE2PStrg_LIB)
#endIfMacro-
$endif
$endif
'*******************************************************************************
'* Name    : Running ADCAverageA                                               *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Built an ADCAverageA for the ADC result based in an array         *
'* Input   : ADC Result from PIC                                               *
'* Output  : Array (using a ring buffer)                                       *
'* Syntax  : ADC_AverageA_Init() / VarWord = ADC_AverageA()                    *
'* Note    : The number of bytes of the Array could be changed                 *
'*         : Must be a power of 2: 4, 8, 16, 32, 64                            *
'*         : The ADCAverageB is reached after AverageAsamples_Size samples     *
'*******************************************************************************
$ifdef _ADCaverageA_
$ifndef __ADCaverageA
$define __ADCaverageA

    $ifndef AverageAsamples_Size
        $define AverageAsamples_Size 16
    $endif
    $ifndef FastAverageAThreshold
        $define FastAverageAThreshold 512
    $endif

    
'#ifMacro- _mADC_Average
' Declare the global variables.
    Dim AverageAADCBuffer_Head As Byte System
    Dim AverageAADCBuffer[AverageAsamples_Size] As Word Heap

' Definition of local variables.
    LocalByte0(AverageLoop)
    LocalWord0(AVADC_Sum0)
    LocalDword0(AVADC_Sum)
'#endIfMacro- 

'/ Clear the pointer and load the FastAverageAThreshold into the buffer array.
$define ADC_AverageA_Init()                           '
    $define ADCaverageAInitialized                    '
    AverageAADCBuffer_Head = AverageAsamples_Size     '
    Repeat                                            '
        AverageAADCBuffer[AverageAADCBuffer_Head] = FastAverageAThreshold '
        Dec AverageAADCBuffer_Head                    '
    Until AverageAADCBuffer_Head = 0                  '
    AverageAADCBuffer_Head = 0

$define ADC_AverageA() _mADC_AverageA                '
    $ifndef ADCaverageAInitialized                   '
    $error "The ADC ADCAverageA must be initialized" '
    $endif

_mADC_AverageA Macro-
    STARTSIZE(ADC_AverageA_MACRO)
    GoSub _mADC_AverageA_Sub
    #if (_mADC_AverageA_RETURN == 1)
        #if (Return_Type == Word)
            Dword_Word AVADC_Sum,Return_Var
        #else
            #error "_mADC_AverageA Macro - Return variable should be a Word!"
            Exitm
        #endif
    #else
        #error "_mADC_AverageA Macro - Mandatory return parameter misssing"
    #endif
    ENDSIZE(ADC_AverageA_MACRO)
Endm

#ifMacro- _mADC_AverageA
_mADC_AverageA_Sub:
    STARTSIZE(ADC_AverageA_LIB)
    AverageAADCBuffer[AverageAADCBuffer_Head] = ADCResult '/ Loading the buffer with ADC result.
    Inc AverageAADCBuffer_Head                            '/ Increase the buffer pointer for next read.
    AverageAADCBuffer_Head = AverageAADCBuffer_Head & (AverageAsamples_Size - 1)    

    '/ Making the sum of all bytes of the buffer.
    AVADC_Sum = 0
    AverageLoop = AverageAsamples_Size
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        AVADC_Sum0 = AverageAADCBuffer[AverageLoop - 1]  '/ Reading every byte of the array.
        AVADC_Sum = AVADC_Sum + AVADC_Sum0               '/ Sum every value
        Dec AverageLoop
    Until AverageLoop = 0

    '/ Calculate the ADCAverageB in every readind of ADC.
    AVADC_Sum = AVADC_Sum / AverageAsamples_Size
    Return
    ENDSIZE(ADC_AverageA_LIB)
#endIfMacro-    
$endif
$endif
'*******************************************************************************
'* Name    : Running ADCAverageB                                               *
'* Author  : [Alberto Freixanet]                                               *
'* Purpose : Built an ADCAverageB for the ADC result based in a SWord          *
'* Input   : ADC Result from PIC                                               *
'* Output  : Return_Var                                                        *
'* Syntax  : ADC_AverageB_Init() / VarWord = ADC_AverageB()                    *
'* Note    : Samples must be a power of 2: 4, 8, 16, 32, 64                    *
'*         : The ADCAverageB is slower than the ADCAverageA                    *
'*           But the code is faster                                            *
'*******************************************************************************
$ifdef _ADCaverageB_
$ifndef __ADCaverageB
$define __ADCaverageB

    $ifndef AverageBsamples_Size
        $define AverageBsamples_Size 16
    $endif
    $ifndef FastAverageBThreshold
        $define FastAverageBThreshold 512
    $endif

'#ifMacro- _mADC_Average
' Declare the global variables.
    Dim ADCAverageB As SWord System

' Definition of local variables.

'#endIfMacro-

$define ADC_AverageB_Init()         '
    $define ADCaverageBInitialized  '
    ADCAverageB = FastAverageBThreshold

$define ADC_AverageB() _mADC_AverageB                '
    $ifndef ADCaverageBInitialized                   '
    $error "The ADC ADCAverageB must be initialized" '
    $endif

_mADC_AverageB Macro-
    STARTSIZE(ADC_AverageB_MACRO)
    GoSub _mADC_AverageB_Sub
    #if (_mADC_AverageB_RETURN == 1)
        #if (Return_Type == Word)
            Word_Word ADCAverageB,Return_Var
        #else
            #error "_mADC_AverageB Macro - Return variable should be a Word!"
            Exitm
        #endif
    #else
        #error "_mADC_AverageB Macro - Mandatory return parameter misssing"
    #endif
    ENDSIZE(ADC_AverageB_MACRO)
Endm

#ifMacro- _mADC_AverageB
_mADC_AverageB_Sub:
    STARTSIZE(ADC_AverageB_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    ADCAverageB = ADCAverageB -(ADCAverageB - ADCResult) / AverageBsamples_Size
    Return                                                                     
    ENDSIZE(ADC_AverageB_LIB)
#endIfMacro-    
$endif
$endif
'*******************************************************************************
'* Name    : MeasureFreq() PDS V3.6.2.3                                        *
'* Author  : [Alberto Freixanet] Sept 2018                                     *
'* Purpose : Count low frequencies: 5Hz to 50000 Hz (method: measure period)   *
'* Input   : PORTA.4 TMR0 pin input to generate an interrupt                   *
'* Output  : Return_Var => Frequency                                           *
'*         : [Word]                  [Num8]   [Word]  [Num8]                   *
'* Syntax  : Frequency = MeasureFreq(FreqMin,Decimals,Nb Decimals)             *
'*         : [Float]                 [Num8]   Num8]                            *
'* Syntax  : Frequency = MeasureFreq(FreqMin,Nb Decimals)                      *
'* Note    : Code request by Teo in the Proton Basic forum                     *
'* Important: It is very important using the Watchdog with this code.          *
'*            The results are very sensitive with interrupts.                  *
'*******************************************************************************
'/ This code displayes the frequencies from 5Hz To 5000Hz measuring the period.
'/ An edge detector is included and filters the input below 5 Hz to avoid the
'/ code hangs when there is not a frequency in pin PORTA.4.
'/ The FOSC/4 frequency instruction is used to calculate the frequency.
'/ More FOSC => more resolution.
'/
'/ Thank to the formula it is independent of FOSC. 
'/ For better resolution use the FOSC = 64Mhz (PIC18FxxKxx)
'/ If the frequency disapears when the code is counting the code can stay in an
'/ infinite loop. Then it is necessary using the PIC Watchdog in your program.
'/ The measure is very sensitive with interrupts then the insterrupts have been 
'/ disabled while counting.
'/ See the MeasurePeriod folder to read the code.
'/ The macro is in Tips_and_Trick_V14.inc file.
'/
'/ There is an option of Over Sampling. More sampling => more precision.
'/
'/ Read the LCD.
'/ L??    => Number of Loops or measures.
'/ S???   => Number of reading samples.
'/ C????? => Nomber of clocks capture.
'/ FI ??? => Frequency calculated with integers.
'/ FL ??? => Frequency calculated with Floats.

$ifdef _MeasurePeriod_
$ifndef __MeasurePeriod
$define __MeasurePeriod

'    $define __MPeriodDebug

'#ifMacro- _mMeasurePeriod
    '/ Declare global variables 
    Dim TempByte As Byte System

    '/ Declare local variables 
    LocalWord0(_mpWCapLoop)
    Dim _mpFrequency As _mpWCapLoop
    LocalWord1(_mpCtFrequMin)
    LocalWord2(_mpWordTemp)
    LocalWord3(_mpDecimalsOut)    
    LocalWord4(_mpDecimalsScale)
    $ifdef __MPeriodDebug
    LocalWord5(NbCapSamples)    '/ Only for debug.
    $endif

    LocalDword0(_mpCaptureValue)
    LocalDword1(_mpFreqRemainder)
    LocalDword2(_mpOverSampling)
    LocalDword3(_mpDectDelay)

    $ifdef __MPeriodDebug
    Dim _Oscilloscope As LATC.2 '/ Only for debug.
    $endif
    Symbol _mpCaptCst = (_xtal * 125000)/4     '/ Capture: _xtal is from Declare Xtal = XX
    Symbol _mpDectDelayCst = 104500            '/ Delay for edges detection. Start value: 210mS for 5Hz
'#endIfMacro-

'#ifMacro- _mMeasurePeriod
    '/ For Float calculations.
    '/ Declare global variables    
    $ifndef PP_AARG_Var
    $define PP_AARG_Var
    Dim PP_AARG As Float System  '/ Compiler variable      
    $endif

    $ifndef FP_FLAGS_Var
    $define FP_FLAGS_Var
    Dim _FP_FLAGS As Byte System
    Symbol FpOverflow = _FP_FLAGS.1     ' Floating point overflow
    Symbol FpUnderFlow = _FP_FLAGS.2    ' Floating point underflow
    Symbol FpDiv0 = _FP_FLAGS.3         ' Floating point divide by zero
    Symbol FpDomainError = _FP_FLAGS.5  ' Domain error exception
    $endif

    '/ Declare local variables 
    LocalByte0(_mpFltLoop)
    LocalFloat0(_mpFltResult)
'    LocalFloat1(_mpnPow10)    

'#endIfMacro-

'/ Working with Integers, you need 2 separate variables: 1 Word Variable for Frequency result & 1 Word Variable For decimals result.
'/ Working with Float, you need 1 variable Float only:

'/ This macro can run with 2 modes.
'/ Mode 1: The Return Vars are integer numbers (whole number + decimals number). (With 1 To 3 decimals configured by the user)
'/  FrequencyInteger = MeasureFreq(75,DecimalWord,2)    '/ Minimum Frequency = 75Hz, Value of decimals in DecimalWord variable, Number of Decimals. 

'/ Mode 2: The Return Var is a Float number. (With 1 to 3 decimals configured by the user)
'/  FrequencyFloat = MeasureFreq(75,2)    '/ Minimum Frequency = 75Hz, Number of decimals = 2 for FrequencyFloat 

$define MeasureFreq(pFreqMin,pDecimalsOut,pNbDecimals) _mMeasurePeriod pFreqMin,pDecimalsOut,pNbDecimals

_mMeasurePeriod Macro- pFreqMin,pDecimalsOut,pNbDecimals
    STARTSIZE(MeasurePeriod_MACRO)
    #if (Prm_Count < 2)
        #error "_mMeasurePeriod - Too few parameters"
        Exitm
    #endif
    #if (Prm_1 != Num8) && (Prm_1 != Num16)
        #error "_mMeasurePeriod - Parameter1 should be a Num8 of Num16"
        Exitm
    #else
        '/ Read the minimum frequency.
        #if (pFreqMin < 5)
            _mpCtFrequMin = 5
        #else            
            Num_Word pFreqMin,_mpCtFrequMin
        #endif
    #endif
    #if (_mMeasurePeriod_RETURN != 1)
        #error "_mMeasurePeriod - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte) && (Return_Type != Word) && (Return_Type != Dword) && (Return_Type != Float)
            #error "_mMeasurePeriod - Return variable should be a Byte, Word, Dword or Float Variable"
            Exitm
        #endif
    #endif
    #if (Return_Type == Float)
        '/ Read the number of decimals.
        #if (Prm_2 != Num8)
            #error "_mMeasurePeriod - Parameter2 should be a Num8"
            Exitm
        #else
            '/ Number of decimals for Float variable.
            #if (pDecimalsOut == 0)
                _mpFltLoop = 1          
            #else            
                #if (pDecimalsOut == 1)
                    _mpFltLoop = 1
                #else
                    #if (pDecimalsOut == 2)
                        _mpFltLoop = 2
                    #else
                        #if (pDecimalsOut == 3)
                            _mpFltLoop = 3
                        #else
                            _mpFltLoop = 3
                        #endif
                    #endif
                #endif
            #endif
        #endif
        GoSub _mMeasurePeriod_Sub       '/ Measure the period.
        GoSub _mpIntegerToFloat_Sub     '/ Transform the results to Float variable.
    #endif
    #if (Return_Type == Byte) || (Return_Type == Word) || (Return_Type == Dword)
        #if (Prm_2 != Word) && (Prm_2 != Byte)
            #error "_mMeasurePeriod - Parameter2 should be a Word or Byte variable"
            Exitm
        #endif
        #if (Prm_3 != Num8)
            #error "_mMeasurePeriod - Parameter3 should be a Num8"
            Exitm
        #else
            '/ Number of decimals for Integer variable.
            #if (pNbDecimals == 0)
                _mpFltLoop = 1          
            #else            
                #if (pNbDecimals == 1)  
                    _mpFltLoop = 1
                #else
                    #if (pNbDecimals == 2)
                        _mpFltLoop = 2
                    #else
                        #if (pNbDecimals == 3)
                            _mpFltLoop = 3
                        #else
                            _mpFltLoop = 3
                        #endif
                    #endif
                #endif
            #endif
        #endif
        GoSub _mMeasurePeriod_Sub       '/ Measure the period.
    #endif        
    '/ Return_Var => Float.
    #if (Return_Type == Float)
        Float_Float PP_AARG,Return_Var
    #else
    '/ Return_Var => Integer.        
        '/ Return Whole number.
        #if (Return_Type == Byte)
            Word_Byte _mpFrequency,Return_Var
        #endif
        #if (Return_Type == Word)
            Word_Word _mpFrequency,Return_Var
        #endif
        #if (Return_Type == Dword)
            Word_Dword _mpFrequency,Return_Var
        #endif
        '/ Return Decimals in Prm_2.
        #if (Prm_2 == Byte)
            Word_Byte _mpDecimalsOut,pDecimalsOut
        #endif
        #if (Prm_2 == Word)
            Word_Word _mpDecimalsOut,pDecimalsOut
        #endif
    #endif            
    ENDSIZE(MeasurePeriod_MACRO)
Endm

#ifMacro- _mMeasurePeriod
_mMeasurePeriod_Sub:
    STARTSIZE(MeasurePeriod_LIB)
    '/--------------------------------------------------------------------------
    #ifdef Watchdog_req
    Clrwdt
    #endif
    $ifdef __MPeriodDebug
    Low _Oscilloscope
    $endif
    CM1CON0 = 0
    CM2CON0 = 0
    $ifdef _CCP5CON
    CCP5CON = 0
    $endif
    INTCON2Bits_TMR0IP = 1
    TMR0L = 255
    INTCONBits_TMR0IE = 0   '/ Disable Timer0 interrupts.
    INTCONBits_TMR0IF = 0   '/ Clear Timer0 interrupt flag.  
    T0CON = %01111000   '/ Bit 7 TMR0ON = 0: Timer0 Off
                        '/ Bit 6 T08BIT = 1: Timer0 is configured As a 8-Bit Timer/Counter 
                        '/ Bit 5 T0CS   = 1: Transition On T0CKI pin
                        '/ Bit 4 T0SE   = 1: Increment On high-to-low transition On T0CKI pin (falling edge).
                        '/ Bit 3 PSA    = 1: = TImer0 prescaler is NOT assigned. Timer0 clock Input bypasses prescaler.
                        '/ Bit 2-0 T0PS = 000: Timer0 Prescaler Select bits
    Input PORTA.4       '/ Input pin Timer0 Counter. 

    '/--------------------------------------------------------------------------
    '/ Calculate delay to measure the lowest signal. 
    '/ Formula: ((104500 / Fmin) / 10) * _xtal
    _mpWordTemp = _mpDectDelayCst / _mpCtFrequMin
    _mpWordTemp = _mpWordTemp / 10
    _mpDectDelay = _mpWordTemp * _xtal  '/ Delay to check the input signal depending of min frequency.

    '/ Test for minimum frequency. Minimum = declared by the user. 
    '/ Edges detector to avoid the code crashes here if there is not a signal.
    _mpWCapLoop = 0
    _mpCaptureValue = 0
    PRODH = PORTA & %00010000       '/ Read state input & Mask the PORTA
    Repeat                          '/ Loop for delay depending of _xtal.
        #ifdef Watchdog_req
        Clrwdt
        #endif 
        PRODL = PORTA & %00010000   '/ Read PORTA.4 and filter all bits.
        If PRODL ^ PRODH > 0 Then   '/ Compare states.
            PRODH = PRODL
            Inc _mpWCapLoop         '/ Yes, there is a signal.
        EndIf
        Inc _mpCaptureValue         '/ Increment the delay.
    Until _mpCaptureValue = _mpDectDelay
    _mpCaptureValue = 0         '/ Clear temp variable value.

    '/ Check if no input pulses.
    If _mpWCapLoop < 2 Then     '/ If NO signal then...
        _mpFrequency = 0        '/ Clear frequency...
        _mpDecimalsOut = 0      '/ & Clear the decimals too.
        Return                  '/ No signal in input pin/Return
    EndIf
    '/--------------------------------------------------------------------------
    '/ Dinamic configuration of the oversampling.
    '/ Calculate number of samples.
    '/ Formula: (((NbEdges X (FreqMin/8(1)) + FreqMin/8) / 4) + 1
    _mpWordTemp = _mpCtFrequMin / 8 
    If _mpWordTemp = 0 Then
        Inc _mpWordTemp
    EndIf
    _mpWCapLoop = _mpWCapLoop * _mpWordTemp
    _mpWCapLoop = _mpWCapLoop + _mpWordTemp
    _mpWCapLoop = _mpWCapLoop / 4
    Inc _mpWCapLoop

    '/ Calculate value max oversampling.
    $ifdef __MPeriodDebug
    NbCapSamples = _mpWCapLoop       '/ Copy the number of samples for main program. '/ Only for debug.
    $endif
    _mpOverSampling = _mpWCapLoop * _mpCaptCst
    '/--------------------------------------------------------------------------
    $ifdef __MPeriodDebug
    '/ Start measure the Periods.
    Set _Oscilloscope       '/ Only for debug.
    $endif
    '/--------------------------------------------------------------------------
    STARTSIZE(MeasurePeriod_LOOP)
    '/ Measure loop.
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif 
        '/ Configure the Timer0 to start.
        GIE_Save()                  '/ Save and clear interrupts.
        INTCONBits_TMR0IF = 0
        T0CONBits_TMR0ON = 1        '/ Start Timer0
        TMR0L = 255                 '/ Preload the counter for interrupt.

        '/ Loop
        '/Waiting 1st falling edge.
        While INTCONBits_TMR0IF = 0 : Wend
        T0CONBits_TMR0ON = 0        '/ Timer0 => OFF
        INTCONBits_TMR0IF = 0       '/ Clear Timer0 interrupt flag.
        TMR0L = 255                 '/ Preload the counter for next interrupt.
        '/
        T0CONBits_TMR0ON = 1        '/ Start Timer0 again

        '/Waiting 2nd falling edge.
        Repeat
            Inc _mpCaptureValue     '/ Counting...
        Until INTCONBits_TMR0IF = 1 '/ Interrupt flag (negative edge in input) then stops counting.
        '/ End loop

        T0CONBits_TMR0ON = 0        '/ Timer0 => Stop
        INTCONBits_TMR0IF = 0       '/ Clear Timer0 interrupt flag.
        GIE_Restore()               '/ Restore interrupts if necessary.
        '/
        Dec _mpWCapLoop
    Until _mpWCapLoop = 0           '/ Read all samples.
    ENDSIZE(MeasurePeriod_LOOP)
    '/--------------------------------------------------------------------------
    $ifdef __MPeriodDebug
    '/ Stop measure the Periods.
    Clear _Oscilloscope             '/ Only for debug.
    $endif
    '/--------------------------------------------------------------------------
    '/ Decimals scale.
    If _mpFltLoop = 1 Then
        _mpDecimalsScale = 10   '/ For 1 decimal.    
    ElseIf _mpFltLoop = 2 Then
        _mpDecimalsScale = 100  '/ For 2 decimals.
    ElseIf _mpFltLoop = 3 Then
        _mpDecimalsScale = 1000 '/ For 3 decimals.     
    EndIf
    $ifdef __MPeriodDebug
    EEDATA = _mpFltLoop         '/ Only for debug.
    $endif

    '/ Calculations.
    _mpFrequency = _mpOverSampling / _mpCaptureValue    '/ Calculate the frequency. (Word) 
    Dword_Dword PPZ,_mpFreqRemainder                    '/ Extract the remainder: (Dword) This Trick that saves 32 bytes of code.
    _mpFreqRemainder = _mpFreqRemainder * _mpDecimalsScale  '/ Change the scale for the decimals.
    _mpDecimalsOut = _mpFreqRemainder / _mpCaptureValue     '/ _mpDecimalsOut (Word) => 3 decimals max.
    Return
'/==============================================================================
'/ Conversion of Integer to Float.
_mpIntegerToFloat_Sub:
    '/ Load the whole part.
    GIE_Save()
    _mpFltResult = _mpFrequency     '/ Float <= Word

    '/ Load the decimal part.
    PP_AARG = _mpDecimalsOut / _mpDecimalsScale '/ Decimals / 10,100,1000.
    PP_AARG = _mpFltResult + PP_AARG            '/ ADD with the Whole value.
    GIE_Restore()
    '/ PP_AARG for Return_Var
    Return
    '/--------------------------------------------------------------------------
    ENDSIZE(MeasurePeriod_LIB)
#endIfMacro-
$endif
$endif
'/------------------------------------------------------------------------------
(*
'/ Conversion of Integer to Float.
_mpIntegerToFloat_Sub:
    '/ Load the whole part.
    _mpFltResult = _mpFrequency     '/ Float <= Word

    '/ Load the decimal part.
    _mpnPow10 = 1
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        Dec _mpFltLoop
        GIE_Save()
        _mpnPow10 = _mpnPow10 * 10
        PP_AARG = Dig _mpDecimalsOut,_mpFltLoop
        PP_AARG = PP_AARG / _mpnPow10
        _mpFltResult = _mpFltResult + PP_AARG 
        GIE_Restore()
    Until _mpFltLoop = 0
    '/ _mpFltResult for Return_Var
    Return
*)
'*******************************************************************************
'* Name    : Measure_Time.inc                                                  *
'* Author  : [Alberto FREIXANET]                                               *
'* Notice  : Copyright (c) 2013 [Alberto FREIXANET]                            *
'*         : All Rights Reserved                                               *
'* Date    : 21/10/2013 Published 23/10/2013                                   *
'* Version : 1.0                                                               *
'* Purpose : Count The execution time of a code (in a PIC)                     *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Syntax  : MT_Timer1On()/MT_Timer1Stop()/MT_Print_Timer1Result()             *
'* Note    : There is an errata in the PIC. Use the 64 Mhz Clock               *
'*         : The precision is + 1 cycle.                                       *
'*         : Time max to read (1 Word = 2 Bytes) 65535 cycles = 4,095938 mS    *
'*         : Use this code without Interrupts                                  *
'*******************************************************************************
(*
    This program measures execution time and will assist with time
    critical applications.
    Sometimes with the AMICUS18 board we need some help to
    check the code that you are writing. In particular I wrote this
    macro to measure the PIC execution times that are then sent to
    the terminal.
    By extension you could use this library with other PICs with the
    Proton Basic compiler.
    We make use of the power of Proton Basic compiler by
    incorporating different test programs for PICs and boards. It is
    very important for the resolution of our code if in the demo
    program you choose the AMICUS18 board or any board available
    on the Proteus Demo.
    After picking a Protonxx.inc the processor and the frequency
    crystal are automatically loaded, then follow the instructions. The
    precision is a little bit more than the reality, the code can read 1
    instruction cycle.
*)
'/ 19/05/2013-Version 1.01: Change Xtal clock. Posibility to work with 64 or 80 Mhz Xtal.
'/ 19/05/2013-Version 1.01: Change Xtal clock. Puede calcular con un Xtal de 64 o 80 Mhz.
'/ 03/08/2013-Version 1.10: Add the configuration for the Timer1 for the PIC18F25K20,
'                           because is different.
'/ 23/09/2018 Include the macros in Tips_and_Tricks.inc.
'/
$ifdef _MeasureTime_
$ifndef __MeasureTime
$define __MeasureTime
'/------------------------------------------------------------------------------
'    Declare Unsigned_Dwords = On
' Inicializacin del Timer1

$define MeasureTime_Init() _mMCountTimer1_Init

_mMCountTimer1_Init Macro-
    GoSub _mMTCountTimer1_Init_Sub
Endm

#ifMacro- _mMCountTimer1_Init
_mMTCountTimer1_Init_Sub:
    STARTSIZE(MeasureTime_LIB)
' Clock source FOSC/4 = 16Mhz: Errata with clock = 64Mhz
' Without prescaler
' 16 Bits Timer
' Note: The 18F25K22 and the 18F25K20 are very differents peripherals.
'
    #ifdef Watchdog_req
    Clrwdt
    #endif 

    PIE1Bits_TMR1IE = 0 ' Disables the TMR1 overflow interrupt
    PIR1Bits_TMR1IF = 0 ' Clear the TMR1 flag interrupt
    $ifdef _PMD0
    PMD0Bits_TMR1MD = 0 ' Timer1 peripheral Module Enabled (in case of...)
    $endif
    T1CON = 0
    T1CONBits_RD16 = 1  ' Load Timer1 for 16 Bits Timer
    TMR1H = 0           ' Clear the TMR1 High Byte
    Nop                 ' Necessary, errata of the PIC
    TMR1L = 0           ' Clear the TMR1 Low Byte    
    Nop

'    $if _device = _18F23K22 Or _device = _18F24K22 Or _device = _18F25K22 Or _device = _18F26K22 Or _device = _18F43K22 Or _device = _18F44K22 Or _device = _18F45K22 Or _device = _18F46K22   
'    $define __T1CON_Init
'    PIE1.0 = 0          ' Disables the TMR1 overflow interrupt
'    PIR1.0 = 0          ' Clear the TMR1 flag interrupt
'    $if _PMD0
'    PMD0.0 = 0          ' Timer1 peripheral Module Enabled (in case of...)
'    $endif
'    DelayUS 5
'    T1CON = %00000010   ' Load Timer1 parameters 16 Bits Timer
'    GIE_Save()
'    TMR1H = 0           ' Clear the TMR1 High Byte
'    Nop                 ' Necessary, errata of the PIC
'    TMR1L = 0           ' Clear the TMR1 Low Byte    
'    GIE_Restore()
'    $endif

'    $if _device = _18F23K20 Or _device = _18F24K20 Or _device = _18F25K20 Or _device = _18F26K20 Or _device = _18F43K20  Or _device = _18F44K20 Or _device = _18F45K20 Or _device = _18F46K20
'    $define __T1CON_Init
'    PIE1.0 = 0          ' Disables the TMR1 overflow interrupt
'    PIR1.0 = 0          ' Clear the TMR1 flag interrupt
'    Nop
'    T1CON = %10000000   ' 16 Bits Timer, Wihout prescaler, Osc shut off, Stops Timer, Clock FOsc/4.
'    GIE_Save()
'    TMR1H = 0           ' Clear the TMR1 High Byte
'    Nop                 ' Necessary, errata of the PIC
'    TMR1L = 0           ' Clear the TMR1 Low Byte
'    GIE_Restore()
'    $endif

'    $if _device = _18F452
'    $define __T1CON_Init
'    PIE1.0 = 0          ' Disables the TMR1 overflow interrupt
'    PIR1.0 = 0          ' Clear the TMR1 flag interrupt
'    T1CON = %10000000   ' 16 Bits Timer, Wihout prescaler, Osc shut off, Stops Timer, Clock FOsc/4.
'    GIE_Save()
'    TMR1H = 0           ' Clear the TMR1 High Byte
'    Nop                 ' Necessary, errata of the PIC
'    TMR1L = 0           ' Clear the TMR1 Low Byte    
'    GIE_Restore()
'    $endif

'    $if _device = _16F877
'    $define __T1CON_Init
'    While INTCON.7 = 1 : INTCON.7 = 0 : Wend 
'    PIE1.0 = 0          ' Disables the TMR1 overflow interrupt
'    PIR1.0 = 0          ' Clear the TMR1 flag interrupt
'    T1CON = %00000000   ' Wihout prescaler, Osc shut off, Stops Timer, Clock FOsc/4.
'    TMR1H = 0           ' Clear the TMR1 High Byte
'    Nop                 ' Necessary, possible errata of the PIC
'    TMR1L = 0           ' Clear the TMR1 Low Byte    
'    $endif

'    $ifndef __T1CON_Init
'        $error "Your PIC device is not declared in the MTimer1_Init() Macro"
'    $endif      

    #ifdef Hserial_TXSTA
    HRSOut "TESTING EXECUTION TIME USING TIMER1!",CR
    $ifdef __ExtraPICParameters
    HRSOut __DEVICE_NAME
    $endif
    HRSOut " CLOCK: ", Dec _xtal,"Mhz",CR,CR
    #endif

    Return    
    ENDSIZE(MeasureTime_LIB)
#endIfMacro-
'-------------------------------------------------------------------------------
' Stop using the Timer1 
$define MTimerDown()     '
    #ifdef Watchdog_req  '
    Clrwdt               '
    #endif               '
    T1CONBits_TMR1ON = 0 '
    PIE1Bits_TMR1IE = 0

' Stop Timer1 counting
$define MTimerStop()     '
    T1CONBits_TMR1ON = 0 '
    GIE_Restore()

' Enable counting of Timer1
$define MTimerOn() _mMTimer1On
    
_mMTimer1On Macro-
' Clear the TMR1 registers
    #ifdef Watchdog_req
    Clrwdt
    #endif
    GIE_Save()
    TMR1H = 0           '/ Clear the Timer1 High Byte first
    Nop                 '/ Necessary, errata of the PIC
    TMR1L = 0
    Nop    
    T1CONBits_TMR1ON = 1    '/ Now Here the Timer1 is running.
Endm
'-------------------------------------------------------------------------------
' Clear the Timer1, use alone.
'
$define MTimerClear() _mMTimer1Clear
    
_mMTimer1Clear Macro-
    #ifdef Watchdog_req
    Clrwdt
    #endif
    TMR1H = 0
    Nop             '/ Necessary, errata of the PIC
    TMR1L = 0
    Nop    
Endm    
'-------------------------------------------------------------------------------
' Read the result of Timer1
' Syntaxis: VarWord = MReadTimer()
'
$define MReadTimer() _mMReadCountTimer1

_mMReadCountTimer1 Macro-
    GoSub _mMTReadCountTimer1_Sub
    #if (_mMTReadCountTimer1_RETURN != 1)
        #error "_mReadCountTimer1 - Mandatory return parameter misssing"
        Exitm
    #else
        #if(Return_Type != Word)
            #error "_mReadCountTimer1 - Return variable should be a Word variable"
            Exitm
        #else
            Word_Word PROD,Return_Var
        #endif
    #endif
Endm

#ifMacro- _mMReadCountTimer1
_mMTReadCountTimer1_Sub:
    #ifdef Watchdog_req
    Clrwdt
    #endif
    PRODL = TMR1L
    Nop
    PRODH = TMR1H
    Nop 
    Return
#endIfMacro-
'-------------------------------------------------------------------------------
'/ Print the results of the Timer1 counting.
'/
    LocalWord0(_xTimer1ResultWord)
    LocalDword0(_xTimer1ResultDword)

$define MPrint_TMRResult() _mMPrint_TMR1Result

_mMPrint_TMR1Result Macro-
    GoSub _mMPrint_TMR1Result_Sub
Endm

#ifMacro- _mMPrint_TMR1Result
_mMPrint_TMR1Result_Sub:
    STARTSIZE(MPrint_TMRResult_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif

'/ Reading the timer1: there is an errata in the PIC. Write a delay beetwen readings = 1 clock.
    '/ Code sensitive with interrupts
    _xTimer1ResultWord.LowByte = TMR1L
    Nop                                 ' Necessary delay.
    _xTimer1ResultWord.HighByte = TMR1H 
    Nop

    Dec _xTimer1ResultWord  '/ Correction.

    If _xTimer1ResultWord > 0 Then
        _xTimer1ResultWord = _xTimer1ResultWord - 1
    EndIf
'-------------------------------------------------------------------------------
'/ Print the number of cycles.    
    #ifdef Hserial_TXSTA
    HRSOut "Result CountTimer1: ", Dec _xTimer1ResultWord, " Cycles",13
    #endif

    CLL(1)
    Print At 1,1,"T1 ", Dec _xTimer1ResultWord, " Cycles"

'/
' Calculate Time in microSeconds
' To avoid using floating variables: Example multiply by 0,0625,
' multiplicate by 625 and divide by 10000. It is the same but faster.
'
    #if (Xtal == 4)
    _xTimer1ResultDword = _xTimer1ResultWord * 10000 'OK
    #endif
    #if (Xtal == 8)
    _xTimer1ResultDword = _xTimer1ResultWord * 5000 'OK
    #endif
    #if (Xtal == 10)
    _xTimer1ResultDword = _xTimer1ResultWord * 4000 'OK
    #endif
    #if (Xtal == 12)
    _xTimer1ResultDword = _xTimer1ResultWord * 3333 'OK
    #endif
    #if (Xtal == 16)
    _xTimer1ResultDword = _xTimer1ResultWord * 2500 'OK
    #endif
    #if (Xtal == 20)
    _xTimer1ResultDword = _xTimer1ResultWord * 2000 'OK
    #endif
    #if (Xtal == 24)
    _xTimer1ResultDword = _xTimer1ResultWord * 1666 'OK
    #endif
    #if (Xtal == 32)
    _xTimer1ResultDword = _xTimer1ResultWord * 1250 'OK
    #endif    
    #if (Xtal == 40)
    _xTimer1ResultDword = _xTimer1ResultWord * 1000 'OK
    #endif                    
    #if (Xtal == 64)
    _xTimer1ResultDword = _xTimer1ResultWord * 625  'OK
    #endif
    #if (Xtal == 80)
    _xTimer1ResultDword = _xTimer1ResultWord * 500  'OK
    #endif    
    _xTimer1ResultWord = _xTimer1ResultDword / 10000
     
' Print the whole value:
    #ifdef Hserial_TXSTA
    HRSOut "Result CountTimer1: ", Dec _xTimer1ResultWord
    #endif

    CLL(2)   
    Print At 2,1,"T1 ", Dec _xTimer1ResultWord

'  Calculate & Print the decimals:        
'    _xTimer1ResultWord = _xTimer1ResultDword // 10000
    Dword_Word PPZ,_xTimer1ResultWord  '/ Extract the remainder: Trick that saves 32 bytes of code.

    #ifdef Hserial_TXSTA
    HRSOut ".", Dec _xTimer1ResultWord, " microS",13,13               
    #endif    
 
    Print ".", Dec _xTimer1ResultWord, " uS" 

    Return
    ENDSIZE(MPrint_TMRResult_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------
$endif    
$endif
'*******************************************************************************
'*  Name    : PIC STATES at Reset                                              *
'*  Author  : [Alberto FREIXANET]                                              *
'*  Notice  : Copyright (c) 2018 [Alberto FREIXANET]                           *
'*          : All Rights Reserved                                              *
'*  Date    : 29/09/2018                                                       *
'*  Version : 1.0                                                              *
'* Purpose : Checking the different states of the PIC at reset                 *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Syntax  : HRSOut_RCON()                                                     *
'* Note    : Place this command at fisrt place at the top of the programm      *
'* Modification : introduce command HRSOutLn 16/06/2019                        *
'*******************************************************************************
'/ With "Delare Wachtdog = On" is impossible to read the TO bits (Wachtdog reset bit)
'/ of RCON because the compiler has been clear this bit in first line of code by .
'/ the Clrwdt instruction. To control the watchdog correctly the "Delare Wachtdog"
'/ must be = OFF. And the WDT must to be enabled by config fuses and SWDTEN bit.

'/ This code must be written after the PIC declares.
(*
    $ifdef _CheckRCONBits_
    '/ Control of the RCON register.
    Dim RCONBits As Byte System
    $define __RCONBitsHeader
    RCONBits = RCON
    $endif
*)
'/ Enable these commands with:
'   $define _CheckRCONBits_
'/  at first line of your file.bas.
'/------------------------------------------------------------------------------
$ifdef _CheckRCONBits_
'/------------------------------------------------------------------------------
'/------------------------------------------------------------------------------
'* Purpose : Save the RCON bist to Control of the PIC resets.
'* Input   : None                                                      
'* Output  : None                                                       
'* Syntax  : HRSOut_RCON()                                               
'/
    '/ Enable/Disable to send messages to the terminal. 
    $define _HRS_RCONenable_

    '/ Declare the Global variable.
    Dim RESET_Status As Byte System
    Dim F_RCON_SoftReset As RESET_Status.7
    Dim F_RCON_MCLRpin   As RESET_Status.6    
    Dim F_RCON_WDT       As RESET_Status.5    
    Dim F_RCON_BrownOut  As RESET_Status.4
    Dim F_RCON_PowerON   As RESET_Status.3    
    Dim F_StackFull      As RESET_Status.2    
    Dim F_StackUnderflow As RESET_Status.1    

    $define _SBOREN 6
    $define _RI 4
    $define _TO 3
    $define _PD 2    
    $define _POR 1
    $define _BOR 0  
'/------------------------------------------------------------------------------            
'/ Put this command in any part of your program.
$define HRSOut_RCON()        '
$ifdef _CheckRCONBits_       '
    $ifndef __RCONBitsHeader '
        $error " The CheckRCONBits header code is not written in the header file" '
    $else                    '
    _mHRSOut_RCON            '
    $endif                   '
$endif

'/------------------------------------------------------------------------------    
_mHRSOut_RCON Macro-
    GoSub _mHRSOut_RCON_Sub
Endm

#ifMacro- _mHRSOut_RCON
_mHRSOut_RCON_Sub:
    STARTSIZE(HRSOut_RCON_LIB)
    #ifdef Watchdog_req
    Clrwdt
    #endif
    RESET_Status = 0

    ' At Power up control the state of the PIC.
    ' Check the Reset Flag bit
    If RCONBits._RI = 0 Then
        RCONBits_RI = 1
        F_RCON_SoftReset = 1
        $ifdef _HRS_RCONenable_
        #ifdef Hserial_TXSTA
        $ifdef _HSerial1Terminator
        HRSOutLn "A SOFTWARE RESET OCCURRED!"
        $else
        HRSOut "A SOFTWARE RESET OCCURRED!",CR
        $endif
        #endif
        $endif
    EndIf

    '/ Check the MCLR pin Reset Status bit
    '/ MCLR during Power-Managed Idle Modes and Sleep Mode    
    If RCONBits._TO = 1 Then
        If RCONBits._PD = 0 Then
            RCONBits_PD = 1
            F_RCON_MCLRpin = 1
            $ifdef _HRS_RCONenable_
            #ifdef Hserial_TXSTA
            $ifdef _HSerial1Terminator
            HRSOutLn "A MCLR PIN RESET OCCURRED DURING IDLE/SLEEP MODE!"
            $else
            HRSOut "A MCLR PIN RESET OCCURRED DURING IDLE/SLEEP MODE!",CR
            $endif
            #endif
            $endif
        EndIf 
    EndIf

    ' Check the Watchdog Time-out Flag bit
    #ifdef Watchdog_req
    If RCONBits._TO = 0 Then
        F_RCON_WDT = 1
        $ifdef _HRS_RCONenable_
        #ifdef Hserial_TXSTA
        $ifdef _HSerial1Terminator
        HRSOutLn "A WATCHDOG RESET OCCURRED!"
        $else
        HRSOut "A WATCHDOG RESET OCCURRED!",CR
        $endif
        #endif
        $endif
    EndIf
    #endif

    '/ Ckeck SBOREN: Brown-out Reset enabled And controlled by software (SBOREN is enabled)
    If RCONBits._SBOREN = 1 Then
        $ifdef _HRS_RCONenable_
        #ifdef Hserial_TXSTA
        $ifdef _HSerial1Terminator
        HRSOutLn "SBOREN IS ENABLED!" 
        $else
        HRSOut "SBOREN IS ENABLED!",CR
        $endif
        #endif
        $endif
    EndIf

    ' Check the Brown-out Reset Status bit
    If RCONBits._POR = 1 Then
        If RCONBits._BOR = 0 Then
            RCONBits_BOR = 1
            F_RCON_BrownOut = 1
            $ifdef _HRS_RCONenable_
            #ifdef Hserial_TXSTA
            $ifdef _HSerial1Terminator
            HRSOutLn "A BROWN-OUT RESET OCCURRED!" 
            $else
            HRSOut "A BROWN-OUT RESET OCCURRED!",CR
            $endif
            #endif
            $endif
        EndIf
    EndIf

    ' Check the Power-on Reset Status bit
    WREG = RCONBits & %00011100 
    If WREG = %00011100 Then
        If RCONBits._POR = 0 Then
            RCONBits_POR = 1
            F_RCON_PowerON = 1
            $ifdef _HRS_RCONenable_
            #ifdef Hserial_TXSTA
            $ifdef _HSerial1Terminator
            HRSOutLn "A POWER-ON RESET OCCURRED!"
            $else
            HRSOut "A POWER-ON RESET OCCURRED!",CR           
            $endif
            #endif
            $endif
        EndIf 
    EndIf

    ' Check the Stack pointer register
    If STKPTRBits_STKFUL = 1 Then
        STKPTRBits_STKFUL = 0
        F_StackFull = 1
        $ifdef _HRS_RCONenable_
        #ifdef Hserial_TXSTA
        $ifdef _HSerial1Terminator
        HRSOutLn "A STACK FULL RESET OCCURRED!"
        $else
        HRSOut "A STACK FULL RESET OCCURRED!",CR
        $endif
        #endif
        $endif
    EndIf
    If STKPTRBits_STKUNF = 1 Then
        STKPTRBits_STKUNF = 0
        F_StackUnderflow = 1
        $ifdef _HRS_RCONenable_
        #ifdef Hserial_TXSTA
        $ifdef _HSerial1Terminator
        HRSOutLn "A STACK UNDERFLOW RESET OCCURRED!"
        $else
        HRSOut "A STACK UNDERFLOW RESET OCCURRED!",CR
        $endif
        #endif
        $endif
    EndIf

''    #ifdef Watchdog_req
    $ifdef _HRS_RCONenable_
    #ifdef Hserial_TXSTA
    If WDTCONBits_SWDTEN = 1 Then
        $ifdef _HSerial1Terminator
        HRSOutLn "SPECIAL WATCHDOG ENABLED!"
        HRSOutLn "SWDTEN BIT ENABLED!"
        $else
        HRSOut "SPECIAL WATCHDOG ENABLED!",CR
        HRSOut "SWDTEN BIT ENABLED!",CR       
        $endif
    Else
        $ifdef _HSerial1Terminator
        HRSOutLn "SWDTEN BIT DISABLED!"
        $else
        HRSOut "SWDTEN BIT DISABLED!",CR
        $endif
    EndIf
    #ifndef Watchdog_req
        $ifdef _HSerial1Terminator
        HRSOutLn "DECLARE WATCHDOG = OFF!"
        $else
        HRSOut "DECLARE WATCHDOG = OFF!",CR
        $endif
    #endif
    #endif  
    $endif
''    #endif

    $ifdef _HRS_RCONenable_
    #ifdef Hserial_TXSTA
    $ifdef _HSerial1Terminator
    HRSOut CR,LF
    $else
    HRSOut CR
    $endif
    #endif  
    $endif

    Return
    ENDSIZE(HRSOut_RCON_LIB)
#endIfMacro-
'/------------------------------------------------------------------------------
$endif
'*******************************************************************************
'*  Name    : MyDelayMS(Value) / MyStop() / MyEnd()                            *
'*  Author  : [Alberto FREIXANET]                                              *
'*  Notice  : Copyright (c) 2018 [Alberto FREIXANET]                           *
'*          : All Rights Reserved                                              *
'*  Date    : 23/09/2018                                                       *
'*  Version : 1.0                                                              *
'* Purpose  : Compiler remplacement for my own Watchdog                        *
'* Input    : Delay 1 to 65535 mS                                              *
'* Output   : None                                                             *
'* Syntax   : MyDelayMS(1000)                                                  *
'* Note     : When the Declare Watchdog = OFF                                  *
'* Update: 01/11/2018 fixed error in  MyDelayMS(X) macro.                      *
'*******************************************************************************
$ifdef __RCONBitsHeader

    '/ Declare local variable.
'    LocalWord0(MyDelayLoop)

$define MyDelayMS(pValue) '
    $ifdef __WatchDog_ON  '
    PROD = pValue         '
    Repeat                '
        Clrwdt            '
        DelayUS 1000      '
        Dec PROD          '
    Until PROD = 0        '
    $else                 '
        DelayMS pValue    '
    $endif

'$define MyDelayMS(pValue) _mMyDelayMS pValue

'_mMyDelayMS Macro- pValue
'    #if (Prm_Count < 1)
'        #error "_mMyDelayMS - Macro - Too few parameters"
'    #else
'    	#if (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Byte) && (Prm_1 != Word)
'    		#error "_mMyDelayMS - (First Char) should be a Num8, Num16, Byte or Word!"
'            Exitm
'        #else
'            #if (Prm_1 == Num8)
'                Num_Byte pValue,PRODH
'                GoSub MyDelayMSByte_Sub
'            #endif
'            #if (Prm_1 == Num16)
'                Num_Word pValue,PROD
'                GoSub MyDelayMSWord_Sub
'            #endif
'            #if (Prm_1 == Byte)
'                Byte_Byte pValue,PRODH
'                GoSub MyDelayMSByte_Sub
'            #endif
'            #if (Prm_1 == Word)
'                Word_Word pValue,PROD
'                GoSub MyDelayMSWord_Sub
'            #endif
'        #endif
'    #endif
'Endm

'#ifMacro- _mMyDelayMS
'MyDelayMSByte_Sub:
'    Repeat
'        Clrwdt
'        DelayUS 1000
'        Dec PRODH
'    Until PRODH = 0
'    Return
    
'MyDelayMSWord_Sub:
'    Repeat
'        Clrwdt
'        DelayUS 1000
'        Dec PROD
'    Until PROD = 0
'    Return    
'#endIfMacro-
    
'/ Generate a Stop at end of the program.
$define MyStop() Do : Clrwdt : Loop

$define MyEnd() Do : Clrwdt : Loop

$endif    
'*******************************************************************************
'*  Name    : Thermistor linearisation using a Stein-Hart equasion             *
'*  Author  : [Les Johnson] 16/06/2009                                         *
'*  Notice  : Copyright (c) 2009 [Les Johnson]                                 *
'*          : All Rights Reserved                                              *
'*  Date    : 04/10/2018 macro made by Alberto Freixanet                       *
'*  Version : 1.0                                                              *
'* Purpose : Read the thermistor Temperature sensor On AN0 (PORTA.0)           *
'*           And linearise the Result                                          *
'* Input   : Read AN0 (PORTA.0)                                                *
'* Output  : None                                                              *
'* Syntax  : ReadTSensorTSH()                                                  *
'* Note    :                                                                   *
'*******************************************************************************
$ifdef _ReadTSensorTSH_
$ifndef __ReadTSensorTSH
$define __ReadTSensorTSH
'/------------------------------------------------------------------------------
'/ The MedianSample array declaration and its associated constants (below) should
'/ be placed at the end of the Dim list
'
    '/ Declare global variables    
    $ifndef PP_AARG_Var
    $define PP_AARG_Var
    Dim PP_AARG As Float System         '/ Compiler variable      
    $endif

    Symbol shMedianSamplesToTake = 32   '/ The amount of samples to take
    #if (shMedianSamplesToTake > 127)
         #error "Constant shMedianSamplesToTake cannot be greater than 127"
    #endif
    Symbol shMiddleSample = (shMedianSamplesToTake / 2) + 1 '/ The middle sample of the samples taken
    Dim shMedianSample[shMedianSamplesToTake] As Word Heap  '/ Create an array to hold the range samples

    '/ ADCResult: Alias the 16-bit ADRESL\H register as ADC Result by Library.

'/ Constant values used for the Stein-Hart thermistor linearisation routine
'/
    Symbol shQuanta = 5000.0 / 1024.0   '/ Quatasizing constant for ADC reading to Voltage calculation
    Symbol shT25 = 0.0033540            '/ Thermistor's t25 value
    Symbol shB = 1.0 / 3489.0           '/ Thermistor's B value
'
' The Stein-Hart linearising equation below is only suitable for describing a restricted range around
' the rated Temperature or resistance with sufficient accuracy.
'
'                 1
' Tt = ------------------------
'      1/B * Ln(Rt/R25) + 1/T25
'
' The B values for common NTC thermistors range from 2000K through to 5000K.
' For this application, the popular, and more complicated, Stein-Hart equation is more accurate.
'
' The thermistor used did not provide the B value within its datasheet, but did give the T25 value.
' i.e. resistance at 25 degrees Centigrade.
' To calculate the B value use the equation below.
'
'      Tt * T25        R25
' B = ---------- * Ln ------
'      Tt - T25        R100
'
' or: -
'
'      (25 + 273.13) * (100 + 273.15)        R25
' B = -------------------------------- * Ln ------
'                    75                      R100
'
' giving: -
'
'                  R25
' B = 1483.4 * Ln ------
'                  R100
'
' Thus, knowing the resistance at 25 degrees Centigrade and also at 100 degrees Centigrade
' we can use the above calculation to find the value of B for a given thermistor.
'-------------------------------------------------------------------------------
' Create a Median filter to make an educated guess as to what is the true reading from the Temperature readings taken.
' The routine below is a Bubble Sort, that arranges all the samples in ascending order within the array MedianSampleS.
' The middle sample is then extracted. This should eliminate spurious readings from the edges.
'
' Input     : Array MedianSample holds "MedianSamplesToTake" Temperature readings taken
' Output    : ThermistorValue = the median (middle value) of the samples taken
'
' Local System variables for this Macro.
    Dim shMedianSwapOccured As Bit    ' Indicates if the Bubble sort is complete
    LocalByte0(shMedianIndex)         ' Holds the position in the Bubble sort
    LocalWord0(shMedianSwap)          ' Temporary Median Filter variable for swapping
    LocalWord1(shThermistorValue)     ' Holds the raw thermistor ADC reading

#ifMacro- _mReadTempSensorTSH
ReadBubbleSortTSH_Sub:
    STARTSIZE(ReadTSensorTSH_LIB)
    Repeat
        #ifdef Watchdog_req
        Clrwdt
        #endif
        shMedianSwapOccured = 0       ' Clear flag that indicates swap.
        shMedianIndex = 0
        Repeat                        ' For each cell of the array...
            If shMedianSample[shMedianIndex] > shMedianSample[shMedianIndex + 1] Then ' Move larger values up.
                shMedianSwap = shMedianSample[shMedianIndex]                          ' ..by swapping them.
                shMedianSample[shMedianIndex] = shMedianSample[shMedianIndex + 1]
                shMedianSample[shMedianIndex + 1] = shMedianSwap
                shMedianSwapOccured = 1     ' Set bit if swap occurred.
            EndIf
            Inc shMedianIndex
        Until shMedianIndex = shMedianSamplesToTake       ' Check out next cell of the array.
    Until shMedianSwapOccured = 0                         ' Keep sorting until no more swaps.
    shThermistorValue = shMedianSample[shMiddleSample]    ' Extract the middle sample's value
    Return
    ENDSIZE(ReadTSensorTSH_LIB)
#endIfMacro-
'-------------------------------------------------------------------------------
' Read the thermistor Temperature sensor on AN0 (PortA.0) and linearise the result
' Input      : None
' Output     : Temperature = Temperature in degrees Centigrade
' Notes      : The thermistor is sampled by the ADC with 10-bit resolution several times
'            : based on the constant "MedianSamplesToTake".
'            : A Median filter is then called to filter out any noise
'            : Then the raw (filtered) thermistor value is run through a Stein-Hart calculation
'            : which linearises the value into degrees Centigrade.
'            : Accuracy depends on the thermistor and its accompanying 10K Ohm resistor.
'
' Local System variables for this Macro.
    LocalFloat0(shTempFloat)    '/ Temporary variable for the thermistor linearisation
    LocalFloat1(shLN)           '/ Used to hold the LOG of the thermistor value    LocalFloat0(shTemperature)    ' Holds the floating point Temperature in degrees Centigrade
    LocalFloat2(shTemperature)  '/ Holds the floating point temperature in degrees Centigrade
'    LocalFloat3(shResistance)   '/ Holds the resistance of the thermistor for a given Temperature

$define ReadTSensorTSH() _mReadTempSensorTSH

_mReadTempSensorTSH Macro-
    GoSub ReadTempSensorTSH_Sub
    #if (_mReadTempSensorTSH_RETURN != 1)
        #error "_mReadTempSensorTSH - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Float)
            #error "_mReadTempSensorTSH - Return variable should be a Float variable"
            Exitm
        #else
            Float_Float PP_AARG,Return_Var
        #endif
    #endif
Endm

#ifMacro- _mReadTempSensorTSH
ReadTempSensorTSH_Sub:
    STARTSIZE(ReadTSensorTSH_LIB2)
    ADCON1 = %10000000                              ' Make PORTA and PORTE all analogue and Right justify the ADC result
    ADCON0 = %10000001                              ' Set ADC: FRC/32 OSC, AN0, GO_DONE = 0, ADC Powered up
    For shMedianIndex = 0 To shMedianSamplesToTake - 1  ' Form a loop for the amount of Temperature readings to take
        #ifdef Watchdog_req
        Clrwdt
        #endif
        DelayUS 5                                   ' Wait for the ADC's internal capacitors to charge
        ADCON0bits_GO_DONE = 1                      ' \ Take an ADC reading
        Repeat : Until ADCON0bits_GO_DONE = 0       ' / Wait for the ADC conversion to finish
        ADRESH = ADRESH & %00000011
        shMedianSample[shMedianIndex] = ADCResult   ' Add the reading to the median array
    Next                                            ' Close the loop
    GoSub ReadBubbleSortTSH_Sub                     ' Perform a median filter on the temperatures read
'
' Perform a Stein-Hart calculation to linearise the thermistor into degrees Centigrade
    '/  Find the resistance across the thermistor
    shTemperature = shThermistorValue * shQuanta
    shTempFloat = 5000 - shTemperature                      
'    shResistance = (shTemperature * 10000) / shTempFloat
    PP_AARG = shTemperature * 10000
    PP_AARG = PP_AARG / shTempFloat

    '/ Linearise the result using the stein-hart algorithm
'    shLN = Log (shResistance / 10000)
    shLN = Log (PP_AARG / 10000)
    shTemperature = (shB * shLN) + shT25

    '/ Convert from Kelvin to Centigrade:
'    shTemperature = (1 / shTemperature) - 273.15
    PP_AARG = 1 / shTemperature          
    PP_AARG = PP_AARG - 273.15      '/ PP_AARG => shTemperature
    ADCON1 = 7                      '/ Make PORTA and PORTE all digital
    Return                          '/ Then return from the subroutine
    ENDSIZE(ReadTSensorTSH_LIB2)
#endIfMacro-
'/------------------------------------------------------------------------------
$endif
$endif
'*******************************************************************************
'*  Name    : PrintDegreSymb()                                                 *
'*  Author  : [Les Johnson] 16/06/2009                                         *
'*  Notice  : Copyright (c) 2018 [Les Johnson]                                 *
'*          : All Rights Reserved                                              *
'*  Date    : 05/10/2018 macro made by Alberto Freixanet                       *
'*  Version : 1.0                                                              *
'* Purpose : Build the LCD degrees Symbol in character 1                       *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Syntax  : PrintDegreSymb()                                                  *
'* Note    : Print 1 for degerees                                              *
'*******************************************************************************

$define PrintDegreSymb() Print 254,72,%00000110,%00001001,%00001001,%00000110,0,0,0,0

'/==============================================================================
'/ More macros here...
    
'/==============================================================================
END_TIPS_AND_TRICKS_INC:
'/==============================================================================
'/ Control of the Watchdog
'/ Set the SWDTEN when Declare Watchdog = On.
    $ifndef __SWDTEN_CFG
        $define __SWDTEN_CFG   
        #ifdef Watchdog_req
        Clrwdt
        WDTCONBits_SWDTEN = 1
        #else
        WDTCONBits_SWDTEN = 0    
        #endif
    $endif
'/------------------------------------------------------------------------------
$if _uart > 0
'    #ifdef HRSOUT#REQ            '/ Because the new compiler V3617.
    #ifdef Hserial_TXSTA        '/ Because issue in the new compiler V3706.
    CleanUART1() 
    #endif
$endif

'/------------------------------------------------------------------------------
$if _uart > 1
'    #ifdef HRSOUT2#REQ            '/ Because the new compiler V3617.
    #ifdef Hserial2_TXSTA        '/ Because issue in the new compiler V3706.
    CleanUART2() 
    #endif
$endif
'------------------------------------------------------------------------------- 
$if _uart > 2
'    #ifdef HRSOUT3#REQ            '/ Because the new compiler V3617.
    #ifdef Hserial3_TXSTA        '/ Because issue in the new compiler V3706.
    CleanUART3() 
    #endif
$endif
'------------------------------------------------------------------------------- 
$if _uart > 3
'    #ifdef HRSOUT4#REQ            '/ Because the new compiler V3617.
    #ifdef Hserial4_TXSTA        '/ Because the new compiler V3706.
    CleanUART4() 
    #endif
$endif
'------------------------------------------------------------------------------- 
$if _uart > 5
'    #ifdef HRSOUT5#REQ            '/ Because the new compiler V3617.
    #ifdef Hserial5_TXSTA        '/ Because the new compiler V3706.
    CleanUART5() 
    #endif
$endif
'/============================================================================== 
'/==============================================================================
'ENDLIBSIZE(TIPS_AND_TRICKS_INC)
'/##############################################################################
$endif  '/ __TIPS_AND_TRICKS_INC_
'/##############################################################################

